/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/errors","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/base/common/map","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/ternarySearchTree","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(_){for(var e=[],R=0,C=_.length;R<C;R++)e[R]=Q[_[R]];return e};define(Q[49],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function R(O){return(y,d,f)=>{let P=null,b=null;if(typeof f.value=="function"?(P="value",b=f.value):typeof f.get=="function"&&(P="get",b=f.get),!b)throw new Error("not supported");f[P]=O(b,d)}}function C(O,y,d){let f=null,P=null;if(typeof d.value=="function"?(f="value",P=d.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(f="get",P=d.get),!P)throw new Error("not supported");const b=`$memoize$${y}`;d[f]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[b]}}e.memoize=C;function I(O,y,d){return R((f,P)=>{const b=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...v){this[m]||(this[m]=d?d():void 0),clearTimeout(this[b]),y&&(this[m]=y(this[m],...v),v=[this[m]]),this[b]=setTimeout(()=>{f.apply(this,v),this[m]=d?d():void 0},O)}})}e.debounce=I;function k(O,y,d){return R((f,P)=>{const b=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,v=`$throttle$lastRun$${P}`,p=`$throttle$pending$${P}`;return function(...E){if(this[m]||(this[m]=d?d():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),y&&(this[m]=y(this[m],...E)),this[p])return;const S=this[v]+O;S<=Date.now()?(this[v]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[v]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0},S-Date.now()))}})}e.throttle=k}),define(Q[69],Z([0,1,11]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function C(d,f){if(!d)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}e.ok=C;function I(d,f="Unreachable"){throw new Error(f)}e.assertNever=I;function k(d){if(!d)throw new R.BugIndicatingError("Assertion Failed")}e.assert=k;function O(d){if(!d()){debugger;d(),(0,R.onUnexpectedError)(new R.BugIndicatingError("Assertion Failed"))}}e.assertFn=O;function y(d,f){let P=0;for(;P<d.length-1;){const b=d[P],m=d[P+1];if(!f(b,m))return!1;P++}return!0}e.checkAdjacentItems=y}),define(Q[50],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C=e.SyntaxKind||(e.SyntaxKind={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function O(t,n=!1){let i=0;const r=t.length;let o="",c=0,a=16,h=0;function D(re){let ge=0,ce=0;for(;ge<re;){const ie=t.charCodeAt(i);if(ie>=48&&ie<=57)ce=ce*16+ie-48;else if(ie>=65&&ie<=70)ce=ce*16+ie-65+10;else if(ie>=97&&ie<=102)ce=ce*16+ie-97+10;else break;i++,ge++}return ge<re&&(ce=-1),ce}function N(re){i=re,o="",c=0,a=16,h=0}function B(){const re=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&f(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&f(t.charCodeAt(i)))for(i++;i<t.length&&f(t.charCodeAt(i));)i++;else return h=3,t.substring(re,i);let ge=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&f(t.charCodeAt(i))){for(i++;i<t.length&&f(t.charCodeAt(i));)i++;ge=i}else h=3;return t.substring(re,ge)}function X(){let re="",ge=i;for(;;){if(i>=r){re+=t.substring(ge,i),h=2;break}const ce=t.charCodeAt(i);if(ce===34){re+=t.substring(ge,i),i++;break}if(ce===92){if(re+=t.substring(ge,i),i++,i>=r){h=2;break}switch(t.charCodeAt(i++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const j=D(4);j>=0?re+=String.fromCharCode(j):h=4;break}default:h=5}ge=i;continue}if(ce>=0&&ce<=31)if(d(ce)){re+=t.substring(ge,i),h=2;break}else h=6;i++}return re}function J(){if(o="",h=0,c=i,i>=r)return c=r,a=17;let re=t.charCodeAt(i);if(y(re)){do i++,o+=String.fromCharCode(re),re=t.charCodeAt(i);while(y(re));return a=15}if(d(re))return i++,o+=String.fromCharCode(re),re===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(re){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=X(),a=10;case 47:{const ge=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!d(t.charCodeAt(i));)i++;return o=t.substring(ge,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const ce=r-1;let ie=!1;for(;i<ce;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ie=!0;break}i++}return ie||(i++,h=1),o=t.substring(ge,i),a=13}return o+=String.fromCharCode(re),i++,a=16}case 45:if(o+=String.fromCharCode(re),i++,i===r||!f(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=B(),a=11;default:for(;i<r&&se(re);)i++,re=t.charCodeAt(i);if(c!==i){switch(o=t.substring(c,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(re),i++,a=16}}function se(re){if(y(re)||d(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let re;do re=J();while(re>=12&&re<=15);return re}return{setPosition:N,getPosition:()=>i,scan:n?ne:J,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>h}}e.createScanner=O;function y(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function f(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function b(t,n){const i=[],r=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(D,N,B,X){c.value=D,c.offset=N,c.length=B,c.type=X,c.colonOffset=void 0,o=c}try{w(t,{onObjectBegin:(D,N)=>{if(n<=D)throw r;o=void 0,a=n>D,i.push("")},onObjectProperty:(D,N,B)=>{if(n<N||(h(D,N,B,"property"),i[i.length-1]=D,n<=N+B))throw r},onObjectEnd:(D,N)=>{if(n<=D)throw r;o=void 0,i.pop()},onArrayBegin:(D,N)=>{if(n<=D)throw r;o=void 0,i.push(0)},onArrayEnd:(D,N)=>{if(n<=D)throw r;o=void 0,i.pop()},onLiteralValue:(D,N,B)=>{if(n<N||(h(D,N,B,s(D)),n<=N+B))throw r},onSeparator:(D,N,B)=>{if(n<=N)throw r;if(D===":"&&o&&o.type==="property")o.colonOffset=N,a=!1,o=void 0;else if(D===","){const X=i[i.length-1];typeof X=="number"?i[i.length-1]=X+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(D){if(D!==r)throw D}return{path:i,previousNode:o,isAtPropertyKey:a,matches:D=>{let N=0;for(let B=0;N<D.length&&B<i.length;B++)if(D[N]===i[B]||D[N]==="*")N++;else if(D[N]!=="**")return!1;return N===D.length}}}e.getLocation=b;function m(t,n=[],i=k.DEFAULT){let r=null,o=[];const c=[];function a(D){Array.isArray(o)?o.push(D):r!==null&&(o[r]=D)}return w(t,{onObjectBegin:()=>{const D={};a(D),c.push(o),o=D,r=null},onObjectProperty:D=>{r=D},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const D=[];a(D),c.push(o),o=D,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(D,N,B)=>{n.push({error:D,offset:N,length:B})}},i),o[0]}e.parse=m;function v(t,n=[],i=k.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){r.type==="property"&&(r.length=D-r.offset,r=r.parent)}function c(D){return r.children.push(D),D}w(t,{onObjectBegin:D=>{r=c({type:"object",offset:D,length:-1,parent:r,children:[]})},onObjectProperty:(D,N,B)=>{r=c({type:"property",offset:N,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:D,offset:N,length:B,parent:r})},onObjectEnd:(D,N)=>{r.length=D+N-r.offset,r=r.parent,o(D+N)},onArrayBegin:(D,N)=>{r=c({type:"array",offset:D,length:-1,parent:r,children:[]})},onArrayEnd:(D,N)=>{r.length=D+N-r.offset,r=r.parent,o(D+N)},onLiteralValue:(D,N,B)=>{c({type:s(D),offset:N,length:B,parent:r,value:D}),o(N+B)},onSeparator:(D,N,B)=>{r.type==="property"&&(D===":"?r.colonOffset=N:D===","&&o(N))},onError:(D,N,B)=>{n.push({error:D,offset:N,length:B})}},i);const h=r.children[0];return h&&delete h.parent,h}e.parseTree=v;function p(t,n){if(!t)return;let i=t;for(const r of n)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===r){i=c.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=p;function E(t){if(!t.parent||!t.parent.children)return[];const n=E(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;n.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&n.push(i)}return n}e.getNodePath=E;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":{const n=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(n[i.children[0].value]=S(r))}return n}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function l(t,n,i=!1){return n>=t.offset&&n<t.offset+t.length||i&&n===t.offset+t.length}e.contains=l;function g(t,n,i=!1){if(l(t,n,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const c=g(r[o],n,i);if(c)return c}return t}}e.findNodeAtOffset=g;function w(t,n,i=k.DEFAULT){const r=O(t,!1);function o(A){return A?()=>A(r.getTokenOffset(),r.getTokenLength()):()=>!0}function c(A){return A?x=>A(x,r.getTokenOffset(),r.getTokenLength()):()=>!0}const a=o(n.onObjectBegin),h=c(n.onObjectProperty),D=o(n.onObjectEnd),N=o(n.onArrayBegin),B=o(n.onArrayEnd),X=c(n.onLiteralValue),J=c(n.onSeparator),se=o(n.onComment),ne=c(n.onError),re=i&&i.disallowComments,ge=i&&i.allowTrailingComma;function ce(){for(;;){const A=r.scan();switch(r.getTokenError()){case 4:ie(14);break;case 5:ie(15);break;case 3:ie(13);break;case 1:re||ie(11);break;case 2:ie(12);break;case 6:ie(16);break}switch(A){case 12:case 13:re?ie(10):se();break;case 16:ie(1);break;case 15:case 14:break;default:return A}}}function ie(A,x=[],L=[]){if(ne(A),x.length+L.length>0){let T=r.getToken();for(;T!==17;){if(x.indexOf(T)!==-1){ce();break}else if(L.indexOf(T)!==-1)break;T=ce()}}}function j(A){const x=r.getTokenValue();return A?X(x):h(x),ce(),!0}function M(){switch(r.getToken()){case 11:{let A=0;try{A=JSON.parse(r.getTokenValue()),typeof A!="number"&&(ie(2),A=0)}catch{ie(2)}X(A);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return ce(),!0}function F(){return r.getToken()!==10?(ie(3,[],[2,5]),!1):(j(!1),r.getToken()===6?(J(":"),ce(),Y()||ie(4,[],[2,5])):ie(5,[],[2,5]),!0)}function z(){a(),ce();let A=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(A||ie(4,[],[]),J(","),ce(),r.getToken()===2&&ge)break}else A&&ie(6,[],[]);F()||ie(4,[],[2,5]),A=!0}return D(),r.getToken()!==2?ie(7,[2],[]):ce(),!0}function $(){N(),ce();let A=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(A||ie(4,[],[]),J(","),ce(),r.getToken()===4&&ge)break}else A&&ie(6,[],[]);Y()||ie(4,[],[4,5]),A=!0}return B(),r.getToken()!==4?ie(8,[4],[]):ce(),!0}function Y(){switch(r.getToken()){case 3:return $();case 1:return z();case 10:return j(!0);default:return M()}}return ce(),r.getToken()===17?i.allowEmptyContent?!0:(ie(4,[],[]),!1):Y()?(r.getToken()!==17&&ie(9,[],[]),!0):(ie(4,[],[]),!1)}e.visit=w;function u(t,n){const i=O(t),r=[];let o,c=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:c!==a&&r.push(t.substring(c,a)),n!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,n)),c=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=u;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),function(){function _(I){const k=[];typeof I=="number"&&k.push("code/timeOrigin",I);function O(d){k.push(d,Date.now())}function y(){const d=[];for(let f=0;f<k.length;f+=2)d.push({name:k[f],startTime:k[f+1]});return d}return{mark:O,getMarks:y}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const O of performance.getEntriesByType("mark"))k.push({name:O.name,startTime:Math.round(I+O.startTime)});return k}};if(typeof process=="object"){const I=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function R(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=R(C))}(),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var C in R)(typeof exports=="object"?exports:_)[C]=R[C]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function R(C){if(e[C])return e[C].exports;var I=e[C]={i:C,l:!1,exports:{}};return _[C].call(I.exports,I,I.exports,R),I.l=!0,I.exports}return R.m=_,R.c=e,R.d=function(C,I,k){R.o(C,I)||Object.defineProperty(C,I,{enumerable:!0,get:k})},R.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},R.t=function(C,I){if(1&I&&(C=R(C)),8&I||4&I&&typeof C=="object"&&C&&C.__esModule)return C;var k=Object.create(null);if(R.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:C}),2&I&&typeof C!="string")for(var O in C)R.d(k,O,function(y){return C[y]}.bind(null,O));return k},R.n=function(C){var I=C&&C.__esModule?function(){return C.default}:function(){return C};return R.d(I,"a",I),I},R.o=function(C,I){return Object.prototype.hasOwnProperty.call(C,I)},R.p="",R(R.s=0)}([function(_,e,R){(function(C){var I;e=_.exports=L,I=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,y=e.re=[],d=e.src=[],f=0,P=f++;d[P]="0|[1-9]\\d*";var b=f++;d[b]="[0-9]+";var m=f++;d[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=f++;d[v]="("+d[P]+")\\.("+d[P]+")\\.("+d[P]+")";var p=f++;d[p]="("+d[b]+")\\.("+d[b]+")\\.("+d[b]+")";var E=f++;d[E]="(?:"+d[P]+"|"+d[m]+")";var S=f++;d[S]="(?:"+d[b]+"|"+d[m]+")";var l=f++;d[l]="(?:-("+d[E]+"(?:\\."+d[E]+")*))";var g=f++;d[g]="(?:-?("+d[S]+"(?:\\."+d[S]+")*))";var w=f++;d[w]="[0-9A-Za-z-]+";var u=f++;d[u]="(?:\\+("+d[w]+"(?:\\."+d[w]+")*))";var s=f++,t="v?"+d[v]+d[l]+"?"+d[u]+"?";d[s]="^"+t+"$";var n="[v=\\s]*"+d[p]+d[g]+"?"+d[u]+"?",i=f++;d[i]="^"+n+"$";var r=f++;d[r]="((?:<|>)?=?)";var o=f++;d[o]=d[b]+"|x|X|\\*";var c=f++;d[c]=d[P]+"|x|X|\\*";var a=f++;d[a]="[v=\\s]*("+d[c]+")(?:\\.("+d[c]+")(?:\\.("+d[c]+")(?:"+d[l]+")?"+d[u]+"?)?)?";var h=f++;d[h]="[v=\\s]*("+d[o]+")(?:\\.("+d[o]+")(?:\\.("+d[o]+")(?:"+d[g]+")?"+d[u]+"?)?)?";var D=f++;d[D]="^"+d[r]+"\\s*"+d[a]+"$";var N=f++;d[N]="^"+d[r]+"\\s*"+d[h]+"$";var B=f++;d[B]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=f++;d[X]="(?:~>?)";var J=f++;d[J]="(\\s*)"+d[X]+"\\s+",y[J]=new RegExp(d[J],"g");var se=f++;d[se]="^"+d[X]+d[a]+"$";var ne=f++;d[ne]="^"+d[X]+d[h]+"$";var re=f++;d[re]="(?:\\^)";var ge=f++;d[ge]="(\\s*)"+d[re]+"\\s+",y[ge]=new RegExp(d[ge],"g");var ce=f++;d[ce]="^"+d[re]+d[a]+"$";var ie=f++;d[ie]="^"+d[re]+d[h]+"$";var j=f++;d[j]="^"+d[r]+"\\s*("+n+")$|^$";var M=f++;d[M]="^"+d[r]+"\\s*("+t+")$|^$";var F=f++;d[F]="(\\s*)"+d[r]+"\\s*("+n+"|"+d[a]+")",y[F]=new RegExp(d[F],"g");var z=f++;d[z]="^\\s*("+d[a]+")\\s+-\\s+("+d[a]+")\\s*$";var $=f++;d[$]="^\\s*("+d[h]+")\\s+-\\s+("+d[h]+")\\s*$";var Y=f++;d[Y]="(<|>)?=?\\s*\\*";for(var A=0;A<35;A++)I(A,d[A]),y[A]||(y[A]=new RegExp(d[A]));function x(V,G){if(V instanceof L)return V;if(typeof V!="string"||V.length>k||!(G?y[i]:y[s]).test(V))return null;try{return new L(V,G)}catch{return null}}function L(V,G){if(V instanceof L){if(V.loose===G)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof L))return new L(V,G);I("SemVer",V,G),this.loose=G;var K=V.trim().match(G?y[i]:y[s]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(he){if(/^[0-9]+$/.test(he)){var me=+he;if(me>=0&&me<O)return me}return he}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=x,e.valid=function(V,G){var K=x(V,G);return K?K.version:null},e.clean=function(V,G){var K=x(V.trim().replace(/^[=v]+/,""),G);return K?K.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(V){return I("SemVer.compare",this.version,this.loose,V),V instanceof L||(V=new L(V,this.loose)),this.compareMain(V)||this.comparePre(V)},L.prototype.compareMain=function(V){return V instanceof L||(V=new L(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},L.prototype.comparePre=function(V){if(V instanceof L||(V=new L(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],he=V.prerelease[G];if(I("prerelease compare",G,K,he),K===void 0&&he===void 0)return 0;if(he===void 0)return 1;if(K===void 0)return-1;if(K!==he)return U(K,he)}while(++G)},L.prototype.inc=function(V,G){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,G,K,he){typeof K=="string"&&(he=K,K=void 0);try{return new L(V,K).inc(G,he).version}catch{return null}},e.diff=function(V,G){if(oe(V,G))return null;var K=x(V),he=x(G);if(K.prerelease.length||he.prerelease.length){for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==he[me])return"pre"+me;return"prerelease"}for(var me in K)if((me==="major"||me==="minor"||me==="patch")&&K[me]!==he[me])return me},e.compareIdentifiers=U;var T=/^[0-9]+$/;function U(V,G){var K=T.test(V),he=T.test(G);return K&&he&&(V=+V,G=+G),K&&!he?-1:he&&!K?1:V<G?-1:V>G?1:0}function W(V,G,K){return new L(V,K).compare(new L(G,K))}function q(V,G,K){return W(V,G,K)>0}function H(V,G,K){return W(V,G,K)<0}function oe(V,G,K){return W(V,G,K)===0}function ue(V,G,K){return W(V,G,K)!==0}function ve(V,G,K){return W(V,G,K)>=0}function Se(V,G,K){return W(V,G,K)<=0}function le(V,G,K,he){var me;switch(G){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),me=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),me=V!==K;break;case"":case"=":case"==":me=oe(V,K,he);break;case"!=":me=ue(V,K,he);break;case">":me=q(V,K,he);break;case">=":me=ve(V,K,he);break;case"<":me=H(V,K,he);break;case"<=":me=Se(V,K,he);break;default:throw new TypeError("Invalid operator: "+G)}return me}function te(V,G){if(V instanceof te){if(V.loose===G)return V;V=V.value}if(!(this instanceof te))return new te(V,G);I("comparator",V,G),this.loose=G,this.parse(V),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(V,G){return U(G,V)},e.major=function(V,G){return new L(V,G).major},e.minor=function(V,G){return new L(V,G).minor},e.patch=function(V,G){return new L(V,G).patch},e.compare=W,e.compareLoose=function(V,G){return W(V,G,!0)},e.rcompare=function(V,G,K){return W(G,V,K)},e.sort=function(V,G){return V.sort(function(K,he){return e.compare(K,he,G)})},e.rsort=function(V,G){return V.sort(function(K,he){return e.rcompare(K,he,G)})},e.gt=q,e.lt=H,e.eq=oe,e.neq=ue,e.gte=ve,e.lte=Se,e.cmp=le,e.Comparator=te;var fe={};function ae(V,G){if(V instanceof ae)return V.loose===G?V:new ae(V.raw,G);if(V instanceof te)return new ae(V.value,G);if(!(this instanceof ae))return new ae(V,G);if(this.loose=G,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function pe(V){return!V||V.toLowerCase()==="x"||V==="*"}function Fe(V,G,K,he,me,De,we,Re,Ie,ke,Ne,Ce,Le){return((G=pe(K)?"":pe(he)?">="+K+".0.0":pe(me)?">="+K+"."+he+".0":">="+G)+" "+(Re=pe(Ie)?"":pe(ke)?"<"+(+Ie+1)+".0.0":pe(Ne)?"<"+Ie+"."+(+ke+1)+".0":Ce?"<="+Ie+"."+ke+"."+Ne+"-"+Ce:"<="+Re)).trim()}function Oe(V,G){for(var K=0;K<V.length;K++)if(!V[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<V.length;K++)if(I(V[K].semver),V[K].semver!==fe&&V[K].semver.prerelease.length>0){var he=V[K].semver;if(he.major===G.major&&he.minor===G.minor&&he.patch===G.patch)return!0}return!1}return!0}function Ae(V,G,K){try{G=new ae(G,K)}catch{return!1}return G.test(V)}function xe(V,G,K,he){var me,De,we,Re,Ie;switch(V=new L(V,he),G=new ae(G,he),K){case">":me=q,De=Se,we=H,Re=">",Ie=">=";break;case"<":me=H,De=ve,we=q,Re="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(V,G,he))return!1;for(var ke=0;ke<G.set.length;++ke){var Ne=G.set[ke],Ce=null,Le=null;if(Ne.forEach(function(Me){Me.semver===fe&&(Me=new te(">=0.0.0")),Ce=Ce||Me,Le=Le||Me,me(Me.semver,Ce.semver,he)?Ce=Me:we(Me.semver,Le.semver,he)&&(Le=Me)}),Ce.operator===Re||Ce.operator===Ie||(!Le.operator||Le.operator===Re)&&De(V,Le.semver)||Le.operator===Ie&&we(V,Le.semver))return!1}return!0}te.prototype.parse=function(V){var G=this.loose?y[j]:y[M],K=V.match(G);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new L(K[2],this.loose):this.semver=fe},te.prototype.toString=function(){return this.value},te.prototype.test=function(V){return I("Comparator.test",V,this.loose),this.semver===fe||(typeof V=="string"&&(V=new L(V,this.loose)),le(V,this.operator,this.semver,this.loose))},te.prototype.intersects=function(V,G){if(!(V instanceof te))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new ae(V.value,G),Ae(this.value,K,G);if(V.operator==="")return K=new ae(this.value,G),Ae(V.semver,K,G);var he=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Re=le(this.semver,"<",V.semver,G)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=le(this.semver,">",V.semver,G)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return he||me||De&&we||Re||Ie},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(V){var G=this.loose;V=V.trim(),I("range",V,G);var K=G?y[$]:y[z];V=V.replace(K,Fe),I("hyphen replace",V),V=V.replace(y[F],"$1$2$3"),I("comparator trim",V,y[F]),V=(V=(V=V.replace(y[J],"$1~")).replace(y[ge],"$1^")).split(/\s+/).join(" ");var he=G?y[j]:y[M],me=V.split(" ").map(function(De){return function(we,Re){return I("comp",we),we=function(Ie,ke){return Ie.trim().split(/\s+/).map(function(Ne){return function(Ce,Le){I("caret",Ce,Le);var Me=Le?y[ie]:y[ce];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be){var Te;return I("caret",Ce,Ue,ye,Ee,Pe,be),pe(ye)?Te="":pe(Ee)?Te=">="+ye+".0.0 <"+(+ye+1)+".0.0":pe(Pe)?Te=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":be?(I("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+be+" <"+(+ye+1)+".0.0"):(I("no pr"),Te=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),I("caret return",Te),Te})}(Ne,ke)}).join(" ")}(we,Re),I("caret",we),we=function(Ie,ke){return Ie.trim().split(/\s+/).map(function(Ne){return function(Ce,Le){var Me=Le?y[ne]:y[se];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be){var Te;return I("tilde",Ce,Ue,ye,Ee,Pe,be),pe(ye)?Te="":pe(Ee)?Te=">="+ye+".0.0 <"+(+ye+1)+".0.0":pe(Pe)?Te=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":be?(I("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),Te=">="+ye+"."+Ee+"."+Pe+be+" <"+ye+"."+(+Ee+1)+".0"):Te=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",I("tilde return",Te),Te})}(Ne,ke)}).join(" ")}(we,Re),I("tildes",we),we=function(Ie,ke){return I("replaceXRanges",Ie,ke),Ie.split(/\s+/).map(function(Ne){return function(Ce,Le){Ce=Ce.trim();var Me=Le?y[N]:y[D];return Ce.replace(Me,function(Ue,ye,Ee,Pe,be,Te){I("xRange",Ce,Ue,ye,Ee,Pe,be,Te);var $e=pe(Ee),Ve=$e||pe(Pe),ze=Ve||pe(be);return ye==="="&&ze&&(ye=""),$e?Ue=ye===">"||ye==="<"?"<0.0.0":"*":ye&&ze?(Ve&&(Pe=0),ze&&(be=0),ye===">"?(ye=">=",Ve?(Ee=+Ee+1,Pe=0,be=0):ze&&(Pe=+Pe+1,be=0)):ye==="<="&&(ye="<",Ve?Ee=+Ee+1:Pe=+Pe+1),Ue=ye+Ee+"."+Pe+"."+be):Ve?Ue=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(Ue=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),I("xRange return",Ue),Ue})}(Ne,ke)}).join(" ")}(we,Re),I("xrange",we),we=function(Ie,ke){return I("replaceStars",Ie,ke),Ie.trim().replace(y[Y],"")}(we,Re),I("stars",we),we}(De,G)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(De){return!!De.match(he)})),me=me.map(function(De){return new te(De,G)})},ae.prototype.intersects=function(V,G){if(!(V instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(he){return V.set.some(function(me){return me.every(function(De){return he.intersects(De,G)})})})})},e.toComparators=function(V,G){return new ae(V,G).set.map(function(K){return K.map(function(he){return he.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new L(V,this.loose));for(var G=0;G<this.set.length;G++)if(Oe(this.set[G],V))return!0;return!1},e.satisfies=Ae,e.maxSatisfying=function(V,G,K){var he=null,me=null;try{var De=new ae(G,K)}catch{return null}return V.forEach(function(we){De.test(we)&&(he&&me.compare(we)!==-1||(me=new L(he=we,K)))}),he},e.minSatisfying=function(V,G,K){var he=null,me=null;try{var De=new ae(G,K)}catch{return null}return V.forEach(function(we){De.test(we)&&(he&&me.compare(we)!==1||(me=new L(he=we,K)))}),he},e.validRange=function(V,G){try{return new ae(V,G).range||"*"}catch{return null}},e.ltr=function(V,G,K){return xe(V,G,"<",K)},e.gtr=function(V,G,K){return xe(V,G,">",K)},e.outside=xe,e.prerelease=function(V,G){var K=x(V,G);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(V,G,K){return V=new ae(V,K),G=new ae(G,K),V.intersects(G)},e.coerce=function(V){if(V instanceof L)return V;if(typeof V!="string")return null;var G=V.match(y[B]);return G==null?null:x((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,R(1))},function(_,e){var R,C,I=_.exports={};function k(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function y(S){if(R===setTimeout)return setTimeout(S,0);if((R===k||!R)&&setTimeout)return R=setTimeout,setTimeout(S,0);try{return R(S,0)}catch{try{return R.call(null,S,0)}catch{return R.call(this,S,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:k}catch{R=k}try{C=typeof clearTimeout=="function"?clearTimeout:O}catch{C=O}})();var d,f=[],P=!1,b=-1;function m(){P&&d&&(P=!1,d.length?f=d.concat(f):b=-1,f.length&&v())}function v(){if(!P){var S=y(m);P=!0;for(var l=f.length;l;){for(d=f,f=[];++b<l;)d&&d[b].run();b=-1,l=f.length}d=null,P=!1,function(g){if(C===clearTimeout)return clearTimeout(g);if((C===O||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(g);try{C(g)}catch{try{return C.call(null,g)}catch{return C.call(this,g)}}}(S)}}function p(S,l){this.fun=S,this.array=l}function E(){}I.nextTick=function(S){var l=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)l[g-1]=arguments[g];f.push(new p(S,l)),f.length!==1||P||y(v)},p.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=E,I.addListener=E,I.once=E,I.off=E,I.removeListener=E,I.removeAllListeners=E,I.emit=E,I.prependListener=E,I.prependOnceListener=E,I.listeners=function(S){return[]},I.binding=function(S){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(S){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Q[70],Z([0,1]),function(_,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class C{constructor(y,d,f){this.level=y,this.key=d,this.value=f,this.forward=[]}}const I=void 0;class k{constructor(y,d=2**16){this.comparator=y,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(d)|0),this._header=new C(this._maxLevel,I,I)}get size(){return this._size}clear(){this._header=new C(this._maxLevel,I,I)}has(y){return Boolean(k._search(this,y,this.comparator))}get(y){return k._search(this,y,this.comparator)?.value}set(y,d){return k._insert(this,y,d,this.comparator)&&(this._size+=1),this}delete(y){const d=k._delete(this,y,this.comparator);return d&&(this._size-=1),d}forEach(y,d){let f=this._header.forward[0];for(;f;)y.call(d,f.value,f.key,this),f=f.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let y=this._header.forward[0];for(;y;)yield[y.key,y.value],y=y.forward[0]}*keys(){let y=this._header.forward[0];for(;y;)yield y.key,y=y.forward[0]}*values(){let y=this._header.forward[0];for(;y;)yield y.value,y=y.forward[0]}toString(){let y="[SkipList]:",d=this._header.forward[0];for(;d;)y+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return y}static _search(y,d,f){let P=y._header;for(let b=y._level-1;b>=0;b--)for(;P.forward[b]&&f(P.forward[b].key,d)<0;)P=P.forward[b];if(P=P.forward[0],P&&f(P.key,d)===0)return P}static _insert(y,d,f,P){const b=[];let m=y._header;for(let v=y._level-1;v>=0;v--){for(;m.forward[v]&&P(m.forward[v].key,d)<0;)m=m.forward[v];b[v]=m}if(m=m.forward[0],m&&P(m.key,d)===0)return m.value=f,!1;{const v=k._randomLevel(y);if(v>y._level){for(let p=y._level;p<v;p++)b[p]=y._header;y._level=v}m=new C(v,d,f);for(let p=0;p<v;p++)m.forward[p]=b[p].forward[p],b[p].forward[p]=m;return!0}}static _randomLevel(y,d=.5){let f=1;for(;Math.random()<d&&f<y._maxLevel;)f+=1;return f}static _delete(y,d,f){const P=[];let b=y._header;for(let m=y._level-1;m>=0;m--){for(;b.forward[m]&&f(b.forward[m].key,d)<0;)b=b.forward[m];P[m]=b}if(b=b.forward[0],!b||f(b.key,d)!==0)return!1;for(let m=0;m<y._level&&P[m].forward[m]===b;m++)P[m].forward[m]=b.forward[m];for(;y._level>0&&y._header.forward[y._level-1]===I;)y._level-=1;return!0}}e.SkipList=k}),define(Q[43],Z([0,1,11,2]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(u){const s=u;return s?typeof s.read=="function":!1}e.isReadable=I;function k(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=k;function O(u){const s=u;return s?k(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=O;function y(u,s){return new d(u,s)}e.newWriteableStream=y;class d{constructor(s,t){this.reducer=s,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s<"u"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(t=>t(s))}emitError(s){this.listeners.error.length===0?(0,R.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(t=>t(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,t){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors();break}}removeListener(s,t){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const i=n.indexOf(t);i>=0&&n.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(u,s){const t=[];let n;for(;(n=u.read())!==null;)t.push(n);return s(t)}e.consumeReadable=f;function P(u,s,t){const n=[];let i;for(;(i=u.read())!==null&&n.length<t;)n.push(i);return i===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return u.read()}}}e.peekReadable=P;function b(u,s){return new Promise((t,n)=>{const i=[];m(u,{onData:r=>{s&&i.push(r)},onError:r=>{s?n(r):t(void 0)},onEnd:()=>{t(s?s(i):void 0)}})})}e.consumeStream=b;function m(u,s){let t=!1;return u.on("error",n=>{t||s.onError(n)}),u.on("end",()=>{t||s.onEnd()}),u.on("data",n=>{t||s.onData(n)}),(0,C.toDisposable)(()=>t=!0)}e.listenStream=m;function v(u,s){return new Promise((t,n)=>{const i=new C.DisposableStore,r=[],o=h=>{if(r.push(h),r.length>s)return i.dispose(),u.pause(),t({stream:u,buffer:r,ended:!1})},c=h=>n(h),a=()=>t({stream:u,buffer:r,ended:!0});i.add((0,C.toDisposable)(()=>u.removeListener("error",c))),u.on("error",c),i.add((0,C.toDisposable)(()=>u.removeListener("end",a))),u.on("end",a),i.add((0,C.toDisposable)(()=>u.removeListener("data",o))),u.on("data",o)})}e.peekStream=v;function p(u,s){const t=y(s);return t.end(u),t}e.toStream=p;function E(){const u=y(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=E;function S(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}e.toReadable=S;function l(u,s,t){const n=y(t);return m(u,{onData:i=>n.write(s.data(i)),onError:i=>n.error(s.error?s.error(i):i),onEnd:()=>n.end()}),n}e.transform=l;function g(u,s,t){let n=!1;return{read:()=>{const i=s.read();return n?i:(n=!0,i!==null?t([u,i]):u)}}}e.prefixedReadable=g;function w(u,s,t){let n=!1;const i=y(t);return m(s,{onData:r=>n?i.write(r):(n=!0,i.write(t([u,r]))),onError:r=>i.error(r),onEnd:()=>{n||(n=!0,i.write(u)),i.end()}}),i}e.prefixedStream=w}),define(Q[15],Z([0,1,43]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer<"u";let I,k;class O{static alloc(h){return C?new O(Buffer.allocUnsafe(h)):new O(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new O(h)}static fromString(h,D){return!(D?.dontUseNodeBuffer||!1)&&C?new O(Buffer.from(h)):(I||(I=new TextEncoder),new O(I.encode(h)))}static fromByteArray(h){const D=O.alloc(h.length);for(let N=0,B=h.length;N<B;N++)D.buffer[N]=h[N];return D}static concat(h,D){if(typeof D>"u"){D=0;for(let X=0,J=h.length;X<J;X++)D+=h[X].byteLength}const N=O.alloc(D);let B=0;for(let X=0,J=h.length;X<J;X++){const se=h[X];N.set(se,B),B+=se.byteLength}return N}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=O.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(h,D){return new O(this.buffer.subarray(h,D))}set(h,D){if(h instanceof O)this.buffer.set(h.buffer,D);else if(h instanceof Uint8Array)this.buffer.set(h,D);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),D);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return f(this.buffer,h)}writeUInt32BE(h,D){P(this.buffer,h,D)}readUInt32LE(h){return b(this.buffer,h)}writeUInt32LE(h,D){m(this.buffer,h,D)}readUInt8(h){return v(this.buffer,h)}writeUInt8(h,D){p(this.buffer,h,D)}}e.VSBuffer=O;function y(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=y;function d(a,h,D){a[D+0]=h&255,h=h>>>8,a[D+1]=h&255}e.writeUInt16LE=d;function f(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=f;function P(a,h,D){a[D+3]=h,h=h>>>8,a[D+2]=h,h=h>>>8,a[D+1]=h,h=h>>>8,a[D]=h}e.writeUInt32BE=P;function b(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=b;function m(a,h,D){a[D+0]=h&255,h=h>>>8,a[D+1]=h&255,h=h>>>8,a[D+2]=h&255,h=h>>>8,a[D+3]=h&255}e.writeUInt32LE=m;function v(a,h){return a[h]}e.readUInt8=v;function p(a,h,D){a[D]=h}e.writeUInt8=p;function E(a){return R.consumeReadable(a,h=>O.concat(h))}e.readableToBuffer=E;function S(a){return R.toReadable(a)}e.bufferToReadable=S;function l(a){return R.consumeStream(a,h=>O.concat(h))}e.streamToBuffer=l;async function g(a){return a.ended?O.concat(a.buffer):O.concat([...a.buffer,await l(a.stream)])}e.bufferedStreamToBuffer=g;function w(a){return R.toStream(a,h=>O.concat(h))}e.bufferToStream=w;function u(a){return R.transform(a,{data:h=>typeof h=="string"?O.fromString(h):O.wrap(h)},h=>O.concat(h))}e.streamToBufferReadableStream=u;function s(a){return R.newWriteableStream(h=>O.concat(h),a)}e.newWriteableBufferStream=s;function t(a,h){return R.prefixedReadable(a,h,D=>O.concat(D))}e.prefixedBufferReadable=t;function n(a,h){return R.prefixedStream(a,h,D=>O.concat(D))}e.prefixedBufferStream=n;function i(a){let h=0,D=0,N=0;const B=new Uint8Array(Math.floor(a.length/4*3)),X=se=>{switch(D){case 3:B[N++]=h|se,D=0;break;case 2:B[N++]=h|se>>>2,h=se<<6,D=3;break;case 1:B[N++]=h|se>>>4,h=se<<4,D=2;break;default:h=se<<2,D=1}};for(let se=0;se<a.length;se++){const ne=a.charCodeAt(se);if(ne>=65&&ne<=90)X(ne-65);else if(ne>=97&&ne<=122)X(ne-97+26);else if(ne>=48&&ne<=57)X(ne-48+52);else if(ne===43||ne===45)X(62);else if(ne===47||ne===95)X(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${a[se]}`)}}const J=N;for(;D>0;)X(0);return O.wrap(B).slice(0,J)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},h=!0,D=!1){const N=D?o:r;let B="";const X=a.byteLength%3;let J=0;for(;J<a.byteLength-X;J+=3){const se=a[J+0],ne=a[J+1],re=a[J+2];B+=N[se>>>2],B+=N[(se<<4|ne>>>4)&63],B+=N[(ne<<2|re>>>6)&63],B+=N[re&63]}if(X===1){const se=a[J+0];B+=N[se>>>2],B+=N[se<<4&63],h&&(B+="==")}else if(X===2){const se=a[J+0],ne=a[J+1];B+=N[se>>>2],B+=N[(se<<4|ne>>>4)&63],B+=N[ne<<2&63],h&&(B+="=")}return B}e.encodeBase64=c}),define(Q[26],Z([0,1,5]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function C(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const g=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([w,u])=>{g[w]=u&&typeof u=="object"?C(u):u}),g}e.deepClone=C;function I(l){if(!l||typeof l!="object")return l;const g=[l];for(;g.length>0;){const w=g.shift();Object.freeze(w);for(const u in w)if(k.call(w,u)){const s=w[u];typeof s=="object"&&!Object.isFrozen(s)&&!(0,R.isTypedArray)(s)&&g.push(s)}}return l}e.deepFreeze=I;const k=Object.prototype.hasOwnProperty;function O(l,g){return y(l,g,new Set)}e.cloneAndChange=O;function y(l,g,w){if((0,R.isUndefinedOrNull)(l))return l;const u=g(l);if(typeof u<"u")return u;if(Array.isArray(l)){const s=[];for(const t of l)s.push(y(t,g,w));return s}if((0,R.isObject)(l)){if(w.has(l))throw new Error("Cannot clone recursive data-structure");w.add(l);const s={};for(const t in l)k.call(l,t)&&(s[t]=y(l[t],g,w));return w.delete(l),s}return l}function d(l,g,w=!0){return(0,R.isObject)(l)?((0,R.isObject)(g)&&Object.keys(g).forEach(u=>{u in l?w&&((0,R.isObject)(l[u])&&(0,R.isObject)(g[u])?d(l[u],g[u],w):l[u]=g[u]):l[u]=g[u]}),l):g}e.mixin=d;function f(l,g){if(l===g)return!0;if(l==null||g===null||g===void 0||typeof l!=typeof g||typeof l!="object"||Array.isArray(l)!==Array.isArray(g))return!1;let w,u;if(Array.isArray(l)){if(l.length!==g.length)return!1;for(w=0;w<l.length;w++)if(!f(l[w],g[w]))return!1}else{const s=[];for(u in l)s.push(u);s.sort();const t=[];for(u in g)t.push(u);if(t.sort(),!f(s,t))return!1;for(w=0;w<s.length;w++)if(!f(l[s[w]],g[s[w]]))return!1}return!0}e.equals=f;function P(l){const g=new Set;return JSON.stringify(l,(w,u)=>{if((0,R.isObject)(u)||Array.isArray(u)){if(g.has(u))return"[Circular]";g.add(u)}return u})}e.safeStringify=P;function b(l,g){const w=Object.create(null);return!l||!g||Object.keys(g).forEach(s=>{const t=l[s],n=g[s];f(t,n)||(w[s]=n)}),w}e.distinct=b;function m(l,g){const w=g.toLowerCase(),u=Object.keys(l).find(s=>s.toLowerCase()===w);return u?l[u]:l[g]}e.getCaseInsensitive=m;function v(l,g){const w=Object.create(null);for(const[u,s]of Object.entries(l))g(u,s)&&(w[u]=s);return w}e.filter=v;function p(l){let g=[],w=Object.getPrototypeOf(l);for(;Object.prototype!==w;)g=g.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return g}e.getAllPropertyNames=p;function E(l){const g=[];for(const w of p(l))typeof l[w]=="function"&&g.push(w);return g}e.getAllMethodNames=E;function S(l,g){const w=s=>function(){const t=Array.prototype.slice.call(arguments,0);return g(s,t)},u={};for(const s of l)u[s]=w(s);return u}e.createProxyObject=S}),define(Q[30],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(I){return R.test(I)}e.isUUID=C,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(y){for(let d=0;d<y.length;d++)y[d]=Math.floor(Math.random()*256);return y};const k=new Uint8Array(16),O=[];for(let y=0;y<256;y++)O.push(y.toString(16).padStart(2,"0"));return function(){I(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let d=0,f="";return f+=O[k[d++]],f+=O[k[d++]],f+=O[k[d++]],f+=O[k[d++]],f+="-",f+=O[k[d++]],f+=O[k[d++]],f+="-",f+=O[k[d++]],f+=O[k[d++]],f+="-",f+=O[k[d++]],f+=O[k[d++]],f+="-",f+=O[k[d++]],f+=O[k[d++]],f+=O[k[d++]],f+=O[k[d++]],f+=O[k[d++]],f+=O[k[d++]],f}}()}),define(Q[71],Z([6,7]),function(_,e){return _.create("vs/base/common/date",e)}),define(Q[72],Z([0,1,71]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const C=60,I=C*60,k=I*24,O=k*7,y=k*30,d=k*365;function f(b,m,v){typeof b!="number"&&(b=b.getTime());const p=Math.round((new Date().getTime()-b)/1e3);if(p<-30)return(0,R.localize)(0,null,f(new Date().getTime()+p*1e3,!1));if(p<30)return(0,R.localize)(1,null);let E;return p<C?(E=p,m?E===1?v?(0,R.localize)(2,null,E):(0,R.localize)(3,null,E):v?(0,R.localize)(4,null,E):(0,R.localize)(5,null,E):E===1?v?(0,R.localize)(6,null,E):(0,R.localize)(7,null,E):v?(0,R.localize)(8,null,E):(0,R.localize)(9,null,E)):p<I?(E=Math.floor(p/C),m?E===1?v?(0,R.localize)(10,null,E):(0,R.localize)(11,null,E):v?(0,R.localize)(12,null,E):(0,R.localize)(13,null,E):E===1?v?(0,R.localize)(14,null,E):(0,R.localize)(15,null,E):v?(0,R.localize)(16,null,E):(0,R.localize)(17,null,E)):p<k?(E=Math.floor(p/I),m?E===1?v?(0,R.localize)(18,null,E):(0,R.localize)(19,null,E):v?(0,R.localize)(20,null,E):(0,R.localize)(21,null,E):E===1?v?(0,R.localize)(22,null,E):(0,R.localize)(23,null,E):v?(0,R.localize)(24,null,E):(0,R.localize)(25,null,E)):p<O?(E=Math.floor(p/k),m?E===1?(0,R.localize)(26,null,E):(0,R.localize)(27,null,E):E===1?(0,R.localize)(28,null,E):(0,R.localize)(29,null,E)):p<y?(E=Math.floor(p/O),m?E===1?v?(0,R.localize)(30,null,E):(0,R.localize)(31,null,E):v?(0,R.localize)(32,null,E):(0,R.localize)(33,null,E):E===1?v?(0,R.localize)(34,null,E):(0,R.localize)(35,null,E):v?(0,R.localize)(36,null,E):(0,R.localize)(37,null,E)):p<d?(E=Math.floor(p/y),m?E===1?v?(0,R.localize)(38,null,E):(0,R.localize)(39,null,E):v?(0,R.localize)(40,null,E):(0,R.localize)(41,null,E):E===1?v?(0,R.localize)(42,null,E):(0,R.localize)(43,null,E):v?(0,R.localize)(44,null,E):(0,R.localize)(45,null,E)):(E=Math.floor(p/d),m?E===1?v?(0,R.localize)(46,null,E):(0,R.localize)(47,null,E):v?(0,R.localize)(48,null,E):(0,R.localize)(49,null,E):E===1?v?(0,R.localize)(50,null,E):(0,R.localize)(51,null,E):v?(0,R.localize)(52,null,E):(0,R.localize)(53,null,E))}e.fromNow=f;function P(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(Q[73],Z([6,7]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(Q[31],Z([0,1,19,5,73]),function(_,e,R,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(b,m){return m&&(b.stack||b.stacktrace)?I.localize(0,null,y(b),O(b.stack)||O(b.stacktrace)):y(b)}function O(b){return Array.isArray(b)?b.join(`
`):b}function y(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?I.localize(1,null,b.message):b.message||I.localize(2,null)}function d(b=null,m=!1){if(!b)return I.localize(3,null);if(Array.isArray(b)){const v=R.coalesce(b),p=d(v[0],m);return v.length>1?I.localize(4,null,p,v.length):p}if(C.isString(b))return b;if(b.detail){const v=b.detail;if(v.error)return k(v.error,m);if(v.exception)return k(v.exception,m)}return b.stack?k(b,m):b.message?b.message:I.localize(5,null)}e.toErrorMessage=d;function f(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=f;function P(b,m){let v;return typeof b=="string"?v=new Error(b):v=b,v.actions=m,v}e.createErrorWithActions=P}),define(Q[74],Z([6,7]),function(_,e){return _.create("vs/base/common/jsonErrorMessages",e)}),define(Q[75],Z([0,1,74]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function C(I){switch(I){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=C}),define(Q[51],Z([0,1,12]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var C;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(C=e.Source||(e.Source={}));var I;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(y,...d){const f=d.reduce((m,v)=>(m[v]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(m=>!f[m]).forEach(m=>{for(let v=0;v<P.length;v++)if(m.search(P[v])!==-1){delete y[m];break}})}e.sanitizeProcessEnvironment=k;function O(y){!y||(delete y.DEBUG,R.isMacintosh&&delete y.DYLD_LIBRARY_PATH,R.isLinux&&delete y.LD_PRELOAD)}e.removeDangerousEnvVariables=O}),define(Q[52],Z([0,1,4,2]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const I=O=>({onDidChange:R.Event.None,value:O});e.staticObservableValue=I;class k extends C.Disposable{get value(){return this._value}set value(y){y!==this._value&&(this._value=y,this.changeEmitter.fire(y))}constructor(y){super(),this._value=y,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=k}),define(Q[53],Z([0,1,27]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function C(l){return I(l,0)}e.hash=C;function I(l,g){switch(typeof l){case"object":return l===null?k(349,g):Array.isArray(l)?d(l,g):f(l,g);case"string":return y(l,g);case"boolean":return O(l,g);case"number":return k(l,g);case"undefined":return k(937,g);default:return k(617,g)}}e.doHash=I;function k(l,g){return(g<<5)-g+l|0}e.numberHash=k;function O(l,g){return k(l?433:863,g)}function y(l,g){g=k(149417,g);for(let w=0,u=l.length;w<u;w++)g=k(l.charCodeAt(w),g);return g}e.stringHash=y;function d(l,g){return g=k(104579,g),l.reduce((w,u)=>I(u,w),g)}function f(l,g){return g=k(181387,g),Object.keys(l).sort().reduce((w,u)=>(w=y(u,w),I(l[u],w)),g)}class P{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=I(g,this._value),this._value}}e.Hasher=P;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(l,g,w=32){const u=w-g,s=~((1<<u)-1);return(l<<g|(s&l)>>>u)>>>0}function v(l,g=0,w=l.byteLength,u=0){for(let s=0;s<w;s++)l[g+s]=u}function p(l,g,w="0"){for(;l.length<g;)l=w+l;return l}function E(l,g=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(w=>w.toString(16).padStart(2,"0")).join(""):p((l>>>0).toString(16),g/4)}e.toHexString=E;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const w=g.length;if(w===0)return;const u=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,n,i;for(t!==0?(n=t,i=-1,t=0):(n=g.charCodeAt(0),i=0);;){let r=n;if(R.isHighSurrogate(n))if(i+1<w){const o=g.charCodeAt(i+1);R.isLowSurrogate(o)?(i++,r=R.computeCodePoint(n,o)):r=65533}else{t=n;break}else R.isLowSurrogate(n)&&(r=65533);if(s=this._push(u,s,r),i++,i<w)n=g.charCodeAt(i);else break}this._buffLen=s,this._leftoverHighSurrogate=t}_push(g,w,u){return u<128?g[w++]=u:u<2048?(g[w++]=192|(u&1984)>>>6,g[w++]=128|(u&63)>>>0):u<65536?(g[w++]=224|(u&61440)>>>12,g[w++]=128|(u&4032)>>>6,g[w++]=128|(u&63)>>>0):(g[w++]=240|(u&1835008)>>>18,g[w++]=128|(u&258048)>>>12,g[w++]=128|(u&4032)>>>6,g[w++]=128|(u&63)>>>0),w>=64&&(this._step(),w-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),w}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),E(this._h0)+E(this._h1)+E(this._h2)+E(this._h3)+E(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=S._bigBlock32,w=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,w.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,m(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let u=this._h0,s=this._h1,t=this._h2,n=this._h3,i=this._h4,r,o,c;for(let a=0;a<80;a++)a<20?(r=s&t|~s&n,o=1518500249):a<40?(r=s^t^n,o=1859775393):a<60?(r=s&t|s&n|t&n,o=2400959708):(r=s^t^n,o=3395469782),c=m(u,5)+r+i+o+g.getUint32(a*4,!1)&4294967295,i=n,n=t,t=m(s,30),s=u,u=c;this._h0=this._h0+u&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[54],Z([0,1,27]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(C||(C={})),function(I){const k="error",O="warning",y="warn",d="info",f="ignore";function P(m){return m?R.equalsIgnoreCase(k,m)?I.Error:R.equalsIgnoreCase(O,m)||R.equalsIgnoreCase(y,m)?I.Warning:R.equalsIgnoreCase(d,m)?I.Info:I.Ignore:I.Ignore}I.fromValue=P;function b(m){switch(m){case I.Error:return k;case I.Warning:return O;case I.Info:return d;default:return f}}I.toString=b}(C||(C={})),e.default=C}),define(Q[76],Z([0,1,10]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function C(f){const P=f;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=C;function I(f){const P=[];let b;try{const m=JSON.parse(f.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),b=v.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",f.arguments)}return{args:P,stack:b}}e.parse=I;function k(f){if(typeof f!="string")return k(I(f).stack);const P=f;if(P){const b=O(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:R.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=k;function O(f){if(!f)return f;const P=f.indexOf(`
`);return P===-1?f:f.substring(0,P)}function y(f,P){const{args:b,stack:m}=I(f),v=typeof b[0]=="string"&&b.length===1;let p=O(m);p&&(p=`(${p.trim()})`);let E=[];if(typeof b[0]=="string"?p&&v?E=[`%c[${P}] %c${b[0]} %c${p}`,d("blue"),d(""),d("grey")]:E=[`%c[${P}] %c${b[0]}`,d("blue"),d(""),...b.slice(1)]:E=[`%c[${P}]%`,d("blue"),...b],p&&!v&&E.push(p),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,E)}e.log=y;function d(f){return`color: ${f}`}}),define(Q[44],Z([0,1,15,27,10]),function(_,e,R,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(f){return JSON.stringify(f,y)}e.stringify=k;function O(f){let P=JSON.parse(f);return P=d(P),P}e.parse=O;function y(f,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,C.regExpFlags)(P)}:P}function d(f,P=0){if(!f||P>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return I.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 15:return new Date(f.source)}if(f instanceof R.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let b=0;b<f.length;++b)f[b]=d(f[b],P+1);else for(const b in f)Object.hasOwnProperty.call(f,b)&&(f[b]=d(f[b],P+1))}return f}e.revive=d}),define(Q[77],Z([0,1,37,14,20]),function(_,e,R,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,O=/^Microsoft.PowerShell_.*/,y=/^Microsoft.PowerShellPreview_.*/;var d;(function(u){u[u.x64=0]="x64",u[u.x86=1]="x86",u[u.ARM=2]="ARM"})(d||(d={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class b{constructor(s,t,n){this.exePath=s,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await I.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:u=!1}={}){return u?f===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:u=!1,findPreview:s=!1}={}){const t=m({useAlternateBitness:u});if(!t)return null;const n=C.join(t,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(n))return null;let i=-1,r=null;for(const a of await I.Promises.readdir(n)){let h=-1;if(s){const N=a.indexOf("-");if(N<0)continue;const B=a.substring(0,N);if(!k.test(B)||a.substring(N+1)!=="preview")continue;h=parseInt(B,10)}else{if(!k.test(a))continue;h=parseInt(a,10)}if(h<=i)continue;const D=C.join(n,a,"pwsh.exe");!await I.SymlinkSupport.existsFile(D)||(r=D,i=h)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",c=s?" Preview":"";return new b(r,`PowerShell${c}${o}`,!0)}async function p({findPreview:u}={}){if(!process.env.LOCALAPPDATA)return null;const s=C.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=u?{pwshMsixDirRegex:y,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const i of await I.Promises.readdir(s))if(t.test(i)){const r=C.join(s,i,"pwsh.exe");return new b(r,n)}return null}function E(){const u=C.join(R.homedir(),".dotnet","tools","pwsh.exe");return new b(u,".NET Core PowerShell Global Tool")}function S(){const u=C.join(process.env.windir,f===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(u,"Windows PowerShell",!0)}async function*l(){let u=await v();u&&(yield u),u=await v({useAlternateBitness:!0}),u&&(yield u),u=await p(),u&&(yield u),u=E(),u&&(yield u),u=await v({findPreview:!0}),u&&(yield u),u=await p({findPreview:!0}),u&&(yield u),u=await v({useAlternateBitness:!0,findPreview:!0}),u&&(yield u),u=S(),u&&(yield u)}async function*g(){for await(const u of l())await u.exists()&&(yield u)}e.enumeratePowerShellInstallations=g;async function w(){for await(const u of g())return u;return null}e.getFirstAvailablePowerShellInstallation=w}),define(Q[55],Z([0,1,14,12,32,51,5,20]),function(_,e,R,C,I,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function d(b=I.env){return b.comspec||"cmd.exe"}e.getWindowsShell=d;function f(b){let m=[],v=!1;const p=function(E){if(v){m.push(E);return}(!b.send(E,l=>{if(l&&console.error(l),v=!1,m.length>0){const g=m.slice(0);m=[],g.forEach(w=>p(w))}})||C.isWindows)&&(v=!0)};return{send:p}}e.createQueuedSender=f;var P;(function(b){async function m(v,p,E){if(R.isAbsolute(v))return v;if(p===void 0&&(p=I.cwd()),R.dirname(v)!=="."||(E===void 0&&O.isString(I.env.PATH)&&(E=I.env.PATH.split(R.delimiter)),E===void 0||E.length===0))return R.join(p,v);async function l(g){if(await y.Promises.exists(g)){let w;try{w=await y.Promises.stat(g)}catch(u){u.message.startsWith("EACCES")&&(w=await y.Promises.lstat(g))}return w?!w.isDirectory():!1}return!1}for(const g of E){let w;if(R.isAbsolute(g)?w=R.join(g,v):w=R.join(p,g,v),await l(w))return w;let u=w+".com";if(await l(u)||(u=w+".exe",await l(u)))return u}return R.join(p,v)}b.findExecutable=m})(P=e.win32||(e.win32={}))}),define(Q[78],Z([0,1,37,12,77,55]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function O(v,p){return v===1?C.isWindows?b():k.getWindowsShell(p):f(v,p)}e.getSystemShell=O;function y(v,p){return v===1?C.isWindows?m(p):k.getWindowsShell(p):f(v,p)}e.getSystemShellSync=y;let d=null;function f(v,p){if(C.isLinux&&v===2||C.isMacintosh&&v===3)return"/bin/bash";if(!d){let E;if(C.isWindows)E="/bin/bash";else{if(E=p.SHELL,!E)try{E=(0,R.userInfo)().shell}catch{}E||(E="sh"),E==="/bin/false"&&(E="/bin/bash")}d=E}return d}let P=null;async function b(){return P||(P=(await(0,I.getFirstAvailablePowerShellInstallation)()).exePath),P}function m(v){if(P)return P;const p=C.isWindows&&parseFloat((0,R.release)())>=10,E=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${v.windir}\\${E?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return p?S:k.getWindowsShell(v)}});var de=this&&this.__decorate||function(_,e,R,C){var I=arguments.length,k=I<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,R):C,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(_,e,R,C);else for(var y=_.length-1;y>=0;y--)(O=_[y])&&(k=(I<3?O(k):I>3?O(e,R,k):O(e,R))||k);return I>3&&k&&Object.defineProperty(e,R,k),k};define(Q[56],Z([0,1,19,3,15,24,49,11,4,2,44,27,5]),function(_,e,R,C,I,k,O,y,d,f,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=void 0;var v;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(v||(v={}));function p(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(E||(E={}));function S(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));class g{constructor(F){this.buffer=F,this.pos=0}read(F){const z=this.buffer.slice(this.pos,this.pos+F);return this.pos+=z.byteLength,z}}class w{constructor(){this.buffers=[]}get buffer(){return I.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var u;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(u||(u={}));function s(M){const F=I.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function t(M){return M.read(4).readUInt32BE(0)}function n(M){const F=I.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const i={Undefined:n(u.Undefined),String:n(u.String),Buffer:n(u.Buffer),VSBuffer:n(u.VSBuffer),Array:n(u.Array),Object:n(u.Object)},r=typeof Buffer<"u";function o(M,F){if(typeof F>"u")M.write(i.Undefined);else if(typeof F=="string"){const z=I.VSBuffer.fromString(F);M.write(i.String),M.write(s(z.byteLength)),M.write(z)}else if(r&&Buffer.isBuffer(F)){const z=I.VSBuffer.wrap(F);M.write(i.Buffer),M.write(s(z.byteLength)),M.write(z)}else if(F instanceof I.VSBuffer)M.write(i.VSBuffer),M.write(s(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(i.Array),M.write(s(F.length));for(const z of F)o(M,z)}else{const z=I.VSBuffer.fromString(JSON.stringify(F));M.write(i.Object),M.write(s(z.byteLength)),M.write(z)}}function c(M){switch(M.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return M.read(t(M)).toString();case u.Buffer:return M.read(t(M)).buffer;case u.VSBuffer:return M.read(t(M));case u.Array:{const z=t(M),$=[];for(let Y=0;Y<z;Y++)$.push(c(M));return $}case u.Object:return JSON.parse(M.read(t(M)).toString())}}class a{constructor(F,z,$=null,Y=1e3){this.protocol=F,this.ctx=z,this.logger=$,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(A=>this.onRawMessage(A)),this.sendResponse({type:200})}registerChannel(F,z){this.channels.set(F,z),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const z=this.send([F.type]);this.logger?.logOutgoing(z,0,1,S(F.type));return}case 201:case 202:case 204:case 203:{const z=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(z,F.id,1,S(F.type),F.data);return}}}send(F,z=void 0){const $=new w;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const z=new g(F),$=c(z),Y=c(z),A=$[0];switch(A){case 100:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}: ${$[2]}.${$[3]}`,Y),this.onPromise({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 102:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}: ${$[2]}.${$[3]}`,Y),this.onEventListen({type:A,id:$[1],channelName:$[2],name:$[3],arg:Y});case 101:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}`),this.disposeActiveRequest({type:A,id:$[1]});case 103:return this.logger?.logIncoming(F.byteLength,$[1],1,`${p(A)}`),this.disposeActiveRequest({type:A,id:$[1]})}}onPromise(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=new k.CancellationTokenSource;let Y;try{Y=z.call(this.ctx,F.name,F.arg,$.token)}catch(L){Y=Promise.reject(L)}const A=F.id;Y.then(L=>{this.sendResponse({id:A,data:L,type:201}),this.activeRequests.delete(F.id)},L=>{L instanceof Error?this.sendResponse({id:A,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.sendResponse({id:A,data:L,type:203}),this.activeRequests.delete(F.id)});const x=(0,f.toDisposable)(()=>$.cancel());this.activeRequests.set(F.id,x)}onEventListen(F){const z=this.channels.get(F.channelName);if(!z){this.collectPendingRequest(F);return}const $=F.id,A=z.listen(this.ctx,F.name,F.arg)(x=>this.sendResponse({id:$,data:x,type:204}));this.activeRequests.set(F.id,A)}disposeActiveRequest(F){const z=this.activeRequests.get(F.id);z&&(z.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let z=this.pendingRequests.get(F.channelName);z||(z=[],this.pendingRequests.set(F.channelName,z));const $=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:F,timeoutTimer:$})}flushPendingRequests(F){const z=this.pendingRequests.get(F);if(z){for(const $ of z)switch(clearTimeout($.timeoutTimer),$.request.type){case 100:this.onPromise($.request);break;case 102:this.onEventListen($.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(F,z=null){this.protocol=F,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage($=>this.onBuffer($)),this.logger=z}getChannel(F){const z=this;return{call($,Y,A){return z.isDisposed?Promise.reject(new y.CancellationError):z.requestPromise(F,$,Y,A)},listen($,Y){return z.isDisposed?d.Event.None:z.requestEvent(F,$,Y)}}}requestPromise(F,z,$,Y=k.CancellationToken.None){const A=this.lastRequestId++,L={id:A,type:100,channelName:F,name:z,arg:$};if(Y.isCancellationRequested)return Promise.reject(new y.CancellationError);let T;return new Promise((W,q)=>{if(Y.isCancellationRequested)return q(new y.CancellationError);const H=()=>{const Se=le=>{switch(le.type){case 201:this.handlers.delete(A),W(le.data);break;case 202:{this.handlers.delete(A);const te=new Error(le.data.message);te.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,te.name=le.data.name,q(te);break}case 203:this.handlers.delete(A),q(le.data);break}};this.handlers.set(A,Se),this.sendRequest(L)};let oe=null;this.state===l.Idle?H():(oe=(0,C.createCancelablePromise)(Se=>this.whenInitialized()),oe.then(()=>{oe=null,H()}));const ue=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:A,type:101}),q(new y.CancellationError)},ve=Y.onCancellationRequested(ue);T=(0,f.combinedDisposable)((0,f.toDisposable)(ue),ve),this.activeRequests.add(T)}).finally(()=>{this.activeRequests.delete(T)})}requestEvent(F,z,$){const Y=this.lastRequestId++,x={id:Y,type:102,channelName:F,name:z,arg:$};let L=null;const T=new d.Emitter({onWillAddFirstListener:()=>{L=(0,C.createCancelablePromise)(W=>this.whenInitialized()),L.then(()=>{L=null,this.activeRequests.add(T),this.sendRequest(x)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.activeRequests.delete(T),this.sendRequest({id:Y,type:103}))}}),U=W=>T.fire(W.data);return this.handlers.set(Y,U),T.event}sendRequest(F){switch(F.type){case 100:case 102:{const z=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(z,F.id,0,`${p(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const z=this.send([F.type,F.id]);this.logger?.logOutgoing(z,F.id,0,p(F.type));return}}}send(F,z=void 0){const $=new w;return o($,F),o($,z),this.sendBuffer($.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const z=new g(F),$=c(z),Y=c(z),A=$[0];switch(A){case 200:return this.logger?.logIncoming(F.byteLength,0,0,S(A)),this.onResponse({type:$[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,$[1],0,S(A),Y),this.onResponse({type:$[0],id:$[1],data:Y})}}onResponse(F){if(F.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,f.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}de([O.memoize],D.prototype,"onDidInitializePromise",null),e.ChannelClient=D;class N{get connections(){const F=[];return this._connections.forEach(z=>F.push(z)),F}constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:z,onDidClientDisconnect:$})=>{d.Event.once(z.onMessage)(A=>{const x=new g(A),L=c(x),T=new a(z,L),U=new D(z);this.channels.forEach((q,H)=>T.registerChannel(H,q));const W={channelServer:T,channelClient:U,ctx:L};this._connections.add(W),this._onDidAddConnection.fire(W),$(()=>{T.dispose(),U.dispose(),this._connections.delete(W),this._onDidRemoveConnection.fire(W)})})})}getChannel(F,z){const $=this;return{call(Y,A,x){let L;if((0,m.isFunction)(z)){const U=(0,R.getRandomElement)($.connections.filter(z));L=U?Promise.resolve(U):d.Event.toPromise(d.Event.filter($.onDidAddConnection,z))}else L=z.routeCall($,Y,A);const T=L.then(U=>U.channelClient.getChannel(F));return X(T).call(Y,A,x)},listen(Y,A){if((0,m.isFunction)(z))return $.getMulticastEvent(F,z,Y,A);const x=z.routeEvent($,Y,A).then(L=>L.channelClient.getChannel(F));return X(x).listen(Y,A)}}}getMulticastEvent(F,z,$,Y){const A=this;let x=new f.DisposableStore;const L=new d.Emitter({onWillAddFirstListener:()=>{x=new f.DisposableStore;const T=new d.EventMultiplexer,U=new Map,W=H=>{const ue=H.channelClient.getChannel(F).listen($,Y),ve=T.add(ue);U.set(H,ve)},q=H=>{const oe=U.get(H);!oe||(oe.dispose(),U.delete(H))};A.connections.filter(z).forEach(W),d.Event.filter(A.onDidAddConnection,z)(W,void 0,x),A.onDidRemoveConnection(q,void 0,x),T.event(L.fire,L,x),x.add(T)},onDidRemoveLastListener:()=>{x.dispose()}});return L.event}registerChannel(F,z){this.channels.set(F,z),this._connections.forEach($=>{$.channelServer.registerChannel(F,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=N;class B{constructor(F,z,$=null){const Y=new w;o(Y,z),F.send(Y.buffer),this.channelClient=new D(F,$),this.channelServer=new a(F,z,$)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,z){this.channelServer.registerChannel(F,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=B;function X(M){return{call(F,z,$){return M.then(Y=>Y.call(F,z,$))},listen(F,z){const $=new d.Relay;return M.then(Y=>$.input=Y.listen(F,z)),$.event}}}e.getDelayedChannel=X;function J(M){let F=!1;return{call(z,$,Y){return F?M.call(z,$,Y):(0,C.timeout)(0).then(()=>F=!0).then(()=>M.call(z,$,Y))},listen(z,$){if(F)return M.listen(z,$);const Y=new d.Relay;return(0,C.timeout)(0).then(()=>F=!0).then(()=>Y.input=M.listen(z,$)),Y.event}}}e.getNextTickChannel=J;class se{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const z of F.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await d.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=se;var ne;(function(M){function F(A,x){const L=A,T=x&&x.disableMarshalling,U=new Map;for(const W in L)$(W)&&U.set(W,d.Event.buffer(L[W],!0));return new class{listen(W,q,H){const oe=U.get(q);if(oe)return oe;if(Y(q)){const ue=L[q];if(typeof ue=="function")return ue.call(L,H)}throw new Error(`Event not found: ${q}`)}call(W,q,H){const oe=L[q];if(typeof oe=="function"){if(!T&&Array.isArray(H))for(let ue=0;ue<H.length;ue++)H[ue]=(0,P.revive)(H[ue]);return oe.apply(L,H)}throw new Error(`Method not found: ${q}`)}}}M.fromService=F;function z(A,x){const L=x&&x.disableMarshalling;return new Proxy({},{get(T,U){if(typeof U=="string")return x?.properties?.has(U)?x.properties.get(U):Y(U)?function(W){return A.listen(U,W)}:$(U)?A.listen(U):async function(...W){let q;x&&!(0,m.isUndefinedOrNull)(x.context)?q=[x.context,...W]:q=W;const H=await A.call(U,q);return L?H:(0,P.revive)(H)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=z;function $(A){return A[0]==="o"&&A[1]==="n"&&b.isUpperAsciiLetter(A.charCodeAt(2))}function Y(A){return/^onDynamic/.test(A)&&b.isUpperAsciiLetter(A.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const F=M.toString();if(F!=="[object Object]")return F}return M}function ce(M){return Array.isArray(M)?M.map(ge):ge(M)}function ie(M,F,z,$,Y,A,x){x=ce(x);const L=re[Y],T=L[$%L.length];let U=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String($).padStart(5," ")} - ${A}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(A)?(U=U.concat(x),U.push(")")):U.push(x),console.log.apply(console,U)}class j{constructor(F,z){this._outgoingPrefix=F,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,z,$,Y,A){this._totalOutgoing+=F,ie(this._outgoingPrefix,this._totalOutgoing,F,z,$,Y,A)}logIncoming(F,z,$,Y,A){this._totalIncoming+=F,ie(this._incomingPrefix,this._totalIncoming,F,z,$,Y,A)}}e.IPCLogger=j}),define(Q[79],Z([0,1,57,3,15,24,76,11,4,2,26,55,51,56]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends v.ChannelServer{constructor(l){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",g=>I.VSBuffer.wrap(Buffer.from(g,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.Server=p;class E{constructor(l,g){this.modulePath=l,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new C.Delayer(w),this.child=null,this._client=null}getChannel(l){const g=this;return{call(w,u,s){return g.requestPromise(l,w,u,s)},listen(w,u){return g.requestEvent(l,w,u)}}}requestPromise(l,g,w,u=k.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),t=(0,C.createCancelablePromise)(r=>s.call(g,w,r)),n=u.onCancellationRequested(()=>t.cancel()),i=(0,f.toDisposable)(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{n.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(l,g,w){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let u;const s=new d.Emitter({onWillAddFirstListener:()=>{u=this.getCachedChannel(l).listen(g,w)(s.fire,s),this.activeRequests.add(u)},onDidRemoveLastListener:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,m.removeDangerousEnvVariables)(g.env),this.child=(0,R.fork)(this.modulePath,l,g);const w=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,O.isRemoteConsoleLog)(o)){(0,O.log)(o,`IPC Library: ${this.options.serverName}`);return}w.fire(I.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,t=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=w.event,i={send:t,onMessage:n};this._client=new v.ChannelClient(i);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",r),this.activeRequests.forEach(a=>(0,f.dispose)(a)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(l){let g=this.channels.get(l);return g||(g=this.client.getChannel(l),this.channels.set(l,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer?.cancel(),this.disposeDelayer=void 0,this.disposeClient(),this.activeRequests.clear()}}e.Client=E}),define(Q[80],Z([0,1,3,4,2,5]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var O;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));function y(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=y;var d;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class f extends I.Disposable{constructor(m,v=Object.create(null)){super(),this.database=m,this.options=v,this._onDidChangeStorage=this._register(new C.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((v,p)=>this.accept(p,v)),m.deleted?.forEach(v=>this.accept(v,void 0))}accept(m,v){if(this.state===d.Closed)return;let p=!1;(0,k.isUndefinedOrNull)(v)?p=this.cache.delete(m):this.cache.get(m)!==v&&(this.cache.set(m,v),p=!0),p&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,v){const p=this.cache.get(m);return(0,k.isUndefinedOrNull)(p)?v:p}getBoolean(m,v){const p=this.get(m);return(0,k.isUndefinedOrNull)(p)?v:p==="true"}getNumber(m,v){const p=this.get(m);return(0,k.isUndefinedOrNull)(p)?v:parseInt(p,10)}async set(m,v){if(this.state===d.Closed)return;if((0,k.isUndefinedOrNull)(v))return this.delete(m);const p=String(v);if(this.cache.get(m)!==p)return this.cache.set(m,p),this.pendingInserts.set(m,p),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===d.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert?.forEach((v,p)=>this.items.set(p,v)),m.delete?.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=P}),define(Q[81],Z([6,7]),function(_,e){return _.create("vs/base/node/zip",e)}),define(Q[82],Z([6,7]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[83],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Q[84],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[85],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Q[86],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Q[87],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Q[88],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[89],Z([6,7]),function(_,e){return _.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[90],Z([6,7]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[91],Z([6,7]),function(_,e){return _.create("vs/platform/files/common/fileService",e)}),define(Q[92],Z([6,7]),function(_,e){return _.create("vs/platform/files/common/io",e)}),define(Q[93],Z([6,7]),function(_,e){return _.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[94],Z([6,7]),function(_,e){return _.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Q[95],Z([6,7]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(Q[96],Z([6,7]),function(_,e){return _.create("vs/platform/shell/node/shellEnv",e)}),define(Q[97],Z([6,7]),function(_,e){return _.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[98],Z([6,7]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Q[99],Z([6,7]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(Q[100],Z([0,1,72,49,16,14,32,18,10]),function(_,e,R,C,I,k,O,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class f{get appRoot(){return(0,k.dirname)(I.FileAccess.asFileUri("",_).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,y.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,y.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const E=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",E)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get remoteTunnelLogResource(){return d.URI.file((0,k.join)(this.logsPath,"remoteTunnel.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,y.joinPath)(d.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,y.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,y.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,y.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const E=O.env.VSCODE_PORTABLE;return E?d.URI.file((0,k.join)(E,"argv.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const E=this.args["builtin-extensions-dir"];return E?(0,k.resolve)(E):(0,k.normalize)((0,k.join)(I.FileAccess.asFileUri("",_).fsPath,"..","extensions"))}get extensionsDownloadLocation(){const E=this.args["extensions-download-dir"];return E?d.URI.file((0,k.resolve)(E)):d.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const E=this.args["extensions-dir"];if(E)return(0,k.resolve)(E);const S=O.env.VSCODE_EXTENSIONS;if(S)return S;const l=O.env.VSCODE_PORTABLE;return l?(0,k.join)(l,"extensions"):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const E=this.args.extensionDevelopmentPath;if(Array.isArray(E))return E.map(S=>/^[^:/?#]+?:\/\//.test(S)?d.URI.parse(S):d.URI.file((0,k.normalize)(S)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(E=>E==="ui"||E==="workspace"||E==="web"?E:"workspace")}get extensionTestsLocationURI(){const E=this.args.extensionTestsPath;if(E)return/^[^:/?#]+?:\/\//.test(E)?d.URI.parse(E):d.URI.file((0,k.normalize)(E))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const E=this.args["disable-extension"];if(E){if(typeof E=="string")return[E];if(Array.isArray(E)&&E.length>0)return E}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(E=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(E))}get extensionLogLevel(){const E=[];for(const S of this.args.log||[]){const l=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(S);l&&l[1]&&l[2]&&E.push([l[1],l[2]])}return E.length?E:void 0}get serviceMachineIdResource(){return(0,y.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const E=O.env.VSCODE_PORTABLE;return E?d.URI.file((0,k.join)(E,"policy.json")):(0,y.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(E){this.args.continueOn=E}get args(){return this._args}constructor(E,S,l){this._args=E,this.paths=S,this.productService=l,this.editSessionId=this.args.editSessionId}}de([C.memoize],f.prototype,"appRoot",null),de([C.memoize],f.prototype,"userHome",null),de([C.memoize],f.prototype,"userDataPath",null),de([C.memoize],f.prototype,"appSettingsHome",null),de([C.memoize],f.prototype,"tmpDir",null),de([C.memoize],f.prototype,"cacheHome",null),de([C.memoize],f.prototype,"stateResource",null),de([C.memoize],f.prototype,"userRoamingDataHome",null),de([C.memoize],f.prototype,"userDataSyncHome",null),de([C.memoize],f.prototype,"userDataSyncLogResource",null),de([C.memoize],f.prototype,"editSessionsLogResource",null),de([C.memoize],f.prototype,"remoteTunnelLogResource",null),de([C.memoize],f.prototype,"sync",null),de([C.memoize],f.prototype,"machineSettingsResource",null),de([C.memoize],f.prototype,"workspaceStorageHome",null),de([C.memoize],f.prototype,"localHistoryHome",null),de([C.memoize],f.prototype,"keyboardLayoutResource",null),de([C.memoize],f.prototype,"argvResource",null),de([C.memoize],f.prototype,"isExtensionDevelopment",null),de([C.memoize],f.prototype,"untitledWorkspacesHome",null),de([C.memoize],f.prototype,"installSourcePath",null),de([C.memoize],f.prototype,"builtinExtensionsPath",null),de([C.memoize],f.prototype,"extensionsPath",null),de([C.memoize],f.prototype,"extensionDevelopmentLocationURI",null),de([C.memoize],f.prototype,"extensionDevelopmentKind",null),de([C.memoize],f.prototype,"extensionTestsLocationURI",null),de([C.memoize],f.prototype,"debugExtensionHost",null),de([C.memoize],f.prototype,"logLevel",null),de([C.memoize],f.prototype,"extensionLogLevel",null),de([C.memoize],f.prototype,"serviceMachineIdResource",null),de([C.memoize],f.prototype,"telemetryLogResource",null),de([C.memoize],f.prototype,"disableWorkspaceTrust",null),de([C.memoize],f.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=f;function P(p,E){return v(p["inspect-extensions"],p["inspect-brk-extensions"],5870,E,p.debugId,p.extensionEnvironment)}e.parseExtensionHostPort=P;function b(p,E){return v(p["inspect-search"],p["inspect-brk-search"],5876,E,p.extensionEnvironment)}e.parseSearchPort=b;function m(p,E){return v(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,E,p.extensionEnvironment)}e.parsePtyHostPort=m;function v(p,E,S,l,g,w){const s=Number(E||p)||(l?null:S),t=s?Boolean(!!E):!1;let n;if(w)try{n=JSON.parse(w)}catch{}return{port:s,break:t,debugId:g,env:n}}}),function(){"use strict";function _(e,R,C){function I(O,y){const d=k(O,y),f=[d];return e.isAbsolute(d)||f.unshift(C),e.resolve(...f)}function k(O,y){process.env.VSCODE_DEV&&(y="code-oss-dev");const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,y);const P=O["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(b,"AppData","Roaming")}break;case"darwin":f=e.join(R.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,y)}return{getUserDataPath:I}}if(typeof define=="function")define(Q[101],Z([151,37,32]),function(e,R,C){return _(e,R,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),R=require("os");module.exports=_(e,R,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[102],Z([0,1,37,100,101]),function(_,e,R,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends C.AbstractNativeEnvironmentService{constructor(y,d){super(y,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,I.getUserDataPath)(y,d.nameShort)},d)}}e.NativeEnvironmentService=k}),define(Q[103],Z([0,1,5,86]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function I(O,y,d){try{k(O,y,d)}catch(f){console.error(f?.message??f)}return O}e.localizeManifest=I;function k(O,y,d){const f=(P,b,m)=>{const v=P[b];if((0,R.isString)(v)){const p=v,E=p.length;if(E>1&&p[0]==="%"&&p[E-1]==="%"){const S=p.substr(1,E-2);let l=y[S];l===void 0&&d&&(l=d[S]);const g=typeof l=="string"?l:l?.message,w=d?.[S],u=typeof w=="string"?w:w?.message;if(!g){u||console.warn(`[${O.name}]: ${(0,C.localize)(0,null,S)}`);return}if(m&&(b==="title"||b==="category")&&u&&u!==g){const s={value:g,original:u};P[b]=s}else P[b]=g}}else if((0,R.isObject)(v))for(const p in v)v.hasOwnProperty(p)&&(p==="commands"?f(v,p,!0):f(v,p,m));else if(Array.isArray(v))for(let p=0;p<v.length;p++)f(v,p,m)};for(const P in O)O.hasOwnProperty(P)&&f(O,P)}}),define(Q[45],Z([0,1,18,54,90,38]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function d(l){return l=l.trim(),l==="*"||O.test(l)}e.isValidVersionStr=d;function f(l){if(!d(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=l.match(O);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=f;function P(l){if(!l)return null;const g=l.majorBase,w=l.majorMustEqual,u=l.minorBase;let s=l.minorMustEqual;const t=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(g===0||(s=!1),n=!1);let i=0;if(l.preRelease){const r=y.exec(l.preRelease);if(r){const[,o,c,a]=r;i=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:g,majorMustEqual:w,minorBase:u,minorMustEqual:s,patchBase:t,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:i}}e.normalizeVersion=P;function b(l,g,w){let u;typeof l=="string"?u=P(f(l)):u=l;let s;g instanceof Date?s=g.getTime():typeof g=="string"&&(s=new Date(g).getTime());let t;if(typeof w=="string"?t=P(f(w)):t=w,!u||!t)return!1;const n=u.majorBase,i=u.minorBase,r=u.patchBase;let o=t.majorBase,c=t.minorBase,a=t.patchBase;const h=t.notBefore;let D=t.majorMustEqual,N=t.minorMustEqual,B=t.patchMustEqual;return t.isMinimum?n>o?!0:n<o?!1:i>c?!0:i<c||s&&s<h?!1:r>=a:(n===1&&o===0&&(!D||!N||!B)&&(o=1,c=0,a=0,D=!0,N=!1,B=!1),n<o?!1:n>o?!D:i<c?!1:i>c?!N:r<a?!1:r>a?!B:!(s&&s<h))}e.isValidVersion=b;function m(l,g,w,u,s){const t=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return t.push([C.default.Error,I.localize(0,null)]),t;if(typeof u.name!="string")return t.push([C.default.Error,I.localize(1,null,"name")]),t;if(typeof u.version!="string")return t.push([C.default.Error,I.localize(2,null,"version")]),t;if(!u.engines)return t.push([C.default.Error,I.localize(3,null,"engines")]),t;if(typeof u.engines.vscode!="string")return t.push([C.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof u.extensionDependencies<"u"&&!S(u.extensionDependencies))return t.push([C.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof u.activationEvents<"u"){if(!S(u.activationEvents))return t.push([C.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof u.main>"u"&&typeof u.browser>"u")return t.push([C.default.Error,I.localize(7,null,"activationEvents","main")]),t}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&t.push([C.default.Warning,I.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return t.push([C.default.Error,I.localize(9,null,"main")]),t;{const r=(0,R.joinPath)(w,u.main);(0,R.isEqualOrParent)(r,w)||t.push([C.default.Warning,I.localize(10,null,r.path,w.path)])}if(typeof u.activationEvents>"u")return t.push([C.default.Error,I.localize(11,null,"activationEvents","main")]),t}if(typeof u.browser<"u"){if(typeof u.browser!="string")return t.push([C.default.Error,I.localize(12,null,"browser")]),t;{const r=(0,R.joinPath)(w,u.browser);(0,R.isEqualOrParent)(r,w)||t.push([C.default.Warning,I.localize(13,null,r.path,w.path)])}if(typeof u.activationEvents>"u")return t.push([C.default.Error,I.localize(14,null,"activationEvents","browser")]),t}if(!k.valid(u.version))return t.push([C.default.Error,I.localize(15,null)]),t;const n=[];if(!v(l,g,u,s,n))for(const r of n)t.push([C.default.Error,r]);return t}e.validateExtensionManifest=m;function v(l,g,w,u,s){return u||typeof w.main>"u"&&typeof w.browser>"u"?!0:E(l,g,w.engines.vscode,s)}e.isValidExtensionVersion=v;function p(l,g,w){return l==="*"||E(g,w,l)}e.isEngineValid=p;function E(l,g,w,u=[]){const s=P(f(w));if(!s)return u.push(I.localize(16,null,w)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return u.push(I.localize(17,null,w)),!1}else if(!s.majorMustEqual)return u.push(I.localize(18,null,w)),!1;return b(l,g,s)?!0:(u.push(I.localize(19,null,l,w)),!1)}function S(l){if(!Array.isArray(l))return!1;for(let g=0,w=l.length;g<w;g++)if(typeof l[g]!="string")return!1;return!0}}),define(Q[104],Z([0,1,15,30]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function I(k,O,y){let d=y&&y.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const P=(await O.readFile(k.serviceMachineIdResource)).value.toString();d=(0,C.isUUID)(P)?P:null}catch{d=null}if(!d){d=(0,C.generateUuid)();try{await O.writeFile(k.serviceMachineIdResource,R.VSBuffer.fromString(d))}catch{}}return y?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=I}),define(Q[46],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(I,k=[],O=!1){this.ctor=I,this.staticArguments=k,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=R}),define(Q[105],Z([0,1,46]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const C=[];var I;(function(y){y[y.Eager=0]="Eager",y[y.Delayed=1]="Delayed"})(I=e.InstantiationType||(e.InstantiationType={}));function k(y,d,f){d instanceof R.SyncDescriptor||(d=new R.SyncDescriptor(d,[],Boolean(f))),C.push([y,d])}e.registerSingleton=k;function O(){return C}e.getSingletonServiceDescriptors=O}),define(Q[106],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(k,O){this.key=k,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.Node=R;class C{constructor(k){this._hashFn=k,this._nodes=new Map}roots(){const k=[];for(const O of this._nodes.values())O.outgoing.size===0&&k.push(O);return k}insertEdge(k,O){const y=this.lookupOrInsertNode(k),d=this.lookupOrInsertNode(O);y.outgoing.set(d.key,d),d.incoming.set(y.key,y)}removeNode(k){const O=this._hashFn(k);this._nodes.delete(O);for(const y of this._nodes.values())y.outgoing.delete(O),y.incoming.delete(O)}lookupOrInsertNode(k){const O=this._hashFn(k);let y=this._nodes.get(O);return y||(y=new R(O,k),this._nodes.set(O,y)),y}lookup(k){return this._nodes.get(this._hashFn(k))}isEmpty(){return this._nodes.size===0}toString(){const k=[];for(const[O,y]of this._nodes)k.push(`${O}
	(-> incoming)[${[...y.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...y.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,O]of this._nodes){const y=new Set([k]),d=this._findCycle(O,y);if(d)return d}}_findCycle(k,O){for(const[y,d]of k.outgoing){if(O.has(y))return[...O,y].join(" -> ");O.add(y);const f=this._findCycle(d,O);if(f)return f;O.delete(y)}}}e.Graph=C}),define(Q[21],Z([0,1,5,10,8]),function(_,e,R,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function k(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof C.URI)}e.isConfigurationOverrides=k;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof C.URI)}e.isConfigurationUpdateOverrides=O;var y;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function f(l,g){const w=Object.create(null);for(const u in l)P(w,u,l[u],g);return w}e.toValuesTree=f;function P(l,g,w,u){const s=g.split("."),t=s.pop();let n=l;for(let i=0;i<s.length;i++){const r=s[i];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:u(`Ignoring ${g} as ${s.slice(0,i+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[t]=w}catch{u(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(n)}`)}else u(`Ignoring ${g} as ${s.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=P;function b(l,g){const w=g.split(".");m(l,w)}e.removeFromValueTree=b;function m(l,g){const w=g.shift();if(g.length===0){delete l[w];return}if(Object.keys(l).indexOf(w)!==-1){const u=l[w];typeof u=="object"&&!Array.isArray(u)&&(m(u,g),Object.keys(u).length===0&&delete l[w])}}function v(l,g,w){function u(n,i){let r=n;for(const o of i){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=g.split("."),t=u(l,s);return typeof t>"u"?w:t}e.getConfigurationValue=v;function p(l,g,w){Object.keys(g).forEach(u=>{u!=="__proto__"&&(u in l?R.isObject(l[u])&&R.isObject(g[u])?p(l[u],g[u],w):w&&(l[u]=g[u]):l[u]=g[u])})}e.merge=p;function E(l,g,w){const u=l.inspect(g),s=l.inspect(w);return typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:typeof s.userValue<"u"||typeof s.workspaceValue<"u"||typeof s.workspaceFolderValue<"u"?s.value:u.defaultValue}e.getMigratedSettingValue=E;function S(l){return l.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=S}),define(Q[58],Z([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(Q[17],Z([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[22],Z([0,1,84,8]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function I(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function k(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function O(l,g){switch(l){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=O;function y(l,g){return g==="web"&&!l.includes("web")}e.isNotWebExtensionInWebTargetPlatform=y;function d(l,g,w){return y(g,w)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===w?!0:f(w).includes(l)}e.isTargetPlatformCompatible=d;function f(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=f;function P(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.isIExtensionIdentifier=P;var b;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var m;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var p;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var E;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal",l.Signature="Signature"})(E=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class S extends Error{constructor(g,w){super(g),this.code=w,this.name=w}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(Q[59],Z([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,R.createDecorator)("IExtensionSignatureVerificationService");class C{vsceSign(){return this.moduleLoadingPromise||(this.moduleLoadingPromise=new Promise((k,O)=>_(["node-vsce-sign"],async y=>k(y),O))),this.moduleLoadingPromise}async verify(k,O){let y;try{y=await this.vsceSign()}catch{return!1}return y.verify(k,O)}}e.ExtensionSignatureVerificationService=C}),define(Q[60],Z([0,1,15,11,92,13]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function O(P,b,m,v,p,E){let S;try{await y(P,b,m,v,p,E)}catch(l){S=l}finally{S&&p.errorTransformer&&(S=p.errorTransformer(S)),typeof S<"u"&&m.error(S),m.end()}}e.readFileIntoStream=O;async function y(P,b,m,v,p,E){d(E);const S=await P.open(b,{create:!1});try{d(E);let l=0,g=0,w=p&&typeof p.length=="number"?p.length:void 0,u=R.VSBuffer.alloc(Math.min(p.bufferSize,typeof w=="number"?w:p.bufferSize)),s=p&&typeof p.position=="number"?p.position:0,t=0;do g=await P.read(S,s,u.buffer,t,u.byteLength-t),s+=g,t+=g,l+=g,typeof w=="number"&&(w-=g),t===u.byteLength&&(await m.write(v(u)),u=R.VSBuffer.alloc(Math.min(p.bufferSize,typeof w=="number"?w:p.bufferSize)),t=0);while(g>0&&(typeof w!="number"||w>0)&&d(E)&&f(l,p));if(t>0){let n=t;typeof w=="number"&&(n=Math.min(t,w)),m.write(v(u.slice(0,n)))}}catch(l){throw(0,k.ensureFileSystemProviderError)(l)}finally{await P.close(S)}}function d(P){if(P.isCancellationRequested)throw(0,C.canceled)();return!0}function f(P,b){if(b?.limits){if(typeof b.limits.memory=="number"&&P>b.limits.memory)throw(0,k.createFileSystemProviderError)((0,I.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&P>b.limits.size)throw(0,k.createFileSystemProviderError)((0,I.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[107],Z([0,1,4,152,2,12,153]),function(_,e,R,C,I,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class y extends I.Disposable{constructor(){super(...arguments),this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(f){const P=this.normalizeRequests(f),b=P.filter(v=>{const p=this.watchers.get(v.path);return p?!(0,C.patternsEquals)(p.request.excludes,v.excludes)||!(0,C.patternsEquals)(p.request.includes,v.includes):!0}),m=Array.from(this.watchers.values()).filter(({request:v})=>!P.find(p=>p.path===v.path&&(0,C.patternsEquals)(p.excludes,v.excludes)&&(0,C.patternsEquals)(p.includes,v.includes))).map(({request:v})=>v.path);b.length&&this.trace(`Request to start watching: ${b.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),m.length&&this.trace(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.stopWatching(v);for(const v of b)this.startWatching(v)}startWatching(f){const P=new O.NodeJSFileWatcherLibrary(f,m=>this._onDidChangeFile.fire(m),m=>this._onDidLogMessage.fire(m),this.verboseLogging),b={request:f,instance:P};this.watchers.set(f.path,b)}async stop(){for(const[f]of this.watchers)this.stopWatching(f);this.watchers.clear()}stopWatching(f){const P=this.watchers.get(f);P&&(this.watchers.delete(f),P.instance.dispose())}normalizeRequests(f){const P=new Map;for(const b of f){const m=k.isLinux?b.path:b.path.toLowerCase();P.set(m,b)}return Array.from(P.values())}async setVerboseLogging(f){this.verboseLogging=f;for(const[,P]of this.watchers)P.instance.setVerboseLogging(f)}trace(f){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(f)})}toMessage(f,P){return P?`[File Watcher (node.js)] ${f} (path: ${P.request.path})`:`[File Watcher (node.js)] ${f}`}}e.NodeJSWatcher=y}),define(Q[108],Z([0,1,61,107]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class I extends R.AbstractNonRecursiveWatcherClient{constructor(O,y,d){super(O,y,d),this.init()}createWatcher(){return new C.NodeJSWatcher}}e.NodeJSWatcherClient=I}),define(Q[109],Z([0,1,16,56,79,61]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class O extends k.AbstractUniversalWatcherClient{constructor(d,f,P){super(d,f,P),this.init()}createWatcher(d){const f=d.add(new I.Client(R.FileAccess.asFileUri("bootstrap-fork",_).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(f.onDidProcessExit(({code:P,signal:b})=>this.onError(`terminated by itself with code ${P}, signal: ${b}`))),C.ProxyChannel.toService((0,C.getNextTickChannel)(f.getChannel("watcher")))}}e.UniversalWatcherClient=O}),define(Q[62],Z([0,1]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...I){this._entries=new Map;for(const[k,O]of I)this.set(k,O)}set(I,k){const O=this._entries.get(I);return this._entries.set(I,k),O}has(I){return this._entries.has(I)}get(I){return this._entries.get(I)}}e.ServiceCollection=R}),define(Q[110],Z([0,1,3,11,2,46,106,8,62,154]),function(_,e,R,C,I,k,O,y,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class b extends Error{constructor(S){super("cyclic dependency between services"),this.message=S.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${S.toString()}`}}class m{constructor(S=new d.ServiceCollection,l=!1,g,w=P){this._services=S,this._strict=l,this._parent=g,this._enableTracing=w,this._activeInstantiations=new Set,this._services.set(y.IInstantiationService,this),this._globalGraph=w?g?._globalGraph??new O.Graph(u=>u):void 0}createChild(S){return new m(S,this._strict,this,this._enableTracing)}invokeFunction(S,...l){const g=p.traceInvocation(this._enableTracing,S);let w=!1;try{return S({get:s=>{if(w)throw(0,C.illegalState)("service accessor is only valid during the invocation of its target method");const t=this._getOrCreateServiceInstance(s,g);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...l)}finally{w=!0,g.stop()}}createInstance(S,...l){let g,w;return S instanceof k.SyncDescriptor?(g=p.traceCreation(this._enableTracing,S.ctor),w=this._createInstance(S.ctor,S.staticArguments.concat(l),g)):(g=p.traceCreation(this._enableTracing,S),w=this._createInstance(S,l,g)),g.stop(),w}_createInstance(S,l=[],g){const w=y._util.getServiceDependencies(S).sort((t,n)=>t.index-n.index),u=[];for(const t of w){const n=this._getOrCreateServiceInstance(t.id,g);n||this._throwIfStrict(`[createInstance] ${S.name} depends on UNKNOWN service ${t.id}.`,!1),u.push(n)}const s=w.length>0?w[0].index:l.length;if(l.length!==s){console.trace(`[createInstance] First service dependency of ${S.name} at position ${s+1} conflicts with ${l.length} static arguments`);const t=s-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,s)}return Reflect.construct(S,l.concat(u))}_setServiceInstance(S,l){if(this._services.get(S)instanceof k.SyncDescriptor)this._services.set(S,l);else if(this._parent)this._parent._setServiceInstance(S,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(S){const l=this._services.get(S);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(S):l}_getOrCreateServiceInstance(S,l){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(S));const g=this._getServiceInstanceOrDescriptor(S);return g instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(S,g,l.branch(S,!0)):(l.branch(S,!1),g)}_safeCreateAndCacheServiceInstance(S,l,g){if(this._activeInstantiations.has(S))throw new Error(`illegal state - RECURSIVELY instantiating service '${S}'`);this._activeInstantiations.add(S);try{return this._createAndCacheServiceInstance(S,l,g)}finally{this._activeInstantiations.delete(S)}}_createAndCacheServiceInstance(S,l,g){const w=new O.Graph(t=>t.id.toString());let u=0;const s=[{id:S,desc:l,_trace:g}];for(;s.length;){const t=s.pop();if(w.lookupOrInsertNode(t),u++>1e3)throw new b(w);for(const n of y._util.getServiceDependencies(t.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(n.id);if(i||this._throwIfStrict(`[createInstance] ${S} depends on ${n.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(n.id)),i instanceof k.SyncDescriptor){const r={id:n.id,desc:i,_trace:t._trace.branch(n.id,!0)};w.insertEdge(t,r),s.push(r)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:n}of t){if(this._getServiceInstanceOrDescriptor(n.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(n.id,n.desc.ctor,n.desc.staticArguments,n.desc.supportsDelayedInstantiation,n._trace);this._setServiceInstance(n.id,r)}w.removeNode(n)}}return this._getServiceInstanceOrDescriptor(S)}_createServiceInstanceWithOwner(S,l,g=[],w,u){if(this._services.get(S)instanceof k.SyncDescriptor)return this._createServiceInstance(S,l,g,w,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(S,l,g,w,u);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(S,l,g=[],w,u){if(w){const s=new m(void 0,this._strict,this,this._enableTracing);s._globalGraphImplicitDependency=String(S);const t=new Map,n=new R.IdleValue(()=>{const i=s._createInstance(l,g,u);for(const[r,o]of t){const c=i[r];if(typeof c=="function")for(const a of o)c.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!n.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let a=t.get(r);return a||(a=new f.LinkedList,t.set(r,a)),(D,N,B)=>{const X=a.push([D,N,B]);return(0,I.toDisposable)(X)}}if(r in i)return i[r];const o=n.value;let c=o[r];return typeof c!="function"||(c=c.bind(o),i[r]=c),c},set(i,r,o){return n.value[r]=o,!0}})}else return this._createInstance(l,g,u)}_throwIfStrict(S,l){if(l&&console.warn(S),this._strict)throw new Error(S)}}e.InstantiationService=m;var v;(function(E){E[E.Creation=0]="Creation",E[E.Invocation=1]="Invocation",E[E.Branch=2]="Branch"})(v||(v={}));class p{static traceInvocation(S,l){return S?new p(1,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p._None}static traceCreation(S,l){return S?new p(0,l.name):p._None}constructor(S,l){this.type=S,this.name=l,this._start=Date.now(),this._dep=[]}branch(S,l){const g=new p(2,S.toString());return this._dep.push([S,l,g]),g}stop(){const S=Date.now()-this._start;p._totals+=S;let l=!1;function g(u,s){const t=[],n=new Array(u+1).join("	");for(const[i,r,o]of s._dep)if(r&&o){l=!0,t.push(`${n}CREATES -> ${i}`);const c=g(u+1,o);c&&t.push(c)}else t.push(`${n}uses -> ${i}`);return t.join(`
`)}const w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${S.toFixed(2)}ms (grand total ${p._totals.toFixed(2)}ms)`];(S>2||l)&&p.all.add(w.join(`
`))}}e.Trace=p,p.all=new Set,p._None=new class extends p{constructor(){super(-1,null)}stop(){}branch(){return this}},p._totals=0});var ee=this&&this.__param||function(_,e){return function(R,C){e(R,C,_)}};define(Q[63],Z([0,1,24,2,12,94,22,8]),function(_,e,R,C,I,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,y.createDecorator)("languagePackService");let d=class extends C.Disposable{constructor(P){super(),this.extensionGalleryService=P}async getAvailableLanguages(){const P=new R.CancellationTokenSource;setTimeout(()=>P.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},P.token)}catch{return[]}const v=b.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(E=>E.startsWith("lp-"))).map(p=>{const E=p.properties.localizedLanguages?.[0],S=this.getLocale(p);return{...this.createQuickPickItem(S,E,p),extensionId:p.identifier.id,galleryExtension:p}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(P){return P.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(P,b,m){const v=b??P;let p;if(v!==P&&(p=`(${P})`),P.toLowerCase()===I.language.toLowerCase()&&(p??="",p+=(0,k.localize)(0,null)),m?.installCount){p??="";const E=m.installCount;let S;E>1e6?S=`${Math.floor(E/1e5)/10}M`:E>1e3?S=`${Math.floor(E/1e3)}K`:S=String(E),p+=` $(cloud-download) ${S}`}return{id:P,label:v,description:p}}};d=de([ee(0,O.IExtensionGalleryService)],d),e.LanguagePackBaseService=d}),define(Q[9],Z([0,1,31,4,2,39,12,10,8]),function(_,e,R,C,I,k,O,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,d.createDecorator)("logService"),e.ILoggerService=(0,d.createDecorator)("loggerService");function f(){return new Date().toISOString()}var P;(function(c){c[c.Off=0]="Off",c[c.Trace=1]="Trace",c[c.Debug=2]="Debug",c[c.Info=3]="Info",c[c.Warning=4]="Warning",c[c.Error=5]="Error"})(P=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=P.Info;function b(c,a,h){switch(a){case P.Trace:c.trace(h);break;case P.Debug:c.debug(h);break;case P.Info:c.info(h);break;case P.Warning:c.warn(h);break;case P.Error:c.error(h);break;default:throw new Error("Invalid log level")}}e.log=b;function m(c){let a="";for(let h=0;h<c.length;h++){let D=c[h];if(typeof D=="object")try{D=JSON.stringify(D)}catch{}a+=(h>0?" ":"")+D}return a}e.format=m;class v extends I.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new C.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(a){this.level!==a&&(this.level=a,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=v;class p extends v{constructor(a){super(),this.logAlways=a}checkLogLevel(a){return this.logAlways||this.getLevel()<=a}trace(a,...h){this.checkLogLevel(P.Trace)&&this.log(P.Trace,m([a,...h]))}debug(a,...h){this.checkLogLevel(P.Debug)&&this.log(P.Debug,m([a,...h]))}info(a,...h){this.checkLogLevel(P.Info)&&this.log(P.Info,m([a,...h]))}warn(a,...h){this.checkLogLevel(P.Warning)&&this.log(P.Warning,m([a,...h]))}error(a,...h){if(this.checkLogLevel(P.Error))if(a instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=a.stack,this.log(P.Error,m(D))}else this.log(P.Error,m([a,...h]))}flush(){}}e.AbstractMessageLogger=p;class E extends v{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a),this.useColors=!O.isWindows}trace(a,...h){this.getLevel()<=P.Trace&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,a,...h):console.log(`[main ${f()}]`,a,...h))}debug(a,...h){this.getLevel()<=P.Debug&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,a,...h):console.log(`[main ${f()}]`,a,...h))}info(a,...h){this.getLevel()<=P.Info&&(this.useColors?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,a,...h):console.log(`[main ${f()}]`,a,...h))}warn(a,...h){this.getLevel()<=P.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,a,...h):console.warn(`[main ${f()}]`,a,...h))}error(a,...h){this.getLevel()<=P.Error&&(this.useColors?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,a,...h):console.error(`[main ${f()}]`,a,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=E;class S extends v{constructor(a=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(a)}trace(a,...h){this.getLevel()<=P.Trace&&console.log("%cTRACE","color: #888",a,...h)}debug(a,...h){this.getLevel()<=P.Debug&&console.log("%cDEBUG","background: #eee; color: #888",a,...h)}info(a,...h){this.getLevel()<=P.Info&&console.log("%c INFO","color: #33f",a,...h)}warn(a,...h){this.getLevel()<=P.Warning&&console.log("%c WARN","color: #993",a,...h)}error(a,...h){this.getLevel()<=P.Error&&console.log("%c  ERR","color: #f33",a,...h)}dispose(){}flush(){}}e.ConsoleLogger=S;class l extends v{constructor(a,h=e.DEFAULT_LOG_LEVEL){super(),this.adapter=a,this.setLevel(h)}trace(a,...h){this.getLevel()<=P.Trace&&this.adapter.log(P.Trace,[this.extractMessage(a),...h])}debug(a,...h){this.getLevel()<=P.Debug&&this.adapter.log(P.Debug,[this.extractMessage(a),...h])}info(a,...h){this.getLevel()<=P.Info&&this.adapter.log(P.Info,[this.extractMessage(a),...h])}warn(a,...h){this.getLevel()<=P.Warning&&this.adapter.log(P.Warning,[this.extractMessage(a),...h])}error(a,...h){this.getLevel()<=P.Error&&this.adapter.log(P.Error,[this.extractMessage(a),...h])}extractMessage(a){return typeof a=="string"?a:(0,R.toErrorMessage)(a,this.getLevel()<=P.Trace)}dispose(){}flush(){}}e.AdapterLogger=l;class g extends v{constructor(a){super(),this.logServices=a,a.length&&this.setLevel(a[0].getLevel())}setLevel(a){for(const h of this.logServices)h.setLevel(a);super.setLevel(a)}trace(a,...h){for(const D of this.logServices)D.trace(a,...h)}debug(a,...h){for(const D of this.logServices)D.debug(a,...h)}info(a,...h){for(const D of this.logServices)D.info(a,...h)}warn(a,...h){for(const D of this.logServices)D.warn(a,...h)}error(a,...h){for(const D of this.logServices)D.error(a,...h)}flush(){for(const a of this.logServices)a.flush()}dispose(){for(const a of this.logServices)a.dispose()}}e.MultiplexLogService=g;class w extends I.Disposable{constructor(a){super(),this.logger=a,this._register(a)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(a){this.logger.setLevel(a)}getLevel(){return this.logger.getLevel()}trace(a,...h){this.logger.trace(a,...h)}debug(a,...h){this.logger.debug(a,...h)}info(a,...h){this.logger.info(a,...h)}warn(a,...h){this.logger.warn(a,...h)}error(a,...h){this.logger.error(a,...h)}flush(){this.logger.flush()}}e.LogService=w;class u extends I.Disposable{constructor(a,h){super(),this.logLevel=a,this.loggerItems=new k.ResourceMap,this._register(h(D=>this.setLevel(D)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:a})=>a)}getLogger(a){return this.loggerItems.get(a)?.logger}createLogger(a,h,D){let N=this.loggerItems.get(a)?.logger;return N||(D=h?.always?P.Trace:D,N=this.doCreateLogger(a,D??this.logLevel,h),this.loggerItems.set(a,{logger:N,logLevel:D})),N}setLevel(a,h){const D=y.URI.isUri(a)?a:void 0,N=D?h:a;if(D){const B=this.loggerItems.get(D);B&&B.logLevel!==N&&(B.logLevel=N,B.logger.setLevel(N))}else this.logLevel=N,this.loggerItems.forEach(({logLevel:B,logger:X})=>{B===void 0&&X.setLevel(this.logLevel)})}getLogLevel(a){return this.loggerItems.get(a)?.logLevel}dispose(){this.loggerItems.forEach(({logger:a})=>a.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=u;class s{constructor(){this.onDidChangeLogLevel=new C.Emitter().event}setLevel(a){}getLevel(){return P.Info}trace(a,...h){}debug(a,...h){}info(a,...h){}warn(a,...h){}error(a,...h){}critical(a,...h){}dispose(){}flush(){}}e.NullLogger=s;class t extends s{}e.NullLogService=t;class n extends u{constructor(){super(P.Info,C.Event.None)}doCreateLogger(a,h,D){return new s}}e.NullLoggerService=n;function i(c){if(c.verbose)return P.Trace;if(typeof c.logLevel=="string"){const a=o(c.logLevel.toLowerCase());if(a!==void 0)return a}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function r(c){switch(c){case P.Trace:return"trace";case P.Debug:return"debug";case P.Info:return"info";case P.Warning:return"warn";case P.Error:return"error";case P.Off:return"off"}}e.LogLevelToString=r;function o(c){switch(c){case"trace":return P.Trace;case"debug":return P.Debug;case"info":return P.Info;case"warn":return P.Warning;case"error":return P.Error;case"critical":return P.Error;case"off":return P.Off}}e.parseLogLevel=o}),define(Q[111],Z([0,1,19,3,11,4,2,14,61,9]),function(_,e,R,C,I,k,O,y,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends O.Disposable{constructor(m,v){super(),this.logService=m,this.options=v,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new C.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new C.ThrottledDelayer(0))}watch(m,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(m,v):this.watchNonRecursive(m,v)}watchUniversal(m,v){const p={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive},E=(0,R.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,O.toDisposable)(()=>{E(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(m=>(0,I.onUnexpectedError)(m))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,d.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)})));const m=this.options?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(v)&&m.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(m,v){const p={path:this.toFilePath(m),excludes:v.excludes,includes:v.includes,recursive:!1},E=(0,R.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,O.toDisposable)(()=>{E(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(m=>(0,I.onUnexpectedError)(m))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,y.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(Q[112],Z([0,1,19,3,15,24,4,53,64,2,113,16,114,18,43,91,13,60,9]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class extends f.Disposable{constructor(s){super(),this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(s,t){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${s}`);const n=new f.DisposableStore;return this.provider.set(s,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:t}),n.add(t.onDidChangeFile(i=>this._onDidFilesChange.fire(new S.FileChangesEvent(i,!this.isPathCaseSensitive(t))))),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),n.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:s}))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:t}),this.provider.delete(s),(0,f.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){t.push(n)}}),!this.provider.has(s)&&await C.Promises.settled(t)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,t){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return d.Iterable.map(this.provider,([s,t])=>({scheme:s,capabilities:t.capabilities}))}async withProvider(s){if(!(0,v.isAbsolutePath)(s))throw new S.FileOperationError((0,E.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const t=this.provider.get(s.scheme);if(!t){const n=new Error;throw n.name="ENOPRO",n.message=(0,E.localize)(1,null,s.toString()),n}return t}async withReadProvider(s){const t=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(t)||(0,S.hasReadWriteCapability)(t)||(0,S.hasFileReadStreamCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const t=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(t)||(0,S.hasReadWriteCapability)(t))return t;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,t){try{return await this.doResolveFile(s,t)}catch(n){throw(0,S.toFileSystemProviderErrorCode)(n)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,E.localize)(2,null,this.resourceForError(s)),1):(0,S.ensureFileSystemProviderError)(n)}}async doResolveFile(s,t){const n=await this.withProvider(s),i=this.isPathCaseSensitive(n),r=t?.resolveTo,o=t?.resolveSingleChildDescendants,c=t?.resolveMetadata,a=await n.stat(s);let h;return this.toFileStat(n,s,a,void 0,!!c,(D,N)=>(h||(h=P.TernarySearchTree.forUris(()=>!i),h.set(s,!0),r&&h.fill(!0,r)),h.get(D.resource)||h.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&o?N===1:!1))}async toFileStat(s,t,n,i,r,o){const{providerExtUri:c}=this.getExtUri(s),a={resource:t,name:c.basename(t),isFile:(n.type&S.FileType.File)!==0,isDirectory:(n.type&S.FileType.Directory)!==0,isSymbolicLink:(n.type&S.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&S.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,S.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(a.isDirectory&&o(a,i)){try{const h=await s.readdir(t),D=await C.Promises.settled(h.map(async([N,B])=>{try{const X=c.joinPath(t,N),J=r?await s.stat(X):{type:B};return await this.toFileStat(s,X,J,h.length,r,o)}catch(X){return this.logService.trace(X),null}}));a.children=(0,R.coalesce)(D)}catch(h){this.logService.trace(h),a.children=[]}return a}return a}async resolveAll(s){return C.Promises.settled(s.map(async t=>{try{return{stat:await this.doResolveFile(t.resource,t.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const t=await this.withProvider(s),n=await t.stat(s);return this.toFileStat(t,s,n,void 0,!0,()=>!1)}async exists(s){const t=await this.withProvider(s);try{return!!await t.stat(s)}catch{return!1}}async canCreateFile(s,t){try{await this.doValidateCreateFile(s,t)}catch(n){return n}return!0}async doValidateCreateFile(s,t){if(!t?.overwrite&&await this.exists(s))throw new S.FileOperationError((0,E.localize)(3,null,this.resourceForError(s)),3,t)}async createFile(s,t=I.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const i=await this.writeFile(s,t);return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,i)),i}async writeFile(s,t,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,s,n)||await this.mkdirp(i,r.dirname(s));let c;if((0,S.hasReadWriteCapability)(i)&&!(t instanceof I.VSBuffer))if((0,p.isReadableStream)(t)){const a=await(0,p.peekStream)(t,3);a.ended?c=I.VSBuffer.concat(a.buffer):c=a}else c=(0,p.peekReadable)(t,a=>I.VSBuffer.concat(a),3);else c=t;!(0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i)&&c instanceof I.VSBuffer?await this.doWriteUnbuffered(i,s,n,c):await this.doWriteBuffered(i,s,n,c instanceof I.VSBuffer?(0,I.bufferToReadable)(c):c),this._onDidRunOperation.fire(new S.FileOperationEvent(s,4))}catch(o){throw new S.FileOperationError((0,E.localize)(4,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,t,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,E.localize)(5,null,this.resourceForError(t)));let r;try{r=await s.stat(t)}catch{return}if((r.type&S.FileType.Directory)!==0)throw new S.FileOperationError((0,E.localize)(6,null,this.resourceForError(t)),0,n);if(this.throwIfFileIsReadonly(t,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==S.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,S.etag)({mtime:n.mtime,size:r.size}))throw new S.FileOperationError((0,E.localize)(7,null),3,n);return r}async readFile(s,t,n){const i=await this.withReadProvider(s);return t?.atomic?this.doReadFileAtomic(i,s,t,n):this.doReadFile(i,s,t,n)}async doReadFileAtomic(s,t,n,i){return new Promise((r,o)=>{this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(s,t,n,i);r(c)}catch(c){o(c)}})})}async doReadFile(s,t,n,i){const r=await this.doReadFileStream(s,t,{...n,preferUnbuffered:!0},i);return{...r,value:await(0,I.streamToBuffer)(r.value)}}async readFileStream(s,t,n){const i=await this.withReadProvider(s);return this.doReadFileStream(i,s,t,n)}async doReadFileStream(s,t,n,i){const r=new k.CancellationTokenSource(i),o=this.validateReadFile(t,n).then(a=>a,a=>{throw r.cancel(),a});let c;try{return typeof n?.etag=="string"&&n.etag!==S.ETAG_DISABLED&&await o,n?.atomic&&(0,S.hasFileAtomicReadCapability)(s)||!((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasFileReadStreamCapability)(s))||(0,S.hasReadWriteCapability)(s)&&n?.preferUnbuffered?c=this.readFileUnbuffered(s,t,n):(0,S.hasFileReadStreamCapability)(s)?c=this.readFileStreamed(s,t,r.token,n):c=this.readFileBuffered(s,t,r.token,n),{...await o,value:c}}catch(a){c&&await(0,p.consumeStream)(c);const h=(0,E.localize)(8,null,this.resourceForError(t),(0,S.ensureFileSystemProviderError)(a).toString());throw a instanceof S.NotModifiedSinceFileOperationError?new S.NotModifiedSinceFileOperationError(h,a.stat,n):new S.FileOperationError(h,(0,S.toFileOperationResult)(a),n)}}readFileStreamed(s,t,n,i=Object.create(null)){const r=s.readFileStream(t,i,n);return(0,p.transform)(r,{data:o=>o instanceof I.VSBuffer?o:I.VSBuffer.wrap(o),error:o=>new S.FileOperationError((0,E.localize)(9,null,this.resourceForError(t),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),i)},o=>I.VSBuffer.concat(o))}readFileBuffered(s,t,n,i=Object.create(null)){const r=(0,I.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,t,r,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new S.FileOperationError((0,E.localize)(10,null,this.resourceForError(t),(0,S.ensureFileSystemProviderError)(o).toString()),(0,S.toFileOperationResult)(o),i)},n),r}readFileUnbuffered(s,t,n){const i=(0,p.newWriteableStream)(r=>I.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,S.hasFileAtomicReadCapability)(s)?r=await s.readFile(t,{atomic:!0}):r=await s.readFile(t),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(t,r.byteLength,n),i.end(I.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(s,t){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new S.FileOperationError((0,E.localize)(11,null,this.resourceForError(s)),0,t);if(typeof t?.etag=="string"&&t.etag!==S.ETAG_DISABLED&&t.etag===n.etag)throw new S.NotModifiedSinceFileOperationError((0,E.localize)(12,null),n,t);return this.validateReadFileLimits(s,n.size,t),n}validateReadFileLimits(s,t,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&t>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&t>n.limits.size&&(i=7),typeof i=="number")throw new S.FileOperationError((0,E.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,t,n){return this.doCanMoveCopy(s,t,"move",n)}async canCopy(s,t,n){return this.doCanMoveCopy(s,t,"copy",n)}async doCanMoveCopy(s,t,n,i){if(s.toString()!==t.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(r,s,o,t,n,i)}catch(r){return r}return!0}async move(s,t,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(i,s,r,t,"move",!!n),c=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="move"?2:3,c)),c}async copy(s,t,n){const i=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(i,s,r,t,"copy",!!n),c=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,o==="copy"?3:2,c)),c}async doMoveCopy(s,t,n,i,r,o){if(t.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(s,t,n,i,r,o);if(c&&!a&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(i)),r==="copy"){if(s===n&&(0,S.hasFileFolderCopyCapability)(s))await s.copy(t,i,{overwrite:o});else{const h=await this.resolve(t);h.isDirectory?await this.doCopyFolder(s,h,n,i):await this.doCopyFile(s,t,n,i)}return r}else return s===n?(await s.rename(t,i,{overwrite:o}),r):(await this.doMoveCopy(s,t,n,i,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(s,t,n,i){if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,t,n,i);if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,t,n,i);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,t,n,i);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,t,n,i)}async doCopyFolder(s,t,n,i){await n.mkdir(i),Array.isArray(t.children)&&await C.Promises.settled(t.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,t,n,i,r,o){let c=!1;if(s===n){const{providerExtUri:h,isPathCaseSensitive:D}=this.getExtUri(s);if(D||(c=h.isEqual(t,i)),c&&r==="copy")throw new Error((0,E.localize)(14,null,this.resourceForError(t),this.resourceForError(i)));if(!c&&h.isEqualOrParent(i,t))throw new Error((0,E.localize)(15,null,this.resourceForError(t),this.resourceForError(i)))}const a=await this.exists(i);if(a&&!c){if(!o)throw new S.FileOperationError((0,E.localize)(16,null,this.resourceForError(t),this.resourceForError(i)),4);if(s===n){const{providerExtUri:h}=this.getExtUri(s);if(h.isEqualOrParent(t,i))throw new Error((0,E.localize)(17,null,this.resourceForError(t),this.resourceForError(i)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}getExtUri(s){const t=this.isPathCaseSensitive(s);return{providerExtUri:t?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(t,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,n)),n}async mkdirp(s,t){const n=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(t,i.dirname(t));)try{if(((await s.stat(t)).type&S.FileType.Directory)===0)throw new Error((0,E.localize)(18,null,this.resourceForError(t)));break}catch(r){if((0,S.toFileSystemProviderErrorCode)(r)!==S.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(i.basename(t)),t=i.dirname(t)}for(let r=n.length-1;r>=0;r--){t=i.joinPath(t,n[r]);try{await s.mkdir(t)}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,t){try{await this.doValidateDelete(s,t)}catch(n){return n}return!0}async doValidateDelete(s,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!t?.useTrash&&!(n.capabilities&4096))throw new Error((0,E.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new S.FileOperationError((0,E.localize)(20,null,this.resourceForError(s)),1);if(!!!t?.recursive){const c=await this.resolve(s);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,E.localize)(21,null,this.resourceForError(s)))}return n}async del(s,t){const n=await this.doValidateDelete(s,t),i=!!t?.useTrash,r=!!t?.recursive;await n.delete(s,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new S.FileOperationEvent(s,1))}async cloneFile(s,t){const n=await this.withProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);if(n===i&&this.getExtUri(n).providerExtUri.isEqual(s,t))return;if(n===i&&(0,S.hasFileCloneCapability)(n))return n.cloneFile(s,t);await this.mkdirp(i,this.getExtUri(i).providerExtUri.dirname(t));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===i&&(0,S.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,t,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,i,t))}watch(s,t={recursive:!1,excludes:[]}){const n=new f.DisposableStore;let i=!1,r=()=>{i=!0};return n.add((0,f.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,t);i?(0,f.dispose)(o):r=()=>(0,f.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,t){const n=await this.withProvider(s),i=(0,y.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),t]);let r=this.activeWatchers.get(i);return r||(r={count:0,disposable:n.watch(s,t)},this.activeWatchers.set(i,r)),r.count+=1,(0,f.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,f.dispose)(r.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,f.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,t,n,i){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,r,i):await this.doWriteReadableBufferedQueued(s,r,i)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,t,n){let i=0,r;if((0,p.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=I.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,t,o,o.byteLength,i,0),i+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,c)=>{(0,p.listenStream)(r,{onData:async a=>{r.pause();try{await this.doWriteBuffer(s,t,a,a.byteLength,i,0)}catch(h){return c(h)}i+=a.byteLength,setTimeout(()=>r.resume())},onError:a=>c(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,t,n){let i=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,t,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(s,t,n,i,r,o){let c=0;for(;c<i;)c+=await s.write(t,r+c,n.buffer,o+c,i-c)}async doWriteUnbuffered(s,t,n,i){return this.writeQueue.queueFor(t,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,t,n,i))}async doWriteUnbufferedQueued(s,t,n,i){let r;i instanceof I.VSBuffer?r=i:(0,p.isReadableStream)(i)?r=await(0,I.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?r=await(0,I.bufferedStreamToBuffer)(i):r=(0,I.readableToBuffer)(i),await s.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,t,n,i))}async doPipeBufferedQueued(s,t,n,i){let r,o;try{r=await s.open(t,{create:!1}),o=await n.open(i,{create:!0,unlock:!1});const c=I.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,h=0,D=0;do D=await s.read(r,a,c.buffer,h,c.byteLength-h),await this.doWriteBuffer(n,o,c,D,a,h),a+=D,h+=D,h===c.byteLength&&(h=0);while(D>0)}catch(c){throw(0,S.ensureFileSystemProviderError)(c)}finally{await C.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,t,n,i))}async doPipeUnbufferedQueued(s,t,n,i){return n.writeFile(i,await s.readFile(t),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,t,n,i){return this.writeQueue.queueFor(i,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,t,n,i))}async doPipeUnbufferedToBufferedQueued(s,t,n,i){const r=await n.open(i,{create:!0,unlock:!1});try{const o=await s.readFile(t);await this.doWriteBuffer(n,r,I.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,S.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,t,n,i){const r=await(0,I.streamToBuffer)(this.readFileBuffered(s,t,k.CancellationToken.None));await this.doWriteUnbuffered(n,i,void 0,r)}throwIfFileSystemIsReadonly(s,t){if(s.capabilities&2048)throw new S.FileOperationError((0,E.localize)(22,null,this.resourceForError(t)),6);return s}throwIfFileIsReadonly(s,t){if((t.permissions??0)&S.FilePermission.Readonly)throw new S.FileOperationError((0,E.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===b.Schemas.file?s.fsPath:s.toString(!0)}};w=de([ee(0,g.ILogService)],w),e.FileService=w}),define(Q[115],Z([0,1,116,155,3,39,15,4,156,2,14,12,18,43,20,93,13,60,111,31,109,108]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l,g,w,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,C.gracefulify)(R)}catch(n){console.error(`Error enabling graceful-fs: ${(0,w.toErrorMessage)(n)}`)}})();class t extends g.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=y.Event.None,this.resourceLocks=new k.ResourceMap(o=>m.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=57374,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:r,symbolicLink:o}=await p.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(i){try{const r=await p.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,m.joinPath)(i,c.name))).type:a=this.toType(c),o.push([c.name,a])}catch(a){this.logService.trace(a)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(i,r){let o;return r?.dangling?o=S.FileType.Unknown:i.isFile()?o=S.FileType.File:i.isDirectory()?o=S.FileType.Directory:o=S.FileType.Unknown,r&&(o|=S.FileType.SymbolicLink),o}async createResourceLock(i){const r=this.toFilePath(i);this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(i);)this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const c=new I.Barrier;return this.resourceLocks.set(i,c),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,f.toDisposable)(()=>{this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(i)===c&&(this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(i)),this.traceLock(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),c.open()})}async readFile(i,r){let o;try{r?.atomic&&(this.traceLock(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const c=this.toFilePath(i);return await p.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{o?.dispose()}}traceLock(i){t.TRACE_LOG_RESOURCE_LOCKS&&this.logService.trace(i)}readFileStream(i,r,o){const c=(0,v.newWriteableStream)(a=>O.VSBuffer.concat(a.map(h=>O.VSBuffer.wrap(h))).buffer);return(0,l.readFileIntoStream)(this,i,c,a=>a.buffer,{...r,bufferSize:256*1024},o),c}async writeFile(i,r,o){let c;try{const a=this.toFilePath(i);if(!o.create||!o.overwrite){if(await p.Promises.exists(a)){if(!o.overwrite)throw(0,S.createFileSystemProviderError)((0,E.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,S.createFileSystemProviderError)((0,E.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(c,0,r,0,r.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(i,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(i){t.canFlush=i}async open(i,r){const o=this.toFilePath(i);let c;(0,S.isFileOpenForWriteOptions)(r)&&(c=await this.createResourceLock(i));let a;try{if((0,S.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:D}=await p.SymlinkSupport.stat(o);D.mode&128||await p.Promises.chmod(o,D.mode|128)}catch(D){this.logService.trace(D)}let h;if((0,S.isFileOpenForWriteOptions)(r)){if(b.isWindows)try{await p.Promises.truncate(o,0),h="r+"}catch(D){D.code!=="ENOENT"&&this.logService.trace(D)}h||(h="w")}else h="r";a=await p.Promises.open(o,h)}catch(h){throw c?.dispose(),(0,S.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(i,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(a,0),(0,S.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(a,i),c){const h=this.mapHandleToLock.get(a);this.traceLock(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,c),h&&(this.traceLock(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),h.dispose())}return a}async close(i){const r=this.mapHandleToLock.get(i);try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&t.canFlush)try{await p.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.logService.error(o)}return await p.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(i)===r&&(this.traceLock(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.mapHandleToLock.delete(i)),this.traceLock(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,o,c,a){const h=this.normalizePos(i,r);let D=null;try{D=(await p.Promises.read(i,o,c,a,h)).bytesRead}catch(N){throw this.toFileSystemProviderError(N)}finally{this.updatePos(i,h,D)}return D}normalizePos(i,r){return r===this.mapHandleToPos.get(i)?null:r}updatePos(i,r,o){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,c+o):this.mapHandleToPos.delete(i)))}async write(i,r,o,c,a){return(0,I.retry)(()=>this.doWrite(i,r,o,c,a),100,3)}async doWrite(i,r,o,c,a){const h=this.normalizePos(i,r);let D=null;try{D=(await p.Promises.write(i,o,c,a,h)).bytesWritten}catch(N){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),N)}finally{this.updatePos(i,h,D)}return D}async mkdir(i){try{await p.Promises.mkdir(this.toFilePath(i))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(i,r){try{const o=this.toFilePath(i);r.recursive?await p.Promises.rm(o,p.RimRafMode.MOVE):await p.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,r,o){const c=this.toFilePath(i),a=this.toFilePath(r);if(c!==a)try{await this.validateTargetDeleted(i,r,"move",o.overwrite),await p.Promises.move(c,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,E.localize)(2,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(i,r,o){const c=this.toFilePath(i),a=this.toFilePath(r);if(c!==a)try{await this.validateTargetDeleted(i,r,"copy",o.overwrite),await p.Promises.copy(c,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,E.localize)(3,null,(0,P.basename)(c),(0,P.basename)((0,P.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(i,r,o,c){const a=this.toFilePath(i),h=this.toFilePath(r);let D=!1;if(!!(this.capabilities&1024)||(D=(0,d.isEqual)(a,h,!0)),D&&o==="copy")throw(0,S.createFileSystemProviderError)((0,E.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!D&&await p.Promises.exists(h)){if(!c)throw(0,S.createFileSystemProviderError)((0,E.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.doCloneFile(i,r,!1)}async doCloneFile(i,r,o){const c=this.toFilePath(i),a=this.toFilePath(r),h=!!(this.capabilities&1024);if((0,d.isEqual)(c,a,!h))return;const D=new f.DisposableStore;try{const[N,B]=await Promise.all([this.createResourceLock(i),this.createResourceLock(r)]);D.add(N),D.add(B),o&&await p.Promises.mkdir((0,P.dirname)(a),{recursive:!0}),await p.Promises.copyFile(c,a)}catch(N){if(N.code==="ENOENT"&&!o)return this.doCloneFile(i,r,!0);throw this.toFileSystemProviderError(N)}finally{D.dispose()}}createUniversalWatcher(i,r,o){return new u.UniversalWatcherClient(c=>i(c),c=>r(c),o)}createNonRecursiveWatcher(i,r,o){return new s.NodeJSWatcherClient(c=>i(c),c=>r(c),o)}toFileSystemProviderError(i){if(i instanceof S.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=S.FileSystemProviderErrorCode.NoPermissions;break;default:r=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(i,r)}async toFileSystemProviderWriteError(i,r){let o=this.toFileSystemProviderError(r);if(i&&o.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await p.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(o=(0,S.createFileSystemProviderError)(r,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return o}}e.DiskFileSystemProvider=t,t.TRACE_LOG_RESOURCE_LOCKS=!1,t.canFlush=!0}),define(Q[117],Z([0,1,13,9]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var I;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(I||(I={}));async function k(f,P,b,m,v){try{const p=await new Promise((S,l)=>{_(["spdlog"],S,l)});p.setFlushOn(C.LogLevel.Trace);const E=await p.createAsyncRotatingLogger(f,P,b,m);return v?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(p){console.error(p)}return null}function O(f,P,b){switch(P){case C.LogLevel.Trace:f.trace(b);break;case C.LogLevel.Debug:f.debug(b);break;case C.LogLevel.Info:f.info(b);break;case C.LogLevel.Warning:f.warn(b);break;case C.LogLevel.Error:f.error(b);break;default:throw new Error("Invalid log level")}}function y(f,P){switch(P){case C.LogLevel.Trace:f.setLevel(I.Trace);break;case C.LogLevel.Debug:f.setLevel(I.Debug);break;case C.LogLevel.Info:f.setLevel(I.Info);break;case C.LogLevel.Warning:f.setLevel(I.Warning);break;case C.LogLevel.Error:f.setLevel(I.Error);break;case C.LogLevel.Off:f.setLevel(I.Off);break;default:throw new Error("Invalid log level")}}class d extends C.AbstractMessageLogger{constructor(P,b,m,v,p){super(),this.buffer=[],this.setLevel(p),this._loggerCreationPromise=this._createSpdLogLogger(P,b,m,v),this._register(this.onDidChangeLogLevel(E=>{this._logger&&y(this._logger,E)}))}async _createSpdLogLogger(P,b,m,v){const p=m?6:1,E=30/p*R.ByteSize.MB,S=await k(P,b,E,p,v);if(S){this._logger=S,y(this._logger,this.getLevel());for(const{level:l,message:g}of this.buffer)O(this._logger,l,g);this.buffer=[]}}log(P,b){this._logger?O(this._logger,P,b):this.getLevel()<=P&&this.buffer.push({level:P,message:b})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=d}),define(Q[36],Z([0,1,4,64,2,8]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class O extends I.Disposable{constructor(){super(...arguments),this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(f){const P=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...f,...this.policyDefinitions},P!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(f),C.Iterable.reduce(this.policies.entries(),(b,[m,v])=>({...b,[m]:v}),{})}getPolicyValue(f){return this.policies.get(f)}serialize(){return C.Iterable.reduce(Object.entries(this.policyDefinitions),(f,[P,b])=>({...f,[P]:{definition:b,value:this.policies.get(P)}}),{})}}e.AbstractPolicyService=O;class y{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=y}),define(Q[118],Z([0,1,3,4,64,5,13,9,36]),function(_,e,R,C,I,k,O,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function f(b,m){const v=[];for(const p of I.Iterable.concat(b.keys(),m.keys()))b.get(p)!==m.get(p)&&v.push(p);return v}let P=class extends d.AbstractPolicyService{constructor(m,v,p){super(),this.file=m,this.fileService=v,this.logService=p,this.throttledDelayer=this._register(new R.ThrottledDelayer(500));const E=C.Event.filter(v.onDidFilesChange,S=>S.affects(m));this._register(v.watch(m)),this._register(E(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(m){await this.refresh()}async read(){const m=new Map;try{const v=await this.fileService.readFile(this.file),p=JSON.parse(v.value.toString());if(!(0,k.isObject)(p))throw new Error("Policy file isn't a JSON object");for(const E of Object.keys(p))this.policyDefinitions[E]&&m.set(E,p[E])}catch(v){v.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return m}async refresh(){const m=await this.read(),v=f(this.policies,m);this.policies=m,v.length>0&&this._onDidChange.fire(v)}};P=de([ee(1,O.IFileService),ee(2,y.ILogService)],P),e.FilePolicyService=P}),define(Q[28],Z([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Q[33],Z([0,1,69,5]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.data=new Map}add(O,y){R.ok(C.isString(O)),R.ok(C.isObject(y)),R.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,y)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new I}),define(Q[119],Z([0,1,4,33]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class k{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,f){this.schemasById[I(d)]=f,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new k;C.Registry.add(e.Extensions.JSONContribution,O)}),define(Q[40],Z([0,1,19,4,5,82,21,119,33]),function(_,e,R,C,I,k,O,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=d.Registry.as(y.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new C.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new C.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(t,n=!0){this.registerConfigurations([t],n)}registerConfigurations(t,n=!0){const i=this.doRegisterConfigurations(t,n);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:i})}deregisterConfigurations(t){const n=this.doDeregisterConfigurations(t);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:t,remove:n}){const i=[];i.push(...this.doDeregisterConfigurations(n)),i.push(...this.doRegisterConfigurations(t,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(i)})}registerDefaultConfigurations(t){const n=[],i=[];for(const{overrides:r,source:o}of t)for(const c in r)if(n.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.configurationDefaultsOverrides.get(c),h=a?.valuesSources??new Map;if(o)for(const X of Object.keys(r[c]))h.set(X,o);const D={...a?.value||{},...r[c]};this.configurationDefaultsOverrides.set(c,{source:o,value:D,valuesSources:h});const N=(0,O.getLanguageTagSettingPlainKey)(c),B={type:"object",default:D,description:k.localize(1,null,N),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:D,source:I.isString(o)?void 0:o,defaultValueSource:o};i.push(...E(c)),this.configurationProperties[c]=B,this.defaultLanguageConfigurationOverridesNode.properties[c]=B}else{this.configurationDefaultsOverrides.set(c,{value:r[c],source:o});const a=this.configurationProperties[c];a&&(this.updatePropertyDefaultValue(c,a),this.updateSchema(c,a))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(t){const n=[];for(const{overrides:i,source:r}of t)for(const o in i){const c=this.configurationDefaultsOverrides.get(o),a=I.isString(r)?r:r?.id,h=I.isString(c?.source)?c?.source:c?.source?.id;if(a===h)if(n.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const D=this.configurationProperties[o];D&&(this.updatePropertyDefaultValue(o,D),this.updateSchema(o,D))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...t){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(t){for(const n of t)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(t,n){const i=[];return t.forEach(r=>{i.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),i}doDeregisterConfigurations(t){const n=[],i=r=>{if(r.properties)for(const o in r.properties){n.push(o);const c=this.configurationProperties[o];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>i(o))};for(const r of t){i(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(t,n=!0,i,r,o=3){o=I.isUndefinedOrNull(t.scope)?o:t.scope;const c=[],a=t.properties;if(a)for(const D in a){const N=a[D];if(n&&w(D,N)){delete a[D];continue}if(N.source=i,N.defaultDefaultValue=a[D].default,this.updatePropertyDefaultValue(D,N),e.OVERRIDE_PROPERTY_REGEX.test(D)?N.scope=void 0:(N.scope=I.isUndefinedOrNull(N.scope)?o:N.scope,N.restricted=I.isUndefinedOrNull(N.restricted)?!!r?.includes(D):N.restricted),a[D].hasOwnProperty("included")&&!a[D].included){this.excludedConfigurationProperties[D]=a[D],delete a[D];continue}else this.configurationProperties[D]=a[D],a[D].policy?.name&&this.policyConfigurations.set(a[D].policy.name,D);!a[D].deprecationMessage&&a[D].markdownDeprecationMessage&&(a[D].deprecationMessage=a[D].markdownDeprecationMessage),c.push(D)}const h=t.allOf;if(h)for(const D of h)c.push(...this.validateAndRegisterProperties(D,n,i,r,o));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(t){const n=i=>{const r=i.properties;if(r)for(const c in r)this.updateSchema(c,r[c]);i.allOf?.forEach(n)};n(t)}updateSchema(t,n){switch(e.allSettings.properties[t]=n,n.scope){case 1:e.applicationSettings.properties[t]=n;break;case 2:e.machineSettings.properties[t]=n;break;case 6:e.machineOverridableSettings.properties[t]=n;break;case 3:e.windowSettings.properties[t]=n;break;case 4:e.resourceSettings.properties[t]=n;break;case 5:e.resourceSettings.properties[t]=n,this.resourceLanguageSettingsSchema.properties[t]=n;break}}removeFromSchema(t,n){switch(delete e.allSettings.properties[t],n.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.resourceLanguageSettingsSchema.properties[t];break}}updateOverridePropertyPatternKey(){for(const t of this.overrideIdentifiers.values()){const n=`[${t}]`,i={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,i),e.allSettings.properties[n]=i,e.applicationSettings.properties[n]=i,e.machineSettings.properties[n]=i,e.machineOverridableSettings.properties[n]=i,e.windowSettings.properties[n]=i,e.resourceSettings.properties[n]=i}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(t,n){const i=this.configurationDefaultsOverrides.get(t);let r=i?.value,o=i?.source;I.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),I.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",p=new RegExp(v,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(s){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(s)){let n=p.exec(s);for(;n?.length;){const i=n[1].trim();i&&t.push(i),n=p.exec(s)}}return(0,R.distinct)(t)}e.overrideIdentifiersFromKey=E;function S(s){return s.reduce((t,n)=>`${t}[${n}]`,"")}e.keyFromOverrideIdentifiers=S;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const g=new m;d.Registry.add(e.Extensions.Configuration,g);function w(s,t){return s.trim()?e.OVERRIDE_PROPERTY_REGEX.test(s)?k.localize(7,null,s):g.getConfigurationProperties()[s]!==void 0?k.localize(8,null,s):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,s,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}e.validateProperty=w;function u(){const s=[],t=g.getConfigurationProperties();for(const n of Object.keys(t))s.push([n,t[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}e.getScopes=u}),define(Q[65],Z([0,1,19,4,50,2,39,26,5,10,21,40,33]),function(_,e,R,C,I,k,O,y,d,f,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class v{constructor(n={},i=[],r=[],o){this._contents=n,this._keys=i,this._overrides=r,this.raw=o,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof v)return i;const r=new p("");return r.parseRaw(i),r.configurationModel});this._rawConfiguration=n.reduce((i,r)=>r===i?r:i.merge(r),n[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const r=this.rawConfiguration.getValue(n),o=i?this.rawConfiguration.getOverrideValue(n,i):void 0,c=i?this.rawConfiguration.override(i).getValue(n):r;return{value:r,override:o,merged:c}}getOverrideValue(n,i){const r=this.getContentsForOverrideIdentifer(i);return r?n?(0,P.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const r of this.overrides)r.identifiers.includes(n)&&i.push(...r.keys);return R.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return R.distinct(n)}override(n){let i=this.overrideConfigurations.get(n);return i||(i=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,i)),i}merge(...n){const i=y.deepClone(this.contents),r=y.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const a of n)if(c.push(...a.raw?.length?a.raw:[a]),!a.isEmpty()){this.mergeContents(i,a.contents);for(const h of a.overrides){const[D]=r.filter(N=>R.equals(N.identifiers,h.identifiers));D?(this.mergeContents(D.contents,h.contents),D.keys.push(...h.keys),D.keys=R.distinct(D.keys)):r.push(y.deepClone(h))}for(const h of a.keys)o.indexOf(h)===-1&&o.push(h)}return new v(i,o,r,c.every(a=>a instanceof v)?void 0:c)}freeze(){return this.frozen=!0,this}clone(){return new v(y.deepClone(this.contents),[...this.keys],y.deepClone(this.overrides))}createOverrideConfigurationModel(n){const i=this.getContentsForOverrideIdentifer(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const r={};for(const o of R.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const a=i[o];a&&(typeof c=="object"&&typeof a=="object"?(c=y.deepClone(c),this.mergeContents(c,a)):c=a),r[o]=c}return new v(r,this.keys,this.overrides)}mergeContents(n,i){for(const r of Object.keys(i)){if(r in n&&d.isObject(n[r])&&d.isObject(i[r])){this.mergeContents(n[r],i[r]);continue}n[r]=y.deepClone(i[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?y.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let i=null,r=null;const o=c=>{c&&(r?this.mergeContents(r,c):r=y.deepClone(c))};for(const c of this.overrides)R.equals(c.identifiers,[n])?i=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(i),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,i){this.addKey(n),(0,P.addToValueTree)(this.contents,n,i,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,P.removeFromValueTree)(this.contents,n)}addKey(n){let i=this.keys.length;for(let r=0;r<i;r++)n.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,n)}removeKey(n){const i=this.keys.indexOf(n);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=v;class p{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,i){if(!d.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,i)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,i){this._raw=n;const{contents:r,keys:o,overrides:c,restricted:a,hasExcludedProperties:h}=this.doParseRaw(n,i);this._configurationModel=new v(r,o,c,h?[n]:void 0),this._restrictedConfigurations=a||[]}doParseContent(n){let i={},r=null,o=[];const c=[],a=[];function h(N){Array.isArray(o)?o.push(N):r!==null&&(o[r]=N)}const D={onObjectBegin:()=>{const N={};h(N),c.push(o),o=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const N=[];h(N),c.push(o),o=N,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:h,onError:(N,B,X)=>{a.push({error:N,offset:B,length:X})}};if(n)try{I.visit(n,D),i=o[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return i}doParseRaw(n,i){const r=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,i);n=o.raw;const c=(0,P.toValuesTree)(n,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),a=Object.keys(n),h=this.toOverrides(n,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:c,keys:a,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}filter(n,i,r,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:c};const a={},h=[];for(const D in n)if(b.OVERRIDE_PROPERTY_REGEX.test(D)&&r){const N=this.filter(n[D],i,!1,o);a[D]=N.raw,c=c||N.hasExcludedProperties,h.push(...N.restricted)}else{const N=i[D],B=N?typeof N.scope<"u"?N.scope:3:void 0;N?.restricted&&h.push(D),(B===void 0||o.scopes===void 0||o.scopes.includes(B))&&!(o.skipRestricted&&N?.restricted)?a[D]=n[D]:c=!0}return{raw:a,restricted:h,hasExcludedProperties:c}}toOverrides(n,i){const r=[];for(const o of Object.keys(n))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in n[o])c[a]=n[o][a];r.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,P.toValuesTree)(c,i)})}return r}}e.ConfigurationModelParser=p;class E extends k.Disposable{constructor(n,i,r,o){super(),this.userSettingsResource=n,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(C.Event.any(C.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),C.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&r.isEqual(c.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class S{constructor(n,i,r,o,c,a,h,D,N,B,X,J,se){this.key=n,this.overrides=i,this.value=r,this.overrideIdentifiers=o,this.defaultConfiguration=c,this.policyConfiguration=a,this.applicationConfiguration=h,this.userConfiguration=D,this.localUserConfiguration=N,this.remoteUserConfiguration=B,this.workspaceConfiguration=X,this.folderConfigurationModel=J,this.memoryInspectValue=se}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class l{constructor(n,i,r,o,c=new v,a=new v,h=new O.ResourceMap,D=new v,N=new O.ResourceMap,B=!0){this._defaultConfiguration=n,this._policyConfiguration=i,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=D,this._memoryConfigurationByResource=N,this._freeze=B,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new O.ResourceMap,this._userConfiguration=null}getValue(n,i,r){return this.getConsolidatedConfigurationModel(n,i,r).getValue(n)}updateValue(n,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new v,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(n):o.setValue(n,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,i,r){const o=this.getConsolidatedConfigurationModel(n,i,r),c=R.distinct(o.overrides.map(D=>D.identifiers).flat()).filter(D=>o.getOverrideValue(n,D)!==void 0),a=this.getFolderConfigurationModelForResource(i.resource,r),h=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration;return new S(n,i,o.getValue(n),c.length?c:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),r?this._workspaceConfiguration.freeze():void 0,a?a.freeze():void 0,h.inspect(n,i.overrideIdentifier))}keys(n){const i=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,i){this._folderConfigurations.set(n,i),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const r=[];if(!i){const{added:o,updated:c,removed:a}=u(this._defaultConfiguration,n);i=[...o,...c,...a]}for(const o of i)for(const c of(0,b.overrideIdentifiersFromKey)(o)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(c),h=n.getKeysForOverrideIdentifier(c),D=[...h.filter(N=>a.indexOf(N)===-1),...a.filter(N=>h.indexOf(N)===-1),...a.filter(N=>!y.equals(this._defaultConfiguration.override(c).getValue(N),n.override(c).getValue(N)))];r.push([c,D])}return this.updateDefaultConfiguration(n),{keys:i,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:r,removed:o}=u(this._policyConfiguration,n),c=[...i,...r,...o];return c.length&&this.updatePolicyConfiguration(n),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=u(this.applicationConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateApplicationConfiguration(n),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=u(this.localUserConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateLocalUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=u(this.remoteUserConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateRemoteUserConfiguration(n),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:r,removed:o,overrides:c}=u(this.workspaceConfiguration,n),a=[...i,...r,...o];return a.length&&this.updateWorkspaceConfiguration(n),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(n,i){const r=this.folderConfigurations.get(n),{added:o,updated:c,removed:a,overrides:h}=u(r,i),D=[...o,...c,...a];return(D.length||!r)&&this.updateFolderConfiguration(n,i),{keys:D,overrides:h}}compareAndDeleteFolderConfiguration(n){const i=this.folderConfigurations.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:c,overrides:a}=u(i,void 0);return{keys:[...r,...o,...c],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,i,r){let o=this.getConsolidatedConfigurationModelForResource(i,r);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&n){const o=i.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const c=this._memoryConfigurationByResource.get(n);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let i=this._foldersConsolidatedConfigurations.get(n);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(i=r.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(n,i)):i=r}return i}getFolderConfigurationModelForResource(n,i){if(i&&n){const r=i.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,i)=>{const{contents:r,overrides:o,keys:c}=this._folderConfigurations.get(i);return n.push([i,{contents:r,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>n.add(i)),this.userConfiguration.freeze().keys.forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o))),[...i.values()]}static parse(n){const i=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),c=this.parseConfigurationModel(n.user),a=this.parseConfigurationModel(n.workspace),h=n.folders.reduce((D,N)=>(D.set(f.URI.revive(N[0]),this.parseConfigurationModel(N[1])),D),new O.ResourceMap);return new l(i,r,o,c,new v,a,h,new v,new O.ResourceMap,!1)}static parseConfigurationModel(n){return new v(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=l;function g(...t){if(t.length===0)return{keys:[],overrides:[]};if(t.length===1)return t[0];const n=new Set,i=new Map;for(const o of t)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,a])=>{const h=(0,O.getOrSet)(i,c,new Set);a.forEach(D=>h.add(D))});const r=[];return i.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...n.values()],overrides:r}}e.mergeChanges=g;class w{constructor(n,i,r,o){this.change=n,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;n.keys.forEach(h=>c.add(h)),n.overrides.forEach(([,h])=>h.forEach(D=>c.add(D))),this.affectedKeys=[...c.values()];const a=new v;this.affectedKeys.forEach(h=>a.setValue(h,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=l.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(i){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,i,this.currentWorkspace);return!y.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,i){let r=(0,P.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=w;function u(t,n){const{added:i,removed:r,updated:o}=s(n?.rawConfiguration,t?.rawConfiguration),c=[],a=t?.getAllOverrideIdentifiers()||[],h=n?.getAllOverrideIdentifiers()||[];if(n){const D=h.filter(N=>!a.includes(N));for(const N of D)c.push([N,n.getKeysForOverrideIdentifier(N)])}if(t){const D=a.filter(N=>!h.includes(N));for(const N of D)c.push([N,t.getKeysForOverrideIdentifier(N)])}if(n&&t){for(const D of a)if(h.includes(D)){const N=s({contents:t.getOverrideValue(void 0,D)||{},keys:t.getKeysForOverrideIdentifier(D)},{contents:n.getOverrideValue(void 0,D)||{},keys:n.getKeysForOverrideIdentifier(D)});c.push([D,[...N.added,...N.removed,...N.updated]])}}return{added:i,removed:r,updated:o,overrides:c}}function s(t,n){const i=t?n?t.keys.filter(c=>n.keys.indexOf(c)===-1):[...t.keys]:[],r=n?t?n.keys.filter(c=>t.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(t&&n){for(const c of n.keys)if(t.keys.indexOf(c)!==-1){const a=(0,P.getConfigurationValue)(n.contents,c),h=(0,P.getConfigurationValue)(t.contents,c);y.equals(a,h)||o.push(c)}}return{added:i,removed:r,updated:o}}}),define(Q[120],Z([0,1,19,4,2,26,5,21,65,40,9,36,33]),function(_,e,R,C,I,k,O,y,d,f,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class v extends I.Disposable{constructor(){super(...arguments),this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new p(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(m.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:w})=>this.onDidUpdateConfiguration(g,w))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,w){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=v;class p extends d.ConfigurationModel{constructor(g={}){const w=m.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(w),s=Object.create(null),t=[];for(const n in w){const i=g[n],r=i!==void 0?i:w[n].default;(0,y.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))f.OVERRIDE_PROPERTY_REGEX.test(n)&&t.push({identifiers:(0,f.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,y.toValuesTree)(s[n],i=>console.error(`Conflict in default settings file: ${i}`))});super(s,u,t)}}e.DefaultConfigurationModel=p;class E{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new d.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=E;let S=class extends I.Disposable{get configurationModel(){return this._configurationModel}constructor(g,w,u){super(),this.defaultConfiguration=g,this.policyService=w,this.logService=u,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new d.ConfigurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const w={},u=[],s=m.Registry.as(f.Extensions.Configuration).getConfigurationProperties();for(const t of g){const n=s[t];if(!n){u.push(t);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}u.push(t),w[n.policy.name]={type:n.type}}}return(0,O.isEmptyObject)(w)||await this.policyService.registerPolicyDefinitions(w),u}onDidChangePolicies(g){const w=m.Registry.as(f.Extensions.Configuration).getPolicyConfigurations(),u=(0,R.coalesce)(g.map(s=>w.get(s)));this.update(u,!0)}update(g,w){const u=m.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),s=[],t=this._configurationModel.isEmpty();for(const n of g){const i=u[n]?.policy?.name;if(i){const r=this.policyService.getPolicyValue(i);(t?r!==void 0:!(0,k.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new d.ConfigurationModel;for(const i of n.keys)this._configurationModel.setValue(i,n.getValue(i));for(const[i,r]of s)r===void 0?this._configurationModel.removeValue(i):this._configurationModel.setValue(i,r);w&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};S=de([ee(1,b.IPolicyService),ee(2,P.ILogService)],S),e.PolicyConfiguration=S}),define(Q[121],Z([0,1,3,4,2,18,21,65,120,36]),function(_,e,R,C,I,k,O,y,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends I.Disposable{constructor(m,v,p,E){super(),this.settingsResource=m,this._onDidChangeConfiguration=this._register(new C.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new d.DefaultConfiguration),this.policyConfiguration=p instanceof f.NullPolicyService?new d.NullPolicyConfiguration:this._register(new d.PolicyConfiguration(this.defaultConfiguration,p,E)),this.userConfiguration=this._register(new y.UserSettings(this.settingsResource,void 0,k.extUriBiasedIgnorePathCase,v)),this.configuration=new y.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new y.ConfigurationModel,new y.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:S,properties:l})=>this.onDidDefaultConfigurationChange(S,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(S=>this.onDidPolicyConfigurationChange(S))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[m,v,p]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new y.Configuration(m,v,new y.ConfigurationModel,p)}getConfigurationData(){return this.configuration.toData()}getValue(m,v){const p=typeof m=="string"?m:void 0,E=(0,O.isConfigurationOverrides)(m)?m:(0,O.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(p,E,void 0)}updateValue(m,v,p,E){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const v=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(p,v,2)}onDidDefaultConfigurationChange(m,v){const p=this.configuration.toData(),E=this.configuration.compareAndUpdateDefaultConfiguration(m,v);this.trigger(E,p,7)}onDidPolicyConfigurationChange(m){const v=this.configuration.toData(),p=this.configuration.compareAndUpdatePolicyConfiguration(m);this.trigger(p,v,7)}trigger(m,v,p){const E=new y.ConfigurationChangeEvent(m,{data:v},this.configuration);E.source=p,E.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(E)}getTargetConfiguration(m){switch(m){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(Q[122],Z([0,1,16]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function C(f){return f.scheme===R.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=C;function I(f){if(!f)return;const P=f.indexOf("+");return P<0?f:f.substr(0,P)}e.getRemoteName=I;function k(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.getRemoteServerRootPath=k;function O(f){const{host:P,port:b}=d(f);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:b}}e.parseAuthorityWithPort=O;function y(f,P){let{host:b,port:m}=d(f);return typeof m>"u"&&(m=P),{host:b,port:m}}e.parseAuthorityWithOptionalPort=y;function d(f){const P=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const b=f.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=f.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:f,port:void 0}}}),define(Q[34],Z([0,1,27,8,122]),function(_,e,R,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.getWorkspaceSupportTypeMessage=k;function O(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));var d;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(d=e.TargetPlatform||(e.TargetPlatform={}));class f{constructor(E){this.value=E,this._lower=E.toLowerCase()}static equals(E,S){if(typeof E>"u"||E===null)return typeof S>"u"||S===null;if(typeof S>"u"||S===null)return!1;if(typeof E=="string"||typeof S=="string"){const l=typeof E=="string"?E:E.value,g=typeof S=="string"?S:S.value;return R.equalsIgnoreCase(l,g)}return E._lower===S._lower}static toKey(E){return typeof E=="string"?E.toLowerCase():E._lower}}e.ExtensionIdentifier=f;function P(p){return b(p)}e.isApplicationScopedExtension=P;function b(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function m(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function v(p,E){if(E){const S=`onResolveRemoteAuthority:${(0,I.getRemoteName)(E)}`;return p.activationEvents?.indexOf(S)!==-1}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,C.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,27,22,34,12,10,11,32]),function(_,e,R,C,I,k,O,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function f(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,R.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=f;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const r=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,r,o)}static parse(i){const r=P.exec(i);return r&&r[1]&&r[2]?new b({id:r[1]},r[2],r[4]||void 0):null}constructor(i,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?f(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(n){const i=m.exec(n);return i&&i[1]?[E(i[1]),i[2]]:[E(n),void 0]}e.getIdAndVersion=v;function p(n,i){return`${n}.${i}`}e.getExtensionId=p;function E(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=E;function S(n,i){return E(p(n,i))}e.getGalleryExtensionId=S;function l(n,i){const r=[],o=c=>{for(const a of r)if(a.some(h=>f(i(h),i(c))))return a;return null};for(const c of n){const a=o(c);a?a.push(c):r.push([c])}return r}e.groupByExtension=l;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function w(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function u(n,i){const r=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&r.every(a=>!f(a.identifier,{id:c}))){const a=n.filter(h=>f(h.identifier,{id:c}));a.length===1&&(r.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=u;async function s(n,i){if(!k.isLinux)return!1;let r;try{r=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,y.getErrorMessage)(c))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=s;async function t(n,i){const r=await s(n,i),o=(0,C.getTargetPlatform)(r?"alpine":k.platform,d.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=t}),define(Q[123],Z([0,1,24,11,16,18,38,10,85,22,23,34]),function(_,e,R,C,I,k,O,y,d,f,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const m=S=>(0,d.localize)(0,null,S),v=(0,d.localize)(1,null,"ms-dotnettools.csharp");function p(S,l){return l?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}let E=class{constructor(l,g){this.extensionManagementService=l,this.extensionGalleryService=g}get location(){}async listExtensions(l,g,w,u=console){let s=await this.extensionManagementService.getInstalled(1,w);const t=b.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(g&&g!==""){if(t.indexOf(g.toLowerCase())<0){u.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}s=s.filter(i=>i.manifest.categories?i.manifest.categories.map(o=>o.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){u.log("Possible Categories: "),t.forEach(i=>{u.log(i)});return}this.location&&u.log((0,d.localize)(2,null,this.location)),s=s.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let n;for(const i of s)n!==i.identifier.id&&(n=i.identifier.id,u.log(p(i.manifest,l)))}async installExtensions(l,g,w,u,s=console){const t=[],n=[];l.length&&s.log(this.location?(0,d.localize)(3,null,this.location):(0,d.localize)(4,null));const i=await this.extensionManagementService.getInstalled(1,w.profileLocation),r=(h,D)=>{const N=i.find(B=>(0,P.areSameExtensions)(B.identifier,{id:h}));if(N){if(!u&&(!D||D==="prerelease"&&N.preRelease))return s.log((0,d.localize)(5,null,h,N.manifest.version,h)),!1;if(D&&N.manifest.version===D)return s.log((0,d.localize)(6,null,`${h}@${D}`)),!1}return!0},o=(h,D,N)=>{a.push({id:h,version:D!=="prerelease"?D:void 0,installOptions:{...w,isBuiltin:N,installPreReleaseVersion:D==="prerelease"||w.installPreReleaseVersion}})},c=[],a=[];for(const h of l)if(h instanceof y.URI)c.push(h);else{const[D,N]=(0,P.getIdAndVersion)(h);r(D,N)&&o(D,N,!1)}for(const h of g){const[D,N]=(0,P.getIdAndVersion)(h);r(D,N)&&o(D,N,!0)}if(c.length&&await Promise.all(c.map(async h=>{try{const D=await this.installVSIX(h,{...w,isBuiltin:!1},u,s);D&&n.push(D)}catch(D){s.error(D.message||D.stack||D),t.push(h.toString())}})),a.length){const h=await this.getGalleryExtensions(a);await Promise.all(a.map(async D=>{const N=h.get(D.id.toLowerCase());if(N)try{const B=await this.installFromGallery(D,N,i,u,s);B&&n.push(B)}catch(B){s.error(B.message||B.stack||B),t.push(D.id)}else s.error(`${m(D.version?`${D.id}@${D.version}`:D.id)}
${v}`),t.push(D.id)}))}if(t.length)throw new Error((0,d.localize)(7,null,t.join(", ")))}async installVSIX(l,g,w,u){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,w,g.profileLocation,u))try{return await this.extensionManagementService.install(l,g),u.log((0,d.localize)(8,null,(0,k.basename)(l))),s}catch(n){if((0,C.isCancellationError)(n))return u.log((0,d.localize)(9,null,(0,k.basename)(l))),null;throw n}return null}async getGalleryExtensions(l){const g=new Map,w=l.some(s=>s.installOptions.installPreReleaseVersion),u=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:w})),R.CancellationToken.None);for(const s of u)g.set(s.identifier.id.toLowerCase(),s);return g}async installFromGallery({id:l,version:g,installOptions:w},u,s,t,n){const i=await this.extensionGalleryService.getManifest(u,R.CancellationToken.None);if(i&&!this.validateExtensionKind(i,n))return null;const r=s.find(o=>(0,P.areSameExtensions)(o.identifier,u.identifier));if(r){if(u.version===r.manifest.version)return n.log((0,d.localize)(10,null,g?`${l}@${g}`:l)),null;n.log((0,d.localize)(11,null,l,u.version))}try{w.isBuiltin?n.log(g?(0,d.localize)(12,null,l,g):(0,d.localize)(13,null,l)):n.log(g?(0,d.localize)(14,null,l,g):(0,d.localize)(15,null,l));const o=await this.extensionManagementService.installFromGallery(u,{...w,installGivenVersion:!!g});return n.log((0,d.localize)(16,null,l,o.manifest.version)),i}catch(o){if((0,C.isCancellationError)(o))return n.log((0,d.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,g){return!0}async validateVSIX(l,g,w,u){const s={id:(0,P.getGalleryExtensionId)(l.publisher,l.name)},n=(await this.extensionManagementService.getInstalled(1,w)).find(i=>(0,P.areSameExtensions)(s,i.identifier)&&(0,O.gt)(i.manifest.version,l.version));return n&&!g?(u.log((0,d.localize)(18,null,n.identifier.id,n.manifest.version,l.version)),!1):this.validateExtensionKind(l,u)}async uninstallExtensions(l,g,w,u=console){const s=async n=>{if(n instanceof y.URI){const i=await this.extensionManagementService.getManifest(n);return p(i)}return n},t=[];for(const n of l){const i=await s(n),o=(await this.extensionManagementService.getInstalled(void 0,w)).filter(c=>(0,P.areSameExtensions)(c.identifier,{id:i}));if(!o.length)throw new Error(`${this.notInstalled(i)}
${v}`);if(o.some(c=>c.type===0)){u.log((0,d.localize)(19,null,i));return}if(!g&&o.some(c=>c.isBuiltin)){u.log((0,d.localize)(20,null,i));return}u.log((0,d.localize)(21,null,i));for(const c of o)await this.extensionManagementService.uninstall(c,{profileLocation:w}),t.push(c);this.location?u.log((0,d.localize)(22,null,i,this.location)):u.log((0,d.localize)(23,null,i))}}async locateExtension(l,g=console){const w=await this.extensionManagementService.getInstalled();l.forEach(u=>{w.forEach(s=>{if(s.identifier.id===u&&s.location.scheme===I.Schemas.file){g.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,d.localize)(24,null,l,this.location):(0,d.localize)(25,null,l)}};E=de([ee(0,f.IExtensionManagementService),ee(1,f.IExtensionGalleryService)],E),e.ExtensionManagementCLI=E}),define(Q[41],Z([0,1,3,15,2,39,10,23,13,8,9]),function(_,e,R,C,I,k,O,y,d,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,f.createDecorator)("IExtensionsProfileScannerService");let b=class extends I.Disposable{constructor(v,p){super(),this.fileService=v,this.logService=p,this.resourcesAccessQueueMap=new k.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,p){return this.withProfileExtensions(p,E=>(E=E.filter(S=>v.some(([l])=>!(0,y.areSameExtensions)(S.identifier,l.identifier))),E.push(...v.map(([S,l])=>({identifier:S.identifier,version:S.manifest.version,location:S.location,metadata:l}))),E))}removeExtensionFromProfile(v,p){return this.withProfileExtensions(p,E=>E.filter(S=>!(0,y.areSameExtensions)(S.identifier,v)))}async withProfileExtensions(v,p){return this.getResourceAccessQueue(v).queue(async()=>{let E=[];try{const S=await this.fileService.readFile(v),l=JSON.parse(S.value.toString());for(const g of l){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}E.push({identifier:g.identifier,location:O.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(S){S.fileOperationResult!==1&&this.logService.error(S)}if(p){E=p(E);const S=E.map(l=>({identifier:l.identifier,version:l.version,location:l.location.toJSON(),metadata:l.metadata}));await this.fileService.writeFile(v,C.VSBuffer.fromString(JSON.stringify(S)))}return E})}getResourceAccessQueue(v){let p=this.resourcesAccessQueueMap.get(v);return p||(p=new R.Queue,this.resourcesAccessQueueMap.set(v,p)),p}};b=de([ee(0,d.IFileService),ee(1,P.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Q[124],Z([0,1,3,11,2,16,12,18,38,30,20,21,17,22,23,59,13,9]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let g=class je extends I.Disposable{constructor(u,s,t,n,i,r){super(),this.fileService=s,this.extensionGalleryService=t,this.configurationService=n,this.extensionSignatureVerificationService=i,this.logService=r,this.extensionsDownloadDir=u.extensionsDownloadLocation,this.cache=20,this.cleanUpPromise=this.cleanUp()}async download(u,s){await this.cleanUpPromise;const t=(0,y.joinPath)(this.extensionsDownloadDir,this.getName(u));try{await this.downloadFile(u,t,i=>this.extensionGalleryService.download(u,i,s))}catch(i){throw new v.ExtensionManagementError(i.message,v.ExtensionManagementErrorCode.Download)}let n=!1;if(u.isSigned&&this.configurationService.getValue("extensions.verifySignature")===!0){const i=await this.downloadSignatureArchive(u);try{n=await this.extensionSignatureVerificationService.verify(t.fsPath,i.fsPath),this.logService.info(`Verified extension: ${u.identifier.id}`,n)}catch(r){throw await this.delete(i),await this.delete(t),new v.ExtensionManagementError(r.code,v.ExtensionManagementErrorCode.Signature)}}return{location:t,verified:n}}async downloadSignatureArchive(u){await this.cleanUpPromise;const s=(0,y.joinPath)(this.extensionsDownloadDir,`${this.getName(u)}${je.SignatureArchiveExtension}`);return await this.downloadFile(u,s,t=>this.extensionGalleryService.downloadSignatureArchive(u,t)),s}async downloadFile(u,s,t){if(await this.fileService.exists(s))return;if(s.scheme!==k.Schemas.file){await t(s);return}const n=(0,y.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(n)||await t(n);try{await this.rename(n,s,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(n)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",u.identifier.id,s.path);else throw this.logService.info(`Rename failed because of ${(0,C.getErrorMessage)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,s,t){try{await P.Promises.rename(u.fsPath,s.fsPath)}catch(n){if(O.isWindows&&n&&n.code==="EPERM"&&Date.now()<t)return this.logService.info(`Failed renaming ${u} to ${s} with 'EPERM' error. Trying again...`),this.rename(u,s,t);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downloads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const s=[],t=[],n=[];for(const o of u.children)if(o.name.endsWith(je.SignatureArchiveExtension))n.push(o.resource);else{const c=p.ExtensionKey.parse(o.name);c&&t.push([c,o])}const i=(0,p.groupByExtension)(t,([o])=>o),r=[];for(const o of i)o.sort((c,a)=>d.rcompare(c[0].version,a[0].version)),s.push(...o.slice(1).map(c=>c[1].resource)),r.push(o[0][1]);r.sort((o,c)=>o.mtime-c.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(o=>o.resource)),s.push(...n),await R.Promises.settled(s.map(o=>(this.logService.trace("Deleting from cache",o.path),this.fileService.del(o))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?p.ExtensionKey.create(u).toString().toLowerCase():(0,f.generateUuid)()}};g.SignatureArchiveExtension=".sigzip",g=de([ee(0,m.INativeEnvironmentService),ee(1,S.IFileService),ee(2,v.IExtensionGalleryService),ee(3,b.IConfigurationService),ee(4,E.IExtensionSignatureVerificationService),ee(5,l.ILogService)],g),e.ExtensionsDownloader=g}),define(Q[125],Z([0,1,2,14,20,34]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends R.Disposable{constructor(d,f){super(),this.environmentService=d,this.extensionsManifestCache=(0,C.join)(this.environmentService.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this._register(f.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(f.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(d){d.some(f=>!!f.local)&&this.invalidate()}onDidUnInstallExtension(d){d.error||this.invalidate()}invalidate(){I.Promises.rm(this.extensionsManifestCache,I.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Q[126],Z([0,1,157,19,3,2,16,14,20,17,22,23,9,63,12,10]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let S=class extends v.LanguagePackBaseService{constructor(u,s,t,n){super(t),this.extensionManagementService=u,this.logService=n,this.cache=this._register(new l(s,n)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getBuiltInExtensionTranslationsUri(u){const t=(await this.cache.getLanguagePacks())[p.Language.value()];if(!t){this.logService.warn(`No language pack found for ${p.Language.value()}`);return}const n=t.translations[u];return n?E.URI.file(n):void 0}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),s=Object.keys(u).map(t=>{const n=u[t];return{...this.createQuickPickItem(t,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return s.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),s.sort((t,n)=>t.label.localeCompare(n.label)),s}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const s=await this.cache.getLanguagePacks();Object.keys(s).some(t=>s[t]&&s[t].extensions.some(n=>(0,b.areSameExtensions)(n.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),t=await this.cache.update(s);return!(0,C.equals)(Object.keys(u),Object.keys(t))}};S=de([ee(0,P.IExtensionManagementService),ee(1,f.INativeEnvironmentService),ee(2,P.IExtensionGalleryService),ee(3,m.ILogService)],S),e.NativeLanguagePackService=S;let l=class extends k.Disposable{constructor(u,s){super(),this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,y.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new I.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(s=>{Object.keys(s).forEach(t=>delete s[t]),this.createLanguagePacksFromExtensions(s,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...s){for(const t of s)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,t);Object.keys(u).forEach(t=>this.updateHash(u[t]))}createLanguagePacksFromExtension(u,s){const t=s.identifier,n=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of n)if(s.location.scheme===O.Schemas.file&&g(i)){let r=u[i.languageId];r||(r={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},u[i.languageId]=r);const o=r.extensions.filter(c=>(0,b.areSameExtensions)(c.extensionIdentifier,t))[0];o?o.version=s.manifest.version:r.extensions.push({extensionIdentifier:t,version:s.manifest.version});for(const c of i.translations)r.translations[c.id]=(0,y.join)(s.location.fsPath,c.path)}}updateHash(u){if(u){const s=(0,R.createHash)("md5");for(const t of u.extensions)s.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);u.hash=s.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return d.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(s=u(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.languagePacks=t,this.initializedCache=!0;const n=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",n),d.Promises.writeFile(this.languagePacksFilePath,n)}).then(()=>s,t=>this.logService.error(t))})}};l=de([ee(0,f.INativeEnvironmentService),ee(1,m.ILogService)],l);function g(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const u of w.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(Q[47],Z([0,1,15,95,40,8,33]),function(_,e,R,C,I,k,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.isSuccess=y;function d(E){return E.res.statusCode===204}async function f(E){return d(E)?null:(await(0,R.streamToBuffer)(E.stream)).toString()}e.asText=f;async function P(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return f(E)}e.asTextOrError=P;async function b(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(d(E))return null;const l=(await(0,R.streamToBuffer)(E.stream)).toString();try{return JSON.parse(l)}catch(g){throw g.message+=`:
`+l,g}}e.asJson=b;function m(E){p(E)}e.updateProxyConfigurationsScope=m;let v;function p(E){const S=O.Registry.as(I.Extensions.Configuration),l=v;v={id:"http",order:15,title:(0,C.localize)(0,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,C.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,C.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,C.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,C.localize)(4,null),(0,C.localize)(5,null),(0,C.localize)(6,null),(0,C.localize)(7,null)],default:"override",description:(0,C.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,C.localize)(9,null),restricted:!0}}},S.updateConfigurations({add:[v],remove:l?[l]:[]})}p(2)}),define(Q[127],Z([0,1,24,16,13,47]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(d,f){this.requestService=d,this.fileService=f}async download(d,f,P=R.CancellationToken.None){if(d.scheme===C.Schemas.file||d.scheme===C.Schemas.vscodeRemote){await this.fileService.copy(d,f);return}const b={type:"GET",url:d.toString(!0)},m=await this.requestService.request(b,P);if(m.res.statusCode===200)await this.fileService.writeFile(f,m.stream);else{const v=await(0,k.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${v}`)}}};O=de([ee(0,k.IRequestService),ee(1,I.IFileService)],O),e.DownloadService=O}),define(Q[128],Z([0,1,129,5]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function I(O,y){return O.protocol==="http:"?y.HTTP_PROXY||y.http_proxy||null:O.protocol==="https:"&&(y.HTTPS_PROXY||y.https_proxy||y.HTTP_PROXY||y.http_proxy)||null}async function k(O,y,d={}){const f=(0,R.parse)(O),P=d.proxyUrl||I(f,y);if(!P)return null;const b=(0,R.parse)(P);if(!/^https?:$/.test(b.protocol||""))return null;const m={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,C.isBoolean)(d.strictSSL)?d.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((v,p)=>{_(["http-proxy-agent"],v,p)}))(m):new(await new Promise((v,p)=>{_(["https-proxy-agent"],v,p)}))(m)}e.getProxyAgent=k}),define(Q[130],Z([0,1,57,14,96,24,31,11,12,30,78,158,3]),function(_,e,R,C,I,k,O,y,d,f,P,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const v=1e4;let p;async function E(l,g,w){return g["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(w)&&!g["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(w)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(u,s)=>{const t=new k.CancellationTokenSource,n=setTimeout(()=>{t.dispose(!0),s(new Error((0,I.localize)(0,null)))},v);try{u(await S(l,t.token))}catch(i){!(0,y.isCancellationError)(i)&&!t.token.isCancellationRequested?s(new Error((0,I.localize)(1,null,(0,O.toErrorMessage)(i)))):u({})}finally{clearTimeout(n),t.dispose()}})),p)}e.getResolvedShellEnv=E;async function S(l,g){const w=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",w);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",u);const s=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const i=await(0,P.getSystemShell)(d.OS,n);return l.trace("getUnixShellEnvironment#shell",i),new Promise((r,o)=>{if(g.isCancellationRequested)return o((0,y.canceled)());const c=(0,C.basename)(i);let a,h;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${D} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${D} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,c==="tcsh"?h=["-ic"]:h=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const N=(0,R.spawn)(i,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});g.onCancellationRequested(()=>(N.kill(),o((0,y.canceled)()))),N.on("error",J=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,O.toErrorMessage)(J)),o(J)});const B=[];N.stdout.on("data",J=>B.push(J));const X=[];N.stderr.on("data",J=>X.push(J)),N.on("close",(J,se)=>{const ne=Buffer.concat(B).toString("utf8");l.trace("getUnixShellEnvironment#raw",ne);const re=Buffer.concat(X).toString("utf8");if(re.trim()&&l.trace("getUnixShellEnvironment#stderr",re),J||se)return o(new Error((0,I.localize)(2,null,J,se)));const ge=t.exec(ne),ce=ge?ge[1]:"{}";try{const ie=JSON.parse(ce);w?ie.ELECTRON_RUN_AS_NODE=w:delete ie.ELECTRON_RUN_AS_NODE,u?ie.ELECTRON_NO_ATTACH_CONSOLE=u:delete ie.ELECTRON_NO_ATTACH_CONSOLE,delete ie.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ie),r(ie)}catch(ie){l.error("getUnixShellEnvironment#errorCaught",(0,O.toErrorMessage)(ie)),o(ie)}})})}}),define(Q[66],Z([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,R.createDecorator)("stateService")}),define(Q[131],Z([0,1,3,15,5,17,13,9]),function(_,e,R,C,I,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(b,m,v){this.storagePath=b,this.logService=m,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new R.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(b){b.fileOperationResult!==1&&this.logService.error(b)}}getItem(b,m){const v=this.storage[b];return(0,I.isUndefinedOrNull)(v)?m:v}setItem(b,m){this.setItems([{key:b,data:m}])}setItems(b){let m=!1;for(const{key:v,data:p}of b)this.storage[v]!==p&&((0,I.isUndefinedOrNull)(p)?(0,I.isUndefined)(this.storage[v])||(this.storage[v]=void 0,m=!0):(this.storage[v]=p,m=!0));m&&this.save()}removeItem(b){(0,I.isUndefined)(this.storage[b])||(this.storage[b]=void 0,this.save())}async save(){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave())}async doSave(){if(!this.initializing)return;await this.initializing;const b=JSON.stringify(this.storage,null,4);if(b!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,C.VSBuffer.fromString(b)),this.lastSavedStorageContents=b}catch(m){this.logService.error(m)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=d;let f=class{constructor(b,m,v){this.fileStorage=new d(b.stateResource,m,v)}async init(){await this.fileStorage.init()}getItem(b,m){return this.fileStorage.getItem(b,m)}};f=de([ee(0,k.IEnvironmentService),ee(1,y.ILogService),ee(2,O.IFileService)],f),e.StateService=f}),define(Q[67],Z([0,1,12,32,10,30]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(f){if(R.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function y(f,P,b,m,v,p,E,S,l,g){const w=Object.create(null);w["common.machineId"]=E,w.sessionID=(0,k.generateUuid)()+Date.now(),w.commitHash=v,w.version=p,w["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,R.PlatformToString)(R.platform),w["common.nodePlatform"]=C.platform,w["common.nodeArch"]=m,w["common.product"]=g||"desktop",S&&(w["common.msftInternal"]=S);let u=0;const s=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),R.isLinuxSnap&&(w["common.snap"]="true");const t=O(b);t&&(w["common.platformDetail"]=t);try{const n=await f.readFile(I.URI.file(l));w["common.source"]=n.value.toString().slice(0,30)}catch{}return w}e.resolveCommonProperties=y;function d(f){const P=C.env.USERDNSDOMAIN;if(!P)return!1;const b=P.toLowerCase();return f.some(m=>b===m)}e.verifyMicrosoftInternalDomain=d}),define(Q[35],Z([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var C;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(C=e.TelemetryLevel||(e.TelemetryLevel={}));var I;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(I=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[42],Z([0,1,26,52,5,21,67,35]),function(_,e,R,C,I,k,O,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class d{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,C.staticObservableValue)(0)}publicLog(r,o){return Promise.resolve(void 0)}publicLog2(r,o){return this.publicLog(r,o)}publicLogError(r,o){return Promise.resolve(void 0)}publicLogError2(r,o){return this.publicLogError(r,o)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=d,e.NullTelemetryService=new d;class f{async publicLog(r,o,c){}async publicLogError(r,o,c){}}e.NullEndpointTelemetryService=f,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function P(i,r){return r.onDidChangeConfiguration(o=>{o.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(o.source),configurationKeys:l(o.sourceConfig)})})}e.configurationTelemetry=P;function b(i,r){return!(r.disableTelemetry||!i.enableTelemetry||r.extensionTestsLocationURI)}e.supportsTelemetry=b;function m(i){const r=i.getValue(y.TELEMETRY_SETTING_ID),o=i.getValue("telemetry.enableCrashReporter");if(i.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=m;function v(i){const r={},o={},c={};S(i,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const h=c[a];typeof h=="number"?o[a]=h:typeof h=="boolean"?o[a]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${h.length}`),r[a]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(r[a]=h)}return{properties:r,measurements:o}}e.validateTelemetryData=v;const p=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function E(i){if(!i)return"none";for(const r of p)if(i.startsWith(`${r}+`))return r;return"other"}e.cleanRemoteAuthority=E;function S(i,r,o=0,c){if(!!i)for(const a of Object.getOwnPropertyNames(i)){const h=i[a],D=c?c+a:a;Array.isArray(h)?r[D]=(0,R.safeStringify)(h):h instanceof Date?r[D]=h.toISOString():(0,I.isObject)(h)?o<2?S(h,r,o+1,D+"."):r[D]=(0,R.safeStringify)(h):r[D]=h}}function l(i){if(!i)return[];const r=[];return g(r,"",i),r}function g(i,r,o){o&&typeof o=="object"&&!Array.isArray(o)?Object.keys(o).forEach(c=>g(i,r?`${r}.${c}`:c,o[c])):i.push(r)}function w(i,r){const o=i.msftInternalDomains||[],c=r.getValue("telemetry.internalTesting");return(0,O.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=w;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=u;function s(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const c=[];for(const N of r)for(;;){const B=N.exec(i);if(!B)break;c.push([B.index,N.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(o="";;){const N=h.exec(i);if(!N)break;const B=c.some(([X,J])=>N.index<J&&X<h.lastIndex);!a.test(N[0])&&!B&&(o+=i.substring(D,N.index)+"<REDACTED: user-file-path>",D=h.lastIndex)}return D<i.length&&(o+=i.substr(D)),o}function t(i){if(!i)return i;const r=i.toLowerCase(),o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const c of o)if(c.regex.test(r))return`<REDACTED: ${c.label}>`;return i}function n(i,r){return(0,R.cloneAndChange)(i,o=>{if(typeof o=="string"){let c=o;c=s(c,r);for(const a of r)c=c.replace(a,"");return c=t(c),c}})}e.cleanData=n}),define(Q[132],Z([0,1,104,42]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function I(k,O,y,d,f,P,b){const m={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${O.nameShort})`};if((0,C.supportsTelemetry)(O,y)&&(0,C.getTelemetryLevel)(d)===3){const v=await(0,R.getServiceMachineId)(y,f,P),{sessionId:p}=await b.getTelemetryInfo();m["X-Market-User-Id"]=v,m["VSCode-SessionId"]=p}return m}e.resolveMarketplaceHeaders=I}),define(Q[133],Z([0,1,11,26,42]),function(_,e,R,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function O(d,f,P){const b=await new Promise((S,l)=>{_(["@microsoft/1ds-core-js"],S,l)}),m=await new Promise((S,l)=>{_(["@microsoft/1ds-post-js"],S,l)}),v=new b.AppInsightsCore,p=new m.PostChannel,E={instrumentationKey:d,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(P){E.extensionConfig={};const S={alwaysUseXhrOverride:!0,httpXHROverride:P};E.extensionConfig[p.identifier]=S}return v.initialize(E,[]),v.addTelemetryInitializer(S=>{f&&(S.ext=S.ext??{},S.ext.utc=S.ext.utc??{},S.ext.utc.flags=8462029)}),v}class y{constructor(f,P,b,m,v){this._isInternalTelemetry=f,this._eventPrefix=P,this._defaultData=b,this._xhrOverride=v,this.endPointUrl=k,this._defaultData||(this._defaultData={}),typeof m=="function"?this._aiCoreOrKey=m():this._aiCoreOrKey=m,this._asyncAiCore=null}_withAIClient(f){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){f(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=O(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(P=>{f(P)},P=>{(0,R.onUnexpectedError)(P),console.error(P)})}}log(f,P){if(!this._aiCoreOrKey)return;P=(0,C.mixin)(P,this._defaultData),P=(0,I.validateTelemetryData)(P);const b=this._eventPrefix+"/"+f;try{this._withAIClient(m=>{m.pluginVersionString=P?.properties.version??"Unknown",m.track({name:b,baseData:{name:b,properties:P?.properties,measurements:P?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(f=>{this._withAIClient(P=>{P.unload(!0,()=>{this._aiCoreOrKey=void 0,f(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=y}),define(Q[134],Z([0,1,2,26,52,12,27,97,21,40,135,28,33,35,42]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let E=class{constructor(g,w,u){this._configurationService=w,this._productService=u,this._experimentProperties={},this.telemetryLevel=new I.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,w){this._experimentProperties[g]=w}_updateTelemetryLevel(){let g=(0,p.getTelemetryLevel)(this._configurationService);const w=this._productService.enabledTelemetryLevels;if(w){this._sendErrorTelemetry=this.sendErrorTelemetry?w.error:!1;const u=w.usage?3:w.error?2:0;g=Math.min(g,u)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,w=g.sessionID,u=g["common.machineId"],s=g["common.firstSessionDate"],t=g["common.msftInternal"];return{sessionId:w,machineId:u,firstSessionDate:s,msftInternal:t}}dispose(){this._disposables.dispose()}_log(g,w,u,s){return this.telemetryLevel.value<w?Promise.resolve(void 0):this._commonProperties.then(t=>{u=(0,C.mixin)(u,this._experimentProperties),u=(0,p.cleanData)(u,this._cleanupPatterns),u=(0,C.mixin)(u,t),this._appenders.forEach(n=>n.log(g,u))},t=>{console.error(t)})}publicLog(g,w,u){return this._log(g,3,w,u)}publicLog2(g,w,u){return this.publicLog(g,w,u)}publicLogError(g,w){return this._sendErrorTelemetry?this._log(g,2,w,!0):Promise.resolve(void 0)}publicLogError2(g,w){return this.publicLogError(g,w)}};E.IDLE_START_EVENT_NAME="UserIdleStart",E.IDLE_STOP_EVENT_NAME="UserIdleStop",E=de([ee(1,d.IConfigurationService),ee(2,b.IProductService)],E),e.TelemetryService=E;function S(){const l=(0,y.localize)(0,null,P.default.nameLong),g=P.default.privacyStatementUrl?(0,y.localize)(2,null,"https://aka.ms/vscode-telemetry",P.default.privacyStatementUrl):(0,y.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=k.isWeb?"":(0,y.localize)(3,null),u=(0,y.localize)(4,null),s=(0,y.localize)(5,null),t=(0,y.localize)(6,null),n=(0,y.localize)(7,null),i=`
|       | ${u} | ${s} | ${t} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,y.localize)(8,null);return`
${l} ${g} ${w}

&nbsp;

${n}
${i}

&nbsp;

${r}
`}m.Registry.as(f.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,y.localize)(10,null),(0,y.localize)(11,null),(0,y.localize)(12,null),(0,y.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(f.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,y.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:P.default.privacyStatementUrl?(0,y.localize)(16,null,P.default.nameLong,P.default.privacyStatementUrl):(0,y.localize)(15,null,P.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,y.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[136],Z([0,1,159,133]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class I extends C.AbstractOneDataSystemAppender{constructor(O,y,d,f){const P={sendPOST:(b,m)=>{const v={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const p=R.request(b.urlString,v,E=>{E.on("data",function(S){m(E.statusCode??200,E.headers,S.toString())}),E.on("error",function(S){m(0,{})})});p.write(b.data),p.end()}catch{m(0,{})}}};super(O,y,d,f,P)}}e.OneDataSystemAppender=I}),define(Q[137],Z([0,1,14,20]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function I(k,O){const y=Object.create(null),d=(P,b)=>{const m=JSON.parse(P);y[b]=m};if(O){const P=[],b=await C.Promises.readdir(O);for(const v of b)try{(await C.Promises.stat((0,R.join)(O,v))).isDirectory()&&P.push(v)}catch{}const m=[];for(const v of P)(await C.Promises.readdir((0,R.join)(O,v))).filter(E=>E==="telemetry.json").length===1&&m.push(v);for(const v of m){const p=(await C.Promises.readFile((0,R.join)(O,v,"telemetry.json"))).toString();d(p,v)}}let f=(await C.Promises.readFile((0,R.join)(k,"telemetry-core.json"))).toString();return d(f,"vscode-core"),f=(await C.Promises.readFile((0,R.join)(k,"telemetry-extensions.json"))).toString(),d(f,"vscode-extensions"),JSON.stringify(y,null,4)}e.buildTelemetryMessage=I}),define(Q[29],Z([0,1,8]),function(_,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(Q[138],Z([0,1,4,2,10,17,23,13,9,29]),function(_,e,R,C,I,k,O,y,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends C.Disposable{constructor(m,v,p,E,S){super(),this.extensionsManagementService=m,this.logService=E,this.uriIdentityService=S,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(w=>w.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(g=>this.onInstallExtension(g))),this._register(m.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(m.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const l=I.URI.file(p.extensionsPath);this._register(v.watch(l)),this._register(R.Event.filter(v.onDidFilesChange,g=>g.rawChanges.some(w=>this.doesChangeAffects(w,l)))(()=>this.onDidChange()))}doesChangeAffects(m,v){return m.type!==1&&m.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(m.resource),v)?!1:this.uriIdentityService.extUri.isEqual(m.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(m.resource).startsWith(".")}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const v of m)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(v=>!(0,O.areSameExtensions)(v,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,O.areSameExtensions)(v,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(),v=m.filter(E=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,O.areSameExtensions)(S,E.identifier))?!1:E.installedTimestamp&&E.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",E.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",E.identifier.id),!1)),p=this.installedExtensions.filter(E=>this.installingExtensions.some(S=>(0,O.areSameExtensions)(S,E))?!1:m.every(S=>!(0,O.areSameExtensions)(S.identifier,E))?(this.logService.info("Detected extension removed from another source",E.id),!0):!1);this.installedExtensions=m.map(E=>E.identifier),(v.length||p.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:p})}}};P=de([ee(1,y.IFileService),ee(2,k.INativeEnvironmentService),ee(3,d.ILogService),ee(4,f.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(Q[139],Z([0,1,29,105,13,18,70,4,2]),function(_,e,R,C,I,k,O,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class f{constructor(m){this.uri=m,this.time=f._clock++}touch(){return this.time=f._clock++,this}}f._clock=0;let P=class{constructor(m){this._fileService=m,this._dispooables=new d.DisposableStore,this._limit=2**16;const v=new Map,p=E=>{let S=v.get(E.scheme);return S===void 0&&(S=m.hasProvider(E)&&!this._fileService.hasCapability(E,1024),v.set(E.scheme,S)),S};this._dispooables.add(y.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(E=>{v.delete(E.scheme)})),this.extUri=new k.ExtUri(p),this._canonicalUris=new O.SkipList((E,S)=>this.extUri.compare(E,S,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(m){this._fileService.hasProvider(m)&&(m=(0,k.normalizePath)(m));const v=this._canonicalUris.get(m);return v?v.touch().uri.with({fragment:m.fragment}):(this._canonicalUris.set(m,new f(m)),this._checkTrim(),m)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const m=[...this._canonicalUris.entries()].sort((p,E)=>p[1].touch<E[1].touch?1:p[1].touch>E[1].touch?-1:0);f._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let p=0;p<v;p++)this._canonicalUris.set(m[p][0],m[p][1].touch())}};P=de([ee(0,I.IFileService)],P),e.UriIdentityService=P,(0,C.registerSingleton)(R.IUriIdentityService,P,1)}),define(Q[140],Z([0,1,99,14,113,18,10,8,16]),function(_,e,R,C,I,k,O,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,y.createDecorator)("contextService");function f(n){const i=n;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=f,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function P(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,C.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const r=n;if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=P;function b(n){const i=n;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function m(n){const i=n;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var v;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(v=e.WorkbenchState||(e.WorkbenchState={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=p;function E(n){const i=n;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=E;class S{constructor(i,r,o,c,a){this._id=i,this._transient=o,this._configuration=c,this._ignorePathCasing=a,this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=I.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=S;class l{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,k.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=l;function g(n){return new l({uri:n,index:0,name:(0,k.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(n,i){return k.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function u(n){let i;return O.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=u;function s(n,i){return!w(n,i)&&!u(n)}e.isSavedWorkspace=s;function t(n){return(typeof n=="string"?(0,C.extname)(n):(0,k.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(Q[25],Z([0,1,53,4,2,18,5,10,98,17,13,8,9,140,39,29,3,30,27]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function w(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&y.URI.isUri(r.location)&&y.URI.isUri(r.globalStorageHome)&&y.URI.isUri(r.settingsResource)&&y.URI.isUri(r.keybindingsResource)&&y.URI.isUri(r.tasksResource)&&y.URI.isUri(r.snippetsHome)&&((0,O.isUndefined)(r.extensionsResource)||y.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=w,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function u(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:y.URI.revive(i.location).with({scheme:r}),globalStorageHome:y.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:y.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:y.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:y.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:y.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:y.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=u,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function s(i,r,o,c){return{id:i,name:r,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,k.joinPath)(o,"globalStorage"),settingsResource:(0,k.joinPath)(o,"settings.json"),keybindingsResource:(0,k.joinPath)(o,"keybindings.json"),tasksResource:(0,k.joinPath)(o,"tasks.json"),snippetsHome:(0,k.joinPath)(o,"snippets"),extensionsResource:(0,k.joinPath)(o,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=s;let t=class extends I.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.profilesObject.profiles,...this.transientProfilesObject.profiles]}constructor(r,o,c,a){super(),this.environmentService=r,this.fileService=o,this.uriIdentityService=c,this.logService=a,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new C.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new C.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new C.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new C.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profileCreationPromises=new Map,this.transientProfilesObject={profiles:[],workspaces:new p.ResourceMap},this.profilesHome=(0,k.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}isEnabled(){return this.enabled}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(h=>s((0,k.basename)(h.location),h.name,h.location,{shortName:h.shortName,useDefaultFlags:h.useDefaultFlags})):[];let o;const c=new p.ResourceMap,a=s((0,R.hash)(this.environmentService.userRoamingDataHome.path).toString(16),(0,d.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...a,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0||this.transientProfilesObject.profiles.length>0?a.extensionsResource:void 0}),r.length){const h=this.getStoredProfileAssociations();if(h.workspaces)for(const[D,N]of Object.entries(h.workspaces)){const B=y.URI.parse(D),X=y.URI.parse(N),J=r.find(se=>this.uriIdentityService.extUri.isEqual(se.location,X));J&&c.set(B,J)}if(h.emptyWindow){const D=y.URI.parse(h.emptyWindow);o=r.find(N=>this.uriIdentityService.extUri.isEqual(N.location,D))}}this._profilesObject={profiles:r,workspaces:c,emptyWindow:o}}return this._profilesObject}async createTransientProfile(r){const o="Temp",c=new RegExp(`${(0,g.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const D of this.profiles){const N=c.exec(D.name),B=N?parseInt(N[1]):0;a=B>a?B:a}const h=`${o} ${a+1}`;return this.createProfile((0,R.hash)((0,l.generateUuid)()).toString(16),h,{transient:!0},r)}async createNamedProfile(r,o,c){return this.createProfile((0,R.hash)((0,l.generateUuid)()).toString(16),r,o,c)}async createProfile(r,o,c,a){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const h=await this.doCreateProfile(r,o,c);return a&&await this.setProfileForWorkspace(a,h),h}async doCreateProfile(r,o,c){let a=this.profileCreationPromises.get(o);return a||(a=(async()=>{try{const h=this.profiles.find(B=>B.name===o||B.id===r);if(h)return h;const D=s(r,o,(0,k.joinPath)(this.profilesHome,r),c);await this.fileService.createFolder(D.location);const N=[];return this._onWillCreateProfile.fire({profile:D,join(B){N.push(B)}}),await S.Promises.settled(N),this.updateProfiles([D],[],[]),D}finally{this.profileCreationPromises.delete(o)}})(),this.profileCreationPromises.set(o,a)),a}async updateProfile(r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let c=this.profiles.find(a=>a.id===r.id);if(!c)throw new Error(`Profile '${r.name}' does not exist`);return c=s(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.updateProfiles([],[],[c]),c}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const c=[];this._onWillRemoveProfile.fire({profile:o,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.logService.error(a)}o.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const a of[...this.profilesObject.workspaces.keys()])o.id===this.profilesObject.workspaces.get(a)?.id&&this.profilesObject.workspaces.delete(a);this.updateStoredProfileAssociations(),this.updateProfiles([],[o],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(o.location,{recursive:!0})}catch(a){this.logService.error(a)}}getOrSetProfileForWorkspace(r,o=this.defaultProfile){if(!this.enabled)return this.defaultProfile;let c=this.getProfileForWorkspace(r);return c||(c=o,this.profiles.length>1&&this.setProfileForWorkspaceSync(r,c)),c}async setProfileForWorkspace(r,o){this.setProfileForWorkspaceSync(r,o)}setProfileForWorkspaceSync(r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.updateWorkspaceAssociation(r,c)}unsetWorkspace(r,o){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r,void 0,o)}async resetWorkspaces(){this.transientProfilesObject.workspaces.clear(),this.transientProfilesObject.emptyWindow=void 0,this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async cleanUp(){if(!!this.enabled&&await this.fileService.exists(this.profilesHome)){const r=await this.fileService.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.uriIdentityService.extUri.isEqual(c.location,o.resource))).map(o=>this.fileService.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.enabled)return;const r=this.transientProfilesObject.profiles.filter(o=>!this.isProfileAssociatedToWorkspace(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.getWorkspace(r);return y.URI.isUri(o)?this.transientProfilesObject.workspaces.get(o)??this.profilesObject.workspaces.get(o):this.transientProfilesObject.emptyWindow??this.profilesObject.emptyWindow}getWorkspace(r){return(0,v.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,v.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}isProfileAssociatedToWorkspace(r){return!!(this.uriIdentityService.extUri.isEqual(this.transientProfilesObject.emptyWindow?.location,r.location)||[...this.transientProfilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location))||this.uriIdentityService.extUri.isEqual(this.profilesObject.emptyWindow?.location,r.location)||[...this.profilesObject.workspaces.values()].some(o=>this.uriIdentityService.extUri.isEqual(o.location,r.location)))}updateProfiles(r,o,c){const a=[...this.profiles,...r],h=[];this.transientProfilesObject.profiles=[];for(let D of a)D.isDefault||o.some(N=>D.id===N.id)||(D=c.find(N=>D.id===N.id)??D,D.isTransient?this.transientProfilesObject.profiles.push(D):h.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.saveStoredProfiles(h),this._profilesObject=void 0,this.triggerProfilesChanges(r,o,c)}triggerProfilesChanges(r,o,c){this._onDidChangeProfiles.fire({added:r,removed:o,updated:c,all:this.profiles})}updateWorkspaceAssociation(r,o,c){c=o?.isTransient?!0:c,c||this.updateWorkspaceAssociation(r,void 0,!0);const a=this.getWorkspace(r),h=c?this.transientProfilesObject:this.profilesObject;y.URI.isUri(a)?(h.workspaces.delete(a),o&&h.workspaces.set(a,o)):h.emptyWindow=o,c||this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[c,a]of this.profilesObject.workspaces.entries())r[c.toString()]=a.location.toString();const o=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:o}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};t.PROFILES_KEY="userDataProfiles",t.PROFILE_ASSOCIATIONS_KEY="profileAssociations",t=de([ee(0,f.IEnvironmentService),ee(1,P.IFileService),ee(2,E.IUriIdentityService),ee(3,m.ILogService)],t),e.UserDataProfilesService=t;class n extends t{constructor(){super(...arguments),this.storedProfiles=[],this.storedProfileAssociations={}}getStoredProfiles(){return this.storedProfiles}saveStoredProfiles(r){this.storedProfiles=r}getStoredProfileAssociations(){return this.storedProfileAssociations}saveStoredProfileAssociations(r){this.storedProfileAssociations=r}}e.InMemoryUserDataProfilesService=n}),define(Q[141],Z([0,1,19,3,24,11,4,2,12,10,83,22,23,34,9,28,35,25]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends y.Disposable{get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}constructor(i,r,o,c,a){super(),this.galleryService=i,this.telemetryService=r,this.logService=o,this.productService=c,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this._onDidInstallExtensions=this._register(new O.Emitter),this._onUninstallExtension=this._register(new O.Emitter),this._onDidUninstallExtension=this._register(new O.Emitter),this.participants=[],this._register((0,y.toDisposable)(()=>{this.installingExtensions.forEach(({task:h})=>h.cancel()),this.uninstallingExtensions.forEach(h=>h.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,b.isTargetPlatformCompatible)(o,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(P.localize(0,null),b.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(i,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(i),error:o}),this.logService.error("Failed to install extension.",i.identifier.id),this.logService.error(o),u(o)}}async uninstall(i,r={}){return this.logService.trace("ExtensionManagementService#uninstall",i.identifier.id),this.uninstallExtension(i,r)}async reinstallFromGallery(i){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",i.identifier.id),!this.galleryService.isEnabled())throw new Error(P.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...i.identifier,preRelease:i.preRelease}],{targetPlatform:r,compatible:!0},I.CancellationToken.None);if(!o)throw new Error(P.localize(2,null));await this.createUninstallExtensionTask(i,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.extensionsControlManifest||i-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=i),this.extensionsControlManifest}registerParticipant(i){this.participants.push(i)}async installExtension(i,r,o){const c=X=>`${m.ExtensionKey.create(X).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!f.URI.isUri(r)){const X=this.installingExtensions.get(c(r));if(X){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:J}=await X.task.waitUntilTaskIsFinished();return J}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],h=[],D=[],N=this.createInstallExtensionTask(i,r,o);f.URI.isUri(r)||this.installingExtensions.set(c(r),{task:N,waitingTasks:[]}),this._onInstallExtension.fire({identifier:N.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",N.identifier.id),a.push({task:N,manifest:i});let B=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",N.identifier.id);else try{const J=await this.getAllDepsAndPackExtensions(N.identifier,i,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation),se=await this.getInstalled(void 0,o.profileLocation);for(const{gallery:ne,manifest:re}of J){B=B||!!re.extensionDependencies?.some(ie=>(0,m.areSameExtensions)({id:ie},N.identifier));const ge=c(ne),ce=this.installingExtensions.get(ge);if(ce){if(this.canWaitForTask(N,ce.task)){this.logService.info("Waiting for already requested installing extension",ne.identifier.id,N.identifier.id),ce.waitingTasks.push(N);const ie=ce.task.identifier;h.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,m.areSameExtensions)(M.identifier,ie)))).then(j=>{if(!j.find(F=>(0,m.areSameExtensions)(F.identifier,ie))?.local)throw new Error(`Extension ${ie.id} is not installed`)}))}}else if(!se.some(({identifier:ie})=>(0,m.areSameExtensions)(ie,ne.identifier))){const ie=this.createInstallExtensionTask(re,ne,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ge,{task:ie,waitingTasks:[N]}),this._onInstallExtension.fire({identifier:ie.identifier,source:ne,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",ie.identifier.id,N.identifier.id),a.push({task:ie,manifest:re})}}}catch(J){if(f.URI.isUri(N.source))(0,R.isNonEmptyArray)(i.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",N.identifier.id,J.message),(0,R.isNonEmptyArray)(i.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",N.identifier.id,J.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",N.identifier.id),J}const X=a.reduce((J,{task:se,manifest:ne})=>(J.set(se.identifier.id.toLowerCase(),{task:se,manifest:ne}),J),new Map);for(;X.size;){let J;const se=[...X.values()].filter(({manifest:ne})=>!ne.extensionDependencies?.some(re=>X.has(re.toLowerCase())));se.length?J=X.size===1?se:se.filter(({task:ne})=>!(ne===N&&!B)):(this.logService.info("Found extensions with circular dependencies",se.map(({task:ne})=>ne.identifier.id)),J=[...X.values()]),await this.joinAllSettled(J.map(async({task:ne})=>{const re=new Date().getTime();try{const{local:ge}=await ne.run();if(await this.joinAllSettled(this.participants.map(ce=>ce.postInstall(ge,ne.source,o,I.CancellationToken.None))),!f.URI.isUri(ne.source)){const ce=ne.operation===3,ie=ce?void 0:(new Date().getTime()-ne.source.lastUpdated)/1e3;if(s(this.telemetryService,ce?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ne.source),wasVerified:ne.wasVerified,duration:new Date().getTime()-re,durationSinceUpdate:ie}),d.isWeb&&ne.operation!==3)try{await this.galleryService.reportStatistic(ge.manifest.publisher,ge.manifest.name,ge.manifest.version,"install")}catch{}}D.push({local:ge,identifier:ne.identifier,operation:ne.operation,source:ne.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:ge.isApplicationScoped})}catch(ge){throw f.URI.isUri(ne.source)||s(this.telemetryService,ne.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.getGalleryExtensionTelemetryData)(ne.source),wasVerified:ne.wasVerified,duration:new Date().getTime()-re,error:ge}),this.logService.error("Error while installing the extension:",ne.identifier.id),ge}finally{X.delete(ne.identifier.id.toLowerCase())}}))}return h.length&&await this.joinAllSettled(h),D.forEach(({identifier:J})=>this.logService.info("Extension installed successfully:",J.id)),this._onDidInstallExtensions.fire(D),D.filter(({identifier:J})=>(0,m.areSameExtensions)(J,N.identifier))[0].local}catch(X){if(a.forEach(({task:J})=>J.cancel()),D.length)try{const J=await Promise.allSettled(D.map(({local:se})=>this.createUninstallExtensionTask(se,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let se=0;se<J.length;se++){const ne=J[se],{identifier:re}=D[se];ne.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",re.id):this.logService.warn("Rollback: Error while uninstalling extension",re.id,(0,k.getErrorMessage)(ne.reason))}}catch(J){this.logService.warn("Error while rolling back extensions",(0,k.getErrorMessage)(J),D.map(({identifier:se})=>se.id))}throw this._onDidInstallExtensions.fire(a.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:o.context,profileLocation:o.profileLocation}))),X}finally{for(const[X,{task:J,waitingTasks:se}]of this.installingExtensions.entries()){const ne=se.indexOf(N);ne!==-1&&se.splice(ne,1),se.length===0&&(J===N||ne!==-1)&&this.installingExtensions.delete(X)}}}canWaitForTask(i,r){for(const[,{task:o,waitingTasks:c}]of this.installingExtensions.entries())if(o===i&&(c.includes(r)||c.some(a=>this.canWaitForTask(a,r)))||o===r&&c[0]&&!this.canWaitForTask(i,c[0]))return!1;return!0}async joinAllSettled(i){const r=[],o=[],c=await Promise.allSettled(i);for(const a of c)a.status==="fulfilled"?r.push(a.value):o.push(a.reason);if(o.length)throw w(o);return r}async getAllDepsAndPackExtensions(i,r,o,c,a){if(!this.galleryService.isEnabled())return[];const h=await this.getInstalled(void 0,a),D=[i],N=[],B=async(X,J)=>{const se=J.extensionDependencies||[],ne=[...se];if(J.extensionPack){const re=o?h.find(ge=>(0,m.areSameExtensions)(ge.identifier,X)):void 0;for(const ge of J.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ce=>(0,m.areSameExtensions)({id:ce},{id:ge}))||ne.every(ce=>!(0,m.areSameExtensions)({id:ce},{id:ge}))&&ne.push(ge)}if(ne.length){const re=[...D,...N.map(ce=>ce.gallery.identifier)],ge=ne.filter(ce=>re.every(ie=>!(0,m.areSameExtensions)(ie,{id:ce})));if(ge.length){const ce=await this.galleryService.getExtensions(ge.map(ie=>({id:ie,preRelease:c})),I.CancellationToken.None);for(const ie of ce){if(re.find(F=>(0,m.areSameExtensions)(F,ie.identifier)))continue;const j=se.some(F=>(0,m.areSameExtensions)({id:F},ie.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(ie,!1,c)}catch(F){if(F instanceof b.ExtensionManagementError&&F.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!j){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw F}N.push({gallery:M.extension,manifest:M.manifest}),await B(M.extension.identifier,M.manifest)}}}};return await B(i,r),N}async checkAndGetCompatibleVersion(i,r,o){if((await this.getExtensionsControlManifest()).malicious.some(D=>(0,m.areSameExtensions)(i.identifier,D)))throw new b.ExtensionManagementError(P.localize(3,null,i.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const D=await this.getTargetPlatform();throw new b.ExtensionManagementError(P.localize(4,null,i.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(D)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(i,r,o);if(a){if(o&&!r&&i.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(P.localize(5,null,i.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([i.identifier],I.CancellationToken.None))[0]?new b.ExtensionManagementError(P.localize(6,null,i.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(P.localize(7,null,i.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const h=await this.galleryService.getManifest(a,I.CancellationToken.None);if(h===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new b.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async getCompatibleVersion(i,r,o){const c=await this.getTargetPlatform();let a=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},I.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(i,o,c)&&(a=i),a||(r?a=(await this.galleryService.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},I.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(i,o,c)),a}async uninstallExtension(i,r){const o=B=>`${B.id.toLowerCase()}${r.versionOnly?`-${i.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,c=this.uninstallingExtensions.get(o(i.identifier));if(c)return this.logService.info("Extensions is already requested to uninstall",i.identifier.id),c.waitUntilTaskIsFinished();const a=(B,X)=>{const J=this.createUninstallExtensionTask(B,X);return this.uninstallingExtensions.set(o(J.extension.identifier),J),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${B.identifier.id}@${B.manifest.version}`),this._onUninstallExtension.fire({identifier:B.identifier,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped}),J},h=(B,X)=>{X?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString(),X.message):this.logService.error("Failed to uninstall extension:",`${B.identifier.id}@${B.manifest.version}`,X.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${B.identifier.id}@${B.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${B.identifier.id}@${B.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,m.getLocalExtensionTelemetryData)(B),error:X}),this._onDidUninstallExtension.fire({identifier:B.identifier,version:B.manifest.version,error:X?.code,profileLocation:r.profileLocation,applicationScoped:B.isApplicationScoped})},D=[],N=[];try{D.push(a(i,r));const B=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const X=this.getAllPackExtensionsToUninstall(i,B);for(const J of X)this.uninstallingExtensions.has(o(J.identifier))?this.logService.info("Extensions is already requested to uninstall",J.identifier.id):D.push(a(J,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.checkForDependents(D.map(X=>X.extension),B,i),await this.joinAllSettled(D.map(async X=>{try{if(await X.run(),await this.joinAllSettled(this.participants.map(J=>J.postUninstall(X.extension,r,I.CancellationToken.None))),X.extension.identifier.uuid)try{await this.galleryService.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,"uninstall")}catch{}h(X.extension)}catch(J){const se=J instanceof b.ExtensionManagementError?J:new b.ExtensionManagementError((0,k.getErrorMessage)(J),b.ExtensionManagementErrorCode.Internal);throw h(X.extension,se),se}finally{N.push(X)}}))}catch(B){const X=B instanceof b.ExtensionManagementError?B:new b.ExtensionManagementError((0,k.getErrorMessage)(B),b.ExtensionManagementErrorCode.Internal);for(const J of D){try{J.cancel()}catch{}N.includes(J)||h(J.extension,X)}throw X}finally{for(const B of D)this.uninstallingExtensions.delete(o(B.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",B.extension.identifier.id)}}checkForDependents(i,r,o){for(const c of i){const a=this.getDependents(c,r);if(a.length){const h=a.filter(D=>!i.some(N=>(0,m.areSameExtensions)(N.identifier,D.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(c,h,o))}}}getDependentsErrorMessage(i,r,o){return o===i?r.length===1?P.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?P.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?P.localize(12,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):P.localize(13,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(i,r,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const a=r.filter(D=>!D.isBuiltin&&c.some(N=>(0,m.areSameExtensions)({id:N},D.identifier))),h=[];for(const D of a)h.push(...this.getAllPackExtensionsToUninstall(D,r,o));return[...a,...h]}return[]}getDependents(i,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,m.areSameExtensions)({id:c},i.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const i=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(i,r,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(i)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(i,r,o)}createUninstallExtensionTask(i,r){return r.profileLocation&&i.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(i,r)}};g=de([ee(0,b.IExtensionGalleryService),ee(1,S.ITelemetryService),ee(2,p.ILogService),ee(3,E.IProductService),ee(4,l.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function w(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=w;function u(n){if(n instanceof b.ExtensionManagementError)return n;const i=new b.ExtensionManagementError(n.message,b.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function s(n,i,{extensionData:r,wasVerified:o,duration:c,error:a,durationSinceUpdate:h}){let D,N;a&&(a instanceof b.ExtensionManagementError?(D=a.code,a.code===b.ExtensionManagementErrorCode.Signature&&(N=a.message)):D=b.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,wasVerified:o,success:!a,duration:c,errorcode:D,errorcodeDetail:N,durationSinceUpdate:h})}e.reportTelemetry=s;class t{constructor(){this.barrier=new C.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(i=>this.doRun(i))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,C.createCancelablePromise)(i=>new Promise((r,o)=>{const c=i.onCancellationRequested(()=>{c.dispose(),o(new k.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=t}),define(Q[48],Z([0,1,19,3,26,15,11,50,75,2,16,14,12,18,38,54,5,10,87,17,23,34,45,13,8,9,28,4,44,41,25,29,103]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l,g,w,u,s,t,n,i,r,o,c,a,h,D,N,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(ie){function j(M,F){if(M===F)return!0;const z=Object.keys(M),$=new Set;for(const Y of Object.keys(F))$.add(Y);if(z.length!==$.size)return!1;for(const Y of z){if(M[Y]!==F[Y])return!1;$.delete(Y)}return $.size===0}ie.equals=j})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let J=class extends f.Disposable{constructor(j,M,F,z,$,Y,A,x,L,T,U){super(),this.systemExtensionsLocation=j,this.userExtensionsLocation=M,this.extensionsControlLocation=F,this.cacheLocation=z,this.userDataProfilesService=$,this.extensionsProfileScannerService=Y,this.fileService=A,this.logService=x,this.environmentService=L,this.productService=T,this.instantiationService=U,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,(0,v.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(re,(0,v.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ne,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(j,M,F){const[z,$]=await Promise.all([this.scanSystemExtensions(j),this.scanUserExtensions(M)]),Y=F?await this.scanExtensionsUnderDevelopment(j,[...z,...$]):[];return this.dedupExtensions(z,$,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(j){const M=[];M.push(this.scanDefaultSystemExtensions(!!j.useCache,j.language)),M.push(this.scanDevSystemExtensions(j.language,!!j.checkControlFile));const[F,z]=await Promise.all(M);return this.applyScanOptions([...F,...z],0,j,!1)}async scanUserExtensions(j){this.logService.trace("Started scanning user extensions");const M=await this.createExtensionScannerInput(j.profileLocation??this.userExtensionsLocation,!!j.profileLocation,1,!j.includeUninstalled,j.language);let z=await(j.useCache&&!M.devMode&&M.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(M);return z=await this.applyScanOptions(z,1,j,!0),this.logService.trace("Scanned user extensions:",z.length),z}async scanExtensionsUnderDevelopment(j,M){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const F=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(z=>z.scheme===P.Schemas.file).map(async z=>{const $=await this.createExtensionScannerInput(z,!1,1,!0,j.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions($)).map(A=>(A.type=M.find(x=>(0,u.areSameExtensions)(x.identifier,A.identifier))?.type??A.type,this.extensionsScanner.validate(A,$)))}))).flat();return this.applyScanOptions(F,"development",j,!0)}return[]}async scanExistingExtension(j,M,F){const z=await this.createExtensionScannerInput(j,!1,M,!0,F.language),$=await this.extensionsScanner.scanExtension(z);return!$||!F.includeInvalid&&!$.isValid?null:$}async scanOneOrMultipleExtensions(j,M,F){const z=await this.createExtensionScannerInput(j,!1,M,!0,F.language),$=await this.extensionsScanner.scanOneOrMultipleExtensions(z);return this.applyScanOptions($,M,F,!0)}async scanMetadata(j){const M=(0,v.joinPath)(j,"package.json"),F=(await this.fileService.readFile(M)).value.toString();return JSON.parse(F).__metadata}async updateMetadata(j,M){const F=(0,v.joinPath)(j,"package.json"),z=(await this.fileService.readFile(F)).value.toString(),$=JSON.parse(z);M.isMachineScoped=M.isMachineScoped||void 0,M.isBuiltin=M.isBuiltin||void 0,M.installedTimestamp=M.installedTimestamp||void 0,$.__metadata={...$.__metadata,...M},await this.fileService.writeFile((0,v.joinPath)(j,"package.json"),k.VSBuffer.fromString(JSON.stringify($,null,"	")))}async applyScanOptions(j,M,F,z){return F.includeAllVersions||(j=this.dedupExtensions(M===0?j:void 0,M===1?j:void 0,M==="development"?j:void 0,await this.getTargetPlatform(),z)),F.includeInvalid||(j=j.filter($=>$.isValid)),j.sort(($,Y)=>{const A=b.basename($.location.fsPath),x=b.basename(Y.location.fsPath);return A<x?-1:A>x?1:0})}dedupExtensions(j,M,F,z,$){const Y=(x,L,T)=>{if(x.isValid&&!L.isValid)return!1;if(x.isValid===L.isValid){if($&&p.gt(x.manifest.version,L.manifest.version))return this.logService.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(p.eq(x.manifest.version,L.manifest.version)){if(x.type===0)return this.logService.debug(`Skipping extension ${L.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===z)return this.logService.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return T?this.logService.warn(`Overwriting user extension ${x.location.path} with ${L.location.path}.`):this.logService.debug(`Overwriting user extension ${x.location.path} with ${L.location.path}.`),!0},A=new Map;return j?.forEach(x=>{const L=s.ExtensionIdentifier.toKey(x.identifier.id),T=A.get(L);(!T||Y(T,x,!1))&&A.set(L,x)}),M?.forEach(x=>{const L=s.ExtensionIdentifier.toKey(x.identifier.id),T=A.get(L);if(!T&&j&&x.type===0){this.logService.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!T||Y(T,x,!1))&&A.set(L,x)}),F?.forEach(x=>{const L=s.ExtensionIdentifier.toKey(x.identifier.id),T=A.get(L);(!T||Y(T,x,!0))&&A.set(L,x),A.set(L,x)}),[...A.values()]}async scanDefaultSystemExtensions(j,M){this.logService.trace("Started scanning system extensions");const F=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,M),$=await(j&&!F.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(F);return this.logService.trace("Scanned system extensions:",$.length),$}async scanDevSystemExtensions(j,M){const F=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!F?.length)return[];this.logService.trace("Started scanning dev system extensions");const z=M?await this.getBuiltInExtensionControl():{},$=[],Y=l.URI.file(b.normalize(b.join(P.FileAccess.asFileUri("",_).fsPath,"..",".build","builtInExtensions")));for(const x of F){const L=z[x.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":$.push((0,v.joinPath)(Y,x.name));break;default:$.push(l.URI.file(L));break}}const A=await Promise.all($.map(async x=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(x,!1,0,!0,j))));return this.logService.trace("Scanned dev system extensions:",A.length),(0,R.coalesce)(A)}async getBuiltInExtensionControl(){try{const j=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(j.value.toString())}catch{return{}}}async createExtensionScannerInput(j,M,F,z,$,Y=!0){const A=await this.getTranslations($??m.language),x=await this.getMtime(j),L=M?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,T=L?await this.getMtime(L):void 0;return new se(j,x,L,T,M,F,z,Y,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,$,A)}async getMtime(j){try{const M=await this.fileService.stat(j);if(typeof M.mtime=="number")return M.mtime}catch{}}};J=de([ee(4,D.IUserDataProfilesService),ee(5,h.IExtensionsProfileScannerService),ee(6,n.IFileService),ee(7,r.ILogService),ee(8,w.IEnvironmentService),ee(9,o.IProductService),ee(10,i.IInstantiationService)],J),e.AbstractExtensionsScannerService=J;class se{constructor(j,M,F,z,$,Y,A,x,L,T,U,W,q,H){this.location=j,this.mtime=M,this.applicationExtensionslocation=F,this.applicationExtensionslocationMtime=z,this.profile=$,this.type=Y,this.excludeObsolete=A,this.validate=x,this.productVersion=L,this.productDate=T,this.productCommit=U,this.devMode=W,this.language=q,this.translations=H}static createNlsConfiguration(j){return{language:j.language,pseudo:j.language==="pseudo",devMode:j.devMode,translations:j.translations}}static equals(j,M){return(0,v.isEqual)(j.location,M.location)&&j.mtime===M.mtime&&(0,v.isEqual)(j.applicationExtensionslocation,M.applicationExtensionslocation)&&j.applicationExtensionslocationMtime===M.applicationExtensionslocationMtime&&j.profile===M.profile&&j.type===M.type&&j.excludeObsolete===M.excludeObsolete&&j.validate===M.validate&&j.productVersion===M.productVersion&&j.productDate===M.productDate&&j.productCommit===M.productCommit&&j.devMode===M.devMode&&j.language===M.language&&X.equals(j.translations,M.translations)}}let ne=class extends f.Disposable{constructor(j,M,F,z,$){super(),this.obsoleteFile=j,this.extensionsProfileScannerService=M,this.uriIdentityService=F,this.fileService=z,this.logService=$}async scanExtensions(j){const M=j.profile?await this.scanExtensionsFromProfile(j):await this.scanExtensionsFromLocation(j);let F={};if(j.excludeObsolete&&j.type===1)try{const z=(await this.fileService.readFile(this.obsoleteFile)).value.toString();F=JSON.parse(z)}catch{}return(0,S.isEmptyObject)(F)?M:M.filter(z=>!F[u.ExtensionKey.create(z).toString()])}async scanExtensionsFromLocation(j){const M=await this.fileService.resolve(j.location);if(!M.children?.length)return[];const F=await Promise.all(M.children.map(async z=>{if(!z.isDirectory||j.type===1&&(0,v.basename)(z.resource).indexOf(".")===0)return null;const $=new se(z.resource,j.mtime,j.applicationExtensionslocation,j.applicationExtensionslocationMtime,j.profile,j.type,j.excludeObsolete,j.validate,j.productVersion,j.productDate,j.productCommit,j.devMode,j.language,j.translations);return this.scanExtension($)}));return(0,R.coalesce)(F).sort((z,$)=>z.location.path<$.location.path?-1:1)}async scanExtensionsFromProfile(j){let M=await this.scanExtensionsFromProfileResource(j.location,()=>!0,j);if(j.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(j.location,j.applicationExtensionslocation)){M=M.filter(z=>!z.metadata?.isApplicationScoped);const F=await this.scanExtensionsFromProfileResource(j.applicationExtensionslocation,z=>!!z.metadata?.isApplicationScoped,j);M.push(...F)}return M}async scanExtensionsFromProfileResource(j,M,F){const z=await this.extensionsProfileScannerService.scanProfileExtensions(j);if(!z.length)return[];const $=await Promise.all(z.map(async Y=>{if(M(Y)){const A=new se(Y.location,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(A,Y.metadata)}return null}));return(0,R.coalesce)($)}async scanOneOrMultipleExtensions(j){try{if(await this.fileService.exists((0,v.joinPath)(j.location,"package.json"))){const M=await this.scanExtension(j);return M?[M]:[]}else return await this.scanExtensions(j)}catch(M){return this.logService.error(`Error scanning extensions at ${j.location.path}:`,(0,O.getErrorMessage)(M)),[]}}async scanExtension(j,M){try{let F=await this.scanExtensionManifest(j.location);if(F){F.publisher||(F.publisher=s.UNDEFINED_PUBLISHER),M=M??F.__metadata,delete F.__metadata;const z=(0,u.getGalleryExtensionId)(F.publisher,F.name),$=M?.id?{id:z,uuid:M.id}:{id:z},Y=M?.isSystem?0:j.type,A=Y===0||!!M?.isBuiltin;F=await this.translateManifest(j.location,F,se.createNlsConfiguration(j));const x={type:Y,identifier:$,manifest:F,location:j.location,isBuiltin:A,targetPlatform:M?.targetPlatform??"undefined",metadata:M,isValid:!0,validations:[]};return j.validate?this.validate(x,j):x}}catch(F){j.type!==0&&this.logService.error(F)}return null}validate(j,M){let F=!0;const z=(0,t.validateExtensionManifest)(M.productVersion,M.productDate,M.location,j.manifest,j.isBuiltin);for(const[$,Y]of z)$===E.default.Error&&(F=!1,this.logService.error(this.formatMessage(M.location,Y)));return j.isValid=F,j.validations=z,j}async scanExtensionManifest(j){const M=(0,v.joinPath)(j,"package.json");let F;try{F=(await this.fileService.readFile(M)).value.toString()}catch($){return(0,n.toFileOperationResult)($)!==1&&this.logService.error(this.formatMessage(j,(0,g.localize)(0,null,M.path,$.message))),null}let z;try{z=JSON.parse(F)}catch{const Y=[];(0,y.parse)(F,Y);for(const A of Y)this.logService.error(this.formatMessage(j,(0,g.localize)(1,null,M.path,A.offset,A.length,(0,d.getParseErrorMessage)(A.error))));return null}return(0,y.getNodeType)(z)!=="object"?(this.logService.error(this.formatMessage(j,(0,g.localize)(2,null,M.path))),null):z}async translateManifest(j,M,F){const z=await this.getLocalizedMessages(j,M,F);if(z)try{const $=[],Y=await this.resolveOriginalMessageBundle(z.default,$);if($.length>0)return $.forEach(x=>{this.logService.error(this.formatMessage(j,(0,g.localize)(3,null,z.default?.path,(0,d.getParseErrorMessage)(x.error))))}),M;if((0,y.getNodeType)(z)!=="object")return this.logService.error(this.formatMessage(j,(0,g.localize)(4,null,z.default?.path))),M;const A=z.values||Object.create(null);return(0,B.localizeManifest)(M,A,Y)}catch{}return M}async getLocalizedMessages(j,M,F){const z=(0,v.joinPath)(j,"package.nls.json"),$=(L,T)=>{T.forEach(U=>{this.logService.error(this.formatMessage(j,(0,g.localize)(5,null,L?.path,(0,d.getParseErrorMessage)(U.error))))})},Y=L=>{this.logService.error(this.formatMessage(j,(0,g.localize)(6,null,L?.path)))},A=`${M.publisher}.${M.name}`,x=F.translations[A];if(x)try{const L=l.URI.file(x),T=(await this.fileService.readFile(L)).value.toString(),U=[],W=(0,y.parse)(T,U);return U.length>0?($(L,U),{values:void 0,default:z}):(0,y.getNodeType)(W)!=="object"?(Y(L),{values:void 0,default:z}):{values:W.contents?W.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.fileService.exists(z))return;let T;try{T=await this.findMessageBundles(j,F)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const U=(await this.fileService.readFile(T.localized)).value.toString(),W=[],q=(0,y.parse)(U,W);return W.length>0?($(T.localized,W),{values:void 0,default:T.original}):(0,y.getNodeType)(q)!=="object"?(Y(T.localized),{values:void 0,default:T.original}):{values:q,default:T.original}}catch{return{values:void 0,default:T.original}}}}async resolveOriginalMessageBundle(j,M){if(j)try{const F=(await this.fileService.readFile(j)).value.toString();return(0,y.parse)(F,M)}catch{}}findMessageBundles(j,M){return new Promise((F,z)=>{const $=Y=>{const A=(0,v.joinPath)(j,`package.nls.${Y}.json`);this.fileService.exists(A).then(x=>{x&&F({localized:A,original:(0,v.joinPath)(j,"package.nls.json")});const L=Y.lastIndexOf("-");L===-1?F({localized:(0,v.joinPath)(j,"package.nls.json"),original:null}):(Y=Y.substring(0,L),$(Y))})};if(M.devMode||M.pseudo||!M.language)return F({localized:(0,v.joinPath)(j,"package.nls.json"),original:null});$(M.language)})}formatMessage(j,M){return`[${j.path}]: ${M}`}};ne=de([ee(1,h.IExtensionsProfileScannerService),ee(2,N.IUriIdentityService),ee(3,n.IFileService),ee(4,r.ILogService)],ne);let re=class extends ne{constructor(j,M,F,z,$,Y){super(M,F,z,$,Y),this.cacheFile=j,this.cacheValidatorThrottler=this._register(new C.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(j){const M=await this.readExtensionCache();if(this.input=j,M&&M.input&&se.equals(M.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),M.result.map(z=>(z.location=l.URI.revive(z.location),z));const F=await super.scanExtensions(j);return await this.writeExtensionCache({input:j,result:F}),F}async readExtensionCache(){try{const j=await this.fileService.readFile(this.cacheFile),M=JSON.parse(j.value.toString());return{result:M.result,input:(0,a.revive)(M.input)}}catch(j){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(j))}return null}async writeExtensionCache(j){try{await this.fileService.writeFile(this.cacheFile,k.VSBuffer.fromString(JSON.stringify(j)))}catch(M){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,O.getErrorMessage)(M))}}async validateCache(){if(!this.input)return;const j=await this.readExtensionCache();if(!j)return;const M=j.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!I.equals(F,M))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(z){this.logService.error(z)}}};re=de([ee(2,h.IExtensionsProfileScannerService),ee(3,N.IUriIdentityService),ee(4,n.IFileService),ee(5,r.ILogService)],re);function ge(ie,j){const M=(0,u.getExtensionId)(ie.manifest.publisher,ie.manifest.name);return{id:M,identifier:new s.ExtensionIdentifier(M),isBuiltin:ie.type===0,isUserBuiltin:ie.type===1&&ie.isBuiltin,isUnderDevelopment:j,extensionLocation:ie.location,uuid:ie.identifier.uuid,targetPlatform:ie.targetPlatform,...ie.manifest}}e.toExtensionDescription=ge;class ce extends J{constructor(j,M,F,z,$,Y,A,x,L,T,U){super(j,M,(0,v.joinPath)(F,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(z,s.MANIFEST_CACHE_FOLDER),$,Y,A,x,L,T,U),this.translationsPromise=(async()=>{if(m.translationsConfigFile)try{const W=await this.fileService.readFile(l.URI.file(m.translationsConfigFile));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}getTranslations(j){return this.translationsPromise}}e.NativeExtensionsScannerService=ce}),define(Q[142],Z([0,1,57,3,31,4,2,16,14,20,9,25]),function(_,e,R,C,I,k,O,y,d,f,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=class extends O.Disposable{constructor(p,E){super(),this.userDataProfilesService=p,this.logService=E,this.processesLimiter=new C.Limiter(5)}async postUninstall(p){const E=this.parseScript(p,"uninstall");return E&&(this.logService.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(E.script,"uninstall",E.args,!0,p).then(()=>this.logService.info(p.identifier.id,p.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(p.identifier.id,p.manifest.version,`Failed to run post uninstall script: ${S}`)))),f.Promises.rm(this.getExtensionStoragePath(p)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(p,E){const S=`vscode:${E}`;if(p.location.scheme===y.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[S]=="string"){const l=p.manifest.scripts[S].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(p.identifier.id,p.manifest.version,`${S} should be a node script`),null):{script:(0,d.join)(p.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(p,E,S,l,g){return new Promise((w,u)=>{const s=this.start(p,E,S,g);let t;const n=i=>{t&&(clearTimeout(t),t=null),i?u(i):w(void 0)};s.on("error",i=>{n((0,I.toErrorMessage)(i)||"Unknown")}),s.on("exit",(i,r)=>{n(i?`post-${E} process exited with code ${i}`:void 0)}),l&&(t=setTimeout(()=>{t=null,s.kill(),u("timed out")},5e3))})}start(p,E,S,l){const g={silent:!0,execArgv:void 0},w=(0,R.fork)(p,[`--type=extension-post-${E}`,...S],g);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const u=k.Event.fromNodeEventEmitter(w.stdout,"data"),s=k.Event.fromNodeEventEmitter(w.stderr,"data");u(i=>this.logService.info(l.identifier.id,l.manifest.version,`post-${E}`,i)),s(i=>this.logService.error(l.identifier.id,l.manifest.version,`post-${E}`,i));const t=k.Event.any(k.Event.map(u,i=>({data:`%c${i}`,format:[""]})),k.Event.map(s,i=>({data:`%c${i}`,format:["color: red"]})));return k.Event.debounce(t,(i,r)=>i?{data:i.data+r.data,format:[...i.format,...r.format]}:{data:r.data,format:r.format},100)(i=>{console.group(l.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),w}getExtensionStoragePath(p){return(0,d.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};m=de([ee(0,b.IUserDataProfilesService),ee(1,P.ILogService)],m),e.ExtensionsLifecycle=m}),define(Q[143],Z([0,1,10,17,41,48,13,8,9,28,25]),function(_,e,R,C,I,k,O,y,d,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends k.NativeExtensionsScannerService{constructor(v,p,E,S,l,g,w){super(R.URI.file(l.builtinExtensionsPath),R.URI.file(l.extensionsPath),l.userHome,R.URI.file(l.userDataPath),v,p,E,S,l,g,w)}};b=de([ee(0,P.IUserDataProfilesService),ee(1,I.IExtensionsProfileScannerService),ee(2,O.IFileService),ee(3,d.ILogService),ee(4,C.INativeEnvironmentService),ee(5,f.IProductService),ee(6,y.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(Q[144],Z([0,1,3,4,2,114,5,80,8,25]),function(_,e,R,C,I,k,O,y,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,d.createDecorator)("storageService");var P;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));function v(g){const w=g.get(e.TARGET_KEY);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.loadKeyTargets=v;class p extends I.Disposable{constructor(w={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super(),this.options=w,this._onDidChangeValue=this._register(new C.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new C.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new C.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new I.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,I.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,k.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(w,u){if(u===e.TARGET_KEY){switch(w){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:w})}else this._onDidChangeValue.fire({scope:w,key:u,target:this.getKeyTargets(w)[u]})}emitWillSaveState(w){this._onWillSaveState.fire({reason:w})}get(w,u,s){return this.getStorage(u)?.get(w,s)}getBoolean(w,u,s){return this.getStorage(u)?.getBoolean(w,s)}getNumber(w,u,s){return this.getStorage(u)?.getNumber(w,s)}store(w,u,s,t){if((0,O.isUndefinedOrNull)(u)){this.remove(w,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(w,s,t),this.getStorage(s)?.set(w,u)})}remove(w,u){this.withPausedEmitters(()=>{this.updateKeyTarget(w,u,void 0),this.getStorage(u)?.delete(w)})}withPausedEmitters(w){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{w()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(w,u){const s=[],t=this.getKeyTargets(w);for(const n of Object.keys(t))t[n]===u&&s.push(n);return s}updateKeyTarget(w,u,s){const t=this.getKeyTargets(u);typeof s=="number"?t[w]!==s&&(t[w]=s,this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[w]=="number"&&(delete t[w],this.getStorage(u)?.set(e.TARGET_KEY,JSON.stringify(t)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(w){switch(w){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(w){const u=this.getStorage(w);return u?v(u):Object.create(null)}isNew(w){return this.getBoolean(e.IS_NEW_KEY,w)===!0}async flush(w=P.NONE){this._onWillSaveState.fire({reason:w});const u=this.getStorage(-1),s=this.getStorage(0),t=this.getStorage(1);switch(w){case P.NONE:await R.Promises.settled([u?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await R.Promises.settled([u?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.getStorage(-1)?.items??new Map,u=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return l(w,u,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(w,u){return this.emitWillSaveState(P.NONE),(0,f.isUserDataProfile)(w)?this.switchToProfile(w,u):this.switchToWorkspace(w,u)}canSwitchProfile(w,u){return!(w.id===u.id||E(u)&&E(w))}switchData(w,u,s,t){this.withPausedEmitters(()=>{if(t)for(const[n,i]of w)u.set(n,i);else{const n=new Set;for(const[i,r]of w)n.add(i),u.get(i)!==r&&this.emitDidChangeValue(s,i);for(const[i]of u.items)n.has(i)||this.emitDidChangeValue(s,i)}})}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;function E(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class S extends p{constructor(){super(),this.applicationStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.profileStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new y.Storage(new y.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(w=>this.emitDidChangeValue(1,w))),this._register(this.profileStorage.onDidChangeStorage(w=>this.emitDidChangeValue(0,w))),this._register(this.applicationStorage.onDidChangeStorage(w=>this.emitDidChangeValue(-1,w)))}getStorage(w){switch(w){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}hasScope(w){return!1}}e.InMemoryStorageService=S;async function l(g,w,u,s,t,n){const i=X=>{try{return JSON.parse(X)}catch{return X}},r=new Map,o=new Map;g.forEach((X,J)=>{r.set(J,X),o.set(J,i(X))});const c=new Map,a=new Map;w.forEach((X,J)=>{c.set(J,X),a.set(J,i(X))});const h=new Map,D=new Map;u.forEach((X,J)=>{h.set(J,X),D.set(J,i(X))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const N=[];if(r.forEach((X,J)=>{N.push({key:J,value:X})}),console.table(N),console.groupEnd(),console.log(o),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const X=[];c.forEach((J,se)=>{X.push({key:se,value:J})}),console.table(X),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${n})`);const B=[];h.forEach((X,J)=>{B.push({key:J,value:X})}),console.table(B),console.groupEnd(),console.log(D)}e.logStorage=l}),define(Q[145],Z([0,1,19,24,11,12,32,5,10,21,17,22,23,45,13,9,28,47,132,144,35]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l,g,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const s=k.isWeb?"web":(0,b.getTargetPlatform)(k.platform,O.arch);var t;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...L){return String(L.reduce((T,U)=>T|U,0))}var i;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class h{constructor(T=a){this.state=T}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}get criteria(){return this.state.criteria}withPage(T,U=this.state.pageSize){return new h({...this.state,pageNumber:T,pageSize:U})}withFilter(T,...U){const W=[...this.state.criteria,...U.length?U.map(q=>({filterType:T,value:q})):[{filterType:T}]];return new h({...this.state,criteria:W})}withSortBy(T){return new h({...this.state,sortBy:T})}withSortOrder(T){return new h({...this.state,sortOrder:T})}withFlags(...T){return new h({...this.state,flags:T.reduce((U,W)=>U|W,0)})}withAssetTypes(...T){return new h({...this.state,assetTypes:T})}withSource(T){return new h({...this.state,source:T})}get raw(){const{criteria:T,pageNumber:U,pageSize:W,sortBy:q,sortOrder:H,flags:oe,assetTypes:ue}=this.state;return{filters:[{criteria:T,pageNumber:U,pageSize:W,sortBy:q,sortOrder:H}],assetTypes:ue,flags:oe}}get searchText(){const T=this.state.criteria.filter(U=>U.filterType===i.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(T=>String(T.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function D(L,T){const U=(L||[]).filter(W=>W.statisticName===T)[0];return U?U.value:0}function N(L){const T="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(W=>W.assetType.indexOf(T)===0).reduce((W,q)=>{const H=J(L,q.assetType);return H&&W.push([q.assetType.substring(T.length),H]),W},[])}function B(L){if(L.properties){const T=L.properties.filter(q=>q.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=T.filter(q=>U.test(q.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return J(L,r.Repository)}function X(L){return{uri:`${L.fallbackAssetUri}/${r.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${r.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function J(L,T){return L.files.filter(W=>W.assetType===T)[0]?{uri:`${L.assetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function se(L,T){const U=L.properties?L.properties.filter(q=>q.key===T):[],W=U.length>0&&U[0].value;return W?W.split(",").map(q=>(0,m.adoptToGalleryExtensionId)(q)):[]}function ne(L){const T=L.properties?L.properties.filter(U=>U.key===o.Engine):[];return T.length>0&&T[0].value||""}function re(L){const T=L.properties?L.properties.filter(U=>U.key===o.PreRelease):[];return T.length>0&&T[0].value==="true"}function ge(L){const T=L.properties?L.properties.filter(W=>W.key===o.LocalizedLanguages):[],U=T.length>0&&T[0].value||"";return U?U.split(","):[]}function ce(L){return L.properties?.find(T=>T.key===o.SponsorLink)?.value}function ie(L){return L.indexOf("preview")!==-1}function j(L){return L.targetPlatform?(0,b.toTargetPlatform)(L.targetPlatform):"undefined"}function M(L){const T=(0,R.distinct)(L.versions.map(j)),U=!!L.tags?.includes(b.WEB_EXTENSION_TAG),W=T.indexOf("web");return U?W===-1&&T.push("web"):W!==-1&&T.splice(W,1),T}function F(L,T){const U=(0,b.getFallbackTargetPlarforms)(T);for(let W=0;W<L.length;W++){const q=L[W];if(q.version===L[W-1]?.version){let H=W;const oe=j(q);if(oe===T)for(;H>0&&L[H-1].version===q.version;)H--;else if(U.includes(oe))for(;H>0&&L[H-1].version===q.version&&j(L[H-1])!==T;)H--;H!==W&&(L.splice(W,1),L.splice(H,0,q))}}return L}e.sortExtensionVersions=F;function z(L,T,U){L.telemetryData={index:T,querySource:U}}function $(L,T,U){const W=L.versions[0],q={manifest:J(T,r.Manifest),readme:J(T,r.Details),changelog:J(T,r.Changelog),license:J(T,r.License),repository:B(T),download:X(T),icon:J(T,r.Icon),signature:J(T,r.Signature),coreTranslations:N(T)};return{identifier:{id:(0,m.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:T.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:ce(W),description:L.shortDescription||"",installCount:D(L.statistics,"install"),rating:D(L.statistics,"averagerating"),ratingCount:D(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:U,assets:q,properties:{dependencies:se(T,o.Dependency),extensionPack:se(T,o.ExtensionPack),engine:ne(T),localizedLanguages:ge(T),targetPlatform:j(T),isPreReleaseVersion:re(T)},hasPreReleaseVersion:re(W),hasReleaseVersion:!0,preview:ie(L.flags),isSigned:!!q.signature}}let Y=class{constructor(T,U,W,q,H,oe,ue,ve){this.requestService=U,this.logService=W,this.environmentService=q,this.telemetryService=H,this.fileService=oe,this.productService=ue,this.configurationService=ve;const Se=ue.extensionsGallery,le=Se?.servicePPEUrl&&ve.getValue("_extensionsGallery.enablePPE");this.extensionsGalleryUrl=le?Se.servicePPEUrl:Se?.serviceUrl,this.extensionsGallerySearchUrl=le?void 0:Se?.searchUrl,this.extensionsControlUrl=Se?.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(ue.version,ue,this.environmentService,this.configurationService,this.fileService,T,this.telemetryService)}api(T=""){return`${this.extensionsGalleryUrl}${T}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(T,U,W){const q=C.CancellationToken.isCancellationToken(U)?{}:U,H=C.CancellationToken.isCancellationToken(U)?U:W,oe=[],ue=[],ve=[],Se=[];let le=!0;for(const ae of T){ae.uuid?ue.push(ae.uuid):oe.push(ae.id);const pe=!!(ae.version||ae.preRelease);ve.push({id:ae.id,uuid:ae.uuid,includePreRelease:pe}),ae.version&&Se.push({id:ae.id,uuid:ae.uuid,version:ae.version}),le=le&&!!ae.hasPreRelease&&!pe}if(!ue.length&&!oe.length)return[];let te=new h().withPage(1,T.length);ue.length&&(te=te.withFilter(i.ExtensionId,...ue)),oe.length&&(te=te.withFilter(i.ExtensionName,...oe)),(q.queryAllVersions||le)&&(te=te.withFlags(te.flags,t.IncludeVersions)),q.source&&(te=te.withSource(q.source));const{extensions:fe}=await this.queryGalleryExtensions(te,{targetPlatform:q.targetPlatform??s,includePreRelease:ve,versions:Se,compatible:!!q.compatible},H);return q.source&&fe.forEach((ae,pe)=>z(ae,pe,q.source)),fe}async getCompatibleExtension(T,U,W){if((0,b.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(T,U,W))return T;const q=new h().withFlags(t.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,T.identifier.uuid),{extensions:H}=await this.queryGalleryExtensions(q,{targetPlatform:W,compatible:!0,includePreRelease:U},C.CancellationToken.None);return H[0]||null}async isExtensionCompatible(T,U,W){if(!(0,b.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,W)||!U&&T.properties.isPreReleaseVersion)return!1;let q=T.properties.engine;if(!q){const H=await this.getManifest(T,C.CancellationToken.None);if(!H)throw new Error("Manifest was not found");q=H.engines.vscode}return(0,v.isEngineValid)(q,this.productService.version,this.productService.date)}async isValidVersion(T,U,W,q,H){if(!(0,b.isTargetPlatformCompatible)(j(T),q,H)||U!=="any"&&re(T)!==(U==="prerelease"))return!1;if(W)try{const oe=await this.getEngine(T);if(!(0,v.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}catch(oe){return this.logService.error(`Error while getting the engine for the version ${T.version}.`,(0,I.getErrorMessage)(oe)),!1}return!0}async query(T,U){let W=T.text||"";const q=T.pageSize??50;let H=new h().withPage(1,q);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,te,fe)=>(H=H.withFilter(i.Category,fe||te),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,te,fe)=>(H=H.withFilter(i.Tag,fe||te),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(i.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),H=H.withFilter(i.SearchText,W)),H=H.withSortBy(0)):T.ids?H=H.withFilter(i.ExtensionId,...T.ids):T.names?H=H.withFilter(i.ExtensionName,...T.names):H=H.withSortBy(4),typeof T.sortBy=="number"&&(H=H.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(H=H.withSortOrder(T.sortOrder)),T.source&&(H=H.withSource(T.source));const oe=async(le,te)=>{const{extensions:fe,total:ae}=await this.queryGalleryExtensions(le,{targetPlatform:s,compatible:!1,includePreRelease:!!T.includePreRelease},te);return fe.forEach((pe,Fe)=>z(pe,(le.pageNumber-1)*le.pageSize+Fe,T.source)),{extensions:fe,total:ae}},{extensions:ue,total:ve}=await oe(H,U),Se=async(le,te)=>{if(te.isCancellationRequested)throw new I.CancellationError;const{extensions:fe}=await oe(H.withPage(le+1),te);return fe};return{firstPage:ue,total:ve,pageSize:H.pageSize,getPage:Se}}async queryGalleryExtensions(T,U,W){const q=T.flags;!!(T.flags&t.IncludeLatestVersionOnly)&&!!(T.flags&t.IncludeVersions)&&(T=T.withFlags(T.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(T.flags&t.IncludeLatestVersionOnly)&&!(T.flags&t.IncludeVersions)&&(T=T.withFlags(T.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(T=T.withFlags(T.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),T=T.withFlags(T.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:H,total:oe}=await this.queryRawGalleryExtensions(T,W);if(!(T.flags&t.IncludeLatestVersionOnly)){const le=[];for(const te of H){const fe=await this.toGalleryExtensionWithCriteria(te,U);fe&&le.push(fe)}return{extensions:le,total:oe}}const ve=[],Se=new Map;for(let le=0;le<H.length;le++){const te=H[le],fe={id:(0,m.getGalleryExtensionId)(te.publisher.publisherName,te.extensionName),uuid:te.extensionId},ae=(0,y.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Fe=>(0,m.areSameExtensions)(Fe,fe))?.includePreRelease;if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(M(te),U.targetPlatform))continue;const pe=await this.toGalleryExtensionWithCriteria(te,U);!pe||pe.properties.isPreReleaseVersion&&(!ae||!pe.hasReleaseVersion)||!pe.properties.isPreReleaseVersion&&pe.properties.targetPlatform!==U.targetPlatform&&pe.hasPreReleaseVersion?Se.set(te.extensionId,le):ve.push([le,pe])}if(Se.size){const le=new Date().getTime(),te=new h().withFlags(q&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,Se.size).withFilter(i.ExtensionId,...Se.keys()),{extensions:fe}=await this.queryGalleryExtensions(te,U,W);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-le,count:Se.size});for(const ae of fe){const pe=Se.get(ae.identifier.uuid);ve.push([pe,ae])}}return{extensions:ve.sort((le,te)=>le[0]-te[0]).map(([,le])=>le),total:oe}}async toGalleryExtensionWithCriteria(T,U){const W={id:(0,m.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},q=U.versions?.find(ve=>(0,m.areSameExtensions)(ve,W))?.version,H=(0,y.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ve=>(0,m.areSameExtensions)(ve,W))?.includePreRelease,oe=M(T),ue=F(T.versions,U.targetPlatform);if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(oe,U.targetPlatform))return null;for(let ve=0;ve<ue.length;ve++){const Se=ue[ve];if(!(q&&Se.version!==q)){if(await this.isValidVersion(Se,H?"any":"release",U.compatible,oe,U.targetPlatform))return $(T,Se,oe);if(q&&Se.version===q)return null}}return q||U.compatible?null:$(T,T.versions[0],oe)}async queryRawGalleryExtensions(T,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,t.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(t.Unpublished));const W=await this.commonHeadersPromise,q=JSON.stringify(T.raw),H={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},oe=new Date().getTime();let ue,ve,Se=0;try{if(ue=await this.requestService.request({type:"POST",url:this.extensionsGallerySearchUrl&&T.criteria.some(te=>te.filterType===i.SearchText)?this.extensionsGallerySearchUrl:this.api("/extensionquery"),data:q,headers:H},U),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:Se};const le=await(0,l.asJson)(ue);if(le){const te=le.results[0],fe=te.extensions,ae=te.resultMetadata&&te.resultMetadata.filter(pe=>pe.metadataType==="ResultCount")[0];return Se=ae&&ae.metadataItems.filter(pe=>pe.name==="TotalCount")[0].count||0,{galleryExtensions:fe,total:Se}}return{galleryExtensions:[],total:Se}}catch(le){throw ve=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(q.length),duration:new Date().getTime()-oe,success:!!ue&&(0,l.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:ve?(0,I.isCancellationError)(ve)?"canceled":(0,I.getErrorMessage)(ve).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Se)})}}async reportStatistic(T,U,W,q){if(!this.isEnabled())return;const H=k.isWeb?this.api(`/itemName/${T}.${U}/version/${W}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${T}/extensions/${U}/${W}/stats?statType=${q}`),oe=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ve={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:H,headers:ve},C.CancellationToken.None)}catch{}}async download(T,U,W){this.logService.trace("ExtensionGalleryService#download",T.identifier.id);const q=(0,m.getGalleryExtensionTelemetryData)(T),H=new Date().getTime(),oe=le=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...q,duration:le}),ue=W===2?"install":W===3?"update":"",ve=ue?{uri:`${T.assets.download.uri}${d.URI.parse(T.assets.download.uri).query?"&":"?"}${ue}=true`,fallbackUri:`${T.assets.download.fallbackUri}${d.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${ue}=true`}:T.assets.download,Se=await this.getAsset(ve);await this.fileService.writeFile(U,Se.stream),oe(new Date().getTime()-H)}async downloadSignatureArchive(T,U){if(!T.assets.signature)throw new Error("No signature asset found");this.logService.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const W=await this.getAsset(T.assets.signature);await this.fileService.writeFile(U,W.stream)}async getReadme(T,U){if(T.assets.readme){const W=await this.getAsset(T.assets.readme,{},U);return await(0,l.asTextOrError)(W)||""}return""}async getManifest(T,U){if(T.assets.manifest){const W=await this.getAsset(T.assets.manifest,{},U),q=await(0,l.asTextOrError)(W);return q?JSON.parse(q):null}return null}async getManifestFromRawExtensionVersion(T,U){const W=J(T,r.Manifest);if(!W)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},H=await this.getAsset(W,{headers:q});return await(0,l.asJson)(H)}async getCoreTranslation(T,U){const W=T.assets.coreTranslations.filter(q=>q[0]===U.toUpperCase())[0];if(W){const q=await this.getAsset(W[1]),H=await(0,l.asTextOrError)(q);return H?JSON.parse(H):null}return null}async getChangelog(T,U){if(T.assets.changelog){const W=await this.getAsset(T.assets.changelog,{},U);return await(0,l.asTextOrError)(W)||""}return""}async getAllCompatibleVersions(T,U,W){let q=new h().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?q=q.withFilter(i.ExtensionId,T.identifier.uuid):q=q.withFilter(i.ExtensionName,T.identifier.id);const{galleryExtensions:H}=await this.queryRawGalleryExtensions(q,C.CancellationToken.None);if(!H.length)return[];const oe=M(H[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(oe,W))return[];const ue=[];await Promise.all(H[0].versions.map(async le=>{try{await this.isValidVersion(le,U?"any":"release",!0,oe,W)&&ue.push(le)}catch{}}));const ve=[],Se=new Set;for(const le of F(ue,W))Se.has(le.version)||(Se.add(le.version),ve.push({version:le.version,date:le.lastUpdated,isPreReleaseVersion:re(le)}));return ve}async getAsset(T,U={},W=C.CancellationToken.None){const q=await this.commonHeadersPromise,H={type:"GET"},oe={...q,...U.headers||{}};U={...U,...H,headers:oe};const ue=T.uri,ve=T.fallbackUri,Se={...U,url:ue};try{const le=await this.requestService.request(Se,W);if(le.res.statusCode===200)return le;const te=await(0,l.asTextOrError)(le);throw new Error(`Expected 200, got back ${le.res.statusCode} instead.

${te}`)}catch(le){if((0,I.isCancellationError)(le))throw le;const te=(0,I.getErrorMessage)(le);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ue,message:te});const fe={...U,url:ve};return this.requestService.request(fe,W)}}async getEngine(T){let U=ne(T);if(!U){const W=await this.getManifestFromRawExtensionVersion(T,C.CancellationToken.None);if(!W)throw new Error("Manifest was not found");U=W.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const T=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},C.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(T),W=[],q={};if(U){for(const H of U.malicious)W.push({id:H});if(U.migrateToPreRelease)for(const[H,oe]of Object.entries(U.migrateToPreRelease))(!oe.engine||(0,v.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(q[H.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[H,oe]of Object.entries(U.deprecated))oe&&(q[H.toLowerCase()]=(0,y.isBoolean)(oe)?{}:oe)}return{malicious:W,deprecated:q}}};Y=de([ee(1,l.IRequestService),ee(2,E.ILogService),ee(3,P.IEnvironmentService),ee(4,u.ITelemetryService),ee(5,p.IFileService),ee(6,S.IProductService),ee(7,f.IConfigurationService)],Y);let A=class extends Y{constructor(T,U,W,q,H,oe,ue,ve){super(T,U,W,q,H,oe,ue,ve)}};A=de([ee(0,w.IStorageService),ee(1,l.IRequestService),ee(2,E.ILogService),ee(3,P.IEnvironmentService),ee(4,u.ITelemetryService),ee(5,p.IFileService),ee(6,S.IProductService),ee(7,f.IConfigurationService)],A),e.ExtensionGalleryService=A;let x=class extends Y{constructor(T,U,W,q,H,oe,ue){super(void 0,T,U,W,q,H,oe,ue)}};x=de([ee(0,l.IRequestService),ee(1,E.ILogService),ee(2,P.IEnvironmentService),ee(3,u.ITelemetryService),ee(4,p.IFileService),ee(5,S.IProductService),ee(6,f.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(Q[146],Z([0,1,44,17,13,9,66,29,25]),function(_,e,R,C,I,k,O,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let f=class We extends d.UserDataProfilesService{constructor(b,m,v,p,E){super(v,p,m,E),this.stateService=b}getStoredProfiles(){return(0,R.revive)(this.stateService.getItem(We.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,R.revive)(this.stateService.getItem(We.PROFILE_ASSOCIATIONS_KEY,{}))}};f=de([ee(0,O.IStateService),ee(1,y.IUriIdentityService),ee(2,C.IEnvironmentService),ee(3,I.IFileService),ee(4,k.ILogService)],f),e.UserDataProfilesService=f}),define(Q[147],Z([0,1,36,3,160,2]),function(_,e,R,C,I,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class O extends R.AbstractPolicyService{constructor(d){super(),this.productName=d,this.throttler=new C.Throttler,this.watcher=this._register(new k.MutableDisposable)}async initializePolicies(d){await this.throttler.queue(()=>new Promise((f,P)=>{try{this.watcher.value=(0,I.createWatcher)(this.productName,d,b=>{for(const m in b){const v=b[m];v===void 0?this.policies.delete(m):this.policies.set(m,v)}this._onDidChange.fire(Object.keys(b)),f()})}catch(b){P(b)}}))}}e.NativePolicyService=O}),define(Q[68],Z([0,1,116,3,14,5,20,81,161,162]),function(_,e,R,C,I,k,O,y,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(t,n){let i=n.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=n}}e.ExtractError=P;function b(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>t&n).reduce((n,i)=>n+i,t&61440)}function m(s){if(s instanceof P)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new P(t,s)}function v(s,t,n,i,r,o){const c=I.dirname(t),a=I.join(i,c);if(!a.startsWith(i))return Promise.reject(new Error(y.localize(0,null,t)));const h=I.join(i,t);let D;return o.onCancellationRequested(()=>{D?.destroy()}),Promise.resolve(O.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((N,B)=>{if(!o.isCancellationRequested)try{D=(0,R.createWriteStream)(h,{mode:n}),D.once("close",()=>N()),D.once("error",B),s.once("error",B),s.pipe(D)}catch(X){B(X)}}))}function p(s,t,n,i){let r=(0,C.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((c,a)=>{const h=new C.Sequencer,D=N=>{N.isCancellationRequested||(o++,s.readEntry())};s.once("error",a),s.once("close",()=>r.then(()=>{i.isCancellationRequested||s.entryCount===o?c():a(new P("Incomplete",new Error(y.localize(1,null,o,s.entryCount))))},a)),s.readEntry(),s.on("entry",N=>{if(i.isCancellationRequested)return;if(!n.sourcePathRegex.test(N.fileName)){D(i);return}const B=N.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(B)){const se=I.join(t,B);r=(0,C.createCancelablePromise)(ne=>O.Promises.mkdir(se,{recursive:!0}).then(()=>D(ne)).then(void 0,a));return}const X=S(s,N),J=b(N);r=(0,C.createCancelablePromise)(se=>h.queue(()=>X.then(ne=>v(ne,B,J,t,n,se).then(()=>D(se)))).then(null,a))})})}function E(s,t=!1){return new Promise((n,i)=>{(0,d.open)(s,t?{lazyEntries:!0}:void 0,(r,o)=>{r?i(m(r)):n((0,k.assertIsDefined)(o))})})}function S(s,t){return new Promise((n,i)=>{s.openReadStream(t,(r,o)=>{r?i(m(r)):n((0,k.assertIsDefined)(o))})})}function l(s,t){return new Promise((n,i)=>{const r=new f.ZipFile;t.forEach(c=>{c.contents?r.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&r.addFile(c.localPath,c.path)}),r.end();const o=(0,R.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>n(s))})}e.zip=l;function g(s,t,n={},i){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=E(s,!0);return n.overwrite&&(o=o.then(c=>O.Promises.rm(t).then(()=>c))),o.then(c=>p(c,t,{sourcePathRegex:r},i))}e.extract=g;function w(s,t){return E(s).then(n=>new Promise((i,r)=>{n.on("entry",o=>{o.fileName===t&&S(n,o).then(c=>i(c),c=>r(c))}),n.once("close",()=>r(new Error(y.localize(2,null,t))))}))}function u(s,t){return w(s,t).then(n=>new Promise((i,r)=>{const o=[];n.once("error",r),n.on("data",c=>o.push(c)),n.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=u}),define(Q[148],Z([0,1,68,89]),function(_,e,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function I(k){return(0,R.buffer)(k,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}e.getManifest=I}),define(Q[149],Z([0,1,3,31,11,2,16,14,12,18,38,5,10,30,20,68,88,58,17,141,22,23,41,48,124,142,148,125,138,34,45,13,8,9,28,35,29,25]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l,g,w,u,s,t,n,i,r,o,c,a,h,D,N,B,X,J,se,ne,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,B.refineServiceDecorator)(u.IExtensionManagementService);let ge=class extends w.AbstractExtensionManagementService{constructor(A,x,L,T,U,W,q,H,oe,ue,ve,Se){super(A,x,L,ue,Se),this.extensionsScannerService=U,this.extensionsProfileScannerService=W,this.downloadService=q,this.fileService=oe,this.installGalleryExtensionsTasks=new Map;const le=this._register(H.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(H.createInstance(ce,fe=>le.postUninstall(fe))),this.manifestCache=this._register(new c.ExtensionsManifestCache(T,this)),this.extensionsDownloader=this._register(H.createInstance(i.ExtensionsDownloader));const te=this._register(new a.ExtensionsWatcher(this,oe,T,L,ve));this._register(te.onDidChangeExtensionsByAnotherSource(({added:fe,removed:ae})=>{fe.length&&this._onDidInstallExtensions.fire(fe.map(pe=>({identifier:pe.identifier,operation:1,local:pe}))),ae.forEach(pe=>this._onDidUninstallExtension.fire({identifier:pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(A){this.logService.trace("ExtensionManagementService#zip",A.identifier.id);const x=await this.collectFiles(A),L=await(0,E.zip)((0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,x);return m.URI.file(L)}async unzip(A){return this.logService.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:x,cleanup:L}=await this.downloadVsix(A),T=y.resolve(x.fsPath);try{return await(0,o.getManifest)(T)}finally{await L()}}getInstalled(A,x){return this.extensionsScanner.scanExtensions(A??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(A,x={}){this.logService.trace("ExtensionManagementService#install",A.toString());const{location:L,cleanup:T}=await this.downloadVsix(A);try{const U=await(0,o.getManifest)(y.resolve(L.fsPath));if(U.engines&&U.engines.vscode&&!(0,D.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(S.localize(0,null,(0,s.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return await this.installExtension(U,L,x)}finally{await T()}}getMetadata(A){return this.extensionsScannerService.scanMetadata(A.location)}async updateMetadata(A,x){this.logService.trace("ExtensionManagementService#updateMetadata",A.identifier.id);const L={...x};return x.isPreReleaseVersion&&(L.preRelease=!0),A=await this.extensionsScanner.updateMetadata(A,L),this.manifestCache.invalidate(),A}async updateExtensionScope(A,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",A.identifier.id),A=await this.extensionsScanner.updateMetadata(A,{isMachineScoped:x}),this.manifestCache.invalidate(),A}removeUninstalledExtensions(A){return this.extensionsScanner.cleanUp(A)}async download(A,x){const{location:L}=await this.extensionsDownloader.download(A,x);return L}async downloadVsix(A){if(A.scheme===O.Schemas.file)return{location:A,async cleanup(){}};this.logService.trace("Downloading extension from",A.toString());const x=(0,f.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(A,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(T){this.logService.error(T)}}}}doCreateInstallExtensionTask(A,x,L){let T;if(m.URI.isUri(x))T=new M(A,x,L,this.galleryService,this.extensionsScanner,this.logService);else{const U=s.ExtensionKey.create(x).toString();T=this.installGalleryExtensionsTasks.get(U),T||(this.installGalleryExtensionsTasks.set(U,T=new j(A,x,L,this.extensionsDownloader,this.extensionsScanner,this.logService)),T.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(U)))}return L.profileLocation?new F(T,L.profileLocation,this.extensionsProfileScannerService):T}doCreateUninstallExtensionTask(A,x){return x.profileLocation?new $(A,x.profileLocation,this.extensionsProfileScannerService):new z(A,x,this.extensionsScanner)}async collectFiles(A){const x=async T=>{let U=await p.Promises.readdir(T);U=U.map(H=>y.join(T,H));const W=await Promise.all(U.map(H=>p.Promises.stat(H)));let q=Promise.resolve([]);return W.forEach((H,oe)=>{const ue=U[oe];H.isFile()&&(q=q.then(ve=>[...ve,ue])),H.isDirectory()&&(q=q.then(ve=>x(ue).then(Se=>[...ve,...Se])))}),q};return(await x(A.location.fsPath)).map(T=>({path:`extension/${y.relative(A.location.fsPath,T)}`,localPath:T}))}};ge=de([ee(0,u.IExtensionGalleryService),ee(1,se.ITelemetryService),ee(2,X.ILogService),ee(3,g.INativeEnvironmentService),ee(4,n.IExtensionsScannerService),ee(5,t.IExtensionsProfileScannerService),ee(6,l.IDownloadService),ee(7,B.IInstantiationService),ee(8,N.IFileService),ee(9,J.IProductService),ee(10,ne.IUriIdentityService),ee(11,re.IUserDataProfilesService)],ge),e.ExtensionManagementService=ge;let ce=class extends k.Disposable{constructor(A,x,L,T){super(),this.beforeRemovingExtension=A,this.fileService=x,this.extensionsScannerService=L,this.logService=T,this.uninstalledPath=(0,f.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(A){await this.removeUninstalledExtensions(),A&&await this.removeOutdatedExtensions()}async scanExtensions(A,x){const L={includeInvalid:!0,profileLocation:x};let T=[];return A===null||A===0?T.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},L,!1)):A===1&&T.push(...await this.extensionsScannerService.scanUserExtensions(L)),T=A!==null?T.filter(U=>U.type===A):T,Promise.all(T.map(U=>this.toLocalExtension(U)))}async scanUserExtensions(A){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(x.map(L=>this.toLocalExtension(L)))}async extractUserExtension(A,x,L,T){const U=A.toString(),W=y.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),q=y.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U);try{await p.Promises.rm(q)}catch{throw new u.ExtensionManagementError(S.localize(1,null,q,A.id),u.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(A,x,W,T),await this.extensionsScannerService.updateMetadata(m.URI.file(W),L);try{await this.rename(A,W,q,Date.now()+2*60*1e3),this.logService.info("Renamed to",q)}catch(H){try{await p.Promises.rm(W)}catch{}if(H.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.logService.info(`Rename failed because of ${(0,I.getErrorMessage)(H)}. Deleted from extracted location`,W),H}return this.scanLocalExtension(m.URI.file(q),1)}async updateMetadata(A,x){return await this.extensionsScannerService.updateMetadata(A.location,x),this.scanLocalExtension(A.location,A.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...A){const x=A.map(L=>s.ExtensionKey.create(L));await this.withUninstalledExtensions(L=>{x.forEach(T=>L[T.toString()]=!0)})}async setInstalled(A){await this.withUninstalledExtensions(T=>delete T[A.toString()]);const L=(await this.scanUserExtensions(!0)).find(T=>s.ExtensionKey.create(T).equals(A))||null;return L?this.updateMetadata(L,{installedTimestamp:Date.now()}):null}async removeExtension(A,x){this.logService.trace(`Deleting ${x} extension from disk`,A.identifier.id,A.location.fsPath),await p.Promises.rm(A.location.fsPath),this.logService.info("Deleted from disk",A.identifier.id,A.location.fsPath)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[s.ExtensionKey.create(A).toString()])}async withUninstalledExtensions(A){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(T){if(T.code!=="ENOENT")throw T}let L={};if(x)try{L=JSON.parse(x)}catch{}return A&&(A(L),Object.keys(L).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(L)):await p.Promises.rm(this.uninstalledPath)),L})}async extractAtLocation(A,x,L,T){this.logService.trace(`Started extracting the extension from ${x} to ${L}`);try{await p.Promises.rm(L)}catch(U){throw new u.ExtensionManagementError(this.joinErrors(U).message,u.ExtensionManagementErrorCode.Delete)}try{await(0,E.extract)(x,L,{sourcePath:"extension",overwrite:!0},T),this.logService.info(`Extracted extension to ${L}:`,A.id)}catch(U){try{await p.Promises.rm(L)}catch{}let W=u.ExtensionManagementErrorCode.Extract;throw U instanceof E.ExtractError&&(U.type==="CorruptZip"?W=u.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(W=u.ExtensionManagementErrorCode.IncompleteZip)),new u.ExtensionManagementError(U.message,W)}}async rename(A,x,L,T){try{await p.Promises.rename(x,L)}catch(U){if(d.isWindows&&U&&U.code==="EPERM"&&Date.now()<T)return this.logService.info(`Failed renaming ${x} to ${L} with 'EPERM' error. Trying again...`,A.id),this.rename(A,x,L,T);throw new u.ExtensionManagementError(U.message||S.localize(2,null,x,L),U.code||u.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(A,x){const L=await this.extensionsScannerService.scanExistingExtension(A,x,{includeInvalid:!0});if(L)return this.toLocalExtension(L);throw new Error(S.localize(3,null,A.path))}async toLocalExtension(A){const x=await this.fileService.resolve(A.location);let L,T;return x.children&&(L=x.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,T=x.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:L,changelogUrl:T,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated}}async removeUninstalledExtensions(){const A=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=new Set;for(const W of x)A[s.ExtensionKey.create(W).toString()]||L.add(W.identifier.id.toLowerCase());const T=(0,s.groupByExtension)(x,W=>W.identifier);await R.Promises.settled(T.map(async W=>{const q=W.sort((H,oe)=>P.rcompare(H.manifest.version,oe.manifest.version))[0];L.has(q.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(q))}));const U=x.filter(W=>A[s.ExtensionKey.create(W).toString()]);await R.Promises.settled(U.map(W=>this.removeUninstalledExtension(W)))}async removeOutdatedExtensions(){const A=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),L=[],T=await this.extensionsScannerService.getTargetPlatform(),U=(0,s.groupByExtension)(x,W=>W.identifier);for(const W of U)if(W.length>1&&L.push(...W.sort((q,H)=>{const oe=P.rcompare(q.manifest.version,H.manifest.version);return oe!==0?oe:q.targetPlatform===T?-1:1}).slice(1)),W[0].type===0){const q=A.find(H=>(0,s.areSameExtensions)(H.identifier,W[0].identifier));(!q||P.gte(q.manifest.version,W[0].manifest.version))&&L.push(W[0])}await R.Promises.settled(L.map(W=>this.removeExtension(W,"outdated")))}joinErrors(A){const x=Array.isArray(A)?A:[A];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((L,T)=>new Error(`${L.message}${L.message?",":""}${T instanceof Error?T.message:T}`),new Error(""))}};ce=de([ee(1,N.IFileService),ee(2,n.IExtensionsScannerService),ee(3,X.ILogService)],ce),e.ExtensionsScanner=ce;class ie extends w.AbstractExtensionTask{get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}constructor(A,x,L,T,U){super(),this.identifier=A,this.source=x,this.options=L,this.extensionsScanner=T,this.logService=U,this.wasVerified=!1,this._operation=2}async installExtension(A,x){try{const L=await this.unsetUninstalledAndGetLocal(A.key);if(L)return this.extensionsScanner.updateMetadata(L,A.metadata)}catch{throw d.isMacintosh?new u.ExtensionManagementError(S.localize(4,null),u.ExtensionManagementErrorCode.Internal):new u.ExtensionManagementError(S.localize(5,null),u.ExtensionManagementErrorCode.Internal)}return this.extract(A,x)}async unsetUninstalledAndGetLocal(A){if(!await this.isUninstalled(A))return null;this.logService.trace("Removing the extension from uninstalled list:",A.id);const L=await this.extensionsScanner.setInstalled(A);return this.logService.info("Removed the extension from uninstalled list:",A.id),L}async isUninstalled(A){return!!(await this.extensionsScanner.getUninstalledExtensions())[A.toString()]}async extract({zipPath:A,key:x,metadata:L},T){const U=await this.extensionsScanner.extractUserExtension(x,A,L,T);return this.logService.info("Extracting completed.",x.id),U}}class j extends ie{constructor(A,x,L,T,U,W){super(x.identifier,x,L,U,W),this.manifest=A,this.gallery=x,this.extensionsDownloader=T}async doRun(A){const L=(await this.extensionsScanner.scanExtensions(null,void 0)).find(q=>(0,s.areSameExtensions)(q.identifier,this.gallery.identifier));L&&(this._operation=3);const T={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,h.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,isSystem:L?.type===0?!0:void 0,updated:!!L,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,installedTimestamp:Date.now(),preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:L?.preRelease)};if(L?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(L,T),metadata:T};const{location:U,verified:W}=await this.extensionsDownloader.download(this.gallery,this._operation);try{this.wasVerified=!!W,this.validateManifest(U.fsPath);const q=await this.installExtension({zipPath:U.fsPath,key:s.ExtensionKey.create(this.gallery),metadata:T},A);return L&&!this.options.profileLocation&&(L.targetPlatform!==q.targetPlatform||P.neq(L.manifest.version,q.manifest.version))&&await this.extensionsScanner.setUninstalled(L),{local:q,metadata:T}}catch(q){try{await this.extensionsDownloader.delete(U)}catch(H){this.logService.warn("Error while deleting the downloaded file",U.toString(),(0,I.getErrorMessage)(H))}throw q}}async validateManifest(A){try{await(0,o.getManifest)(A)}catch(x){throw new u.ExtensionManagementError((0,w.joinErrors)(x).message,u.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=j;class M extends ie{constructor(A,x,L,T,U,W){super({id:(0,s.getGalleryExtensionId)(A.publisher,A.name)},x,L,U,W),this.manifest=A,this.location=x,this.galleryService=T}async doRun(A){const x=new s.ExtensionKey(this.identifier,this.manifest.version),T=(await this.extensionsScanner.scanExtensions(1,void 0)).find(q=>(0,s.areSameExtensions)(this.identifier,q.identifier)),U=await this.getMetadata(this.identifier.id,this.manifest.version,A);if(U.isApplicationScoped=(0,h.isApplicationScopedExtension)(this.manifest),U.isMachineScoped=this.options.isMachineScoped||T?.isMachineScoped,U.isBuiltin=this.options.isBuiltin||T?.isBuiltin,U.installedTimestamp=Date.now(),T)if(this._operation=3,x.equals(new s.ExtensionKey(T.identifier,T.manifest.version)))try{await this.extensionsScanner.removeExtension(T,"existing")}catch{throw new Error(S.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&P.gt(T.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(T);else{const q=await this.unsetUninstalledAndGetLocal(x);if(q)try{await this.extensionsScanner.removeExtension(q,"existing")}catch{throw new Error(S.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:y.resolve(this.location.fsPath),key:x,metadata:U},A),metadata:U}}async getMetadata(A,x,L){try{let[T]=await this.galleryService.getExtensions([{id:A,version:x}],L);if(T||([T]=await this.galleryService.getExtensions([{id:A}],L)),T)return{id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId,isPreReleaseVersion:T.properties.isPreReleaseVersion,preRelease:T.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(A,x,L){this.task=A,this.profileLocation=x,this.extensionsProfileScannerService=L,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const A=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[A.local,A.metadata]],this.profileLocation),A}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class z extends w.AbstractExtensionTask{constructor(A,x,L){super(),this.extension=A,this.options=x,this.extensionsScanner=L}async doRun(A){const x=[],L=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const T=s.ExtensionKey.create(this.extension);x.push(...L.filter(U=>T.equals(s.ExtensionKey.create(U))))}else x.push(...L.filter(T=>(0,s.areSameExtensions)(T.identifier,this.extension.identifier)));if(!x.length)throw new Error(S.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const T of x)try{A.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(T)}catch(U){throw new Error(S.localize(9,null,(0,C.toErrorMessage)(U)))}}}class $ extends w.AbstractExtensionTask{constructor(A,x,L){super(),this.extension=A,this.profileLocation=x,this.extensionsProfileScannerService=L}async doRun(A){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Q[150],Z([0,1,129,3,15,11,2,5,21,17,130,9,128,163]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let p=class extends O.Disposable{constructor(S,l,g){super(),this.environmentService=l,this.logService=g,this.configure(S.getValue()),this._register(S.onDidChangeConfiguration(()=>this.configure(S.getValue()),this))}configure(S){this.proxyUrl=S.http&&S.http.proxy,this.strictSSL=!!(S.http&&S.http.proxyStrictSSL),this.authorization=S.http&&S.http.proxyAuthorization}async request(S,l){this.logService.trace("RequestService#request (node) - begin",S.url);const{proxyUrl:g,strictSSL:w}=this;let u;try{u=await(0,P.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...u},t=S.agent?S.agent:await(0,m.getProxyAgent)(S.url||"",s,{proxyUrl:g,strictSSL:w});S.agent=t,S.strictSSL=w,this.authorization&&(S.headers={...S.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(S,l);return this.logService.trace("RequestService#request (node) - success",S.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",S.url,n),n}}async getNodeRequest(S){return((0,R.parse)(S.url).protocol==="https:"?await new Promise((w,u)=>{_(["https"],w,u)}):await new Promise((w,u)=>{_(["http"],w,u)})).request}_request(S,l){return C.Promises.withAsyncBody(async(g,w)=>{const u=(0,R.parse)(S.url),s=S.getRawRequest?S.getRawRequest(S):await this.getNodeRequest(S),t={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:S.type||"GET",headers:S.headers,agent:S.agent,rejectUnauthorized:(0,y.isBoolean)(S.strictSSL)?S.strictSSL:!0};S.user&&S.password&&(t.auth=S.user+":"+S.password);const n=s(t,i=>{const r=(0,y.isNumber)(S.followRedirects)?S.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this._request({...S,url:i.headers.location,followRedirects:r-1},l).then(g,w);else{let o=i;i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,v.createGunzip)())),g({res:i,stream:(0,I.streamToBufferReadableStream)(o)})}});n.on("error",w),S.timeout&&n.setTimeout(S.timeout),S.data&&typeof S.data=="string"&&n.write(S.data),n.end(),l.onCancellationRequested(()=>{n.abort(),w(new k.CancellationError)})})}async resolveProxy(S){}};p=de([ee(0,d.IConfigurationService),ee(1,f.INativeEnvironmentService),ee(2,b.ILogService)],p),e.RequestService=p}),define(Q[164],Z([0,1,37,3,15,31,11,2,16,14,12,32,10,20,21,121,58,127,17,102,145,22,59,123,41,48,149,143,13,112,115,46,110,62,63,126,9,117,118,36,147,135,28,47,150,66,131,67,35,134,42,136,137,29,139,25,146]),function(_,e,R,C,I,k,O,y,d,f,P,b,m,v,p,E,S,l,g,w,u,s,t,n,i,r,o,c,a,h,D,N,B,X,J,se,ne,re,ge,ce,ie,j,M,F,z,$,Y,A,x,L,T,U,W,q,H,oe,ue){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ve extends y.Disposable{constructor(te){super(),this.argv=te,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[te,fe]=await this.initServices();return te.invokeFunction(async ae=>{const pe=ae.get(ne.ILogService),Fe=ae.get(a.IFileService),Oe=ae.get(g.INativeEnvironmentService),Ae=ae.get(oe.IUserDataProfilesService);pe.info("CLI main",this.argv),this.registerErrorHandler(pe),await this.doRun(Oe,Fe,Ae,te),await Promise.all(fe.map(xe=>{(0,C.raceTimeout)(xe.flush(),1e3)}))})}async initServices(){const te=new X.ServiceCollection,fe={_serviceBrand:void 0,...j.default};te.set(M.IProductService,fe);const ae=new w.NativeEnvironmentService(this.argv,fe);te.set(g.INativeEnvironmentService,ae),await Promise.all([ae.appSettingsHome.fsPath,ae.extensionsPath].map(Re=>Re?v.Promises.mkdir(Re,{recursive:!0}):void 0));const pe=(0,ne.getLogLevel)(ae),Fe=[];Fe.push(new re.SpdLogLogger("cli",(0,f.join)(ae.logsPath,"cli.log"),!0,!1,pe)),pe===ne.LogLevel.Trace&&Fe.push(new ne.ConsoleLogger(pe));const Oe=this._register(new ne.MultiplexLogService(Fe));te.set(ne.ILogService,Oe);const Ae=this._register(new h.FileService(Oe));te.set(a.IFileService,Ae);const xe=this._register(new D.DiskFileSystemProvider(Oe));Ae.registerProvider(d.Schemas.file,xe);const V=new Y.StateService(ae,Oe,Ae);te.set($.IStateService,V);const G=new H.UriIdentityService(Ae);te.set(q.IUriIdentityService,G);const K=new ue.UserDataProfilesService(V,G,ae,Ae,Oe);te.set(oe.IUserDataProfilesService,K);const he=P.isWindows&&fe.win32RegValueName?this._register(new ie.NativePolicyService(fe.win32RegValueName)):ae.policyFile?this._register(new ge.FilePolicyService(ae.policyFile,Ae,Oe)):new ce.NullPolicyService;te.set(ce.IPolicyService,he);const me=this._register(new E.ConfigurationService(K.defaultProfile.settingsResource,Ae,he,Oe));te.set(p.IConfigurationService,me),await Promise.all([V.init(),me.initialize()]),K.setEnablement(fe.quality!=="stable"||me.getValue(oe.PROFILES_ENABLEMENT_CONFIG)),te.set(q.IUriIdentityService,new H.UriIdentityService(Ae)),te.set(F.IRequestService,new N.SyncDescriptor(z.RequestService,void 0,!0)),te.set(S.IDownloadService,new N.SyncDescriptor(l.DownloadService,void 0,!0)),te.set(i.IExtensionsProfileScannerService,new N.SyncDescriptor(i.ExtensionsProfileScannerService,void 0,!0)),te.set(r.IExtensionsScannerService,new N.SyncDescriptor(c.ExtensionsScannerService,void 0,!0)),te.set(t.IExtensionSignatureVerificationService,new N.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),te.set(o.INativeServerExtensionManagementService,new N.SyncDescriptor(o.ExtensionManagementService,void 0,!0)),te.set(s.IExtensionGalleryService,new N.SyncDescriptor(u.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),te.set(J.ILanguagePackService,new N.SyncDescriptor(se.NativeLanguagePackService,void 0,!1));const De=[],we=(0,T.isInternalTelemetry)(fe,me);if((0,T.supportsTelemetry)(fe,ae)){fe.aiConfig&&fe.aiConfig.ariaKey&&De.push(new U.OneDataSystemAppender(we,"monacoworkbench",null,fe.aiConfig.ariaKey));const{installSourcePath:Re}=ae,Ie={appenders:De,sendErrorTelemetry:!1,commonProperties:(async()=>{let ke;try{const Ne=await v.Promises.readFile(ae.stateResource.fsPath);ke=JSON.parse(Ne.toString())[x.machineIdKey]}catch(Ne){Ne.code!=="ENOENT"&&Oe.error(Ne)}return(0,A.resolveCommonProperties)(Ae,(0,R.release)(),(0,R.hostname)(),process.arch,fe.commit,fe.version,ke,we,Re)})(),piiPaths:(0,T.getPiiPathsFromEnvironment)(ae)};te.set(x.ITelemetryService,new N.SyncDescriptor(L.TelemetryService,[Ie],!1))}else te.set(x.ITelemetryService,T.NullTelemetryService);return[new B.InstantiationService(te),De]}registerErrorHandler(te){(0,O.setUnexpectedErrorHandler)(fe=>{const ae=(0,k.toErrorMessage)(fe,!0);!ae||te.error(`[uncaught exception in CLI]: ${ae}`)}),process.on("uncaughtException",fe=>(0,O.onUnexpectedError)(fe)),process.on("unhandledRejection",fe=>(0,O.onUnexpectedError)(fe))}async doRun(te,fe,ae,pe){const Fe=te.args.profile?ae.profiles.find(Oe=>Oe.name===te.args.profile)?.extensionsResource:ae.defaultProfile.extensionsResource;if(this.argv["install-source"])return this.setInstallSource(te,fe,this.argv["install-source"]);if(this.argv["list-extensions"])return pe.createInstance(n.ExtensionManagementCLI).listExtensions(!!this.argv["show-versions"],this.argv.category,Fe);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const Oe={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"],profileLocation:Fe};return pe.createInstance(n.ExtensionManagementCLI).installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],Oe,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return pe.createInstance(n.ExtensionManagementCLI).uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force,Fe);if(this.argv["locate-extension"])return pe.createInstance(n.ExtensionManagementCLI).locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,W.buildTelemetryMessage)(te.appRoot,te.extensionsPath))}}asExtensionIdOrVSIX(te){return te.map(fe=>/\.vsix$/i.test(fe)?m.URI.file((0,f.isAbsolute)(fe)?fe:(0,f.join)((0,b.cwd)(),fe)):fe)}async setInstallSource(te,fe,ae){await fe.writeFile(m.URI.file(te.installSourcePath),I.VSBuffer.fromString(ae.slice(0,30)))}}async function Se(le){const te=new ve(le);try{await te.run()}finally{te.dispose()}}e.main=Se})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/86f0f9bfa268fe21af7efae37d8f0da1dba8137f/core/vs/code/node/cliProcessMain.js.map
