/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/errorMessage","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/base/common/process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/common/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/observableValue","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/telemetry/common/telemetryUtils","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/base/common/hash","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ie=function(ie){for(var e=[],i=0,I=ie.length;i<I;i++)e[i]=De[ie[i]];return e};define(De[77],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function i(D,A){const y=Object.create(null);for(const T of D){const O=A(T);let b=y[O];b||(b=y[O]=[]),b.push(T)}return y}e.groupBy=i;function I(D,A){const y=[],T=[];for(const O of D)A.has(O)||y.push(O);for(const O of A)D.has(O)||T.push(O);return{removed:y,added:T}}e.diffSets=I;function w(D,A){const y=[],T=[];for(const[O,b]of D)A.has(O)||y.push(b);for(const[O,b]of A)D.has(O)||T.push(b);return{removed:y,added:T}}e.diffMaps=w;class M{constructor(){this.map=new Map}add(A,y){let T=this.map.get(A);T||(T=new Set,this.map.set(A,T)),T.add(y)}delete(A,y){const T=this.map.get(A);!T||(T.delete(y),T.size===0&&this.map.delete(A))}forEach(A,y){const T=this.map.get(A);!T||T.forEach(y)}}e.SetMap=M}),define(De[58],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function i(D){return(A,y,T)=>{let O=null,b=null;if(typeof T.value=="function"?(O="value",b=T.value):typeof T.get=="function"&&(O="get",b=T.get),!b)throw new Error("not supported");T[O]=D(b,y)}}function I(D,A,y){let T=null,O=null;if(typeof y.value=="function"?(T="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(T="get",O=y.get),!O)throw new Error("not supported");const b=`$memoize$${A}`;y[T]=function(...g){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,g)}),this[b]}}e.memoize=I;function w(D,A,y){return i((T,O)=>{const b=`$debounce$${O}`,g=`$debounce$result$${O}`;return function(...E){this[g]||(this[g]=y?y():void 0),clearTimeout(this[b]),A&&(this[g]=A(this[g],...E),E=[this[g]]),this[b]=setTimeout(()=>{T.apply(this,E),this[g]=y?y():void 0},D)}})}e.debounce=w;function M(D,A,y){return i((T,O)=>{const b=`$throttle$timer$${O}`,g=`$throttle$result$${O}`,E=`$throttle$lastRun$${O}`,m=`$throttle$pending$${O}`;return function(...t){if(this[g]||(this[g]=y?y():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),A&&(this[g]=A(this[g],...t)),this[m])return;const s=this[E]+D;s<=Date.now()?(this[E]=Date.now(),T.apply(this,[this[g]]),this[g]=y?y():void 0):(this[m]=!0,this[b]=setTimeout(()=>{this[m]=!1,this[E]=Date.now(),T.apply(this,[this[g]]),this[g]=y?y():void 0},s-Date.now()))}})}e.throttle=M}),define(De[78],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class i{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=i,e.defaultGenerator=new i("id#")}),define(De[106],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var i;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(i=e.ScanError||(e.ScanError={}));var I;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(r){r.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function D(r,c=!1){let n=0;const d=r.length;let l="",f=0,o=16,h=0;function v(U){let R=0,x=0;for(;R<U;){const z=r.charCodeAt(n);if(z>=48&&z<=57)x=x*16+z-48;else if(z>=65&&z<=70)x=x*16+z-65+10;else if(z>=97&&z<=102)x=x*16+z-97+10;else break;n++,R++}return R<U&&(x=-1),x}function k(U){n=U,l="",f=0,o=16,h=0}function F(){const U=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&T(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&T(r.charCodeAt(n)))for(n++;n<r.length&&T(r.charCodeAt(n));)n++;else return h=3,r.substring(U,n);let R=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&T(r.charCodeAt(n))){for(n++;n<r.length&&T(r.charCodeAt(n));)n++;R=n}else h=3;return r.substring(U,R)}function j(){let U="",R=n;for(;;){if(n>=d){U+=r.substring(R,n),h=2;break}const x=r.charCodeAt(n);if(x===34){U+=r.substring(R,n),n++;break}if(x===92){if(U+=r.substring(R,n),n++,n>=d){h=2;break}switch(r.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const B=v(4);B>=0?U+=String.fromCharCode(B):h=4;break}default:h=5}R=n;continue}if(x>=0&&x<=31)if(y(x)){U+=r.substring(R,n),h=2;break}else h=6;n++}return U}function H(){if(l="",h=0,f=n,n>=d)return f=d,o=17;let U=r.charCodeAt(n);if(A(U)){do n++,l+=String.fromCharCode(U),U=r.charCodeAt(n);while(A(U));return o=15}if(y(U))return n++,l+=String.fromCharCode(U),U===13&&r.charCodeAt(n)===10&&(n++,l+=`
`),o=14;switch(U){case 123:return n++,o=1;case 125:return n++,o=2;case 91:return n++,o=3;case 93:return n++,o=4;case 58:return n++,o=6;case 44:return n++,o=5;case 34:return n++,l=j(),o=10;case 47:{const R=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<d&&!y(r.charCodeAt(n));)n++;return l=r.substring(R,n),o=12}if(r.charCodeAt(n+1)===42){n+=2;const x=d-1;let z=!1;for(;n<x;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,z=!0;break}n++}return z||(n++,h=1),l=r.substring(R,n),o=13}return l+=String.fromCharCode(U),n++,o=16}case 45:if(l+=String.fromCharCode(U),n++,n===d||!T(r.charCodeAt(n)))return o=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=F(),o=11;default:for(;n<d&&V(U);)n++,U=r.charCodeAt(n);if(f!==n){switch(l=r.substring(f,n),l){case"true":return o=8;case"false":return o=9;case"null":return o=7}return o=16}return l+=String.fromCharCode(U),n++,o=16}}function V(U){if(A(U)||y(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function P(){let U;do U=H();while(U>=12&&U<=15);return U}return{setPosition:k,getPosition:()=>n,scan:c?P:H,getToken:()=>o,getTokenValue:()=>l,getTokenOffset:()=>f,getTokenLength:()=>n-f,getTokenError:()=>h}}e.createScanner=D;function A(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function y(r){return r===10||r===13||r===8232||r===8233}function T(r){return r>=48&&r<=57}var O;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(O||(O={}));function b(r,c){const n=[],d=new Object;let l;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function h(v,k,F,j){f.value=v,f.offset=k,f.length=F,f.type=j,f.colonOffset=void 0,l=f}try{S(r,{onObjectBegin:(v,k)=>{if(c<=v)throw d;l=void 0,o=c>v,n.push("")},onObjectProperty:(v,k,F)=>{if(c<k||(h(v,k,F,"property"),n[n.length-1]=v,c<=k+F))throw d},onObjectEnd:(v,k)=>{if(c<=v)throw d;l=void 0,n.pop()},onArrayBegin:(v,k)=>{if(c<=v)throw d;l=void 0,n.push(0)},onArrayEnd:(v,k)=>{if(c<=v)throw d;l=void 0,n.pop()},onLiteralValue:(v,k,F)=>{if(c<k||(h(v,k,F,C(v)),c<=k+F))throw d},onSeparator:(v,k,F)=>{if(c<=k)throw d;if(v===":"&&l&&l.type==="property")l.colonOffset=k,o=!1,l=void 0;else if(v===","){const j=n[n.length-1];typeof j=="number"?n[n.length-1]=j+1:(o=!0,n[n.length-1]=""),l=void 0}}})}catch(v){if(v!==d)throw v}return{path:n,previousNode:l,isAtPropertyKey:o,matches:v=>{let k=0;for(let F=0;k<v.length&&F<n.length;F++)if(v[k]===n[F]||v[k]==="*")k++;else if(v[k]!=="**")return!1;return k===v.length}}}e.getLocation=b;function g(r,c=[],n=M.DEFAULT){let d=null,l=[];const f=[];function o(v){Array.isArray(l)?l.push(v):d!==null&&(l[d]=v)}return S(r,{onObjectBegin:()=>{const v={};o(v),f.push(l),l=v,d=null},onObjectProperty:v=>{d=v},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const v=[];o(v),f.push(l),l=v,d=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:o,onError:(v,k,F)=>{c.push({error:v,offset:k,length:F})}},n),l[0]}e.parse=g;function E(r,c=[],n=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(v){d.type==="property"&&(d.length=v-d.offset,d=d.parent)}function f(v){return d.children.push(v),v}S(r,{onObjectBegin:v=>{d=f({type:"object",offset:v,length:-1,parent:d,children:[]})},onObjectProperty:(v,k,F)=>{d=f({type:"property",offset:k,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:v,offset:k,length:F,parent:d})},onObjectEnd:(v,k)=>{d.length=v+k-d.offset,d=d.parent,l(v+k)},onArrayBegin:(v,k)=>{d=f({type:"array",offset:v,length:-1,parent:d,children:[]})},onArrayEnd:(v,k)=>{d.length=v+k-d.offset,d=d.parent,l(v+k)},onLiteralValue:(v,k,F)=>{f({type:C(v),offset:k,length:F,parent:d,value:v}),l(k+F)},onSeparator:(v,k,F)=>{d.type==="property"&&(v===":"?d.colonOffset=k:v===","&&l(k))},onError:(v,k,F)=>{c.push({error:v,offset:k,length:F})}},n);const h=d.children[0];return h&&delete h.parent,h}e.parseTree=E;function m(r,c){if(!r)return;let n=r;for(const d of c)if(typeof d=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const f of n.children)if(Array.isArray(f.children)&&f.children[0].value===d){n=f.children[1],l=!0;break}if(!l)return}else{const l=d;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}e.findNodeAtLocation=m;function t(r){if(!r.parent||!r.parent.children)return[];const c=t(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;c.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&c.push(n)}return c}e.getNodePath=t;function s(r){switch(r.type){case"array":return r.children.map(s);case"object":{const c=Object.create(null);for(const n of r.children){const d=n.children[1];d&&(c[n.children[0].value]=s(d))}return c}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=s;function a(r,c,n=!1){return c>=r.offset&&c<r.offset+r.length||n&&c===r.offset+r.length}e.contains=a;function p(r,c,n=!1){if(a(r,c,n)){const d=r.children;if(Array.isArray(d))for(let l=0;l<d.length&&d[l].offset<=c;l++){const f=p(d[l],c,n);if(f)return f}return r}}e.findNodeAtOffset=p;function S(r,c,n=M.DEFAULT){const d=D(r,!1);function l(ae){return ae?()=>ae(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(ae){return ae?de=>ae(de,d.getTokenOffset(),d.getTokenLength()):()=>!0}const o=l(c.onObjectBegin),h=f(c.onObjectProperty),v=l(c.onObjectEnd),k=l(c.onArrayBegin),F=l(c.onArrayEnd),j=f(c.onLiteralValue),H=f(c.onSeparator),V=l(c.onComment),P=f(c.onError),U=n&&n.disallowComments,R=n&&n.allowTrailingComma;function x(){for(;;){const ae=d.scan();switch(d.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:U||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(ae){case 12:case 13:U?z(10):V();break;case 16:z(1);break;case 15:case 14:break;default:return ae}}}function z(ae,de=[],Y=[]){if(P(ae),de.length+Y.length>0){let me=d.getToken();for(;me!==17;){if(de.indexOf(me)!==-1){x();break}else if(Y.indexOf(me)!==-1)break;me=x()}}}function B(ae){const de=d.getTokenValue();return ae?j(de):h(de),x(),!0}function K(){switch(d.getToken()){case 11:{let ae=0;try{ae=JSON.parse(d.getTokenValue()),typeof ae!="number"&&(z(2),ae=0)}catch{z(2)}j(ae);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return x(),!0}function Z(){return d.getToken()!==10?(z(3,[],[2,5]),!1):(B(!1),d.getToken()===6?(H(":"),x(),pe()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function ue(){o(),x();let ae=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ae||z(4,[],[]),H(","),x(),d.getToken()===2&&R)break}else ae&&z(6,[],[]);Z()||z(4,[],[2,5]),ae=!0}return v(),d.getToken()!==2?z(7,[2],[]):x(),!0}function ne(){k(),x();let ae=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ae||z(4,[],[]),H(","),x(),d.getToken()===4&&R)break}else ae&&z(6,[],[]);pe()||z(4,[],[4,5]),ae=!0}return F(),d.getToken()!==4?z(8,[4],[]):x(),!0}function pe(){switch(d.getToken()){case 3:return ne();case 1:return ue();case 10:return B(!0);default:return K()}}return x(),d.getToken()===17?n.allowEmptyContent?!0:(z(4,[],[]),!1):pe()?(d.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=S;function u(r,c){const n=D(r),d=[];let l,f=0,o;do switch(o=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:f!==o&&d.push(r.substring(f,o)),c!==void 0&&d.push(n.getTokenValue().replace(/[^\r\n]/g,c)),f=n.getPosition();break}while(l!==17);return d.join("")}e.stripComments=u;function C(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),define(De[28],Ie([1,0]),function(ie,e){"use strict";var i,I,w;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function M(m,t,s){let a=m.get(t);return a===void 0&&(a=s,m.set(t,a)),a}e.getOrSet=M;function D(m){const t=[];return m.forEach((s,a)=>{t.push(`${a} => ${s}`)}),`Map(${m.size}) {${t.join(", ")}}`}e.mapToString=D;function A(m){const t=[];return m.forEach(s=>{t.push(s)}),`Set(${m.size}) {${t.join(", ")}}`}e.setToString=A;class y{constructor(t,s){this.uri=t,this.value=s}}class T{constructor(t,s){this[i]="ResourceMap",t instanceof T?(this.map=new Map(t.map),this.toKey=s??T.defaultToKey):(this.map=new Map,this.toKey=t??T.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new y(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[a,p]of this.map)t(p.value,p.uri,this)}*values(){for(const t of this.map.values())yield t.value}*keys(){for(const t of this.map.values())yield t.uri}*entries(){for(const t of this.map.values())yield[t.uri,t.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=T,T.defaultToKey=m=>m.toString();class O{constructor(t,s){this[I]="ResourceSet",!t||typeof t=="function"?this._map=new T(t):(this._map=new T(s),t.forEach(this.add,this))}get size(){return this._map.size}add(t){return this._map.set(t,t),this}clear(){this._map.clear()}delete(t){return this._map.delete(t)}forEach(t,s){this._map.forEach((a,p)=>t.call(s,p,p,this))}has(t){return this._map.has(t)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var b;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class g{constructor(){this[w]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const a=this._map.get(t);if(!!a)return s!==0&&this.touch(a,s),a.value}set(t,s,a=0){let p=this._map.get(t);if(p)p.value=s,a!==0&&this.touch(p,a);else{switch(p={key:t,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(t,p),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const a=this._state;let p=this._head;for(;p;){if(s?t.bind(s)(p.value,p.key,this):t(p.value,p.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const t=this,s=this._state;let a=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:a.key,done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return p}values(){const t=this,s=this._state;let a=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:a.value,done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return p}entries(){const t=this,s=this._state;let a=this._head;const p={[Symbol.iterator](){return p},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:[a.key,a.value],done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return p}[(w=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>t;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,a=t.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const a=t.next,p=t.previous;t===this._tail?(p.next=void 0,this._tail=p):(a.previous=p,p.next=a),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const a=t.next,p=t.previous;t===this._head?(a.previous=void 0,this._head=a):(a.previous=p,p.next=a),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,a)=>{t.push([a,s])}),t}fromJSON(t){this.clear();for(const[s,a]of t)this.set(s,a)}}e.LinkedMap=g;class E extends g{constructor(t,s=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=E}),function(ie,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(De[107],Ie([0]),e):(ie=typeof globalThis<"u"?globalThis:ie||self,e(ie.marked={}))}(this,function(ie){"use strict";function e(ke,ye){for(var Ce=0;Ce<ye.length;Ce++){var se=ye[Ce];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(ke,se.key,se)}}function i(ke,ye,Ce){return ye&&e(ke.prototype,ye),Ce&&e(ke,Ce),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function I(ke,ye){if(!!ke){if(typeof ke=="string")return w(ke,ye);var Ce=Object.prototype.toString.call(ke).slice(8,-1);if(Ce==="Object"&&ke.constructor&&(Ce=ke.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(ke);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return w(ke,ye)}}function w(ke,ye){(ye==null||ye>ke.length)&&(ye=ke.length);for(var Ce=0,se=new Array(ye);Ce<ye;Ce++)se[Ce]=ke[Ce];return se}function M(ke,ye){var Ce=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(Ce)return(Ce=Ce.call(ke)).next.bind(Ce);if(Array.isArray(ke)||(Ce=I(ke))||ye&&ke&&typeof ke.length=="number"){Ce&&(ke=Ce);var se=0;return function(){return se>=ke.length?{done:!0}:{done:!1,value:ke[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ie.defaults=D();function A(ke){ie.defaults=ke}var y=/[&<>"']/,T=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ye){return g[ye]};function m(ke,ye){if(ye){if(y.test(ke))return ke.replace(T,E)}else if(O.test(ke))return ke.replace(b,E);return ke}var t=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(ke){return ke.replace(t,function(ye,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var a=/(^|[^\[])\^/g;function p(ke,ye){ke=typeof ke=="string"?ke:ke.source,ye=ye||"";var Ce={replace:function(le,J){return J=J.source||J,J=J.replace(a,"$1"),ke=ke.replace(le,J),Ce},getRegex:function(){return new RegExp(ke,ye)}};return Ce}var S=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(ke,ye,Ce){if(ke){var se;try{se=decodeURIComponent(s(Ce)).replace(S,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}ye&&!u.test(Ce)&&(Ce=l(ye,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch{return null}return Ce}var r={},c=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function l(ke,ye){r[" "+ke]||(c.test(ke)?r[" "+ke]=ke+"/":r[" "+ke]=v(ke,"/",!0)),ke=r[" "+ke];var Ce=ke.indexOf(":")===-1;return ye.substring(0,2)==="//"?Ce?ye:ke.replace(n,"$1")+ye:ye.charAt(0)==="/"?Ce?ye:ke.replace(d,"$1")+ye:ke+ye}var f={exec:function(){}};function o(ke){for(var ye=1,Ce,se;ye<arguments.length;ye++){Ce=arguments[ye];for(se in Ce)Object.prototype.hasOwnProperty.call(Ce,se)&&(ke[se]=Ce[se])}return ke}function h(ke,ye){var Ce=ke.replace(/\|/g,function(J,_,L){for(var W=!1,q=_;--q>=0&&L[q]==="\\";)W=!W;return W?"|":" |"}),se=Ce.split(/ \|/),le=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>ye)se.splice(ye);else for(;se.length<ye;)se.push("");for(;le<se.length;le++)se[le]=se[le].trim().replace(/\\\|/g,"|");return se}function v(ke,ye,Ce){var se=ke.length;if(se===0)return"";for(var le=0;le<se;){var J=ke.charAt(se-le-1);if(J===ye&&!Ce)le++;else if(J!==ye&&Ce)le++;else break}return ke.slice(0,se-le)}function k(ke,ye){if(ke.indexOf(ye[1])===-1)return-1;for(var Ce=ke.length,se=0,le=0;le<Ce;le++)if(ke[le]==="\\")le++;else if(ke[le]===ye[0])se++;else if(ke[le]===ye[1]&&(se--,se<0))return le;return-1}function F(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(ke,ye){if(ye<1)return"";for(var Ce="";ye>1;)ye&1&&(Ce+=ke),ye>>=1,ke+=ke;return Ce+ke}function H(ke,ye,Ce,se){var le=ye.href,J=ye.title?m(ye.title):null,_=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){se.state.inLink=!0;var L={type:"link",raw:Ce,href:le,title:J,text:_,tokens:se.inlineTokens(_)};return se.state.inLink=!1,L}return{type:"image",raw:Ce,href:le,title:J,text:m(_)}}function V(ke,ye){var Ce=ke.match(/^(\s+)(?:```)/);if(Ce===null)return ye;var se=Ce[1];return ye.split(`
`).map(function(le){var J=le.match(/^\s+/);if(J===null)return le;var _=J[0];return _.length>=se.length?le.slice(se.length):le}).join(`
`)}var P=function(){function ke(Ce){this.options=Ce||ie.defaults}var ye=ke.prototype;return ye.space=function(se){var le=this.rules.block.newline.exec(se);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},ye.code=function(se){var le=this.rules.block.code.exec(se);if(le){var J=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?J:v(J,`
`)}}},ye.fences=function(se){var le=this.rules.block.fences.exec(se);if(le){var J=le[0],_=V(J,le[3]||"");return{type:"code",raw:J,lang:le[2]?le[2].trim():le[2],text:_}}},ye.heading=function(se){var le=this.rules.block.heading.exec(se);if(le){var J=le[2].trim();if(/#$/.test(J)){var _=v(J,"#");(this.options.pedantic||!_||/ $/.test(_))&&(J=_.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:J,tokens:this.lexer.inline(J)}}},ye.hr=function(se){var le=this.rules.block.hr.exec(se);if(le)return{type:"hr",raw:le[0]}},ye.blockquote=function(se){var le=this.rules.block.blockquote.exec(se);if(le){var J=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},ye.list=function(se){var le=this.rules.block.list.exec(se);if(le){var J,_,L,W,q,ee,ce,be,oe,we,ve,Ue,ze=le[1].trim(),et=ze.length>1,Ke={type:"list",raw:"",ordered:et,start:et?+ze.slice(0,-1):"",loose:!1,items:[]};ze=et?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=et?ze:"[*+-]");for(var tt=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Ue=!1,!(!(le=tt.exec(se))||this.rules.block.hr.test(se)));){if(J=le[0],se=se.substring(J.length),be=le[2].split(`
`,1)[0],oe=se.split(`
`,1)[0],this.options.pedantic?(W=2,ve=be.trimLeft()):(W=le[2].search(/[^ ]/),W=W>4?1:W,ve=be.slice(W),W+=le[1].length),ee=!1,!be&&/^ *$/.test(oe)&&(J+=oe+`
`,se=se.substring(oe.length+1),Ue=!0),!Ue)for(var Fe=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ht=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),X=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),Q=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");se&&(we=se.split(`
`,1)[0],be=we,this.options.pedantic&&(be=be.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(X.test(be)||Q.test(be)||Fe.test(be)||ht.test(se)));){if(be.search(/[^ ]/)>=W||!be.trim())ve+=`
`+be.slice(W);else if(!ee)ve+=`
`+be;else break;!ee&&!be.trim()&&(ee=!0),J+=we+`
`,se=se.substring(we.length+1)}Ke.loose||(ce?Ke.loose=!0:/\n *\n *$/.test(J)&&(ce=!0)),this.options.gfm&&(_=/^\[[ xX]\] /.exec(ve),_&&(L=_[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:J,task:!!_,checked:L,loose:!1,text:ve}),Ke.raw+=J}Ke.items[Ke.items.length-1].raw=J.trimRight(),Ke.items[Ke.items.length-1].text=ve.trimRight(),Ke.raw=Ke.raw.trimRight();var ge=Ke.items.length;for(q=0;q<ge;q++){this.lexer.state.top=!1,Ke.items[q].tokens=this.lexer.blockTokens(Ke.items[q].text,[]);var Ne=Ke.items[q].tokens.filter(function(qe){return qe.type==="space"}),je=Ne.every(function(qe){for(var We=qe.raw.split(""),Ze=0,nt=M(We),ct;!(ct=nt()).done;){var It=ct.value;if(It===`
`&&(Ze+=1),Ze>1)return!0}return!1});!Ke.loose&&Ne.length&&je&&(Ke.loose=!0,Ke.items[q].loose=!0)}return Ke}},ye.html=function(se){var le=this.rules.block.html.exec(se);if(le){var J={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var _=this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]);J.type="paragraph",J.text=_,J.tokens=this.lexer.inline(_)}return J}},ye.def=function(se){var le=this.rules.block.def.exec(se);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var J=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:le[0],href:le[2],title:le[3]}}},ye.table=function(se){var le=this.rules.block.table.exec(se);if(le){var J={type:"table",header:h(le[1]).map(function(ce){return{text:ce}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=le[0];var _=J.align.length,L,W,q,ee;for(L=0;L<_;L++)/^ *-+: *$/.test(J.align[L])?J.align[L]="right":/^ *:-+: *$/.test(J.align[L])?J.align[L]="center":/^ *:-+ *$/.test(J.align[L])?J.align[L]="left":J.align[L]=null;for(_=J.rows.length,L=0;L<_;L++)J.rows[L]=h(J.rows[L],J.header.length).map(function(ce){return{text:ce}});for(_=J.header.length,W=0;W<_;W++)J.header[W].tokens=this.lexer.inline(J.header[W].text);for(_=J.rows.length,W=0;W<_;W++)for(ee=J.rows[W],q=0;q<ee.length;q++)ee[q].tokens=this.lexer.inline(ee[q].text);return J}}},ye.lheading=function(se){var le=this.rules.block.lheading.exec(se);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},ye.paragraph=function(se){var le=this.rules.block.paragraph.exec(se);if(le){var J=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:J,tokens:this.lexer.inline(J)}}},ye.text=function(se){var le=this.rules.block.text.exec(se);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},ye.escape=function(se){var le=this.rules.inline.escape.exec(se);if(le)return{type:"escape",raw:le[0],text:m(le[1])}},ye.tag=function(se){var le=this.rules.inline.tag.exec(se);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]):le[0]}},ye.link=function(se){var le=this.rules.inline.link.exec(se);if(le){var J=le[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var _=v(J.slice(0,-1),"\\");if((J.length-_.length)%2===0)return}else{var L=k(le[2],"()");if(L>-1){var W=le[0].indexOf("!")===0?5:4,q=W+le[1].length+L;le[2]=le[2].substring(0,L),le[0]=le[0].substring(0,q).trim(),le[3]=""}}var ee=le[2],ce="";if(this.options.pedantic){var be=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ee);be&&(ee=be[1],ce=be[3])}else ce=le[3]?le[3].slice(1,-1):"";return ee=ee.trim(),/^</.test(ee)&&(this.options.pedantic&&!/>$/.test(J)?ee=ee.slice(1):ee=ee.slice(1,-1)),H(le,{href:ee&&ee.replace(this.rules.inline._escapes,"$1"),title:ce&&ce.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},ye.reflink=function(se,le){var J;if((J=this.rules.inline.reflink.exec(se))||(J=this.rules.inline.nolink.exec(se))){var _=(J[2]||J[1]).replace(/\s+/g," ");if(_=le[_.toLowerCase()],!_||!_.href){var L=J[0].charAt(0);return{type:"text",raw:L,text:L}}return H(J,_,J[0],this.lexer)}},ye.emStrong=function(se,le,J){J===void 0&&(J="");var _=this.rules.inline.emStrong.lDelim.exec(se);if(!!_&&!(_[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var L=_[1]||_[2]||"";if(!L||L&&(J===""||this.rules.inline.punctuation.exec(J))){var W=_[0].length-1,q,ee,ce=W,be=0,oe=_[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,le=le.slice(-1*se.length+W);(_=oe.exec(le))!=null;)if(q=_[1]||_[2]||_[3]||_[4]||_[5]||_[6],!!q){if(ee=q.length,_[3]||_[4]){ce+=ee;continue}else if((_[5]||_[6])&&W%3&&!((W+ee)%3)){be+=ee;continue}if(ce-=ee,!(ce>0)){if(ee=Math.min(ee,ee+ce+be),Math.min(W,ee)%2){var we=se.slice(1,W+_.index+ee);return{type:"em",raw:se.slice(0,W+_.index+ee+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ve=se.slice(2,W+_.index+ee-1);return{type:"strong",raw:se.slice(0,W+_.index+ee+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},ye.codespan=function(se){var le=this.rules.inline.code.exec(se);if(le){var J=le[2].replace(/\n/g," "),_=/[^ ]/.test(J),L=/^ /.test(J)&&/ $/.test(J);return _&&L&&(J=J.substring(1,J.length-1)),J=m(J,!0),{type:"codespan",raw:le[0],text:J}}},ye.br=function(se){var le=this.rules.inline.br.exec(se);if(le)return{type:"br",raw:le[0]}},ye.del=function(se){var le=this.rules.inline.del.exec(se);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},ye.autolink=function(se,le){var J=this.rules.inline.autolink.exec(se);if(J){var _,L;return J[2]==="@"?(_=m(this.options.mangle?le(J[1]):J[1]),L="mailto:"+_):(_=m(J[1]),L=_),{type:"link",raw:J[0],text:_,href:L,tokens:[{type:"text",raw:_,text:_}]}}},ye.url=function(se,le){var J;if(J=this.rules.inline.url.exec(se)){var _,L;if(J[2]==="@")_=m(this.options.mangle?le(J[0]):J[0]),L="mailto:"+_;else{var W;do W=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(W!==J[0]);_=m(J[0]),J[1]==="www."?L="http://"+_:L=_}return{type:"link",raw:J[0],text:_,href:L,tokens:[{type:"text",raw:_,text:_}]}}},ye.inlineText=function(se,le){var J=this.rules.inline.text.exec(se);if(J){var _;return this.lexer.state.inRawBlock?_=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):m(J[0]):J[0]:_=m(this.options.smartypants?le(J[0]):J[0]),{type:"text",raw:J[0],text:_}}},ke}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=p(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=p(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=p(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=p(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=p(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=p(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=o({},U),U.gfm=o({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=p(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=p(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=o({},U.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:p(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=p(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=p(U._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=p(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=p(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=p(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=p(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=p(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=p(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=p(R.reflink).replace("label",R._label).replace("ref",U._label).getRegex(),R.nolink=p(R.nolink).replace("ref",U._label).getRegex(),R.reflinkSearch=p(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=o({},R),R.pedantic=o({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=o({},R.normal,{escape:p(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=p(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=o({},R.gfm,{br:p(R.br).replace("{2,}","*").getRegex(),text:p(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(ke){var ye="",Ce,se,le=ke.length;for(Ce=0;Ce<le;Ce++)se=ke.charCodeAt(Ce),Math.random()>.5&&(se="x"+se.toString(16)),ye+="&#"+se+";";return ye}var B=function(){function ke(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||ie.defaults,this.options.tokenizer=this.options.tokenizer||new P,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:U.normal,inline:R.normal};this.options.pedantic?(se.block=U.pedantic,se.inline=R.pedantic):this.options.gfm&&(se.block=U.gfm,this.options.breaks?se.inline=R.breaks:se.inline=R.gfm),this.tokenizer.rules=se}ke.lex=function(se,le){var J=new ke(le);return J.lex(se)},ke.lexInline=function(se,le){var J=new ke(le);return J.inlineTokens(se)};var ye=ke.prototype;return ye.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},ye.blockTokens=function(se,le){var J=this;le===void 0&&(le=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(ce,be,oe){return be+"    ".repeat(oe.length)});for(var _,L,W,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ce){return(_=ce.call({lexer:J},se,le))?(se=se.substring(_.raw.length),le.push(_),!0):!1}))){if(_=this.tokenizer.space(se)){se=se.substring(_.raw.length),_.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(_);continue}if(_=this.tokenizer.code(se)){se=se.substring(_.raw.length),L=le[le.length-1],L&&(L.type==="paragraph"||L.type==="text")?(L.raw+=`
`+_.raw,L.text+=`
`+_.text,this.inlineQueue[this.inlineQueue.length-1].src=L.text):le.push(_);continue}if(_=this.tokenizer.fences(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.heading(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.hr(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.blockquote(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.list(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.html(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.def(se)){se=se.substring(_.raw.length),L=le[le.length-1],L&&(L.type==="paragraph"||L.type==="text")?(L.raw+=`
`+_.raw,L.text+=`
`+_.raw,this.inlineQueue[this.inlineQueue.length-1].src=L.text):this.tokens.links[_.tag]||(this.tokens.links[_.tag]={href:_.href,title:_.title});continue}if(_=this.tokenizer.table(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.lheading(se)){se=se.substring(_.raw.length),le.push(_);continue}if(W=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ce=1/0,be=se.slice(1),oe=void 0;J.options.extensions.startBlock.forEach(function(we){oe=we.call({lexer:this},be),typeof oe=="number"&&oe>=0&&(ce=Math.min(ce,oe))}),ce<1/0&&ce>=0&&(W=se.substring(0,ce+1))}(),this.state.top&&(_=this.tokenizer.paragraph(W))){L=le[le.length-1],q&&L.type==="paragraph"?(L.raw+=`
`+_.raw,L.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=L.text):le.push(_),q=W.length!==se.length,se=se.substring(_.raw.length);continue}if(_=this.tokenizer.text(se)){se=se.substring(_.raw.length),L=le[le.length-1],L&&L.type==="text"?(L.raw+=`
`+_.raw,L.text+=`
`+_.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=L.text):le.push(_);continue}if(se){var ee="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return this.state.top=!0,le},ye.inline=function(se,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:se,tokens:le}),le},ye.inlineTokens=function(se,le){var J=this;le===void 0&&(le=[]);var _,L,W,q=se,ee,ce,be;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(ee=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)oe.includes(ee[0].slice(ee[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,ee.index)+"["+j("a",ee[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ee=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,ee.index)+"["+j("a",ee[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ee=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,ee.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ce||(be=""),ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(_=ve.call({lexer:J},se,le))?(se=se.substring(_.raw.length),le.push(_),!0):!1}))){if(_=this.tokenizer.escape(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.tag(se)){se=se.substring(_.raw.length),L=le[le.length-1],L&&_.type==="text"&&L.type==="text"?(L.raw+=_.raw,L.text+=_.text):le.push(_);continue}if(_=this.tokenizer.link(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(_.raw.length),L=le[le.length-1],L&&_.type==="text"&&L.type==="text"?(L.raw+=_.raw,L.text+=_.text):le.push(_);continue}if(_=this.tokenizer.emStrong(se,q,be)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.codespan(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.br(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.del(se)){se=se.substring(_.raw.length),le.push(_);continue}if(_=this.tokenizer.autolink(se,z)){se=se.substring(_.raw.length),le.push(_);continue}if(!this.state.inLink&&(_=this.tokenizer.url(se,z))){se=se.substring(_.raw.length),le.push(_);continue}if(W=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ue=se.slice(1),ze=void 0;J.options.extensions.startInline.forEach(function(et){ze=et.call({lexer:this},Ue),typeof ze=="number"&&ze>=0&&(ve=Math.min(ve,ze))}),ve<1/0&&ve>=0&&(W=se.substring(0,ve+1))}(),_=this.tokenizer.inlineText(W,x)){se=se.substring(_.raw.length),_.raw.slice(-1)!=="_"&&(be=_.raw.slice(-1)),ce=!0,L=le[le.length-1],L&&L.type==="text"?(L.raw+=_.raw,L.text+=_.text):le.push(_);continue}if(se){var we="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return le},i(ke,null,[{key:"rules",get:function(){return{block:U,inline:R}}}]),ke}(),K=function(){function ke(Ce){this.options=Ce||ie.defaults}var ye=ke.prototype;return ye.code=function(se,le,J){var _=(le||"").match(/\S*/)[0];if(this.options.highlight){var L=this.options.highlight(se,_);L!=null&&L!==se&&(J=!0,se=L)}return se=se.replace(/\n$/,"")+`
`,_?'<pre><code class="'+this.options.langPrefix+m(_,!0)+'">'+(J?se:m(se,!0))+`</code></pre>
`:"<pre><code>"+(J?se:m(se,!0))+`</code></pre>
`},ye.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},ye.html=function(se){return se},ye.heading=function(se,le,J,_){if(this.options.headerIds){var L=this.options.headerPrefix+_.slug(J);return"<h"+le+' id="'+L+'">'+se+"</h"+le+`>
`}return"<h"+le+">"+se+"</h"+le+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(se,le,J){var _=le?"ol":"ul",L=le&&J!==1?' start="'+J+'"':"";return"<"+_+L+`>
`+se+"</"+_+`>
`},ye.listitem=function(se){return"<li>"+se+`</li>
`},ye.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(se){return"<p>"+se+`</p>
`},ye.table=function(se,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+le+`</table>
`},ye.tablerow=function(se){return`<tr>
`+se+`</tr>
`},ye.tablecell=function(se,le){var J=le.header?"th":"td",_=le.align?"<"+J+' align="'+le.align+'">':"<"+J+">";return _+se+("</"+J+`>
`)},ye.strong=function(se){return"<strong>"+se+"</strong>"},ye.em=function(se){return"<em>"+se+"</em>"},ye.codespan=function(se){return"<code>"+se+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(se){return"<del>"+se+"</del>"},ye.link=function(se,le,J){if(se=C(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var _='<a href="'+m(se)+'"';return le&&(_+=' title="'+le+'"'),_+=">"+J+"</a>",_},ye.image=function(se,le,J){if(se=C(this.options.sanitize,this.options.baseUrl,se),se===null)return J;var _='<img src="'+se+'" alt="'+J+'"';return le&&(_+=' title="'+le+'"'),_+=this.options.xhtml?"/>":">",_},ye.text=function(se){return se},ke}(),Z=function(){function ke(){}var ye=ke.prototype;return ye.strong=function(se){return se},ye.em=function(se){return se},ye.codespan=function(se){return se},ye.del=function(se){return se},ye.html=function(se){return se},ye.text=function(se){return se},ye.link=function(se,le,J){return""+J},ye.image=function(se,le,J){return""+J},ye.br=function(){return""},ke}(),ue=function(){function ke(){this.seen={}}var ye=ke.prototype;return ye.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(se,le){var J=se,_=0;if(this.seen.hasOwnProperty(J)){_=this.seen[se];do _++,J=se+"-"+_;while(this.seen.hasOwnProperty(J))}return le||(this.seen[se]=_,this.seen[J]=0),J},ye.slug=function(se,le){le===void 0&&(le={});var J=this.serialize(se);return this.getNextSafeSlug(J,le.dryrun)},ke}(),ne=function(){function ke(Ce){this.options=Ce||ie.defaults,this.options.renderer=this.options.renderer||new K,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new ue}ke.parse=function(se,le){var J=new ke(le);return J.parse(se)},ke.parseInline=function(se,le){var J=new ke(le);return J.parseInline(se)};var ye=ke.prototype;return ye.parse=function(se,le){le===void 0&&(le=!0);var J="",_,L,W,q,ee,ce,be,oe,we,ve,Ue,ze,et,Ke,tt,Fe,ht,X,Q,ge=se.length;for(_=0;_<ge;_++){if(ve=se[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Q=this.options.extensions.renderers[ve.type].call({parser:this},ve),Q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){J+=Q||"";continue}switch(ve.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,s(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(oe="",be="",q=ve.header.length,L=0;L<q;L++)be+=this.renderer.tablecell(this.parseInline(ve.header[L].tokens),{header:!0,align:ve.align[L]});for(oe+=this.renderer.tablerow(be),we="",q=ve.rows.length,L=0;L<q;L++){for(ce=ve.rows[L],be="",ee=ce.length,W=0;W<ee;W++)be+=this.renderer.tablecell(this.parseInline(ce[W].tokens),{header:!1,align:ve.align[W]});we+=this.renderer.tablerow(be)}J+=this.renderer.table(oe,we);continue}case"blockquote":{we=this.parse(ve.tokens),J+=this.renderer.blockquote(we);continue}case"list":{for(Ue=ve.ordered,ze=ve.start,et=ve.loose,q=ve.items.length,we="",L=0;L<q;L++)tt=ve.items[L],Fe=tt.checked,ht=tt.task,Ke="",tt.task&&(X=this.renderer.checkbox(Fe),et?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=X+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=X+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:X}):Ke+=X),Ke+=this.parse(tt.tokens,et),we+=this.renderer.listitem(Ke,ht,Fe);J+=this.renderer.list(we,Ue,ze);continue}case"html":{J+=this.renderer.html(ve.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(we=ve.tokens?this.parseInline(ve.tokens):ve.text;_+1<ge&&se[_+1].type==="text";)ve=se[++_],we+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);J+=le?this.renderer.paragraph(we):we;continue}default:{var Ne='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return J},ye.parseInline=function(se,le){le=le||this.renderer;var J="",_,L,W,q=se.length;for(_=0;_<q;_++){if(L=se[_],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[L.type]&&(W=this.options.extensions.renderers[L.type].call({parser:this},L),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(L.type))){J+=W||"";continue}switch(L.type){case"escape":{J+=le.text(L.text);break}case"html":{J+=le.html(L.text);break}case"link":{J+=le.link(L.href,L.title,this.parseInline(L.tokens,le));break}case"image":{J+=le.image(L.href,L.title,L.text);break}case"strong":{J+=le.strong(this.parseInline(L.tokens,le));break}case"em":{J+=le.em(this.parseInline(L.tokens,le));break}case"codespan":{J+=le.codespan(L.text);break}case"br":{J+=le.br();break}case"del":{J+=le.del(this.parseInline(L.tokens,le));break}case"text":{J+=le.text(L.text);break}default:{var ee='Token with "'+L.type+'" type was not found.';if(this.options.silent){console.error(ee);return}else throw new Error(ee)}}}return J},ke}();function pe(ke,ye,Ce){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof ye=="function"&&(Ce=ye,ye=null),ye=o({},pe.defaults,ye||{}),F(ye),Ce){var se=ye.highlight,le;try{le=B.lex(ke,ye)}catch(q){return Ce(q)}var J=function(ee){var ce;if(!ee)try{ye.walkTokens&&pe.walkTokens(le,ye.walkTokens),ce=ne.parse(le,ye)}catch(be){ee=be}return ye.highlight=se,ee?Ce(ee):Ce(null,ce)};if(!se||se.length<3||(delete ye.highlight,!le.length))return J();var _=0;pe.walkTokens(le,function(q){q.type==="code"&&(_++,setTimeout(function(){se(q.text,q.lang,function(ee,ce){if(ee)return J(ee);ce!=null&&ce!==q.text&&(q.text=ce,q.escaped=!0),_--,_===0&&J()})},0))}),_===0&&J();return}function L(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+m(q.message+"",!0)+"</pre>";throw q}try{var W=B.lex(ke,ye);if(ye.walkTokens){if(ye.async)return Promise.all(pe.walkTokens(W,ye.walkTokens)).then(function(){return ne.parse(W,ye)}).catch(L);pe.walkTokens(W,ye.walkTokens)}return ne.parse(W,ye)}catch(q){L(q)}}pe.options=pe.setOptions=function(ke){return o(pe.defaults,ke),A(pe.defaults),pe},pe.getDefaults=D,pe.defaults=ie.defaults,pe.use=function(){for(var ke=arguments.length,ye=new Array(ke),Ce=0;Ce<ke;Ce++)ye[Ce]=arguments[Ce];var se=o.apply(void 0,[{}].concat(ye)),le=pe.defaults.extensions||{renderers:{},childTokens:{}},J;ye.forEach(function(_){if(_.extensions&&(J=!0,_.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var q=le.renderers?le.renderers[W.name]:null;q?le.renderers[W.name]=function(){for(var ee=arguments.length,ce=new Array(ee),be=0;be<ee;be++)ce[be]=arguments[be];var oe=W.renderer.apply(this,ce);return oe===!1&&(oe=q.apply(this,ce)),oe}:le.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[W.level]?le[W.level].unshift(W.tokenizer):le[W.level]=[W.tokenizer],W.start&&(W.level==="block"?le.startBlock?le.startBlock.push(W.start):le.startBlock=[W.start]:W.level==="inline"&&(le.startInline?le.startInline.push(W.start):le.startInline=[W.start]))}W.childTokens&&(le.childTokens[W.name]=W.childTokens)})),_.renderer&&function(){var W=pe.defaults.renderer||new K,q=function(be){var oe=W[be];W[be]=function(){for(var we=arguments.length,ve=new Array(we),Ue=0;Ue<we;Ue++)ve[Ue]=arguments[Ue];var ze=_.renderer[be].apply(W,ve);return ze===!1&&(ze=oe.apply(W,ve)),ze}};for(var ee in _.renderer)q(ee);se.renderer=W}(),_.tokenizer&&function(){var W=pe.defaults.tokenizer||new P,q=function(be){var oe=W[be];W[be]=function(){for(var we=arguments.length,ve=new Array(we),Ue=0;Ue<we;Ue++)ve[Ue]=arguments[Ue];var ze=_.tokenizer[be].apply(W,ve);return ze===!1&&(ze=oe.apply(W,ve)),ze}};for(var ee in _.tokenizer)q(ee);se.tokenizer=W}(),_.walkTokens){var L=pe.defaults.walkTokens;se.walkTokens=function(W){var q=[];return q.push(_.walkTokens.call(this,W)),L&&(q=q.concat(L.call(this,W))),q}}J&&(se.extensions=le),pe.setOptions(se)})},pe.walkTokens=function(ke,ye){for(var Ce=[],se=function(){var L=J.value;switch(Ce=Ce.concat(ye.call(pe,L)),L.type){case"table":{for(var W=M(L.header),q;!(q=W()).done;){var ee=q.value;Ce=Ce.concat(pe.walkTokens(ee.tokens,ye))}for(var ce=M(L.rows),be;!(be=ce()).done;)for(var oe=be.value,we=M(oe),ve;!(ve=we()).done;){var Ue=ve.value;Ce=Ce.concat(pe.walkTokens(Ue.tokens,ye))}break}case"list":{Ce=Ce.concat(pe.walkTokens(L.items,ye));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[L.type]?pe.defaults.extensions.childTokens[L.type].forEach(function(ze){Ce=Ce.concat(pe.walkTokens(L[ze],ye))}):L.tokens&&(Ce=Ce.concat(pe.walkTokens(L.tokens,ye)))}},le=M(ke),J;!(J=le()).done;)se();return Ce},pe.parseInline=function(ke,ye){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");ye=o({},pe.defaults,ye||{}),F(ye);try{var Ce=B.lexInline(ke,ye);return ye.walkTokens&&pe.walkTokens(Ce,ye.walkTokens),ne.parseInline(Ce,ye)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+m(se.message+"",!0)+"</pre>";throw se}},pe.Parser=ne,pe.parser=ne.parse,pe.Renderer=K,pe.TextRenderer=Z,pe.Lexer=B,pe.lexer=B.lex,pe.Tokenizer=P,pe.Slugger=ue,pe.parse=pe;var ae=pe.options,de=pe.setOptions,Y=pe.use,me=pe.walkTokens,Se=pe.parseInline,Oe=pe,Be=ne.parse,Xe=B.lex;ie.Lexer=B,ie.Parser=ne,ie.Renderer=K,ie.Slugger=ue,ie.TextRenderer=Z,ie.Tokenizer=P,ie.getDefaults=D,ie.lexer=Xe,ie.marked=pe,ie.options=ae,ie.parse=Oe,ie.parseInline=Se,ie.parser=Be,ie.setOptions=de,ie.use=Y,ie.walkTokens=me,Object.defineProperty(ie,"__esModule",{value:!0})}),define(De[108],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function i(A,y,T){return Math.min(Math.max(A,y),T)}e.clamp=i;function I(A,y){return(y+A%y)%y}e.rot=I;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class M{constructor(){this._n=1,this._val=0}update(y){return this._val=this._val+(y-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=M;class D{constructor(y){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(y),this._values.fill(0,0,y)}update(y){const T=this._values[this._index];return this._values[this._index]=y,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=y,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function ie(w){const M=[];typeof w=="number"&&M.push("code/timeOrigin",w);function D(y){M.push(y,Date.now())}function A(){const y=[];for(let T=0;T<M.length;T+=2)y.push({name:M[T],startTime:M[T+1]});return y}return{mark:D,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(w+D.startTime)});return M}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function i(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return i(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=i(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=i(I))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var i=e();for(var I in i)(typeof exports=="object"?exports:ie)[I]=i[I]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function i(I){if(e[I])return e[I].exports;var w=e[I]={i:I,l:!1,exports:{}};return ie[I].call(w.exports,w,w.exports,i),w.l=!0,w.exports}return i.m=ie,i.c=e,i.d=function(I,w,M){i.o(I,w)||Object.defineProperty(I,w,{enumerable:!0,get:M})},i.r=function(I){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(I,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(I,"__esModule",{value:!0})},i.t=function(I,w){if(1&w&&(I=i(I)),8&w||4&w&&typeof I=="object"&&I&&I.__esModule)return I;var M=Object.create(null);if(i.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:I}),2&w&&typeof I!="string")for(var D in I)i.d(M,D,function(A){return I[A]}.bind(null,D));return M},i.n=function(I){var w=I&&I.__esModule?function(){return I.default}:function(){return I};return i.d(w,"a",w),w},i.o=function(I,w){return Object.prototype.hasOwnProperty.call(I,w)},i.p="",i(i.s=0)}([function(ie,e,i){(function(I){var w;e=ie.exports=Y,w=typeof I=="object"&&I.env&&I.env.NODE_DEBUG&&/\bsemver\b/i.test(I.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],T=0,O=T++;y[O]="0|[1-9]\\d*";var b=T++;y[b]="[0-9]+";var g=T++;y[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=T++;y[E]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var m=T++;y[m]="("+y[b]+")\\.("+y[b]+")\\.("+y[b]+")";var t=T++;y[t]="(?:"+y[O]+"|"+y[g]+")";var s=T++;y[s]="(?:"+y[b]+"|"+y[g]+")";var a=T++;y[a]="(?:-("+y[t]+"(?:\\."+y[t]+")*))";var p=T++;y[p]="(?:-?("+y[s]+"(?:\\."+y[s]+")*))";var S=T++;y[S]="[0-9A-Za-z-]+";var u=T++;y[u]="(?:\\+("+y[S]+"(?:\\."+y[S]+")*))";var C=T++,r="v?"+y[E]+y[a]+"?"+y[u]+"?";y[C]="^"+r+"$";var c="[v=\\s]*"+y[m]+y[p]+"?"+y[u]+"?",n=T++;y[n]="^"+c+"$";var d=T++;y[d]="((?:<|>)?=?)";var l=T++;y[l]=y[b]+"|x|X|\\*";var f=T++;y[f]=y[O]+"|x|X|\\*";var o=T++;y[o]="[v=\\s]*("+y[f]+")(?:\\.("+y[f]+")(?:\\.("+y[f]+")(?:"+y[a]+")?"+y[u]+"?)?)?";var h=T++;y[h]="[v=\\s]*("+y[l]+")(?:\\.("+y[l]+")(?:\\.("+y[l]+")(?:"+y[p]+")?"+y[u]+"?)?)?";var v=T++;y[v]="^"+y[d]+"\\s*"+y[o]+"$";var k=T++;y[k]="^"+y[d]+"\\s*"+y[h]+"$";var F=T++;y[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=T++;y[j]="(?:~>?)";var H=T++;y[H]="(\\s*)"+y[j]+"\\s+",A[H]=new RegExp(y[H],"g");var V=T++;y[V]="^"+y[j]+y[o]+"$";var P=T++;y[P]="^"+y[j]+y[h]+"$";var U=T++;y[U]="(?:\\^)";var R=T++;y[R]="(\\s*)"+y[U]+"\\s+",A[R]=new RegExp(y[R],"g");var x=T++;y[x]="^"+y[U]+y[o]+"$";var z=T++;y[z]="^"+y[U]+y[h]+"$";var B=T++;y[B]="^"+y[d]+"\\s*("+c+")$|^$";var K=T++;y[K]="^"+y[d]+"\\s*("+r+")$|^$";var Z=T++;y[Z]="(\\s*)"+y[d]+"\\s*("+c+"|"+y[o]+")",A[Z]=new RegExp(y[Z],"g");var ue=T++;y[ue]="^\\s*("+y[o]+")\\s+-\\s+("+y[o]+")\\s*$";var ne=T++;y[ne]="^\\s*("+y[h]+")\\s+-\\s+("+y[h]+")\\s*$";var pe=T++;y[pe]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)w(ae,y[ae]),A[ae]||(A[ae]=new RegExp(y[ae]));function de(oe,we){if(oe instanceof Y)return oe;if(typeof oe!="string"||oe.length>M||!(we?A[n]:A[C]).test(oe))return null;try{return new Y(oe,we)}catch{return null}}function Y(oe,we){if(oe instanceof Y){if(oe.loose===we)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof Y))return new Y(oe,we);w("SemVer",oe,we),this.loose=we;var ve=oe.trim().match(we?A[n]:A[C]);if(!ve)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var ze=+Ue;if(ze>=0&&ze<D)return ze}return Ue}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=de,e.valid=function(oe,we){var ve=de(oe,we);return ve?ve.version:null},e.clean=function(oe,we){var ve=de(oe.trim().replace(/^[=v]+/,""),we);return ve?ve.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(oe){return w("SemVer.compare",this.version,this.loose,oe),oe instanceof Y||(oe=new Y(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},Y.prototype.compareMain=function(oe){return oe instanceof Y||(oe=new Y(oe,this.loose)),Se(this.major,oe.major)||Se(this.minor,oe.minor)||Se(this.patch,oe.patch)},Y.prototype.comparePre=function(oe){if(oe instanceof Y||(oe=new Y(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var we=0;do{var ve=this.prerelease[we],Ue=oe.prerelease[we];if(w("prerelease compare",we,ve,Ue),ve===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ue)return Se(ve,Ue)}while(++we)},Y.prototype.inc=function(oe,we){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,we,ve,Ue){typeof ve=="string"&&(Ue=ve,ve=void 0);try{return new Y(oe,ve).inc(we,Ue).version}catch{return null}},e.diff=function(oe,we){if(ke(oe,we))return null;var ve=de(oe),Ue=de(we);if(ve.prerelease.length||Ue.prerelease.length){for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ue[ze])return"pre"+ze;return"prerelease"}for(var ze in ve)if((ze==="major"||ze==="minor"||ze==="patch")&&ve[ze]!==Ue[ze])return ze},e.compareIdentifiers=Se;var me=/^[0-9]+$/;function Se(oe,we){var ve=me.test(oe),Ue=me.test(we);return ve&&Ue&&(oe=+oe,we=+we),ve&&!Ue?-1:Ue&&!ve?1:oe<we?-1:oe>we?1:0}function Oe(oe,we,ve){return new Y(oe,ve).compare(new Y(we,ve))}function Be(oe,we,ve){return Oe(oe,we,ve)>0}function Xe(oe,we,ve){return Oe(oe,we,ve)<0}function ke(oe,we,ve){return Oe(oe,we,ve)===0}function ye(oe,we,ve){return Oe(oe,we,ve)!==0}function Ce(oe,we,ve){return Oe(oe,we,ve)>=0}function se(oe,we,ve){return Oe(oe,we,ve)<=0}function le(oe,we,ve,Ue){var ze;switch(we){case"===":typeof oe=="object"&&(oe=oe.version),typeof ve=="object"&&(ve=ve.version),ze=oe===ve;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof ve=="object"&&(ve=ve.version),ze=oe!==ve;break;case"":case"=":case"==":ze=ke(oe,ve,Ue);break;case"!=":ze=ye(oe,ve,Ue);break;case">":ze=Be(oe,ve,Ue);break;case">=":ze=Ce(oe,ve,Ue);break;case"<":ze=Xe(oe,ve,Ue);break;case"<=":ze=se(oe,ve,Ue);break;default:throw new TypeError("Invalid operator: "+we)}return ze}function J(oe,we){if(oe instanceof J){if(oe.loose===we)return oe;oe=oe.value}if(!(this instanceof J))return new J(oe,we);w("comparator",oe,we),this.loose=we,this.parse(oe),this.semver===_?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}e.rcompareIdentifiers=function(oe,we){return Se(we,oe)},e.major=function(oe,we){return new Y(oe,we).major},e.minor=function(oe,we){return new Y(oe,we).minor},e.patch=function(oe,we){return new Y(oe,we).patch},e.compare=Oe,e.compareLoose=function(oe,we){return Oe(oe,we,!0)},e.rcompare=function(oe,we,ve){return Oe(we,oe,ve)},e.sort=function(oe,we){return oe.sort(function(ve,Ue){return e.compare(ve,Ue,we)})},e.rsort=function(oe,we){return oe.sort(function(ve,Ue){return e.rcompare(ve,Ue,we)})},e.gt=Be,e.lt=Xe,e.eq=ke,e.neq=ye,e.gte=Ce,e.lte=se,e.cmp=le,e.Comparator=J;var _={};function L(oe,we){if(oe instanceof L)return oe.loose===we?oe:new L(oe.raw,we);if(oe instanceof J)return new L(oe.value,we);if(!(this instanceof L))return new L(oe,we);if(this.loose=we,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function W(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function q(oe,we,ve,Ue,ze,et,Ke,tt,Fe,ht,X,Q,ge){return((we=W(ve)?"":W(Ue)?">="+ve+".0.0":W(ze)?">="+ve+"."+Ue+".0":">="+we)+" "+(tt=W(Fe)?"":W(ht)?"<"+(+Fe+1)+".0.0":W(X)?"<"+Fe+"."+(+ht+1)+".0":Q?"<="+Fe+"."+ht+"."+X+"-"+Q:"<="+tt)).trim()}function ee(oe,we){for(var ve=0;ve<oe.length;ve++)if(!oe[ve].test(we))return!1;if(we.prerelease.length){for(ve=0;ve<oe.length;ve++)if(w(oe[ve].semver),oe[ve].semver!==_&&oe[ve].semver.prerelease.length>0){var Ue=oe[ve].semver;if(Ue.major===we.major&&Ue.minor===we.minor&&Ue.patch===we.patch)return!0}return!1}return!0}function ce(oe,we,ve){try{we=new L(we,ve)}catch{return!1}return we.test(oe)}function be(oe,we,ve,Ue){var ze,et,Ke,tt,Fe;switch(oe=new Y(oe,Ue),we=new L(we,Ue),ve){case">":ze=Be,et=se,Ke=Xe,tt=">",Fe=">=";break;case"<":ze=Xe,et=Ce,Ke=Be,tt="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ce(oe,we,Ue))return!1;for(var ht=0;ht<we.set.length;++ht){var X=we.set[ht],Q=null,ge=null;if(X.forEach(function(Ne){Ne.semver===_&&(Ne=new J(">=0.0.0")),Q=Q||Ne,ge=ge||Ne,ze(Ne.semver,Q.semver,Ue)?Q=Ne:Ke(Ne.semver,ge.semver,Ue)&&(ge=Ne)}),Q.operator===tt||Q.operator===Fe||(!ge.operator||ge.operator===tt)&&et(oe,ge.semver)||ge.operator===Fe&&Ke(oe,ge.semver))return!1}return!0}J.prototype.parse=function(oe){var we=this.loose?A[B]:A[K],ve=oe.match(we);if(!ve)throw new TypeError("Invalid comparator: "+oe);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new Y(ve[2],this.loose):this.semver=_},J.prototype.toString=function(){return this.value},J.prototype.test=function(oe){return w("Comparator.test",oe,this.loose),this.semver===_||(typeof oe=="string"&&(oe=new Y(oe,this.loose)),le(oe,this.operator,this.semver,this.loose))},J.prototype.intersects=function(oe,we){if(!(oe instanceof J))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new L(oe.value,we),ce(this.value,ve,we);if(oe.operator==="")return ve=new L(this.value,we),ce(oe.semver,ve,we);var Ue=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),et=this.semver.version===oe.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),tt=le(this.semver,"<",oe.semver,we)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Fe=le(this.semver,">",oe.semver,we)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Ue||ze||et&&Ke||tt||Fe},e.Range=L,L.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},L.prototype.toString=function(){return this.range},L.prototype.parseRange=function(oe){var we=this.loose;oe=oe.trim(),w("range",oe,we);var ve=we?A[ne]:A[ue];oe=oe.replace(ve,q),w("hyphen replace",oe),oe=oe.replace(A[Z],"$1$2$3"),w("comparator trim",oe,A[Z]),oe=(oe=(oe=oe.replace(A[H],"$1~")).replace(A[R],"$1^")).split(/\s+/).join(" ");var Ue=we?A[B]:A[K],ze=oe.split(" ").map(function(et){return function(Ke,tt){return w("comp",Ke),Ke=function(Fe,ht){return Fe.trim().split(/\s+/).map(function(X){return function(Q,ge){w("caret",Q,ge);var Ne=ge?A[z]:A[x];return Q.replace(Ne,function(je,qe,We,Ze,nt){var ct;return w("caret",Q,je,qe,We,Ze,nt),W(qe)?ct="":W(We)?ct=">="+qe+".0.0 <"+(+qe+1)+".0.0":W(Ze)?ct=qe==="0"?">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+".0 <"+(+qe+1)+".0.0":nt?(w("replaceCaret pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=qe==="0"?We==="0"?">="+qe+"."+We+"."+Ze+nt+" <"+qe+"."+We+"."+(+Ze+1):">="+qe+"."+We+"."+Ze+nt+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+Ze+nt+" <"+(+qe+1)+".0.0"):(w("no pr"),ct=qe==="0"?We==="0"?">="+qe+"."+We+"."+Ze+" <"+qe+"."+We+"."+(+Ze+1):">="+qe+"."+We+"."+Ze+" <"+qe+"."+(+We+1)+".0":">="+qe+"."+We+"."+Ze+" <"+(+qe+1)+".0.0"),w("caret return",ct),ct})}(X,ht)}).join(" ")}(Ke,tt),w("caret",Ke),Ke=function(Fe,ht){return Fe.trim().split(/\s+/).map(function(X){return function(Q,ge){var Ne=ge?A[P]:A[V];return Q.replace(Ne,function(je,qe,We,Ze,nt){var ct;return w("tilde",Q,je,qe,We,Ze,nt),W(qe)?ct="":W(We)?ct=">="+qe+".0.0 <"+(+qe+1)+".0.0":W(Ze)?ct=">="+qe+"."+We+".0 <"+qe+"."+(+We+1)+".0":nt?(w("replaceTilde pr",nt),nt.charAt(0)!=="-"&&(nt="-"+nt),ct=">="+qe+"."+We+"."+Ze+nt+" <"+qe+"."+(+We+1)+".0"):ct=">="+qe+"."+We+"."+Ze+" <"+qe+"."+(+We+1)+".0",w("tilde return",ct),ct})}(X,ht)}).join(" ")}(Ke,tt),w("tildes",Ke),Ke=function(Fe,ht){return w("replaceXRanges",Fe,ht),Fe.split(/\s+/).map(function(X){return function(Q,ge){Q=Q.trim();var Ne=ge?A[k]:A[v];return Q.replace(Ne,function(je,qe,We,Ze,nt,ct){w("xRange",Q,je,qe,We,Ze,nt,ct);var It=W(We),at=It||W(Ze),rt=at||W(nt);return qe==="="&&rt&&(qe=""),It?je=qe===">"||qe==="<"?"<0.0.0":"*":qe&&rt?(at&&(Ze=0),rt&&(nt=0),qe===">"?(qe=">=",at?(We=+We+1,Ze=0,nt=0):rt&&(Ze=+Ze+1,nt=0)):qe==="<="&&(qe="<",at?We=+We+1:Ze=+Ze+1),je=qe+We+"."+Ze+"."+nt):at?je=">="+We+".0.0 <"+(+We+1)+".0.0":rt&&(je=">="+We+"."+Ze+".0 <"+We+"."+(+Ze+1)+".0"),w("xRange return",je),je})}(X,ht)}).join(" ")}(Ke,tt),w("xrange",Ke),Ke=function(Fe,ht){return w("replaceStars",Fe,ht),Fe.trim().replace(A[pe],"")}(Ke,tt),w("stars",Ke),Ke}(et,we)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(et){return!!et.match(Ue)})),ze=ze.map(function(et){return new J(et,we)})},L.prototype.intersects=function(oe,we){if(!(oe instanceof L))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ue){return oe.set.some(function(ze){return ze.every(function(et){return Ue.intersects(et,we)})})})})},e.toComparators=function(oe,we){return new L(oe,we).set.map(function(ve){return ve.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},L.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new Y(oe,this.loose));for(var we=0;we<this.set.length;we++)if(ee(this.set[we],oe))return!0;return!1},e.satisfies=ce,e.maxSatisfying=function(oe,we,ve){var Ue=null,ze=null;try{var et=new L(we,ve)}catch{return null}return oe.forEach(function(Ke){et.test(Ke)&&(Ue&&ze.compare(Ke)!==-1||(ze=new Y(Ue=Ke,ve)))}),Ue},e.minSatisfying=function(oe,we,ve){var Ue=null,ze=null;try{var et=new L(we,ve)}catch{return null}return oe.forEach(function(Ke){et.test(Ke)&&(Ue&&ze.compare(Ke)!==1||(ze=new Y(Ue=Ke,ve)))}),Ue},e.validRange=function(oe,we){try{return new L(oe,we).range||"*"}catch{return null}},e.ltr=function(oe,we,ve){return be(oe,we,"<",ve)},e.gtr=function(oe,we,ve){return be(oe,we,">",ve)},e.outside=be,e.prerelease=function(oe,we){var ve=de(oe,we);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(oe,we,ve){return oe=new L(oe,ve),we=new L(we,ve),oe.intersects(we)},e.coerce=function(oe){if(oe instanceof Y)return oe;if(typeof oe!="string")return null;var we=oe.match(A[F]);return we==null?null:de((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,i(1))},function(ie,e){var i,I,w=ie.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function A(s){if(i===setTimeout)return setTimeout(s,0);if((i===M||!i)&&setTimeout)return i=setTimeout,setTimeout(s,0);try{return i(s,0)}catch{try{return i.call(null,s,0)}catch{return i.call(this,s,0)}}}(function(){try{i=typeof setTimeout=="function"?setTimeout:M}catch{i=M}try{I=typeof clearTimeout=="function"?clearTimeout:D}catch{I=D}})();var y,T=[],O=!1,b=-1;function g(){O&&y&&(O=!1,y.length?T=y.concat(T):b=-1,T.length&&E())}function E(){if(!O){var s=A(g);O=!0;for(var a=T.length;a;){for(y=T,T=[];++b<a;)y&&y[b].run();b=-1,a=T.length}y=null,O=!1,function(p){if(I===clearTimeout)return clearTimeout(p);if((I===D||!I)&&clearTimeout)return I=clearTimeout,clearTimeout(p);try{I(p)}catch{try{return I.call(null,p)}catch{return I.call(this,p)}}}(s)}}function m(s,a){this.fun=s,this.array=a}function t(){}w.nextTick=function(s){var a=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)a[p-1]=arguments[p];T.push(new m(s,a)),T.length!==1||O||A(E)},m.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=t,w.addListener=t,w.once=t,w.off=t,w.removeListener=t,w.removeAllListeners=t,w.emit=t,w.prependListener=t,w.prependOnceListener=t,w.listeners=function(s){return[]},w.binding=function(s){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(s){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(De[109],Ie([1,0,12,7]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(u){const C=u;return C?typeof C.read=="function":!1}e.isReadable=w;function M(u){const C=u;return C?[C.on,C.pause,C.resume,C.destroy].every(r=>typeof r=="function"):!1}e.isReadableStream=M;function D(u){const C=u;return C?M(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.isReadableBufferedStream=D;function A(u,C){return new y(u,C)}e.newWriteableStream=A;class y{constructor(C,r){this.reducer=C,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(C){if(!this.state.destroyed){if(this.state.flowing)this.emitData(C);else if(this.buffer.data.push(C),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(r=>this.pendingWritePromises.push(r))}}error(C){this.state.destroyed||(this.state.flowing?this.emitError(C):this.buffer.error.push(C))}end(C){this.state.destroyed||(typeof C<"u"&&this.write(C),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(C){this.listeners.data.slice(0).forEach(r=>r(C))}emitError(C){this.listeners.error.length===0?(0,i.onUnexpectedError)(C):this.listeners.error.slice(0).forEach(r=>r(C))}emitEnd(){this.listeners.end.slice(0).forEach(C=>C())}on(C,r){if(!this.state.destroyed)switch(C){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(C,r){if(this.state.destroyed)return;let c;switch(C){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const n=c.indexOf(r);n>=0&&c.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const C=this.reducer(this.buffer.data);this.emitData(C),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const C of this.buffer.error)this.emitError(C);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function T(u,C){const r=[];let c;for(;(c=u.read())!==null;)r.push(c);return C(r)}e.consumeReadable=T;function O(u,C,r){const c=[];let n;for(;(n=u.read())!==null&&c.length<r;)c.push(n);return n===null&&c.length>0?C(c):{read:()=>{if(c.length>0)return c.shift();if(typeof n<"u"){const d=n;return n=void 0,d}return u.read()}}}e.peekReadable=O;function b(u,C){return new Promise((r,c)=>{const n=[];g(u,{onData:d=>{C&&n.push(d)},onError:d=>{C?c(d):r(void 0)},onEnd:()=>{r(C?C(n):void 0)}})})}e.consumeStream=b;function g(u,C){let r=!1;return u.on("error",c=>{r||C.onError(c)}),u.on("end",()=>{r||C.onEnd()}),u.on("data",c=>{r||C.onData(c)}),(0,I.toDisposable)(()=>r=!0)}e.listenStream=g;function E(u,C){return new Promise((r,c)=>{const n=new I.DisposableStore,d=[],l=h=>{if(d.push(h),d.length>C)return n.dispose(),u.pause(),r({stream:u,buffer:d,ended:!1})},f=h=>c(h),o=()=>r({stream:u,buffer:d,ended:!0});n.add((0,I.toDisposable)(()=>u.removeListener("error",f))),u.on("error",f),n.add((0,I.toDisposable)(()=>u.removeListener("end",o))),u.on("end",o),n.add((0,I.toDisposable)(()=>u.removeListener("data",l))),u.on("data",l)})}e.peekStream=E;function m(u,C){const r=A(C);return r.end(u),r}e.toStream=m;function t(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=t;function s(u){let C=!1;return{read:()=>C?null:(C=!0,u)}}e.toReadable=s;function a(u,C,r){const c=A(r);return g(u,{onData:n=>c.write(C.data(n)),onError:n=>c.error(C.error?C.error(n):n),onEnd:()=>c.end()}),c}e.transform=a;function p(u,C,r){let c=!1;return{read:()=>{const n=C.read();return c?n:(c=!0,n!==null?r([u,n]):u)}}}e.prefixedReadable=p;function S(u,C,r){let c=!1;const n=A(r);return g(C,{onData:d=>c?n.write(d):(c=!0,n.write(r([u,d]))),onError:d=>n.error(d),onEnd:()=>{c||(c=!0,n.write(u)),n.end()}}),n}e.prefixedStream=S}),define(De[24],Ie([1,0,109]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const I=typeof Buffer<"u";let w,M;class D{static alloc(h){return I?new D(Buffer.allocUnsafe(h)):new D(new Uint8Array(h))}static wrap(h){return I&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new D(h)}static fromString(h,v){return!(v?.dontUseNodeBuffer||!1)&&I?new D(Buffer.from(h)):(w||(w=new TextEncoder),new D(w.encode(h)))}static fromByteArray(h){const v=D.alloc(h.length);for(let k=0,F=h.length;k<F;k++)v.buffer[k]=h[k];return v}static concat(h,v){if(typeof v>"u"){v=0;for(let j=0,H=h.length;j<H;j++)v+=h[j].byteLength}const k=D.alloc(v);let F=0;for(let j=0,H=h.length;j<H;j++){const V=h[j];k.set(V,F),F+=V.byteLength}return k}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=D.alloc(this.byteLength);return h.set(this),h}toString(){return I?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(h,v){return new D(this.buffer.subarray(h,v))}set(h,v){if(h instanceof D)this.buffer.set(h.buffer,v);else if(h instanceof Uint8Array)this.buffer.set(h,v);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),v);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return T(this.buffer,h)}writeUInt32BE(h,v){O(this.buffer,h,v)}readUInt32LE(h){return b(this.buffer,h)}writeUInt32LE(h,v){g(this.buffer,h,v)}readUInt8(h){return E(this.buffer,h)}writeUInt8(h,v){m(this.buffer,h,v)}}e.VSBuffer=D;function A(o,h){return o[h+0]<<0>>>0|o[h+1]<<8>>>0}e.readUInt16LE=A;function y(o,h,v){o[v+0]=h&255,h=h>>>8,o[v+1]=h&255}e.writeUInt16LE=y;function T(o,h){return o[h]*2**24+o[h+1]*2**16+o[h+2]*2**8+o[h+3]}e.readUInt32BE=T;function O(o,h,v){o[v+3]=h,h=h>>>8,o[v+2]=h,h=h>>>8,o[v+1]=h,h=h>>>8,o[v]=h}e.writeUInt32BE=O;function b(o,h){return o[h+0]<<0>>>0|o[h+1]<<8>>>0|o[h+2]<<16>>>0|o[h+3]<<24>>>0}e.readUInt32LE=b;function g(o,h,v){o[v+0]=h&255,h=h>>>8,o[v+1]=h&255,h=h>>>8,o[v+2]=h&255,h=h>>>8,o[v+3]=h&255}e.writeUInt32LE=g;function E(o,h){return o[h]}e.readUInt8=E;function m(o,h,v){o[v]=h}e.writeUInt8=m;function t(o){return i.consumeReadable(o,h=>D.concat(h))}e.readableToBuffer=t;function s(o){return i.toReadable(o)}e.bufferToReadable=s;function a(o){return i.consumeStream(o,h=>D.concat(h))}e.streamToBuffer=a;async function p(o){return o.ended?D.concat(o.buffer):D.concat([...o.buffer,await a(o.stream)])}e.bufferedStreamToBuffer=p;function S(o){return i.toStream(o,h=>D.concat(h))}e.bufferToStream=S;function u(o){return i.transform(o,{data:h=>typeof h=="string"?D.fromString(h):D.wrap(h)},h=>D.concat(h))}e.streamToBufferReadableStream=u;function C(o){return i.newWriteableStream(h=>D.concat(h),o)}e.newWriteableBufferStream=C;function r(o,h){return i.prefixedReadable(o,h,v=>D.concat(v))}e.prefixedBufferReadable=r;function c(o,h){return i.prefixedStream(o,h,v=>D.concat(v))}e.prefixedBufferStream=c;function n(o){let h=0,v=0,k=0;const F=new Uint8Array(Math.floor(o.length/4*3)),j=V=>{switch(v){case 3:F[k++]=h|V,v=0;break;case 2:F[k++]=h|V>>>2,h=V<<6,v=3;break;case 1:F[k++]=h|V>>>4,h=V<<4,v=2;break;default:h=V<<2,v=1}};for(let V=0;V<o.length;V++){const P=o.charCodeAt(V);if(P>=65&&P<=90)j(P-65);else if(P>=97&&P<=122)j(P-97+26);else if(P>=48&&P<=57)j(P-48+52);else if(P===43||P===45)j(62);else if(P===47||P===95)j(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${o[V]}`)}}const H=k;for(;v>0;)j(0);return D.wrap(F).slice(0,H)}e.decodeBase64=n;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:o},h=!0,v=!1){const k=v?l:d;let F="";const j=o.byteLength%3;let H=0;for(;H<o.byteLength-j;H+=3){const V=o[H+0],P=o[H+1],U=o[H+2];F+=k[V>>>2],F+=k[(V<<4|P>>>4)&63],F+=k[(P<<2|U>>>6)&63],F+=k[U&63]}if(j===1){const V=o[H+0];F+=k[V>>>2],F+=k[V<<4&63],h&&(F+="==")}else if(j===2){const V=o[H+0],P=o[H+1];F+=k[V>>>2],F+=k[(V<<4|P>>>4)&63],F+=k[P<<2&63],h&&(F+="=")}return F}e.encodeBase64=f}),define(De[38],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(w){return i.test(w)}e.isUUID=I,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const M=new Uint8Array(16),D=[];for(let A=0;A<256;A++)D.push(A.toString(16).padStart(2,"0"));return function(){w(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let y=0,T="";return T+=D[M[y++]],T+=D[M[y++]],T+=D[M[y++]],T+=D[M[y++]],T+="-",T+=D[M[y++]],T+=D[M[y++]],T+="-",T+=D[M[y++]],T+=D[M[y++]],T+="-",T+=D[M[y++]],T+=D[M[y++]],T+="-",T+=D[M[y++]],T+=D[M[y++]],T+=D[M[y++]],T+=D[M[y++]],T+=D[M[y++]],T+=D[M[y++]],T}}()}),define(De[110],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[111],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var i;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(i=e.IndentAction||(e.IndentAction={}));class I{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let y=0,T=A.notIn.length;y<T;y++)switch(A.notIn[y]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const T=A.findTokenIndexAtOffset(y-2),O=A.getStandardTokenType(T);return this.isOK(O)}_findNeutralCharacterInRange(A,y){for(let T=A;T<=y;T++){const O=String.fromCharCode(T);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=I;class w{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)M(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),M(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),M(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),M(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&M(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=w;function M(D,A,y){D.has(A)?D.get(A).push(y):D.set(A,[y])}}),define(De[112],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(De[113],Ie([1,0,112]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,w=I*60,M=w*24,D=M*7,A=M*30,y=M*365;function T(b,g,E){typeof b!="number"&&(b=b.getTime());const m=Math.round((new Date().getTime()-b)/1e3);if(m<-30)return(0,i.localize)(0,null,T(new Date().getTime()+m*1e3,!1));if(m<30)return(0,i.localize)(1,null);let t;return m<I?(t=m,g?t===1?E?(0,i.localize)(2,null,t):(0,i.localize)(3,null,t):E?(0,i.localize)(4,null,t):(0,i.localize)(5,null,t):t===1?E?(0,i.localize)(6,null,t):(0,i.localize)(7,null,t):E?(0,i.localize)(8,null,t):(0,i.localize)(9,null,t)):m<w?(t=Math.floor(m/I),g?t===1?E?(0,i.localize)(10,null,t):(0,i.localize)(11,null,t):E?(0,i.localize)(12,null,t):(0,i.localize)(13,null,t):t===1?E?(0,i.localize)(14,null,t):(0,i.localize)(15,null,t):E?(0,i.localize)(16,null,t):(0,i.localize)(17,null,t)):m<M?(t=Math.floor(m/w),g?t===1?E?(0,i.localize)(18,null,t):(0,i.localize)(19,null,t):E?(0,i.localize)(20,null,t):(0,i.localize)(21,null,t):t===1?E?(0,i.localize)(22,null,t):(0,i.localize)(23,null,t):E?(0,i.localize)(24,null,t):(0,i.localize)(25,null,t)):m<D?(t=Math.floor(m/M),g?t===1?(0,i.localize)(26,null,t):(0,i.localize)(27,null,t):t===1?(0,i.localize)(28,null,t):(0,i.localize)(29,null,t)):m<A?(t=Math.floor(m/D),g?t===1?E?(0,i.localize)(30,null,t):(0,i.localize)(31,null,t):E?(0,i.localize)(32,null,t):(0,i.localize)(33,null,t):t===1?E?(0,i.localize)(34,null,t):(0,i.localize)(35,null,t):E?(0,i.localize)(36,null,t):(0,i.localize)(37,null,t)):m<y?(t=Math.floor(m/A),g?t===1?E?(0,i.localize)(38,null,t):(0,i.localize)(39,null,t):E?(0,i.localize)(40,null,t):(0,i.localize)(41,null,t):t===1?E?(0,i.localize)(42,null,t):(0,i.localize)(43,null,t):E?(0,i.localize)(44,null,t):(0,i.localize)(45,null,t)):(t=Math.floor(m/y),g?t===1?E?(0,i.localize)(46,null,t):(0,i.localize)(47,null,t):E?(0,i.localize)(48,null,t):(0,i.localize)(49,null,t):t===1?E?(0,i.localize)(50,null,t):(0,i.localize)(51,null,t):E?(0,i.localize)(52,null,t):(0,i.localize)(53,null,t))}e.fromNow=T;function O(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(De[114],Ie([16,17]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(De[45],Ie([1,0,18,9,114]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function M(b,g){return g&&(b.stack||b.stacktrace)?w.localize(0,null,A(b),D(b.stack)||D(b.stacktrace)):A(b)}function D(b){return Array.isArray(b)?b.join(`
`):b}function A(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?w.localize(1,null,b.message):b.message||w.localize(2,null)}function y(b=null,g=!1){if(!b)return w.localize(3,null);if(Array.isArray(b)){const E=i.coalesce(b),m=y(E[0],g);return E.length>1?w.localize(4,null,m,E.length):m}if(I.isString(b))return b;if(b.detail){const E=b.detail;if(E.error)return M(E.error,g);if(E.exception)return M(E.exception,g)}return b.stack?M(b,g):b.message?b.message:w.localize(5,null)}e.toErrorMessage=y;function T(b){const g=b;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=T;function O(b,g){let E;return typeof b=="string"?E=new Error(b):E=b,E.actions=g,E}e.createErrorWithActions=O}),define(De[79],Ie([1,0,19]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const I={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(O){const b=(0,i.extname)(O),g=I[b.toLowerCase()];return g!==void 0?g:D(O)}e.getMediaOrTextMime=M;function D(O){const b=(0,i.extname)(O);return w[b.toLowerCase()]}e.getMediaMime=D;function A(O){for(const b in w)if(w[b]===O)return b}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function T(O,b){const g=y.exec(O);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:b?void 0:O}e.normalizeMimeType=T}),define(De[115],Ie([1,0,4,7]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const w=D=>({onDidChange:i.Event.None,value:D});e.staticObservableValue=w;class M extends I.Disposable{get value(){return this._value}set value(A){A!==this._value&&(this._value=A,this.changeEmitter.fire(A))}constructor(A){super(),this._value=A,this.changeEmitter=this._register(new i.Emitter),this.onDidChange=this.changeEmitter.event}}e.MutableObservableValue=M}),define(De[39],Ie([1,0,19,21,10,9]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(l){return l===47||l===92}e.isPathSeparator=D;function A(l){return l.replace(/[\\/]/g,i.posix.sep)}e.toSlashes=A;function y(l){return l.indexOf("/")===-1&&(l=A(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.toPosixPath=y;function T(l,f=i.posix.sep){if(!l)return"";const o=l.length,h=l.charCodeAt(0);if(D(h)){if(D(l.charCodeAt(1))&&!D(l.charCodeAt(2))){let k=3;const F=k;for(;k<o&&!D(l.charCodeAt(k));k++);if(F!==k&&!D(l.charCodeAt(k+1))){for(k+=1;k<o;k++)if(D(l.charCodeAt(k)))return l.slice(0,k+1).replace(/[\\/]/g,f)}}return f}else if(a(h)&&l.charCodeAt(1)===58)return D(l.charCodeAt(2))?l.slice(0,2)+f:l.slice(0,2);let v=l.indexOf("://");if(v!==-1){for(v+=3;v<o;v++)if(D(l.charCodeAt(v)))return l.slice(0,v+1)}return""}e.getRoot=T;function O(l){if(!I.isWindows||!l||l.length<5)return!1;let f=l.charCodeAt(0);if(f!==92||(f=l.charCodeAt(1),f!==92))return!1;let o=2;const h=o;for(;o<l.length&&(f=l.charCodeAt(o),f!==92);o++);return!(h===o||(f=l.charCodeAt(o+1),isNaN(f)||f===92))}e.isUNC=O;const b=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(l,f=I.isWindows){const o=f?b:g;return!(!l||l.length===0||/^\s+$/.test(l)||(o.lastIndex=0,o.test(l))||f&&E.test(l)||l==="."||l===".."||f&&l[l.length-1]==="."||f&&l.length!==l.trim().length||l.length>255)}e.isValidBasename=m;function t(l,f,o){const h=l===f;return!o||h?h:!l||!f?!1:(0,w.equalsIgnoreCase)(l,f)}e.isEqual=t;function s(l,f,o,h=i.sep){if(l===f)return!0;if(!l||!f||f.length>l.length)return!1;if(o){if(!(0,w.startsWithIgnoreCase)(l,f))return!1;if(f.length===l.length)return!0;let k=f.length;return f.charAt(f.length-1)===h&&k--,l.charAt(k)===h}return f.charAt(f.length-1)!==h&&(f+=h),l.indexOf(f)===0}e.isEqualOrParent=s;function a(l){return l>=65&&l<=90||l>=97&&l<=122}e.isWindowsDriveLetter=a;function p(l,f){return I.isWindows&&l.endsWith(":")&&(l+=i.sep),(0,i.isAbsolute)(l)||(l=(0,i.join)(f,l)),l=(0,i.normalize)(l),I.isWindows?(l=(0,w.rtrim)(l,i.sep),l.endsWith(":")&&(l+=i.sep)):(l=(0,w.rtrim)(l,i.sep),l||(l=i.sep)),l}e.sanitizeFilePath=p;function S(l){const f=(0,i.normalize)(l);return I.isWindows?l.length>3?!1:u(f)&&(l.length===2||f.charCodeAt(2)===92):f===i.posix.sep}e.isRootOrDriveLetter=S;function u(l,f=I.isWindows){return f?a(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function C(l){return u(l)?l[0]:void 0}e.getDriveLetter=C;function r(l,f,o){return f.length>l.length?-1:l===f?0:(o&&(l=l.toLowerCase(),f=f.toLowerCase()),l.indexOf(f))}e.indexOfPath=r;function c(l){const f=l.split(":");let o,h,v;for(const k of f){const F=Number(k);(0,M.isNumber)(F)?h===void 0?h=F:v===void 0&&(v=F):o=o?[o,k].join(":"):k}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:h!==void 0?h:void 0,column:v!==void 0?v:h!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function d(l,f,o=8){let h="";for(let k=0;k<o;k++)h+=n.charAt(Math.floor(Math.random()*n.length));let v;return f?v=`${f}-${h}`:v=h,l?(0,i.join)(l,v):v}e.randomPath=d}),define(De[116],Ie([1,0,28,10]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...J){return function(_,L){for(let W=0,q=J.length;W<q;W++){const ee=J[W](_,L);if(ee)return ee}return null}}e.or=w,e.matchesStrictPrefix=M.bind(void 0,!1),e.matchesPrefix=M.bind(void 0,!0);function M(J,_,L){if(!L||L.length<_.length)return null;let W;return J?W=I.startsWithIgnoreCase(L,_):W=L.indexOf(_)===0,W?_.length>0?[{start:0,end:_.length}]:[]:null}function D(J,_){const L=_.toLowerCase().indexOf(J.toLowerCase());return L===-1?null:[{start:L,end:L+J.length}]}e.matchesContiguousSubString=D;function A(J,_){return y(J.toLowerCase(),_.toLowerCase(),0,0)}e.matchesSubString=A;function y(J,_,L,W){if(L===J.length)return[];if(W===_.length)return null;if(J[L]===_[W]){let q=null;return(q=y(J,_,L+1,W+1))?a({start:W,end:W+1},q):null}return y(J,_,L,W+1)}function T(J){return 97<=J&&J<=122}function O(J){return 65<=J&&J<=90}e.isUpper=O;function b(J){return 48<=J&&J<=57}function g(J){return J===32||J===9||J===10||J===13}const E=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>E.add(J.charCodeAt(0)));function m(J){return g(J)||E.has(J)}function t(J,_){return J===_||m(J)&&m(_)}function s(J){return T(J)||O(J)||b(J)}function a(J,_){return _.length===0?_=[J]:J.end===_[0].start?_[0].start=J.start:_.unshift(J),_}function p(J,_){for(let L=_;L<J.length;L++){const W=J.charCodeAt(L);if(O(W)||b(W)||L>0&&!s(J.charCodeAt(L-1)))return L}return J.length}function S(J,_,L,W){if(L===J.length)return[];if(W===_.length)return null;if(J[L]!==_[W].toLowerCase())return null;{let q=null,ee=W+1;for(q=S(J,_,L+1,W+1);!q&&(ee=p(_,ee))<_.length;)q=S(J,_,L+1,ee),ee++;return q===null?null:a({start:W,end:W+1},q)}}function u(J){let _=0,L=0,W=0,q=0,ee=0;for(let ve=0;ve<J.length;ve++)ee=J.charCodeAt(ve),O(ee)&&_++,T(ee)&&L++,s(ee)&&W++,b(ee)&&q++;const ce=_/J.length,be=L/J.length,oe=W/J.length,we=q/J.length;return{upperPercent:ce,lowerPercent:be,alphaPercent:oe,numericPercent:we}}function C(J){const{upperPercent:_,lowerPercent:L}=J;return L===0&&_>.6}function r(J){const{upperPercent:_,lowerPercent:L,alphaPercent:W,numericPercent:q}=J;return L>.2&&_<.8&&W>.6&&q<.2}function c(J){let _=0,L=0,W=0,q=0;for(let ee=0;ee<J.length;ee++)W=J.charCodeAt(ee),O(W)&&_++,T(W)&&L++,g(W)&&q++;return(_===0||L===0)&&q===0?J.length<=30:_<=5}function n(J,_){if(!_||(_=_.trim(),_.length===0)||!c(J)||_.length>60)return null;const L=u(_);if(!r(L)){if(!C(L))return null;_=_.toLowerCase()}let W=null,q=0;for(J=J.toLowerCase();q<_.length&&(W=S(J,_,0,q))===null;)q=p(_,q+1);return W}e.matchesCamelCase=n;function d(J,_,L=!1){if(!_||_.length===0)return null;let W=null,q=0;for(J=J.toLowerCase(),_=_.toLowerCase();q<_.length&&(W=l(J,_,0,q,L))===null;)q=f(_,q+1);return W}e.matchesWords=d;function l(J,_,L,W,q){if(L===J.length)return[];if(W===_.length)return null;if(t(J.charCodeAt(L),_.charCodeAt(W))){let ee=null,ce=W+1;if(ee=l(J,_,L+1,W+1,q),!q)for(;!ee&&(ce=f(_,ce))<_.length;)ee=l(J,_,L+1,ce,q),ce++;return ee?J.charCodeAt(L)!==_.charCodeAt(W)?ee:a({start:W,end:W+1},ee):null}else return null}function f(J,_){for(let L=_;L<J.length;L++)if(m(J.charCodeAt(L))||L>0&&m(J.charCodeAt(L-1)))return L;return J.length}const o=w(e.matchesPrefix,n,D),h=w(e.matchesPrefix,n,A),v=new i.LRUCache(1e4);function k(J,_,L=!1){if(typeof J!="string"||typeof _!="string")return null;let W=v.get(J);W||(W=new RegExp(I.convertSimple2RegExpPattern(J),"i"),v.set(J,W));const q=W.exec(_);return q?[{start:q.index,end:q.index+q[0].length}]:L?h(J,_):o(J,_)}e.matchesFuzzy=k;function F(J,_){const L=Be(J,J.toLowerCase(),0,_,_.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return L?H(L):null}e.matchesFuzzy2=F;function j(J,_,L,W,q,ee){const ce=Math.min(13,J.length);for(;L<ce;L++){const be=Be(J,_,L,W,q,ee,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(be)return be}return[0,ee]}e.anyScore=j;function H(J){if(typeof J>"u")return[];const _=[],L=J[1];for(let W=J.length-1;W>1;W--){const q=J[W]+L,ee=_[_.length-1];ee&&ee.end===q?ee.end=q+1:_.push({start:q,end:q+1})}return _}e.createMatches=H;const V=128;function P(){const J=[],_=[];for(let L=0;L<=V;L++)_[L]=0;for(let L=0;L<=V;L++)J.push(_.slice(0));return J}function U(J){const _=[];for(let L=0;L<=J;L++)_[L]=0;return _}const R=U(2*V),x=U(2*V),z=P(),B=P(),K=P(),Z=!1;function ue(J,_,L,W,q){function ee(be,oe,we=" "){for(;be.length<oe;)be=we+be;return be}let ce=` |   |${W.split("").map(be=>ee(be,3)).join("|")}
`;for(let be=0;be<=L;be++)be===0?ce+=" |":ce+=`${_[be-1]}|`,ce+=J[be].slice(0,q+1).map(oe=>ee(oe.toString(),3)).join("|")+`
`;return ce}function ne(J,_,L,W){J=J.substr(_),L=L.substr(W),console.log(ue(B,J,J.length,L,L.length)),console.log(ue(K,J,J.length,L,L.length)),console.log(ue(z,J,J.length,L,L.length))}function pe(J,_){if(_<0||_>=J.length)return!1;const L=J.codePointAt(_);switch(L){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(L)}}function ae(J,_){if(_<0||_>=J.length)return!1;switch(J.charCodeAt(_)){case 32:case 9:return!0;default:return!1}}function de(J,_,L){return _[J]!==L[J]}function Y(J,_,L,W,q,ee,ce=!1){for(;_<L&&q<ee;)J[_]===W[q]&&(ce&&(R[_]=q),_+=1),q+=1;return _===L}e.isPatternInWord=Y;var me;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(me||(me={}));var Se;(function(J){J.Default=[-100,0];function _(L){return!L||L.length===2&&L[0]===-100&&L[1]===0}J.isDefault=_})(Se=e.FuzzyScore||(e.FuzzyScore={}));class Oe{constructor(_,L){this.firstMatchCanBeWeak=_,this.boostFullMatch=L}}e.FuzzyScoreOptions=Oe,Oe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Be(J,_,L,W,q,ee,ce=Oe.default){const be=J.length>V?V:J.length,oe=W.length>V?V:W.length;if(L>=be||ee>=oe||be-L>oe-ee||!Y(_,L,be,q,ee,oe,!0))return;Xe(be,oe,L,ee,_,q);let we=1,ve=1,Ue=L,ze=ee;const et=[!1];for(we=1,Ue=L;Ue<be;we++,Ue++){const X=R[Ue],Q=x[Ue],ge=Ue+1<be?x[Ue+1]:oe;for(ve=X-ee+1,ze=X;ze<ge;ve++,ze++){let Ne=Number.MIN_SAFE_INTEGER,je=!1;ze<=Q&&(Ne=ke(J,_,Ue,L,W,q,ze,oe,ee,z[we-1][ve-1]===0,et));let qe=0;Ne!==Number.MAX_SAFE_INTEGER&&(je=!0,qe=Ne+B[we-1][ve-1]);const We=ze>X,Ze=We?B[we][ve-1]+(z[we][ve-1]>0?-5:0):0,nt=ze>X+1&&z[we][ve-1]>0,ct=nt?B[we][ve-2]+(z[we][ve-2]>0?-5:0):0;if(nt&&(!We||ct>=Ze)&&(!je||ct>=qe))B[we][ve]=ct,K[we][ve]=3,z[we][ve]=0;else if(We&&(!je||Ze>=qe))B[we][ve]=Ze,K[we][ve]=2,z[we][ve]=0;else if(je)B[we][ve]=qe,K[we][ve]=1,z[we][ve]=z[we-1][ve-1]+1;else throw new Error("not possible")}}if(Z&&ne(J,L,W,ee),!et[0]&&!ce.firstMatchCanBeWeak)return;we--,ve--;const Ke=[B[we][ve],ee];let tt=0,Fe=0;for(;we>=1;){let X=ve;do{const Q=K[we][X];if(Q===3)X=X-2;else if(Q===2)X=X-1;else break}while(X>=1);tt>1&&_[L+we-1]===q[ee+ve-1]&&!de(X+ee-1,W,q)&&tt+1>z[we][X]&&(X=ve),X===ve?tt++:tt=1,Fe||(Fe=X),we--,ve=X-1,Ke.push(ve)}oe===be&&ce.boostFullMatch&&(Ke[0]+=2);const ht=Fe-be;return Ke[0]-=ht,Ke}e.fuzzyScore=Be;function Xe(J,_,L,W,q,ee){let ce=J-1,be=_-1;for(;ce>=L&&be>=W;)q[ce]===ee[be]&&(x[ce]=be,ce--),be--}function ke(J,_,L,W,q,ee,ce,be,oe,we,ve){if(_[L]!==ee[ce])return Number.MIN_SAFE_INTEGER;let Ue=1,ze=!1;return ce===L-W?Ue=J[L]===q[ce]?7:5:de(ce,q,ee)&&(ce===0||!de(ce-1,q,ee))?(Ue=J[L]===q[ce]?7:5,ze=!0):pe(ee,ce)&&(ce===0||!pe(ee,ce-1))?Ue=5:(pe(ee,ce-1)||ae(ee,ce-1))&&(Ue=5,ze=!0),Ue>1&&L===W&&(ve[0]=!0),ze||(ze=de(ce,q,ee)||pe(ee,ce-1)||ae(ee,ce-1)),L===W?ce>oe&&(Ue-=ze?3:5):we?Ue+=ze?2:0:Ue+=ze?0:1,ce+1===be&&(Ue-=ze?3:5),Ue}function ye(J,_,L,W,q,ee,ce){return se(J,_,L,W,q,ee,!0,ce)}e.fuzzyScoreGracefulAggressive=ye;function Ce(J,_,L,W,q,ee,ce){return se(J,_,L,W,q,ee,!1,ce)}e.fuzzyScoreGraceful=Ce;function se(J,_,L,W,q,ee,ce,be){let oe=Be(J,_,L,W,q,ee,be);if(oe&&!ce)return oe;if(J.length>=3){const we=Math.min(7,J.length-1);for(let ve=L+1;ve<we;ve++){const Ue=le(J,ve);if(Ue){const ze=Be(Ue,Ue.toLowerCase(),L,W,q,ee,be);ze&&(ze[0]-=3,(!oe||ze[0]>oe[0])&&(oe=ze))}}}return oe}function le(J,_){if(_+1>=J.length)return;const L=J[_],W=J[_+1];if(L!==W)return J.slice(0,_)+W+L+J.slice(_+2)}}),define(De[117],Ie([1,0,118,116,10]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const M=new RegExp(`\\$\\(${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(i.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${M.source}`,"g");function y(s){return s.replace(A,(a,p)=>p?a:`\\${a}`)}e.escapeIcons=y;const T=new RegExp(`\\\\${M.source}`,"g");function O(s){return s.replace(T,a=>`\\${a}`)}e.markdownEscapeEscapedIcons=O;const b=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function g(s){return s.indexOf(e.iconStartMarker)===-1?s:s.replace(b,(a,p,S,u)=>S?a:p||u||"")}e.stripIcons=g;function E(s){const a=s.indexOf(e.iconStartMarker);return a===-1?{text:s}:m(s,a)}e.parseLabelWithIcons=E;function m(s,a){const p=[];let S="";function u(o){if(o){S+=o;for(const h of o)p.push(c)}}let C=-1,r="",c=0,n,d,l=a;const f=s.length;for(u(s.substr(0,a));l<f;)n=s[l],d=s[l+1],n===e.iconStartMarker[0]&&d===e.iconStartMarker[1]?(C=l,u(r),r=e.iconStartMarker,l++):n===")"&&C!==-1?(c+=l-C+1,C=-1,r=""):C!==-1?D.test(n)?r+=n:(u(r),C=-1,r=""):u(n),l++;return u(r),{text:S,iconOffsets:p}}function t(s,a,p=!1){const{text:S,iconOffsets:u}=a;if(!u||u.length===0)return(0,I.matchesFuzzy)(s,S,p);const C=(0,w.ltrim)(S," "),r=S.length-C.length,c=(0,I.matchesFuzzy)(s,C,p);if(c)for(const n of c){const d=u[n.start+r]+r;n.start+=d,n.end+=d}return c}e.matchesFuzzyIconAware=t}),define(De[29],Ie([1,0,10]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(I||(I={})),function(w){const M="error",D="warning",A="warn",y="info",T="ignore";function O(g){return g?i.equalsIgnoreCase(M,g)?w.Error:i.equalsIgnoreCase(D,g)||i.equalsIgnoreCase(A,g)?w.Warning:i.equalsIgnoreCase(y,g)?w.Info:w.Ignore:w.Ignore}w.fromValue=O;function b(g){switch(g){case w.Error:return M;case w.Warning:return D;case w.Info:return y;default:return T}}w.toString=b}(I||(I={})),e.default=I}),define(De[46],Ie([1,0,18,10]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class w{constructor(){this._value="",this._pos=0}reset(E){return this._value=E,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(E){const m=E.charCodeAt(0),t=this._value.charCodeAt(this._pos);return m-t}value(){return this._value[this._pos]}}e.StringIterator=w;class M{constructor(E=!0){this._caseSensitive=E}reset(E){return this._value=E,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let E=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(E)this._from++;else break;else E=!1;return this}cmp(E){return this._caseSensitive?(0,I.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=M;class D{constructor(E=!0,m=!0){this._splitOnBackslash=E,this._caseSensitive=m}reset(E){this._from=0,this._to=0,this._value=E,this._valueLen=E.length;for(let m=E.length-1;m>=0;m--,this._valueLen--){const t=this._value.charCodeAt(m);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let E=!0;for(;this._to<this._valueLen;this._to++){const m=this._value.charCodeAt(this._to);if(m===47||this._splitOnBackslash&&m===92)if(E)this._from++;else break;else E=!1}return this}cmp(E){return this._caseSensitive?(0,I.compareSubstring)(E,this._value,0,E.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(E,this._value,0,E.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=D;var A;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(E,m){this._ignorePathCasing=E,this._ignoreQueryAndFragment=m,this._states=[],this._stateIdx=0}reset(E){return this._value=E,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new D(!1,!this._ignorePathCasing(E)),this._pathIterator.reset(E.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(E)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(E){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(E,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(E,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(E);if(this._states[this._stateIdx]===4)return(0,I.compare)(E,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(E,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=y;class T{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(O||(O={}));class b{static forUris(E=()=>!1,m=()=>!1){return new b(new y(E,m))}static forPaths(E=!1){return new b(new D(void 0,!E))}static forStrings(){return new b(new w)}static forConfigKeys(){return new b(new M)}constructor(E){this._iter=E}clear(){this._root=void 0}fill(E,m){if(m){const t=m.slice(0);(0,i.shuffle)(t);for(const s of t)this.set(s,E)}else{const t=E.slice(0);(0,i.shuffle)(t);for(const s of t)this.set(s[0],s[1])}}set(E,m){const t=this._iter.reset(E);let s;this._root||(this._root=new T,this._root.segment=t.value());const a=[];for(s=this._root;;){const S=t.cmp(s.segment);if(S>0)s.left||(s.left=new T,s.left.segment=t.value()),a.push([-1,s]),s=s.left;else if(S<0)s.right||(s.right=new T,s.right.segment=t.value()),a.push([1,s]),s=s.right;else if(t.hasNext())t.next(),s.mid||(s.mid=new T,s.mid.segment=t.value()),a.push([0,s]),s=s.mid;else break}const p=s.value;s.value=m,s.key=E;for(let S=a.length-1;S>=0;S--){const u=a[S][1];u.updateHeight();const C=u.balanceFactor();if(C<-1||C>1){const r=a[S][0],c=a[S+1][0];if(r===1&&c===1)a[S][1]=u.rotateLeft();else if(r===-1&&c===-1)a[S][1]=u.rotateRight();else if(r===1&&c===-1)u.right=a[S+1][1]=a[S+1][1].rotateRight(),a[S][1]=u.rotateLeft();else if(r===-1&&c===1)u.left=a[S+1][1]=a[S+1][1].rotateLeft(),a[S][1]=u.rotateRight();else throw new Error;if(S>0)switch(a[S-1][0]){case-1:a[S-1][1].left=a[S][1];break;case 1:a[S-1][1].right=a[S][1];break;case 0:a[S-1][1].mid=a[S][1];break}else this._root=a[0][1]}}return p}get(E){return this._getNode(E)?.value}_getNode(E){const m=this._iter.reset(E);let t=this._root;for(;t;){const s=m.cmp(t.segment);if(s>0)t=t.left;else if(s<0)t=t.right;else if(m.hasNext())m.next(),t=t.mid;else break}return t}has(E){const m=this._getNode(E);return!(m?.value===void 0&&m?.mid===void 0)}delete(E){return this._delete(E,!1)}deleteSuperstr(E){return this._delete(E,!0)}_delete(E,m){const t=this._iter.reset(E),s=[];let a=this._root;for(;a;){const p=t.cmp(a.segment);if(p>0)s.push([-1,a]),a=a.left;else if(p<0)s.push([1,a]),a=a.right;else if(t.hasNext())t.next(),s.push([0,a]),a=a.mid;else break}if(!!a){if(m?(a.left=void 0,a.mid=void 0,a.right=void 0,a.height=1):(a.key=void 0,a.value=void 0),!a.mid&&!a.value)if(a.left&&a.right){const p=this._min(a.right);if(p.key){const{key:S,value:u,segment:C}=p;this._delete(p.key,!1),a.key=S,a.value=u,a.segment=C}}else{const p=a.left??a.right;if(s.length>0){const[S,u]=s[s.length-1];switch(S){case-1:u.left=p;break;case 0:u.mid=p;break;case 1:u.right=p;break}}else this._root=p}for(let p=s.length-1;p>=0;p--){const S=s[p][1];S.updateHeight();const u=S.balanceFactor();if(u>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),s[p][1]=S.rotateLeft()):u<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),s[p][1]=S.rotateRight()),p>0)switch(s[p-1][0]){case-1:s[p-1][1].left=s[p][1];break;case 1:s[p-1][1].right=s[p][1];break;case 0:s[p-1][1].mid=s[p][1];break}else this._root=s[0][1]}}}_min(E){for(;E.left;)E=E.left;return E}findSubstr(E){const m=this._iter.reset(E);let t=this._root,s;for(;t;){const a=m.cmp(t.segment);if(a>0)t=t.left;else if(a<0)t=t.right;else if(m.hasNext())m.next(),s=t.value||s,t=t.mid;else break}return t&&t.value||s}findSuperstr(E){const m=this._iter.reset(E);let t=this._root;for(;t;){const s=m.cmp(t.segment);if(s>0)t=t.left;else if(s<0)t=t.right;else if(m.hasNext())m.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(E){for(const[m,t]of this)E(t,m)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(E){const m=[];return this._dfsEntries(E,m),m[Symbol.iterator]()}_dfsEntries(E,m){!E||(E.left&&this._dfsEntries(E.left,m),E.value&&m.push([E.key,E.value]),E.mid&&this._dfsEntries(E.mid,m),E.right&&this._dfsEntries(E.right,m))}_isBalanced(){const E=m=>{if(!m)return!0;const t=m.balanceFactor();return t<-1||t>1?!1:E(m.left)&&E(m.right)};return E(this._root)}}e.TernarySearchTree=b}),define(De[80],Ie([1,0,24,10,2]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function M(T){return JSON.stringify(T,A)}e.stringify=M;function D(T){let O=JSON.parse(T);return O=y(O),O}e.parse=D;function A(T,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,I.regExpFlags)(O)}:O}function y(T,O=0){if(!T||O>200)return T;if(typeof T=="object"){switch(T.$mid){case 1:return w.URI.revive(T);case 2:return new RegExp(T.source,T.flags);case 15:return new Date(T.source)}if(T instanceof i.VSBuffer||T instanceof Uint8Array)return T;if(Array.isArray(T))for(let b=0;b<T.length;++b)T[b]=y(T[b],O+1);else for(const b in T)Object.hasOwnProperty.call(T,b)&&(T[b]=y(T[b],O+1))}return T}e.revive=y}),define(De[13],Ie([1,0,21,2]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebook="vscode-notebook",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(T){this._preferredWebSchema=T}setDelegate(T){this._delegate=T}setServerRootPath(T){this._remoteResourcesPath=`${T}/${w.vscodeRemoteResource}`}set(T,O,b){this._hosts[T]=O,this._ports[T]=b}setConnectionToken(T,O){this._connectionTokens[T]=O}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(T){if(this._delegate)return this._delegate(T);const O=T.authority;let b=this._hosts[O];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const g=this._ports[O],E=this._connectionTokens[O];let m=`path=${encodeURIComponent(T.path)}`;return typeof E=="string"&&(m+=`&${e.connectionTokenQueryName}=${encodeURIComponent(E)}`),I.URI.from({scheme:i.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${b}:${g}`,path:this._remoteResourcesPath,query:m})}}e.RemoteAuthorities=new M;class D{asBrowserUri(T,O){const b=this.toUri(T,O);return b.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===w.file&&(i.isNative||i.isWebWorker&&i.globals.origin===`${w.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?b.with({scheme:w.vscodeFileResource,authority:b.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):b}asFileUri(T,O){const b=this.toUri(T,O);return b.scheme===w.vscodeFileResource?b.with({scheme:w.file,authority:b.authority!==D.FALLBACK_AUTHORITY?b.authority:null,query:null,fragment:null}):b}toUri(T,O){return I.URI.isUri(T)?T:I.URI.parse(O.toUrl(T))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D;var A;(function(y){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(T.get("3"));const O="vscode-coi";function b(E){let m;typeof E=="string"?m=new URL(E).searchParams:E instanceof URL?m=E.searchParams:I.URI.isUri(E)&&(m=new URL(E.toString(!0)).searchParams);const t=m?.get(O);if(!!t)return T.get(t)}y.getHeadersFromQuery=b;function g(E,m,t){if(!globalThis.crossOriginIsolated)return;const s=m&&t?"3":t?"2":"1";E instanceof URLSearchParams?E.set(O,s):E[O]=s}y.addSearchParam=g})(A=e.COI||(e.COI={}))}),define(De[22],Ie([1,0,39,13,19,21,10,2]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(E){return(0,A.uriToFsPath)(E,!0)}e.originalFSPath=y;class T{constructor(m){this._ignorePathCasing=m}compare(m,t,s=!1){return m===t?0:(0,D.compare)(this.getComparisonKey(m,s),this.getComparisonKey(t,s))}isEqual(m,t,s=!1){return m===t?!0:!m||!t?!1:this.getComparisonKey(m,s)===this.getComparisonKey(t,s)}getComparisonKey(m,t=!1){return m.with({path:this._ignorePathCasing(m)?m.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}ignorePathCasing(m){return this._ignorePathCasing(m)}isEqualOrParent(m,t,s=!1){if(m.scheme===t.scheme){if(m.scheme===I.Schemas.file)return i.isEqualOrParent(y(m),y(t),this._ignorePathCasing(m))&&m.query===t.query&&(s||m.fragment===t.fragment);if((0,e.isEqualAuthority)(m.authority,t.authority))return i.isEqualOrParent(m.path,t.path,this._ignorePathCasing(m),"/")&&m.query===t.query&&(s||m.fragment===t.fragment)}return!1}joinPath(m,...t){return A.URI.joinPath(m,...t)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return w.posix.basename(m.path)}extname(m){return w.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let t;return m.scheme===I.Schemas.file?t=A.URI.file(w.dirname(y(m))).path:(t=w.posix.dirname(m.path),m.authority&&t.length&&t.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),t="/")),m.with({path:t})}normalizePath(m){if(!m.path.length)return m;let t;return m.scheme===I.Schemas.file?t=A.URI.file(w.normalize(y(m))).path:t=w.posix.normalize(m.path),m.with({path:t})}relativePath(m,t){if(m.scheme!==t.scheme||!(0,e.isEqualAuthority)(m.authority,t.authority))return;if(m.scheme===I.Schemas.file){const p=w.relative(y(m),y(t));return M.isWindows?i.toSlashes(p):p}let s=m.path||"/";const a=t.path||"/";if(this._ignorePathCasing(m)){let p=0;for(const S=Math.min(s.length,a.length);p<S&&!(s.charCodeAt(p)!==a.charCodeAt(p)&&s.charAt(p).toLowerCase()!==a.charAt(p).toLowerCase());p++);s=a.substr(0,p)+s.substr(p)}return w.posix.relative(s,a)}resolvePath(m,t){if(m.scheme===I.Schemas.file){const s=A.URI.file(w.resolve(y(m),t));return m.with({authority:s.authority,path:s.path})}return t=i.toPosixPath(t),m.with({path:w.posix.resolve(m.path,t)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,t){return m===t||m!==void 0&&t!==void 0&&(0,D.equalsIgnoreCase)(m,t)}hasTrailingPathSeparator(m,t=w.sep){if(m.scheme===I.Schemas.file){const s=y(m);return s.length>i.getRoot(s).length&&s[s.length-1]===t}else{const s=m.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,t=w.sep){return(0,e.hasTrailingPathSeparator)(m,t)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,t=w.sep){let s=!1;if(m.scheme===I.Schemas.file){const a=y(m);s=a!==void 0&&a.length===i.getRoot(a).length&&a[a.length-1]===t}else{t="/";const a=m.path;s=a.length===1&&a.charCodeAt(a.length-1)===47}return!s&&!(0,e.hasTrailingPathSeparator)(m,t)?m.with({path:m.path+"/"}):m}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(E=>E.scheme===I.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new T(E=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(E,m){const t=[];for(let s=0;s<E.length;s++){const a=m(E[s]);E.some((p,S)=>S===s?!1:(0,e.isEqualOrParent)(a,m(p)))||t.push(E[s])}return t}e.distinctParents=O;var b;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function m(t){const s=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(S=>{const[u,C]=S.split(":");u&&C&&s.set(u,C)});const p=t.path.substring(0,t.path.indexOf(";"));return p&&s.set(E.META_DATA_MIME,p),s}E.parseMetaData=m})(b=e.DataUri||(e.DataUri={}));function g(E,m,t){if(m){let s=E.path;return s&&s[0]!==w.posix.sep&&(s=w.posix.sep+s),E.with({scheme:t,authority:m,path:s})}return E.with({scheme:t})}e.toLocalResource=g}),define(De[15],Ie([1,0,20,12,4,7,22,21]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(de){return!!de&&typeof de.then=="function"}e.isThenable=y;function T(de){const Y=new i.CancellationTokenSource,me=de(Y.token),Se=new Promise((Oe,Be)=>{const Xe=Y.token.onCancellationRequested(()=>{Xe.dispose(),Y.dispose(),Be(new I.CancellationError)});Promise.resolve(me).then(ke=>{Xe.dispose(),Y.dispose(),Oe(ke)},ke=>{Xe.dispose(),Y.dispose(),Be(ke)})});return new class{cancel(){Y.cancel()}then(Oe,Be){return Se.then(Oe,Be)}catch(Oe){return this.then(void 0,Oe)}finally(Oe){return Se.finally(Oe)}}}e.createCancelablePromise=T;function O(de,Y,me){return new Promise((Se,Oe)=>{const Be=Y.onCancellationRequested(()=>{Be.dispose(),Se(me)});de.then(Se,Oe).finally(()=>Be.dispose())})}e.raceCancellation=O;function b(de,Y){return new Promise((me,Se)=>{const Oe=Y.onCancellationRequested(()=>{Oe.dispose(),Se(new I.CancellationError)});de.then(me,Se).finally(()=>Oe.dispose())})}e.raceCancellationError=b;async function g(de){let Y=-1;const me=de.map((Oe,Be)=>Oe.then(Xe=>(Y=Be,Xe))),Se=await Promise.race(me);return de.forEach((Oe,Be)=>{Be!==Y&&Oe.cancel()}),Se}e.raceCancellablePromises=g;function E(de,Y,me){let Se;const Oe=setTimeout(()=>{Se?.(void 0),me?.()},Y);return Promise.race([de.finally(()=>clearTimeout(Oe)),new Promise(Be=>Se=Be)])}e.raceTimeout=E;function m(de){return new Promise((Y,me)=>{const Se=de();y(Se)?Se.then(Y,me):Y(Se)})}e.asPromise=m;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(Y){if(this.activePromise){if(this.queuedPromiseFactory=Y,!this.queuedPromise){const me=()=>{this.queuedPromise=null;const Se=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Se};this.queuedPromise=new Promise(Se=>{this.activePromise.then(me,me).then(Se)})}return new Promise((me,Se)=>{this.queuedPromise.then(me,Se)})}return this.activePromise=Y(),new Promise((me,Se)=>{this.activePromise.then(Oe=>{this.activePromise=null,me(Oe)},Oe=>{this.activePromise=null,Se(Oe)})})}}e.Throttler=t;class s{constructor(){this.current=Promise.resolve(null)}queue(Y){return this.current=this.current.then(()=>Y(),()=>Y())}}e.Sequencer=s;class a{constructor(){this.promiseMap=new Map}queue(Y,me){const Oe=(this.promiseMap.get(Y)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.promiseMap.get(Y)===Oe&&this.promiseMap.delete(Y)});return this.promiseMap.set(Y,Oe),Oe}}e.SequencerByKey=a;const p=(de,Y)=>{let me=!0;const Se=setTimeout(()=>{me=!1,Y()},de);return{isTriggered:()=>me,dispose:()=>{clearTimeout(Se),me=!1}}},S=de=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,de())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class u{constructor(Y){this.defaultDelay=Y,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(Y,me=this.defaultDelay){this.task=Y,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Oe,Be)=>{this.doResolve=Oe,this.doReject=Be}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Oe=this.task;return this.task=null,Oe()}}));const Se=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=me===e.MicrotaskDelay?S(Se):p(me,Se),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new I.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=u;class C{constructor(Y){this.delayer=new u(Y),this.throttler=new t}trigger(Y,me){return this.delayer.trigger(()=>this.throttler.queue(Y),me)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=C;class r{constructor(){this._isOpen=!1,this._promise=new Promise((Y,me)=>{this._completePromise=Y})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class c extends r{constructor(Y){super(),this._timeout=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function n(de,Y){return Y?new Promise((me,Se)=>{const Oe=setTimeout(()=>{Be.dispose(),me()},de),Be=Y.onCancellationRequested(()=>{clearTimeout(Oe),Be.dispose(),Se(new I.CancellationError)})}):T(me=>n(de,me))}e.timeout=n;function d(de,Y=0){const me=setTimeout(de,Y);return(0,M.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=d;function l(de){const Y=[];let me=0;const Se=de.length;function Oe(){return me<Se?de[me++]():null}function Be(Xe){Xe!=null&&Y.push(Xe);const ke=Oe();return ke?ke.then(Be):Promise.resolve(Y)}return Promise.resolve(null).then(Be)}e.sequence=l;function f(de,Y=Se=>!!Se,me=null){let Se=0;const Oe=de.length,Be=()=>{if(Se>=Oe)return Promise.resolve(me);const Xe=de[Se++];return Promise.resolve(Xe()).then(ye=>Y(ye)?Promise.resolve(ye):Be())};return Be()}e.first=f;function o(de,Y=Se=>!!Se,me=null){if(de.length===0)return Promise.resolve(me);let Se=de.length;const Oe=()=>{Se=-1;for(const Be of de)Be.cancel?.()};return new Promise((Be,Xe)=>{for(const ke of de)ke.then(ye=>{--Se>=0&&Y(ye)?(Oe(),Be(ye)):Se===0&&Be(me)}).catch(ye=>{--Se>=0&&(Oe(),Xe(ye))})})}e.firstParallel=o;class h{constructor(Y){this._size=0,this.maxDegreeOfParalellism=Y,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new w.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(Y){return this._size++,new Promise((me,Se)=>{this.outstandingPromises.push({factory:Y,c:me,e:Se}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const Y=this.outstandingPromises.shift();this.runningPromises++;const me=Y.factory();me.then(Y.c,Y.e),me.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class v extends h{constructor(){super(1)}}e.Queue=v;class k{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const Y=new K;return this.drainers.add(Y),Y.p}isDrained(){for(const[,Y]of this.queues)if(Y.size>0)return!1;return!0}queueFor(Y,me=D.extUri){const Se=me.getComparisonKey(Y);let Oe=this.queues.get(Se);return Oe||(Oe=new v,w.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.queues.delete(Se),this.onDidQueueDrain()}),this.queues.set(Se,Oe)),Oe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const Y of this.drainers)Y.complete();this.drainers.clear()}dispose(){for(const[,Y]of this.queues)Y.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=k;class F{constructor(Y,me){this._token=-1,typeof Y=="function"&&typeof me=="number"&&this.setIfNotSet(Y,me)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setTimeout(()=>{this._token=-1,Y()},me)}setIfNotSet(Y,me){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,Y()},me))}}e.TimeoutTimer=F;class j{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(Y,me){this.cancel(),this._token=setInterval(()=>{Y()},me)}}e.IntervalTimer=j;class H{constructor(Y,me){this.timeoutToken=-1,this.runner=Y,this.timeout=me,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(Y=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,Y)}get delay(){return this.timeout}set delay(Y){this.timeout=Y}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=H;class V{constructor(Y,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.runner=Y,this.timeout=me,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(Y=this.timeout){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(Y/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=V;class P extends H{constructor(Y,me){super(Y,me),this.units=[]}work(Y){this.units.push(Y),this.isScheduled()||this.schedule()}doRun(){const Y=this.units;this.units=[],this.runner?.(Y)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=P;class U extends M.Disposable{constructor(Y,me){super(),this.options=Y,this.handler=me,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(Y){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+Y.length>this.options.maxBufferedWork)return!1}else if(this.pending+Y.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...Y),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new H(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=de=>{(0,A.setTimeout0)(()=>{if(Y)return;const me=Date.now()+15;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.runWhenIdle=(de,Y)=>{const me=requestIdleCallback(de,typeof Y=="number"?{timeout:Y}:void 0);let Se=!1;return{dispose(){Se||(Se=!0,cancelIdleCallback(me))}}}}();class R{constructor(Y){this._didRun=!1,this._executor=()=>{try{this._value=Y()}catch(me){this._error=me}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=R;async function x(de,Y,me){let Se;for(let Oe=0;Oe<me;Oe++)try{return await de()}catch(Be){Se=Be,await n(Y)}throw Se}e.retry=x;class z{hasPending(Y){return this._pending?typeof Y=="number"?this._pending.taskId===Y:!!this._pending:!1}get pending(){return this._pending?.promise}cancelPending(){this._pending?.cancel()}setPending(Y,me,Se){return this._pending={taskId:Y,cancel:()=>Se?.(),promise:me},me.then(()=>this.donePending(Y),()=>this.donePending(Y)),me}donePending(Y){this._pending&&Y===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const Y=this._next;this._next=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}setNext(Y){if(this._next)this._next.run=Y;else{let me,Se;const Oe=new Promise((Be,Xe)=>{me=Be,Se=Xe});this._next={run:Y,promise:Oe,promiseResolve:me,promiseReject:Se}}return this._next.promise}hasNext(){return!!this._next}async join(){return this._next?.promise??this._pending?.promise}}e.TaskSequentializer=z;class B{constructor(Y,me=()=>Date.now()){this.interval=Y,this.nowFn=me,this.lastIncrementTime=0,this.value=0}increment(){const Y=this.nowFn();return Y-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=Y,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class K{get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((Y,me)=>{this.completeCallback=Y,this.errorCallback=me})}complete(Y){return new Promise(me=>{this.completeCallback(Y),this.resolved=!0,me()})}error(Y){return new Promise(me=>{this.errorCallback(Y),this.rejected=!0,me()})}cancel(){new Promise(Y=>{this.errorCallback(new I.CancellationError),this.rejected=!0,Y()})}}e.DeferredPromise=K;var Z;(function(de){async function Y(Se){let Oe;const Be=await Promise.all(Se.map(Xe=>Xe.then(ke=>ke,ke=>{Oe||(Oe=ke)})));if(typeof Oe<"u")throw Oe;return Be}de.settled=Y;function me(Se){return new Promise(async(Oe,Be)=>{try{await Se(Oe,Be)}catch(Xe){Be(Xe)}})}de.withAsyncBody=me})(Z=e.Promises||(e.Promises={}));var ue;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(ue||(ue={}));class ne{static fromArray(Y){return new ne(me=>{me.emitMany(Y)})}static fromPromise(Y){return new ne(async me=>{me.emitMany(await Y)})}static fromPromises(Y){return new ne(async me=>{await Promise.all(Y.map(async Se=>me.emitOne(await Se)))})}static merge(Y){return new ne(async me=>{await Promise.all(Y.map(async Se=>{for await(const Oe of Se)me.emitOne(Oe)}))})}constructor(Y){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const me={emitOne:Se=>this.emitOne(Se),emitMany:Se=>this.emitMany(Se),reject:Se=>this.reject(Se)};try{await Promise.resolve(Y(me)),this.resolve()}catch(Se){this.reject(Se)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(Y<this._results.length)return{done:!1,value:this._results[Y++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(Y,me){return new ne(async Se=>{for await(const Oe of Y)Se.emitOne(me(Oe))})}map(Y){return ne.map(this,Y)}static filter(Y,me){return new ne(async Se=>{for await(const Oe of Y)me(Oe)&&Se.emitOne(Oe)})}filter(Y){return ne.filter(this,Y)}static coalesce(Y){return ne.filter(Y,me=>!!me)}coalesce(){return ne.coalesce(this)}static async toPromise(Y){const me=[];for await(const Se of Y)me.push(Se);return me}toPromise(){return ne.toPromise(this)}emitOne(Y){this._state===0&&(this._results.push(Y),this._onStateChanged.fire())}emitMany(Y){this._state===0&&(this._results=this._results.concat(Y),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(Y){this._state===0&&(this._state=2,this._error=Y,this._onStateChanged.fire())}}e.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class pe extends ne{constructor(Y,me){super(me),this._source=Y}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=pe;function ae(de){const Y=new i.CancellationTokenSource,me=de(Y.token);return new pe(Y,async Se=>{const Oe=Y.token.onCancellationRequested(()=>{Oe.dispose(),Y.dispose(),Se.reject(new I.CancellationError)});try{for await(const Be of me){if(Y.token.isCancellationRequested)return;Se.emitOne(Be)}Oe.dispose(),Y.dispose()}catch(Be){Oe.dispose(),Y.dispose(),Se.reject(Be)}})}e.createCancelableAsyncIterable=ae}),define(De[119],Ie([1,0,15,19]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new i.IdleValue(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),M=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new i.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(v,k,F=!1){const j=v||"",H=k||"",V=w.value.collator.compare(j,H);return w.value.collatorIsNumeric&&V===0&&j!==H?j<H?-1:1:V}e.compareFileNames=A;function y(v,k){const F=M.value.collator;return v=v||"",k=k||"",C(F,v,k)}e.compareFileNamesDefault=y;function T(v,k){const F=M.value.collator;return v=v||"",k=k||"",d(v,k)||C(F,v,k)}e.compareFileNamesUpper=T;function O(v,k){const F=M.value.collator;return v=v||"",k=k||"",n(v,k)||C(F,v,k)}e.compareFileNamesLower=O;function b(v,k){return v=v||"",k=k||"",v===k?0:v<k?-1:1}e.compareFileNamesUnicode=b;function g(v,k,F=!1){F||(v=v&&v.toLowerCase(),k=k&&k.toLowerCase());const[j,H]=S(v),[V,P]=S(k);return j!==V?j<V?-1:1:H===P?0:H<P?-1:1}e.noIntlCompareFileNames=g;function E(v,k){const[F,j]=S(v),[H,V]=S(k);let P=w.value.collator.compare(j,V);if(P===0){if(w.value.collatorIsNumeric&&j!==V)return j<V?-1:1;if(P=w.value.collator.compare(F,H),w.value.collatorIsNumeric&&P===0&&F!==H)return F<H?-1:1}return P}e.compareFileExtensions=E;function m(v,k){v=v||"",k=k||"";const F=u(v),j=u(k),H=M.value.collator,V=D.value.collator;return C(V,F,j)||C(H,v,k)}e.compareFileExtensionsDefault=m;function t(v,k){v=v||"",k=k||"";const F=u(v),j=u(k),H=M.value.collator,V=D.value.collator;return C(V,F,j)||d(v,k)||C(H,v,k)}e.compareFileExtensionsUpper=t;function s(v,k){v=v||"",k=k||"";const F=u(v),j=u(k),H=M.value.collator,V=D.value.collator;return C(V,F,j)||n(v,k)||C(H,v,k)}e.compareFileExtensionsLower=s;function a(v,k){v=v||"",k=k||"";const F=u(v).toLowerCase(),j=u(k).toLowerCase();return F!==j?F<j?-1:1:v!==k?v<k?-1:1:0}e.compareFileExtensionsUnicode=a;const p=/^(.*?)(\.([^.]*))?$/;function S(v,k=!1){const F=v?p.exec(v):[];let j=[F&&F[1]||"",F&&F[3]||""];return k&&(!j[0]&&j[1]||j[0]&&j[0].charAt(0)===".")&&(j=[j[0]+"."+j[1],""]),j}function u(v){const k=v?p.exec(v):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function C(v,k,F){const j=v.compare(k,F);return j!==0?j:k.length!==F.length?k.length<F.length?-1:1:0}function r(v){const k=v.charAt(0);return k.toLocaleUpperCase()!==k}function c(v){const k=v.charAt(0);return k.toLocaleLowerCase()!==k}function n(v,k){return r(v)&&c(k)?-1:c(v)&&r(k)?1:0}function d(v,k){return c(v)&&r(k)?-1:r(v)&&c(k)?1:0}function l(v,k,F=!1){return F||(v=v&&v.toLowerCase(),k=k&&k.toLowerCase()),v===k?0:v<k?-1:1}function f(v,k,F=!1){const j=v.split(I.sep),H=k.split(I.sep),V=j.length-1,P=H.length-1;let U,R;for(let x=0;;x++){if(U=V===x,R=P===x,U&&R)return A(j[x],H[x],F);if(U)return-1;if(R)return 1;const z=l(j[x],H[x],F);if(z!==0)return z}}e.comparePaths=f;function o(v,k,F){const j=v.toLowerCase(),H=k.toLowerCase(),V=h(v,k,F);if(V)return V;const P=j.endsWith(F),U=H.endsWith(F);if(P!==U)return P?-1:1;const R=A(j,H);return R!==0?R:j.localeCompare(H)}e.compareAnything=o;function h(v,k,F){const j=v.toLowerCase(),H=k.toLowerCase(),V=j.startsWith(F),P=H.startsWith(F);if(V!==P)return V?-1:1;if(V&&P){if(j.length<H.length)return-1;if(j.length>H.length)return 1}return 0}e.compareByPrefix=h}),define(De[34],Ie([1,0,18,15,39,28,19,21,10]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function T(){return Object.create(null)}e.getEmptyExpression=T,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",b="[^/\\\\]",g=/\//g;function E(K,Z){switch(K){case 0:return"";case 1:return`${b}*?`;default:return`(?:${O}|${b}+${O}${Z?`|${O}${b}+`:""})*?`}}function m(K,Z){if(!K)return[];const ue=[];let ne=!1,pe=!1,ae="";for(const de of K){switch(de){case Z:if(!ne&&!pe){ue.push(ae),ae="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}ae+=de}return ae&&ue.push(ae),ue}e.splitGlobAware=m;function t(K){if(!K)return"";let Z="";const ue=m(K,e.GLOB_SPLIT);if(ue.every(ne=>ne===e.GLOBSTAR))Z=".*";else{let ne=!1;ue.forEach((pe,ae)=>{if(pe===e.GLOBSTAR){if(ne)return;Z+=E(2,ae===ue.length-1)}else{let de=!1,Y="",me=!1,Se="";for(const Oe of pe){if(Oe!=="}"&&de){Y+=Oe;continue}if(me&&(Oe!=="]"||!Se)){let Be;Oe==="-"?Be=Oe:(Oe==="^"||Oe==="!")&&!Se?Be="^":Oe===e.GLOB_SPLIT?Be="":Be=(0,y.escapeRegExpCharacters)(Oe),Se+=Be;continue}switch(Oe){case"{":de=!0;continue;case"[":me=!0;continue;case"}":{Z+=`(?:${m(Y,",").map(ke=>t(ke)).join("|")})`,de=!1,Y="";break}case"]":{Z+="["+Se+"]",me=!1,Se="";break}case"?":Z+=b;continue;case"*":Z+=E(1);continue;default:Z+=(0,y.escapeRegExpCharacters)(Oe)}}ae<ue.length-1&&(ue[ae+1]!==e.GLOBSTAR||ae+2<ue.length)&&(Z+=O)}ne=pe===e.GLOBSTAR})}return Z}const s=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,S=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new M.LRUCache(1e4),c=function(){return!1},n=function(){return null};function d(K,Z){if(!K)return n;let ue;typeof K!="string"?ue=K.pattern:ue=K,ue=ue.trim();const ne=`${ue}_${!!Z.trimForExclusions}`;let pe=r.get(ne);if(pe)return l(pe,K);let ae;return s.test(ue)?pe=o(ue.substr(4),ue):(ae=a.exec(f(ue,Z)))?pe=h(ae[1],ue):(Z.trimForExclusions?S:p).test(ue)?pe=v(ue,Z):(ae=u.exec(f(ue,Z)))?pe=k(ae[1].substr(1),ue,!0):(ae=C.exec(f(ue,Z)))?pe=k(ae[1],ue,!1):pe=F(ue),r.set(ne,pe),l(pe,K)}function l(K,Z){if(typeof Z=="string")return K;const ue=function(ne,pe){return(0,w.isEqualOrParent)(ne,Z.base,!A.isLinux)?K(ne.substr(Z.base.length+1),pe):null};return ue.allBasenames=K.allBasenames,ue.allPaths=K.allPaths,ue.basenames=K.basenames,ue.patterns=K.patterns,ue}function f(K,Z){return Z.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function o(K,Z){return function(ue,ne){return typeof ue=="string"&&ue.endsWith(K)?Z:null}}function h(K,Z){const ue=`/${K}`,ne=`\\${K}`,pe=function(de,Y){return typeof de!="string"?null:Y?Y===K?Z:null:de===K||de.endsWith(ue)||de.endsWith(ne)?Z:null},ae=[K];return pe.basenames=ae,pe.patterns=[Z],pe.allBasenames=ae,pe}function v(K,Z){const ue=z(K.slice(1,-1).split(",").map(Y=>d(Y,Z)).filter(Y=>Y!==n),K),ne=ue.length;if(!ne)return n;if(ne===1)return ue[0];const pe=function(Y,me){for(let Se=0,Oe=ue.length;Se<Oe;Se++)if(ue[Se](Y,me))return K;return null},ae=ue.find(Y=>!!Y.allBasenames);ae&&(pe.allBasenames=ae.allBasenames);const de=ue.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return de.length&&(pe.allPaths=de),pe}function k(K,Z,ue){const ne=D.sep===D.posix.sep,pe=ne?K:K.replace(g,D.sep),ae=D.sep+pe,de=D.posix.sep+K;let Y;return ue?Y=function(me,Se){return typeof me=="string"&&(me===pe||me.endsWith(ae)||!ne&&(me===K||me.endsWith(de)))?Z:null}:Y=function(me,Se){return typeof me=="string"&&(me===pe||!ne&&me===K)?Z:null},Y.allPaths=[(ue?"*/":"./")+K],Y}function F(K){try{const Z=new RegExp(`^${t(K)}$`);return function(ue){return Z.lastIndex=0,typeof ue=="string"&&Z.test(ue)?K:null}}catch{return n}}function j(K,Z,ue){return!K||typeof Z!="string"?!1:H(K)(Z,void 0,ue)}e.match=j;function H(K,Z={}){if(!K)return c;if(typeof K=="string"||V(K)){const ue=d(K,Z);if(ue===n)return c;const ne=function(pe,ae){return!!ue(pe,ae)};return ue.allBasenames&&(ne.allBasenames=ue.allBasenames),ue.allPaths&&(ne.allPaths=ue.allPaths),ne}return R(K,Z)}e.parse=H;function V(K){const Z=K;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.isRelativePattern=V;function P(K){return K.allBasenames||[]}e.getBasenameTerms=P;function U(K){return K.allPaths||[]}e.getPathTerms=U;function R(K,Z){const ue=z(Object.getOwnPropertyNames(K).map(Y=>x(Y,K[Y],Z)).filter(Y=>Y!==n)),ne=ue.length;if(!ne)return n;if(!ue.some(Y=>!!Y.requiresSiblings)){if(ne===1)return ue[0];const Y=function(Oe,Be){let Xe;for(let ke=0,ye=ue.length;ke<ye;ke++){const Ce=ue[ke](Oe,Be);if(typeof Ce=="string")return Ce;(0,I.isThenable)(Ce)&&(Xe||(Xe=[]),Xe.push(Ce))}return Xe?(async()=>{for(const ke of Xe){const ye=await ke;if(typeof ye=="string")return ye}return null})():null},me=ue.find(Oe=>!!Oe.allBasenames);me&&(Y.allBasenames=me.allBasenames);const Se=ue.reduce((Oe,Be)=>Be.allPaths?Oe.concat(Be.allPaths):Oe,[]);return Se.length&&(Y.allPaths=Se),Y}const pe=function(Y,me,Se){let Oe,Be;for(let Xe=0,ke=ue.length;Xe<ke;Xe++){const ye=ue[Xe];ye.requiresSiblings&&Se&&(me||(me=(0,D.basename)(Y)),Oe||(Oe=me.substr(0,me.length-(0,D.extname)(Y).length)));const Ce=ye(Y,me,Oe,Se);if(typeof Ce=="string")return Ce;(0,I.isThenable)(Ce)&&(Be||(Be=[]),Be.push(Ce))}return Be?(async()=>{for(const Xe of Be){const ke=await Xe;if(typeof ke=="string")return ke}return null})():null},ae=ue.find(Y=>!!Y.allBasenames);ae&&(pe.allBasenames=ae.allBasenames);const de=ue.reduce((Y,me)=>me.allPaths?Y.concat(me.allPaths):Y,[]);return de.length&&(pe.allPaths=de),pe}function x(K,Z,ue){if(Z===!1)return n;const ne=d(K,ue);if(ne===n)return n;if(typeof Z=="boolean")return ne;if(Z){const pe=Z.when;if(typeof pe=="string"){const ae=(de,Y,me,Se)=>{if(!Se||!ne(de,Y))return null;const Oe=pe.replace("$(basename)",me),Be=Se(Oe);return(0,I.isThenable)(Be)?Be.then(Xe=>Xe?K:null):Be?K:null};return ae.requiresSiblings=!0,ae}}return ne}function z(K,Z){const ue=K.filter(Y=>!!Y.basenames);if(ue.length<2)return K;const ne=ue.reduce((Y,me)=>{const Se=me.basenames;return Se?Y.concat(Se):Y},[]);let pe;if(Z){pe=[];for(let Y=0,me=ne.length;Y<me;Y++)pe.push(Z)}else pe=ue.reduce((Y,me)=>{const Se=me.patterns;return Se?Y.concat(Se):Y},[]);const ae=function(Y,me){if(typeof Y!="string")return null;if(!me){let Oe;for(Oe=Y.length;Oe>0;Oe--){const Be=Y.charCodeAt(Oe-1);if(Be===47||Be===92)break}me=Y.substr(Oe)}const Se=ne.indexOf(me);return Se!==-1?pe[Se]:null};ae.basenames=ne,ae.patterns=pe,ae.allBasenames=ne;const de=K.filter(Y=>!Y.basenames);return de.push(ae),de}function B(K,Z){return(0,i.equals)(K,Z,(ue,ne)=>typeof ue=="string"&&typeof ne=="string"?ue===ne:typeof ue!="string"&&typeof ne!="string"?ue.base===ne.base&&ue.pattern===ne.pattern:!1)}e.patternsEquals=B}),define(De[81],Ie([1,0,12,117,22,10,2]),function(ie,e,i,I,w,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(a="",p=!1){if(this.value=a,typeof this.value!="string")throw(0,i.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(a,p=0){return this.value+=g(this.supportThemeIcons?(0,I.escapeIcons)(a):a).replace(/([ \t]+)/g,(S,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,p){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(a,p,S){return this.value+="[",this.value+=this._escape(p,"]"),this.value+="](",this.value+=this._escape(String(a),")"),S&&(this.value+=` "${this._escape(this._escape(S,'"'),")")}"`),this.value+=")",this}_escape(a,p){const S=new RegExp((0,M.escapeRegExpCharacters)(p),"g");return a.replace(S,(u,C)=>a.charAt(C-1)!=="\\"?`\\${u}`:u)}}e.MarkdownString=y;function T(s){return O(s)?!s.value:Array.isArray(s)?s.every(T):!0}e.isEmptyMarkdownString=T;function O(s){return s instanceof y?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function b(s,a){return s===a?!0:!s||!a?!1:s.value===a.value&&s.isTrusted===a.isTrusted&&s.supportThemeIcons===a.supportThemeIcons&&s.supportHtml===a.supportHtml&&(s.baseUri===a.baseUri||!!s.baseUri&&!!a.baseUri&&(0,w.isEqual)(D.URI.from(s.baseUri),D.URI.from(a.baseUri)))}e.markdownStringEqual=b;function g(s){return s.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function E(s){return s.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=E;function m(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=m;function t(s){const a=[],p=s.split("|").map(u=>u.trim());s=p[0];const S=p[1];if(S){const u=/height=(\d+)/.exec(S),C=/width=(\d+)/.exec(S),r=u?u[1]:"",c=C?C[1]:"",n=isFinite(parseInt(c)),d=isFinite(parseInt(r));n&&a.push(`width="${c}"`),d&&a.push(`height="${r}"`)}return{href:s,dimensions:a}}e.parseHrefAndDimensions=t}),define(De[82],Ie([1,0,18,39,19,21,22,10]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(n,d){const{os:l,tildify:f,relative:o}=d;if(o){const k=T(n,o,l);if(typeof k=="string")return k}let h=n.fsPath;if(l===1&&!M.isWindows?h=h.replace(/\//g,"\\"):l!==1&&M.isWindows&&(h=h.replace(/\\/g,"/")),l!==1&&f?.userHome){const k=f.userHome.fsPath;let F;n.scheme!==f.userHome.scheme&&n.path.startsWith(w.posix.sep)?F=f.userHome.with({path:n.path}).fsPath:F=n.fsPath,h=g(F,k,l)}return(l===1?w.win32:w.posix).normalize(O(h,l===1))}e.getPathLabel=y;function T(n,d,l){const f=l===1?w.win32:w.posix,o=l===3?D.extUri:D.extUriIgnorePathCase,h=d.getWorkspace(),v=(0,i.firstOrDefault)(h.folders);if(!v)return;n.scheme!==v.uri.scheme&&n.path.startsWith(w.posix.sep)&&(n=v.uri.with({path:n.path}));const k=d.getWorkspaceFolder(n);if(!k)return;let F;if(o.isEqual(k.uri,n)?F="":F=o.relativePath(k.uri,n)??"",F&&(F=f.normalize(F)),h.folders.length>1&&!d.noPrefix){const j=k.name?k.name:o.basenameOrAuthority(k.uri);F=F?`${j} \u2022 ${F}`:j}return F}function O(n,d=M.isWindows){return(0,I.hasDriveLetter)(n,d)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=O;let b=Object.create(null);function g(n,d,l=M.OS){if(l===1||!n||!d)return n;let f=b.original===d?b.normalized:void 0;f||(f=d,M.isWindows&&(f=(0,I.toSlashes)(f)),f=`${(0,A.rtrim)(f,w.posix.sep)}${w.posix.sep}`,b={original:d,normalized:f});let o=n;return M.isWindows&&(o=(0,I.toSlashes)(o)),(l===3?o.startsWith(f):(0,A.startsWithIgnoreCase)(o,f))?`~/${o.substr(f.length)}`:n}e.tildify=g;function E(n,d){return n.replace(/^~($|\/|\\)/,`${d}$1`)}e.untildify=E;const m="\u2026",t="\\\\",s="~";function a(n,d=w.sep){const l=new Array(n.length);let f=!1;for(let o=0;o<n.length;o++){const h=n[o];if(h===""){l[o]=`.${d}`;continue}if(!h){l[o]=h;continue}f=!0;let v="",k=h;k.indexOf(t)===0?(v=k.substr(0,k.indexOf(t)+t.length),k=k.substr(k.indexOf(t)+t.length)):k.indexOf(d)===0?(v=k.substr(0,k.indexOf(d)+d.length),k=k.substr(k.indexOf(d)+d.length)):k.indexOf(s)===0&&(v=k.substr(0,k.indexOf(s)+s.length),k=k.substr(k.indexOf(s)+s.length));const F=k.split(d);for(let j=1;f&&j<=F.length;j++)for(let H=F.length-j;f&&H>=0;H--){f=!1;let V=F.slice(H,H+j).join(d);for(let P=0;!f&&P<n.length;P++)if(P!==o&&n[P]&&n[P].indexOf(V)>-1){const U=H+j===F.length,R=H>0&&n[P].indexOf(d)>-1?d+V:V,x=n[P].endsWith(R);f=!U||x}if(!f){let P="";(F[0].endsWith(":")||v!=="")&&(H===1&&(H=0,j++,V=F[0]+d+V),H>0&&(P=F[0]+d),P=v+P),H>0&&(P=P+m+d),P=P+V,H+j<F.length&&(P=P+d+m),l[o]=P}}f&&(l[o]=h)}return l}e.shorten=a;var p;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function S(n,d=Object.create(null)){const l=[];let f=!1,o="";for(const h of n)if(h==="$"||f&&h==="{")o&&l.push({value:o,type:p.TEXT}),o="",f=!0;else if(h==="}"&&f){const v=d[o];if(typeof v=="string")v.length&&l.push({value:v,type:p.VARIABLE});else if(v){const k=l[l.length-1];(!k||k.type!==p.SEPARATOR)&&l.push({value:v.label,type:p.SEPARATOR})}o="",f=!1}else o+=h;return o&&!f&&l.push({value:o,type:p.TEXT}),l.filter((h,v)=>{if(h.type===p.SEPARATOR){const k=l[v-1],F=l[v+1];return[k,F].every(j=>j&&(j.type===p.VARIABLE||j.type===p.TEXT)&&j.value.length>0)}return!0}).map(h=>h.value).join("")}e.template=S;function u(n,d){return M.isMacintosh||d?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):n.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function C(n,d){return M.isMacintosh||d?n.replace(/\(&&\w\)|&&/g,""):M.isWindows?n.replace(/&&|&/g,l=>l==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=C;function r(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=r;function c(n){const d=n.indexOf("/")!==-1?w.posix:w.win32,l=d.basename(n),f=d.dirname(n);return l.length?{name:l,parentPath:f}:{name:f,parentPath:""}}e.splitName=c}),define(De[120],Ie([1,0,2]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(O){return O.toJSON()}class w{constructor(b){this._uriTransformer=b}transformIncoming(b){const g=this._uriTransformer.transformIncoming(b);return g===b?b:I(i.URI.from(g))}transformOutgoing(b){const g=this._uriTransformer.transformOutgoing(b);return g===b?b:I(i.URI.from(g))}transformOutgoingURI(b){const g=this._uriTransformer.transformOutgoing(b);return g===b?b:i.URI.from(g)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(O){return O}transformOutgoing(O){return O}transformOutgoingURI(O){return O}transformOutgoingScheme(O){return O}};function M(O,b,g){if(!O||g>200)return null;if(typeof O=="object"){if(O instanceof i.URI)return b.transformOutgoing(O);for(const E in O)if(Object.hasOwnProperty.call(O,E)){const m=M(O[E],b,g+1);m!==null&&(O[E]=m)}}return null}function D(O,b){const g=M(O,b,0);return g===null?O:g}e.transformOutgoingURIs=D;function A(O,b,g,E){if(!O||E>200)return null;if(typeof O=="object"){if(O.$mid===1)return g?i.URI.revive(b.transformIncoming(O)):b.transformIncoming(O);for(const m in O)if(Object.hasOwnProperty.call(O,m)){const t=A(O[m],b,g,E+1);t!==null&&(O[m]=t)}}return null}function y(O,b){const g=A(O,b,!1,0);return g===null?O:g}e.transformIncomingURIs=y;function T(O,b){const g=A(O,b,!0,0);return g===null?O:g}e.transformAndReviveIncomingURIs=T}),define(De[121],Ie([1,0,34,19]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(M,D,A,y,T,O){if(Array.isArray(M)){let b=0;for(const g of M){const E=w(g,D,A,y,T,O);if(E===10)return E;E>b&&(b=E)}return b}else{if(typeof M=="string")return y?M==="*"?5:M===A?10:0:0;if(M){const{language:b,pattern:g,scheme:E,hasAccessToAllModels:m,notebookType:t}=M;if(!y&&!m)return 0;t&&T&&(D=T);let s=0;if(E)if(E===D.scheme)s=10;else if(E==="*")s=5;else return 0;if(b)if(b===A)s=10;else if(b==="*")s=Math.max(s,5);else return 0;if(t)if(t===O)s=10;else if(t==="*"&&O!==void 0)s=Math.max(s,5);else return 0;if(g){let a;if(typeof g=="string"?a=g:a={...g,base:(0,I.normalize)(g.base)},a===D.fsPath||(0,i.match)(a,D.fsPath))s=10;else return 0}return s}else return 0}}e.score=w}),define(De[83],Ie([1,0,24,21]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(w||(w={}));function M(b){for(let g=0,E=b.length;g<E;g+=4){const m=b[g+0],t=b[g+1],s=b[g+2],a=b[g+3];b[g+0]=a,b[g+1]=s,b[g+2]=t,b[g+3]=m}}function D(b){const g=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return I.isLittleEndian()||M(g),i.VSBuffer.wrap(g)}function A(b){const g=b.buffer;if(I.isLittleEndian()||M(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const E=new Uint8Array(g.byteLength);return E.set(g),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function y(b){const g=new Uint32Array(T(b));let E=0;if(g[E++]=b.id,b.type==="full")g[E++]=1,g[E++]=b.data.length,g.set(b.data,E),E+=b.data.length;else{g[E++]=2,g[E++]=b.deltas.length;for(const m of b.deltas)g[E++]=m.start,g[E++]=m.deleteCount,m.data?(g[E++]=m.data.length,g.set(m.data,E),E+=m.data.length):g[E++]=0}return D(g)}e.encodeSemanticTokensDto=y;function T(b){let g=0;if(g+=1+1,b.type==="full")g+=1+b.data.length;else{g+=1,g+=(1+1+1)*b.deltas.length;for(const E of b.deltas)E.data&&(g+=E.data.length)}return g}function O(b){const g=A(b);let E=0;const m=g[E++];if(g[E++]===1){const p=g[E++],S=g.subarray(E,E+p);return E+=p,{id:m,type:"full",data:S}}const s=g[E++],a=[];for(let p=0;p<s;p++){const S=g[E++],u=g[E++],C=g[E++];let r;C>0&&(r=g.subarray(E,E+C),E+=C),a[p]={start:S,deleteCount:u,data:r}}return{id:m,type:"delta",deltas:a}}e.decodeSemanticTokensDto=O}),define(De[122],Ie([16,17]),function(ie,e){return ie.create("vs/editor/common/config/editorOptions",e)}),define(De[123],Ie([1,0,122,21,124,18,23,110]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class T{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=T;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class b{constructor(Q,ge,Ne,je){this.id=Q,this.name=ge,this.defaultValue=Ne,this.schema=je}applyUpdate(Q,ge){return E(Q,ge)}compute(Q,ge,Ne){return Ne}}class g{constructor(Q,ge){this.newValue=Q,this.didChange=ge}}e.ApplyUpdateResult=g;function E(X,Q){if(typeof X!="object"||typeof Q!="object"||!X||!Q)return new g(Q,X!==Q);if(Array.isArray(X)||Array.isArray(Q)){const Ne=Array.isArray(X)&&Array.isArray(Q)&&M.equals(X,Q);return new g(Q,!Ne)}let ge=!1;for(const Ne in Q)if(Q.hasOwnProperty(Ne)){const je=E(X[Ne],Q[Ne]);je.didChange&&(X[Ne]=je.newValue,ge=!0)}return new g(X,ge)}class m{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,ge){return E(Q,ge)}validate(Q){return this.defaultValue}}class t{constructor(Q,ge,Ne,je){this.id=Q,this.name=ge,this.defaultValue=Ne,this.schema=je}applyUpdate(Q,ge){return E(Q,ge)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,ge,Ne){return Ne}}function s(X,Q){return typeof X>"u"?Q:X==="false"?!1:Boolean(X)}e.boolean=s;class a extends t{constructor(Q,ge,Ne,je=void 0){typeof je<"u"&&(je.type="boolean",je.default=Ne),super(Q,ge,Ne,je)}validate(Q){return s(Q,this.defaultValue)}}function p(X,Q,ge,Ne){if(typeof X>"u")return Q;let je=parseInt(X,10);return isNaN(je)?Q:(je=Math.max(ge,je),je=Math.min(Ne,je),je|0)}e.clampedInt=p;class S extends t{static clampedInt(Q,ge,Ne,je){return p(Q,ge,Ne,je)}constructor(Q,ge,Ne,je,qe,We=void 0){typeof We<"u"&&(We.type="integer",We.default=Ne,We.minimum=je,We.maximum=qe),super(Q,ge,Ne,We),this.minimum=je,this.maximum=qe}validate(Q){return S.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class u extends t{static clamp(Q,ge,Ne){return Q<ge?ge:Q>Ne?Ne:Q}static float(Q,ge){if(typeof Q=="number")return Q;if(typeof Q>"u")return ge;const Ne=parseFloat(Q);return isNaN(Ne)?ge:Ne}constructor(Q,ge,Ne,je,qe){typeof qe<"u"&&(qe.type="number",qe.default=Ne),super(Q,ge,Ne,qe),this.validationFn=je}validate(Q){return this.validationFn(u.float(Q,this.defaultValue))}}class C extends t{static string(Q,ge){return typeof Q!="string"?ge:Q}constructor(Q,ge,Ne,je=void 0){typeof je<"u"&&(je.type="string",je.default=Ne),super(Q,ge,Ne,je)}validate(Q){return C.string(Q,this.defaultValue)}}function r(X,Q,ge){return typeof X!="string"||ge.indexOf(X)===-1?Q:X}e.stringSet=r;class c extends t{constructor(Q,ge,Ne,je,qe=void 0){typeof qe<"u"&&(qe.type="string",qe.enum=je,qe.default=Ne),super(Q,ge,Ne,qe),this._allowedValues=je}validate(Q){return r(Q,this.defaultValue,this._allowedValues)}}class n extends b{constructor(Q,ge,Ne,je,qe,We,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=qe,Ze.default=je),super(Q,ge,Ne,Ze),this._allowedValues=qe,this._convert=We}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function d(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",tags:["accessibility"],description:i.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,ge,Ne){return Ne===0?Q.accessibilitySupport:Ne}}class f extends b{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:i.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:i.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertSpace:s(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var o;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(o=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(v=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function k(X){switch(X){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function F(X){switch(X){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class j extends m{constructor(){super(130)}compute(Q,ge,Ne){const je=["monaco-editor"];return ge.get(34)&&je.push(ge.get(34)),Q.extraEditorClassName&&je.push(Q.extraEditorClassName),ge.get(67)==="default"?je.push("mouse-default"):ge.get(67)==="copy"&&je.push("mouse-copy"),ge.get(101)&&je.push("showUnused"),ge.get(128)&&je.push("showDeprecated"),je.join(" ")}}class H extends a{constructor(){super(33,"emptySelectionClipboard",!0,{description:i.localize(6,null)})}compute(Q,ge,Ne){return Ne&&Q.emptySelectionClipboard}}class V extends b{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(36,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:i.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[i.localize(8,null),i.localize(9,null),i.localize(10,null)],description:i.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[i.localize(12,null),i.localize(13,null),i.localize(14,null)],description:i.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:i.localize(16,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:i.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:i.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{cursorMoveOnType:s(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":r(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":r(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(ge.loop,this.defaultValue.loop)}}}class P extends b{constructor(){super(46,"fontLigatures",P.OFF,{anyOf:[{type:"boolean",description:i.localize(19,null)},{type:"string",description:i.localize(20,null)}],description:i.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?P.OFF:Q==="true"?P.ON:Q:Boolean(Q)?P.ON:P.OFF}}e.EditorFontLigatures=P,P.OFF='"liga" off, "calt" off',P.ON='"liga" on, "calt" on';class U extends m{constructor(){super(45)}compute(Q,ge,Ne){return Q.fontInfo}}class R extends t{constructor(){super(47,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(22,null)})}validate(Q){const ge=u.float(Q,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(ge,6,100)}compute(Q,ge,Ne){return Q.fontInfo.fontSize}}class x extends b{constructor(){super(48,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:x.MINIMUM_VALUE,maximum:x.MAXIMUM_VALUE,errorMessage:i.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:x.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:i.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(S.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,x.MINIMUM_VALUE,x.MAXIMUM_VALUE))}}x.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],x.MINIMUM_VALUE=1,x.MAXIMUM_VALUE=1e3;class z extends b{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[i.localize(25,null),i.localize(26,null),i.localize(27,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(52,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:i.localize(29,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:i.localize(30,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:i.localize(31,null),...ge},"editor.gotoLocation.multipleImplementations":{description:i.localize(32,null),...ge},"editor.gotoLocation.multipleReferences":{description:i.localize(33,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ne,description:i.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ne,description:i.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ne,description:i.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ne,description:i.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ne,description:i.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{multiple:r(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??r(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??r(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??r(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??r(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??r(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:C.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:C.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:C.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:C.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:C.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class B extends b{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(54,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:i.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:i.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:i.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:i.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:s(ge.enabled,this.defaultValue.enabled),delay:S.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:s(ge.sticky,this.defaultValue.sticky),above:s(ge.above,this.defaultValue.above)}}}var K;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(K=e.RenderMinimap||(e.RenderMinimap={}));class Z extends m{constructor(){super(133)}compute(Q,ge,Ne){return Z.computeLayout(ge,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const ge=Q.height/Q.lineHeight,Ne=Q.scrollBeyondLastLine?ge-1:0,je=(Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),qe=Math.floor(Q.viewLineCount/je);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ne,desiredRatio:je,minimapLineCount:qe}}static _computeMinimapLayout(Q,ge){const Ne=Q.outerWidth,je=Q.outerHeight,qe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(qe*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const We=ge.stableMinimapLayoutInput,Ze=We&&Q.outerHeight===We.outerHeight&&Q.lineHeight===We.lineHeight&&Q.typicalHalfwidthCharacterWidth===We.typicalHalfwidthCharacterWidth&&Q.pixelRatio===We.pixelRatio&&Q.scrollBeyondLastLine===We.scrollBeyondLastLine&&Q.minimap.enabled===We.minimap.enabled&&Q.minimap.side===We.minimap.side&&Q.minimap.size===We.minimap.size&&Q.minimap.showSlider===We.minimap.showSlider&&Q.minimap.renderCharacters===We.minimap.renderCharacters&&Q.minimap.maxColumn===We.minimap.maxColumn&&Q.minimap.scale===We.minimap.scale&&Q.verticalScrollbarWidth===We.verticalScrollbarWidth&&Q.isViewportWrapping===We.isViewportWrapping,nt=Q.lineHeight,ct=Q.typicalHalfwidthCharacterWidth,It=Q.scrollBeyondLastLine,at=Q.minimap.renderCharacters;let rt=qe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Lt=Q.minimap.maxColumn,At=Q.minimap.size,kt=Q.minimap.side,ft=Q.verticalScrollbarWidth,yt=Q.viewLineCount,Ut=Q.remainingWidth,Rt=Q.isViewportWrapping,Ge=at?2:3;let Ct=Math.floor(qe*je);const Ot=Ct/qe;let Bt=!1,pt=!1,_e=Ge*rt,Te=rt/qe,fe=1;if(At==="fill"||At==="fit"){const{typicalViewportLineCount:ot,extraLinesBeyondLastLine:Tt,desiredRatio:Et,minimapLineCount:_t}=Z.computeContainedMinimapLineCount({viewLineCount:yt,scrollBeyondLastLine:It,height:je,lineHeight:nt,pixelRatio:qe});if(yt/_t>1)Bt=!0,pt=!0,rt=1,_e=1,Te=rt/qe;else{let Ft=!1,mt=rt+1;if(At==="fit"){const Mt=Math.ceil((yt+Tt)*_e);Rt&&Ze&&Ut<=ge.stableFitRemainingWidth?(Ft=!0,mt=ge.stableFitMaxMinimapScale):Ft=Mt>Ct}if(At==="fill"||Ft){Bt=!0;const Mt=rt;_e=Math.min(nt*qe,Math.max(1,Math.floor(1/Et))),Rt&&Ze&&Ut<=ge.stableFitRemainingWidth&&(mt=ge.stableFitMaxMinimapScale),rt=Math.min(mt,Math.max(1,Math.floor(_e/Ge))),rt>Mt&&(fe=Math.min(2,rt/Mt)),Te=rt/qe/fe,Ct=Math.ceil(Math.max(ot,yt+Tt)*_e),Rt?(ge.stableMinimapLayoutInput=Q,ge.stableFitRemainingWidth=Ut,ge.stableFitMaxMinimapScale=rt):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const G=Math.floor(Lt*Te),Pe=Math.min(G,Math.max(0,Math.floor((Ut-ft-2)*Te/(ct+Te)))+e.MINIMAP_GUTTER_WIDTH);let Me=Math.floor(qe*Pe);const Je=Me/qe;Me=Math.floor(Me*fe);const xe=at?1:2,it=kt==="left"?0:Ne-Pe-ft;return{renderMinimap:xe,minimapLeft:it,minimapWidth:Pe,minimapHeightIsEditorHeight:Bt,minimapIsSampling:pt,minimapScale:rt,minimapLineHeight:_e,minimapCanvasInnerWidth:Me,minimapCanvasInnerHeight:Ct,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:Ot}}static computeLayout(Q,ge){const Ne=ge.outerWidth|0,je=ge.outerHeight|0,qe=ge.lineHeight|0,We=ge.lineNumbersDigitCount|0,Ze=ge.typicalHalfwidthCharacterWidth,nt=ge.maxDigitWidth,ct=ge.pixelRatio,It=ge.viewLineCount,at=Q.get(125),rt=at==="inherit"?Q.get(124):at,Lt=rt==="inherit"?Q.get(120):rt,At=Q.get(123),kt=ge.isDominatedByLongLines,ft=Q.get(51),yt=Q.get(61).renderType!==0,Ut=Q.get(62),Rt=Q.get(95),Ge=Q.get(66),Ct=Q.get(93),Ot=Ct.verticalScrollbarSize,Bt=Ct.verticalHasArrows,pt=Ct.arrowSize,_e=Ct.horizontalScrollbarSize,Te=Q.get(59),fe=Q.get(38),G=Q.get(100)!=="never";let Pe;if(typeof Te=="string"&&/^\d+(\.\d+)?ch$/.test(Te)){const Ht=parseFloat(Te.substr(0,Te.length-2));Pe=S.clampedInt(Ht*Ze,0,0,1e3)}else Pe=S.clampedInt(Te,0,0,1e3);fe&&G&&(Pe+=16);let Me=0;if(yt){const Ht=Math.max(We,Ut);Me=Math.round(Ht*nt)}let Je=0;ft&&(Je=qe);let xe=0,it=xe+Je,ot=it+Me,Tt=ot+Pe;const Et=Ne-Je-Me-Pe;let _t=!1,vt=!1,Ft=-1;rt==="inherit"&&kt?(_t=!0,vt=!0):Lt==="on"||Lt==="bounded"?vt=!0:Lt==="wordWrapColumn"&&(Ft=At);const mt=Z._computeMinimapLayout({outerWidth:Ne,outerHeight:je,lineHeight:qe,typicalHalfwidthCharacterWidth:Ze,pixelRatio:ct,scrollBeyondLastLine:Rt,minimap:Ge,verticalScrollbarWidth:Ot,viewLineCount:It,remainingWidth:Et,isViewportWrapping:vt},ge.memory||new O);mt.renderMinimap!==0&&mt.minimapLeft===0&&(xe+=mt.minimapWidth,it+=mt.minimapWidth,ot+=mt.minimapWidth,Tt+=mt.minimapWidth);const Mt=Et-mt.minimapWidth,Kt=Math.max(1,Math.floor((Mt-Ot-2)/Ze)),bt=Bt?pt:0;return vt&&(Ft=Math.max(1,Kt),Lt==="bounded"&&(Ft=Math.min(Ft,At))),{width:Ne,height:je,glyphMarginLeft:xe,glyphMarginWidth:Je,lineNumbersLeft:it,lineNumbersWidth:Me,decorationsLeft:ot,decorationsWidth:Pe,contentLeft:Tt,contentWidth:Mt,minimap:mt,viewportColumn:Kt,isWordWrapMinified:_t,isViewportWrapping:vt,wrappingColumn:Ft,verticalScrollbarWidth:Ot,horizontalScrollbarHeight:_e,overviewRuler:{top:bt,width:Ot,height:je-2*bt,right:0}}}}e.EditorLayoutInfoComputer=Z;class ue extends b{constructor(){super(127,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[i.localize(43,null),i.localize(44,null)],type:"string",enum:["simple","advanced"],default:"simple",description:i.localize(45,null)}})}validate(Q){return r(Q,"simple",["simple","advanced"])}compute(Q,ge,Ne){return ge.get(2)===2?"advanced":Ne}}class ne extends b{constructor(){const Q={enabled:!0};super(58,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:i.localize(46,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:s(Q.enabled,this.defaultValue.enabled)}}}class pe extends b{constructor(){const Q={enabled:!1,maxLineCount:5};super(105,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:i.localize(47,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:i.localize(48,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:s(ge.enabled,this.defaultValue.enabled),maxLineCount:S.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class ae extends b{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:i.localize(49,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[i.localize(50,null),i.localize(51,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(52,null,I.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),i.localize(53,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:i.localize(54,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:i.localize(55,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:i.localize(56,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:r(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:S.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:C.string(ge.fontFamily,this.defaultValue.fontFamily),padding:s(ge.padding,this.defaultValue.padding)}}}class de extends u{constructor(){super(60,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>u.clamp(Q,0,150),{markdownDescription:i.localize(57,null)})}compute(Q,ge,Ne){return Q.fontInfo.lineHeight}}class Y extends b{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(66,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:i.localize(58,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:i.localize(59,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[i.localize(60,null),i.localize(61,null),i.localize(62,null)],default:Q.size,description:i.localize(63,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:i.localize(64,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:i.localize(65,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(66,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:i.localize(67,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:i.localize(68,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:s(ge.enabled,this.defaultValue.enabled),autohide:s(ge.autohide,this.defaultValue.autohide),size:r(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ge.side,this.defaultValue.side,["right","left"]),showSlider:r(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(ge.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(ge.scale,1,1,3),maxColumn:S.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends b{constructor(){super(76,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(69,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(70,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{top:S.clampedInt(ge.top,0,0,1e3),bottom:S.clampedInt(ge.bottom,0,0,1e3)}}}class Oe extends b{constructor(){const Q={enabled:!0,cycle:!1};super(77,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:i.localize(71,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:i.localize(72,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:s(ge.enabled,this.defaultValue.enabled),cycle:s(ge.cycle,this.defaultValue.cycle)}}}class Be extends m{constructor(){super(131)}compute(Q,ge,Ne){return Q.pixelRatio}}class Xe extends b{constructor(){const Q={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[i.localize(73,null),i.localize(74,null),i.localize(75,null)]}];super(80,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:Q.strings,description:i.localize(76,null)},comments:{anyOf:ge,default:Q.comments,description:i.localize(77,null)},other:{anyOf:ge,default:Q.other,description:i.localize(78,null)}},default:Q,markdownDescription:i.localize(79,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const ct=Q?"on":"off";return{comments:ct,strings:ct,other:ct}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:ge,comments:Ne,strings:je}=Q,qe=["on","inline","off"];let We,Ze,nt;return typeof ge=="boolean"?We=ge?"on":"off":We=r(ge,this.defaultValue.other,qe),typeof Ne=="boolean"?Ze=Ne?"on":"off":Ze=r(Ne,this.defaultValue.comments,qe),typeof je=="boolean"?nt=je?"on":"off":nt=r(je,this.defaultValue.strings,qe),{other:We,comments:Ze,strings:nt}}}var ke;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ke=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ye extends b{constructor(){super(61,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(80,null),i.localize(81,null),i.localize(82,null),i.localize(83,null)],default:"on",description:i.localize(84,null)})}validate(Q){let ge=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(ge=4,Ne=Q):Q==="interval"?ge=3:Q==="relative"?ge=2:Q==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ne}}}function Ce(X){const Q=X.get(88);return Q==="editable"?X.get(82):Q!=="on"}e.filterValidationDecorations=Ce;class se extends b{constructor(){const Q=[],ge={type:"number",description:i.localize(85,null)};super(92,"rulers",Q,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:i.localize(86,null),format:"color-hex"}}}]},default:Q,description:i.localize(87,null)})}validate(Q){if(Array.isArray(Q)){const ge=[];for(const Ne of Q)if(typeof Ne=="number")ge.push({column:S.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const je=Ne;ge.push({column:S.clampedInt(je.column,0,0,1e4),color:je.color})}return ge.sort((Ne,je)=>Ne.column-je.column),ge}return this.defaultValue}}function le(X,Q){if(typeof X!="string")return Q;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class J extends b{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(93,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(88,null),i.localize(89,null),i.localize(90,null)],default:"auto",description:i.localize(91,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[i.localize(92,null),i.localize(93,null),i.localize(94,null)],default:"auto",description:i.localize(95,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:i.localize(96,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:i.localize(97,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:i.localize(98,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q,Ne=S.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=S.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:le(ge.vertical,this.defaultValue.vertical),horizontal:le(ge.horizontal,this.defaultValue.horizontal),useShadows:s(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:S.clampedInt(ge.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:je,verticalSliderSize:S.clampedInt(ge.verticalSliderSize,je,0,1e3),scrollByPage:s(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class _ extends b{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:i.localize(99,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:i.localize(100,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:i.localize(101,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:i.localize(102,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:i.localize(103,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:i.localize(104,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:i.localize(105,null)}})}applyUpdate(Q,ge){let Ne=!1;ge.allowedCharacters&&Q&&(D.equals(Q.allowedCharacters,ge.allowedCharacters)||(Q={...Q,allowedCharacters:ge.allowedCharacters},Ne=!0)),ge.allowedLocales&&Q&&(D.equals(Q.allowedLocales,ge.allowedLocales)||(Q={...Q,allowedLocales:ge.allowedLocales},Ne=!0));const je=super.applyUpdate(Q,ge);return Ne?new g(je.newValue,!0):je}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{nonBasicASCII:ee(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,ge){if(typeof Q!="object"||!Q)return ge;const Ne={};for(const[je,qe]of Object.entries(Q))qe===!0&&(Ne[je]=!0);return Ne}}class L extends b{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(56,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:i.localize(106,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:s(ge.enabled,this.defaultValue.enabled),mode:r(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class W extends b{constructor(){const Q={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(107,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:i.localize(108,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{enabled:s(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends b{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(109,null),i.localize(110,null),i.localize(111,null)],default:Q.bracketPairs,description:i.localize(112,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[i.localize(113,null),i.localize(114,null),i.localize(115,null)],default:Q.bracketPairsHorizontal,description:i.localize(116,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:i.localize(117,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:i.localize(118,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[i.localize(119,null),i.localize(120,null),i.localize(121,null)],default:Q.highlightActiveIndentation,description:i.localize(122,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{bracketPairs:ee(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Q,ge){const Ne=ge.indexOf(X);return Ne===-1?Q:ge[Ne]}class ce extends b{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(123,null),i.localize(124,null)],default:Q.insertMode,description:i.localize(125,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:i.localize(126,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:i.localize(127,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:i.localize(128,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:i.localize(129,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:i.localize(130,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:i.localize(131,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:i.localize(132,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:i.localize(133,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:i.localize(134,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(135,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(136,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(137,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(138,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:i.localize(139,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:i.localize(140,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(141,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:i.localize(142,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(143,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(144,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(145,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(146,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(147,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(148,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(149,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(150,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(151,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(152,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(153,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(154,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(155,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(156,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(157,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(158,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(159,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(160,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(161,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(162,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:i.localize(163,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(164,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(165,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const ge=Q;return{insertMode:r(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:s(ge.showIcons,this.defaultValue.showIcons),showStatusBar:s(ge.showStatusBar,this.defaultValue.showStatusBar),preview:s(ge.preview,this.defaultValue.preview),previewMode:r(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(ge.showMethods,this.defaultValue.showMethods),showFunctions:s(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:s(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(ge.showFields,this.defaultValue.showFields),showVariables:s(ge.showVariables,this.defaultValue.showVariables),showClasses:s(ge.showClasses,this.defaultValue.showClasses),showStructs:s(ge.showStructs,this.defaultValue.showStructs),showInterfaces:s(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:s(ge.showModules,this.defaultValue.showModules),showProperties:s(ge.showProperties,this.defaultValue.showProperties),showEvents:s(ge.showEvents,this.defaultValue.showEvents),showOperators:s(ge.showOperators,this.defaultValue.showOperators),showUnits:s(ge.showUnits,this.defaultValue.showUnits),showValues:s(ge.showValues,this.defaultValue.showValues),showConstants:s(ge.showConstants,this.defaultValue.showConstants),showEnums:s(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:s(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(ge.showKeywords,this.defaultValue.showKeywords),showWords:s(ge.showWords,this.defaultValue.showWords),showColors:s(ge.showColors,this.defaultValue.showColors),showFiles:s(ge.showFiles,this.defaultValue.showFiles),showReferences:s(ge.showReferences,this.defaultValue.showReferences),showFolders:s(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:s(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(ge.showSnippets,this.defaultValue.showSnippets),showUsers:s(ge.showUsers,this.defaultValue.showUsers),showIssues:s(ge.showIssues,this.defaultValue.showIssues)}}}class be extends b{constructor(){super(103,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:i.localize(166,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class oe extends m{constructor(){super(132)}compute(Q,ge,Ne){return ge.get(82)?!0:Q.tabFocusMode}}var we;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(we=e.WrappingIndent||(e.WrappingIndent={}));class ve extends b{constructor(){super(126,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[i.localize(167,null),i.localize(168,null),i.localize(169,null),i.localize(170,null)],description:i.localize(171,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,ge,Ne){return ge.get(2)===2?0:Ne}}class Ue extends m{constructor(){super(134)}compute(Q,ge,Ne){const je=ge.get(133);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}class ze extends b{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:i.localize(172,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:s(Q.enabled,this.defaultValue.enabled)}}}const et="Consolas, 'Courier New', monospace",Ke="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Ke:I.isLinux?tt:et,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(X){return e.editorOptionsRegistry[X.id]=X,X}var ht;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.dropIntoEditor=32]="dropIntoEditor",X[X.emptySelectionClipboard=33]="emptySelectionClipboard",X[X.extraEditorClassName=34]="extraEditorClassName",X[X.fastScrollSensitivity=35]="fastScrollSensitivity",X[X.find=36]="find",X[X.fixedOverflowWidgets=37]="fixedOverflowWidgets",X[X.folding=38]="folding",X[X.foldingStrategy=39]="foldingStrategy",X[X.foldingHighlight=40]="foldingHighlight",X[X.foldingImportsByDefault=41]="foldingImportsByDefault",X[X.foldingMaximumRegions=42]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=43]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=44]="fontFamily",X[X.fontInfo=45]="fontInfo",X[X.fontLigatures=46]="fontLigatures",X[X.fontSize=47]="fontSize",X[X.fontWeight=48]="fontWeight",X[X.formatOnPaste=49]="formatOnPaste",X[X.formatOnType=50]="formatOnType",X[X.glyphMargin=51]="glyphMargin",X[X.gotoLocation=52]="gotoLocation",X[X.hideCursorInOverviewRuler=53]="hideCursorInOverviewRuler",X[X.hover=54]="hover",X[X.inDiffEditor=55]="inDiffEditor",X[X.inlineSuggest=56]="inlineSuggest",X[X.letterSpacing=57]="letterSpacing",X[X.lightbulb=58]="lightbulb",X[X.lineDecorationsWidth=59]="lineDecorationsWidth",X[X.lineHeight=60]="lineHeight",X[X.lineNumbers=61]="lineNumbers",X[X.lineNumbersMinChars=62]="lineNumbersMinChars",X[X.linkedEditing=63]="linkedEditing",X[X.links=64]="links",X[X.matchBrackets=65]="matchBrackets",X[X.minimap=66]="minimap",X[X.mouseStyle=67]="mouseStyle",X[X.mouseWheelScrollSensitivity=68]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=69]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=70]="multiCursorMergeOverlapping",X[X.multiCursorModifier=71]="multiCursorModifier",X[X.multiCursorPaste=72]="multiCursorPaste",X[X.occurrencesHighlight=73]="occurrencesHighlight",X[X.overviewRulerBorder=74]="overviewRulerBorder",X[X.overviewRulerLanes=75]="overviewRulerLanes",X[X.padding=76]="padding",X[X.parameterHints=77]="parameterHints",X[X.peekWidgetDefaultFocus=78]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=79]="definitionLinkOpensInPeek",X[X.quickSuggestions=80]="quickSuggestions",X[X.quickSuggestionsDelay=81]="quickSuggestionsDelay",X[X.readOnly=82]="readOnly",X[X.renameOnType=83]="renameOnType",X[X.renderControlCharacters=84]="renderControlCharacters",X[X.renderFinalNewline=85]="renderFinalNewline",X[X.renderLineHighlight=86]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=87]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=88]="renderValidationDecorations",X[X.renderWhitespace=89]="renderWhitespace",X[X.revealHorizontalRightPadding=90]="revealHorizontalRightPadding",X[X.roundedSelection=91]="roundedSelection",X[X.rulers=92]="rulers",X[X.scrollbar=93]="scrollbar",X[X.scrollBeyondLastColumn=94]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=95]="scrollBeyondLastLine",X[X.scrollPredominantAxis=96]="scrollPredominantAxis",X[X.selectionClipboard=97]="selectionClipboard",X[X.selectionHighlight=98]="selectionHighlight",X[X.selectOnLineNumbers=99]="selectOnLineNumbers",X[X.showFoldingControls=100]="showFoldingControls",X[X.showUnused=101]="showUnused",X[X.snippetSuggestions=102]="snippetSuggestions",X[X.smartSelect=103]="smartSelect",X[X.smoothScrolling=104]="smoothScrolling",X[X.stickyScroll=105]="stickyScroll",X[X.stickyTabStops=106]="stickyTabStops",X[X.stopRenderingLineAfter=107]="stopRenderingLineAfter",X[X.suggest=108]="suggest",X[X.suggestFontSize=109]="suggestFontSize",X[X.suggestLineHeight=110]="suggestLineHeight",X[X.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",X[X.suggestSelection=112]="suggestSelection",X[X.tabCompletion=113]="tabCompletion",X[X.tabIndex=114]="tabIndex",X[X.unicodeHighlighting=115]="unicodeHighlighting",X[X.unusualLineTerminators=116]="unusualLineTerminators",X[X.useShadowDOM=117]="useShadowDOM",X[X.useTabStops=118]="useTabStops",X[X.wordSeparators=119]="wordSeparators",X[X.wordWrap=120]="wordWrap",X[X.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=123]="wordWrapColumn",X[X.wordWrapOverride1=124]="wordWrapOverride1",X[X.wordWrapOverride2=125]="wordWrapOverride2",X[X.wrappingIndent=126]="wrappingIndent",X[X.wrappingStrategy=127]="wrappingStrategy",X[X.showDeprecated=128]="showDeprecated",X[X.inlayHints=129]="inlayHints",X[X.editorClassName=130]="editorClassName",X[X.pixelRatio=131]="pixelRatio",X[X.tabFocusMode=132]="tabFocusMode",X[X.layoutInfo=133]="layoutInfo",X[X.wrappingInfo=134]="wrappingInfo"})(ht=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(173,null)})),acceptSuggestionOnEnter:Fe(new c(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(174,null),""],markdownDescription:i.localize(175,null)})),accessibilitySupport:Fe(new l),accessibilityPageSize:Fe(new S(3,"accessibilityPageSize",10,1,1073741824,{description:i.localize(176,null),tags:["accessibility"]})),ariaLabel:Fe(new C(4,"ariaLabel",i.localize(177,null))),autoClosingBrackets:Fe(new c(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(178,null),i.localize(179,null),""],description:i.localize(180,null)})),autoClosingDelete:Fe(new c(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",i.localize(181,null),""],description:i.localize(182,null)})),autoClosingOvertype:Fe(new c(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(183,null),""],description:i.localize(184,null)})),autoClosingQuotes:Fe(new c(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(185,null),i.localize(186,null),""],description:i.localize(187,null)})),autoIndent:Fe(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[i.localize(188,null),i.localize(189,null),i.localize(190,null),i.localize(191,null),i.localize(192,null)],description:i.localize(193,null)})),automaticLayout:Fe(new a(10,"automaticLayout",!1)),autoSurround:Fe(new c(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(194,null),i.localize(195,null),i.localize(196,null),""],description:i.localize(197,null)})),bracketPairColorization:Fe(new W),bracketPairGuides:Fe(new q),stickyTabStops:Fe(new a(106,"stickyTabStops",!1,{description:i.localize(198,null)})),codeLens:Fe(new a(14,"codeLens",!0,{description:i.localize(199,null)})),codeLensFontFamily:Fe(new C(15,"codeLensFontFamily","",{description:i.localize(200,null)})),codeLensFontSize:Fe(new S(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:i.localize(201,null)})),colorDecorators:Fe(new a(17,"colorDecorators",!0,{description:i.localize(202,null)})),columnSelection:Fe(new a(18,"columnSelection",!1,{description:i.localize(203,null)})),comments:Fe(new f),contextmenu:Fe(new a(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new a(21,"copyWithSyntaxHighlighting",!0,{description:i.localize(204,null)})),cursorBlinking:Fe(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:i.localize(205,null)})),cursorSmoothCaretAnimation:Fe(new a(23,"cursorSmoothCaretAnimation",!1,{description:i.localize(206,null)})),cursorStyle:Fe(new n(24,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:i.localize(207,null)})),cursorSurroundingLines:Fe(new S(25,"cursorSurroundingLines",0,0,1073741824,{description:i.localize(208,null)})),cursorSurroundingLinesStyle:Fe(new c(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(209,null),i.localize(210,null)],description:i.localize(211,null)})),cursorWidth:Fe(new S(27,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(212,null)})),disableLayerHinting:Fe(new a(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new a(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new a(30,"domReadOnly",!1)),dragAndDrop:Fe(new a(31,"dragAndDrop",!0,{description:i.localize(213,null)})),emptySelectionClipboard:Fe(new H),dropIntoEditor:Fe(new ze),stickyScroll:Fe(new pe),extraEditorClassName:Fe(new C(34,"extraEditorClassName","")),fastScrollSensitivity:Fe(new u(35,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:i.localize(214,null)})),find:Fe(new V),fixedOverflowWidgets:Fe(new a(37,"fixedOverflowWidgets",!1)),folding:Fe(new a(38,"folding",!0,{description:i.localize(215,null)})),foldingStrategy:Fe(new c(39,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(216,null),i.localize(217,null)],description:i.localize(218,null)})),foldingHighlight:Fe(new a(40,"foldingHighlight",!0,{description:i.localize(219,null)})),foldingImportsByDefault:Fe(new a(41,"foldingImportsByDefault",!1,{description:i.localize(220,null)})),foldingMaximumRegions:Fe(new S(42,"foldingMaximumRegions",5e3,10,65e3,{description:i.localize(221,null)})),unfoldOnClickAfterEndOfLine:Fe(new a(43,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(222,null)})),fontFamily:Fe(new C(44,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:i.localize(223,null)})),fontInfo:Fe(new U),fontLigatures2:Fe(new P),fontSize:Fe(new R),fontWeight:Fe(new x),formatOnPaste:Fe(new a(49,"formatOnPaste",!1,{description:i.localize(224,null)})),formatOnType:Fe(new a(50,"formatOnType",!1,{description:i.localize(225,null)})),glyphMargin:Fe(new a(51,"glyphMargin",!0,{description:i.localize(226,null)})),gotoLocation:Fe(new z),hideCursorInOverviewRuler:Fe(new a(53,"hideCursorInOverviewRuler",!1,{description:i.localize(227,null)})),hover:Fe(new B),inDiffEditor:Fe(new a(55,"inDiffEditor",!1)),letterSpacing:Fe(new u(57,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>u.clamp(X,-5,20),{description:i.localize(228,null)})),lightbulb:Fe(new ne),lineDecorationsWidth:Fe(new t(59,"lineDecorationsWidth",10)),lineHeight:Fe(new de),lineNumbers:Fe(new ye),lineNumbersMinChars:Fe(new S(62,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new a(63,"linkedEditing",!1,{description:i.localize(229,null)})),links:Fe(new a(64,"links",!0,{description:i.localize(230,null)})),matchBrackets:Fe(new c(65,"matchBrackets","always",["always","near","never"],{description:i.localize(231,null)})),minimap:Fe(new Y),mouseStyle:Fe(new c(67,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new u(68,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:i.localize(232,null)})),mouseWheelZoom:Fe(new a(69,"mouseWheelZoom",!1,{markdownDescription:i.localize(233,null)})),multiCursorMergeOverlapping:Fe(new a(70,"multiCursorMergeOverlapping",!0,{description:i.localize(234,null)})),multiCursorModifier:Fe(new n(71,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[i.localize(235,null),i.localize(236,null)],markdownDescription:i.localize(237,null)})),multiCursorPaste:Fe(new c(72,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(238,null),i.localize(239,null)],markdownDescription:i.localize(240,null)})),occurrencesHighlight:Fe(new a(73,"occurrencesHighlight",!0,{description:i.localize(241,null)})),overviewRulerBorder:Fe(new a(74,"overviewRulerBorder",!0,{description:i.localize(242,null)})),overviewRulerLanes:Fe(new S(75,"overviewRulerLanes",3,0,3)),padding:Fe(new Se),parameterHints:Fe(new Oe),peekWidgetDefaultFocus:Fe(new c(78,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(243,null),i.localize(244,null)],description:i.localize(245,null)})),definitionLinkOpensInPeek:Fe(new a(79,"definitionLinkOpensInPeek",!1,{description:i.localize(246,null)})),quickSuggestions:Fe(new Xe),quickSuggestionsDelay:Fe(new S(81,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(247,null)})),readOnly:Fe(new a(82,"readOnly",!1)),renameOnType:Fe(new a(83,"renameOnType",!1,{description:i.localize(248,null),markdownDeprecationMessage:i.localize(249,null)})),renderControlCharacters:Fe(new a(84,"renderControlCharacters",!0,{description:i.localize(250,null),restricted:!0})),renderFinalNewline:Fe(new a(85,"renderFinalNewline",!0,{description:i.localize(251,null)})),renderLineHighlight:Fe(new c(86,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(252,null)],description:i.localize(253,null)})),renderLineHighlightOnlyWhenFocus:Fe(new a(87,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(254,null)})),renderValidationDecorations:Fe(new c(88,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new c(89,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",i.localize(255,null),i.localize(256,null),i.localize(257,null),""],description:i.localize(258,null)})),revealHorizontalRightPadding:Fe(new S(90,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new a(91,"roundedSelection",!0,{description:i.localize(259,null)})),rulers:Fe(new se),scrollbar:Fe(new J),scrollBeyondLastColumn:Fe(new S(94,"scrollBeyondLastColumn",4,0,1073741824,{description:i.localize(260,null)})),scrollBeyondLastLine:Fe(new a(95,"scrollBeyondLastLine",!0,{description:i.localize(261,null)})),scrollPredominantAxis:Fe(new a(96,"scrollPredominantAxis",!0,{description:i.localize(262,null)})),selectionClipboard:Fe(new a(97,"selectionClipboard",!0,{description:i.localize(263,null),included:I.isLinux})),selectionHighlight:Fe(new a(98,"selectionHighlight",!0,{description:i.localize(264,null)})),selectOnLineNumbers:Fe(new a(99,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new c(100,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[i.localize(265,null),i.localize(266,null),i.localize(267,null)],description:i.localize(268,null)})),showUnused:Fe(new a(101,"showUnused",!0,{description:i.localize(269,null)})),showDeprecated:Fe(new a(128,"showDeprecated",!0,{description:i.localize(270,null)})),inlayHints:Fe(new ae),snippetSuggestions:Fe(new c(102,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(271,null),i.localize(272,null),i.localize(273,null),i.localize(274,null)],description:i.localize(275,null)})),smartSelect:Fe(new be),smoothScrolling:Fe(new a(104,"smoothScrolling",!1,{description:i.localize(276,null)})),stopRenderingLineAfter:Fe(new S(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new ce),inlineSuggest:Fe(new L),suggestFontSize:Fe(new S(109,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(277,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new S(110,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(278,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new a(111,"suggestOnTriggerCharacters",!0,{description:i.localize(279,null)})),suggestSelection:Fe(new c(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(280,null),i.localize(281,null),i.localize(282,null)],description:i.localize(283,null)})),tabCompletion:Fe(new c(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(284,null),i.localize(285,null),i.localize(286,null)],description:i.localize(287,null)})),tabIndex:Fe(new S(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new _),unusualLineTerminators:Fe(new c(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[i.localize(288,null),i.localize(289,null),i.localize(290,null)],description:i.localize(291,null)})),useShadowDOM:Fe(new a(117,"useShadowDOM",!0)),useTabStops:Fe(new a(118,"useTabStops",!0,{description:i.localize(292,null)})),wordSeparators:Fe(new C(119,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:i.localize(293,null)})),wordWrap:Fe(new c(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(294,null),i.localize(295,null),i.localize(296,null),i.localize(297,null)],description:i.localize(298,null)})),wordWrapBreakAfterCharacters:Fe(new C(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new C(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new S(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(299,null)})),wordWrapOverride1:Fe(new c(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new c(125,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new j),pixelRatio:Fe(new Be),tabFocusMode:Fe(new oe),layoutInfo:Fe(new Z),wrappingInfo:Fe(new Ue),wrappingIndent:Fe(new ve),wrappingStrategy:Fe(new ue)}}),define(De[125],Ie([16,17]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[126],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[127],Ie([16,17]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[128],Ie([16,17]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(De[129],Ie([16,17]),function(ie,e){return ie.create("vs/platform/markers/common/markers",e)}),define(De[130],Ie([16,17]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(De[131],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[132],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[133],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostProgress",e)}),define(De[134],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[135],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[136],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[137],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[138],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/common/editor",e)}),define(De[139],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[140],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[141],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[142],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[143],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[144],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[145],Ie([16,17]),function(ie,e){return ie.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[146],Ie([1,0,22,29,127,246]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(a){return a=a.trim(),a==="*"||D.test(a)}e.isValidVersionStr=y;function T(a){if(!y(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=a.match(D);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=T;function O(a){if(!a)return null;const p=a.majorBase,S=a.majorMustEqual,u=a.minorBase;let C=a.minorMustEqual;const r=a.patchBase;let c=a.patchMustEqual;a.hasCaret&&(p===0||(C=!1),c=!1);let n=0;if(a.preRelease){const d=A.exec(a.preRelease);if(d){const[,l,f,o]=d;n=Date.UTC(Number(l),Number(f)-1,Number(o))}}return{majorBase:p,majorMustEqual:S,minorBase:u,minorMustEqual:C,patchBase:r,patchMustEqual:c,isMinimum:a.hasGreaterEquals,notBefore:n}}e.normalizeVersion=O;function b(a,p,S){let u;typeof a=="string"?u=O(T(a)):u=a;let C;p instanceof Date?C=p.getTime():typeof p=="string"&&(C=new Date(p).getTime());let r;if(typeof S=="string"?r=O(T(S)):r=S,!u||!r)return!1;const c=u.majorBase,n=u.minorBase,d=u.patchBase;let l=r.majorBase,f=r.minorBase,o=r.patchBase;const h=r.notBefore;let v=r.majorMustEqual,k=r.minorMustEqual,F=r.patchMustEqual;return r.isMinimum?c>l?!0:c<l?!1:n>f?!0:n<f||C&&C<h?!1:d>=o:(c===1&&l===0&&(!v||!k||!F)&&(l=1,f=0,o=0,v=!0,k=!1,F=!1),c<l?!1:c>l?!v:n<f?!1:n>f?!k:d<o?!1:d>o?!F:!(C&&C<h))}e.isValidVersion=b;function g(a,p,S,u,C){const r=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return r.push([I.default.Error,w.localize(0,null)]),r;if(typeof u.name!="string")return r.push([I.default.Error,w.localize(1,null,"name")]),r;if(typeof u.version!="string")return r.push([I.default.Error,w.localize(2,null,"version")]),r;if(!u.engines)return r.push([I.default.Error,w.localize(3,null,"engines")]),r;if(typeof u.engines.vscode!="string")return r.push([I.default.Error,w.localize(4,null,"engines.vscode")]),r;if(typeof u.extensionDependencies<"u"&&!s(u.extensionDependencies))return r.push([I.default.Error,w.localize(5,null,"extensionDependencies")]),r;if(typeof u.activationEvents<"u"){if(!s(u.activationEvents))return r.push([I.default.Error,w.localize(6,null,"activationEvents")]),r;if(typeof u.main>"u"&&typeof u.browser>"u")return r.push([I.default.Error,w.localize(7,null,"activationEvents","main")]),r}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&r.push([I.default.Warning,w.localize(8,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return r.push([I.default.Error,w.localize(9,null,"main")]),r;{const d=(0,i.joinPath)(S,u.main);(0,i.isEqualOrParent)(d,S)||r.push([I.default.Warning,w.localize(10,null,d.path,S.path)])}if(typeof u.activationEvents>"u")return r.push([I.default.Error,w.localize(11,null,"activationEvents","main")]),r}if(typeof u.browser<"u"){if(typeof u.browser!="string")return r.push([I.default.Error,w.localize(12,null,"browser")]),r;{const d=(0,i.joinPath)(S,u.browser);(0,i.isEqualOrParent)(d,S)||r.push([I.default.Warning,w.localize(13,null,d.path,S.path)])}if(typeof u.activationEvents>"u")return r.push([I.default.Error,w.localize(14,null,"activationEvents","browser")]),r}if(!M.valid(u.version))return r.push([I.default.Error,w.localize(15,null)]),r;const c=[];if(!E(a,p,u,C,c))for(const d of c)r.push([I.default.Error,d]);return r}e.validateExtensionManifest=g;function E(a,p,S,u,C){return u||typeof S.main>"u"&&typeof S.browser>"u"?!0:t(a,p,S.engines.vscode,C)}e.isValidExtensionVersion=E;function m(a,p,S){return a==="*"||t(p,S,a)}e.isEngineValid=m;function t(a,p,S,u=[]){const C=O(T(S));if(!C)return u.push(w.localize(16,null,S)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return u.push(w.localize(17,null,S)),!1}else if(!C.majorMustEqual)return u.push(w.localize(18,null,S)),!1;return b(a,p,C)?!0:(u.push(w.localize(19,null,a,S)),!1)}function s(a){if(!Array.isArray(a))return!1;for(let p=0,S=a.length;p<S;p++)if(typeof a[p]!="string")return!1;return!0}}),define(De[84],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class i{constructor(w,M=[],D=!1){this.ctor=w,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=i}),define(De[59],Ie([1,0,84]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const I=[];var w;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(w=e.InstantiationType||(e.InstantiationType={}));function M(A,y,T){y instanceof i.SyncDescriptor||(y=new i.SyncDescriptor(y,[],Boolean(T))),I.push([A,y])}e.registerSingleton=M;function D(){return I}e.getSingletonServiceDescriptors=D}),define(De[147],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class i{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=i;class I{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(const D of this._nodes.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const A=this.lookupOrInsertNode(M),y=this.lookupOrInsertNode(D);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(M){const D=this._hashFn(M);this._nodes.delete(D);for(const A of this._nodes.values())A.outgoing.delete(D),A.incoming.delete(D)}lookupOrInsertNode(M){const D=this._hashFn(M);let A=this._nodes.get(D);return A||(A=new i(D,M),this._nodes.set(D,A)),A}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){const M=[];for(const[D,A]of this._nodes)M.push(`${D}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this._nodes){const A=new Set([M]),y=this._findCycle(D,A);if(y)return y}}_findCycle(M,D){for(const[A,y]of M.outgoing){if(D.has(A))return[...D,A].join(" -> ");D.add(A);const T=this._findCycle(y,D);if(T)return T;D.delete(A)}}}e.Graph=I}),define(De[3],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var i;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=A})(i=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function I(D,A,y){A[i.DI_TARGET]===A?A[i.DI_DEPENDENCIES].push({id:D,index:y}):(A[i.DI_DEPENDENCIES]=[{id:D,index:y}],A[i.DI_TARGET]=A)}function w(D){if(i.serviceIds.has(D))return i.serviceIds.get(D);const A=function(y,T,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(A,y,O)};return A.toString=()=>D,i.serviceIds.set(D,A),A}e.createDecorator=w;function M(D){return D}e.refineServiceDecorator=M}),define(De[40],Ie([1,0,9,2,3]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function M(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof I.URI)}e.isConfigurationOverrides=M;function D(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof I.URI)}e.isConfigurationUpdateOverrides=D;var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function T(a,p){const S=Object.create(null);for(const u in a)O(S,u,a[u],p);return S}e.toValuesTree=T;function O(a,p,S,u){const C=p.split("."),r=C.pop();let c=a;for(let n=0;n<C.length;n++){const d=C[n];let l=c[d];switch(typeof l){case"undefined":l=c[d]=Object.create(null);break;case"object":break;default:u(`Ignoring ${p} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(l)}`);return}c=l}if(typeof c=="object"&&c!==null)try{c[r]=S}catch{u(`Ignoring ${p} as ${C.join(".")} is ${JSON.stringify(c)}`)}else u(`Ignoring ${p} as ${C.join(".")} is ${JSON.stringify(c)}`)}e.addToValueTree=O;function b(a,p){const S=p.split(".");g(a,S)}e.removeFromValueTree=b;function g(a,p){const S=p.shift();if(p.length===0){delete a[S];return}if(Object.keys(a).indexOf(S)!==-1){const u=a[S];typeof u=="object"&&!Array.isArray(u)&&(g(u,p),Object.keys(u).length===0&&delete a[S])}}function E(a,p,S){function u(c,n){let d=c;for(const l of n){if(typeof d!="object"||d===null)return;d=d[l]}return d}const C=p.split("."),r=u(a,C);return typeof r>"u"?S:r}e.getConfigurationValue=E;function m(a,p,S){Object.keys(p).forEach(u=>{u!=="__proto__"&&(u in a?i.isObject(a[u])&&i.isObject(p[u])?m(a[u],p[u],S):S&&(a[u]=p[u]):a[u]=p[u])})}e.merge=m;function t(a,p,S){const u=a.inspect(p),C=a.inspect(S);return typeof u.userValue<"u"||typeof u.workspaceValue<"u"||typeof u.workspaceFolderValue<"u"?u.value:typeof C.userValue<"u"||typeof C.workspaceValue<"u"||typeof C.workspaceFolderValue<"u"?C.value:u.defaultValue}e.getMigratedSettingValue=t;function s(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=s}),define(De[41],Ie([1,0,21,10,3]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const M=new Map;M.set("false",!1),M.set("true",!0),M.set("isMac",i.isMacintosh),M.set("isLinux",i.isLinux),M.set("isWindows",i.isWindows),M.set("isWeb",i.isWeb),M.set("isMacNative",i.isMacintosh&&!i.isWeb),M.set("isEdge",i.isEdge),M.set("isFirefox",i.isFirefox),M.set("isChrome",i.isChrome),M.set("isSafari",i.isSafari);const D=Object.prototype.hasOwnProperty;var A;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return b.INSTANCE}static true(){return g.INSTANCE}static has(P){return E.create(P)}static equals(P,U){return m.create(P,U)}static notEquals(P,U){return a.create(P,U)}static regex(P,U){return n.create(P,U)}static in(P,U){return t.create(P,U)}static notIn(P,U){return s.create(P,U)}static not(P){return p.create(P)}static and(...P){return f.create(P,null,!0)}static or(...P){return o.create(P,null,!0)}static greater(P,U){return u.create(P,U)}static greaterEquals(P,U){return C.create(P,U)}static smaller(P,U){return r.create(P,U)}static smallerEquals(P,U){return c.create(P,U)}static deserialize(P,U=!1){if(!!P)return this._deserializeOrExpression(P,U)}static _deserializeOrExpression(P,U){const R=P.split("||");return o.create(R.map(x=>this._deserializeAndExpression(x,U)),null,!0)}static _deserializeAndExpression(P,U){const R=P.split("&&");return f.create(R.map(x=>this._deserializeOne(x,U)),null,!0)}static _deserializeOne(P,U){if(P=P.trim(),P.indexOf("!=")>=0){const R=P.split("!=");return a.create(R[0].trim(),this._deserializeValue(R[1],U))}if(P.indexOf("==")>=0){const R=P.split("==");return m.create(R[0].trim(),this._deserializeValue(R[1],U))}if(P.indexOf("=~")>=0){const R=P.split("=~");return n.create(R[0].trim(),this._deserializeRegexValue(R[1],U))}if(P.indexOf(" not in ")>=0){const R=P.split(" not in ");return s.create(R[0].trim(),this._deserializeValue(R[1],U))}if(P.indexOf(" in ")>=0){const R=P.split(" in ");return t.create(R[0].trim(),this._deserializeValue(R[1],U))}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const R=P.split(">=");return C.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const R=P.split(">");return u.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const R=P.split("<=");return c.create(R[0].trim(),R[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const R=P.split("<");return r.create(R[0].trim(),R[1].trim())}return/^\!\s*/.test(P)?p.create(P.substr(1).trim()):E.create(P)}static _deserializeValue(P,U){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;const R=/^'([^']*)'$/.exec(P);return R?R[1].trim():P}static _deserializeRegexValue(P,U){if((0,I.isFalsyOrWhitespace)(P)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const R=P.indexOf("/"),x=P.lastIndexOf("/");if(R===x||R<0){if(U)throw new Error(`bad regexp-value '${P}', missing /-enclosure`);return console.warn(`bad regexp-value '${P}', missing /-enclosure`),null}const z=P.slice(R+1,x),B=P[x+1]==="i"?"i":"";try{return new RegExp(z,B)}catch(K){if(U)throw new Error(`bad regexp-value '${P}', parse error: ${K}`);return console.warn(`bad regexp-value '${P}', parse error: ${K}`),null}}}e.ContextKeyExpr=y;function T(V,P){const U=V?V.substituteConstants():void 0,R=P?P.substituteConstants():void 0;return!U&&!R?!0:!U||!R?!1:U.equals(R)}e.expressionsAreEqualWithConstantSubstitution=T;function O(V,P){return V.cmp(P)}class b{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class g{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class E{static create(P,U=null){const R=M.get(P);return typeof R=="boolean"?R?g.INSTANCE:b.INSTANCE:new E(P,U)}constructor(P,U){this.key=P,this.negated=U,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:v(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=M.get(this.key);return typeof P=="boolean"?P?g.INSTANCE:b.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=p.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=E;class m{static create(P,U,R=null){if(typeof U=="boolean")return U?E.create(P,R):p.create(P,R);const x=M.get(P);return typeof x=="boolean"?U===(x?"true":"false")?g.INSTANCE:b.INSTANCE:new m(P,U,R)}constructor(P,U,R){this.key=P,this.value=U,this.negated=R,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:k(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=M.get(this.key);if(typeof P=="boolean"){const U=P?"true":"false";return this.value===U?g.INSTANCE:b.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=m;class t{static create(P,U){return new t(P,U)}constructor(P,U){this.key=P,this.valueKey=U,this.type=10,this.negated=null}cmp(P){return P.type!==this.type?this.type-P.type:k(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const U=P.getValue(this.valueKey),R=P.getValue(this.key);return Array.isArray(U)?U.includes(R):typeof R=="string"&&typeof U=="object"&&U!==null?D.call(U,R):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=s.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=t;class s{static create(P,U){return new s(P,U)}constructor(P,U){this.key=P,this.valueKey=U,this.type=11,this._negated=t.create(P,U)}cmp(P){return P.type!==this.type?this.type-P.type:this._negated.cmp(P._negated)}equals(P){return P.type===this.type?this._negated.equals(P._negated):!1}substituteConstants(){return this}evaluate(P){return!this._negated.evaluate(P)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(P){return P.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=s;class a{static create(P,U,R=null){if(typeof U=="boolean")return U?p.create(P,R):E.create(P,R);const x=M.get(P);return typeof x=="boolean"?U===(x?"true":"false")?b.INSTANCE:g.INSTANCE:new a(P,U,R)}constructor(P,U,R){this.key=P,this.value=U,this.negated=R,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:k(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=M.get(this.key);if(typeof P=="boolean"){const U=P?"true":"false";return this.value===U?b.INSTANCE:g.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=a;class p{static create(P,U=null){const R=M.get(P);return typeof R=="boolean"?R?b.INSTANCE:g.INSTANCE:new p(P,U)}constructor(P,U){this.key=P,this.negated=U,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:v(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=M.get(this.key);return typeof P=="boolean"?P?b.INSTANCE:g.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=E.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=p;function S(V,P){if(typeof V=="string"){const U=parseFloat(V);isNaN(U)||(V=U)}return typeof V=="string"||typeof V=="number"?P(V):b.INSTANCE}class u{static create(P,U,R=null){return S(U,x=>new u(P,x,R))}constructor(P,U,R){this.key=P,this.value=U,this.negated=R,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:k(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class C{static create(P,U,R=null){return S(U,x=>new C(P,x,R))}constructor(P,U,R){this.key=P,this.value=U,this.negated=R,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:k(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=C;class r{static create(P,U,R=null){return S(U,x=>new r(P,x,R))}constructor(P,U,R){this.key=P,this.value=U,this.negated=R,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:k(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=r;class c{static create(P,U,R=null){return S(U,x=>new c(P,x,R))}constructor(P,U,R){this.key=P,this.value=U,this.negated=R,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:k(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return typeof this.value=="string"?!1:parseFloat(P.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=c;class n{static create(P,U){return new n(P,U)}constructor(P,U){this.key=P,this.regexp=U,this.type=7,this.negated=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const U=this.regexp?this.regexp.source:"",R=P.regexp?P.regexp.source:"";return U<R?-1:U>R?1:0}equals(P){if(P.type===this.type){const U=this.regexp?this.regexp.source:"",R=P.regexp?P.regexp.source:"";return this.key===P.key&&U===R}return!1}substituteConstants(){return this}evaluate(P){const U=P.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=d.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class d{static create(P){return new d(P)}constructor(P){this._actual=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new d(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=d;function l(V){let P=null;for(let U=0,R=V.length;U<R;U++){const x=V[U].substituteConstants();if(V[U]!==x&&P===null){P=[];for(let z=0;z<U;z++)P[z]=V[z]}P!==null&&(P[U]=x)}return P===null?V:P}class f{static create(P,U,R){return f._normalizeArr(P,U,R)}constructor(P,U){this.expr=P,this.negated=U,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let U=0,R=this.expr.length;U<R;U++){const x=O(this.expr[U],P.expr[U]);if(x!==0)return x}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let U=0,R=this.expr.length;U<R;U++)if(!this.expr[U].equals(P.expr[U]))return!1;return!0}return!1}substituteConstants(){const P=l(this.expr);return P===this.expr?this:f.create(P,this.negated,!1)}evaluate(P){for(let U=0,R=this.expr.length;U<R;U++)if(!this.expr[U].evaluate(P))return!1;return!0}static _normalizeArr(P,U,R){const x=[];let z=!1;for(const B of P)if(!!B){if(B.type===1){z=!0;continue}if(B.type===0)return b.INSTANCE;if(B.type===6){x.push(...B.expr);continue}x.push(B)}if(x.length===0&&z)return g.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(O);for(let B=1;B<x.length;B++)x[B-1].equals(x[B])&&(x.splice(B,1),B--);if(x.length===1)return x[0];for(;x.length>1;){const B=x[x.length-1];if(B.type!==9)break;x.pop();const K=x.pop(),Z=x.length===0,ue=o.create(B.expr.map(ne=>f.create([ne,K],null,R)),null,Z);ue&&(x.push(ue),x.sort(O))}if(x.length===1)return x[0];if(R){for(let B=0;B<x.length;B++)for(let K=B+1;K<x.length;K++)if(x[B].negate().equals(x[K]))return b.INSTANCE;if(x.length===1)return x[0]}return new f(x,U)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const U of this.expr)P.push(...U.keys());return P}map(P){return new f(this.expr.map(U=>U.map(P)),null)}negate(){if(!this.negated){const P=[];for(const U of this.expr)P.push(U.negate());this.negated=o.create(P,this,!0)}return this.negated}}class o{static create(P,U,R){return o._normalizeArr(P,U,R)}constructor(P,U){this.expr=P,this.negated=U,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let U=0,R=this.expr.length;U<R;U++){const x=O(this.expr[U],P.expr[U]);if(x!==0)return x}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let U=0,R=this.expr.length;U<R;U++)if(!this.expr[U].equals(P.expr[U]))return!1;return!0}return!1}substituteConstants(){const P=l(this.expr);return P===this.expr?this:o.create(P,this.negated,!1)}evaluate(P){for(let U=0,R=this.expr.length;U<R;U++)if(this.expr[U].evaluate(P))return!0;return!1}static _normalizeArr(P,U,R){let x=[],z=!1;if(P){for(let B=0,K=P.length;B<K;B++){const Z=P[B];if(!!Z){if(Z.type===0){z=!0;continue}if(Z.type===1)return g.INSTANCE;if(Z.type===9){x=x.concat(Z.expr);continue}x.push(Z)}}if(x.length===0&&z)return b.INSTANCE;x.sort(O)}if(x.length!==0){if(x.length===1)return x[0];for(let B=1;B<x.length;B++)x[B-1].equals(x[B])&&(x.splice(B,1),B--);if(x.length===1)return x[0];if(R){for(let B=0;B<x.length;B++)for(let K=B+1;K<x.length;K++)if(x[B].negate().equals(x[K]))return g.INSTANCE;if(x.length===1)return x[0]}return new o(x,U)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const U of this.expr)P.push(...U.keys());return P}map(P){return new o(this.expr.map(U=>U.map(P)),null)}negate(){if(!this.negated){const P=[];for(const U of this.expr)P.push(U.negate());for(;P.length>1;){const U=P.shift(),R=P.shift(),x=[];for(const z of H(U))for(const B of H(R))x.push(f.create([z,B],null,!1));P.unshift(o.create(x,null,!1))}this.negated=o.create(P,this,!0)}return this.negated}}class h extends E{static all(){return h._info.values()}constructor(P,U,R){super(P,null),this._defaultValue=U,typeof R=="object"?h._info.push({...R,key:P}):R!==!0&&h._info.push({key:P,description:R,type:U!=null?typeof U:void 0})}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return m.create(this.key,P)}notEqualsTo(P){return a.create(this.key,P)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(V,P){return V<P?-1:V>P?1:0}function k(V,P,U,R){return V<U?-1:V>U?1:P<R?-1:P>R?1:0}function F(V,P){if(V.type===0||P.type===1)return!0;if(V.type===9)return P.type===9?j(V.expr,P.expr):!1;if(P.type===9){for(const U of P.expr)if(F(V,U))return!0;return!1}if(V.type===6){if(P.type===6)return j(P.expr,V.expr);for(const U of V.expr)if(F(U,P))return!0;return!1}return V.equals(P)}e.implies=F;function j(V,P){let U=0,R=0;for(;U<V.length&&R<P.length;){const x=V[U].cmp(P[R]);if(x<0)return!1;x===0&&U++,R++}return U===V.length}function H(V){return V.type===9?V.expr:[V]}}),define(De[148],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,i.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,i.refineServiceDecorator)(e.IEnvironmentService)}),define(De[85],Ie([1,0,126,3]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function w(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=w;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=M;function D(a,p){switch(a){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function A(a,p){return p==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(a,p,S){return A(p,S)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===S?!0:T(S).includes(a)}e.isTargetPlatformCompatible=y;function T(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=T;function O(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=O;var b;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var g;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(g=e.SortOrder||(e.SortOrder={}));var E;(function(a){a.Install="install",a.Uninstall="uninstall"})(E=e.StatisticType||(e.StatisticType={}));var m;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService");var t;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal",a.Signature="Signature"})(t=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class s extends Error{constructor(p,S){super(p),this.code=S,this.name=S}}e.ExtensionManagementError=s,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(De[35],Ie([1,0,46,19,10,9,2,128,3]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function T(z){return z.create===!0}e.isFileOpenForWriteOptions=T;var O;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(O=e.FileType||(e.FileType={}));var b;(function(z){z[z.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var g;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileClone=32768]="FileClone"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=E;function m(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=m;function t(z){return!!(z.capabilities&32768)}e.hasFileCloneCapability=t;function s(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function a(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=a;function p(z){return E(z)?!!(z.capabilities&16384):!1}e.hasFileAtomicReadCapability=p;var S;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class u extends Error{constructor(B,K){super(B),this.code=K}}e.FileSystemProviderError=u;function C(z,B){const K=new u(z.toString(),B);return c(K,B),K}e.createFileSystemProviderError=C;function r(z){return z||C((0,A.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=r;function c(z,B){return z.name=B?`${B} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=c;function n(z){if(!z)return S.Unknown;if(z instanceof u)return z.code;const B=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!B)return S.Unknown;switch(B[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=n;function d(z){if(z instanceof k)return z.fileOperationResult;switch(n(z)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=d;var l;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(l=e.FileOperation||(e.FileOperation={}));class f{constructor(B,K,Z){this.resource=B,this.operation=K,this.target=Z}isOperation(B){return this.operation===B}}e.FileOperationEvent=f;var o;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class h{constructor(B,K){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=B;const Z=new Map;for(const ue of B){const ne=Z.get(ue.type);switch(ne?ne.push([ue.resource,ue]):Z.set(ue.type,[[ue.resource,ue]]),ue.type){case 1:this.rawAdded.push(ue.resource);break;case 0:this.rawUpdated.push(ue.resource);break;case 2:this.rawDeleted.push(ue.resource);break}}for(const[ue,ne]of Z)switch(ue){case 1:this.added=i.TernarySearchTree.forUris(()=>K),this.added.fill(ne);break;case 0:this.updated=i.TernarySearchTree.forUris(()=>K),this.updated.fill(ne);break;case 2:this.deleted=i.TernarySearchTree.forUris(()=>K),this.deleted.fill(ne);break}}contains(B,...K){return this.doContains(B,{includeChildren:!1},...K)}affects(B,...K){return this.doContains(B,{includeChildren:!0},...K)}doContains(B,K,...Z){if(!B)return!1;const ue=Z.length>0;return!!((!ue||Z.includes(1))&&(this.added?.get(B)||K.includeChildren&&this.added?.findSuperstr(B))||(!ue||Z.includes(0))&&(this.updated?.get(B)||K.includeChildren&&this.updated?.findSuperstr(B))||(!ue||Z.includes(2))&&(this.deleted?.findSubstr(B)||K.includeChildren&&this.deleted?.findSuperstr(B)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function v(z,B,K){return!z||!B||z===B||B.length>z.length?!1:(B.charAt(B.length-1)!==I.sep&&(B+=I.sep),K?(0,w.startsWithIgnoreCase)(z,B):z.indexOf(B)===0)}e.isParent=v;class k extends Error{constructor(B,K,Z){super(B),this.fileOperationResult=K,this.options=Z}}e.FileOperationError=k;class F extends k{constructor(B,K,Z){super(B,2,Z),this.stat=K}}e.NotModifiedSinceFileOperationError=F;var j;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(j=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var H;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(H=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=V;async function P(z,B){if(!B.hasProvider(D.URI.from({scheme:z.scheme})))return new Promise(K=>{const Z=B.onDidChangeFileSystemProviderRegistrations(ue=>{ue.scheme===z.scheme&&ue.added&&(Z.dispose(),K())})})}e.whenProviderRegistered=P,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class U{static formatSize(B){return(0,M.isNumber)(B)||(B=0),B<U.KB?(0,A.localize)(1,null,B.toFixed(0)):B<U.MB?(0,A.localize)(2,null,(B/U.KB).toFixed(2)):B<U.GB?(0,A.localize)(3,null,(B/U.MB).toFixed(2)):B<U.TB?(0,A.localize)(4,null,(B/U.GB).toFixed(2)):(0,A.localize)(5,null,(B/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;var R;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(R=e.Arch||(e.Arch={}));function x(z){return{maxFileSize:z===0?300*U.MB:16*U.GB,maxHeapSize:z===0?700*U.MB:2*700*U.MB}}e.getPlatformLimits=x}),define(De[60],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class i{constructor(...w){this._entries=new Map;for(const[M,D]of w)this.set(M,D)}set(w,M){const D=this._entries.get(w);return this._entries.set(w,M),D}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=i}),define(De[149],Ie([1,0,15,12,7,84,147,3,60,150]),function(ie,e,i,I,w,M,D,A,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class b extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class g{constructor(s=new y.ServiceCollection,a=!1,p,S=O){this._services=s,this._strict=a,this._parent=p,this._enableTracing=S,this._activeInstantiations=new Set,this._services.set(A.IInstantiationService,this),this._globalGraph=S?p?._globalGraph??new D.Graph(u=>u):void 0}createChild(s){return new g(s,this._strict,this,this._enableTracing)}invokeFunction(s,...a){const p=m.traceInvocation(this._enableTracing,s);let S=!1;try{return s({get:C=>{if(S)throw(0,I.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(C,p);if(!r)throw new Error(`[invokeFunction] unknown service '${C}'`);return r}},...a)}finally{S=!0,p.stop()}}createInstance(s,...a){let p,S;return s instanceof M.SyncDescriptor?(p=m.traceCreation(this._enableTracing,s.ctor),S=this._createInstance(s.ctor,s.staticArguments.concat(a),p)):(p=m.traceCreation(this._enableTracing,s),S=this._createInstance(s,a,p)),p.stop(),S}_createInstance(s,a=[],p){const S=A._util.getServiceDependencies(s).sort((r,c)=>r.index-c.index),u=[];for(const r of S){const c=this._getOrCreateServiceInstance(r.id,p);c||this._throwIfStrict(`[createInstance] ${s.name} depends on UNKNOWN service ${r.id}.`,!1),u.push(c)}const C=S.length>0?S[0].index:a.length;if(a.length!==C){console.trace(`[createInstance] First service dependency of ${s.name} at position ${C+1} conflicts with ${a.length} static arguments`);const r=C-a.length;r>0?a=a.concat(new Array(r)):a=a.slice(0,C)}return Reflect.construct(s,a.concat(u))}_setServiceInstance(s,a){if(this._services.get(s)instanceof M.SyncDescriptor)this._services.set(s,a);else if(this._parent)this._parent._setServiceInstance(s,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){const a=this._services.get(s);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):a}_getOrCreateServiceInstance(s,a){this._globalGraph&&this._globalGraphImplicitDependency&&this._globalGraph.insertEdge(this._globalGraphImplicitDependency,String(s));const p=this._getServiceInstanceOrDescriptor(s);return p instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,p,a.branch(s,!0)):(a.branch(s,!1),p)}_safeCreateAndCacheServiceInstance(s,a,p){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,a,p)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,a,p){const S=new D.Graph(r=>r.id.toString());let u=0;const C=[{id:s,desc:a,_trace:p}];for(;C.length;){const r=C.pop();if(S.lookupOrInsertNode(r),u++>1e3)throw new b(S);for(const c of A._util.getServiceDependencies(r.desc.ctor)){const n=this._getServiceInstanceOrDescriptor(c.id);if(n||this._throwIfStrict(`[createInstance] ${s} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(c.id)),n instanceof M.SyncDescriptor){const d={id:c.id,desc:n,_trace:r._trace.branch(c.id,!0)};S.insertEdge(r,d),C.push(d)}}}for(;;){const r=S.roots();if(r.length===0){if(!S.isEmpty())throw new b(S);break}for(const{data:c}of r){if(this._getServiceInstanceOrDescriptor(c.id)instanceof M.SyncDescriptor){const d=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,d)}S.removeNode(c)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,a,p=[],S,u){if(this._services.get(s)instanceof M.SyncDescriptor)return this._createServiceInstance(s,a,p,S,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,a,p,S,u);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(s,a,p=[],S,u){if(S){const C=new g(void 0,this._strict,this,this._enableTracing);C._globalGraphImplicitDependency=String(s);const r=new Map,c=new i.IdleValue(()=>{const n=C._createInstance(a,p,u);for(const[d,l]of r){const f=n[d];if(typeof f=="function")for(const o of l)f.apply(n,o)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,d){if(!c.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let o=r.get(d);return o||(o=new T.LinkedList,r.set(d,o)),(v,k,F)=>{const j=o.push([v,k,F]);return(0,w.toDisposable)(j)}}if(d in n)return n[d];const l=c.value;let f=l[d];return typeof f!="function"||(f=f.bind(l),n[d]=f),f},set(n,d,l){return c.value[d]=l,!0}})}else return this._createInstance(a,p,u)}_throwIfStrict(s,a){if(a&&console.warn(s),this._strict)throw new Error(s)}}e.InstantiationService=g;var E;(function(t){t[t.Creation=0]="Creation",t[t.Invocation=1]="Invocation",t[t.Branch=2]="Branch"})(E||(E={}));class m{static traceInvocation(s,a){return s?new m(1,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m._None}static traceCreation(s,a){return s?new m(0,a.name):m._None}constructor(s,a){this.type=s,this.name=a,this._start=Date.now(),this._dep=[]}branch(s,a){const p=new m(2,s.toString());return this._dep.push([s,a,p]),p}stop(){const s=Date.now()-this._start;m._totals+=s;let a=!1;function p(u,C){const r=[],c=new Array(u+1).join("	");for(const[n,d,l]of C._dep)if(d&&l){a=!0,r.push(`${c}CREATES -> ${n}`);const f=p(u+1,l);f&&r.push(f)}else r.push(`${c}uses -> ${n}`);return r.join(`
`)}const S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(s>2||a)&&m.all.add(S.join(`
`))}}e.Trace=m,m.all=new Set,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(De[11],Ie([1,0,45,4,7,28,21,2,3]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function T(){return new Date().toISOString()}var O;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(O=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=O.Info;function b(f,o,h){switch(o){case O.Trace:f.trace(h);break;case O.Debug:f.debug(h);break;case O.Info:f.info(h);break;case O.Warning:f.warn(h);break;case O.Error:f.error(h);break;default:throw new Error("Invalid log level")}}e.log=b;function g(f){let o="";for(let h=0;h<f.length;h++){let v=f[h];if(typeof v=="object")try{v=JSON.stringify(v)}catch{}o+=(h>0?" ":"")+v}return o}e.format=g;class E extends w.Disposable{constructor(){super(...arguments),this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new I.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class m extends E{constructor(o){super(),this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...h){this.checkLogLevel(O.Trace)&&this.log(O.Trace,g([o,...h]))}debug(o,...h){this.checkLogLevel(O.Debug)&&this.log(O.Debug,g([o,...h]))}info(o,...h){this.checkLogLevel(O.Info)&&this.log(O.Info,g([o,...h]))}warn(o,...h){this.checkLogLevel(O.Warning)&&this.log(O.Warning,g([o,...h]))}error(o,...h){if(this.checkLogLevel(O.Error))if(o instanceof Error){const v=Array.prototype.slice.call(arguments);v[0]=o.stack,this.log(O.Error,g(v))}else this.log(O.Error,g([o,...h]))}flush(){}}e.AbstractMessageLogger=m;class t extends E{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o),this.useColors=!D.isWindows}trace(o,...h){this.getLevel()<=O.Trace&&(this.useColors?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,o,...h):console.log(`[main ${T()}]`,o,...h))}debug(o,...h){this.getLevel()<=O.Debug&&(this.useColors?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,o,...h):console.log(`[main ${T()}]`,o,...h))}info(o,...h){this.getLevel()<=O.Info&&(this.useColors?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,o,...h):console.log(`[main ${T()}]`,o,...h))}warn(o,...h){this.getLevel()<=O.Warning&&(this.useColors?console.warn(`\x1B[93m[main ${T()}]\x1B[0m`,o,...h):console.warn(`[main ${T()}]`,o,...h))}error(o,...h){this.getLevel()<=O.Error&&(this.useColors?console.error(`\x1B[91m[main ${T()}]\x1B[0m`,o,...h):console.error(`[main ${T()}]`,o,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=t;class s extends E{constructor(o=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(o)}trace(o,...h){this.getLevel()<=O.Trace&&console.log("%cTRACE","color: #888",o,...h)}debug(o,...h){this.getLevel()<=O.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...h)}info(o,...h){this.getLevel()<=O.Info&&console.log("%c INFO","color: #33f",o,...h)}warn(o,...h){this.getLevel()<=O.Warning&&console.log("%c WARN","color: #993",o,...h)}error(o,...h){this.getLevel()<=O.Error&&console.log("%c  ERR","color: #f33",o,...h)}dispose(){}flush(){}}e.ConsoleLogger=s;class a extends E{constructor(o,h=e.DEFAULT_LOG_LEVEL){super(),this.adapter=o,this.setLevel(h)}trace(o,...h){this.getLevel()<=O.Trace&&this.adapter.log(O.Trace,[this.extractMessage(o),...h])}debug(o,...h){this.getLevel()<=O.Debug&&this.adapter.log(O.Debug,[this.extractMessage(o),...h])}info(o,...h){this.getLevel()<=O.Info&&this.adapter.log(O.Info,[this.extractMessage(o),...h])}warn(o,...h){this.getLevel()<=O.Warning&&this.adapter.log(O.Warning,[this.extractMessage(o),...h])}error(o,...h){this.getLevel()<=O.Error&&this.adapter.log(O.Error,[this.extractMessage(o),...h])}extractMessage(o){return typeof o=="string"?o:(0,i.toErrorMessage)(o,this.getLevel()<=O.Trace)}dispose(){}flush(){}}e.AdapterLogger=a;class p extends E{constructor(o){super(),this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const h of this.logServices)h.setLevel(o);super.setLevel(o)}trace(o,...h){for(const v of this.logServices)v.trace(o,...h)}debug(o,...h){for(const v of this.logServices)v.debug(o,...h)}info(o,...h){for(const v of this.logServices)v.info(o,...h)}warn(o,...h){for(const v of this.logServices)v.warn(o,...h)}error(o,...h){for(const v of this.logServices)v.error(o,...h)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=p;class S extends w.Disposable{constructor(o){super(),this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...h){this.logger.trace(o,...h)}debug(o,...h){this.logger.debug(o,...h)}info(o,...h){this.logger.info(o,...h)}warn(o,...h){this.logger.warn(o,...h)}error(o,...h){this.logger.error(o,...h)}flush(){this.logger.flush()}}e.LogService=S;class u extends w.Disposable{constructor(o,h){super(),this.logLevel=o,this.loggerItems=new M.ResourceMap,this._register(h(v=>this.setLevel(v)))}getLoggers(){return[...this.loggerItems.values()].map(({logger:o})=>o)}getLogger(o){return this.loggerItems.get(o)?.logger}createLogger(o,h,v){let k=this.loggerItems.get(o)?.logger;return k||(v=h?.always?O.Trace:v,k=this.doCreateLogger(o,v??this.logLevel,h),this.loggerItems.set(o,{logger:k,logLevel:v})),k}setLevel(o,h){const v=A.URI.isUri(o)?o:void 0,k=v?h:o;if(v){const F=this.loggerItems.get(v);F&&F.logLevel!==k&&(F.logLevel=k,F.logger.setLevel(k))}else this.logLevel=k,this.loggerItems.forEach(({logLevel:F,logger:j})=>{F===void 0&&j.setLevel(this.logLevel)})}getLogLevel(o){return this.loggerItems.get(o)?.logLevel}dispose(){this.loggerItems.forEach(({logger:o})=>o.dispose()),this.loggerItems.clear(),super.dispose()}}e.AbstractLoggerService=u;class C{constructor(){this.onDidChangeLogLevel=new I.Emitter().event}setLevel(o){}getLevel(){return O.Info}trace(o,...h){}debug(o,...h){}info(o,...h){}warn(o,...h){}error(o,...h){}critical(o,...h){}dispose(){}flush(){}}e.NullLogger=C;class r extends C{}e.NullLogService=r;class c extends u{constructor(){super(O.Info,I.Event.None)}doCreateLogger(o,h,v){return new C}}e.NullLoggerService=c;function n(f){if(f.verbose)return O.Trace;if(typeof f.logLevel=="string"){const o=l(f.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function d(f){switch(f){case O.Trace:return"trace";case O.Debug:return"debug";case O.Info:return"info";case O.Warning:return"warn";case O.Error:return"error";case O.Off:return"off"}}e.LogLevelToString=d;function l(f){switch(f){case"trace":return O.Trace;case"debug":return O.Debug;case"info":return O.Info;case"warn":return O.Warning;case"error":return O.Error;case"critical":return O.Error;case"off":return O.Off}}e.parseLogLevel=l}),define(De[86],Ie([1,0,29,129,3]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(M=e.MarkerTag||(e.MarkerTag={}));var D;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function T(m,t){return t-m}y.compare=T;const O=Object.create(null);O[y.Error]=(0,I.localize)(0,null),O[y.Warning]=(0,I.localize)(1,null),O[y.Info]=(0,I.localize)(2,null);function b(m){return O[m]||""}y.toString=b;function g(m){switch(m){case i.default.Error:return y.Error;case i.default.Warning:return y.Warning;case i.default.Info:return y.Info;case i.default.Ignore:return y.Hint}}y.fromSeverity=g;function E(m){switch(m){case y.Error:return i.default.Error;case y.Warning:return i.default.Warning;case y.Info:return i.default.Info;case y.Hint:return i.default.Ignore}}y.toSeverity=E}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const T="";function O(g){return b(g,!0)}y.makeKey=O;function b(g,E){const m=[T];return g.source?m.push(g.source.replace("\xA6","\\\xA6")):m.push(T),g.code?typeof g.code=="string"?m.push(g.code.replace("\xA6","\\\xA6")):m.push(g.code.value.replace("\xA6","\\\xA6")):m.push(T),g.severity!==void 0&&g.severity!==null?m.push(D.toString(g.severity)):m.push(T),g.message&&E?m.push(g.message.replace("\xA6","\\\xA6")):m.push(T),g.startLineNumber!==void 0&&g.startLineNumber!==null?m.push(g.startLineNumber.toString()):m.push(T),g.startColumn!==void 0&&g.startColumn!==null?m.push(g.startColumn.toString()):m.push(T),g.endLineNumber!==void 0&&g.endLineNumber!==null?m.push(g.endLineNumber.toString()):m.push(T),g.endColumn!==void 0&&g.endColumn!==null?m.push(g.endColumn.toString()):m.push(T),m.push(T),m.join("\xA6")}y.makeKeyOptionalMessage=b})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(De[151],Ie([1,0,4,29,3]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=I.default,e.INotificationService=(0,w.createDecorator)("notificationService");var M;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.PROFILE=1]="PROFILE",T[T.APPLICATION=2]="APPLICATION"})(M=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(De[87],Ie([1,0,7,10,2,3]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,M.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return i.Disposable.None},registerValidator(){return i.Disposable.None},registerExternalUriResolver(){return i.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return i.Disposable.None},async open(){return!1},async resolveExternalUri(O){return{resolved:O,dispose(){}}}});function D(O,b){return w.URI.isUri(O)?(0,I.equalsIgnoreCase)(O.scheme,b):(0,I.startsWithIgnoreCase)(O,b+":")}e.matchesScheme=D;function A(O,...b){return b.some(g=>D(O,g))}e.matchesSomeScheme=A;function y(O,b){return O.with({fragment:`${b.startLineNumber},${b.startColumn}${b.endLineNumber?`-${b.endLineNumber}${b.endColumn?`,${b.endColumn}`:""}`:""}`})}e.withSelection=y;function T(O){let b;const g=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(O.fragment);return g&&(b={startLineNumber:parseInt(g[1]),startColumn:g[2]?parseInt(g[2]):1,endLineNumber:g[4]?parseInt(g[4]):void 0,endColumn:g[4]?g[5]?parseInt(g[5]):1:void 0},O=O.with({fragment:""})),{selection:b,uri:O}}e.extractSelection=T}),define(De[152],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,i.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(ie,e,i,I){var w=arguments.length,M=w<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,i):I,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ie,e,i,I);else for(var A=ie.length-1;A>=0;A--)(D=ie[A])&&(M=(w<3?D(M):w>3?D(e,i,M):D(e,i))||M);return w>3&&M&&Object.defineProperty(e,i,M),M},$e=this&&this.__param||function(ie,e){return function(i,I){e(i,I,ie)}};define(De[153],Ie([1,0,15,20,7,3]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,M.createDecorator)("progressService");var D;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this._value}constructor(b){this.callback=b}report(b){this._value=b,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=class extends w.Disposable{constructor(b,g){super(),this.deferred=new i.DeferredPromise,g.withProgress(b,E=>(this.reporter=E,this.lastStep&&E.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};y=He([$e(1,e.IProgressService)],y),e.UnmanagedProgress=y;class T extends w.Disposable{constructor(b){super(),this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(b){this.stop();const g=++this.currentOperationId,E=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>E.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:E.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,M.createDecorator)("editorProgressService")}),define(De[30],Ie([1,0,47,9]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(D,A){i.ok(I.isString(D)),i.ok(I.isObject(A)),i.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,A)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new w}),define(De[88],Ie([1,0,4,30]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class M{constructor(){this._onDidChangeSchema=new i.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,T){this.schemasById[w(y)]=T,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new M;I.Registry.add(e.Extensions.JSONContribution,D)}),define(De[89],Ie([1,0,18,4,9,125,40,88,30]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var T;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(T=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=y.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(r,c=!0){this.registerConfigurations([r],c)}registerConfigurations(r,c=!0){const n=this.doRegisterConfigurations(r,c);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(r){const c=this.doDeregisterConfigurations(r);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c})}updateConfigurations({add:r,remove:c}){const n=[];n.push(...this.doDeregisterConfigurations(c)),n.push(...this.doRegisterConfigurations(r,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,i.distinct)(n)})}registerDefaultConfigurations(r){const c=[],n=[];for(const{overrides:d,source:l}of r)for(const f in d)if(c.push(f),e.OVERRIDE_PROPERTY_REGEX.test(f)){const o=this.configurationDefaultsOverrides.get(f),h=o?.valuesSources??new Map;if(l)for(const j of Object.keys(d[f]))h.set(j,l);const v={...o?.value||{},...d[f]};this.configurationDefaultsOverrides.set(f,{source:l,value:v,valuesSources:h});const k=(0,D.getLanguageTagSettingPlainKey)(f),F={type:"object",default:v,description:M.localize(1,null,k),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:v,source:w.isString(l)?void 0:l,defaultValueSource:l};n.push(...t(f)),this.configurationProperties[f]=F,this.defaultLanguageConfigurationOverridesNode.properties[f]=F}else{this.configurationDefaultsOverrides.set(f,{value:d[f],source:l});const o=this.configurationProperties[f];o&&(this.updatePropertyDefaultValue(f,o),this.updateSchema(f,o))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}deregisterDefaultConfigurations(r){const c=[];for(const{overrides:n,source:d}of r)for(const l in n){const f=this.configurationDefaultsOverrides.get(l),o=w.isString(d)?d:d?.id,h=w.isString(f?.source)?f?.source:f?.source?.id;if(o===h)if(c.push(l),this.configurationDefaultsOverrides.delete(l),e.OVERRIDE_PROPERTY_REGEX.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const v=this.configurationProperties[l];v&&(this.updatePropertyDefaultValue(l,v),this.updateSchema(l,v))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:c,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...r){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(r){for(const c of r)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(r,c){const n=[];return r.forEach(d=>{n.push(...this.validateAndRegisterProperties(d,c,d.extensionInfo,d.restrictedProperties)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),n}doDeregisterConfigurations(r){const c=[],n=d=>{if(d.properties)for(const l in d.properties){c.push(l);const f=this.configurationProperties[l];f?.policy?.name&&this.policyConfigurations.delete(f.policy.name),delete this.configurationProperties[l],this.removeFromSchema(l,d.properties[l])}d.allOf?.forEach(l=>n(l))};for(const d of r){n(d);const l=this.configurationContributors.indexOf(d);l!==-1&&this.configurationContributors.splice(l,1)}return c}validateAndRegisterProperties(r,c=!0,n,d,l=3){l=w.isUndefinedOrNull(r.scope)?l:r.scope;const f=[],o=r.properties;if(o)for(const v in o){const k=o[v];if(c&&S(v,k)){delete o[v];continue}if(k.source=n,k.defaultDefaultValue=o[v].default,this.updatePropertyDefaultValue(v,k),e.OVERRIDE_PROPERTY_REGEX.test(v)?k.scope=void 0:(k.scope=w.isUndefinedOrNull(k.scope)?l:k.scope,k.restricted=w.isUndefinedOrNull(k.restricted)?!!d?.includes(v):k.restricted),o[v].hasOwnProperty("included")&&!o[v].included){this.excludedConfigurationProperties[v]=o[v],delete o[v];continue}else this.configurationProperties[v]=o[v],o[v].policy?.name&&this.policyConfigurations.set(o[v].policy.name,v);!o[v].deprecationMessage&&o[v].markdownDeprecationMessage&&(o[v].deprecationMessage=o[v].markdownDeprecationMessage),f.push(v)}const h=r.allOf;if(h)for(const v of h)f.push(...this.validateAndRegisterProperties(v,c,n,d,l));return f}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(r){const c=n=>{const d=n.properties;if(d)for(const f in d)this.updateSchema(f,d[f]);n.allOf?.forEach(c)};c(r)}updateSchema(r,c){switch(e.allSettings.properties[r]=c,c.scope){case 1:e.applicationSettings.properties[r]=c;break;case 2:e.machineSettings.properties[r]=c;break;case 6:e.machineOverridableSettings.properties[r]=c;break;case 3:e.windowSettings.properties[r]=c;break;case 4:e.resourceSettings.properties[r]=c;break;case 5:e.resourceSettings.properties[r]=c,this.resourceLanguageSettingsSchema.properties[r]=c;break}}removeFromSchema(r,c){switch(delete e.allSettings.properties[r],c.scope){case 1:delete e.applicationSettings.properties[r];break;case 2:delete e.machineSettings.properties[r];break;case 6:delete e.machineOverridableSettings.properties[r];break;case 3:delete e.windowSettings.properties[r];break;case 4:case 5:delete e.resourceSettings.properties[r],delete this.resourceLanguageSettingsSchema.properties[r];break}}updateOverridePropertyPatternKey(){for(const r of this.overrideIdentifiers.values()){const c=`[${r}]`,n={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,n),e.allSettings.properties[c]=n,e.applicationSettings.properties[c]=n,e.machineSettings.properties[c]=n,e.machineOverridableSettings.properties[c]=n,e.windowSettings.properties[c]=n,e.resourceSettings.properties[c]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const r={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=r,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(r,c){const n=this.configurationDefaultsOverrides.get(r);let d=n?.value,l=n?.source;w.isUndefined(d)&&(d=c.defaultDefaultValue,l=void 0),w.isUndefined(d)&&(d=a(c.type)),c.default=d,c.defaultValueSource=l}}const E="\\[([^\\]]+)\\]",m=new RegExp(E,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${E})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(C){const r=[];if(e.OVERRIDE_PROPERTY_REGEX.test(C)){let c=m.exec(C);for(;c?.length;){const n=c[1].trim();n&&r.push(n),c=m.exec(C)}}return(0,i.distinct)(r)}e.overrideIdentifiersFromKey=t;function s(C){return C.reduce((r,c)=>`${r}[${c}]`,"")}e.keyFromOverrideIdentifiers=s;function a(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const p=new g;y.Registry.add(e.Extensions.Configuration,p);function S(C,r){return C.trim()?e.OVERRIDE_PROPERTY_REGEX.test(C)?M.localize(7,null,C):p.getConfigurationProperties()[C]!==void 0?M.localize(8,null,C):r.policy?.name&&p.getPolicyConfigurations().get(r.policy?.name)!==void 0?M.localize(9,null,C,r.policy?.name,p.getPolicyConfigurations().get(r.policy?.name)):null:M.localize(6,null)}e.validateProperty=S;function u(){const C=[],r=p.getConfigurationProperties();for(const c of Object.keys(r))C.push([c,r[c].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.getScopes=u}),define(De[154],Ie([1,0,18,4,106,7,28,23,9,2,40,89,30]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class E{constructor(c={},n=[],d=[],l){this._contents=c,this._keys=n,this._overrides=d,this.raw=l,this.frozen=!1,this.overrideConfigurations=new Map}get rawConfiguration(){if(!this._rawConfiguration)if(this.raw?.length){const c=this.raw.map(n=>{if(n instanceof E)return n;const d=new m("");return d.parseRaw(n),d.configurationModel});this._rawConfiguration=c.reduce((n,d)=>d===n?d:n.merge(d),c[0])}else this._rawConfiguration=this;return this._rawConfiguration}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(c){return c?(0,O.getConfigurationValue)(this.contents,c):this.contents}inspect(c,n){const d=this.rawConfiguration.getValue(c),l=n?this.rawConfiguration.getOverrideValue(c,n):void 0,f=n?this.rawConfiguration.override(n).getValue(c):d;return{value:d,override:l,merged:f}}getOverrideValue(c,n){const d=this.getContentsForOverrideIdentifer(n);return d?c?(0,O.getConfigurationValue)(d,c):d:void 0}getKeysForOverrideIdentifier(c){const n=[];for(const d of this.overrides)d.identifiers.includes(c)&&n.push(...d.keys);return i.distinct(n)}getAllOverrideIdentifiers(){const c=[];for(const n of this.overrides)c.push(...n.identifiers);return i.distinct(c)}override(c){let n=this.overrideConfigurations.get(c);return n||(n=this.createOverrideConfigurationModel(c),this.overrideConfigurations.set(c,n)),n}merge(...c){const n=A.deepClone(this.contents),d=A.deepClone(this.overrides),l=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const o of c)if(f.push(...o.raw?.length?o.raw:[o]),!o.isEmpty()){this.mergeContents(n,o.contents);for(const h of o.overrides){const[v]=d.filter(k=>i.equals(k.identifiers,h.identifiers));v?(this.mergeContents(v.contents,h.contents),v.keys.push(...h.keys),v.keys=i.distinct(v.keys)):d.push(A.deepClone(h))}for(const h of o.keys)l.indexOf(h)===-1&&l.push(h)}return new E(n,l,d,f.every(o=>o instanceof E)?void 0:f)}freeze(){return this.frozen=!0,this}clone(){return new E(A.deepClone(this.contents),[...this.keys],A.deepClone(this.overrides))}createOverrideConfigurationModel(c){const n=this.getContentsForOverrideIdentifer(c);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const d={};for(const l of i.distinct([...Object.keys(this.contents),...Object.keys(n)])){let f=this.contents[l];const o=n[l];o&&(typeof f=="object"&&typeof o=="object"?(f=A.deepClone(f),this.mergeContents(f,o)):f=o),d[l]=f}return new E(d,this.keys,this.overrides)}mergeContents(c,n){for(const d of Object.keys(n)){if(d in c&&y.isObject(c[d])&&y.isObject(n[d])){this.mergeContents(c[d],n[d]);continue}c[d]=A.deepClone(n[d])}}checkAndFreeze(c){return this.frozen&&!Object.isFrozen(c)?A.deepFreeze(c):c}getContentsForOverrideIdentifer(c){let n=null,d=null;const l=f=>{f&&(d?this.mergeContents(d,f):d=A.deepClone(f))};for(const f of this.overrides)i.equals(f.identifiers,[c])?n=f.contents:f.identifiers.includes(c)&&l(f.contents);return l(n),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(c,n){this.addKey(c),(0,O.addToValueTree)(this.contents,c,n,d=>{throw new Error(d)})}removeValue(c){this.removeKey(c)&&(0,O.removeFromValueTree)(this.contents,c)}addKey(c){let n=this.keys.length;for(let d=0;d<n;d++)c.indexOf(this.keys[d])===0&&(n=d);this.keys.splice(n,1,c)}removeKey(c){const n=this.keys.indexOf(c);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=E;class m{constructor(c){this._name=c,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new E}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(c,n){if(!y.isUndefinedOrNull(c)){const d=this.doParseContent(c);this.parseRaw(d,n)}}reparse(c){this._raw&&this.parseRaw(this._raw,c)}parseRaw(c,n){this._raw=c;const{contents:d,keys:l,overrides:f,restricted:o,hasExcludedProperties:h}=this.doParseRaw(c,n);this._configurationModel=new E(d,l,f,h?[c]:void 0),this._restrictedConfigurations=o||[]}doParseContent(c){let n={},d=null,l=[];const f=[],o=[];function h(k){Array.isArray(l)?l.push(k):d!==null&&(l[d]=k)}const v={onObjectBegin:()=>{const k={};h(k),f.push(l),l=k,d=null},onObjectProperty:k=>{d=k},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{const k=[];h(k),f.push(l),l=k,d=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:h,onError:(k,F,j)=>{o.push({error:k,offset:F,length:j})}};if(c)try{w.visit(c,v),n=l[0]||{}}catch(k){console.error(`Error while parsing settings file ${this._name}: ${k}`),this._parseErrors=[k]}return n}doParseRaw(c,n){const d=g.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),l=this.filter(c,d,!0,n);c=l.raw;const f=(0,O.toValuesTree)(c,v=>console.error(`Conflict in settings file ${this._name}: ${v}`)),o=Object.keys(c),h=this.toOverrides(c,v=>console.error(`Conflict in settings file ${this._name}: ${v}`));return{contents:f,keys:o,overrides:h,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}filter(c,n,d,l){let f=!1;if(!l?.scopes&&!l?.skipRestricted)return{raw:c,restricted:[],hasExcludedProperties:f};const o={},h=[];for(const v in c)if(b.OVERRIDE_PROPERTY_REGEX.test(v)&&d){const k=this.filter(c[v],n,!1,l);o[v]=k.raw,f=f||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=n[v],F=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(v),(F===void 0||l.scopes===void 0||l.scopes.includes(F))&&!(l.skipRestricted&&k?.restricted)?o[v]=c[v]:f=!0}return{raw:o,restricted:h,hasExcludedProperties:f}}toOverrides(c,n){const d=[];for(const l of Object.keys(c))if(b.OVERRIDE_PROPERTY_REGEX.test(l)){const f={};for(const o in c[l])f[o]=c[l][o];d.push({identifiers:(0,b.overrideIdentifiersFromKey)(l),keys:Object.keys(f),contents:(0,O.toValuesTree)(f,n)})}return d}}e.ConfigurationModelParser=m;class t extends M.Disposable{constructor(c,n,d,l){super(),this.userSettingsResource=c,this.scopes=n,this.fileService=l,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(d.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(I.Event.any(I.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource)),I.Event.filter(this.fileService.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&d.isEqual(f.resource,c)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const c=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(c.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new E}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=t;class s{constructor(c,n,d,l,f,o,h,v,k,F,j,H,V){this.key=c,this.overrides=n,this.value=d,this.overrideIdentifiers=l,this.defaultConfiguration=f,this.policyConfiguration=o,this.applicationConfiguration=h,this.userConfiguration=v,this.localUserConfiguration=k,this.remoteUserConfiguration=F,this.workspaceConfiguration=j,this.folderConfigurationModel=H,this.memoryInspectValue=V}get defaultInspectValue(){return this._defaultInspectValue||(this._defaultInspectValue=this.defaultConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._defaultInspectValue}get defaultValue(){return this.defaultInspectValue.merged}get default(){return this.defaultInspectValue.value!==void 0||this.defaultInspectValue.override!==void 0?{value:this.defaultInspectValue.value,override:this.defaultInspectValue.override}:void 0}get policyInspectValue(){return this._policyInspectValue===void 0&&(this._policyInspectValue=this.policyConfiguration?this.policyConfiguration.inspect(this.key):null),this._policyInspectValue}get policyValue(){return this.policyInspectValue?.merged}get policy(){return this.policyInspectValue?.value!==void 0?{value:this.policyInspectValue.value}:void 0}get applicationInspectValue(){return this._applicationInspectValue===void 0&&(this._applicationInspectValue=this.applicationConfiguration?this.applicationConfiguration.inspect(this.key):null),this._applicationInspectValue}get applicationValue(){return this.applicationInspectValue?.merged}get application(){return this.applicationInspectValue?.value!==void 0||this.applicationInspectValue?.override!==void 0?{value:this.applicationInspectValue.value,override:this.applicationInspectValue.override}:void 0}get userInspectValue(){return this._userInspectValue||(this._userInspectValue=this.userConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userInspectValue}get userValue(){return this.userInspectValue.merged}get user(){return this.userInspectValue.value!==void 0||this.userInspectValue.override!==void 0?{value:this.userInspectValue.value,override:this.userInspectValue.override}:void 0}get userLocalInspectValue(){return this._userLocalInspectValue||(this._userLocalInspectValue=this.localUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userLocalInspectValue}get userLocalValue(){return this.userLocalInspectValue.merged}get userLocal(){return this.userLocalInspectValue.value!==void 0||this.userLocalInspectValue.override!==void 0?{value:this.userLocalInspectValue.value,override:this.userLocalInspectValue.override}:void 0}get userRemoteInspectValue(){return this._userRemoteInspectValue||(this._userRemoteInspectValue=this.remoteUserConfiguration.inspect(this.key,this.overrides.overrideIdentifier)),this._userRemoteInspectValue}get userRemoteValue(){return this.userRemoteInspectValue.merged}get userRemote(){return this.userRemoteInspectValue.value!==void 0||this.userRemoteInspectValue.override!==void 0?{value:this.userRemoteInspectValue.value,override:this.userRemoteInspectValue.override}:void 0}get workspaceInspectValue(){return this._workspaceInspectValue===void 0&&(this._workspaceInspectValue=this.workspaceConfiguration?this.workspaceConfiguration.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceInspectValue}get workspaceValue(){return this.workspaceInspectValue?.merged}get workspace(){return this.workspaceInspectValue?.value!==void 0||this.workspaceInspectValue?.override!==void 0?{value:this.workspaceInspectValue.value,override:this.workspaceInspectValue.override}:void 0}get workspaceFolderInspectValue(){return this._workspaceFolderInspectValue===void 0&&(this._workspaceFolderInspectValue=this.folderConfigurationModel?this.folderConfigurationModel.inspect(this.key,this.overrides.overrideIdentifier):null),this._workspaceFolderInspectValue}get workspaceFolderValue(){return this.workspaceFolderInspectValue?.merged}get workspaceFolder(){return this.workspaceFolderInspectValue?.value!==void 0||this.workspaceFolderInspectValue?.override!==void 0?{value:this.workspaceFolderInspectValue.value,override:this.workspaceFolderInspectValue.override}:void 0}get memoryValue(){return this.memoryInspectValue.merged}get memory(){return this.memoryInspectValue.value!==void 0||this.memoryInspectValue.override!==void 0?{value:this.memoryInspectValue.value,override:this.memoryInspectValue.override}:void 0}}class a{constructor(c,n,d,l,f=new E,o=new E,h=new D.ResourceMap,v=new E,k=new D.ResourceMap,F=!0){this._defaultConfiguration=c,this._policyConfiguration=n,this._applicationConfiguration=d,this._localUserConfiguration=l,this._remoteUserConfiguration=f,this._workspaceConfiguration=o,this._folderConfigurations=h,this._memoryConfiguration=v,this._memoryConfigurationByResource=k,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(c,n,d){return this.getConsolidatedConfigurationModel(c,n,d).getValue(c)}updateValue(c,n,d={}){let l;d.resource?(l=this._memoryConfigurationByResource.get(d.resource),l||(l=new E,this._memoryConfigurationByResource.set(d.resource,l))):l=this._memoryConfiguration,n===void 0?l.removeValue(c):l.setValue(c,n),d.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(c,n,d){const l=this.getConsolidatedConfigurationModel(c,n,d),f=i.distinct(l.overrides.map(v=>v.identifiers).flat()).filter(v=>l.getOverrideValue(c,v)!==void 0),o=this.getFolderConfigurationModelForResource(n.resource,d),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration;return new s(c,n,l.getValue(c),f.length?f:void 0,this._defaultConfiguration,this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze(),this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze(),this.userConfiguration.freeze(),this.localUserConfiguration.freeze(),this.remoteUserConfiguration.freeze(),d?this._workspaceConfiguration.freeze():void 0,o?o.freeze():void 0,h.inspect(c,n.overrideIdentifier))}keys(c){const n=this.getFolderConfigurationModelForResource(void 0,c);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(c){this._defaultConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(c){this._policyConfiguration=c}updateApplicationConfiguration(c){this._applicationConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(c){this._localUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(c){this._remoteUserConfiguration=c,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(c){this._workspaceConfiguration=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(c,n){this._folderConfigurations.set(c,n),this._foldersConsolidatedConfigurations.delete(c)}deleteFolderConfiguration(c){this.folderConfigurations.delete(c),this._foldersConsolidatedConfigurations.delete(c)}compareAndUpdateDefaultConfiguration(c,n){const d=[];if(!n){const{added:l,updated:f,removed:o}=u(this._defaultConfiguration,c);n=[...l,...f,...o]}for(const l of n)for(const f of(0,b.overrideIdentifiersFromKey)(l)){const o=this._defaultConfiguration.getKeysForOverrideIdentifier(f),h=c.getKeysForOverrideIdentifier(f),v=[...h.filter(k=>o.indexOf(k)===-1),...o.filter(k=>h.indexOf(k)===-1),...o.filter(k=>!A.equals(this._defaultConfiguration.override(f).getValue(k),c.override(f).getValue(k)))];d.push([f,v])}return this.updateDefaultConfiguration(c),{keys:n,overrides:d}}compareAndUpdatePolicyConfiguration(c){const{added:n,updated:d,removed:l}=u(this._policyConfiguration,c),f=[...n,...d,...l];return f.length&&this.updatePolicyConfiguration(c),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(c){const{added:n,updated:d,removed:l,overrides:f}=u(this.applicationConfiguration,c),o=[...n,...d,...l];return o.length&&this.updateApplicationConfiguration(c),{keys:o,overrides:f}}compareAndUpdateLocalUserConfiguration(c){const{added:n,updated:d,removed:l,overrides:f}=u(this.localUserConfiguration,c),o=[...n,...d,...l];return o.length&&this.updateLocalUserConfiguration(c),{keys:o,overrides:f}}compareAndUpdateRemoteUserConfiguration(c){const{added:n,updated:d,removed:l,overrides:f}=u(this.remoteUserConfiguration,c),o=[...n,...d,...l];return o.length&&this.updateRemoteUserConfiguration(c),{keys:o,overrides:f}}compareAndUpdateWorkspaceConfiguration(c){const{added:n,updated:d,removed:l,overrides:f}=u(this.workspaceConfiguration,c),o=[...n,...d,...l];return o.length&&this.updateWorkspaceConfiguration(c),{keys:o,overrides:f}}compareAndUpdateFolderConfiguration(c,n){const d=this.folderConfigurations.get(c),{added:l,updated:f,removed:o,overrides:h}=u(d,n),v=[...l,...f,...o];return(v.length||!d)&&this.updateFolderConfiguration(c,n),{keys:v,overrides:h}}compareAndDeleteFolderConfiguration(c){const n=this.folderConfigurations.get(c);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(c);const{added:d,updated:l,removed:f,overrides:o}=u(n,void 0);return{keys:[...d,...l,...f],overrides:o}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(c,n,d){let l=this.getConsolidatedConfigurationModelForResource(n,d);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(c)!==void 0&&(l=l.merge(this._policyConfiguration)),l}getConsolidatedConfigurationModelForResource({resource:c},n){let d=this.getWorkspaceConsolidatedConfiguration();if(n&&c){const l=n.getFolder(c);l&&(d=this.getFolderConsolidatedConfiguration(l.uri)||d);const f=this._memoryConfigurationByResource.get(c);f&&(d=d.merge(f))}return d}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(c){let n=this._foldersConsolidatedConfigurations.get(c);if(!n){const d=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(c);l?(n=d.merge(l),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(c,n)):n=d}return n}getFolderConfigurationModelForResource(c,n){if(n&&c){const d=n.getFolder(c);if(d)return this._folderConfigurations.get(d.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((c,n)=>{const{contents:d,overrides:l,keys:f}=this._folderConfigurations.get(n);return c.push([n,{contents:d,overrides:l,keys:f}]),c},[])}}allKeys(){const c=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>c.add(n)),this.userConfiguration.freeze().keys.forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(d=>c.add(d))),[...c.values()]}allOverrideIdentifiers(){const c=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>c.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(d=>c.add(d))),[...c.values()]}getAllKeysForOverrideIdentifier(c){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(c).forEach(d=>n.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(c).forEach(d=>n.add(d)),this._workspaceConfiguration.getKeysForOverrideIdentifier(c).forEach(d=>n.add(d)),this._folderConfigurations.forEach(d=>d.getKeysForOverrideIdentifier(c).forEach(l=>n.add(l))),[...n.values()]}static parse(c){const n=this.parseConfigurationModel(c.defaults),d=this.parseConfigurationModel(c.policy),l=this.parseConfigurationModel(c.application),f=this.parseConfigurationModel(c.user),o=this.parseConfigurationModel(c.workspace),h=c.folders.reduce((v,k)=>(v.set(T.URI.revive(k[0]),this.parseConfigurationModel(k[1])),v),new D.ResourceMap);return new a(n,d,l,f,new E,o,h,new E,new D.ResourceMap,!1)}static parseConfigurationModel(c){return new E(c.contents,c.keys,c.overrides).freeze()}}e.Configuration=a;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const c=new Set,n=new Map;for(const l of r)l.keys.forEach(f=>c.add(f)),l.overrides.forEach(([f,o])=>{const h=(0,D.getOrSet)(n,f,new Set);o.forEach(v=>h.add(v))});const d=[];return n.forEach((l,f)=>d.push([f,[...l.values()]])),{keys:[...c.values()],overrides:d}}e.mergeChanges=p;class S{constructor(c,n,d,l){this.change=c,this.previous=n,this.currentConfiguraiton=d,this.currentWorkspace=l,this._previousConfiguration=void 0;const f=new Set;c.keys.forEach(h=>f.add(h)),c.overrides.forEach(([,h])=>h.forEach(v=>f.add(v))),this.affectedKeys=[...f.values()];const o=new E;this.affectedKeys.forEach(h=>o.setValue(h,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=a.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(c,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,c)){if(n){const d=this.previousConfiguration?this.previousConfiguration.getValue(c,n,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(c,n,this.currentWorkspace);return!A.equals(d,l)}return!0}return!1}doesAffectedKeysTreeContains(c,n){let d=(0,O.toValuesTree)({[n]:!0},()=>{}),l;for(;typeof d=="object"&&(l=Object.keys(d)[0]);){if(c=c[l],!c)return!1;d=d[l]}return!0}}e.ConfigurationChangeEvent=S;function u(r,c){const{added:n,removed:d,updated:l}=C(c?.rawConfiguration,r?.rawConfiguration),f=[],o=r?.getAllOverrideIdentifiers()||[],h=c?.getAllOverrideIdentifiers()||[];if(c){const v=h.filter(k=>!o.includes(k));for(const k of v)f.push([k,c.getKeysForOverrideIdentifier(k)])}if(r){const v=o.filter(k=>!h.includes(k));for(const k of v)f.push([k,r.getKeysForOverrideIdentifier(k)])}if(c&&r){for(const v of o)if(h.includes(v)){const k=C({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:c.getOverrideValue(void 0,v)||{},keys:c.getKeysForOverrideIdentifier(v)});f.push([v,[...k.added,...k.removed,...k.updated]])}}return{added:n,removed:d,updated:l,overrides:f}}function C(r,c){const n=r?c?r.keys.filter(f=>c.keys.indexOf(f)===-1):[...r.keys]:[],d=c?r?c.keys.filter(f=>r.keys.indexOf(f)===-1):[...c.keys]:[],l=[];if(r&&c){for(const f of c.keys)if(r.keys.indexOf(f)!==-1){const o=(0,O.getConfigurationValue)(c.contents,f),h=(0,O.getConfigurationValue)(r.contents,f);A.equals(o,h)||l.push(f)}}return{added:n,removed:d,updated:l}}}),define(De[90],Ie([1,0,12,3]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,I.createDecorator)("remoteAuthorityResolverService");var w;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(w=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends i.ErrorNoTelemetry{static isNotAvailable(A){return A instanceof M&&A._code===w.NotAvailable}static isTemporarilyNotAvailable(A){return A instanceof M&&A._code===w.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof M&&A._code===w.NoResolverFound}static isHandled(A){return A instanceof M&&A.isHandled}constructor(A,y=w.Unknown,T){super(A),this._message=A,this._code=y,this._detail=T,this.isHandled=y===w.NotAvailable&&T===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}}e.RemoteAuthorityResolverError=M}),define(De[61],Ie([1,0,13]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function I(T){return T.scheme===i.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=I;function w(T){if(!T)return;const O=T.indexOf("+");return O<0?T:T.substr(0,O)}e.getRemoteName=w;function M(T){return`/${T.quality??"oss"}-${T.commit??"dev"}`}e.getRemoteServerRootPath=M;function D(T){const{host:O,port:b}=y(T);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:b}}e.parseAuthorityWithPort=D;function A(T,O){let{host:b,port:g}=y(T);return typeof g>"u"&&(g=O),{host:b,port:g}}e.parseAuthorityWithOptionalPort=A;function y(T){const O=T.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const b=T.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const g=T.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:T,port:void 0}}}),define(De[25],Ie([1,0,10,3,61]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=M;function D(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));var y;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(y=e.TargetPlatform||(e.TargetPlatform={}));class T{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,s){if(typeof t>"u"||t===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof t=="string"||typeof s=="string"){const a=typeof t=="string"?t:t.value,p=typeof s=="string"?s:s.value;return i.equalsIgnoreCase(a,p)}return t._lower===s._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.ExtensionIdentifier=T;function O(m){return b(m)}e.isApplicationScopedExtension=O;function b(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function g(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function E(m,t){if(t){const s=`onResolveRemoteAuthority:${(0,w.getRemoteName)(t)}`;return m.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[155],Ie([1,0,10,85,25,21,2,12,48]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(c,n){return c.uuid&&n.uuid?c.uuid===n.uuid:c.id===n.id?!0:(0,i.compareIgnoreCase)(c.id,n.id)===0}e.areSameExtensions=T;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(n){const d=n.manifest?n.manifest.version:n.version,l=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new b(n.identifier,d,l)}static parse(n){const d=O.exec(n);return d&&d[1]&&d[2]?new b({id:d[1]},d[2],d[4]||void 0):null}constructor(n,d,l="undefined"){this.version=d,this.targetPlatform=l,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof b?T(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=b;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(c){const n=g.exec(c);return n&&n[1]?[t(n[1]),n[2]]:[t(c),void 0]}e.getIdAndVersion=E;function m(c,n){return`${c}.${n}`}e.getExtensionId=m;function t(c){return c.toLocaleLowerCase()}e.adoptToGalleryExtensionId=t;function s(c,n){return t(m(c,n))}e.getGalleryExtensionId=s;function a(c,n){const d=[],l=f=>{for(const o of d)if(o.some(h=>T(n(h),n(f))))return o;return null};for(const f of c){const o=l(f);o?o.push(f):d.push([f])}return d}e.groupByExtension=a;function p(c){return{id:c.identifier.id,name:c.manifest.name,galleryId:null,publisherId:c.publisherId,publisherName:c.manifest.publisher,publisherDisplayName:c.publisherDisplayName,dependencies:c.manifest.extensionDependencies&&c.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=p;function S(c){return{id:c.identifier.id,name:c.name,galleryId:c.identifier.uuid,publisherId:c.publisherId,publisherName:c.publisher,publisherDisplayName:c.publisherDisplayName,isPreReleaseVersion:c.properties.isPreReleaseVersion,dependencies:!!(c.properties.dependencies&&c.properties.dependencies.length>0),isSigned:c.isSigned,...c.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function u(c,n){const d=[],l=n.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const f=l.shift();if(f&&d.every(o=>!T(o.identifier,{id:f}))){const o=c.filter(h=>T(h.identifier,{id:f}));o.length===1&&(d.push(o[0]),l.push(...o[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=u;async function C(c,n){if(!M.isLinux)return!1;let d;try{d=(await c.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await c.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){n.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(f))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=C;async function r(c,n){const d=await C(c,n),l=(0,I.getTargetPlatform)(d?"alpine":M.platform,y.arch);return n.debug("ComputeTargetPlatform:",l),l}e.computeTargetPlatform=r}),define(De[156],Ie([1,0,21,48,2,38]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(T){if(i.platform===2&&/^penguin(\.|$)/i.test(T))return"chromebook"}async function A(T,O,b,g,E,m,t,s,a,p){const S=Object.create(null);S["common.machineId"]=t,S.sessionID=(0,M.generateUuid)()+Date.now(),S.commitHash=E,S.version=m,S["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),S["common.platform"]=(0,i.PlatformToString)(i.platform),S["common.nodePlatform"]=I.platform,S["common.nodeArch"]=g,S["common.product"]=p||"desktop",s&&(S["common.msftInternal"]=s);let u=0;const C=Date.now();Object.defineProperties(S,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-C,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),i.isLinuxSnap&&(S["common.snap"]="true");const r=D(b);r&&(S["common.platformDetail"]=r);try{const c=await T.readFile(w.URI.file(a));S["common.source"]=c.value.toString().slice(0,30)}catch{}return S}e.resolveCommonProperties=A;function y(T){const O=I.env.USERDNSDOMAIN;if(!O)return!1;const b=O.toLowerCase();return T.some(g=>b===g)}e.verifyMicrosoftInternalDomain=y}),define(De[157],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,i.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,i.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var I;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(I=e.TelemetryLevel||(e.TelemetryLevel={}));var w;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(w=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(De[158],Ie([1,0,23,115,9,40,156,157]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class y{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,I.staticObservableValue)(0)}publicLog(d,l){return Promise.resolve(void 0)}publicLog2(d,l){return this.publicLog(d,l)}publicLogError(d,l){return Promise.resolve(void 0)}publicLogError2(d,l){return this.publicLogError(d,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=y,e.NullTelemetryService=new y;class T{async publicLog(d,l,f){}async publicLogError(d,l,f){}}e.NullEndpointTelemetryService=T,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function O(n,d){return d.onDidChangeConfiguration(l=>{l.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(l.source),configurationKeys:a(l.sourceConfig)})})}e.configurationTelemetry=O;function b(n,d){return!(d.disableTelemetry||!n.enableTelemetry||d.extensionTestsLocationURI)}e.supportsTelemetry=b;function g(n){const d=n.getValue(A.TELEMETRY_SETTING_ID),l=n.getValue("telemetry.enableCrashReporter");if(n.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(d??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=g;function E(n){const d={},l={},f={};s(n,f);for(let o in f){o=o.length>150?o.substr(o.length-149):o;const h=f[o];typeof h=="number"?l[o]=h:typeof h=="boolean"?l[o]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${h.length}`),d[o]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(d[o]=h)}return{properties:d,measurements:l}}e.validateTelemetryData=E;const m=["ssh-remote","dev-container","attached-container","wsl","tunneling","codespaces"];function t(n){if(!n)return"none";for(const d of m)if(n.startsWith(`${d}+`))return d;return"other"}e.cleanRemoteAuthority=t;function s(n,d,l=0,f){if(!!n)for(const o of Object.getOwnPropertyNames(n)){const h=n[o],v=f?f+o:o;Array.isArray(h)?d[v]=(0,i.safeStringify)(h):h instanceof Date?d[v]=h.toISOString():(0,w.isObject)(h)?l<2?s(h,d,l+1,v+"."):d[v]=(0,i.safeStringify)(h):d[v]=h}}function a(n){if(!n)return[];const d=[];return p(d,"",n),d}function p(n,d,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(f=>p(n,d?`${d}.${f}`:f,l[f])):n.push(d)}function S(n,d){const l=n.msftInternalDomains||[],f=d.getValue("telemetry.internalTesting");return(0,D.verifyMicrosoftInternalDomain)(l)||f}e.isInternalTelemetry=S;function u(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=u;function C(n,d){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let l=n;const f=[];for(const k of d)for(;;){const F=k.exec(n);if(!F)break;f.push([F.index,k.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(l="";;){const k=h.exec(n);if(!k)break;const F=f.some(([j,H])=>k.index<H&&j<h.lastIndex);!o.test(k[0])&&!F&&(l+=n.substring(v,k.index)+"<REDACTED: user-file-path>",v=h.lastIndex)}return v<n.length&&(l+=n.substr(v)),l}function r(n){if(!n)return n;const d=n.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of l)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return n}function c(n,d){return(0,i.cloneAndChange)(n,l=>{if(typeof l=="string"){let f=l;f=C(f,d);for(const o of d)f=f.replace(o,"");return f=r(f),f}})}e.cleanData=c}),define(De[159],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class i{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,M,D=5){const A=M(y=>{const T=typeof y=="string"?y:y.data;let O=this._terminalBufferMap.get(w);if(O){O.data.push(T);return}const b=setTimeout(()=>this.flushBuffer(w),D);O={data:[T],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(w),A.dispose()}},this._terminalBufferMap.set(w,O)});return A}stopBuffering(w){this._terminalBufferMap.get(w)?.dispose()}flushBuffer(w){const M=this._terminalBufferMap.get(w);M&&(this._terminalBufferMap.delete(w),this._callback(w,M.data.join("")))}}e.TerminalDataBufferer=i}),define(De[160],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var i;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(i=e.ColorScheme||(e.ColorScheme={}));function I(M){return M===i.HIGH_CONTRAST_DARK||M===i.HIGH_CONTRAST_LIGHT}e.isHighContrast=I;function w(M){return M===i.DARK||M===i.HIGH_CONTRAST_DARK}e.isDark=w}),define(De[62],Ie([1,0,118,4,7,3,30,160]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var y;(function(s){function a(p){return p&&typeof p=="object"&&typeof p.id=="string"}s.isThemeColor=a})(y=e.ThemeColor||(e.ThemeColor={}));function T(s){return{id:s}}e.themeColorFromId=T;var O;(function(s){function a(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||y.isThemeColor(d.color))}s.isThemeIcon=a;const p=new RegExp(`^\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)$`);function S(d){const l=p.exec(d);if(!l)return;const[,f]=l;return{id:f}}s.fromString=S;function u(d){return{id:d}}s.fromId=u;function C(d,l){let f=d.id;const o=f.lastIndexOf("~");return o!==-1&&(f=f.substring(0,o)),l&&(f=`${f}~${l}`),{id:f}}s.modify=C;function r(d){const l=d.id.lastIndexOf("~");if(l!==-1)return d.id.substring(l+1)}s.getModifier=r;function c(d,l){return d.id===l.id&&d.color?.id===l.color?.id}s.isEqual=c;function n(d,l){return{id:d.id,color:l?T(l):void 0}}s.asThemeIcon=n,s.asClassNameArray=i.CSSIcon.asClassNameArray,s.asClassName=i.CSSIcon.asClassName,s.asCSSSelector=i.CSSIcon.asCSSSelector})(O=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=i.Codicon.file,e.FolderThemeIcon=i.Codicon.folder;function b(s){switch(s){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case A.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new I.Emitter}onColorThemeChange(a){return this.themingParticipants.push(a),this.onThemingParticipantAddedEmitter.fire(a),(0,w.toDisposable)(()=>{const p=this.themingParticipants.indexOf(a);this.themingParticipants.splice(p,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const E=new g;D.Registry.add(e.Extensions.ThemingContribution,E);function m(s){return E.onColorThemeChange(s)}e.registerThemingParticipant=m;class t extends w.Disposable{constructor(a){super(),this.themeService=a,this.theme=a.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(p=>this.onThemeChange(p)))}onThemeChange(a){this.theme=a,this.updateStyles()}updateStyles(){}getColor(a,p){let S=this.theme.getColor(a);return S&&p&&(S=p(S,this.theme)),S?S.toString():null}}e.Themable=t}),define(De[161],Ie([1,0,4,40,3,11]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var D;(function(t){t.Http="http",t.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=b;function g(t,s,a,p){if(a===1)return!1;if(a===2&&b(s)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(S?.length===4&&parseInt(S[1])>=18)return!1}return t<1024}e.isPortPrivileged=g;class E{constructor(s,a,p){this.remoteAddress=s,this.localAddress=a,this._dispose=p,this._onDispose=new i.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=E;let m=class{constructor(s,a){this.logService=s,this.configurationService=a,this._onTunnelOpened=new i.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new i.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new i.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}get defaultTunnelHost(){const s=this.configurationService.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],a=Array.from(this._tunnels.values());for(const p of a){const S=Array.from(p.values());for(const u of S){const C=await u.value;C&&s.push(C)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:a}of s.values())await a.then(p=>p?.dispose());s.clear()}this._tunnels.clear()}setEnvironmentTunnel(s,a,p,S,u){this.addTunnelToMap(s,a,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:a,localAddress:p,privacy:S,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,a){(b(s)||O(s))&&(s=e.LOCALHOST_ADDRESSES[0]);const p=this.getTunnelFromMap(s,a);if(p)return++p.refcount,p.value}openTunnel(s,a,p,S,u=!1,C,r){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${p} on local port ${S}.`),!s)return;if(a||(a="localhost"),this._tunnelProvider&&this._factoryInProgress.has(p)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.retainOrCreateTunnel(s,a,p,S,u,C,r);return c?c.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(a,p);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const d=this.makeTunnel(n);return(n.tunnelRemoteHost!==a||n.tunnelRemotePort!==p)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(d),d}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const a=this._tunnels.get(s.tunnelRemoteHost);if(a){const p=a.get(s.tunnelRemotePort);p&&(p.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,p))}}}}async tryDisposeTunnel(s,a,p){if(p.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${a}.`);const S=p.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(a),S}}async closeTunnel(s,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${a} `);const p=this._tunnels.get(s);if(p&&p.has(a)){const S=p.get(a);S.refcount=0,await this.tryDisposeTunnel(s,a,S)}}addTunnelToMap(s,a,p){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(a,{refcount:1,value:p})}async removeEmptyTunnelFromMap(s,a){const p=this._tunnels.get(s);p&&(await p.get(a)||p.delete(a),p.size===0&&this._tunnels.delete(s))}getTunnelFromMap(s,a){const p=[s];O(s)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):b(s)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const S=p.map(u=>this._tunnels.get(u));for(const u of S){const C=u?.get(a);if(C)return C}}canTunnel(s){return!!T(s)}createWithProvider(s,a,p,S,u,C,r){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${p} on local port ${S}.`);const c=p;this._factoryInProgress.add(c);const n=S===void 0?p:S,d={elevationRequired:u?this.isPortPrivileged(n):!1},l={remoteAddress:{host:a,port:p},localAddressPort:S,privacy:C,public:C?C!==A.Private:void 0,protocol:r},f=s.forwardPort(l,d);return f?(this.addTunnelToMap(a,p,f),f.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(c)})):this._factoryInProgress.delete(c),f}};m=He([$e(0,M.ILogService),$e(1,I.IConfigurationService)],m),e.AbstractTunnelService=m}),define(De[162],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,i.createDecorator)("editSessionIdentityService");var I;(function(w){w[w.Complete=100]="Complete",w[w.Partial=50]="Partial",w[w.None=0]="None"})(I=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(De[163],Ie([1,0,13]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function I(y){return y.scheme!==i.Schemas.file&&y.scheme!==i.Schemas.vscodeRemote}e.isVirtualResource=I;function w(y){if(y.folders.length)return y.folders.every(T=>I(T.uri))?y.folders[0].uri:void 0;if(y.configuration&&I(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=w;function M(y){return w(y)?.scheme}e.getVirtualWorkspaceScheme=M;function D(y){return w(y)?.authority}e.getVirtualWorkspaceAuthority=D;function A(y){return w(y)!==void 0}e.isVirtualWorkspace=A}),define(De[49],Ie([1,0,130,19,46,22,2,3,13]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function T(c){const n=c;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"};function O(c,n){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,I.basename)(c)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:void 0;const d=c;if(d.configuration)return{id:d.id,configPath:d.configuration};if(d.folders.length===1)return{id:d.id,uri:d.folders[0].uri}}e.toWorkspaceIdentifier=O;function b(c){const n=c;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=b;function g(c){const n=c;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const d=c;if(d?.configPath)return{id:d.id,configPath:D.URI.revive(d.configPath)};if(c?.id)return{id:c.id}}e.reviveIdentifier=g;var E;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(E=e.WorkbenchState||(e.WorkbenchState={}));function m(c){const n=c;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=m;function t(c){const n=c;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=t;class s{constructor(n,d,l,f,o){this._id=n,this._transient=l,this._configuration=f,this._ignorePathCasing=o,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=d}update(n){this._id=n.id,this._configuration=n.configuration,this._transient=n.transient,this._ignorePathCasing=n._ignorePathCasing,this.folders=n.folders}get folders(){return this._folders}set folders(n){this._folders=n,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(n){this._configuration=n}getFolder(n){return n&&this._foldersMap.findSubstr(n)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const n of this.folders)this._foldersMap.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=s;class a{constructor(n,d){this.raw=d,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function p(c){return new a({uri:c,index:0,name:(0,M.basenameOrAuthority)(c)},{uri:c.toString()})}e.toWorkspaceFolder=p,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,i.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(c,n){return M.extUriBiasedIgnorePathCase.isEqualOrParent(c,n.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function u(c){let n;return D.URI.isUri(c)?n=c:n=c.configuration,n?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=u;function C(c,n){return!S(c,n)&&!u(c)}e.isSavedWorkspace=C;function r(c){return(typeof c=="string"?(0,I.extname)(c):(0,M.extname)(c))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(De[63],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class i{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const M=this._idPool++;return this._data.set(M,w),this.logDebugInfo(),M}get(w,M){return this._data.has(w)?this._data.get(w)[M]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!i.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=i,i.enableDebugLogging=!1}),define(De[36],Ie([1,0,13,22,3]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class M{constructor(){this._systemSchemes=new Set(Object.keys(i.Schemas)),this._providerInfo=new Map,this.extUri=new I.ExtUri(A=>{const y=this._providerInfo.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,y)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=M,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(De[26],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,i.createDecorator)("IExtHostInitDataService")}),define(De[164],Ie([1,0,15]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(D,A,y){this._deferredPromises=new Map,this._id=D,this._shared=A,this._storage=y,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new i.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const O of T.values())O.complete()}catch(O){for(const b of T.values())b.error(O)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,A){let y=this._value[D];return typeof y>"u"&&(y=A),y}update(D,A){this._value[D]=A;const y=this._deferredPromises.get(D);if(y!==void 0)return y.p;const T=new i.DeferredPromise;return this._deferredPromises.set(D,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class w extends I{setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}constructor(D,A){super(D.identifier.value,!0,A),this._extension=D}}e.ExtensionGlobalMemento=w}),define(De[165],Ie([1,0,4,2]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class w{constructor(D){this._notebooksAndEditors=D,this._onDidSaveNotebookDocument=new i.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new i.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(D,A,y,T){const b=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(D)).acceptModelChanged(A.value,y,T);this._onDidChangeNotebookDocument.fire(b)}$acceptDirtyStateChanged(D,A){this._notebooksAndEditors.getNotebookDocument(I.URI.revive(D)).acceptDirty(A)}$acceptModelSaved(D){const A=this._notebooksAndEditors.getNotebookDocument(I.URI.revive(D));this._onDidSaveNotebookDocument.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=w}),define(De[14],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,i.createDecorator)("IExtHostRpcService");class I{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.ExtHostRpcService=I});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[166],Ie([1,0,25,4]),function(ie,e,i,I){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class M{constructor(A,y){w.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=i.ExtensionIdentifier.toKey(A.identifier),Ye(this,w,y,"f"),Ae(this,w,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(A){return Ae(this,w,"f").get(this._id,A)}store(A,y){return Ae(this,w,"f").store(this._id,A,y)}delete(A){return Ae(this,w,"f").delete(this._id,A)}}e.ExtensionSecrets=M,w=new WeakMap}),define(De[64],Ie([1,0,3,161,4,14]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(y){function T(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?I.TunnelPrivacyId.Public:I.TunnelPrivacyId.Private),protocol:b.protocol}}y.fromApiTunnel=T;function O(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==I.TunnelPrivacyId.ConstantPrivate&&b.privacy!==I.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}y.fromServiceTunnel=O})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,i.createDecorator)("IExtHostTunnelService");let A=class{constructor(T){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,O){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,O){return{dispose:()=>{}}}async $providePortAttributes(T,O,b,g,E){return[]}async $forwardPort(T,O){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=He([$e(0,M.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(De[50],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,i.createDecorator)("IURITransformerService");class I{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=I}),define(De[167],Ie([1,0,24]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(y){let T=this.buffers.indexOf(y);return T<0&&(T=this.buffers.length,this.buffers.push(y)),T}}function w(A,y){if(y.serializeBuffersForPostMessage){const T=new I,O=(E,m)=>{if(m instanceof ArrayBuffer){const t=T.add(m);return{$$vscode_array_buffer_reference$$:!0,index:t}}else if(ArrayBuffer.isView(m)){const t=M(m);if(t){const s=T.add(m.buffer);return{$$vscode_array_buffer_reference$$:!0,index:s,view:{type:t,byteLength:m.byteLength,byteOffset:m.byteOffset}}}}return m},b=JSON.stringify(A,O),g=T.buffers.map(E=>{const m=new Uint8Array(E);return i.VSBuffer.wrap(m)});return{message:b,buffers:g}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=w;function M(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(A,y){const T=y.map(g=>{const E=new ArrayBuffer(g.byteLength);return new Uint8Array(E).set(g.buffer),E}),O=y.length?(g,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const m=E,{index:t}=m,s=T[t];if(m.view)switch(m.view.type){case 1:return new Int8Array(s,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return E}:void 0;return{message:JSON.parse(A,O),arrayBuffers:T}}e.deserializeWebviewMessage=D}),define(De[91],Ie([1,0,138,9,2,7,3,30,35,13]),function(ie,e,i,I,w,M,D,A,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,i.localize)(0,null),providerDisplayName:(0,i.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var O;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(O=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var b;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(b=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g(K){const Z=K;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.isEditorPaneWithSelection=g;function E(K,Z,ue){for(const ne of ue.visibleEditorPanes)if(ne.group.id===Z&&K.matches(ne.input))return ne.getViewState()}e.findViewStateForEditor=E;function m(K){if(l(K))return!1;const Z=K;return w.URI.isUri(Z?.resource)}e.isResourceEditorInput=m;function t(K){if(l(K))return!1;const Z=K;return Z?.original!==void 0&&Z.modified!==void 0}e.isResourceDiffEditorInput=t;function s(K){if(l(K)||t(K))return!1;const Z=K;return Z?.primary!==void 0&&Z.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function a(K){if(l(K))return!1;const Z=K;return Z?Z.resource===void 0||Z.resource.scheme===T.Schemas.untitled||Z.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;const p=/Untitled-\d+/;function S(K){return K.scheme===T.Schemas.untitled&&K.path.length>1&&!p.test(K.path)}e.isUntitledWithAssociatedResource=S;function u(K){if(l(K))return!1;const Z=K;return w.URI.isUri(Z?.base?.resource)&&w.URI.isUri(Z?.input1?.resource)&&w.URI.isUri(Z?.input2?.resource)&&w.URI.isUri(Z?.result?.resource)}e.isResourceMergeEditorInput=u;var C;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(C=e.Verbosity||(e.Verbosity={}));var r;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.mapIdToSaveSource=new Map}registerSource(Z,ue){let ne=this.mapIdToSaveSource.get(Z);return ne||(ne={source:Z,label:ue},this.mapIdToSaveSource.set(Z,ne)),ne.source}getSourceLabel(Z){return this.mapIdToSaveSource.get(Z)?.label??Z}}e.SaveSourceRegistry=new c;var n;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors"})(n=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class d extends M.Disposable{}e.AbstractEditorInput=d;function l(K){return K instanceof d}e.isEditorInput=l;function f(K){const Z=K;return w.URI.isUri(Z?.preferredResource)}function o(K){const Z=K;return l(Z?.primary)&&l(Z?.secondary)}e.isSideBySideEditorInput=o;function h(K){const Z=K;return l(Z?.modified)&&l(Z?.original)}e.isDiffEditorInput=h;function v(K){return l(K?.editor)}e.isEditorInputWithOptions=v;function k(K){const Z=K;return v(K)&&Z?.group!==void 0}e.isEditorInputWithOptionsAndGroup=k;function F(K){const Z=K;return typeof Z?.groupId=="number"&&l(Z.editor)}e.isEditorIdentifier=F;var j;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(j=e.EditorCloseContext||(e.EditorCloseContext={}));var H;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(H=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var V;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(V=e.SideBySideEditor||(e.SideBySideEditor={}));class P{getOriginalUri(Z,ue){if(!Z)return;if(u(Z))return e.EditorResourceAccessor.getOriginalUri(Z.result,ue);if(ue?.supportSideBySide){const{primary:pe,secondary:ae}=this.getSideEditors(Z);if(pe&&ae){if(ue?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:ue.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===V.ANY)return this.getOriginalUri(pe,{filterByScheme:ue.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:ue.filterByScheme});Z=ue.supportSideBySide===V.PRIMARY?pe:ae}}if(t(Z)||s(Z)||u(Z))return;const ne=f(Z)?Z.preferredResource:Z.resource;return!ne||!ue||!ue.filterByScheme?ne:this.filterUri(ne,ue.filterByScheme)}getSideEditors(Z){return o(Z)||s(Z)?{primary:Z.primary,secondary:Z.secondary}:h(Z)||t(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,ue){if(!Z)return;if(u(Z))return e.EditorResourceAccessor.getCanonicalUri(Z.result,ue);if(ue?.supportSideBySide){const{primary:pe,secondary:ae}=this.getSideEditors(Z);if(pe&&ae){if(ue?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:ue.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===V.ANY)return this.getCanonicalUri(pe,{filterByScheme:ue.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:ue.filterByScheme});Z=ue.supportSideBySide===V.PRIMARY?pe:ae}}if(t(Z)||s(Z)||u(Z))return;const ne=Z.resource;return!ne||!ue||!ue.filterByScheme?ne:this.filterUri(ne,ue.filterByScheme)}filterUri(Z,ue){if(Array.isArray(ue)){if(ue.some(ne=>Z.scheme===ne))return Z}else if(ue===Z.scheme)return Z}}e.EditorResourceAccessor=new P;var U;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(U=e.CloseDirection||(e.CloseDirection={}));class R{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(Z){const ue=this.instantiationService=Z.get(D.IInstantiationService);for(const[ne,pe]of this.editorSerializerConstructors)this.createEditorSerializer(ne,pe,ue);this.editorSerializerConstructors.clear()}createEditorSerializer(Z,ue,ne){const pe=ne.createInstance(ue);this.editorSerializerInstances.set(Z,pe)}registerFileEditorFactory(Z){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=Z}getFileEditorFactory(){return(0,I.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(Z,ue){if(this.editorSerializerConstructors.has(Z)||this.editorSerializerInstances.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.instantiationService?this.createEditorSerializer(Z,ue,this.instantiationService):this.editorSerializerConstructors.set(Z,ue),(0,M.toDisposable)(()=>{this.editorSerializerConstructors.delete(Z),this.editorSerializerInstances.delete(Z)})}getEditorSerializer(Z){return this.editorSerializerInstances.get(typeof Z=="string"?Z:Z.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new R);async function x(K,Z,ue){return!K||!K.length?[]:await Promise.all(K.map(async ne=>{const pe=w.URI.revive(ne.fileUri);if(!pe){ue.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Z.canHandleResource(pe)){ue.info("Cannot resolve the path because it cannot be handled",ne);return}let de=ne.exists,Y=ne.type;if(typeof de!="boolean"||typeof Y!="number")try{Y=(await Z.stat(pe)).isDirectory?y.FileType.Directory:y.FileType.Unknown,de=!0}catch(Se){ue.error(Se),de=!1}if(!de&&ne.openOnlyIfExists){ue.info("Cannot resolve the path because it does not exist",ne);return}if(Y===y.FileType.Directory){ue.info("Cannot resolve the path because it is a directory",ne);return}const me={...ne.options,pinned:!0};return de?{resource:pe,options:me}:{resource:pe,options:me,forceUntitled:!0}}))}e.pathsToEditors=x;var z;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(z=e.EditorsOrder||(e.EditorsOrder={}));function B(K){const Z=K;if(!Z)return!1;const ue=Z;if(ue.modified)return B(ue.modified);const ne=Z;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.isTextEditorViewState=B}),define(De[65],Ie([1,0,13,2]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function w(A,y){return A.scheme===i.Schemas.http||A.scheme===i.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===i.Schemas.file&&(A=I.URI.from({scheme:i.Schemas.vscodeRemote,authority:y.authority,path:A.path})),I.URI.from({scheme:i.Schemas.https,authority:`${A.scheme}+${M(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=w;function M(A){return A.replace(/./g,y=>{const T=y.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?y:"-"+T.toString(16).padStart(4,"0")})}function D(A){return A.replace(/-([0-9a-f]{4})/g,(y,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=D}),define(De[168],Ie([1,0,4,7,65]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class M{constructor(A,y,T){this._proxy=A,this._editors=y,this._remoteInfo=T,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const b of this._insets.values())O.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,y,T,O,b){let g;for(const S of this._editors.getVisibleTextEditors(!0))if(S.value===A){g=S;break}if(!g)throw new Error("not a visible editor");const E=this,m=this._handlePool++,t=new i.Emitter,s=new i.Emitter,a=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(S){return(0,w.asWebviewUri)(S,E._remoteInfo)}get cspSource(){return w.webviewGenericCspSource}set options(S){this._options=S,E._proxy.$setOptions(m,S)}get options(){return this._options}set html(S){this._html=S,E._proxy.$setHtml(m,S)}get html(){return this._html}get onDidReceiveMessage(){return t.event}postMessage(S){return E._proxy.$postMessage(m,S)}},p=new class{constructor(){this.editor=A,this.line=y,this.height=T,this.webview=a,this.onDidDispose=s.event}dispose(){E._insets.has(m)&&(E._insets.delete(m),E._proxy.$disposeEditorInset(m),s.fire(),s.dispose(),t.dispose())}};return this._proxy.$createEditorInset(m,g.id,g.value.document.uri,y+1,T,O||{},b.identifier,b.extensionLocation),this._insets.set(m,{editor:A,inset:p,onDidReceiveMessage:t}),p}$onDidDispose(A){const y=this._insets.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this._insets.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=M}),define(De[169],Ie([1,0,4,15,139]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class M{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new i.Emitter,this._onExit=new i.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,y,T,O){const b={command:A};if(y&&Object.keys(y).length>0&&(b.arguments=y),this.internalSend("request",b),typeof O=="number"){const g=setTimeout(()=>{clearTimeout(g);const E=this.pendingRequests.get(b.seq);if(E){this.pendingRequests.delete(b.seq);const m={type:"response",seq:0,request_seq:b.seq,success:!1,command:A,message:(0,w.localize)(0,null,O,A)};E(m)}},O)}return T&&this.pendingRequests.set(b.seq,T),b.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,y){return A.type!=="event"||y.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,I.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback?.(A);break;case"request":this.requestCallback?.(A);break;case"response":{const y=A,T=this.pendingRequests.get(y.request_seq);T&&(this.pendingRequests.delete(y.request_seq),T(y));break}}}}internalSend(A,y){y.type=A,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((y,T)=>A.set(T,y)),await(0,I.timeout)(500),A.forEach((y,T)=>{y({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=M}),define(De[170],Ie([1,0,140,41,3]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new I.RawContextKey("debugType",void 0,{type:"string",description:i.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new I.RawContextKey("debugConfigurationType",void 0,{type:"string",description:i.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new I.RawContextKey("debugState","inactive",{type:"string",description:i.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new I.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:i.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new I.RawContextKey("inDebugMode",!1,{type:"boolean",description:i.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new I.RawContextKey("inDebugRepl",!1,{type:"boolean",description:i.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new I.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:i.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new I.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:i.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new I.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:i.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new I.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:i.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new I.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:i.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new I.RawContextKey("variablesFocused",!0,{type:"boolean",description:i.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new I.RawContextKey("expressionSelected",!1,{type:"boolean",description:i.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new I.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:i.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new I.RawContextKey("callStackItemType",void 0,{type:"string",description:i.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new I.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:i.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new I.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:i.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new I.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:i.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new I.RawContextKey("watchItemType",void 0,{type:"string",description:i.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new I.RawContextKey("canViewMemory",void 0,{type:"boolean",description:i.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new I.RawContextKey("breakpointItemType",void 0,{type:"string",description:i.localize(20,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new I.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:i.localize(21,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new I.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:i.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new I.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:i.localize(23,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new I.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:i.localize(24,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new I.RawContextKey("stepBackSupported",!1,{type:"boolean",description:i.localize(25,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new I.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:i.localize(26,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new I.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:i.localize(27,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new I.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:i.localize(28,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new I.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:i.localize(29,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new I.RawContextKey("breakpointsExist",!1,{type:"boolean",description:i.localize(30,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new I.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:i.localize(31,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new I.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:i.localize(32,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new I.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:i.localize(33,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new I.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:i.localize(34,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new I.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:i.localize(35,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new I.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:i.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new I.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:i.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new I.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:i.localize(38,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new I.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:i.localize(39,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new I.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:i.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new I.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:i.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new I.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:i.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new I.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:i.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new I.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:i.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new I.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:i.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new I.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:i.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new I.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:i.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new I.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:i.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new I.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:i.localize(49,null)});const M=g=>i.localize(50,null,g);e.debuggerDisabledMessage=M,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:i.localize(51,null)};var D;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(D=e.State||(e.State={}));function A(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var T;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(T=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,w.createDecorator)("debugService");var b;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(b=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[171],Ie([1,0,10,2,19,23,13]),function(ie,e,i,I,w,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function y(n,d,l){return n.replace(A,function(f,o){return d&&o.length>0&&o[0]!=="_"?f:l&&l.hasOwnProperty(o)?l[o]:f})}e.formatPII=y;function T(n){const d={};for(const l of Object.keys(n))l.startsWith("!")||(d[l]=n[l]);return d}e.filterExceptionsFromTelemetry=T;function O(n){return n.configuration.request==="attach"&&!b(n)&&(!n.parentSession||O(n.parentSession))}e.isSessionAttach=O;function b(n){let d=n.configuration.type;if(!!d)return d==="vslsShare"&&(d=n.configuration.adapterProxy.configuration.type),(0,i.equalsIgnoreCase)(d,"extensionhost")||(0,i.equalsIgnoreCase)(d,"pwa-extensionhost")?n:n.parentSession?b(n.parentSession):void 0}e.getExtensionHostDebugSession=b;function g(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=g;function E(n,d,l){let f,o=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let v=null;for(;v=h.exec(n);){const k=v.index+1,F=k+v[0].length;if(k<=d&&F>=l){f=v[0],o=k;break}}if(f){const k=/\w+/g;let F=null;for(;(F=k.exec(f))&&!(F.index+1+o+F[0].length>=l););F&&(f=f.substring(0,k.lastIndex))}return f?{start:o,end:o+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=E;const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(n){return!!(n&&n.match(m))}e.isUri=t;function s(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(t(n.path))return I.URI.parse(n.path);if((0,w.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function a(n){if(typeof n.path=="object"){const d=I.URI.revive(n.path);if(d)return d.scheme===D.Schemas.file?d.fsPath:d.toString()}return n.path}function p(n,d){const l=d?s:a,f=(0,M.deepClone)(n);return u(f,(o,h)=>{o&&h&&(h.path=l(h))}),f}e.convertToDAPaths=p;function S(n,d){const l=d?s:a,f=(0,M.deepClone)(n);return u(f,(o,h)=>{!o&&h&&(h.path=l(h))}),f}e.convertToVSCPaths=S;function u(n,d){switch(n.type){case"event":{const l=n;switch(l.event){case"output":d(!1,l.body.source);break;case"loadedSource":d(!1,l.body.source);break;case"breakpoint":d(!1,l.body.breakpoint.source);break;default:break}break}case"request":{const l=n;switch(l.command){case"setBreakpoints":d(!0,l.arguments.source);break;case"breakpointLocations":d(!0,l.arguments.source);break;case"source":d(!0,l.arguments.source);break;case"gotoTargets":d(!0,l.arguments.source);break;case"launchVSCode":l.arguments.args.forEach(f=>d(!1,f));break;default:break}break}case"response":{const l=n;if(l.success&&l.body)switch(l.command){case"stackTrace":l.body.stackFrames.forEach(f=>d(!1,f.source));break;case"loadedSources":l.body.sources.forEach(f=>d(!1,f));break;case"scopes":l.body.scopes.forEach(f=>d(!1,f.source));break;case"setFunctionBreakpoints":l.body.breakpoints.forEach(f=>d(!1,f.source));break;case"setBreakpoints":l.body.breakpoints.forEach(f=>d(!1,f.source));break;case"disassemble":l.body?.instructions.forEach(o=>d(!1,o.location));break;default:break}break}}}function C(n){return n.filter(d=>!d.presentation?.hidden).sort((d,l)=>d.presentation?l.presentation?d.presentation.group?l.presentation.group?d.presentation.group!==l.presentation.group?d.presentation.group.localeCompare(l.presentation.group):r(d.presentation.order,l.presentation.order):-1:l.presentation.group?1:r(d.presentation.order,l.presentation.order):-1:l.presentation?1:0)}e.getVisibleAndSorted=C;function r(n,d){return typeof n!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:n-d}async function c(n,d){const l=n.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(l!=="none"&&(await d.saveAll(),l==="allEditorsInActiveGroup")){const f=d.activeEditorPane;f&&f.input.resource?.scheme===D.Schemas.untitled&&await d.save({editor:f.input,groupId:f.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=c}),define(De[66],Ie([1,0,24,34,172,79,13,19,21,41]),function(ie,e,i,I,w,M,D,A,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",M.Mimes.latex,M.Mimes.markdown,"image/png","image/jpeg",M.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[M.Mimes.latex,M.Mimes.markdown,"application/json",M.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var b;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(b=e.NotebookRunState||(e.NotebookRunState={}));var g;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(g=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var E;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(E=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var t;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(t=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var p;(function(x){x.scheme=D.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${z.join("")}]+`),K=7;function Z(Y,me){const Se=me.toString(K),Be=`${Se.length<z.length?z[Se.length-1]:"z"}${Se}s${(0,i.encodeBase64)(i.VSBuffer.fromString(Y.scheme),!0,!0)}`;return Y.with({scheme:x.scheme,fragment:Be})}x.generate=Z;function ue(Y){if(Y.scheme!==x.scheme)return;const me=Y.fragment.indexOf("s");if(me<0)return;const Se=parseInt(Y.fragment.substring(0,me).replace(B,""),K),Oe=(0,i.decodeBase64)(Y.fragment.substring(me+1)).toString();if(!isNaN(Se))return{handle:Se,notebook:Y.with({scheme:Oe,fragment:null})}}x.parse=ue;function ne(Y,me){return Y.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${Y.scheme!==D.Schemas.file?Y.scheme:""}`})}x.generateCellOutputUri=ne;function pe(Y){if(Y.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!me)return;const Se=me[1]&&me[1]!==""?me[1]:void 0,Oe=me[2];return{outputId:Se,notebook:Y.with({scheme:Oe||D.Schemas.file,fragment:null})}}x.parseCellOutputUri=pe;function ae(Y,me,Se){return x.generate(Y,me).with({scheme:Se})}x.generateCellPropertyUri=ae;function de(Y,me){if(Y.scheme===me)return x.parse(Y.with({scheme:x.scheme}))}x.parseCellPropertyUri=de})(p=e.CellUri||(e.CellUri={}));const S=x=>y.isWindows?x.replace(/\//g,"\\"):x;class u{constructor(z=[],B=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=B,this.order=[...new Set(z)].map(K=>({pattern:K,matches:I.parse(S(K))}))}sort(z){const B=new Map(w.Iterable.map(z,Z=>[Z,S(Z)]));let K=[];for(const{matches:Z}of this.order)for(const[ue,ne]of B)if(Z(ne)){K.push(ue),B.delete(ue);break}return B.size&&(K=K.concat([...B.keys()].sort((Z,ue)=>this.defaultOrder.indexOf(Z)-this.defaultOrder.indexOf(ue)))),K}prioritize(z,B){const K=this.findIndex(z);if(K===-1){this.order.unshift({pattern:z,matches:I.parse(S(z))});return}const Z=new Set(B.map(ne=>this.findIndex(ne,K)));Z.delete(-1);const ue=Array.from(Z).sort();this.order.splice(K+1,0,...ue.map(ne=>this.order[ne]));for(let ne=ue.length-1;ne>=0;ne--)this.order.splice(ue[ne],1)}toArray(){return this.order.map(z=>z.pattern)}findIndex(z,B=this.order.length){const K=S(z);for(let Z=0;Z<B;Z++)if(this.order[Z].matches(K))return Z;return-1}}e.MimeTypeDisplayOrder=u;function C(x,z,B,K=(Z,ue)=>Z===ue){const Z=[];function ue(ae,de,Y){if(de===0&&Y.length===0)return;const me=Z[Z.length-1];me&&me.start+me.deleteCount===ae?(me.deleteCount+=de,me.toInsert.push(...Y)):Z.push({start:ae,deleteCount:de,toInsert:Y})}let ne=0,pe=0;for(;;){if(ne===x.length){ue(ne,0,z.slice(pe));break}if(pe===z.length){ue(ne,x.length-ne,[]);break}const ae=x[ne],de=z[pe];if(K(ae,de)){ne+=1,pe+=1;continue}B(de)?(ue(ne,1,[]),ne+=1):(ue(ne,0,[de]),pe+=1)}return Z}e.diff=C,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new T.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(x){x.default="default",x.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function c(x){const z=x;return!!((typeof z.include=="string"||I.isRelativePattern(z.include))&&(typeof z.exclude=="string"||I.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=c;function n(x,z,B){if(Array.isArray(x.viewType)&&x.viewType.indexOf(z)>=0||x.viewType===z)return!0;if(x.filenamePattern){const K=c(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,Z=c(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(I.match(K,(0,A.basename)(B.fsPath).toLowerCase()))return!(Z&&I.match(Z,(0,A.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var d;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(d=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class l{static create(z){return`${l._prefix}${z}`}static parse(z){if(z.startsWith(l._prefix))return z.substring(l._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=l,l._prefix="notebook/";function f(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=f;const o=new TextDecoder;function h(x){const z=[];let B=!1;for(const K of x)(z.length===0||B)&&(z.push(K),B=!0);return j(z),R(i.VSBuffer.concat(z.map(K=>i.VSBuffer.wrap(K))))}e.compressOutputItemStreams=h;const v=`${String.fromCharCode(27)}[A`,k=v.split("").map(x=>x.charCodeAt(0)),F=10;function j(x){x.forEach((z,B)=>{if(B===0||z.length<v.length)return;const K=x[B-1],Z=z.subarray(0,v.length);if(Z[0]===k[0]&&Z[1]===k[1]&&Z[2]===k[2]){const ue=K.lastIndexOf(F);if(ue===-1)return;x[B-1]=K.subarray(0,ue),x[B]=z.subarray(v.length)}})}function H(x){let z=x;do x=z,z=x.replace(/[^\n]\x08/gm,"");while(z.length<x.length);return x}function V(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const z=x.match(/^(.*)\r+/m)[1];let B=x.match(/\r+(.*)$/m)[1];B=B+z.slice(B.length,z.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return x}const P="\b".charCodeAt(0),U="\r".charCodeAt(0);function R(x){return!x.buffer.includes(P)&&!x.buffer.includes(U)?x:i.VSBuffer.fromString(V(H(o.decode(x.buffer))))}}),define(De[173],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var I;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState"})(I=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,i.createDecorator)("INotebookExecutionService")}),define(De[174],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function i(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=i;function I(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=I;function w(D){return Array.from(D.entries()).map(A=>[A[0],i(A[1].map)])}e.serializeEnvironmentVariableCollections=w;function M(D){return new Map(D.map(A=>[A[0],{map:I(A[1])}]))}e.deserializeEnvironmentVariableCollections=M}),define(De[42],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var i;(function(M){M.Delimiter="\0"})(i=e.TestIdPathParts||(e.TestIdPathParts={}));var I;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(I=e.TestPosition||(e.TestPosition={}));class w{static fromExtHostTestItem(D,A,y=D.parent){if(D._isRoot)return new w([A]);const T=[D.id];for(let O=y;O&&O.id!==A;O=O.parent)T.push(O.id);return T.push(A),new w(T.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const A=D.indexOf("\0");return A===-1?D:D.slice(0,A)}static fromString(D){return new w(D.split("\0"))}static join(D,A){return new w([...D.path,A])}static joinToString(D,A){return D.toString()+"\0"+A}static parentId(D){const A=D.lastIndexOf("\0");return A===-1?void 0:D.slice(0,A)}static compare(D,A){return D===A?0:A.startsWith(D+"\0")?2:D.startsWith(A+"\0")?3:1}constructor(D,A=D.length){if(this.path=D,this.viewEnd=A,D.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):void 0}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new w(this.path,D)}*idsToRoot(){for(let D=this.viewEnd;D>0;D--)yield new w(this.path,D)}compare(D){if(typeof D=="string")return w.compare(this.toString(),D);for(let A=0;A<D.viewEnd&&A<this.viewEnd;A++)if(D.path[A]!==this.path[A])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=w}),define(De[51],Ie([1,0,2,52,42]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var M;(function(o){o[o.Unset=0]="Unset",o[o.Queued=1]="Queued",o[o.Running=2]="Running",o[o.Passed=3]="Passed",o[o.Failed=4]="Failed",o[o.Skipped=5]="Skipped",o[o.Errored=6]="Errored"})(M=e.TestResultState||(e.TestResultState={}));var D;(function(o){o[o.Run=2]="Run",o[o.Debug=4]="Debug",o[o.Coverage=8]="Coverage",o[o.HasNonDefaultProfile=16]="HasNonDefaultProfile",o[o.HasConfigurable=32]="HasConfigurable"})(D=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var A;(function(o){o.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),o.deserialize=h=>({range:I.Range.lift(h.range),uri:i.URI.revive(h.uri)})})(A=e.IRichLocation||(e.IRichLocation={}));var y;(function(o){o[o.Error=0]="Error",o[o.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var T;(function(o){o.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.serialize(h.location)}),o.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,location:h.location&&A.deserialize(h.location)})})(T=e.ITestErrorMessage||(e.ITestErrorMessage={}));const O=(o,h)=>`${h?"s":"e"}${o}`;e.getMarkId=O;var b;(function(o){o.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.serialize(h.location)}),o.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&A.deserialize(h.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var g;(function(o){o.serialize=h=>h.type===0?T.serialize(h):b.serialize(h),o.deserialize=h=>h.type===0?T.deserialize(h):b.deserialize(h)})(g=e.ITestMessage||(e.ITestMessage={}));var E;(function(o){o.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),o.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(g.serialize)}),o.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(g.deserialize)})})(E=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",t=(o,h)=>o+m+h;e.namespaceTestTag=t;const s=o=>{const h=o.indexOf(m);return{ctrlId:o.slice(0,h),tagId:o.slice(h+1)}};e.denamespaceTestTag=s;var a;(function(o){o.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),o.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?i.URI.revive(h.uri):void 0,range:h.range?I.Range.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(a=e.ITestItem||(e.ITestItem={}));var p;(function(o){o[o.NotExpandable=0]="NotExpandable",o[o.Expandable=1]="Expandable",o[o.BusyExpanding=2]="BusyExpanding",o[o.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));var S;(function(o){o.serialize=h=>({expand:h.expand,item:a.serialize(h.item)}),o.deserialize=h=>({controllerId:w.TestId.root(h.item.extId),expand:h.expand,item:a.deserialize(h.item)})})(S=e.InternalTestItem||(e.InternalTestItem={}));var u;(function(o){o.serialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.uri!==void 0&&(v.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(v.range=h.item.range?.toJSON()),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}},o.deserialize=h=>{let v;return h.item&&(v={},h.item.label!==void 0&&(v.label=h.item.label),h.item.tags!==void 0&&(v.tags=h.item.tags),h.item.busy!==void 0&&(v.busy=h.item.busy),h.item.range!==void 0&&(v.range=h.item.range?I.Range.lift(h.item.range):null),h.item.description!==void 0&&(v.description=h.item.description),h.item.error!==void 0&&(v.error=h.item.error),h.item.sortText!==void 0&&(v.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:v}}})(u=e.ITestItemUpdate||(e.ITestItemUpdate={}));const C=(o,h)=>{h.expand!==void 0&&(o.expand=h.expand),h.item!==void 0&&(o.item=o.item?Object.assign(o.item,h.item):h.item)};e.applyTestItemUpdate=C;var r;(function(o){o.serializeWithoutMessages=h=>({...S.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.serializeWithoutMessages),retired:h.retired}),o.serialize=h=>({...S.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.serialize),retired:h.retired}),o.deserialize=h=>({...S.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(E.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var c;(function(o){o[o.Function=0]="Function",o[o.Statement=1]="Statement"})(c=e.DetailType||(e.DetailType={}));var n;(function(o){o[o.Add=0]="Add",o[o.Update=1]="Update",o[o.DocumentSynced=2]="DocumentSynced",o[o.Remove=3]="Remove",o[o.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",o[o.Retire=5]="Retire",o[o.AddTag=6]="AddTag",o[o.RemoveTag=7]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var d;(function(o){o.deserialize=h=>h.op===0?{op:h.op,item:S.deserialize(h.item)}:h.op===1?{op:h.op,item:u.deserialize(h.item)}:h.op===2?{op:h.op,uri:i.URI.revive(h.uri),docv:h.docv}:h,o.serialize=h=>h.op===0?{op:h.op,item:S.serialize(h.item)}:h.op===1?{op:h.op,item:u.serialize(h.item)}:h})(d=e.TestsDiffOp||(e.TestsDiffOp={}));class l{add(h){}update(h){}remove(h,v){}complete(){}}e.IncrementalChangeCollector=l;class f{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(h){const v=this.createChangeCollector();for(const k of h)switch(k.op){case 0:{const F=S.deserialize(k.item),j=w.TestId.parentId(F.item.extId)?.toString();if(j){if(this.items.has(j)){const H=this.items.get(j);H.children.add(F.item.extId);const V=this.createItem(F,H);this.items.set(F.item.extId,V),v.add(V)}}else{const H=this.createItem(F);this.roots.add(H),this.items.set(F.item.extId,H),v.add(H)}F.expand===2&&this.busyControllerCount++;break}case 1:{const F=u.deserialize(k.item),j=this.items.get(F.extId);if(!j)break;F.expand!==void 0&&(j.expand===2&&this.busyControllerCount--,F.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(j,F),v.update(j);break}case 3:{const F=this.items.get(k.itemId);if(!F)break;const j=w.TestId.parentId(F.item.extId)?.toString();j?this.items.get(j).children.delete(F.item.extId):this.roots.delete(F);const H=[[k.itemId]];for(;H.length;)for(const V of H.pop()){const P=this.items.get(V);P&&(H.push(P.children),this.items.delete(V),v.remove(P,P!==F),P.expand===2&&this.busyControllerCount--)}break}case 5:this.retireTest(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this._tags.set(k.tag.id,k.tag);break;case 7:this._tags.delete(k.id);break}v.complete()}retireTest(h){}updatePendingRoots(h){this.pendingRootCount+=h}createChangeCollector(){return new l}}e.AbstractIncrementalTestCollection=f}),define(De[67],Ie([1,0,15,4,7,47,51,42]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const T=(a,p)=>a===p,O={range:(a,p)=>a===p?!0:!a||!p?!1:a.equalsRange(p),busy:T,label:T,description:T,error:T,tags:(a,p)=>!(a.length!==p.length||a.some(S=>!p.includes(S)))},b=(a,p)=>{let S;for(const[u,C]of Object.entries(O))C(a[u],p[u])||(S?S[u]=p[u]:S={[u]:p[u]});return S};class g extends w.Disposable{get root(){return this.options.root}constructor(p){super(),this.options=p,this.debounceSendDiff=this._register(new i.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new I.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(p){this._resolveHandler=p;for(const S of this.tree.values())this.updateExpandability(S)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){switch(p.op){case 2:{for(const S of this.diff)if(S.op===2&&S.uri===p.uri){S.docv=p.docv;return}break}case 1:{const S=this.diff[this.diff.length-1];if(S){if(S.op===1&&S.item.extId===p.item.extId){(0,D.applyTestItemUpdate)(S.item,p.item);return}if(S.op===0&&S.item.item.extId===p.item.extId){(0,D.applyTestItemUpdate)(S.item,p.item);return}}break}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,S){const u=this.tree.get(p);if(!!u){if((u.expandLevels===void 0||S>u.expandLevels)&&(u.expandLevels=S),u.expand===1){const C=this.resolveChildren(u);return C.isOpen()?this.expandChildren(u,S-1):C.wait().then(()=>this.expandChildren(u,S-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.expandChildren(u,S-1)):this.expandChildren(u,S-1)}}dispose(){for(const p of this.tree.values())this.options.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(p,S){switch(S.op){case 3:this.removeItem(A.TestId.joinToString(p.fullId,S.id));break;case 0:this.upsertItem(S.item,p);break;case 5:for(const u of S.ops)this.onTestItemEvent(p,u);break;case 1:this.diffTagRefs(S.new,S.old,p.fullId.toString());break;case 2:this.updateExpandability(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:S.update}});break;case 6:this.documentSynced(p.actual.uri);break;default:(0,M.assertNever)(S)}}documentSynced(p){p&&this.pushDiff({op:2,uri:p,docv:this.options.getDocumentVersion(p)})}upsertItem(p,S){const u=A.TestId.fromExtHostTestItem(p,this.root.id,S?.actual),C=this.options.getApiFor(p);C.parent&&C.parent!==S?.actual&&this.options.getChildren(C.parent).delete(p.id);let r=this.tree.get(u.toString());if(!r){r={fullId:u,actual:p,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},p.tags.forEach(this.incrementTagRefs,this),this.tree.set(r.fullId.toString(),r),this.setItemParent(p,S),this.pushDiff({op:0,item:{controllerId:this.options.controllerId,expand:r.expand,item:this.options.toITestItem(p)}}),this.connectItemAndChildren(p,r,S);return}if(r.actual===p){this.connectItem(p,r,S);return}const c=this.options.getChildren(r.actual),n=r.actual,d=b(this.options.toITestItem(n),this.options.toITestItem(p));this.options.getApiFor(n).listener=void 0,r.actual=p,r.expand=0,d&&(d.hasOwnProperty("tags")&&(this.diffTagRefs(p.tags,n.tags,u.toString()),delete d.tags),this.onTestItemEvent(r,{op:4,update:d})),this.connectItemAndChildren(p,r,S);for(const[l,f]of c)this.options.getChildren(p).get(f.id)||this.removeItem(A.TestId.joinToString(u,f.id));this.documentSynced(r.actual.uri)}diffTagRefs(p,S,u){const C=new Set(S.map(r=>r.id));for(const r of p)C.delete(r.id)||this.incrementTagRefs(r);this.pushDiff({op:1,item:{extId:u,item:{tags:p.map(r=>(0,D.namespaceTestTag)(this.options.controllerId,r.id))}}}),C.forEach(this.decrementTagRefs,this)}incrementTagRefs(p){const S=this.tags.get(p.id);S?S.refCount++:(this.tags.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,D.namespaceTestTag)(this.options.controllerId,p.id)}}))}decrementTagRefs(p){const S=this.tags.get(p);S&&!--S.refCount&&(this.tags.delete(p),this.pushDiff({op:7,id:(0,D.namespaceTestTag)(this.options.controllerId,p)}))}setItemParent(p,S){this.options.getApiFor(p).parent=S&&S.actual!==this.root?S.actual:void 0}connectItem(p,S,u){this.setItemParent(p,u);const C=this.options.getApiFor(p);C.parent=u?.actual,C.listener=r=>this.onTestItemEvent(S,r),this.updateExpandability(S)}connectItemAndChildren(p,S,u){this.connectItem(p,S,u);for(const[C,r]of this.options.getChildren(p))this.upsertItem(r,S)}updateExpandability(p){let S;this._resolveHandler?p.resolveBarrier?S=p.resolveBarrier.isOpen()?3:2:S=p.actual.canResolveChildren?1:0:S=0,S!==p.expand&&(p.expand=S,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:S}}),S===1&&p.expandLevels!==void 0&&this.resolveChildren(p))}expandChildren(p,S){if(S<0)return;const u=[];for(const[C,r]of this.options.getChildren(p.actual)){const c=this.expand(A.TestId.joinToString(p.fullId,r.id),S);(0,i.isThenable)(c)&&u.push(c)}if(u.length)return Promise.all(u).then(()=>{})}resolveChildren(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this._resolveHandler){const r=new i.Barrier;return r.open(),r}p.expand=2,this.pushExpandStateUpdate(p);const S=p.resolveBarrier=new i.Barrier,u=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,r)};let C;try{C=this._resolveHandler(p.actual===this.root?void 0:p.actual)}catch(r){u(r)}return(0,i.isThenable)(C)?C.catch(u).then(()=>{S.open(),this.updateExpandability(p)}):(S.open(),this.updateExpandability(p)),p.resolveBarrier}pushExpandStateUpdate(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}removeItem(p){const S=this.tree.get(p);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const u=[S];for(;u.length;){const C=u.pop();if(!!C){this.options.getApiFor(C.actual).listener=void 0;for(const r of C.actual.tags)this.decrementTagRefs(r.id);this.tree.delete(C.fullId.toString());for(const[r,c]of this.options.getChildren(C.actual))u.push(this.tree.get(A.TestId.joinToString(C.fullId,c.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}}e.TestItemCollection=g;class E extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.DuplicateTestItemError=E;class m extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=m;class t extends Error{constructor(p,S,u){super(`TestItem with ID "${p}" is from controller "${S}" and cannot be added as a child of an item from controller "${u}".`)}}e.MixedTestItemController=t;const s=(a,p,S)=>{let u=new Map;return{get size(){return u.size},forEach(C,r){for(const c of u.values())C.call(r,c,this)},[Symbol.iterator](){return u.entries()},replace(C){const r=new Map,c=new Set(u.keys()),n={op:5,ops:[]};for(const d of C){if(!(d instanceof S))throw new m(d.id);const l=p(d).controllerId;if(l!==a.controllerId)throw new t(d.id,l,a.controllerId);if(r.has(d.id))throw new E(d.id);r.set(d.id,d),c.delete(d.id),n.ops.push({op:0,item:d})}for(const d of c.keys())n.ops.push({op:3,id:d});a.listener?.(n),u=r},add(C){if(!(C instanceof S))throw new m(C.id);u.set(C.id,C),a.listener?.({op:0,item:C})},delete(C){u.delete(C)&&a.listener?.({op:3,id:C})},get(C){return u.get(C)},toJSON(){return Array.from(u.values())}}};e.createTestItemChildren=s}),define(De[92],Ie([1,0,67]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const I=new WeakMap,w=(D,A)=>{const y={controllerId:A};return I.set(D,y),y};e.createPrivateApiFor=w;const M=D=>{const A=I.get(D);if(!A)throw new i.InvalidTestItemError(D?.id||"<unknown>");return A};e.getPrivateApiFor=M}),define(De[175],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,i.createDecorator)("configurationResolverService");var I;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(I=e.VariableKind||(e.VariableKind={}));class w extends Error{constructor(D,A){super(A),this.variable=D}}e.VariableError=w}),define(De[176],Ie([1,0,19,48,9,23,21,82,143,175,10]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class b{constructor(E,m,t,s){this._contributedVariables=new Map,this._context=E,this._labelService=m,this._userHomePromise=t,s&&(this._envVariablesPromise=s.then(a=>this.prepareEnv(a)))}prepareEnv(E){if(D.isWindows){const m=Object.create(null);return Object.keys(E).forEach(t=>{m[t.toLowerCase()]=E[t]}),m}return E}resolveWithEnvironment(E,m,t){return this.recursiveResolve({env:this.prepareEnv(E),userHome:void 0},m?m.uri:void 0,t)}async resolveAsync(E,m){const t={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(t,E?E.uri:void 0,m)}async resolveAnyBase(E,m,t,s){const a=M.deepClone(m);D.isWindows&&a.windows?Object.keys(a.windows).forEach(S=>a[S]=a.windows[S]):D.isMacintosh&&a.osx?Object.keys(a.osx).forEach(S=>a[S]=a.osx[S]):D.isLinux&&a.linux&&Object.keys(a.linux).forEach(S=>a[S]=a.linux[S]),delete a.windows,delete a.osx,delete a.linux;const p={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(p,E?E.uri:void 0,a,t,s)}async resolveAnyAsync(E,m,t){return this.resolveAnyBase(E,m,t)}async resolveAnyMap(E,m,t){const s=new Map;return{newConfig:await this.resolveAnyBase(E,m,t,s),resolvedVariables:s}}resolveWithInteractionReplace(E,m,t,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,m,t,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,m){if(this._contributedVariables.has(E))throw new Error("Variable "+E+" is contributed twice.");this._contributedVariables.set(E,m)}async recursiveResolve(E,m,t,s,a){if(w.isString(t))return this.resolveString(E,m,t,s,a);if(Array.isArray(t))return Promise.all(t.map(p=>this.recursiveResolve(E,m,p,s,a)));if(w.isObject(t)){const p=Object.create(null),S=await Promise.all(Object.keys(t).map(async u=>[await this.resolveString(E,m,u,s,a),await this.recursiveResolve(E,m,t[u],s,a)]));for(const[u,C]of S)p[u]=C;return p}return t}resolveString(E,m,t,s,a){return(0,O.replaceAsync)(t,b.VARIABLE_REGEXP,async(p,S)=>{if(S.includes(b.VARIABLE_LHS))return p;let u=await this.evaluateSingleVariable(E,p,S,m,s);return a?.set(S,u),u!==p&&w.isString(u)&&u.match(b.VARIABLE_REGEXP)&&(u=await this.resolveString(E,m,u,s,a)),u})}fsPath(E){return this._labelService?this._labelService.getUriLabel(E,{noPrefix:!0}):E.fsPath}async evaluateSingleVariable(E,m,t,s,a){let p;const S=t.split(":");S.length>1&&(t=S[0],p=S[1]);const u=c=>{const n=this._context.getFilePath();if(n)return n;throw new T.VariableError(c,(0,y.localize)(0,null,m))},C=c=>{const n=u(c);if(this._context.getWorkspaceFolderPathForFile){const d=this._context.getWorkspaceFolderPathForFile();if(d)return d}throw new T.VariableError(c,(0,y.localize)(1,null,m,i.basename(n)))},r=c=>{if(p){const n=this._context.getFolderUri(p);if(n)return n;throw new T.VariableError(c,(0,y.localize)(2,null,m,p))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new T.VariableError(c,(0,y.localize)(3,null,m)):new T.VariableError(c,(0,y.localize)(4,null,m))};switch(t){case"env":if(p){if(E.env){const c=E.env[D.isWindows?p.toLowerCase():p];if(w.isString(c))return c}return""}throw new T.VariableError(T.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(p){const c=this._context.getConfigurationValue(s,p);if(w.isUndefinedOrNull(c))throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(6,null,m,p));if(w.isObject(c))throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(7,null,m,p));return c}throw new T.VariableError(T.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.resolveFromMap(T.VariableKind.Command,m,p,a,"command");case"input":return this.resolveFromMap(T.VariableKind.Input,m,p,a,"input");case"extensionInstallFolder":if(p){const c=await this._context.getExtension(p);if(!c)throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,p));return this.fsPath(c.extensionLocation)}throw new T.VariableError(T.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(t){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(r(T.VariableKind.WorkspaceFolder)));case"cwd":return s||p?(0,A.normalizeDriveLetter)(this.fsPath(r(T.VariableKind.Cwd))):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return i.basename(this.fsPath(r(T.VariableKind.WorkspaceFolderBasename)));case"userHome":{if(E.userHome)return E.userHome;throw new T.VariableError(T.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const c=this._context.getLineNumber();if(c)return c;throw new T.VariableError(T.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const c=this._context.getSelectedText();if(c)return c;throw new T.VariableError(T.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return u(T.VariableKind.File);case"fileWorkspaceFolder":return C(T.VariableKind.FileWorkspaceFolder);case"relativeFile":return s||p?i.relative(this.fsPath(r(T.VariableKind.RelativeFile)),u(T.VariableKind.RelativeFile)):u(T.VariableKind.RelativeFile);case"relativeFileDirname":{const c=i.dirname(u(T.VariableKind.RelativeFileDirname));if(s||p){const n=i.relative(this.fsPath(r(T.VariableKind.RelativeFileDirname)),c);return n.length===0?".":n}return c}case"fileDirname":return i.dirname(u(T.VariableKind.FileDirname));case"fileExtname":return i.extname(u(T.VariableKind.FileExtname));case"fileBasename":return i.basename(u(T.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=i.basename(u(T.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-i.extname(c).length)}case"fileDirnameBasename":return i.basename(i.dirname(u(T.VariableKind.FileDirnameBasename)));case"execPath":{const c=this._context.getExecPath();return c||m}case"execInstallFolder":{const c=this._context.getAppRoot();return c||m}case"pathSeparator":return i.sep;default:try{const c=p?`${t}:${p}`:t;return this.resolveFromMap(T.VariableKind.Unknown,m,c,a,void 0)}catch{return m}}}}resolveFromMap(E,m,t,s,a){if(t&&s){const p=a===void 0?s[t]:s[a+":"+t];if(typeof p=="string")return p;throw new T.VariableError(E,(0,y.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=b,b.VARIABLE_LHS="${",b.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[93],Ie([1,0,3,91]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,i.createDecorator)("editorGroupsService");var w;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var M;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(M=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var A;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function T(m){const t=m;return(0,I.isEditorInput)(t?.editor)&&(0,I.isEditorInput)(t?.replacement)}e.isEditorReplacement=T;var O;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function g(m){const t=m;return!!t&&typeof t.id=="number"&&Array.isArray(t.editors)}e.isEditorGroup=g;function E(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=E}),define(De[177],Ie([1,0,3,93]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,i.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(M){const D=M;return typeof M=="number"||(0,I.isEditorGroup)(D)}e.isPreferredGroup=w}),define(De[178],Ie([1,0,3,148]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,i.refineServiceDecorator)(I.IEnvironmentService)}),define(De[179],Ie([1,0,25,4,19]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class M{constructor(b){this.removedDueToLooping=b}}e.DeltaExtensionsResult=M;class D{constructor(b){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=b,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const b of this._extensionDescriptions){if(this._extensionsMap.has(i.ExtensionIdentifier.toKey(b.identifier))){console.error("Extension `"+b.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(i.ExtensionIdentifier.toKey(b.identifier),b),this._extensionsArr.push(b),Array.isArray(b.activationEvents))for(let g of b.activationEvents)g==="onUri"&&(g=`onUri:${i.ExtensionIdentifier.toKey(b.identifier)}`),this._activationMap.has(g)||this._activationMap.set(g,[]),this._activationMap.get(g).push(b)}}set(b){this._extensionDescriptions=b,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(b,g){this._extensionDescriptions=T(this._extensionDescriptions,g),this._extensionDescriptions=this._extensionDescriptions.concat(b);const E=D._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=T(this._extensionDescriptions,E.map(m=>m.identifier)),this._initialize(),this._onDidChange.fire(void 0),new M(E)}static _findLoopingExtensions(b){const g=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(a){this._nodesSet.has(a)||(this._nodesSet.add(a),this._nodesArr.push(a))}addArc(a,p){this.addNode(a),this.addNode(p),this._arcs.has(a)?this._arcs.get(a).push(p):this._arcs.set(a,[p])}getArcs(a){return this._arcs.has(a)?this._arcs.get(a):[]}hasOnlyGoodArcs(a,p){const S=g.getArcs(a);for(let u=0;u<S.length;u++)if(!p.has(S[u]))return!1;return!0}getNodes(){return this._nodesArr}},E=new Map;for(const a of b){const p=i.ExtensionIdentifier.toKey(a.identifier);if(E.set(p,a),a.extensionDependencies)for(const S of a.extensionDependencies){const u=i.ExtensionIdentifier.toKey(S);g.addArc(p,u)}}const m=new Set;g.getNodes().filter(a=>g.getArcs(a).length===0).forEach(a=>m.add(a));const t=g.getNodes().filter(a=>!m.has(a));let s;do{s=!1;for(let a=0;a<t.length;a++){const p=t[a];g.hasOnlyGoodArcs(p,m)&&(t.splice(a,1),a--,m.add(p),s=!0)}}while(s);return t.map(a=>E.get(a))}containsActivationEvent(b){return this._activationMap.has(b)}containsExtension(b){return this._extensionsMap.has(i.ExtensionIdentifier.toKey(b))}getExtensionDescriptionsForActivationEvent(b){const g=this._activationMap.get(b);return g?g.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(b){const g=this._extensionsMap.get(i.ExtensionIdentifier.toKey(b));return g||void 0}getExtensionDescriptionByUUID(b){for(const g of this._extensionsArr)if(g.uuid===b)return g}getExtensionDescriptionByIdOrUUID(b,g){return this.getExtensionDescription(b)??(g?this.getExtensionDescriptionByUUID(g):void 0)}}e.ExtensionDescriptionRegistry=D;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function y(O,b){const g=O.isBuiltin?0:O.isUnderDevelopment?2:1,E=b.isBuiltin?0:b.isUnderDevelopment?2:1;if(g!==E)return g-E;const m=w.posix.basename(O.extensionLocation.path),t=w.posix.basename(b.extensionLocation.path);return m<t?-1:m>t?1:0}function T(O,b){const g=new Set;return b.forEach(E=>g.add(i.ExtensionIdentifier.toKey(E))),O.filter(E=>!g.has(i.ExtensionIdentifier.toKey(E.identifier)))}}),define(De[68],Ie([1,0,24]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var I;(function(T){T[T.Desktop=1]="Desktop",T[T.Web=2]="Web"})(I=e.UIKind||(e.UIKind={}));var w;(function(T){T[T.VersionMismatch=55]="VersionMismatch",T[T.UnexpectedError=81]="UnexpectedError"})(w=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var M;(function(T){T[T.Initialized=0]="Initialized",T[T.Ready=1]="Ready",T[T.Terminate=2]="Terminate"})(M=e.MessageType||(e.MessageType={}));function D(T){const O=i.VSBuffer.alloc(1);switch(T){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=D;function A(T,O){if(T.byteLength!==1)return!1;switch(T.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var y;(function(T){T.Start="START_NATIVE_LOG",T.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[69],Ie([1,0,3,4,11,26,68,61,158,23,2]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let b=class{constructor(t,s){this.initData=t,this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new I.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0,this._telemetryLoggers=new Map,this._outputLogger=s.createLogger(O.URI.revive(this.initData.environment.extensionTelemetryLogResource)),this._outputLogger.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this._outputLogger.info("===========================================================")}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}instantiateLogger(t,s){const a=this.getTelemetryDetails(),p=new g(s,t,this._outputLogger,this.getBuiltInCommonProperties(t),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled});return this._telemetryLoggers.set(t.identifier.value,p),p.apiTelemetryLogger}$initializeTelemetryLevel(t,s){this._level=t,this._productConfig=s||{usage:!0,error:!0}}getBuiltInCommonProperties(t){const s={};switch(s["common.extname"]=t.name,s["common.extversion"]=t.version,s["common.vscodemachineid"]=this.initData.telemetryInfo.machineId,s["common.vscodesessionid"]=this.initData.telemetryInfo.sessionId,s["common.vscodeversion"]=this.initData.version,s["common.isnewappinstall"]=E(this.initData.telemetryInfo.firstSessionDate),s["common.product"]=this.initData.environment.appHost,this.initData.uiKind){case D.UIKind.Web:s["common.uikind"]="web";break;case D.UIKind.Desktop:s["common.uikind"]="desktop";break;default:s["common.uikind"]="unknown"}return s["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.initData.remote.authority)),s}$onDidChangeTelemetryLevel(t){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=t;const s=this.getTelemetryDetails();this._telemetryLoggers.forEach(a=>{a.updateTelemetryEnablements(s.isUsageEnabled,s.isErrorsEnabled)}),this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}onExtensionError(t,s){const a=this._telemetryLoggers.get(t.value);return a?(a.logError(s),!0):!1}};b=He([$e(0,M.IExtHostInitDataService),$e(1,w.ILoggerService)],b),e.ExtHostTelemetry=b;class g{constructor(t,s,a,p,S){this._extension=s,this._logger=a,this._commonProperties=p,this._onDidChangeEnableStates=new I.Emitter,this._appender=t,this._telemetryEnablements={isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}}updateTelemetryEnablements(t,s){this._apiObject&&(this._telemetryEnablements={isUsageEnabled:t,isErrorsEnabled:s},this._onDidChangeEnableStates.fire(this._apiObject))}mixInCommonPropsAndCleanData(t){return this._appender.ignoreBuiltInCommonProperties||(t=(0,T.mixin)(t,this._commonProperties)),this._appender.additionalCommonProperties&&(t=(0,T.mixin)(t,this._appender.additionalCommonProperties)),t=(0,y.cleanData)(t,[]),t}logEvent(t,s){t=this._extension.identifier.value+"/"+t,s=this.mixInCommonPropsAndCleanData(s||{}),this._appender.logEvent(t,s),this._logger.trace(t,s)}logUsage(t,s){!this._telemetryEnablements.isUsageEnabled||this.logEvent(t,s)}logError(t,s){!this._telemetryEnablements.isErrorsEnabled||(typeof t=="string"?this.logEvent(t,s):this._appender.logException(t,s))}get apiTelemetryLogger(){if(!this._apiObject){const t=this,s={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t._telemetryEnablements.isUsageEnabled},get isErrorsEnabled(){return t._telemetryEnablements.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t._onDidChangeEnableStates.event.bind(t)};this._apiObject=Object.freeze(s)}return this._apiObject}dispose(){this._appender?.flush&&this._appender.flush()}}e.ExtHostTelemetryLogger=g;function E(m){const t=Date.now()-new Date(m).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.isNewAppInstall=E,e.IExtHostTelemetry=(0,i.createDecorator)("IExtHostTelemetry")}),define(De[27],Ie([1,0,4,2,3,25,155]),function(ie,e,i,I,w,M,D){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.webWorkerExtHostLog=e.remoteExtHostLog=e.localExtHostLog=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new M.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");class y{constructor(f){this.affinity=f,this.kind=1}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class T{constructor(f){this.affinity=f,this.kind=2}equals(f){return this.kind===f.kind&&this.affinity===f.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=T;class O{constructor(){this.kind=3,this.affinity=0}equals(f){return this.kind===f.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class b{constructor(f){this.dependency=f}}e.MissingExtensionDependency=b;var g;(function(l){l[l.LocalProcess=1]="LocalProcess",l[l.LocalWebWorker=2]="LocalWebWorker",l[l.Remote=3]="Remote"})(g=e.ExtensionHostKind||(e.ExtensionHostKind={}));function E(l){if(l===null)return"None";switch(l){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=E;class m{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(f,o){const h=[],v=[],k=[],F=[],j=a(this._allExtensions),H=a(f),V=(x,z)=>x.extensionLocation.toString()===z.extensionLocation.toString()||x.isBuiltin===z.isBuiltin||x.isUserBuiltin===z.isUserBuiltin||x.isUnderDevelopment===z.isUnderDevelopment;for(const x of this._allExtensions){const z=H.get(M.ExtensionIdentifier.toKey(x.identifier));if(!z){h.push(x.identifier),j.delete(M.ExtensionIdentifier.toKey(x.identifier));continue}if(!V(x,z)){h.push(x.identifier),j.delete(M.ExtensionIdentifier.toKey(x.identifier));continue}}for(const x of f){const z=j.get(M.ExtensionIdentifier.toKey(x.identifier));if(!z){v.push(x);continue}if(!V(z,x)){h.push(z.identifier),j.delete(M.ExtensionIdentifier.toKey(z.identifier));continue}}const P=s(this._myExtensions),U=s(o);for(const x of this._myExtensions)U.has(M.ExtensionIdentifier.toKey(x))||k.push(x);for(const x of o)P.has(M.ExtensionIdentifier.toKey(x))||F.push(x);const R={toRemove:h,toAdd:v,myToRemove:k,myToAdd:F};return this.delta(R),R}delta(f){const{toRemove:o,toAdd:h,myToRemove:v,myToAdd:k}=f,F=s(o),j=s(v);for(let H=0;H<this._allExtensions.length;H++)F.has(M.ExtensionIdentifier.toKey(this._allExtensions[H].identifier))&&(this._allExtensions.splice(H,1),H--);for(let H=0;H<this._myExtensions.length;H++)j.has(M.ExtensionIdentifier.toKey(this._myExtensions[H]))&&(this._myExtensions.splice(H,1),H--);for(const H of h)this._allExtensions.push(H);for(const H of k)this._myExtensions.push(H)}containsExtension(f){for(const o of this._myExtensions)if(M.ExtensionIdentifier.equals(o,f))return!0;return!1}}e.ExtensionHostExtensions=m;class t{constructor(f){if(this[A]="ExtensionIdentifierSet",this._map=new Map,this._toKey=M.ExtensionIdentifier.toKey,f)for(const o of f)this.add(o)}get size(){return this._map.size}add(f){return this._map.set(this._toKey(f),f),this}clear(){this._map.clear()}delete(f){return this._map.delete(this._toKey(f))}has(f){return this._map.has(this._toKey(f))}forEach(f,o){this._map.forEach(h=>f.call(o,h,h,this))}*entries(){for(const[f,o]of this._map)yield[o,o]}keys(){return this._map.values()}values(){return this._map.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=t;function s(l){const f=new Set;for(const o of l)f.add(M.ExtensionIdentifier.toKey(o));return f}e.extensionIdentifiersArrayToSet=s;function a(l){const f=new Map;for(const o of l)f.set(M.ExtensionIdentifier.toKey(o.identifier),o);return f}function p(l,f){return l.enabledApiProposals?l.enabledApiProposals.includes(f):!1}e.isProposedApiEnabled=p;function S(l,f){if(!p(l,f))throw new Error(`Extension '${l.identifier.value}' CANNOT use API proposal: ${f}.
Its package.json#enabledApiProposals-property declares: ${l.enabledApiProposals?.join(", ")??"[]"} but NOT ${f}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${l.identifier.value}`)}e.checkProposedApiEnabled=S;class u{constructor(f,o,h,v){this.codeLoadingTime=f,this.activateCallTime=o,this.activateResolvedTime=h,this.activationReason=v}}e.ActivationTimes=u;class C{constructor(f,o){this.description=f,this.value=o}}e.ExtensionPointContribution=C,e.ExtensionHostLogFileName="exthost",e.localExtHostLog="extHostLog",e.remoteExtHostLog="remoteExtHostLog",e.webWorkerExtHostLog="webWorkerExtHostLog";var r;(function(l){l[l.Normal=0]="Normal",l[l.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function c(l){return{type:l.isBuiltin?0:1,isBuiltin:l.isBuiltin||l.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(l.publisher,l.name),uuid:l.uuid},manifest:l,location:l.extensionLocation,targetPlatform:l.targetPlatform,validations:[],isValid:!0}}e.toExtension=c;function n(l,f){return{identifier:new M.ExtensionIdentifier((0,D.getExtensionId)(l.manifest.publisher,l.manifest.name)),isBuiltin:l.type===0,isUserBuiltin:l.type===1&&l.isBuiltin,isUnderDevelopment:!!f,extensionLocation:l.location,...l.manifest,uuid:l.identifier.uuid,targetPlatform:l.targetPlatform,browserNlsBundleUris:l.browserNlsBundleUris}}e.toExtensionDescription=n;class d{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None,this.extensions=[]}activateByEvent(f){return Promise.resolve(void 0)}activationEventIsDone(f){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(f){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(f,o){return Promise.resolve(0)}getInspectPorts(f,o){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(f){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(f,o){return Promise.resolve()}}e.NullExtensionService=d}),define(De[180],Ie([1,0,12,25,27,11,15]),function(ie,e,i,I,w,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class A{constructor(s,a,p,S){this.startup=s,this.codeLoadingTime=a,this.activateCallTime=p,this.activateResolvedTime=S}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class y{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,a){return s===-1||a===-1?-1:a-s}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=y;class T{constructor(s,a,p,S,u,C){this.activationFailed=s,this.activationFailedError=a,this.activationTimes=p,this.module=S,this.exports=u,this.subscriptions=C}}e.ActivatedExtension=T;class O extends T{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=O;class b extends T{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class g extends T{constructor(s){super(!0,s,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let E=class{constructor(s,a,p,S,u){this._logService=u,this._registry=s,this._resolvedExtensionsSet=new Set,a.forEach(C=>this._resolvedExtensionsSet.add(I.ExtensionIdentifier.toKey(C))),this._externalExtensionsMap=new Map,p.forEach(C=>this._externalExtensionsMap.set(I.ExtensionIdentifier.toKey(C),C)),this._host=S,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[s,a]of this._operations)a.dispose()}isActivated(s){const a=this._operations.get(I.ExtensionIdentifier.toKey(s));return Boolean(a&&a.value)}getActivatedExtension(s){const a=this._operations.get(I.ExtensionIdentifier.toKey(s));if(!a||!a.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return a.value}async activateByEvent(s,a){if(this._alreadyActivatedEvents[s])return;const p=this._registry.getExtensionDescriptionsForActivationEvent(s);await this._activateExtensions(p.map(S=>({id:S.identifier,reason:{startup:a,extensionId:S.identifier,activationEvent:s}}))),this._alreadyActivatedEvents[s]=!0}activateById(s,a){const p=this._registry.getExtensionDescription(s);if(!p)throw new Error(`Extension '${s}' is not known`);return this._activateExtensions([{id:p.identifier,reason:a}])}async _activateExtensions(s){const a=s.filter(p=>!this.isActivated(p.id)).map(p=>this._handleActivationRequest(p));await Promise.all(a.map(p=>p.wait()))}_handleActivationRequest(s){if(this._operations.has(I.ExtensionIdentifier.toKey(s.id)))return this._operations.get(I.ExtensionIdentifier.toKey(s.id));if(this._externalExtensionsMap.has(I.ExtensionIdentifier.toKey(s.id)))return this._createAndSaveOperation(s,null,[],null);const a=this._registry.getExtensionDescription(s.id);if(!a){const u=new Error(`Cannot activate unknown extension '${s.id.value}'`),C=this._createAndSaveOperation(s,null,[],new g(u));return this._host.onExtensionActivationError(s.id,u,new w.MissingExtensionDependency(s.id.value)),C}const p=[],S=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const u of S){if(this._resolvedExtensionsSet.has(I.ExtensionIdentifier.toKey(u)))continue;const C=this._operations.get(I.ExtensionIdentifier.toKey(u));if(C){p.push(C);continue}if(this._externalExtensionsMap.has(I.ExtensionIdentifier.toKey(u))){p.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(I.ExtensionIdentifier.toKey(u)),reason:s.reason}));continue}const r=this._registry.getExtensionDescription(u);if(r){if(!r.main&&!r.browser)continue;p.push(this._handleActivationRequest({id:r.identifier,reason:s.reason}));continue}const c=a.displayName||a.identifier.value,n=new Error(`Cannot activate the '${c}' extension because it depends on unknown extension '${u}'`),d=this._createAndSaveOperation(s,a.displayName,[],new g(n));return this._host.onExtensionActivationError(a.identifier,n,new w.MissingExtensionDependency(u)),d}return this._createAndSaveOperation(s,a.displayName,p,null)}_createAndSaveOperation(s,a,p,S){const u=new m(s.id,a,s.reason,p,S,this._host,this._logService);return this._operations.set(I.ExtensionIdentifier.toKey(s.id),u),u}};E=He([$e(4,M.ILogService)],E),e.ExtensionsActivator=E;let m=class{get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}constructor(s,a,p,S,u,C,r){this._id=s,this._displayName=a,this._reason=p,this._deps=S,this._value=u,this._host=C,this._logService=r,this._barrier=new D.Barrier,this._isDisposed=!1,this._initialize()}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let s=0;s<this._deps.length;s++){const a=this._deps[s];if(a.value&&!a.value.activationFailed){this._deps.splice(s,1),s--;continue}if(a.value&&a.value.activationFailed){const p=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);p.detail=a.value.activationFailedError,this._value=new g(p),this._host.onExtensionActivationError(this._id,p,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(s=>s.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(s){const a=new Error;if(s&&s.name&&(a.name=s.name),s&&s.message?a.message=`Activating extension '${this._id.value}' failed: ${s.message}.`:a.message=`Activating extension '${this._id.value}' failed: ${s}.`,s&&s.stack&&(a.stack=s.stack),this._value=new g(a),this._isDisposed&&i.isCancellationError(s))return;this._host.onExtensionActivationError(this._id,a,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(s)}}};m=He([$e(6,M.ILogService)],m)}),define(De[181],Ie([1,0,11,26,27]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let M=class extends i.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:w.ExtensionHostLogFileName}))}};M=He([$e(0,i.ILoggerService),$e(1,I.IExtHostInitDataService)],M),e.ExtHostLogService=M});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[6],Ie([1,0,18,12,81,28,79,10,9,2,38,35,90,66,27]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m){"use strict";var t,s,a,p,S,u,C,r,c,n,d,l,f,o,h,v,k,F,j,H,V,P,U;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function R($){return Object.assign($,{apply:function(){const te=arguments.length===1?[]:arguments[1];return Reflect.construct($,te,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct($,[]);{const[te,...Ee]=arguments;return Reflect.construct($,Ee,te.constructor)}}})}let x=u=class{static from(...N){let te=N;return new u(function(){if(te){for(const Ee of te)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();te=void 0}})}constructor(N){t.set(this,void 0),Ye(this,t,N,"f")}dispose(){typeof Ae(this,t,"f")=="function"&&(Ae(this,t,"f").call(this),Ye(this,t,void 0,"f"))}};t=new WeakMap,x=u=He([R],x),e.Disposable=x;let z=C=class{static Min(...N){if(N.length===0)throw new TypeError;let te=N[0];for(let Ee=1;Ee<N.length;Ee++){const Ve=N[Ee];Ve.isBefore(te)&&(te=Ve)}return te}static Max(...N){if(N.length===0)throw new TypeError;let te=N[0];for(let Ee=1;Ee<N.length;Ee++){const Ve=N[Ee];Ve.isAfter(te)&&(te=Ve)}return te}static isPosition(N){if(!N)return!1;if(N instanceof C)return!0;const{line:te,character:Ee}=N;return typeof te=="number"&&typeof Ee=="number"}static of(N){if(N instanceof C)return N;if(this.isPosition(N))return new C(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}constructor(N,te){if(N<0)throw(0,I.illegalArgument)("line must be non-negative");if(te<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=N,this._character=te}isBefore(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<N._character}isBeforeOrEqual(N){return this._line<N._line?!0:N._line<this._line?!1:this._character<=N._character}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this._line===N._line&&this._character===N._character}compareTo(N){return this._line<N._line?-1:this._line>N.line?1:this._character<N._character?-1:this._character>N._character?1:0}translate(N,te=0){if(N===null||te===null)throw(0,I.illegalArgument)();let Ee;return typeof N>"u"?Ee=0:typeof N=="number"?Ee=N:(Ee=typeof N.lineDelta=="number"?N.lineDelta:0,te=typeof N.characterDelta=="number"?N.characterDelta:0),Ee===0&&te===0?this:new C(this.line+Ee,this.character+te)}with(N,te=this.character){if(N===null||te===null)throw(0,I.illegalArgument)();let Ee;return typeof N>"u"?Ee=this.line:typeof N=="number"?Ee=N:(Ee=typeof N.line=="number"?N.line:this.line,te=typeof N.character=="number"?N.character:this.character),Ee===this.line&&te===this.character?this:new C(Ee,te)}toJSON(){return{line:this.line,character:this.character}}};z=C=He([R],z),e.Position=z;let B=r=class{static isRange(N){return N instanceof r?!0:N?z.isPosition(N.start)&&z.isPosition(N.end):!1}static of(N){if(N instanceof r)return N;if(this.isRange(N))return new r(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}constructor(N,te,Ee,Ve){let Qe,lt;if(typeof N=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(Qe=new z(N,te),lt=new z(Ee,Ve)):z.isPosition(N)&&z.isPosition(te)&&(Qe=z.of(N),lt=z.of(te)),!Qe||!lt)throw new Error("Invalid arguments");Qe.isBefore(lt)?(this._start=Qe,this._end=lt):(this._start=lt,this._end=Qe)}contains(N){return r.isRange(N)?this.contains(N.start)&&this.contains(N.end):z.isPosition(N)?!(z.of(N).isBefore(this._start)||this._end.isBefore(N)):!1}isEqual(N){return this._start.isEqual(N._start)&&this._end.isEqual(N._end)}intersection(N){const te=z.Max(N.start,this._start),Ee=z.Min(N.end,this._end);if(!te.isAfter(Ee))return new r(te,Ee)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const te=z.Min(N.start,this._start),Ee=z.Max(N.end,this.end);return new r(te,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(N,te=this.end){if(N===null||te===null)throw(0,I.illegalArgument)();let Ee;return N?z.isPosition(N)?Ee=N:(Ee=N.start||this.start,te=N.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&te.isEqual(this.end)?this:new r(Ee,te)}toJSON(){return[this.start,this.end]}};B=r=He([R],B),e.Range=B;let K=c=class extends B{static isSelection(N){return N instanceof c?!0:N?B.isRange(N)&&z.isPosition(N.anchor)&&z.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}constructor(N,te,Ee,Ve){let Qe,lt;if(typeof N=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"?(Qe=new z(N,te),lt=new z(Ee,Ve)):z.isPosition(N)&&z.isPosition(te)&&(Qe=z.of(N),lt=z.of(te)),!Qe||!lt)throw new Error("Invalid arguments");super(Qe,lt),this._anchor=Qe,this._active=lt}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};K=c=He([R],K),e.Selection=K;class Z{constructor(N,te,Ee){if(typeof N!="string"||N.length===0)throw(0,I.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,I.illegalArgument)("port");if(typeof Ee<"u"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,I.illegalArgument)("connectionToken");this.host=N,this.port=Math.round(te),this.connectionToken=Ee}}e.ResolvedAuthority=Z;class ue extends Error{static NotAvailable(N,te){return new ue(N,g.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(N){return new ue(N,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,te=g.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(N),this._message=N,this._code=te,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ue.prototype)}}e.RemoteAuthorityResolverError=ue;var ne;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(ne=e.EndOfLine||(e.EndOfLine={}));var pe;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(pe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ae=n=class{static isTextEdit(N){return N instanceof n?!0:N?B.isRange(N)&&typeof N.newText=="string":!1}static replace(N,te){return new n(N,te)}static insert(N,te){return n.replace(new B(N,N),te)}static delete(N){return n.replace(N,"")}static setEndOfLine(N){const te=new n(new B(new z(0,0),new z(0,0)),"");return te.newEol=N,te}get range(){return this._range}set range(N){if(N&&!B.isRange(N))throw(0,I.illegalArgument)("range");this._range=N}get newText(){return this._newText||""}set newText(N){if(N&&typeof N!="string")throw(0,I.illegalArgument)("newText");this._newText=N}get newEol(){return this._newEol}set newEol(N){if(N&&typeof N!="number")throw(0,I.illegalArgument)("newEol");this._newEol=N}constructor(N,te){this._range=N,this._newText=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ae=n=He([R],ae),e.TextEdit=ae;let de=d=class{static isNotebookCellEdit(N){return N instanceof d?!0:N?jt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,te){return new d(N,te)}static insertCells(N,te){return new d(new jt(N,N),te)}static deleteCells(N){return new d(N,[])}static updateCellMetadata(N,te){const Ee=new d(new jt(N,N),[]);return Ee.newCellMetadata=te,Ee}static updateNotebookMetadata(N){const te=new d(new jt(0,0),[]);return te.newNotebookMetadata=N,te}constructor(N,te){this.range=N,this.newCells=te}};de=d=He([R],de),e.NotebookEdit=de;class Y{static isSnippetTextEdit(N){return N instanceof Y?!0:N?B.isRange(N.range)&&Oe.isSnippetString(N.snippet):!1}static replace(N,te){return new Y(N,te)}static insert(N,te){return Y.replace(new B(N,N),te)}constructor(N,te){this.range=N,this.snippet=te}}e.SnippetTextEdit=Y;var me;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(me=e.FileEditType||(e.FileEditType={}));let Se=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(N,te,Ee,Ve){this._edits.push({_type:1,from:N,to:te,options:Ee,metadata:Ve})}createFile(N,te,Ee){this._edits.push({_type:1,from:void 0,to:N,options:te,metadata:Ee})}deleteFile(N,te,Ee){this._edits.push({_type:1,from:N,to:void 0,options:te,metadata:Ee})}replaceNotebookMetadata(N,te,Ee){this._edits.push({_type:3,metadata:Ee,uri:N,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(N,te,Ee,Ve){const Qe=te.start,lt=te.end;(Qe!==lt||Ee.length>0)&&this._edits.push({_type:5,uri:N,index:Qe,count:lt-Qe,cells:Ee,metadata:Ve})}replaceNotebookCellMetadata(N,te,Ee,Ve){this._edits.push({_type:3,metadata:Ve,uri:N,edit:{editType:8,index:te,metadata:Ee}})}replace(N,te,Ee,Ve){this._edits.push({_type:2,uri:N,edit:new ae(te,Ee),metadata:Ve})}insert(N,te,Ee,Ve){this.replace(N,new B(te,te),Ee,Ve)}delete(N,te,Ee){this.replace(N,te,"",Ee)}has(N){return this._edits.some(te=>te._type===2&&te.uri.toString()===N.toString())}set(N,te){if(te)for(const Ee of te){if(!Ee)continue;let Ve,Qe;Array.isArray(Ee)?(Ve=Ee[0],Qe=Ee[1]):Ve=Ee,de.isNotebookCellEdit(Ve)?Ve.newCellMetadata?this.replaceNotebookCellMetadata(N,Ve.range.start,Ve.newCellMetadata,Qe):Ve.newNotebookMetadata?this.replaceNotebookMetadata(N,Ve.newNotebookMetadata,Qe):this.replaceNotebookCells(N,Ve.range,Ve.newCells,Qe):Y.isSnippetTextEdit(Ve)?this._edits.push({_type:6,uri:N,range:Ve.range,edit:Ve.snippet,metadata:Qe}):this._edits.push({_type:2,uri:N,edit:Ve,metadata:Qe})}else{for(let Ee=0;Ee<this._edits.length;Ee++){const Ve=this._edits[Ee];switch(Ve._type){case 2:case 6:case 3:case 5:Ve.uri.toString()===N.toString()&&(this._edits[Ee]=void 0);break}}(0,i.coalesceInPlace)(this._edits)}}get(N){const te=[];for(const Ee of this._edits)Ee._type===2&&Ee.uri.toString()===N.toString()&&te.push(Ee.edit);return te}entries(){const N=new M.ResourceMap;for(const te of this._edits)if(te._type===2){let Ee=N.get(te.uri);Ee||(Ee=[te.uri,[]],N.set(te.uri,Ee)),Ee[1].push(te.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Se=He([R],Se),e.WorkspaceEdit=Se;let Oe=l=class{static isSnippetString(N){return N instanceof l?!0:N?typeof N.value=="string":!1}static _escape(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this._tabstop=1,this.value=N||""}appendText(N){return this.value+=l._escape(N),this}appendTabstop(N=this._tabstop++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,te=this._tabstop++){if(typeof N=="function"){const Ee=new l;Ee._tabstop=this._tabstop,N(Ee),this._tabstop=Ee._tabstop,N=Ee.value}else N=l._escape(N);return this.value+="${",this.value+=te,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,te=this._tabstop++){const Ee=N.map(Ve=>Ve.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(N,te){if(typeof te=="function"){const Ee=new l;Ee._tabstop=this._tabstop,te(Ee),this._tabstop=Ee._tabstop,te=Ee.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,te&&(this.value+=":",this.value+=te),this.value+="}",this}};Oe=l=He([R],Oe),e.SnippetString=Oe;var Be;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(Be=e.DiagnosticTag||(e.DiagnosticTag={}));var Xe;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(Xe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ke=f=class{static isLocation(N){return N instanceof f?!0:N?B.isRange(N.range)&&T.URI.isUri(N.uri):!1}constructor(N,te){if(this.uri=N,te)if(B.isRange(te))this.range=B.of(te);else if(z.isPosition(te))this.range=new B(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ke=f=He([R],ke),e.Location=ke;let ye=class{static is(N){return N?typeof N.message=="string"&&N.location&&B.isRange(N.location.range)&&T.URI.isUri(N.location.uri):!1}constructor(N,te){this.location=N,this.message=te}static isEqual(N,te){return N===te?!0:!N||!te?!1:N.message===te.message&&N.location.range.isEqual(te.location.range)&&N.location.uri.toString()===te.location.uri.toString()}};ye=He([R],ye),e.DiagnosticRelatedInformation=ye;let Ce=class{constructor(N,te,Ee=Xe.Error){if(!B.isRange(N))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=N,this.message=te,this.severity=Ee}toJSON(){return{severity:Xe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,te){return N===te?!0:!N||!te?!1:N.message===te.message&&N.severity===te.severity&&N.code===te.code&&N.severity===te.severity&&N.source===te.source&&N.range.isEqual(te.range)&&(0,i.equals)(N.tags,te.tags)&&(0,i.equals)(N.relatedInformation,te.relatedInformation,ye.isEqual)}};Ce=He([R],Ce),e.Diagnostic=Ce;let se=class{constructor(N,te){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=te}};se=He([R],se),e.Hover=se;var le;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let J=class{constructor(N,te=le.Text){this.range=N,this.kind=te}toJSON(){return{range:this.range,kind:le[this.kind]}}};J=He([R],J),e.DocumentHighlight=J;var _;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(_=e.SymbolKind||(e.SymbolKind={}));var L;(function($){$[$.Deprecated=1]="Deprecated"})(L=e.SymbolTag||(e.SymbolTag={}));let W=o=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,te,Ee,Ve,Qe){this.name=N,this.kind=te,this.containerName=Qe,typeof Ee=="string"&&(this.containerName=Ee),Ve instanceof ke?this.location=Ve:Ee instanceof B&&(this.location=new ke(Ve,Ee)),o.validate(this)}toJSON(){return{name:this.name,kind:_[this.kind],location:this.location,containerName:this.containerName}}};W=o=He([R],W),e.SymbolInformation=W;let q=h=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(h.validate)}constructor(N,te,Ee,Ve,Qe){this.name=N,this.detail=te,this.kind=Ee,this.range=Ve,this.selectionRange=Qe,this.children=[],h.validate(this)}};q=h=He([R],q),e.DocumentSymbol=q;var ee;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ce=class{constructor(N,te){this.title=N,this.kind=te}};ce=He([R],ce),e.CodeAction=ce;let be=v=class{constructor(N){this.value=N}append(N){return new v(this.value?this.value+v.sep+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+v.sep)}};be.sep=".",be=v=He([R],be),e.CodeActionKind=be,be.Empty=new be(""),be.QuickFix=be.Empty.append("quickfix"),be.Refactor=be.Empty.append("refactor"),be.RefactorExtract=be.Refactor.append("extract"),be.RefactorInline=be.Refactor.append("inline"),be.RefactorMove=be.Refactor.append("move"),be.RefactorRewrite=be.Refactor.append("rewrite"),be.Source=be.Empty.append("source"),be.SourceOrganizeImports=be.Source.append("organizeImports"),be.SourceFixAll=be.Source.append("fixAll");let oe=class{constructor(N,te){if(this.range=N,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};oe=He([R],oe),e.SelectionRange=oe;class we{constructor(N,te,Ee,Ve,Qe,lt){this.kind=N,this.name=te,this.detail=Ee,this.uri=Ve,this.range=Qe,this.selectionRange=lt}}e.CallHierarchyItem=we;class ve{constructor(N,te){this.fromRanges=te,this.from=N}}e.CallHierarchyIncomingCall=ve;class Ue{constructor(N,te){this.fromRanges=te,this.to=N}}e.CallHierarchyOutgoingCall=Ue;var ze;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(ze=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let et=class{constructor(N,te){this.range=N,this.command=te}get isResolved(){return!!this.command}};et=He([R],et),e.CodeLens=et;let Ke=k=class{static isMarkdownString(N){return N instanceof k?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,te=!1){s.set(this,void 0),Ye(this,s,new w.MarkdownString(N,{supportThemeIcons:te}),"f")}get value(){return Ae(this,s,"f").value}set value(N){Ae(this,s,"f").value=N}get isTrusted(){return Ae(this,s,"f").isTrusted}set isTrusted(N){Ae(this,s,"f").isTrusted=N}get supportThemeIcons(){return Ae(this,s,"f").supportThemeIcons}set supportThemeIcons(N){Ae(this,s,"f").supportThemeIcons=N}get supportHtml(){return Ae(this,s,"f").supportHtml}set supportHtml(N){Ae(this,s,"f").supportHtml=N}get baseUri(){return Ae(this,s,"f").baseUri}set baseUri(N){Ae(this,s,"f").baseUri=N}appendText(N){return Ae(this,s,"f").appendText(N),this}appendMarkdown(N){return Ae(this,s,"f").appendMarkdown(N),this}appendCodeblock(N,te){return Ae(this,s,"f").appendCodeblock(te??"",N),this}};s=new WeakMap,Ke=k=He([R],Ke),e.MarkdownString=Ke;let tt=class{constructor(N,te){this.label=N,this.documentation=te}};tt=He([R],tt),e.ParameterInformation=tt;let Fe=class{constructor(N,te){this.label=N,this.documentation=te,this.parameters=[]}};Fe=He([R],Fe),e.SignatureInformation=Fe;let ht=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ht=He([R],ht),e.SignatureHelp=ht;var X;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(X=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Q;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(Q=e.InlayHintKind||(e.InlayHintKind={}));let ge=class{constructor(N){this.value=N}};ge=He([R],ge),e.InlayHintLabelPart=ge;let Ne=class{constructor(N,te,Ee){this.position=N,this.label=te,this.kind=Ee}};Ne=He([R],Ne),e.InlayHint=Ne;var je;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var qe;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(qe=e.CompletionItemKind||(e.CompletionItemKind={}));var We;(function($){$[$.Deprecated=1]="Deprecated"})(We=e.CompletionItemTag||(e.CompletionItemTag={}));let Ze=class{constructor(N,te){this.label=N,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&qe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ze=He([R],Ze),e.CompletionItem=Ze;let nt=class{constructor(N=[],te=!1){this.items=N,this.isIncomplete=te}};nt=He([R],nt),e.CompletionList=nt;let ct=class{constructor(N,te,Ee){this.insertText=N,this.range=te,this.command=Ee}};ct=He([R],ct),e.InlineSuggestion=ct;let It=class{constructor(N){this.commands=void 0,this.items=N}};It=He([R],It),e.InlineSuggestionList=It;var at;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(at=e.ViewColumn||(e.ViewColumn={}));var rt;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Lt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(Lt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var At;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(At=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var kt;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(kt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var yt;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(yt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function N(te){switch(te){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=N}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Rt=class{constructor(N,te){if(te&&!T.URI.isUri(te))throw(0,I.illegalArgument)("target");if(!B.isRange(N)||N.isEmpty)throw(0,I.illegalArgument)("range");this.range=N,this.target=te}};Rt=He([R],Rt),e.DocumentLink=Rt;let Ge=class{constructor(N,te,Ee,Ve){this.red=N,this.green=te,this.blue=Ee,this.alpha=Ve}};Ge=He([R],Ge),e.Color=Ge;let Ct=class{constructor(N,te){if(te&&!(te instanceof Ge))throw(0,I.illegalArgument)("color");if(!B.isRange(N)||N.isEmpty)throw(0,I.illegalArgument)("range");this.range=N,this.color=te}};Ct=He([R],Ct),e.ColorInformation=Ct;let Ot=class{constructor(N){if(!N||typeof N!="string")throw(0,I.illegalArgument)("label");this.label=N}};Ot=He([R],Ot),e.ColorPresentation=Ot;var Bt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(Bt=e.ColorFormat||(e.ColorFormat={}));var pt;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(pt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var _e;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(_e=e.TerminalExitReason||(e.TerminalExitReason={}));class Te{constructor(N,te,Ee){if(this.startIndex=N,this.length=te,this.tooltip=Ee,typeof N!="number"||N<0)throw(0,I.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,I.illegalArgument)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,I.illegalArgument)("tooltip")}}e.TerminalLink=Te;var fe;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(fe=e.TerminalLocation||(e.TerminalLocation={}));class G{constructor(N){if(this.options=N,typeof N!="object")throw(0,I.illegalArgument)("options")}}e.TerminalProfile=G;var Pe;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(Pe=e.TaskRevealKind||(e.TaskRevealKind={}));var Me;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(Me=e.TaskPanelKind||(e.TaskPanelKind={}));let Je=F=class{static from(N){switch(N){case"clean":return F.Clean;case"build":return F.Build;case"rebuild":return F.Rebuild;case"test":return F.Test;default:return}}constructor(N,te){if(this.label=te,typeof N!="string"||typeof te!="string")throw(0,I.illegalArgument)("name");this._id=N}get id(){return this._id}};Je.Clean=new F("clean","Clean"),Je.Build=new F("build","Build"),Je.Rebuild=new F("rebuild","Rebuild"),Je.Test=new F("test","Test"),Je=F=He([R],Je),e.TaskGroup=Je;function xe($){let N="";for(let te=0;te<$.length;te++)N+=$[te].replace(/,/g,",,")+",";return N}let it=class{constructor(N,te,Ee){if(typeof N!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=N,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=Ee):this._options=te)}get process(){return this._process}set process(N){if(typeof N!="string")throw(0,I.illegalArgument)("process");this._process=N}get args(){return this._args}set args(N){Array.isArray(N)||(N=[]),this._args=N}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("process"),this._process!==void 0&&N.push(this._process),this._args&&this._args.length>0)for(const te of this._args)N.push(te);return xe(N)}};it=He([R],it),e.ProcessExecution=it;let ot=class{constructor(N,te,Ee){if(this._args=[],Array.isArray(te)){if(!N)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,I.illegalArgument)("command");this._command=N,this._args=te,this._options=Ee}else{if(typeof N!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=N,this._options=te}}get commandLine(){return this._commandLine}set commandLine(N){if(typeof N!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=N}get command(){return this._command?this._command:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,I.illegalArgument)("command");this._command=N}get args(){return this._args}set args(N){this._args=N||[]}get options(){return this._options}set options(N){this._options=N}computeId(){const N=[];if(N.push("shell"),this._commandLine!==void 0&&N.push(this._commandLine),this._command!==void 0&&N.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const te of this._args)N.push(typeof te=="string"?te:te.value);return xe(N)}};ot=He([R],ot),e.ShellExecution=ot;var Tt;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(Tt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class _t{constructor(N){this._callback=N}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(N){this._callback=N}get callback(){return this._callback}}e.CustomExecution=_t;let vt=j=class{constructor(N,te,Ee,Ve,Qe,lt){this.__deprecated=!1,this._definition=this.definition=N;let dt;typeof te=="string"?(this._name=this.name=te,this._source=this.source=Ee,this.execution=Ve,dt=Qe,this.__deprecated=!0):te===Et.Global||te===Et.Workspace?(this.target=te,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=Qe,dt=lt):(this.target=te,this._name=this.name=Ee,this._source=this.source=Ve,this.execution=Qe,dt=lt),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(N){this.__id=N}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof it?this._definition={type:j.ProcessType,id:this._execution.computeId()}:this._execution instanceof ot?this._definition={type:j.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:j.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:j.EmptyType,id:(0,O.generateUuid)()}}get definition(){return this._definition}set definition(N){if(N==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=N}get scope(){return this._scope}set target(N){this.clear(),this._scope=N}get name(){return this._name}set name(N){if(typeof N!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=N}get execution(){return this._execution}set execution(N){N===null&&(N=void 0),this.clear(),this._execution=N;const te=this._definition.type;(j.EmptyType===te||j.ProcessType===te||j.ShellType===te||j.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(N){if(Array.isArray(N))this.clear(),this._problemMatchers=N,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.clear(),this._isBackground=N}get source(){return this._source}set source(N){if(typeof N!="string"||N.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=N}get group(){return this._group}set group(N){N===null&&(N=void 0),this.clear(),this._group=N}get detail(){return this._detail}set detail(N){N===null&&(N=void 0),this._detail=N}get presentationOptions(){return this._presentationOptions}set presentationOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._presentationOptions=N}get runOptions(){return this._runOptions}set runOptions(N){N==null&&(N=Object.create(null)),this.clear(),this._runOptions=N}};vt.ExtensionCallbackType="customExecution",vt.ProcessType="process",vt.ShellType="shell",vt.EmptyType="$empty",vt=j=He([R],vt),e.Task=vt;var Ft;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})(Ft=e.ProgressLocation||(e.ProgressLocation={}));var mt;(function($){function N(te){const Ee=te;return(0,y.isNumber)(Ee.value)?Ee.tooltip&&!(0,y.isString)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}$.isViewBadge=N})(mt=e.ViewBadge||(e.ViewBadge={}));let Mt=H=class{static isTreeItem(N,te){if(N instanceof H)return!0;const Ee=N;if(Ee.label!==void 0&&!(0,y.isString)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,y.isString)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,y.isString)(Ee.iconPath)&&!T.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,y.isString)(Ee.iconPath.id))){const Ve=Ee.iconPath;if(!Ve||!(0,y.isString)(Ve.light)&&!T.URI.isUri(Ve.light)&&!(0,y.isString)(Ve.dark)&&!T.URI.isUri(Ve.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}if(Ee.description!==void 0&&!(0,y.isString)(Ee.description)&&typeof Ee.description!="boolean")return console.log("INVALID tree item, invalid description",Ee.description),!1;if(Ee.resourceUri!==void 0&&!T.URI.isUri(Ee.resourceUri))return console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1;if(Ee.tooltip!==void 0&&!(0,y.isString)(Ee.tooltip)&&!(Ee.tooltip instanceof Ke))return console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1;if(Ee.command!==void 0&&!Ee.command.command)return console.log("INVALID tree item, invalid command",Ee.command),!1;if(Ee.collapsibleState!==void 0&&Ee.collapsibleState<Kt.None&&Ee.collapsibleState>Kt.Expanded)return console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1;if(Ee.contextValue!==void 0&&!(0,y.isString)(Ee.contextValue))return console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1;if(Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1;if(Ee.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(te,"treeItemCheckbox");const Ve=(0,y.isNumber)(Ee.checkboxState)?Ee.checkboxState:(0,y.isObject)(Ee.checkboxState)&&(0,y.isNumber)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Qe=!(0,y.isNumber)(Ee.checkboxState)&&(0,y.isObject)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ve===void 0||Ve!==bt.Checked&&Ve!==bt.Unchecked||Qe!==void 0&&!(0,y.isString)(Qe))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}return!0}constructor(N,te=Kt.None){this.collapsibleState=te,T.URI.isUri(N)?this.resourceUri=N:this.label=N}};Mt=H=He([R],Mt),e.TreeItem=Mt;var Kt;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(Kt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var bt;(function($){$[$.Unchecked=0]="Unchecked",$[$.Checked=1]="Checked"})(bt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Ht=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N,te){this.value=N,this.id=te??(0,O.generateUuid)()}};Ht=He([R],Ht),e.DataTransferItem=Ht;let ni=class{constructor(N){a.set(this,new Map);for(const[te,Ee]of N??[]){const Ve=Ae(this,a,"f").get(te);Ve?Ve.push(Ee):Ae(this,a,"f").set(te,[Ee])}}get(N){return Ae(this,a,"f").get(N)?.[0]}set(N,te){Ae(this,a,"f").set(N,[te])}forEach(N,te){for(const[Ee,Ve]of Ae(this,a,"f"))for(const Qe of Ve)N.call(te,Qe,Ee,this)}*[(a=new WeakMap,Symbol.iterator)](){for(const[N,te]of Ae(this,a,"f"))for(const Ee of te)yield[N,Ee]}};ni=He([R],ni),e.DataTransfer=ni;let ri=class{constructor(N){this.insertText=N}};ri=He([R],ri),e.DocumentDropEdit=ri;let mi=class{constructor(N){this.insertText=N}};mi=He([R],mi),e.DocumentPasteEdit=mi;let St=class{constructor(N,te){this.id=N,this.color=te}};St=He([R],St),e.ThemeIcon=St,St.File=new St("file"),St.Folder=new St("folder");let si=class{constructor(N){this.id=N}};si=He([R],si),e.ThemeColor=si;var Ai;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(Ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Jt=class{get base(){return this._base}set base(N){this._base=N,this._baseUri=T.URI.file(N)}get baseUri(){return this._baseUri}set baseUri(N){this._baseUri=N,this._base=N.fsPath}constructor(N,te){if(typeof N!="string"&&(!N||!T.URI.isUri(N)&&!T.URI.isUri(N.uri)))throw(0,I.illegalArgument)("base");if(typeof te!="string")throw(0,I.illegalArgument)("pattern");typeof N=="string"?this.baseUri=T.URI.file(N):T.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Jt=He([R],Jt),e.RelativePattern=Jt;let zt=class{constructor(N,te,Ee,Ve){this.enabled=typeof N=="boolean"?N:!0,typeof te=="string"&&(this.condition=te),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ve=="string"&&(this.logMessage=Ve)}get id(){return this._id||(this._id=(0,O.generateUuid)()),this._id}};zt=He([R],zt),e.Breakpoint=zt;let ut=class extends zt{constructor(N,te,Ee,Ve,Qe){if(super(te,Ee,Ve,Qe),N===null)throw(0,I.illegalArgument)("location");this.location=N}};ut=He([R],ut),e.SourceBreakpoint=ut;let gi=class extends zt{constructor(N,te,Ee,Ve,Qe){super(te,Ee,Ve,Qe),this.functionName=N}};gi=He([R],gi),e.FunctionBreakpoint=gi;let $t=class extends zt{constructor(N,te,Ee,Ve,Qe,lt,dt){if(super(Ve,Qe,lt,dt),!te)throw(0,I.illegalArgument)("dataId");this.label=N,this.dataId=te,this.canPersist=Ee}};$t=He([R],$t),e.DataBreakpoint=$t;let Gt=class{constructor(N,te,Ee){this.command=N,this.args=te||[],this.options=Ee}};Gt=He([R],Gt),e.DebugAdapterExecutable=Gt;let oi=class{constructor(N,te){this.port=N,this.host=te}};oi=He([R],oi),e.DebugAdapterServer=oi;let pi=class{constructor(N){this.path=N}};pi=He([R],pi),e.DebugAdapterNamedPipeServer=pi;let ai=class{constructor(N){this.implementation=N}};ai=He([R],ai),e.DebugAdapterInlineImplementation=ai;let vi=class{constructor(N,te){this.range=N,this.expression=te}};vi=He([R],vi),e.EvaluatableExpression=vi;var Di;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Di=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Zt=class{constructor(N,te){this.range=N,this.text=te}};Zt=He([R],Zt),e.InlineValueText=Zt;let Ei=class{constructor(N,te,Ee=!0){this.range=N,this.variableName=te,this.caseSensitiveLookup=Ee}};Ei=He([R],Ei),e.InlineValueVariableLookup=Ei;let ei=class{constructor(N,te){this.range=N,this.expression=te}};ei=He([R],ei),e.InlineValueEvaluatableExpression=ei;let ti=class{constructor(N,te){this.frameId=N,this.stoppedLocation=te}};ti=He([R],ti),e.InlineValueContext=ti;var Ri;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Ri=e.FileChangeType||(e.FileChangeType={}));let bi=V=class extends Error{static FileExists(N){return new V(N,b.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(N){return new V(N,b.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(N){return new V(N,b.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(N){return new V(N,b.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(N){return new V(N,b.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(N){return new V(N,b.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(N,te=b.FileSystemProviderErrorCode.Unknown,Ee){super(T.URI.isUri(N)?N.toString(!0):N),this.code=Ee?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};bi=V=He([R],bi),e.FileSystemError=bi;let Xt=class{constructor(N,te,Ee){this.start=N,this.end=te,this.kind=Ee}};Xt=He([R],Xt),e.FoldingRange=Xt;var Oi;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Oi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Fi;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Li;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Li=e.CommentMode||(e.CommentMode={}));var Mi;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})(Mi=e.CommentThreadState||(e.CommentThreadState={}));class wi{constructor(N,te=[]){this.tokenTypes=N,this.tokenModifiers=te}}e.SemanticTokensLegend=wi;function Ii($){return typeof $>"u"||(0,y.isStringArray)($)}class li{constructor(N){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,N){this._hasLegend=!0;for(let te=0,Ee=N.tokenTypes.length;te<Ee;te++)this._tokenTypeStrToInt.set(N.tokenTypes[te],te);for(let te=0,Ee=N.tokenModifiers.length;te<Ee;te++)this._tokenModifierStrToInt.set(N.tokenModifiers[te],te)}}push(N,te,Ee,Ve,Qe){if(typeof N=="number"&&typeof te=="number"&&typeof Ee=="number"&&typeof Ve=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this._pushEncoded(N,te,Ee,Ve,Qe);if(B.isRange(N)&&typeof te=="string"&&Ii(Ee))return this._push(N,te,Ee);throw(0,I.illegalArgument)()}_push(N,te,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const Ve=N.start.line,Qe=N.start.character,lt=N.end.character-N.start.character,dt=this._tokenTypeStrToInt.get(te);let Pt=0;if(Ee)for(const xt of Ee){if(!this._tokenModifierStrToInt.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(xt);Pt|=1<<Wt>>>0}this._pushEncoded(Ve,Qe,lt,dt,Pt)}_pushEncoded(N,te,Ee,Ve,Qe){if(this._dataIsSortedAndDeltaEncoded&&(N<this._prevLine||N===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let xt=0,Wt=0;for(let qt=0;qt<Pt;qt++){let Qt=this._data[5*qt],_i=this._data[5*qt+1];Qt===0?(Qt=xt,_i+=Wt):Qt+=xt,this._data[5*qt]=Qt,this._data[5*qt+1]=_i,xt=Qt,Wt=_i}}let lt=N,dt=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(lt-=this._prevLine,lt===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=lt,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=Ve,this._data[this._dataLen++]=Qe,this._prevLine=N,this._prevChar=te}static _sortAndDeltaEncode(N){const te=[],Ee=N.length/5|0;for(let dt=0;dt<Ee;dt++)te[dt]=dt;te.sort((dt,Pt)=>{const xt=N[5*dt],Wt=N[5*Pt];if(xt===Wt){const qt=N[5*dt+1],Qt=N[5*Pt+1];return qt-Qt}return xt-Wt});const Ve=new Uint32Array(N.length);let Qe=0,lt=0;for(let dt=0;dt<Ee;dt++){const Pt=5*te[dt],xt=N[Pt+0],Wt=N[Pt+1],qt=N[Pt+2],Qt=N[Pt+3],_i=N[Pt+4],Yi=xt-Qe,_n=Yi===0?Wt-lt:Wt,yi=5*dt;Ve[yi+0]=Yi,Ve[yi+1]=_n,Ve[yi+2]=qt,Ve[yi+3]=Qt,Ve[yi+4]=_i,Qe=xt,lt=Wt}return Ve}build(N){return this._dataIsSortedAndDeltaEncoded?new Le(new Uint32Array(this._data),N):new Le(li._sortAndDeltaEncode(this._data),N)}}e.SemanticTokensBuilder=li;class Le{constructor(N,te){this.resultId=te,this.data=N}}e.SemanticTokens=Le;class Vt{constructor(N,te,Ee){this.start=N,this.deleteCount=te,this.data=Ee}}e.SemanticTokensEdit=Vt;class Ci{constructor(N,te){this.resultId=te,this.edits=N}}e.SemanticTokensEdits=Ci;var gt;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(gt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ci=class{constructor(){}};ci.Back={iconPath:new St("arrow-left")},ci=He([R],ci),e.QuickInputButtons=ci;var Ni;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ti;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(Ti=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Ui;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(Ui=e.ExtensionKind||(e.ExtensionKind={}));class ui{static validate(N){if(N.badge){let te=(0,A.nextCharLength)(N.badge,0);if(te<N.badge.length&&(te+=(0,A.nextCharLength)(N.badge,te)),N.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,te,Ee){this.badge=N,this.tooltip=te,this.color=Ee}}e.FileDecoration=ui;let Si=class{constructor(N){this.kind=N}};Si=He([R],Si),e.ColorTheme=Si;var Bi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(Bi=e.ColorThemeKind||(e.ColorThemeKind={}));class jt{static isNotebookRange(N){return N instanceof jt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}constructor(N,te){if(N<0)throw(0,I.illegalArgument)("start must be positive");if(te<0)throw(0,I.illegalArgument)("end must be positive");N<=te?(this._start=N,this._end=te):(this._start=te,this._end=N)}with(N){let te=this._start,Ee=this._end;return N.start!==void 0&&(te=N.start),N.end!==void 0&&(Ee=N.end),te===this._start&&Ee===this._end?this:new jt(te,Ee)}}e.NotebookRange=jt;class ii{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(te=>ii.isNotebookCellData(te))}static isNotebookCellData(N){return!0}constructor(N,te,Ee,Ve,Qe,lt,dt){this.kind=N,this.value=te,this.languageId=Ee,this.mime=Ve,this.outputs=Qe??[],this.metadata=lt,this.executionSummary=dt,ii.validate(this)}}e.NotebookCellData=ii;class xi{constructor(N){this.cells=N}}e.NotebookData=xi;class Nt{static isNotebookCellOutputItem(N){return N instanceof Nt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const te={name:N.name,message:N.message,stack:N.stack};return Nt.json(te,"application/vnd.code.notebook.error")}static stdout(N){return Nt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Nt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,te="application/octet-stream"){return new Nt(N,te)}static text(N,te=D.Mimes.text){const Ee=Ae(Nt,p,"f",S).encode(String(N));return new Nt(Ee,te)}static json(N,te="text/x-json"){const Ee=JSON.stringify(N,void 0,"	");return Nt.text(Ee,te)}constructor(N,te){this.data=N,this.mime=te;const Ee=(0,D.normalizeMimeType)(te,!0);if(!Ee)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.NotebookCellOutputItem=Nt,p=Nt,S={value:new TextEncoder};class di{static isNotebookCellOutput(N){return N instanceof di?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,te=!1){const Ee=new Set,Ve=new Set;for(let Qe=0;Qe<N.length;Qe++){const lt=N[Qe],dt=(0,D.normalizeMimeType)(lt.mime);if(!Ee.has(dt)||(0,E.isTextStreamMime)(dt)){Ee.add(dt);continue}Ve.add(Qe),te&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ve.size===0?N:N.filter((Qe,lt)=>!Ve.has(lt))}constructor(N,te,Ee){this.items=di.ensureUniqueMimeTypes(N,!0),typeof te=="string"?(this.id=te,this.metadata=Ee):(this.id=(0,O.generateUuid)(),this.metadata=te??Ee)}}e.NotebookCellOutput=di;var zi;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(zi=e.NotebookCellKind||(e.NotebookCellKind={}));var $i;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})($i=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Wi;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Wi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var re;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(re=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class he{constructor(N,te){this.text=N,this.alignment=te}}e.NotebookCellStatusBarItem=he;var Re;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(Re=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var st;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred",$[$.Hidden=-1]="Hidden"})(st=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class wt{constructor(N,te=[]){this.uri=N,this.provides=(0,i.asArray)(te)}}e.NotebookRendererScript=wt;let Dt=class{constructor(N,te){this.label=N,this.timestamp=te}};Dt=He([R],Dt),e.TimelineItem=Dt;var tn;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(tn=e.ExtensionMode||(e.ExtensionMode={}));var nn;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(nn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var rn;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(rn=e.StandardTokenType||(e.StandardTokenType={}));class sn{constructor(N,te){this.ranges=N,this.wordPattern=te}}e.LinkedEditingRanges=sn;class on{constructor(N,te){this._port=N,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=on;var an;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(an=e.TestResultState||(e.TestResultState={}));var ln;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(ln=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Hi=class{constructor(N=void 0,te=void 0,Ee=void 0){this.include=N,this.exclude=te,this.profile=Ee}};Hi=He([R],Hi),e.TestRunRequest=Hi;let Vi=P=class{static diff(N,te,Ee){const Ve=new P(N);return Ve.expectedOutput=te,Ve.actualOutput=Ee,Ve}constructor(N){this.message=N}};Vi=P=He([R],Vi),e.TestMessage=Vi;let ji=class{constructor(N){this.id=N}};ji=He([R],ji),e.TestTag=ji;let hi=class{constructor(N,te){this.covered=N,this.total=te}};hi=He([R],hi),e.CoveredCount=hi;let qi=U=class{static fromDetails(N,te){const Ee=new hi(0,0),Ve=new hi(0,0),Qe=new hi(0,0);for(const dt of te)if("branches"in dt){Ee.total+=1,Ee.covered+=dt.executionCount>0?1:0;for(const Pt of dt.branches)Ve.total+=1,Ve.covered+=Pt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=dt.executionCount>0?1:0;const lt=new U(N,Ee,Ve.total>0?Ve:void 0,Qe.total>0?Qe:void 0);return lt.detailedCoverage=te,lt}constructor(N,te,Ee,Ve){this.uri=N,this.statementCoverage=te,this.branchCoverage=Ee,this.functionCoverage=Ve}};qi=U=He([R],qi),e.FileCoverage=qi;let Ki=class{constructor(N,te,Ee=[]){this.executionCount=N,this.location=te,this.branches=Ee}};Ki=He([R],Ki),e.StatementCoverage=Ki;let Gi=class{constructor(N,te){this.executionCount=N,this.location=te}};Gi=He([R],Gi),e.BranchCoverage=Gi;let Xi=class{constructor(N,te){this.executionCount=N,this.location=te}};Xi=He([R],Xi),e.FunctionCoverage=Xi;var cn;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(cn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var un;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(un=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var dn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(dn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class hn{constructor(N,te,Ee,Ve,Qe,lt){this.kind=N,this.name=te,this.detail=Ee,this.uri=Ve,this.range=Qe,this.selectionRange=lt}}e.TypeHierarchyItem=hn;class fn{constructor(N){this.uri=N}}e.TextTabInput=fn;class mn{constructor(N,te){this.original=N,this.modified=te}}e.TextDiffTabInput=mn;class gn{constructor(N,te,Ee,Ve){this.base=N,this.input1=te,this.input2=Ee,this.result=Ve}}e.TextMergeTabInput=gn;class pn{constructor(N,te){this.uri=N,this.viewType=te}}e.CustomEditorTabInput=pn;class vn{constructor(N){this.viewType=N}}e.WebviewEditorTabInput=vn;class En{constructor(N,te){this.uri=N,this.notebookType=te}}e.NotebookEditorTabInput=En;class bn{constructor(N,te,Ee){this.original=N,this.modified=te,this.notebookType=Ee}}e.NotebookDiffEditorTabInput=bn;class wn{constructor(){}}e.TerminalEditorTabInput=wn;class Sn{constructor(N,te){this.uri=N,this.inputBoxUri=te}}e.InteractiveWindowInput=Sn}),define(De[94],Ie([1,0,47,13,10,247,124,6,18]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const T=new Map;function O(m,t){t?T.set(m,t):T.delete(m)}e.setWordDefinitionFor=O;function b(m){return T.get(m)}class g extends M.MirrorTextModel{constructor(t,s,a,p,S,u,C,r){super(s,a,p,S),this._proxy=t,this._languageId=u,this._isDirty=C,this.notebook=r,this._isDisposed=!1}dispose(){(0,i.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(t){return(0,y.equals)(this._lines,t)}get document(){if(!this._document){const t=this;this._document={get uri(){return t._uri},get fileName(){return t._uri.fsPath},get isUntitled(){return t._uri.scheme===I.Schemas.untitled},get languageId(){return t._languageId},get version(){return t._versionId},get isClosed(){return t._isDisposed},get isDirty(){return t._isDirty},save(){return t._save()},getText(s){return s?t._getTextInRange(s):t.getText()},get eol(){return t._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return t._lines.length},lineAt(s){return t._lineAt(s)},offsetAt(s){return t._offsetAt(s)},positionAt(s){return t._positionAt(s)},validateRange(s){return t._validateRange(s)},validatePosition(s){return t._validatePosition(s)},getWordRangeAtPosition(s,a){return t._getWordRangeAtPosition(s,a)}}}return Object.freeze(this._document)}_acceptLanguageId(t){(0,i.ok)(!this._isDisposed),this._languageId=t}_acceptIsDirty(t){(0,i.ok)(!this._isDisposed),this._isDirty=t}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(t){const s=this._validateRange(t);if(s.isEmpty)return"";if(s.isSingleLine)return this._lines[s.start.line].substring(s.start.character,s.end.character);const a=this._eol,p=s.start.line,S=s.end.line,u=[];u.push(this._lines[p].substring(s.start.character));for(let C=p+1;C<S;C++)u.push(this._lines[C]);return u.push(this._lines[S].substring(0,s.end.character)),u.join(a)}_lineAt(t){let s;if(t instanceof A.Position?s=t.line:typeof t=="number"&&(s=t),typeof s!="number"||s<0||s>=this._lines.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new E(s,this._lines[s],s===this._lines.length-1)}_offsetAt(t){return t=this._validatePosition(t),this._ensureLineStarts(),this._lineStarts.getPrefixSum(t.line-1)+t.character}_positionAt(t){t=Math.floor(t),t=Math.max(0,t),this._ensureLineStarts();const s=this._lineStarts.getIndexOf(t),a=this._lines[s.index].length;return new A.Position(s.index,Math.min(s.remainder,a))}_validateRange(t){if(!(t instanceof A.Range))throw new Error("Invalid argument");const s=this._validatePosition(t.start),a=this._validatePosition(t.end);return s===t.start&&a===t.end?t:new A.Range(s.line,s.character,a.line,a.character)}_validatePosition(t){if(!(t instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return t.with(0,0);let{line:s,character:a}=t,p=!1;if(s<0)s=0,a=0,p=!0;else if(s>=this._lines.length)s=this._lines.length-1,a=this._lines[s].length,p=!0;else{const S=this._lines[s].length;a<0?(a=0,p=!0):a>S&&(a=S,p=!0)}return p?new A.Position(s,a):t}_getWordRangeAtPosition(t,s){const a=this._validatePosition(t);if(!s)s=b(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const p=(0,D.getWordAtText)(a.character+1,(0,D.ensureValidWordDefinition)(s),this._lines[a.line],0);if(p)return new A.Range(a.line,p.startColumn-1,a.line,p.endColumn-1)}}e.ExtHostDocumentData=g;class E{constructor(t,s,a){this._line=t,this._text=s,this._isLastLine=a}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=E}),define(De[182],Ie([1,0,6,14,4]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let M=class{constructor(A){this._actual=new i.ColorTheme(i.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let y;switch(A){case"light":y=i.ColorThemeKind.Light;break;case"hcDark":y=i.ColorThemeKind.HighContrast;break;case"hcLight":y=i.ColorThemeKind.HighContrastLight;break;default:y=i.ColorThemeKind.Dark}this._actual=new i.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};M=He([$e(0,I.IExtHostRpcService)],M),e.ExtHostTheming=M}),define(De[8],Ie([1,0,18,24,81,28,107,80,23,9,2,52,70,86,92,91,66,42,51,177,6,183]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(_e){function Te(G){const{selectionStartLineNumber:Pe,selectionStartColumn:Me,positionLineNumber:Je,positionColumn:xe}=G,it=new u.Position(Pe-1,Me-1),ot=new u.Position(Je-1,xe-1);return new u.Selection(it,ot)}_e.to=Te;function fe(G){const{anchor:Pe,active:Me}=G;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Me.line+1,positionColumn:Me.character+1}}_e.from=fe})(r=e.Selection||(e.Selection={}));var c;(function(_e){function Te(G){if(!G)return;const{start:Pe,end:Me}=G;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Me.line+1,endColumn:Me.character+1}}_e.from=Te;function fe(G){if(!G)return;const{startLineNumber:Pe,startColumn:Me,endLineNumber:Je,endColumn:xe}=G;return new u.Range(Pe-1,Me-1,Je-1,xe-1)}_e.to=fe})(c=e.Range||(e.Range={}));var n;(function(_e){function Te(fe){switch(fe){case 1:return u.StandardTokenType.Comment;case 0:return u.StandardTokenType.Other;case 3:return u.StandardTokenType.RegEx;case 2:return u.StandardTokenType.String}}_e.to=Te})(n=e.TokenType||(e.TokenType={}));var d;(function(_e){function Te(G){return new u.Position(G.lineNumber-1,G.column-1)}_e.to=Te;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}_e.from=fe})(d=e.Position||(e.Position={}));var l;(function(_e){function Te(Pe,Me){return(0,i.coalesce)((0,i.asArray)(Pe).map(Je=>fe(Je,Me)))}_e.from=Te;function fe(Pe,Me){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:G(Pe.scheme,Me),pattern:Q.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function G(Pe,Me){return Me&&typeof Pe=="string"?Me.transformOutgoingScheme(Pe):Pe}})(l=e.DocumentSelector||(e.DocumentSelector={}));var f;(function(_e){function Te(G){switch(G){case u.DiagnosticTag.Unnecessary:return 1;case u.DiagnosticTag.Deprecated:return 2}}_e.from=Te;function fe(G){switch(G){case 1:return u.DiagnosticTag.Unnecessary;case 2:return u.DiagnosticTag.Deprecated;default:return}}_e.to=fe})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var o;(function(_e){function Te(G){let Pe;return G.code&&((0,T.isString)(G.code)||(0,T.isNumber)(G.code)?Pe=String(G.code):Pe={value:String(G.code.value),target:G.code.target}),{...c.from(G.range),message:G.message,source:G.source,code:Pe,severity:v.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(h.from),tags:Array.isArray(G.tags)?(0,i.coalesce)(G.tags.map(f.from)):void 0}}_e.from=Te;function fe(G){const Pe=new u.Diagnostic(c.to(G),G.message,v.to(G.severity));return Pe.source=G.source,Pe.code=(0,T.isString)(G.code)?G.code:G.code?.value,Pe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(h.to),Pe.tags=G.tags&&(0,i.coalesce)(G.tags.map(f.to)),Pe}_e.to=fe})(o=e.Diagnostic||(e.Diagnostic={}));var h;(function(_e){function Te(G){return{...c.from(G.location.range),message:G.message,resource:G.location.uri}}_e.from=Te;function fe(G){return new u.DiagnosticRelatedInformation(new u.Location(G.resource,c.to(G)),G.message)}_e.to=fe})(h=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var v;(function(_e){function Te(G){switch(G){case u.DiagnosticSeverity.Error:return E.MarkerSeverity.Error;case u.DiagnosticSeverity.Warning:return E.MarkerSeverity.Warning;case u.DiagnosticSeverity.Information:return E.MarkerSeverity.Info;case u.DiagnosticSeverity.Hint:return E.MarkerSeverity.Hint}return E.MarkerSeverity.Error}_e.from=Te;function fe(G){switch(G){case E.MarkerSeverity.Info:return u.DiagnosticSeverity.Information;case E.MarkerSeverity.Warning:return u.DiagnosticSeverity.Warning;case E.MarkerSeverity.Error:return u.DiagnosticSeverity.Error;case E.MarkerSeverity.Hint:return u.DiagnosticSeverity.Hint;default:return u.DiagnosticSeverity.Error}}_e.to=fe})(v=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var k;(function(_e){function Te(G){return typeof G=="number"&&G>=u.ViewColumn.One?G-1:G===u.ViewColumn.Beside?S.SIDE_GROUP:S.ACTIVE_GROUP}_e.from=Te;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}_e.to=fe})(k=e.ViewColumn||(e.ViewColumn={}));function F(_e){return typeof _e.range<"u"}function j(_e){return _e.length===0?!0:!!F(_e[0])}e.isDecorationOptionsArr=j;var H;(function(_e){function Te(xe){return xe.map(_e.from)}_e.fromMany=Te;function fe(xe){return xe&&typeof xe=="object"&&typeof xe.language=="string"&&typeof xe.value=="string"}function G(xe){let it;if(fe(xe)){const{language:_t,value:vt}=xe;it={value:"```"+_t+`
`+vt+"\n```\n"}}else u.MarkdownString.isMarkdownString(xe)?it={value:xe.value,isTrusted:xe.isTrusted,supportThemeIcons:xe.supportThemeIcons,supportHtml:xe.supportHtml,baseUri:xe.baseUri}:typeof xe=="string"?it={value:xe}:it={value:""};const ot=Object.create(null);it.uris=ot;const Tt=_t=>{try{let vt=O.URI.parse(_t,!0);vt=vt.with({query:Pe(vt.query,ot)}),ot[_t]=vt}catch{}return""},Et=new D.marked.Renderer;return Et.link=Tt,Et.image=_t=>typeof _t=="string"?Tt(w.parseHrefAndDimensions(_t).href):"",(0,D.marked)(it.value,{renderer:Et}),it}_e.from=G;function Pe(xe,it){if(!xe)return xe;let ot;try{ot=(0,A.parse)(xe)}catch{}if(!ot)return xe;let Tt=!1;return ot=(0,y.cloneAndChange)(ot,Et=>{if(O.URI.isUri(Et)){const _t=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[_t]=Et,Tt=!0,_t}else return}),Tt?JSON.stringify(ot):xe}function Me(xe){const it=new u.MarkdownString(xe.value,xe.supportThemeIcons);return it.isTrusted=xe.isTrusted,it.supportHtml=xe.supportHtml,it.baseUri=xe.baseUri?O.URI.from(xe.baseUri):void 0,it}_e.to=Me;function Je(xe){if(!!xe)return typeof xe=="string"?xe:_e.from(xe)}_e.fromStrict=Je})(H=e.MarkdownString||(e.MarkdownString={}));function V(_e){return j(_e)?_e.map(Te=>({range:c.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?H.fromMany(Te.hoverMessage):Te.hoverMessage?H.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):_e.map(Te=>({range:c.from(Te)}))}e.fromRangeOrRangeWithMessage=V;function P(_e){return typeof _e>"u"?_e:typeof _e=="string"?O.URI.file(_e):_e}e.pathOrURIToURI=P;var U;(function(_e){function Te(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?P(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}_e.from=Te})(U=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var R;(function(_e){function Te(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?U.from(fe.before):void 0,after:fe.after?U.from(fe.after):void 0}}_e.from=Te})(R=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var x;(function(_e){function Te(fe){if(typeof fe>"u")return fe;switch(fe){case u.DecorationRangeBehavior.OpenOpen:return 0;case u.DecorationRangeBehavior.ClosedClosed:return 1;case u.DecorationRangeBehavior.OpenClosed:return 2;case u.DecorationRangeBehavior.ClosedOpen:return 3}}_e.from=Te})(x=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var z;(function(_e){function Te(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?x.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?R.from(fe.light):void 0,dark:fe.dark?R.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?P(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?U.from(fe.before):void 0,after:fe.after?U.from(fe.after):void 0}}_e.from=Te})(z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var B;(function(_e){function Te(G){return{text:G.newText,eol:G.newEol&&Ke.from(G.newEol),range:c.from(G.range)}}_e.from=Te;function fe(G){const Pe=new u.TextEdit(c.to(G.range),G.text);return Pe.newEol=typeof G.eol>"u"?void 0:Ke.to(G.eol),Pe}_e.to=fe})(B=e.TextEdit||(e.TextEdit={}));var K;(function(_e){function Te(G,Pe){const Me={edits:[]};if(G instanceof u.WorkspaceEdit){const Je=new M.ResourceSet;for(const xe of G._allEntries())xe._type===1&&O.URI.isUri(xe.to)&&xe.from===void 0&&Je.add(xe.to);for(const xe of G._allEntries())xe._type===1?Me.edits.push({oldResource:xe.from,newResource:xe.to,options:{...xe.options,contentsBase64:xe.options?.contents&&(0,I.encodeBase64)(I.VSBuffer.wrap(xe.options.contents))},metadata:xe.metadata}):xe._type===2?Me.edits.push({resource:xe.uri,textEdit:B.from(xe.edit),versionId:Je.has(xe.uri)?void 0:Pe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===6?Me.edits.push({resource:xe.uri,textEdit:{range:c.from(xe.range),text:xe.edit.value,insertAsSnippet:!0},versionId:Je.has(xe.uri)?void 0:Pe?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?Me.edits.push({metadata:xe.metadata,resource:xe.uri,cellEdit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Me.edits.push({metadata:xe.metadata,resource:xe.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(xe.uri),cellEdit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(nt.from)}})}return Me}_e.from=Te;function fe(G){const Pe=new u.WorkspaceEdit;for(const Me of G.edits)Me.textEdit?Pe.replace(O.URI.revive(Me.resource),c.to(Me.textEdit.range),Me.textEdit.text):Pe.renameFile(O.URI.revive(Me.oldResource),O.URI.revive(Me.newResource),Me.options);return Pe}_e.to=fe})(K=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Z;(function(_e){const Te=Object.create(null);Te[u.SymbolKind.File]=0,Te[u.SymbolKind.Module]=1,Te[u.SymbolKind.Namespace]=2,Te[u.SymbolKind.Package]=3,Te[u.SymbolKind.Class]=4,Te[u.SymbolKind.Method]=5,Te[u.SymbolKind.Property]=6,Te[u.SymbolKind.Field]=7,Te[u.SymbolKind.Constructor]=8,Te[u.SymbolKind.Enum]=9,Te[u.SymbolKind.Interface]=10,Te[u.SymbolKind.Function]=11,Te[u.SymbolKind.Variable]=12,Te[u.SymbolKind.Constant]=13,Te[u.SymbolKind.String]=14,Te[u.SymbolKind.Number]=15,Te[u.SymbolKind.Boolean]=16,Te[u.SymbolKind.Array]=17,Te[u.SymbolKind.Object]=18,Te[u.SymbolKind.Key]=19,Te[u.SymbolKind.Null]=20,Te[u.SymbolKind.EnumMember]=21,Te[u.SymbolKind.Struct]=22,Te[u.SymbolKind.Event]=23,Te[u.SymbolKind.Operator]=24,Te[u.SymbolKind.TypeParameter]=25;function fe(Pe){return typeof Te[Pe]=="number"?Te[Pe]:6}_e.from=fe;function G(Pe){for(const Me in Te)if(Te[Me]===Pe)return Number(Me);return u.SymbolKind.Property}_e.to=G})(Z=e.SymbolKind||(e.SymbolKind={}));var ue;(function(_e){function Te(G){switch(G){case u.SymbolTag.Deprecated:return 1}}_e.from=Te;function fe(G){switch(G){case 1:return u.SymbolTag.Deprecated}}_e.to=fe})(ue=e.SymbolTag||(e.SymbolTag={}));var ne;(function(_e){function Te(G){return{name:G.name,kind:Z.from(G.kind),tags:G.tags&&G.tags.map(ue.from),containerName:G.containerName,location:me.from(G.location)}}_e.from=Te;function fe(G){const Pe=new u.SymbolInformation(G.name,Z.to(G.kind),G.containerName,me.to(G.location));return Pe.tags=G.tags&&G.tags.map(ue.to),Pe}_e.to=fe})(ne=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var pe;(function(_e){function Te(G){const Pe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:c.from(G.range),selectionRange:c.from(G.selectionRange),kind:Z.from(G.kind),tags:G.tags?.map(ue.from)??[]};return G.children&&(Pe.children=G.children.map(Te)),Pe}_e.from=Te;function fe(G){const Pe=new u.DocumentSymbol(G.name,G.detail,Z.to(G.kind),c.to(G.range),c.to(G.selectionRange));return(0,i.isNonEmptyArray)(G.tags)&&(Pe.tags=G.tags.map(ue.to)),G.children&&(Pe.children=G.children.map(fe)),Pe}_e.to=fe})(pe=e.DocumentSymbol||(e.DocumentSymbol={}));var ae;(function(_e){function Te(G){const Pe=new u.CallHierarchyItem(Z.to(G.kind),G.name,G.detail||"",O.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Pe._sessionId=G._sessionId,Pe._itemId=G._itemId,Pe}_e.to=Te;function fe(G,Pe,Me){if(Pe=Pe??G._sessionId,Me=Me??G._itemId,Pe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Me,name:G.name,detail:G.detail,kind:Z.from(G.kind),uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(ue.from)}}_e.from=fe})(ae=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(_e){function Te(fe){return new u.CallHierarchyIncomingCall(ae.to(fe.from),fe.fromRanges.map(G=>c.to(G)))}_e.to=Te})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var Y;(function(_e){function Te(fe){return new u.CallHierarchyOutgoingCall(ae.to(fe.to),fe.fromRanges.map(G=>c.to(G)))}_e.to=Te})(Y=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var me;(function(_e){function Te(G){return{range:G.range&&c.from(G.range),uri:G.uri}}_e.from=Te;function fe(G){return new u.Location(O.URI.revive(G.uri),c.to(G.range))}_e.to=fe})(me=e.location||(e.location={}));var Se;(function(_e){function Te(G){const Pe=G,Me=G;return{originSelectionRange:Pe.originSelectionRange?c.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Me.uri,range:c.from(Pe.targetRange?Pe.targetRange:Me.range),targetSelectionRange:Pe.targetSelectionRange?c.from(Pe.targetSelectionRange):void 0}}_e.from=Te;function fe(G){return{targetUri:O.URI.revive(G.uri),targetRange:c.to(G.range),targetSelectionRange:G.targetSelectionRange?c.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?c.to(G.originSelectionRange):void 0}}_e.to=fe})(Se=e.DefinitionLink||(e.DefinitionLink={}));var Oe;(function(_e){function Te(G){return{range:c.from(G.range),contents:H.fromMany(G.contents)}}_e.from=Te;function fe(G){return new u.Hover(G.contents.map(H.to),c.to(G.range))}_e.to=fe})(Oe=e.Hover||(e.Hover={}));var Be;(function(_e){function Te(G){return{range:c.from(G.range),expression:G.expression}}_e.from=Te;function fe(G){return new u.EvaluatableExpression(c.to(G.range),G.expression)}_e.to=fe})(Be=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Xe;(function(_e){function Te(G){if(G instanceof u.InlineValueText)return{type:"text",range:c.from(G.range),text:G.text};if(G instanceof u.InlineValueVariableLookup)return{type:"variable",range:c.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof u.InlineValueEvaluatableExpression)return{type:"expression",range:c.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}_e.from=Te;function fe(G){switch(G.type){case"text":return{range:c.to(G.range),text:G.text};case"variable":return{range:c.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:c.to(G.range),expression:G.expression}}}_e.to=fe})(Xe=e.InlineValue||(e.InlineValue={}));var ke;(function(_e){function Te(G){return{frameId:G.frameId,stoppedLocation:c.from(G.stoppedLocation)}}_e.from=Te;function fe(G){return new u.InlineValueContext(G.frameId,c.to(G.stoppedLocation))}_e.to=fe})(ke=e.InlineValueContext||(e.InlineValueContext={}));var ye;(function(_e){function Te(G){return{range:c.from(G.range),kind:G.kind}}_e.from=Te;function fe(G){return new u.DocumentHighlight(c.to(G.range),G.kind)}_e.to=fe})(ye=e.DocumentHighlight||(e.DocumentHighlight={}));var Ce;(function(_e){function Te(fe){switch(fe){case 1:return u.CompletionTriggerKind.TriggerCharacter;case 2:return u.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return u.CompletionTriggerKind.Invoke}}_e.to=Te})(Ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var se;(function(_e){function Te(fe){return{triggerKind:Ce.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}_e.to=Te})(se=e.CompletionContext||(e.CompletionContext={}));var le;(function(_e){function Te(G){switch(G){case u.CompletionItemTag.Deprecated:return 1}}_e.from=Te;function fe(G){switch(G){case 1:return u.CompletionItemTag.Deprecated}}_e.to=fe})(le=e.CompletionItemTag||(e.CompletionItemTag={}));var J;(function(_e){const Te=new Map([[u.CompletionItemKind.Method,0],[u.CompletionItemKind.Function,1],[u.CompletionItemKind.Constructor,2],[u.CompletionItemKind.Field,3],[u.CompletionItemKind.Variable,4],[u.CompletionItemKind.Class,5],[u.CompletionItemKind.Interface,7],[u.CompletionItemKind.Struct,6],[u.CompletionItemKind.Module,8],[u.CompletionItemKind.Property,9],[u.CompletionItemKind.Unit,12],[u.CompletionItemKind.Value,13],[u.CompletionItemKind.Constant,14],[u.CompletionItemKind.Enum,15],[u.CompletionItemKind.EnumMember,16],[u.CompletionItemKind.Keyword,17],[u.CompletionItemKind.Snippet,27],[u.CompletionItemKind.Text,18],[u.CompletionItemKind.Color,19],[u.CompletionItemKind.File,20],[u.CompletionItemKind.Reference,21],[u.CompletionItemKind.Folder,23],[u.CompletionItemKind.Event,10],[u.CompletionItemKind.Operator,11],[u.CompletionItemKind.TypeParameter,24],[u.CompletionItemKind.Issue,26],[u.CompletionItemKind.User,25]]);function fe(Me){return Te.get(Me)??9}_e.from=fe;const G=new Map([[0,u.CompletionItemKind.Method],[1,u.CompletionItemKind.Function],[2,u.CompletionItemKind.Constructor],[3,u.CompletionItemKind.Field],[4,u.CompletionItemKind.Variable],[5,u.CompletionItemKind.Class],[7,u.CompletionItemKind.Interface],[6,u.CompletionItemKind.Struct],[8,u.CompletionItemKind.Module],[9,u.CompletionItemKind.Property],[12,u.CompletionItemKind.Unit],[13,u.CompletionItemKind.Value],[14,u.CompletionItemKind.Constant],[15,u.CompletionItemKind.Enum],[16,u.CompletionItemKind.EnumMember],[17,u.CompletionItemKind.Keyword],[27,u.CompletionItemKind.Snippet],[18,u.CompletionItemKind.Text],[19,u.CompletionItemKind.Color],[20,u.CompletionItemKind.File],[21,u.CompletionItemKind.Reference],[23,u.CompletionItemKind.Folder],[10,u.CompletionItemKind.Event],[11,u.CompletionItemKind.Operator],[24,u.CompletionItemKind.TypeParameter],[25,u.CompletionItemKind.User],[26,u.CompletionItemKind.Issue]]);function Pe(Me){return G.get(Me)??u.CompletionItemKind.Property}_e.to=Pe})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var _;(function(_e){function Te(fe,G){const Pe=new u.CompletionItem(fe.label);return Pe.insertText=fe.insertText,Pe.kind=J.to(fe.kind),Pe.tags=fe.tags?.map(le.to),Pe.detail=fe.detail,Pe.documentation=w.isMarkdownString(fe.documentation)?H.to(fe.documentation):fe.documentation,Pe.sortText=fe.sortText,Pe.filterText=fe.filterText,Pe.preselect=fe.preselect,Pe.commitCharacters=fe.commitCharacters,b.Range.isIRange(fe.range)?Pe.range=c.to(fe.range):typeof fe.range=="object"&&(Pe.range={inserting:c.to(fe.range.insert),replacing:c.to(fe.range.replace)}),Pe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:Boolean(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Pe.insertText=new u.SnippetString(fe.insertText):(Pe.insertText=fe.insertText,Pe.textEdit=Pe.range instanceof u.Range?new u.TextEdit(Pe.range,Pe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=fe.additionalTextEdits.map(Me=>B.to(Me))),Pe.command=G&&fe.command?G.fromInternal(fe.command):void 0,Pe}_e.to=Te})(_=e.CompletionItem||(e.CompletionItem={}));var L;(function(_e){function Te(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:H.fromStrict(G.documentation)}}_e.from=Te;function fe(G){return{label:G.label,documentation:w.isMarkdownString(G.documentation)?H.to(G.documentation):G.documentation}}_e.to=fe})(L=e.ParameterInformation||(e.ParameterInformation={}));var W;(function(_e){function Te(G){return{label:G.label,documentation:H.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(L.from):[],activeParameter:G.activeParameter}}_e.from=Te;function fe(G){return{label:G.label,documentation:w.isMarkdownString(G.documentation)?H.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(L.to):[],activeParameter:G.activeParameter}}_e.to=fe})(W=e.SignatureInformation||(e.SignatureInformation={}));var q;(function(_e){function Te(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(W.from):[]}}_e.from=Te;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(W.to):[]}}_e.to=fe})(q=e.SignatureHelp||(e.SignatureHelp={}));var ee;(function(_e){function Te(fe,G){const Pe=new u.InlayHint(d.to(G.position),typeof G.label=="string"?G.label:G.label.map(ce.to.bind(void 0,fe)),G.kind&&be.to(G.kind));return Pe.textEdits=G.textEdits&&G.textEdits.map(B.to),Pe.tooltip=w.isMarkdownString(G.tooltip)?H.to(G.tooltip):G.tooltip,Pe.paddingLeft=G.paddingLeft,Pe.paddingRight=G.paddingRight,Pe}_e.to=Te})(ee=e.InlayHint||(e.InlayHint={}));var ce;(function(_e){function Te(fe,G){const Pe=new u.InlayHintLabelPart(G.label);return Pe.tooltip=w.isMarkdownString(G.tooltip)?H.to(G.tooltip):G.tooltip,g.Command.is(G.command)&&(Pe.command=fe.fromInternal(G.command)),G.location&&(Pe.location=me.to(G.location)),Pe}_e.to=Te})(ce=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var be;(function(_e){function Te(G){return G}_e.from=Te;function fe(G){return G}_e.to=fe})(be=e.InlayHintKind||(e.InlayHintKind={}));var oe;(function(_e){function Te(G){return{range:c.from(G.range),url:G.target,tooltip:G.tooltip}}_e.from=Te;function fe(G){let Pe;if(G.url)try{Pe=typeof G.url=="string"?O.URI.parse(G.url,!0):O.URI.revive(G.url)}catch{}return new u.DocumentLink(c.to(G.range),Pe)}_e.to=fe})(oe=e.DocumentLink||(e.DocumentLink={}));var we;(function(_e){function Te(G){const Pe=new u.ColorPresentation(G.label);return G.textEdit&&(Pe.textEdit=B.to(G.textEdit)),G.additionalTextEdits&&(Pe.additionalTextEdits=G.additionalTextEdits.map(Me=>B.to(Me))),Pe}_e.to=Te;function fe(G){return{label:G.label,textEdit:G.textEdit?B.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Pe=>B.from(Pe)):void 0}}_e.from=fe})(we=e.ColorPresentation||(e.ColorPresentation={}));var ve;(function(_e){function Te(G){return new u.Color(G[0],G[1],G[2],G[3])}_e.to=Te;function fe(G){return[G.red,G.green,G.blue,G.alpha]}_e.from=fe})(ve=e.Color||(e.Color={}));var Ue;(function(_e){function Te(G){return{range:c.from(G.range)}}_e.from=Te;function fe(G){return new u.SelectionRange(c.to(G.range))}_e.to=fe})(Ue=e.SelectionRange||(e.SelectionRange={}));var ze;(function(_e){function Te(fe){switch(fe){case 2:return u.TextDocumentSaveReason.AfterDelay;case 1:return u.TextDocumentSaveReason.Manual;case 3:case 4:return u.TextDocumentSaveReason.FocusOut}}_e.to=Te})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var et;(function(_e){function Te(G){switch(G){case u.TextEditorLineNumbersStyle.Off:return 0;case u.TextEditorLineNumbersStyle.Relative:return 2;case u.TextEditorLineNumbersStyle.On:default:return 1}}_e.from=Te;function fe(G){switch(G){case 0:return u.TextEditorLineNumbersStyle.Off;case 2:return u.TextEditorLineNumbersStyle.Relative;case 1:default:return u.TextEditorLineNumbersStyle.On}}_e.to=fe})(et=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ke;(function(_e){function Te(G){if(G===u.EndOfLine.CRLF)return 1;if(G===u.EndOfLine.LF)return 0}_e.from=Te;function fe(G){if(G===1)return u.EndOfLine.CRLF;if(G===0)return u.EndOfLine.LF}_e.to=fe})(Ke=e.EndOfLine||(e.EndOfLine={}));var tt;(function(_e){function Te(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case u.ProgressLocation.SourceControl:return 3;case u.ProgressLocation.Window:return 10;case u.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}_e.from=Te})(tt=e.ProgressLocation||(e.ProgressLocation={}));var Fe;(function(_e){function Te(fe){const G={start:fe.start+1,end:fe.end+1};return fe.kind&&(G.kind=ht.from(fe.kind)),G}_e.from=Te})(Fe=e.FoldingRange||(e.FoldingRange={}));var ht;(function(_e){function Te(fe){if(fe)switch(fe){case u.FoldingRangeKind.Comment:return g.FoldingRangeKind.Comment;case u.FoldingRangeKind.Imports:return g.FoldingRangeKind.Imports;case u.FoldingRangeKind.Region:return g.FoldingRangeKind.Region}}_e.from=Te})(ht=e.FoldingRangeKind||(e.FoldingRangeKind={}));var X;(function(_e){function Te(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?c.from(fe.selection):void 0,override:typeof fe.override=="boolean"?t.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}_e.from=Te})(X=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Q;(function(_e){function Te(Me){return Me instanceof u.RelativePattern?Me.toJSON():typeof Me=="string"?Me:fe(Me)||G(Me)?new u.RelativePattern(Me.baseUri??Me.base,Me.pattern).toJSON():Me}_e.from=Te;function fe(Me){const Je=Me;return Je?O.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function G(Me){const Je=Me;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Pe(Me){return typeof Me=="string"?Me:new u.RelativePattern(O.URI.revive(Me.baseUri),Me.pattern)}_e.to=Pe})(Q=e.GlobPattern||(e.GlobPattern={}));var ge;(function(_e){function Te(fe){if(fe){if(Array.isArray(fe))return fe.map(Te);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:Q.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}_e.from=Te})(ge=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(_e){function Te(G){return{start:G.start,end:G.end}}_e.from=Te;function fe(G){return new u.NotebookRange(G.start,G.end)}_e.to=fe})(Ne=e.NotebookRange||(e.NotebookRange={}));var je;(function(_e){function Te(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}_e.to=Te;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}_e.from=fe})(je=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var qe;(function(_e){function Te(fe){if(fe===s.NotebookCellExecutionState.Unconfirmed)return u.NotebookCellExecutionState.Pending;if(fe===s.NotebookCellExecutionState.Pending)return;if(fe===s.NotebookCellExecutionState.Executing)return u.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}_e.to=Te})(qe=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var We;(function(_e){function Te(G){switch(G){case u.NotebookCellKind.Markup:return s.CellKind.Markup;case u.NotebookCellKind.Code:default:return s.CellKind.Code}}_e.from=Te;function fe(G){switch(G){case s.CellKind.Markup:return u.NotebookCellKind.Markup;case s.CellKind.Code:default:return u.NotebookCellKind.Code}}_e.to=fe})(We=e.NotebookCellKind||(e.NotebookCellKind={}));var Ze;(function(_e){function Te(G){const Pe={metadata:G.metadata??Object.create(null),cells:[]};for(const Me of G.cells)u.NotebookCellData.validate(Me),Pe.cells.push(nt.from(Me));return Pe}_e.from=Te;function fe(G){const Pe=new u.NotebookData(G.cells.map(nt.to));return(0,T.isEmptyObject)(G.metadata)||(Pe.metadata=G.metadata),Pe}_e.to=fe})(Ze=e.NotebookData||(e.NotebookData={}));var nt;(function(_e){function Te(G){return{cellKind:We.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:je.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(It.from):[]}}_e.from=Te;function fe(G){return new u.NotebookCellData(We.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(It.to):void 0,G.metadata,G.internalMetadata?je.to(G.internalMetadata):void 0)}_e.to=fe})(nt=e.NotebookCellData||(e.NotebookCellData={}));var ct;(function(_e){function Te(G){return{mime:G.mime,valueBytes:I.VSBuffer.wrap(G.data)}}_e.from=Te;function fe(G){return new u.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}_e.to=fe})(ct=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var It;(function(_e){function Te(G){return{outputId:G.id,items:G.items.map(ct.from),metadata:G.metadata}}_e.from=Te;function fe(G){const Pe=G.items.map(ct.to);return new u.NotebookCellOutput(Pe,G.outputId,G.metadata)}_e.to=fe})(It=e.NotebookCellOutput||(e.NotebookCellOutput={}));var at;(function(_e){function Te(Pe){return G(Pe)?{include:(0,T.withNullAsUndefined)(Q.from(Pe.include)),exclude:(0,T.withNullAsUndefined)(Q.from(Pe.exclude))}:(0,T.withNullAsUndefined)(Q.from(Pe))}_e.from=Te;function fe(Pe){return G(Pe)?{include:Q.to(Pe.include),exclude:Q.to(Pe.exclude)}:Q.to(Pe)}_e.to=fe;function G(Pe){const Me=Pe;return Me?!(0,T.isUndefinedOrNull)(Me.include)&&!(0,T.isUndefinedOrNull)(Me.exclude):!1}})(at=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(_e){function Te(fe,G,Pe){const Me=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===u.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Me,Pe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}_e.from=Te})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Lt;(function(_e){function Te(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}_e.from=Te})(Lt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var At;(function(_e){function Te(G){return{uri:G.uri,provides:G.provides}}_e.from=Te;function fe(G){return new u.NotebookRendererScript(O.URI.revive(G.uri),G.provides)}_e.to=fe})(At=e.NotebookRendererScript||(e.NotebookRendererScript={}));var kt;(function(_e){function Te(G){return{message:H.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:c.from(G.location.range),uri:G.location.uri}}}_e.from=Te;function fe(G){const Pe=new u.TestMessage(typeof G.message=="string"?G.message:H.to(G.message));return Pe.actualOutput=G.actual,Pe.expectedOutput=G.expected,Pe.location=G.location?me.to(G.location):void 0,Pe}_e.to=fe})(kt=e.TestMessage||(e.TestMessage={}));var ft;(function(_e){_e.namespace=p.namespaceTestTag,_e.denamespace=p.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var yt;(function(_e){function Te(G){const Pe=(0,m.getPrivateApiFor)(G).controllerId;return{extId:a.TestId.fromExtHostTestItem(G,Pe).toString(),label:G.label,uri:O.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Me=>ft.namespace(Pe,Me.id)),range:b.Range.lift(c.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&H.fromStrict(G.error)||null}}_e.from=Te;function fe(G){return{parent:void 0,error:void 0,id:a.TestId.fromString(G.extId).localId,label:G.label,uri:O.URI.revive(G.uri),tags:(G.tags||[]).map(Pe=>{const{tagId:Me}=ft.denamespace(Pe);return new u.TestTag(Me)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}_e.toPlain=fe})(yt=e.TestItem||(e.TestItem={})),function(_e){function Te(G){return{id:G.id}}_e.from=Te;function fe(G){return new u.TestTag(G.id)}_e.to=fe}(ft=e.TestTag||(e.TestTag={}));var Ut;(function(_e){const Te=(G,Pe)=>{const Me=[];for(const[xe,it]of Pe)a.TestId.compare(it.item.extId,xe)===2&&(Pe.delete(xe),Me.push(it));const Je={...yt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(it=>it.type===0).map(kt.to)})),children:Me.map(xe=>Te(xe,Pe))};for(const xe of Je.children)xe.parent=Je;return Je};function fe(G){const Pe=[],Me=new Map;for(const Je of G.items){Me.set(Je.item.extId,Je);const xe=a.TestId.root(Je.item.extId);G.request.targets.some(it=>it.controllerId===xe&&it.testIds.includes(Je.item.extId))&&Pe.push(Je)}return{completedAt:G.completedAt,results:Pe.map(Je=>Te(Je,Me))}}_e.to=fe})(Ut=e.TestResults||(e.TestResults={}));var Rt;(function(_e){function Te(Me){return{covered:Me.covered,total:Me.covered}}function fe(Me){return"line"in Me?d.from(Me):c.from(Me)}function G(Me){return"branches"in Me?{count:Me.executionCount,location:fe(Me.location),type:1,branches:Me.branches.length?Me.branches.map(Je=>({count:Je.executionCount,location:Je.location&&fe(Je.location)})):void 0}:{type:0,count:Me.executionCount,location:fe(Me.location)}}_e.fromDetailed=G;function Pe(Me){return{uri:Me.uri,statement:Te(Me.statementCoverage),branch:Me.branchCoverage&&Te(Me.branchCoverage),function:Me.functionCoverage&&Te(Me.functionCoverage),details:Me.detailedCoverage?.map(G)}}_e.fromFile=Pe})(Rt=e.TestCoverage||(e.TestCoverage={}));var Ge;(function(_e){function Te(fe){switch(fe){case 1:return u.CodeActionTriggerKind.Invoke;case 2:return u.CodeActionTriggerKind.Automatic}}_e.to=Te})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ct;(function(_e){function Te(G){const Pe=new u.TypeHierarchyItem(Z.to(G.kind),G.name,G.detail||"",O.URI.revive(G.uri),c.to(G.range),c.to(G.selectionRange));return Pe._sessionId=G._sessionId,Pe._itemId=G._itemId,Pe}_e.to=Te;function fe(G,Pe,Me){if(Pe=Pe??G._sessionId,Me=Me??G._itemId,Pe===void 0||Me===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Me,kind:Z.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:c.from(G.range),selectionRange:c.from(G.selectionRange),tags:G.tags?.map(ue.from)}}_e.from=fe})(Ct=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ot;(function(_e){function Te(fe){if(!!fe)return{value:fe.value,tooltip:fe.tooltip}}_e.from=Te})(Ot=e.ViewBadge||(e.ViewBadge={}));var Bt;(function(_e){function Te(fe,G){const Pe=fe.fileData;return Pe?new class extends u.DataTransferItem{asFile(){return{name:Pe.name,uri:O.URI.revive(Pe.uri),data:(0,C.once)(()=>G())}}}("",fe.id):new u.DataTransferItem(fe.asString)}_e.toDataTransferItem=Te})(Bt=e.DataTransferItem||(e.DataTransferItem={}));var pt;(function(_e){function Te(G,Pe){const Me=G.items.map(([Je,xe])=>[Je,Bt.toDataTransferItem(xe,()=>Pe(xe.id))]);return new u.DataTransfer(Me)}_e.toDataTransfer=Te;async function fe(G){const Pe={items:[]},Me=[];return G.forEach((Je,xe)=>{Me.push((async()=>{const it=await Je.asString(),ot=Je.asFile();Pe.items.push([xe,{id:Je.id,asString:it,fileData:ot?{name:ot.name,uri:ot.uri}:void 0}])})())}),await Promise.all(Me),Pe}_e.toDataTransferDTO=fe})(pt=e.DataTransfer||(e.DataTransfer={}))}),define(De[184],Ie([1,0,2,12,6,8,150]),function(ie,e,i,I,w,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(T,O,b,g={timeout:1500,errors:3}){this._logService=T,this._documents=O,this._mainThreadBulkEdits=b,this._thresholds=g,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(O,b,g)=>{const m={dispose:this._callbacks.push([O,b,T])};return Array.isArray(g)&&g.push(m),m}}async $participateInSave(T,O){const b=i.URI.revive(T);let g=!1;const E=setTimeout(()=>g=!0,this._thresholds.timeout),m=[];try{for(const t of[...this._callbacks]){if(g)break;const s=this._documents.getDocument(b),a=await this._deliverEventAsyncAndBlameBadListeners(t,{document:s,reason:M.TextDocumentSaveReason.to(O)});m.push(a)}}finally{clearTimeout(E)}return m}_deliverEventAsyncAndBlameBadListeners([T,O,b],g){const E=this._badListeners.get(T);return typeof E=="number"&&E>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,T,O,g).then(()=>!0,m=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(m),!(m instanceof Error)||m.message!=="concurrent_edits"){const t=this._badListeners.get(T);this._badListeners.set(T,t?t+1:1),typeof t=="number"&&t>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,O,b,g){const E=[],m=Date.now(),{document:t,reason:s}=g,{version:a}=t,p=Object.freeze({document:t,reason:s,waitUntil(S){if(Object.isFrozen(E))throw(0,I.illegalState)("waitUntil can not be called async");E.push(Promise.resolve(S))}});try{O.apply(b,[p])}catch(S){return Promise.reject(S)}return Object.freeze(E),new Promise((S,u)=>{const C=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(E).then(r=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-m}ms`),clearTimeout(C),S(r)}).catch(r=>{clearTimeout(C),u(r)})}).then(S=>{const u={edits:[]};for(const C of S)if(Array.isArray(C)&&C.every(r=>r instanceof w.TextEdit))for(const{newText:r,newEol:c,range:n}of C)u.edits.push({resource:t.uri,versionId:void 0,textEdit:{range:n&&M.Range.from(n),text:r,eol:c&&M.EndOfLine.from(c)}});if(u.edits.length!==0)return a===t.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(De[185],Ie([1,0,13,2,8,6,66]),function(ie,e,i,I,w,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(b,g,E,m){this.start=b,this.deletedCount=g,this.deletedItems=E,this.items=m}asApiEvent(){return{range:new M.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(b=>b.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(b,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:b}}constructor(b,g,E){this.notebook=b,this._extHostDocument=g,this._cellData=E,this.handle=E.handle,this.uri=I.URI.revive(E.uri),this.cellKind=E.cellKind,this._outputs=E.outputs.map(w.NotebookCellOutput.to),this._internalMetadata=E.internalMetadata??{},this._metadata=Object.freeze(E.metadata??{}),this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const b=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return b.notebook.getCellIndex(b)},notebook:b.notebook.apiNotebook,kind:w.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return b._mime},set mime(m){b._mime=m},get outputs(){return b._outputs.slice(0)},get metadata(){return b._metadata},get executionSummary(){return b._previousResult}};this._apiCell=Object.freeze(E)}return this._apiCell}setOutputs(b){this._outputs=b.map(w.NotebookCellOutput.to)}setOutputItems(b,g,E){const m=E.map(w.NotebookCellOutputItem.to),t=this._outputs.find(s=>s.id===b);if(t&&(g||(t.items.length=0),t.items.push(...m),t.items.length>1&&t.items.every(s=>D.isTextStreamMime(s.mime)))){const s=new Map,a=[];t.items.forEach(p=>{let S;s.has(p.mime)?S=s.get(p.mime):(S=[],s.set(p.mime,S),a.push(p.mime)),S.push(p.data)}),t.items.length=0,a.forEach(p=>{const S=D.compressOutputItemStreams(s.get(p));t.items.push({mime:p,data:S.buffer})})}}setMetadata(b){this._metadata=Object.freeze(b)}setInternalMetadata(b){this._internalMetadata=b,this._previousResult=Object.freeze(w.NotebookCellExecutionSummary.to(b))}setMime(b){}}e.ExtHostCell=y;class T{constructor(b,g,E,m,t){this._proxy=b,this._textDocumentsAndEditors=g,this._textDocuments=E,this.uri=m,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=t.viewType,this._metadata=Object.freeze(t.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,t.cells]],!0,void 0),this._versionId=t.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const b=this,g={get uri(){return b.uri},get version(){return b._versionId},get notebookType(){return b._notebookType},get isDirty(){return b._isDirty},get isUntitled(){return b.uri.scheme===i.Schemas.untitled},get isClosed(){return b._disposed},get metadata(){return b._metadata},get cellCount(){return b._cells.length},cellAt(E){return E=b._validateIndex(E),b._cells[E].apiCell},getCells(E){return(E?b._getCells(E):b._cells).map(t=>t.apiCell)},save(){return b._save()}};this._notebook=Object.freeze(g)}return this._notebook}acceptDocumentPropertiesChanged(b){b.metadata&&(this._metadata=Object.freeze({...this._metadata,...b.metadata}))}acceptDirty(b){this._isDirty=b}acceptModelChanged(b,g,E){this._versionId=b.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:E});const m={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},t=[];for(const a of b.rawEvents)a.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1,m.contentChanges):a.kind===D.NotebookCellsChangeType.Move?this._moveCells(a.index,a.length,a.newIdx,m.contentChanges):a.kind===D.NotebookCellsChangeType.Output?(this._setCellOutputs(a.index,a.outputs),t.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===D.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems),t.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(a.index,a.language),t.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document})):a.kind===D.NotebookCellsChangeType.ChangeCellContent?t.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document}):a.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(a.index,a.metadata),t.push({cell:this._cells[a.index].apiCell,metadata:this._cells[a.index].apiCell.metadata})):a.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(a.index,a.internalMetadata),t.push({cell:this._cells[a.index].apiCell,executionSummary:this._cells[a.index].apiCell.executionSummary}));const s=new Map;for(let a=0;a<t.length;a++){const p=t[a],S=s.get(p.cell);if(S===void 0){const u=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});s.set(p.cell,u-1)}else m.cellChanges[S]={...m.cellChanges[S],...p}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}_validateIndex(b){return b=b|0,b<0?0:b>=this._cells.length?this._cells.length-1:b}_validateRange(b){let g=b.start|0,E=b.end|0;return g<0&&(g=0),E>this._cells.length&&(E=this._cells.length),b.with({start:g,end:E})}_getCells(b){b=this._validateRange(b);const g=[];for(let E=b.start;E<b.end;E++)g.push(this._cells[E]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(b,g,E){if(this._disposed)return;const m=[],t=[],s=[];if(b.reverse().forEach(a=>{const S=a[2].map(r=>{const c=new y(this,this._textDocumentsAndEditors,r);return g||t.push(y.asModelAddData(this.apiNotebook,r)),c}),u=new A(a[0],a[1],[],S),C=this._cells.splice(a[0],a[1],...S);for(const r of C)s.push(r.uri),u.deletedItems.push(r.apiCell);m.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:t,removedDocuments:s}),E)for(const a of m)E.push(a.asApiEvent())}_moveCells(b,g,E,m){const t=this._cells.splice(b,g);this._cells.splice(E,0,...t);const s=[new A(b,g,t.map(a=>a.apiCell),[]),new A(E,0,[],t)];for(const a of s)m.push(a.asApiEvent())}_setCellOutputs(b,g){this._cells[b].setOutputs(g)}_setCellOutputItems(b,g,E,m){this._cells[b].setOutputItems(g,E,m)}_changeCellLanguage(b,g){const E=this._cells[b];E.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(E.uri,g)}_changeCellMime(b,g){const E=this._cells[b];E.apiCell.mime=g}_changeCellMetadata(b,g){this._cells[b].setMetadata(g)}_changeCellInternalMetadata(b,g){this._cells[b].setInternalMetadata(g)}getCellFromApiCell(b){return this._cells.find(g=>g.apiCell===b)}getCellFromIndex(b){return this._cells[b]}getCell(b){return this._cells.find(g=>g.handle===b)}getCellIndex(b){return this._cells.indexOf(b)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(De[95],Ie([1,0,12,8,6]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class M{constructor(A,y,T,O,b,g){this.id=A,this._proxy=y,this.notebookData=T,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=b,this._visibleRanges=O,this._viewColumn=g}get apiEditor(){if(!this._editor){const A=this;this._editor={get notebook(){return A.notebookData.apiNotebook},get selection(){return A._selections[0]},set selection(y){this.selections=[y]},get selections(){return A._selections},set selections(y){if(!Array.isArray(y)||!y.every(w.NotebookRange.isNotebookRange))throw(0,i.illegalArgument)("selections");A._selections=y,A._trySetSelections(y)},get visibleRanges(){return A._visibleRanges},revealRange(y,T){A._proxy.$tryRevealRange(A.id,I.NotebookRange.from(y),T??w.NotebookEditorRevealType.Default)},get viewColumn(){return A._viewColumn}},M.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(A){this._visible=A}_acceptVisibleRanges(A){this._visibleRanges=A}_acceptSelections(A){this._selections=A}_trySetSelections(A){this._proxy.$trySetSelections(this.id,A.map(I.NotebookRange.from))}_acceptViewColumn(A){this._viewColumn=A}}e.ExtHostNotebookEditor=M,M.apiEditorsToExtHost=new WeakMap}),define(De[186],Ie([1,0,4,11,8]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let M=class{constructor(A,y){this._logService=A,this._notebooksAndEditors=y,this._onDidChangeNotebookEditorSelection=new i.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new i.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(A,y){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const T=this._notebooksAndEditors.getEditorById(A);y.visibleRanges&&T._acceptVisibleRanges(y.visibleRanges.ranges.map(w.NotebookRange.to)),y.selections&&T._acceptSelections(y.selections.selections.map(w.NotebookRange.to)),y.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:T.apiEditor,visibleRanges:T.apiEditor.visibleRanges}),y.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:T.apiEditor,selections:T.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this._notebooksAndEditors.getEditorById(y)._acceptViewColumn(w.ViewColumn.to(A[y]))}};M=He([$e(0,I.ILogService)],M),e.ExtHostNotebookEditors=M}),define(De[187],Ie([1,0,8,153,133,20,58,12]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(g){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=g}async withProgress(g,E,m){const t=this._handles++,{title:s,location:a,cancellable:p}=E,S={label:(0,w.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this._proxy.$startProgress(t,{location:i.ProgressLocation.from(a),title:s,source:S,cancellable:p},g.isUnderDevelopment?void 0:g.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(t,m,!!p)}_withProgress(g,E,m){let t;m&&(t=new M.CancellationTokenSource,this._mapHandleToCancellationSource.set(g,t));const s=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),t?.dispose()};let a;try{a=E(new O(this._proxy,g),m&&t?t.token:M.CancellationToken.None)}catch(p){throw s(g),p}return a.then(p=>s(g),p=>s(g)),a}$acceptProgressCanceled(g){const E=this._mapHandleToCancellationSource.get(g);E&&(E.cancel(),this._mapHandleToCancellationSource.delete(g))}}e.ExtHostProgress=y;function T(b,g){return b.message=g.message,typeof g.increment=="number"&&(typeof b.increment=="number"?b.increment+=g.increment:b.increment=g.increment),b}class O extends I.Progress{constructor(g,E){super(m=>this.throttledReport(m)),this._proxy=g,this._handle=E}throttledReport(g){this._proxy.$progressReport(this._handle,g)}}He([(0,D.throttle)(100,(b,g)=>T(b,g),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(De[96],Ie([1,0,52,92,42,67,51,8,2]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const T=(S,u,C,r)=>{let c=u;return{enumerable:!0,configurable:!1,get(){return c},set(n){if(!C(c,n)){const d=c;c=n,S.listener?.(r(n,d))}}}},O=(S,u)=>S===u,b={range:(S,u)=>S===u?!0:!S||!u?!1:S.isEqual(u),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(S,u)=>!(S.length!==u.length||S.some(C=>!u.find(r=>C.id===r.id)))},g=S=>u=>({op:4,update:S(u)}),E=(S,u)=>({range:(()=>{let C;const r=g(c=>({range:i.Range.lift(A.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return C},set(c){S.listener?.({op:6}),b.range(C,c)||(C=c,S.listener?.(r(c)))}}})(),label:T(S,u,b.label,g(C=>({label:C}))),description:T(S,void 0,b.description,g(C=>({description:C}))),sortText:T(S,void 0,b.sortText,g(C=>({sortText:C}))),canResolveChildren:T(S,!1,b.canResolveChildren,C=>({op:2,state:C})),busy:T(S,!1,b.busy,g(C=>({busy:C}))),error:T(S,void 0,b.error,g(C=>({error:A.MarkdownString.fromStrict(C)||null}))),tags:T(S,[],b.tags,(C,r)=>({op:1,new:C.map(A.TestTag.from),old:r.map(A.TestTag.from)}))}),m=S=>{const u=w.TestId.fromString(S.extId),C=new s(u.controllerId,u.localId,S.label,y.URI.revive(S.uri)||void 0);return C.range=A.Range.to(S.range||void 0),C.description=S.description||void 0,C.sortText=S.sortText||void 0,C.tags=S.tags.map(r=>A.TestTag.to({id:(0,D.denamespaceTestTag)(r).tagId})),C},t=S=>{let u;for(const C of S.tests){const r=m(C.item);(0,I.getPrivateApiFor)(r).parent=u,u=r}return u};e.toItemFromContext=t;class s{constructor(u,C,r,c){if(C.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(C)} symbol`);const n=(0,I.createPrivateApiFor)(this,u);Object.defineProperties(this,{id:{value:C,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof a?void 0:n.parent}},children:{value:(0,M.createTestItemChildren)(n,I.getPrivateApiFor,s),enumerable:!0,writable:!1},...E(n,r)})}}e.TestItemImpl=s;class a extends s{constructor(u,C){super(u,u,C,void 0),this._isRoot=!0}}e.TestItemRootImpl=a;class p extends M.TestItemCollection{constructor(u,C,r){super({controllerId:u,getDocumentVersion:c=>c&&r.getDocument(c)?.version,getApiFor:I.getPrivateApiFor,getChildren:c=>c.children,root:new a(u,C),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(De[97],Ie([1,0,47,12,78,8,6]),function(ie,e,i,I,w,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(g,E,m){const t=A._Keys.nextId();g.$registerTextEditorDecorationType(E.identifier,t,M.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:t,dispose(){g.$removeTextEditorDecorationType(t)}})}}e.TextEditorDecorationType=A,A._Keys=new w.IdGenerator("TextEditorDecorationType");class y{constructor(g,E){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=E.undoStopBefore,this._undoStopAfter=E.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,E){this._throwIfFinalized();let m=null;if(g instanceof D.Position)m=new D.Range(g,g);else if(g instanceof D.Range)m=g;else throw new Error("Unrecognized location");this._pushEdit(m,E,!1)}insert(g,E){this._throwIfFinalized(),this._pushEdit(new D.Range(g,g),E,!0)}delete(g){this._throwIfFinalized();let E=null;if(g instanceof D.Range)E=g;else throw new Error("Unrecognized location");this._pushEdit(E,null,!0)}_pushEdit(g,E,m){const t=this._document.validateRange(g);this._collectedEdits.push({range:t,text:E,forceMoveMarkers:m})}setEndOfLine(g){if(this._throwIfFinalized(),g!==D.EndOfLine.LF&&g!==D.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=y;class T{constructor(g,E,m,t){this._proxy=g,this._id=E,this._accept(m),this._logService=t;const s=this;this.value={get tabSize(){return s._tabSize},set tabSize(a){s._setTabSize(a)},get insertSpaces(){return s._insertSpaces},set insertSpaces(a){s._setInsertSpaces(a)},get cursorStyle(){return s._cursorStyle},set cursorStyle(a){s._setCursorStyle(a)},get lineNumbers(){return s._lineNumbers},set lineNumbers(a){s._setLineNumbers(a)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=M.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const E=Math.floor(g);return E>0?E:null}if(typeof g=="string"){const E=parseInt(g,10);return isNaN(E)?null:E>0?E:null}return null}_setTabSize(g){const E=this._validateTabSize(g);if(E!==null){if(typeof E=="number"){if(this._tabSize===E)return;this._tabSize=E}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:E}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const E=this._validateInsertSpaces(g);if(typeof E=="boolean"){if(this._insertSpaces===E)return;this._insertSpaces=E}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:E}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:M.TextEditorLineNumbersStyle.from(g)})))}assign(g){const E={};let m=!1;if(typeof g.tabSize<"u"){const t=this._validateTabSize(g.tabSize);t==="auto"?(m=!0,E.tabSize=t):typeof t=="number"&&this._tabSize!==t&&(this._tabSize=t,m=!0,E.tabSize=t)}if(typeof g.insertSpaces<"u"){const t=this._validateInsertSpaces(g.insertSpaces);t==="auto"?(m=!0,E.insertSpaces=t):this._insertSpaces!==t&&(this._insertSpaces=t,m=!0,E.insertSpaces=t)}typeof g.cursorStyle<"u"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,m=!0,E.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,m=!0,E.lineNumbers=M.TextEditorLineNumbersStyle.from(g.lineNumbers)),m&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,E))}_warnOnError(g,E){E.catch(m=>{this._logService.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this._logService.warn(m)})}}e.ExtHostTextEditorOptions=T;class O{constructor(g,E,m,t,s,a,p,S){this.id=g,this._proxy=E,this._logService=m,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=s,this._options=new T(this._proxy,this.id,a,m),this._visibleRanges=p,this._viewColumn=S;const u=this;this.value=Object.freeze({get document(){return t.getValue()},set document(C){throw(0,I.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(C){if(!(C instanceof D.Selection))throw(0,I.illegalArgument)("selection");u._selections=[C],u._trySetSelection()},get selections(){return u._selections},set selections(C){if(!Array.isArray(C)||C.some(r=>!(r instanceof D.Selection)))throw(0,I.illegalArgument)("selections");u._selections=C,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(C){throw(0,I.readonly)("visibleRanges")},get options(){return u._options.value},set options(C){u._disposed||u._options.assign(C)},get viewColumn(){return u._viewColumn},set viewColumn(C){throw(0,I.readonly)("viewColumn")},edit(C,r={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new y(t.getValue(),r);return C(c),u._applyEdit(c)},insertSnippet(C,r,c={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=u._selections.map(d=>M.Range.from(d));else if(r instanceof D.Position){const{lineNumber:d,column:l}=M.Position.from(r);n=[{startLineNumber:d,startColumn:l,endLineNumber:d,endColumn:l}]}else if(r instanceof D.Range)n=[M.Range.from(r)];else{n=[];for(const d of r)if(d instanceof D.Range)n.push(M.Range.from(d));else{const{lineNumber:l,column:f}=M.Position.from(d);n.push({startLineNumber:l,startColumn:f,endLineNumber:l,endColumn:f})}}return E.$tryInsertSnippet(g,t.getValue().version,C.value,n,c)},setDecorations(C,r){const c=r.length===0;c&&!u._hasDecorationsForKey.has(C.key)||(c?u._hasDecorationsForKey.delete(C.key):u._hasDecorationsForKey.add(C.key),u._runOnProxy(()=>{if(M.isDecorationOptionsArr(r))return E.$trySetDecorations(g,C.key,M.fromRangeOrRangeWithMessage(r));{const n=new Array(4*r.length);for(let d=0,l=r.length;d<l;d++){const f=r[d];n[4*d]=f.start.line+1,n[4*d+1]=f.start.character+1,n[4*d+2]=f.end.line+1,n[4*d+3]=f.end.character+1}return E.$trySetDecorationsFast(g,C.key,n)}}))},revealRange(C,r){u._runOnProxy(()=>E.$tryRevealRange(g,M.Range.from(C),r||D.TextEditorRevealType.Default))},show(C){E.$tryShowEditor(g,M.ViewColumn.from(C))},hide(){E.$tryHideEditor(g)}})}dispose(){(0,i.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,i.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,i.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,i.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,i.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(M.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const E=g.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const m=E.edits.map(s=>s.range);m.sort((s,a)=>s.end.line===a.end.line?s.end.character===a.end.character?s.start.line===a.start.line?s.start.character-a.start.character:s.start.line-a.start.line:s.end.character-a.end.character:s.end.line-a.end.line);for(let s=0,a=m.length-1;s<a;s++){const p=m[s].end;if(m[s+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const t=E.edits.map(s=>({range:M.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,t,{setEndOfLine:typeof E.setEndOfLine=="number"?M.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this._logService.warn(E),null))}}e.ExtHostTextEditor=O}),define(De[188],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribTerminalQuickFixes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribTerminalQuickFixes.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionLog:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionLog.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",telemetryLogger:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetryLogger.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[189],Ie([1,0,144,12,29,85,88,30,25,188,152]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const b=A.Registry.as(D.Extensions.JSONContribution);class g{constructor(u,C,r){this._messageHandler=u,this._extension=C,this._extensionPointId=r}_msg(u,C){this._messageHandler({type:u,message:C,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(u){this._msg(w.default.Error,u)}warn(u){this._msg(w.default.Warning,u)}info(u){this._msg(w.default.Info,u)}}e.ExtensionMessageCollector=g;class E{static _toSet(u){const C=new Set;for(let r=0,c=u.length;r<c;r++)C.add(y.ExtensionIdentifier.toKey(u[r].description.identifier));return C}static compute(u,C){if(!u||!u.length)return new E(C,[]);if(!C||!C.length)return new E([],u);const r=this._toSet(u),c=this._toSet(C),n=C.filter(l=>!r.has(y.ExtensionIdentifier.toKey(l.description.identifier))),d=u.filter(l=>!c.has(y.ExtensionIdentifier.toKey(l.description.identifier)));return new E(n,d)}constructor(u,C){this.added=u,this.removed=C}}e.ExtensionPointUserDelta=E;class m{constructor(u,C){this.name=u,this.defaultExtensionKind=C,this._handler=null,this._users=null,this._delta=null}setHandler(u){if(this._handler!==null)throw new Error("Handler already set!");this._handler=u,this._handle()}acceptUsers(u){this._delta=E.compute(this._users,u),this._users=u,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(u){(0,I.onUnexpectedError)(u)}}}e.ExtensionPoint=m;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[i.localize(0,null),i.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:i.localize(2,null),properties:{vscode:{type:"string",description:i.localize(3,null),default:"^1.22.0"}}},publisher:{description:i.localize(4,null),type:"string"},displayName:{description:i.localize(5,null),type:"string"},categories:{description:i.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:i.localize(7,null)}]}},galleryBanner:{type:"object",description:i.localize(8,null),properties:{color:{description:i.localize(9,null),type:"string"},theme:{description:i.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:i.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:i.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:i.localize(13,null)},enabledApiProposals:{markdownDescription:i.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}},activationEvents:{description:i.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:i.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:i.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:i.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:i.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:i.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:i.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:i.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:i.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:i.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:i.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:i.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:i.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:i.localize(28,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:i.localize(29,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:i.localize(30,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:i.localize(31,null)},{label:"onUri",body:"onUri",description:i.localize(32,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:i.localize(33,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:i.localize(34,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:i.localize(35,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:i.localize(36,null)},{label:"onRenderer",description:i.localize(37,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:i.localize(38,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:i.localize(39,null)},{label:"*",description:i.localize(40,null),body:"*"}]}},badges:{type:"array",description:i.localize(41,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:i.localize(42,null)},href:{type:"string",description:i.localize(43,null)},description:{type:"string",description:i.localize(44,null)}}}},markdown:{type:"string",description:i.localize(45,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:i.localize(46,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:i.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:i.localize(48,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:i.localize(49,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:i.localize(50,null)},{body:["workspace"],description:i.localize(51,null)},{body:["ui","workspace"],description:i.localize(52,null)},{body:["workspace","ui"],description:i.localize(53,null)},{body:[],description:i.localize(54,null)}]},capabilities:{description:i.localize(55,null),type:"object",properties:{virtualWorkspaces:{description:i.localize(56,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:i.localize(57,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(58,null),i.localize(59,null),i.localize(60,null)]},description:{type:"string",markdownDescription:i.localize(61,null)}}},untrustedWorkspaces:{description:i.localize(62,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:i.localize(63,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[i.localize(64,null),i.localize(65,null),i.localize(66,null)]},restrictedConfigurations:{description:i.localize(67,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:i.localize(68,null)}}}}},sponsor:{description:i.localize(69,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:i.localize(70,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:i.localize(71,null),type:"string"},"vscode:uninstall":{description:i.localize(72,null),type:"string"}}},icon:{type:"string",description:i.localize(73,null)},l10n:{type:"string",description:i.localize(74,null)}}};class a{constructor(){this._extensionPoints=new Map}registerExtensionPoint(u){if(this._extensionPoints.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const C=new m(u.extensionPoint,u.defaultExtensionKind);return this._extensionPoints.set(u.extensionPoint,C),e.schema.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,b.registerSchema(s,e.schema),C}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=a;const p={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(p.ExtensionsRegistry,new a),e.ExtensionsRegistry=A.Registry.as(p.ExtensionsRegistry),b.registerSchema(s,e.schema),b.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:i.localize(75,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(T.allApiProposals),markdownEnumDescriptions:Object.values(T.allApiProposals)}}]}}}})}),define(De[190],Ie([1,0,141,9,23,189,41,4]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:i.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:i.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:i.localize(2,null),default:""}}};var T;(function(g){function E(m,t,s){if(!m)return;const a=I.isString(m.type)?m.type:void 0;if(!a||a.length===0){s.error(i.localize(3,null));return}const p=[];if(Array.isArray(m.required))for(const S of m.required)I.isString(S)&&p.push(S);return{extensionId:t.value,taskType:a,required:p,properties:m.properties?w.deepClone(m.properties):{},when:m.when?D.ContextKeyExpr.deserialize(m.when):void 0}}g.from=E})(T||(T={}));const O=M.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:i.localize(4,null),type:"array",items:y}});class b{constructor(){this._onDefinitionsChanged=new A.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((E,m)=>{O.setHandler((t,s)=>{this._schema=void 0;try{for(const a of s.removed){const p=a.value;for(const S of p)this.taskTypes&&S.type&&this.taskTypes[S.type]&&delete this.taskTypes[S.type]}for(const a of s.added){const p=a.value;for(const S of p){const u=T.from(S,a.description.identifier,a.collector);u&&(this.taskTypes[u.taskType]=u)}}(s.removed.length>0||s.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}E(void 0)})})}onReady(){return this.readyPromise}get(E){return this.taskTypes[E]}all(){return Object.keys(this.taskTypes).map(E=>this.taskTypes[E])}getJsonSchema(){if(this._schema===void 0){const E=[];for(const m of this.all()){const t={type:"object",additionalProperties:!1};m.required.length>0&&(t.required=m.required.slice(0)),m.properties!==void 0?t.properties=w.deepClone(m.properties):t.properties=Object.create(null),t.properties.type={type:"string",enum:[m.taskType]},E.push(t)}this._schema={oneOf:E}}return this._schema}}e.TaskDefinitionRegistry=new b}),define(De[191],Ie([1,0,142,9,22,23,41,190]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,i.localize(0,null)),e.TASKS_CATEGORY={value:i.localize(1,null),original:"Tasks"};var y;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(R){function x(z){if(!z)return R.Strong;switch(z.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=x}(y=e.ShellQuoting||(e.ShellQuoting={}));var T;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(T=e.CommandOptions||(e.CommandOptions={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(R){function x(z){switch(z.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=x}(O=e.RevealKind||(e.RevealKind={}));var b;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(b=e.RevealProblemKind||(e.RevealProblemKind={})),function(R){function x(z){switch(z.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=x}(b=e.RevealProblemKind||(e.RevealProblemKind={}));var g;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(g=e.PanelKind||(e.PanelKind={})),function(R){function x(z){switch(z.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=x}(g=e.PanelKind||(e.PanelKind={}));var E;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:b.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(E=e.PresentationOptions||(e.PresentationOptions={}));var m;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(m=e.RuntimeType||(e.RuntimeType={})),function(R){function x(B){switch(B.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=x;function z(B){switch(B){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=z}(m=e.RuntimeType||(e.RuntimeType={}));var t;(function(R){function x(z){return I.isString(z)?z:z.value}R.value=x})(t=e.CommandString||(e.CommandString={}));var s;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function x(B){return B===R.Clean._id||B===R.Build._id||B===R.Rebuild._id||B===R.Test._id}R.is=x;function z(B){if(B!==void 0)return I.isString(B)?x(B)?{_id:B,isDefault:!1}:void 0:B}R.from=z})(s=e.TaskGroup||(e.TaskGroup={}));var a;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var p;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function x(z){switch(z){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=x})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var S;(function(R){R.parallel="parallel",R.sequence="sequence"})(S=e.DependsOrder||(e.DependsOrder={}));var u;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(u=e.RunOnOptions||(e.RunOnOptions={}));var C;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:u.default,instanceLimit:1}})(C=e.RunOptions||(e.RunOptions={}));class r{constructor(x,z,B,K,Z,ue){this._label="",this._id=x,z&&(this._label=z),B&&(this.type=B),this.runOptions=K,this.configurationProperties=Z,this._source=ue}getDefinition(x){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const x={folder:this.getFolderId(),id:this._id};return JSON.stringify(x)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(x,z=!1){if(x===void 0)return!1;if(I.isString(x))return x===this._label||x===this.configurationProperties.identifier||z&&x===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===x._key}getQualifiedLabel(){const x=this.getWorkspaceFolder();return x?`${this._label} (${x.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(x){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),x&&(this._taskLoadMessages=this._taskLoadMessages.concat(x))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=r;class c extends r{constructor(x,z,B,K,Z,ue,ne,pe){super(x,B,void 0,ne,pe,z),this.command={},this._source=z,this.hasDefinedMatchers=ue,Z&&(this.command=Z)}clone(){return new c(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(x=!1){if(x&&this._source.customizes!==void 0)return this._source.customizes;{let z;switch(this.command?this.command.runtime:void 0){case m.Shell:z="shell";break;case m.Process:z="process";break;case m.CustomExecution:z="customExecution";break;case void 0:z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:z,_key:this._id,id:this._id}}}static is(x){return x instanceof c}getMapKey(){const x=this._source.config.workspaceFolder;return x?`${x.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const x=this.getFolderId();if(!x)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:z};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(x){return new c(x._id,x._source,x._label,x.type,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.CustomTask=c;class n extends r{constructor(x,z,B,K,Z,ue,ne){super(x,B,K,ue,ne,z),this._source=z,this.configures=Z}static is(x){return x instanceof n}fromObject(x){return x}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?w.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const x=this.getFolderId();if(!x)return;let z=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(z+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:x,id:z};return JSON.stringify(B)}}e.ConfiguringTask=n;class d extends r{constructor(x,z,B,K,Z,ue,ne,pe,ae){super(x,B,K,pe,ae,z),this.defines=Z,this.hasDefinedMatchers=ne,this.command=ue,this.icon=ae.icon,this.hide=ae.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(x){return x instanceof d}getMapKey(){const x=this._source.workspaceFolder;return x?`${this._source.scope.toString()}|${x.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const x={type:"contributed",scope:this._source.scope,id:this._id};return x.folder=this.getFolderId(),JSON.stringify(x)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(x){return new d(x._id,x._source,x._label,x.type,x.defines,x.command,x.hasDefinedMatchers,x.runOptions,x.configurationProperties)}}e.ContributedTask=d;class l extends r{constructor(x,z,B,K,Z,ue){super(x,B,K,Z,ue,z),this._source=z}clone(){return new l(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(x){return x instanceof l}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(x){return new l(x._id,x._source,x._label,x.type,x.runOptions,x.configurationProperties)}}e.InMemoryTask=l;var f;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})(f=e.ExecutionEngine||(e.ExecutionEngine={})),function(R){R._default=R.Terminal}(f=e.ExecutionEngine||(e.ExecutionEngine={}));var o;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(o=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class h{constructor(x){this._order=new Map;for(let z=0;z<x.length;z++)this._order.set(x[z].uri.toString(),z)}compare(x,z){const B=x.getWorkspaceFolder(),K=z.getWorkspaceFolder();if(B&&K){let Z=this._order.get(B.uri.toString());Z=Z===void 0?0:Z+1;let ue=this._order.get(K.uri.toString());return ue=ue===void 0?0:ue+1,Z===ue?x._label.localeCompare(z._label):Z-ue}else return!B&&K?-1:B&&!K?1:0}}e.TaskSorter=h;var v;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(v=e.TaskEventKind||(e.TaskEventKind={}));var k;(function(R){R.SingleRun="singleRun",R.Background="background"})(k=e.TaskRunType||(e.TaskRunType={}));var F;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(F=e.TaskRunSource||(e.TaskRunSource={}));var j;(function(R){function x(z,B,K,Z,ue){if(B){const ne={kind:z,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:B};return z==="start"?(ne.terminalId=K,ne.resolvedVariables=Z):z==="processStarted"?ne.processId=K:z==="processEnded"&&(ne.exitCode=K),Object.freeze(ne)}else return Object.freeze({kind:"changed"})}R.create=x})(j=e.TaskEvent||(e.TaskEvent={}));var H;(function(R){function x(B){const K=Object.keys(B).sort();let Z="";for(const ue of K){let ne=B[ue];ne instanceof Object?ne=x(ne):typeof ne=="string"&&(ne=ne.replace(/,/g,",,")),Z+=ue+","+ne+","}return Z}function z(B){const Z={_key:x(B),type:B.taskType};return Object.assign(Z,B),Z}R.create=z})(H=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var P;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(P=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var U;(function(R){function x(z,B){const K=A.TaskDefinitionRegistry.get(z.type);if(K===void 0){const pe=M.deepClone(z);return delete pe._key,H.create(pe)}const Z=Object.create(null);Z.type=K.taskType;const ue=new Set;K.required.forEach(pe=>ue.add(pe));const ne=K.properties;for(const pe of Object.keys(ne)){const ae=z[pe];if(ae!=null)Z[pe]=ae;else if(ue.has(pe)){const de=ne[pe];if(de.default!==void 0)Z[pe]=M.deepClone(de.default);else switch(de.type){case"boolean":Z[pe]=!1;break;case"number":case"integer":Z[pe]=0;break;case"string":Z[pe]="";break;default:B.error(i.localize(2,null,JSON.stringify(z,void 0,0),pe));return}}}return H.create(Z)}R.createTaskIdentifier=x})(U=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[192],Ie([1,0,12]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,A)=>{this._actualOk=D,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,i.onUnexpectedError)(D))}then(D,A){return this._ensureActual().then(D,A)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=I;class w extends I{constructor(){super(),this._hasErr=!0,this._err=new i.CancellationError}}e.CanceledLazyPromise=w}),define(De[43],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class i{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++i.count}}e.ProxyIdentifier=i,i.count=0;const I=[];function w(A){const y=new i(A);return I[y.nid]=y,y}e.createProxyIdentifier=w;function M(A){return I[A].sid}e.getStringIdentifierForProxy=M;class D{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=D}),define(De[5],Ie([1,0,43]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var I;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var w;(function(t){t[t.UnknownInput=0]="UnknownInput",t[t.TextInput=1]="TextInput",t[t.TextDiffInput=2]="TextDiffInput",t[t.TextMergeInput=3]="TextMergeInput",t[t.NotebookInput=4]="NotebookInput",t[t.NotebookDiffInput=5]="NotebookDiffInput",t[t.CustomEditorInput=6]="CustomEditorInput",t[t.WebviewEditorInput=7]="WebviewEditorInput",t[t.TerminalEditorInput=8]="TerminalEditorInput",t[t.InteractiveEditorInput=9]="InteractiveEditorInput"})(w=e.TabInputKind||(e.TabInputKind={}));var M;(function(t){t[t.TAB_OPEN=0]="TAB_OPEN",t[t.TAB_CLOSE=1]="TAB_CLOSE",t[t.TAB_UPDATE=2]="TAB_UPDATE",t[t.TAB_MOVE=3]="TAB_MOVE"})(M=e.TabModelOperationKind||(e.TabModelOperationKind={}));var D;(function(t){t[t.Editable=0]="Editable",t[t.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(t){t[t.Int8Array=1]="Int8Array",t[t.Uint8Array=2]="Uint8Array",t[t.Uint8ClampedArray=3]="Uint8ClampedArray",t[t.Int16Array=4]="Int16Array",t[t.Uint16Array=5]="Uint16Array",t[t.Int32Array=6]="Int32Array",t[t.Uint32Array=7]="Uint32Array",t[t.Float32Array=8]="Float32Array",t[t.Float64Array=9]="Float64Array",t[t.BigInt64Array=10]="BigInt64Array",t[t.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(t){t[t.Text=1]="Text",t[t.Error=2]="Error",t[t.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var T;(function(t){t[t.Default=0]="Default",t[t.InCenter=1]="InCenter",t[t.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",t[t.AtTop=3]="AtTop"})(T=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(t){t[t.None=0]="None",t[t.Process=1]="Process",t[t.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class b{static mixin(s){return s._id=b._n++,s}}e.IdObject=b,b._n=0;var g;(function(t){t.label="a",t.kind="b",t.detail="c",t.documentation="d",t.sortText="e",t.filterText="f",t.preselect="g",t.insertText="h",t.insertTextRules="i",t.range="j",t.commitCharacters="k",t.additionalTextEdits="l",t.kindModifier="m",t.commandIdent="n",t.commandId="o",t.commandArguments="p"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(t){t.defaultRanges="a",t.completions="b",t.isIncomplete="c",t.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(t){t[t.Workspace=0]="Workspace",t[t.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,i.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,i.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,i.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,i.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,i.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,i.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,i.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,i.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,i.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,i.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,i.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,i.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,i.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,i.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,i.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,i.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,i.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,i.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,i.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,i.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,i.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,i.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,i.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,i.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,i.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,i.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,i.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,i.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,i.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,i.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,i.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,i.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,i.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,i.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,i.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,i.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,i.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,i.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,i.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,i.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,i.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,i.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,i.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,i.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,i.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,i.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,i.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,i.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,i.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,i.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,i.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,i.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,i.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,i.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,i.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,i.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,i.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,i.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,i.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,i.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,i.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,i.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,i.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,i.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,i.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,i.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,i.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,i.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,i.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,i.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,i.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,i.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,i.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,i.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,i.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,i.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,i.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,i.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,i.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,i.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,i.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,i.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,i.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,i.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,i.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,i.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,i.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,i.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,i.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,i.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,i.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,i.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,i.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,i.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,i.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,i.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,i.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,i.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,i.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,i.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,i.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,i.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,i.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,i.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,i.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,i.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,i.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,i.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,i.createProxyIdentifier)("ExtHostLocalization")}}),define(De[71],Ie([1,0,3,11,5,14]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,i.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(y,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(w.MainContext.MainThreadTelemetry)}report(y,T,O){const b=this.getUsageKey(y,T);this._reportedUsages.has(b)||(this._reportedUsages.add(b),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:y}))}getUsageKey(y,T){return`${y}-${T.identifier.value}`}};D=He([$e(0,M.IExtHostRpcService),$e(1,I.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,T){}})}),define(De[193],Ie([1,0,4,5,6,25]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new i.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,T,O,b={}){const g=M.ExtensionIdentifier.toKey(y.identifier),E=this._inFlightRequests.get(g)||[],m=[...O].sort().join(" ");let t=E.find(s=>s.providerId===T&&s.scopes===m);if(t)return t.result;{const s=this._getSession(y,g,T,O,b);t={providerId:T,scopes:m,result:s},E.push(t),this._inFlightRequests.set(g,E);try{await s}finally{const a=E.findIndex(p=>p.providerId===T&&p.scopes===m);a>-1&&(E.splice(a),this._inFlightRequests.set(g,E))}return s}}async _getSession(y,T,O,b,g={}){await this._proxy.$ensureProvider(O);const E=y.displayName||y.name;return this._proxy.$getSession(O,b,T,E,g)}async removeSession(y,T){const O=this._authenticationProviders.get(y);return O?O.provider.removeSession(T):this._proxy.$removeSession(y,T)}registerAuthenticationProvider(y,T,O,b){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:T,provider:O,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(E=>E.id===y)||this._providers.push({id:y,label:T});const g=O.onDidChangeSessions(E=>{this._proxy.$sendDidChangeSessions(y,{added:E.added??[],changed:E.changed??[],removed:E.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,T,b?.supportsMultipleAccounts??!1),new w.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(y);const E=this._providers.findIndex(m=>m.id===y);E>-1&&this._providers.splice(E),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,T){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,T){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,T){const O=this._authenticationProviders.get(y);if(O)return Promise.resolve(O.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,T){return this._onDidChangeSessions.fire({provider:{id:y,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(De[194],Ie([1,0,5,14,8]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let M=class{constructor(A,y){this._proxy=A.getProxy(i.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:T=>y.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,T){const O=w.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(O,void 0,T?.isRefactoring??!1)}};M=He([$e(0,I.IExtHostRpcService)],M),e.ExtHostBulkEdits=M}),define(De[195],Ie([1,0,5]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(M){const D=M.getProxy(i.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(A){return D.$writeText(A)}})}}e.ExtHostClipboard=I});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[37],Ie([1,0,9,6,8,23,5,18,11,80,52,248,2,7,3,14,96,24,43,45]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S){"use strict";var u,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let r=class{constructor(o,h){u.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,C.set(this,void 0),Ye(this,u,o.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=h,Ye(this,C,o.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new c(this,v=>{const k=this._apiCommands.get(v);return k?.result===d.Void?k:void 0},h),this._argumentProcessors=[{processArgument(v){return(0,T.revive)(v)}},{processArgument(v){return(0,M.cloneAndChange)(v,function(k){if(O.Range.isIRange(k))return w.Range.to(k);if(b.Position.isIPosition(k))return w.Position.to(k);if(O.Range.isIRange(k.range)&&g.URI.isUri(k.uri))return w.location.to(k);if(k instanceof a.VSBuffer)return k.buffer.buffer;if(!Array.isArray(k))return k})}}]}registerArgumentProcessor(o){this._argumentProcessors.push(o)}registerApiCommand(o){const h=this.registerCommand(!1,o.id,async(...v)=>{const k=o.args.map((j,H)=>{if(!j.validate(v[H]))throw new Error(`Invalid argument '${j.name}' when running '${o.id}', received: ${v[H]}`);return j.convert(v[H])}),F=await this.executeCommand(o.internalId,...k);return o.result.convert(F,v,this.converter)},void 0,{description:o.description,args:o.args,returns:o.result.description});return this._apiCommands.set(o.id,o),new I.Disposable(()=>{h.dispose(),this._apiCommands.delete(o.id)})}registerCommand(o,h,v,k,F,j){if(this._logService.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this._commands.has(h))throw new Error(`command '${h}' already exists`);return this._commands.set(h,{callback:v,thisArg:k,description:F,extension:j}),o&&Ae(this,u,"f").$registerCommand(h),new I.Disposable(()=>{this._commands.delete(h)&&o&&Ae(this,u,"f").$unregisterCommand(h)})}executeCommand(o,...h){return this._logService.trace("ExtHostCommands#executeCommand",o),this._doExecuteCommand(o,h,!0)}async _doExecuteCommand(o,h,v){if(this._commands.has(o))return Ae(this,u,"f").$fireCommandActivationEvent(o),this._executeContributedCommand(o,h,!1);{let k=!1;const F=(0,M.cloneAndChange)(h,function(j){if(j instanceof I.Position)return w.Position.from(j);if(j instanceof I.Range)return w.Range.from(j);if(j instanceof I.Location)return w.location.from(j);if(I.NotebookRange.isNotebookRange(j))return w.NotebookRange.from(j);if(j instanceof ArrayBuffer)return k=!0,a.VSBuffer.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return k=!0,a.VSBuffer.wrap(j);if(j instanceof a.VSBuffer)return k=!0,j;if(!Array.isArray(j))return j});try{const j=await Ae(this,u,"f").$executeCommand(o,k?new p.SerializableObjectWithBuffers(F):F,v);return(0,T.revive)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this._doExecuteCommand(o,h,!1);throw j}}}async _executeContributedCommand(o,h,v){const k=this._commands.get(o);if(!k)throw new Error("Unknown command");this._reportTelemetry(k,o);const{callback:F,thisArg:j,description:H}=k;if(H)for(let V=0;V<H.args.length;V++)try{(0,i.validateConstraint)(h[V],H.args[V].constraint)}catch{throw new Error(`Running the contributed command: '${o}' failed. Illegal argument '${H.args[V].name}' - ${H.args[V].description}`)}try{return await F.apply(j,h)}catch(V){if(o===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...h);P&&(o=P.command)}throw this._logService.error(V,o,k.extension?.identifier),v?new class extends Error{constructor(){super((0,S.toErrorMessage)(V)),this.id=o,this.source=k.extension?.displayName??k.extension?.name}}:V}}_reportTelemetry(o,h){!o.extension||o.extension.isBuiltin||Ae(this,C,"f").$publicLog2("Extension:ActionExecuted",{extensionId:o.extension.identifier.value,id:h})}$executeContributedCommand(o,...h){return this._logService.trace("ExtHostCommands#$executeContributedCommand",o),this._commands.has(o)?(h=h.map(v=>this._argumentProcessors.reduce((k,F)=>F.processArgument(k),v)),this._executeContributedCommand(o,h,!0)):Promise.reject(new Error(`Contributed command '${o}' does not exist.`))}getCommands(o=!1){return this._logService.trace("ExtHostCommands#getCommands",o),Ae(this,u,"f").$getCommands().then(h=>(o&&(h=h.filter(v=>v[0]!=="_")),h))}$getContributedCommandHandlerDescriptions(){const o=Object.create(null);for(const[h,v]of this._commands){const{description:k}=v;k&&(o[h]=k)}return Promise.resolve(o)}};u=new WeakMap,C=new WeakMap,r=He([$e(0,t.IExtHostRpcService),$e(1,y.ILogService)],r),e.ExtHostCommands=r,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class c{constructor(o,h,v){this._commands=o,this._lookupApiCommand=h,this._logService=v,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(o,h){if(!o)return;const v={$ident:void 0,id:o.command,title:o.title,tooltip:o.tooltip};if(!o.command)return v;const k=this._lookupApiCommand(o.command);if(k)v.id=k.internalId,v.arguments=k.args.map((F,j)=>F.convert(o.arguments&&o.arguments[j]));else if((0,A.isNonEmptyArray)(o.arguments)){const F=++this._cachIdPool;this._cache.set(F,o),h.add((0,E.toDisposable)(()=>{this._cache.delete(F),this._logService.trace("CommandsConverter#DISPOSE",F)})),v.$ident=F,v.id=this.delegatingCommandId,v.arguments=[F],this._logService.trace("CommandsConverter#CREATE",o.command,F)}return v}fromInternal(o){return typeof o.$ident=="number"?this._cache.get(o.$ident):{command:o.id,title:o.title,arguments:o.arguments}}getActualCommand(...o){return this._cache.get(o[0])}_executeConvertedCommand(...o){const h=this.getActualCommand(...o);return this._logService.trace("CommandsConverter#EXECUTE",o[0],h?h.command:"MISSING"),h?this._commands.executeCommand(h.command,...h.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=c;class n{constructor(o,h,v,k){this.name=o,this.description=h,this.validate=v,this.convert=k}optional(){return new n(this.name,`(optional) ${this.description}`,o=>o==null||this.validate(o),o=>o===void 0?void 0:o===null?null:this.convert(o))}with(o,h){return new n(o??this.name,h??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",f=>g.URI.isUri(f),f=>f),n.Position=new n("position","A position in a text document",f=>I.Position.isPosition(f),w.Position.from),n.Range=new n("range","A range in a text document",f=>I.Range.isRange(f),w.Range.from),n.Selection=new n("selection","A selection in a text document",f=>I.Selection.isSelection(f),w.Selection.from),n.Number=new n("number","",f=>typeof f=="number",f=>f),n.String=new n("string","",f=>typeof f=="string",f=>f),n.CallHierarchyItem=new n("item","A call hierarchy item",f=>f instanceof I.CallHierarchyItem,w.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",f=>f instanceof I.TypeHierarchyItem,w.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",f=>f instanceof s.TestItemImpl,w.TestItem.from);class d{constructor(o,h){this.description=o,this.convert=h}}e.ApiCommandResult=d,d.Void=new d("no result",f=>f);class l{constructor(o,h,v,k,F){this.id=o,this.internalId=h,this.description=v,this.args=k,this.result=F}}e.ApiCommand=l}),define(De[196],Ie([1,0,2,8,6,70,37,18,83,87,13]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",E(I.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,s)=>{if((0,A.isFalsyOrEmpty)(t))return;class a extends w.SymbolInformation{static to(S){const u=new a(S.name,I.SymbolKind.to(S.kind),S.containerName||"",new w.Location(s[0],I.Range.to(S.range)));return u.detail=S.detail,u.range=u.location.range,u.selectionRange=I.Range.to(S.selectionRange),u.children=S.children?S.children.map(a.to):[],u}}return t.map(a.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(I.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new D.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",E(I.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",E(I.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",E(I.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(s=>w.Position.isPosition(s)),t=>t.map(I.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(s=>{let a;for(const p of s.reverse())a=new w.SelectionRange(I.Range.to(p),a);return a}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(I.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(I.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(I.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",t=>t.map(I.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(!!t)return{range:I.Range.to(t.range),placeholder:t.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(!!t){if(t.rejectReason)throw new Error(t.rejectReason);return I.WorkspaceEdit.to(t)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(I.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new w.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const s=(0,y.decodeSemanticTokensDto)(t);if(s.type==="full")return new w.SemanticTokens(s.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(!!t)return new w.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const s=(0,y.decodeSemanticTokensDto)(t);if(s.type==="full")return new w.SemanticTokens(s.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,s,a)=>{if(!t)return new w.CompletionList([]);const p=t.suggestions.map(S=>I.CompletionItem.to(S,a));return new w.CompletionList(p,t.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return I.SignatureHelp.to(t)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,s,a)=>E(p=>new w.CodeLens(I.Range.to(p.range),p.command&&a.fromInternal(p.command)))(t))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>w.Range.isRange(t),t=>w.Selection.isSelection(t)?I.Selection.from(t):I.Range.from(t)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,s,a)=>E(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(p.command)}else{const S=new w.CodeAction(p.title,p.kind?new w.CodeActionKind(p.kind):void 0);return p.edit&&(S.edit=I.WorkspaceEdit.to(p.edit)),p.command&&(S.command=a.fromInternal(p.command)),S.isPreferred=p.isPreferred,S}})(t))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(s=>new w.ColorInformation(I.Range.to(s.range),I.Color.to(s.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",t=>t instanceof w.Color,I.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:I.Range.from(t.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(I.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,s,a)=>t.map(I.InlayHint.to.bind(void 0,a)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",E(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(s=>I.NotebookExclusiveDocumentPattern.to(s))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(I.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>i.URI.isUri(t)||typeof t=="string"&&(0,T.matchesSomeScheme)(t,O.Schemas.http,O.Schemas.https),t=>t),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[I.ViewColumn.from(t),void 0]:[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[I.ViewColumn.from(t),void 0]:[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",t=>t.map(I.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class g{static register(s){b.forEach(s.registerApiCommand,s)}}e.ExtHostApiCommands=g;function E(t){return s=>{if(Array.isArray(s))return s.map(t)}}function m(t){if(!Array.isArray(t))return;const s=[];for(const a of t)M.isLocationLink(a)?s.push(I.DefinitionLink.to(a)):s.push(I.location.to(a));return s}}),define(De[197],Ie([1,0,15,58,4,7,2,70,25,8,6,27,5]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function E(m,t,s){const a=m.getProxy(g.MainContext.MainThreadComments);class p{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,t.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const o=this._commentControllers.get(f.handle);return o?o.value:f}else if(f&&f.$mid===7){const o=this._commentControllers.get(f.commentControlHandle);if(!o)return f;const h=o.getCommentThread(f.commentThreadHandle);return h?h.value:f}else if(f&&f.$mid===8){const o=this._commentControllers.get(f.thread.commentControlHandle);if(!o)return f;const h=o.getCommentThread(f.thread.commentThreadHandle);return h?{thread:h.value,text:f.text}:f}else if(f&&f.$mid===9){const o=this._commentControllers.get(f.thread.commentControlHandle);if(!o)return f;const h=o.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const v=f.commentUniqueId,k=h.getCommentByUniqueId(v);return k||f}else if(f&&f.$mid===10){const o=this._commentControllers.get(f.thread.commentControlHandle);if(!o)return f;const h=o.getCommentThread(f.thread.commentThreadHandle);if(!h)return f;const v=f.text,k=f.commentUniqueId,F=h.getCommentByUniqueId(k);return F?(typeof F.body=="string"?F.body=v:F.body.value=v,F):f}return f}})}createCommentController(f,o,h){const v=p.handlePool++,k=new u(f,v,o,h);this._commentControllers.set(k.handle,k);const F=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(f.identifier))||[];return F.push(k),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(f.identifier),F),k.value}$createCommentThreadTemplate(f,o,h){const v=this._commentControllers.get(f);!v||v.$createCommentThreadTemplate(o,h)}async $updateCommentThreadTemplate(f,o,h){const v=this._commentControllers.get(f);!v||v.$updateCommentThreadTemplate(o,h)}$deleteCommentThread(f,o){this._commentControllers.get(f)?.$deleteCommentThread(o)}$provideCommentingRanges(f,o,h){const v=this._commentControllers.get(f);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const k=s.getDocument(D.URI.revive(o));return(0,i.asPromise)(()=>v.commentingRangeProvider.provideCommentingRanges(k,h)).then(F=>F?F.map(j=>T.Range.from(j)):void 0)}$toggleReaction(f,o,h,v,k){const F=this._commentControllers.get(f);return!F||!F.reactionHandler?Promise.resolve(void 0):(0,i.asPromise)(()=>{const j=F.getCommentThread(o);if(j){const H=j.getCommentByUniqueId(v.uniqueIdInThread);if(F!==void 0&&H&&F.reactionHandler)return F.reactionHandler(H,c(k))}return Promise.resolve(void 0)})}dispose(){}}p.handlePool=0;class S{set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get state(){return(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(f){(0,b.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=f,this.modifications.state=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}constructor(f,o,h,v,k,F,j,H){this._commentControllerHandle=o,this._id=h,this._uri=v,this._range=k,this._comments=F,this.extensionDescription=j,this._isTemplate=H,this.handle=S._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputDisposables.value=new M.DisposableStore,this._id===void 0&&(this._id=`${f}.${this.handle}`),a.$createCommentThread(o,this.handle,this._id,this._uri,T.Range.from(this._range),j.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=F,this._localDisposables.push({dispose:()=>{a.$deleteCommentThread(o,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(P){V.range=P},get comments(){return V.comments},set comments(P){V.comments=P},get collapsibleState(){return V.collapsibleState},set collapsibleState(P){V.collapsibleState=P},get canReply(){return V.canReply},set canReply(P){V.canReply=P},get contextValue(){return V.contextValue},set contextValue(P){V.contextValue=P},get label(){return V.label},set label(P){V.label=P},get state(){return V.state},set state(P){V.state=P},dispose:()=>{V.dispose()}}}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new M.DisposableStore);const f=h=>Object.prototype.hasOwnProperty.call(this.modifications,h),o={};f("range")&&(o.range=T.Range.from(this._range)),f("label")&&(o.label=this.label),f("contextValue")&&(o.contextValue=this.contextValue??null),f("comments")&&(o.comments=this._comments.map(h=>C(this,h,this._commentsMap))),f("collapsibleState")&&(o.collapseState=n(this._collapseState)),f("canReply")&&(o.canReply=this.canReply),f("state")&&(o.state=d(this._state)),f("isTemplate")&&(o.isTemplate=this._isTemplate),this.modifications={},a.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,o)}getCommentByUniqueId(f){for(const o of this._commentsMap){const h=o[0],v=o[1];if(f===v)return h}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose())}}S._handlePool=0,He([(0,I.debounce)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class u{get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(f){this._commentingRangeProvider=f,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,a.$updateCommentControllerFeatures(this.handle,{options:this._options})}constructor(f,o,h,v){this._extension=f,this._handle=o,this._id=h,this._label=v,this._threads=new Map,a.$registerCommentController(this.handle,h,v);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(F){k.options=F},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(F){k.commentingRangeProvider=F},get reactionHandler(){return k.reactionHandler},set reactionHandler(F){k.reactionHandler=F},createCommentThread(F,j,H){return k.createCommentThread(F,j,H).value},dispose:()=>{k.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(f,o,h,v){if(typeof f=="string"){const k=new S(this.id,this.handle,f,o,h,v,this._extension,!1);return this._threads.set(k.handle,k),k}else{const k=new S(this.id,this.handle,void 0,f,o,h,this._extension,!1);return this._threads.set(k.handle,k),k}}$createCommentThreadTemplate(f,o){const h=new S(this.id,this.handle,void 0,D.URI.revive(f),T.Range.to(o),[],this._extension,!0);return h.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(h.handle,h),h}$updateCommentThreadTemplate(f,o){const h=this._threads.get(f);h&&(h.range=T.Range.to(o))}$deleteCommentThread(f){this._threads.get(f)?.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._localDisposables.forEach(f=>f.dispose())}}function C(l,f,o){let h=o.get(f);h||(h=++l.commentHandle,o.set(f,h));const v=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:h,body:typeof f.body=="string"?f.body:T.MarkdownString.from(f.body),userName:f.author.name,userIconPath:v,label:f.label,commentReactions:f.reactions?f.reactions.map(k=>r(k)):void 0,timestamp:f.timestamp?.toJSON()}}function r(l){return{label:l.label,iconPath:l.iconPath?T.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function c(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?D.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function n(l){if(l!==void 0)switch(l){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function d(l){if(l!==void 0)switch(l){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new p}e.createExtHostComments=E}),define(De[198],Ie([1,0,23,5,26,14]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(O,b){this._mainThreadConsole=O.getProxy(I.MainContext.MainThreadConsole),this._includeStack=b.consoleForward.includeStack,this._logNative=b.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(O,b){const g=this,E=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){g._handleConsoleCall(O,b,E,arguments)}})}_handleConsoleCall(O,b,g,E){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:b,arguments:y(E,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(O,g,E)}};D=He([$e(0,M.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const A=1e5;function y(T,O){const b=[];if(T.length)for(let g=0;g<T.length;g++){let E=T[g];if(typeof E>"u")E="undefined";else if(E instanceof Error){const m=E;m.stack?E=m.stack:E=m.toString()}b.push(E)}if(O){const g=new Error().stack;g&&b.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,i.safeStringify)(b);return g.length>A?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(De[98],Ie([1,0,2,5,6,3,14,11,18,10,19]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class ki{constructor(E,m){this._logService=m,this._provider=new Map,this._proxy=E.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(E,m){const t=ki._handlePool++;this._provider.set(t,{provider:E,extensionId:m}),this._proxy.$registerDecorationProvider(t,m.value);const s=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(a=>{if(!a){this._proxy.$onDidChange(t,null);return}const p=(0,y.asArray)(a);if(p.length<=ki._maxEventSize){this._proxy.$onDidChange(t,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",m.value,p.length);const S=p.map(r=>({uri:r,rank:(0,T.count)(r.path,"/")})),u=(0,y.groupBy)(S,(r,c)=>r.rank-c.rank||(0,T.compare)(r.uri.path,c.uri.path)),C=[];e:for(const r of u){let c;for(const n of r){const d=(0,O.dirname)(n.uri.path);if(c!==d&&(c=d,C.push(n.uri)>=ki._maxEventSize))break e}}this._proxy.$onDidChange(t,C)});return new w.Disposable(()=>{s?.dispose(),this._proxy.$unregisterDecorationProvider(t),this._provider.delete(t)})}async $provideDecorations(E,m,t){if(!this._provider.has(E))return Object.create(null);const s=Object.create(null),{provider:a,extensionId:p}=this._provider.get(E);return await Promise.all(m.map(async S=>{try{const{uri:u,id:C}=S,r=await Promise.resolve(a.provideFileDecoration(i.URI.revive(u),t));if(!r)return;try{w.FileDecoration.validate(r),s[C]=[r.propagate,r.tooltip,r.badge,r.color]}catch(c){this._logService.warn(`INVALID decoration from extension '${p.value}': ${c}`)}}catch(u){this._logService.error(u)}})),s}};b._handlePool=0,b._maxEventSize=250,b=He([$e(0,D.IExtHostRpcService),$e(1,A.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,M.createDecorator)("IExtHostDecorations")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[199],Ie([1,0,131,86,2,5,6,8,4,11,28,36]),function(ie,e,i,I,w,M,D,A,y,T,O,b){"use strict";var g,E,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class t{constructor(p,S,u,C,r,c,n){this._name=p,this._owner=S,this._maxDiagnosticsPerFile=u,this._modelVersionIdProvider=C,g.set(this,void 0),E.set(this,void 0),m.set(this,void 0),this._isDisposed=!1,Ye(this,m,new O.ResourceMap(d=>r.getComparisonKey(d)),"f"),Ye(this,g,c,"f"),Ye(this,E,n,"f")}dispose(){this._isDisposed||(Ae(this,E,"f").fire([...Ae(this,m,"f").keys()]),Ae(this,g,"f")?.$clear(this._owner),Ae(this,m,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(p,S){if(!p){this.clear();return}this._checkDisposed();let u=[];if(w.URI.isUri(p)){if(!S){this.delete(p);return}Ae(this,m,"f").set(p,S.slice()),u=[p]}else if(Array.isArray(p)){u=[];let r;p=[...p].sort(t._compareIndexedTuplesByUri);for(const c of p){const[n,d]=c;if((!r||n.toString()!==r.toString())&&(r&&Ae(this,m,"f").get(r).length===0&&Ae(this,m,"f").delete(r),r=n,u.push(n),Ae(this,m,"f").set(n,[])),d)Ae(this,m,"f").get(n)?.push(...d);else{const l=Ae(this,m,"f").get(n);l&&(l.length=0)}}}if(Ae(this,E,"f").fire(u),!Ae(this,g,"f"))return;const C=[];for(const r of u){let c=[];const n=Ae(this,m,"f").get(r);if(n)if(n.length>this._maxDiagnosticsPerFile){c=[];const d=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const f of n)if(f.severity===d[l]&&c.push({...A.Diagnostic.from(f),modelVersionId:this._modelVersionIdProvider(r)})===this._maxDiagnosticsPerFile)break e;c.push({severity:I.MarkerSeverity.Info,message:(0,i.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=n.map(d=>({...A.Diagnostic.from(d),modelVersionId:this._modelVersionIdProvider(r)}));C.push([r,c])}Ae(this,g,"f").$changeMany(this._owner,C)}delete(p){this._checkDisposed(),Ae(this,E,"f").fire([p]),Ae(this,m,"f").delete(p),Ae(this,g,"f")?.$changeMany(this._owner,[[p,void 0]])}clear(){this._checkDisposed(),Ae(this,E,"f").fire([...Ae(this,m,"f").keys()]),Ae(this,m,"f").clear(),Ae(this,g,"f")?.$clear(this._owner)}forEach(p,S){this._checkDisposed();for(const[u,C]of this)p.call(S,u,C,this)}*[(g=new WeakMap,E=new WeakMap,m=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const p of Ae(this,m,"f").keys())yield[p,this.get(p)]}get(p){this._checkDisposed();const S=Ae(this,m,"f").get(p);return Array.isArray(S)?Object.freeze(S.slice(0)):[]}has(p){return this._checkDisposed(),Array.isArray(Ae(this,m,"f").get(p))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(p,S){return p[0].toString()<S[0].toString()?-1:p[0].toString()>S[0].toString()?1:0}}e.DiagnosticCollection=t;let s=class fi{static _mapper(p){const S=new O.ResourceMap;for(const u of p)S.set(u,u);return{uris:Object.freeze(Array.from(S.values()))}}constructor(p,S,u,C){this._logService=S,this._fileSystemInfoService=u,this._extHostDocumentsAndEditors=C,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,fi._mapper),this._proxy=p.getProxy(M.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,S){const{_collections:u,_proxy:C,_onDidChangeDiagnostics:r,_logService:c,_fileSystemInfoService:n,_extHostDocumentsAndEditors:d}=this,l=new class{$changeMany(h,v){C.$changeMany(h,v),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,h,v.length===0?"CLEARING":v)}$clear(h){C.$clear(h),c.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,h)}dispose(){C.dispose()}};let f;if(!S)S="_generated_diagnostic_collection_name_#"+fi._idPool++,f=S;else if(!u.has(S))f=S;else{this._logService.warn(`DiagnosticCollection with name '${S}' does already exist.`);do f=S+fi._idPool++;while(u.has(f))}return new class extends t{constructor(){super(S,f,fi._maxDiagnosticsPerFile,h=>d.getDocument(h)?.version,n.extUri,l,r),u.set(f,this)}dispose(){super.dispose(),u.delete(f)}}}getDiagnostics(p){if(p)return this._getDiagnostics(p);{const S=new Map,u=[];for(const C of this._collections.values())C.forEach((r,c)=>{let n=S.get(r.toString());typeof n>"u"&&(n=u.length,S.set(r.toString(),n),u.push([r,[]])),u[n][1]=u[n][1].concat(...c)});return u}}_getDiagnostics(p){let S=[];for(const u of this._collections.values())u.has(p)&&(S=S.concat(u.get(p)));return S}$acceptMarkersChange(p){if(!this._mirrorCollection){const S="_generated_mirror",u=new t(S,S,fi._maxDiagnosticsPerFile,C=>{},this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(S,u),this._mirrorCollection=u}for(const[S,u]of p)this._mirrorCollection.set(w.URI.revive(S),u.map(A.Diagnostic.to))}};s._idPool=0,s._maxDiagnosticsPerFile=1e3,s=He([$e(1,T.ILogService),$e(2,b.IExtHostFileSystemInfo)],s),e.ExtHostDiagnostics=s}),define(De[200],Ie([1,0,2,5]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(D){this._proxy=D.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(A=>A?A.map(y=>i.URI.revive(y)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(A=>A?i.URI.revive(A):void 0)}}e.ExtHostDialogs=w}),define(De[201],Ie([1,0,12,2,6,5,13,20,10]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(b,g,E){this._documentsAndEditors=g,this._logService=E,this._documentContentProviders=new Map,this._proxy=b.getProxy(M.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,g){if(Object.keys(D.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const E=T._handlePool++;this._documentContentProviders.set(E,g),this._proxy.$registerTextContentProvider(E,b);let m;return typeof g.onDidChange=="function"&&(m=g.onDidChange(t=>{if(t.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${t.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(t)&&this.$provideTextDocumentContent(E,t).then(s=>{if(!s&&typeof s!="string")return;const a=this._documentsAndEditors.getDocument(t);if(!a)return;const p=(0,y.splitLines)(s);if(!a.equalLines(p))return this._proxy.$onVirtualDocumentChange(t,s)},i.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(E)&&this._proxy.$unregisterTextContentProvider(E),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(b,g){const E=this._documentContentProviders.get(b);return E?Promise.resolve(E.provideTextDocumentContent(I.URI.revive(g),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(De[202],Ie([1,0,4,7,2,5,94,8,9,23,6]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(E,m){this._onDidAddDocument=new i.Emitter,this._onDidRemoveDocument=new i.Emitter,this._onDidChangeDocument=new i.Emitter,this._onDidSaveDocument=new i.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=E.getProxy(M.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(t=>{for(const s of t)this._onDidRemoveDocument.fire(s.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(t=>{for(const s of t)this._onDidAddDocument.fire(s.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(E){if(!E)return;const m=this._documentsAndEditors.getDocument(E);if(m)return m}getDocument(E){const m=this.getDocumentData(E);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return m.document}ensureDocumentData(E){const m=this._documentsAndEditors.getDocument(E);if(m)return Promise.resolve(m);let t=this._documentLoader.get(E.toString());return t||(t=this._proxy.$tryOpenDocument(E).then(s=>{this._documentLoader.delete(E.toString());const a=w.URI.revive(s);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(a))},s=>(this._documentLoader.delete(E.toString()),Promise.reject(s))),this._documentLoader.set(E.toString(),t)),t}createDocumentData(E){return this._proxy.$tryCreateDocument(E).then(m=>w.URI.revive(m))}$acceptModelLanguageChanged(E,m){const t=w.URI.revive(E),s=this._documentsAndEditors.getDocument(t);if(!s)throw new Error("unknown document");this._onDidRemoveDocument.fire(s.document),s._acceptLanguageId(m),this._onDidAddDocument.fire(s.document)}$acceptModelSaved(E){const m=w.URI.revive(E),t=this._documentsAndEditors.getDocument(m);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this._onDidSaveDocument.fire(t.document)}$acceptDirtyStateChanged(E,m){const t=w.URI.revive(E),s=this._documentsAndEditors.getDocument(t);if(!s)throw new Error("unknown document");s._acceptIsDirty(m),this._onDidChangeDocument.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,m,t){const s=w.URI.revive(E),a=this._documentsAndEditors.getDocument(s);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(m);let p;m.isUndoing?p=O.TextDocumentChangeReason.Undo:m.isRedoing&&(p=O.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:a.document,contentChanges:m.changes.map(S=>({range:A.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:p}))}setWordDefinitionFor(E,m){(0,D.setWordDefinitionFor)(E,m)}}e.ExtHostDocuments=b}),define(De[53],Ie([1,0,47,4,7,2,3,5,94,14,97,8,11,28,13,172,203]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count===0}}let p=class{constructor(u,C){this._extHostRpc=u,this._logService=C,this._activeEditorId=null,this._editors=new Map,this._documents=new E.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const C=[],r=[],c=[];if(u.removedDocuments)for(const n of u.removedDocuments){const d=M.URI.revive(n),l=this._documents.get(d);l?.unref()&&(this._documents.delete(d),C.push(l.value))}if(u.addedDocuments)for(const n of u.addedDocuments){const d=M.URI.revive(n.uri);let l=this._documents.get(d);if(l&&d.scheme!==m.Schemas.vscodeNotebookCell&&d.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);l||(l=new a(new y.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),d,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(d,l),r.push(l.value)),l.ref()}if(u.removedEditors)for(const n of u.removedEditors){const d=this._editors.get(n);this._editors.delete(n),d&&c.push(d)}if(u.addedEditors)for(const n of u.addedEditors){const d=M.URI.revive(n.documentUri);i.ok(this._documents.has(d),`document '${d}' does not exist`),i.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const l=this._documents.get(d).value,f=new O.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new s.Lazy(()=>l.document),n.selections.map(b.Selection.to),n.options,n.visibleRanges.map(o=>b.Range.to(o)),typeof n.editorPosition=="number"?b.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,f)}u.newActiveEditor!==void 0&&(i.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,w.dispose)(C),(0,w.dispose)(c),u.removedDocuments&&this._onDidRemoveDocuments.fire(C),u.addedDocuments&&this._onDidAddDocuments.fire(r),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){return this._documents.get(u)?.value}allDocuments(){return t.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!this._activeEditorId)return;const C=this._editors.get(this._activeEditorId);return u?C:C?.value}allEditors(){return[...this._editors.values()]}};p=He([$e(0,T.IExtHostRpcService),$e(1,g.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[54],Ie([1,0,8,5,2,4,3,6,14,9,77]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class b{constructor(s,a,p){this._activeTabIdGetter=p,this._parentGroup=a,this.acceptDtoUpdate(s)}get apiObject(){if(!this._apiObject){const s=this,a={get isActive(){return s._dto.id===s._activeTabIdGetter()},get label(){return s._dto.label},get input(){return s._input},get isDirty(){return s._dto.isDirty},get isPinned(){return s._dto.isPinned},get isPreview(){return s._dto.isPreview},get group(){return s._parentGroup.apiObject}};this._apiObject=Object.freeze(a)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(s){this._dto=s,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new A.TextTabInput(w.URI.revive(this._dto.input.uri));case 2:return new A.TextDiffTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified));case 3:return new A.TextMergeTabInput(w.URI.revive(this._dto.input.base),w.URI.revive(this._dto.input.input1),w.URI.revive(this._dto.input.input2),w.URI.revive(this._dto.input.result));case 6:return new A.CustomEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new A.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new A.NotebookEditorTabInput(w.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(w.URI.revive(this._dto.input.original),w.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(w.URI.revive(this._dto.input.uri),w.URI.revive(this._dto.input.inputBoxUri));default:return}}}class g{constructor(s,a){this._tabs=[],this._activeTabId="",this._dto=s,this._activeGroupIdGetter=a;for(const p of s.tabs)p.isActive&&(this._activeTabId=p.id),this._tabs.push(new b(p,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const s=this,a={get isActive(){return s._dto.groupId===s._activeGroupIdGetter()},get viewColumn(){return i.ViewColumn.to(s._dto.viewColumn)},get activeTab(){return s._tabs.find(p=>p.tabId===s._activeTabId)?.apiObject},get tabs(){return Object.freeze(s._tabs.map(p=>p.apiObject))}};this._apiObject=Object.freeze(a)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(s){this._dto=s}acceptTabOperation(s){if(s.kind===0){const p=new b(s.tabDto,this,()=>this.activeTabId());return this._tabs.splice(s.index,0,p),s.tabDto.isActive&&(this._activeTabId=p.tabId),p}else if(s.kind===1){const p=this._tabs.splice(s.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return p.tabId===this._activeTabId&&(this._activeTabId=""),p}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this._tabs.splice(s.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this._tabs.splice(s.index,0,p),p}const a=this._tabs.find(p=>p.tabId===s.tabDto.id);if(!a)throw new Error("INVALID tab");return s.tabDto.isActive?this._activeTabId=s.tabDto.id:this._activeTabId===s.tabDto.id&&!s.tabDto.isActive&&(this._activeTabId=""),a.acceptDtoUpdate(s.tabDto),a}activeTabId(){return this._activeTabId}}let E=class{constructor(s){this._onDidChangeTabs=new M.Emitter,this._onDidChangeTabGroups=new M.Emitter,this._extHostTabGroups=[],this._proxy=s.getProxy(I.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const s=this,a={onDidChangeTabGroups:s._onDidChangeTabGroups.event,onDidChangeTabs:s._onDidChangeTabs.event,get all(){return Object.freeze(s._extHostTabGroups.map(p=>p.apiObject))},get activeTabGroup(){const p=s._activeGroupId;return(0,T.assertIsDefined)(s._extHostTabGroups.find(u=>u.groupId===p)?.apiObject)},close:async(p,S)=>{const u=Array.isArray(p)?p:[p];return u.length?m(u[0])?this._closeGroups(u,S):this._closeTabs(u,S):!0}};this._apiObject=Object.freeze(a)}return this._apiObject}$acceptEditorTabModel(s){const a=new Set(this._extHostTabGroups.map(n=>n.groupId)),p=new Set(s.map(n=>n.groupId)),S=(0,O.diffSets)(a,p),u=this._extHostTabGroups.filter(n=>S.removed.includes(n.groupId)).map(n=>n.apiObject),C=[],r=[];this._extHostTabGroups=s.map(n=>{const d=new g(n,()=>this._activeGroupId);return S.added.includes(d.groupId)?C.push(d.apiObject):r.push(d.apiObject),d});const c=(0,T.assertIsDefined)(s.find(n=>n.isActive===!0)?.groupId);c!==void 0&&this._activeGroupId!==c&&(this._activeGroupId=c),this._onDidChangeTabGroups.fire(Object.freeze({opened:C,closed:u,changed:r}))}$acceptTabGroupUpdate(s){const a=this._extHostTabGroups.find(p=>p.groupId===s.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(s),s.isActive&&(this._activeGroupId=s.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const a=this._extHostTabGroups.find(S=>S.groupId===s.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const p=a.acceptTabOperation(s);switch(s.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}_findExtHostTabFromApi(s){for(const a of this._extHostTabGroups)for(const p of a.tabs)if(p.apiObject===s)return p}_findExtHostTabGroupFromApi(s){return this._extHostTabGroups.find(a=>a.apiObject===s)}async _closeTabs(s,a){const p=[];for(const S of s){const u=this._findExtHostTabFromApi(S);if(!u)throw new Error("Tab close: Invalid tab not found!");p.push(u.tabId)}return this._proxy.$closeTab(p,a)}async _closeGroups(s,a){const p=[];for(const S of s){const u=this._findExtHostTabGroupFromApi(S);if(!u)throw new Error("Group close: Invalid group not found!");p.push(u.groupId)}return this._proxy.$closeGroup(p,a)}};E=He([$e(0,y.IExtHostRpcService)],E),e.ExtHostEditorTabs=E;function m(t){return t.tabs!==void 0}}),define(De[204],Ie([1,0,2,5,7,6,8,249,10,24,27]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const t=this._schemes.indexOf(m);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),t=[];let s,a,p=14,S=14;for(const u of m){let C=s?(0,y.commonPrefixLength)(s,u):0;for(C===0?a=1:a=S;C<u.length;C++)C+1===u.length?(p=S,S=9):S+=1,t.push([a,u.toUpperCase().charCodeAt(C),S]),t.push([a,u.toLowerCase().charCodeAt(C),S]),a=S;s=u,S=p}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new A.StateMachine(t)}}provideDocumentLinks(m){this._initStateMachine();const t=[],s=A.LinkComputer.computeLinks({getLineContent(a){return m.lineAt(a-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const a of s){const p=D.DocumentLink.to(a);p.target&&t.push(p)}return t}}class g{constructor(m,t){this._extHostLanguageFeatures=t,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(m,t,s,a={}){if(this._registeredSchemes.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(m,"*",this._linkProvider));const p=this._handlePool++;this._linkProvider.add(t),this._registeredSchemes.add(t),this._fsProvider.set(p,s);let S=2;a.isCaseSensitive&&(S+=1024),a.isReadonly&&(S+=2048),typeof s.copy=="function"&&(S+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,O.checkProposedApiEnabled)(m,"fsChunks"),S+=4),this._proxy.$registerFileSystemProvider(p,t,S).catch(C=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${t}`),console.error(C)});const u=s.onDidChangeFile(C=>{const r=[];for(const c of C){const{uri:n,type:d}=c;if(n.scheme!==t)continue;let l;switch(d){case M.FileChangeType.Changed:l=0;break;case M.FileChangeType.Created:l=1;break;case M.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:n,type:l})}this._proxy.$onFileSystemChange(p,r)});return(0,w.toDisposable)(()=>{u.dispose(),this._linkProvider.delete(t),this._registeredSchemes.delete(t),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(m){const{type:t,ctime:s,mtime:a,size:p,permissions:S}=m;return{type:t,ctime:s,mtime:a,size:p,permissions:S}}$stat(m,t){return Promise.resolve(this._getFsProvider(m).stat(i.URI.revive(t))).then(s=>g._asIStat(s))}$readdir(m,t){return Promise.resolve(this._getFsProvider(m).readDirectory(i.URI.revive(t)))}$readFile(m,t){return Promise.resolve(this._getFsProvider(m).readFile(i.URI.revive(t))).then(s=>T.VSBuffer.wrap(s))}$writeFile(m,t,s,a){return Promise.resolve(this._getFsProvider(m).writeFile(i.URI.revive(t),s.buffer,a))}$delete(m,t,s){return Promise.resolve(this._getFsProvider(m).delete(i.URI.revive(t),s))}$rename(m,t,s,a){return Promise.resolve(this._getFsProvider(m).rename(i.URI.revive(t),i.URI.revive(s),a))}$copy(m,t,s,a){const p=this._getFsProvider(m);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(i.URI.revive(t),i.URI.revive(s),a))}$mkdir(m,t){return Promise.resolve(this._getFsProvider(m).createDirectory(i.URI.revive(t)))}$watch(m,t,s,a){const p=this._getFsProvider(m).watch(i.URI.revive(s),a);this._watches.set(t,p)}$unwatch(m,t){const s=this._watches.get(t);s&&(s.dispose(),this._watches.delete(t))}$open(m,t,s){const a=this._getFsProvider(m);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(i.URI.revive(t),s))}$close(m,t){const s=this._getFsProvider(m);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(t))}$read(m,t,s,a){const p=this._getFsProvider(m);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const S=T.VSBuffer.alloc(a);return Promise.resolve(p.read(t,s,S.buffer,0,a)).then(u=>S.slice(0,u))}$write(m,t,s,a){const p=this._getFsProvider(m);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(t,s,a.buffer,0,a.byteLength))}_getFsProvider(m){const t=this._fsProvider.get(m);if(!t){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return t}}e.ExtHostFileSystem=g}),define(De[55],Ie([1,0,5,35,6,24,3,14,36,7]),function(ie,e,i,I,w,M,D,A,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Yt{constructor(g,E){this._fileSystemProvider=new Map,this._proxy=g.getProxy(i.MainContext.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(t){try{const s=m._fileSystemProvider.get(t.scheme);if(!s)return await m._proxy.$stat(t);await m._proxy.$ensureActivation(t.scheme);const a=await s.stat(t);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(s){Yt._handleError(s)}},async readDirectory(t){try{const s=m._fileSystemProvider.get(t.scheme);return s?(await m._proxy.$ensureActivation(t.scheme),(await s.readDirectory(t)).slice()):await m._proxy.$readdir(t)}catch(s){return Yt._handleError(s)}},async createDirectory(t){try{return await m._proxy.$mkdir(t)}catch(s){return Yt._handleError(s)}},async readFile(t){try{const s=m._fileSystemProvider.get(t.scheme);return s?(await m._proxy.$ensureActivation(t.scheme),(await s.readFile(t)).slice()):(await m._proxy.$readFile(t)).buffer}catch(s){return Yt._handleError(s)}},async writeFile(t,s){try{return await m._proxy.$writeFile(t,M.VSBuffer.wrap(s))}catch(a){return Yt._handleError(a)}},async delete(t,s){try{const a=m._fileSystemProvider.get(t.scheme);return a?(await m._proxy.$ensureActivation(t.scheme),await a.delete(t,{recursive:!1,...s})):await m._proxy.$delete(t,{recursive:!1,useTrash:!1,...s})}catch(a){return Yt._handleError(a)}},async rename(t,s,a){try{return await m._proxy.$rename(t,s,{overwrite:!1,...a})}catch(p){return Yt._handleError(p)}},async copy(t,s,a){try{return await m._proxy.$copy(t,s,{overwrite:!1,...a})}catch(p){return Yt._handleError(p)}},isWritableFileSystem(t){const s=E.getCapabilities(t);if(typeof s=="number")return!(s&2048)}})}static _handleError(g){if(g instanceof w.FileSystemError)throw g;if(!(g instanceof Error))throw new w.FileSystemError(String(g));if(g.name==="ENOPRO")throw w.FileSystemError.Unavailable(g.message);switch(g.name){case I.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(g.message);case I.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(g.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(g.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(g.message);case I.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(g.message);case I.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(g.message);default:throw new w.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,E){return this._fileSystemProvider.set(g,E),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(g))}};O=He([$e(0,A.IExtHostRpcService),$e(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(De[205],Ie([1,0,4,34,2,5,8,6]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}constructor(b,g,E,m,t,s,a,p){this._onDidCreate=new i.Emitter,this._onDidChange=new i.Emitter,this._onDidDelete=new i.Emitter;const S=this.ensureWatching(b,E,t);this._config=0,s&&(this._config+=1),a&&(this._config+=2),p&&(this._config+=4);const u=(0,I.parse)(t),C=typeof t=="string",r=m(c=>{if(!s)for(const n of c.created){const d=w.URI.revive(n);u(d.fsPath)&&(!C||g.getWorkspaceFolder(d))&&this._onDidCreate.fire(d)}if(!a)for(const n of c.changed){const d=w.URI.revive(n);u(d.fsPath)&&(!C||g.getWorkspaceFolder(d))&&this._onDidChange.fire(d)}if(!p)for(const n of c.deleted){const d=w.URI.revive(n);u(d.fsPath)&&(!C||g.getWorkspaceFolder(d))&&this._onDidDelete.fire(d)}});this._disposable=A.Disposable.from(S,this._onDidCreate,this._onDidChange,this._onDidDelete,r)}ensureWatching(b,g,E){const m=A.Disposable.from();if(typeof E=="string")return m;const t=b.getProxy(M.MainContext.MainThreadFileSystem);let s=!1;(E.pattern.includes(I.GLOBSTAR)||E.pattern.includes(I.GLOB_SPLIT))&&(s=!0);const a=Math.random();return t.$watch(g.identifier.value,a,E.baseUri,{recursive:s,excludes:[]}),A.Disposable.from({dispose:()=>t.$unwatch(a)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(b,g,E){this._mainContext=b,this._logService=g,this._extHostDocumentsAndEditors=E,this._onFileSystemEvent=new i.Emitter,this._onDidRenameFile=new i.Emitter,this._onDidCreateFile=new i.Emitter,this._onDidDeleteFile=new i.Emitter,this._onWillRenameFile=new i.AsyncEmitter,this._onWillCreateFile=new i.AsyncEmitter,this._onWillDeleteFile=new i.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,g,E,m,t,s){return new y(this._mainContext,b,g,this._onFileSystemEvent.event,D.GlobPattern.from(E),m,t,s)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,g){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(E=>({oldUri:w.URI.revive(E.source),newUri:w.URI.revive(E.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(E=>w.URI.revive(E.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:g.map(E=>w.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,g){return(E,m,t)=>{const s=function(p){E.call(m,p)};return s.extension=b,g.event(s,void 0,t)}}async $onWillRunFileOperation(b,g,E,m){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(t=>({oldUri:w.URI.revive(t.source),newUri:w.URI.revive(t.target)}))},E,m);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(t=>w.URI.revive(t.target))},E,m);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(t=>w.URI.revive(t.target))},E,m)}}async _fireWillEvent(b,g,E,m){const t=new Set,s=[];if(await b.fireAsync(g,m,async(p,S)=>{const u=Date.now(),C=await Promise.resolve(p);C instanceof A.WorkspaceEdit&&(s.push([S.extension,C]),t.add(S.extension.displayName??S.extension.identifier.value)),Date.now()-u>E&&this._logService.warn("SLOW file-participant",S.extension.identifier)}),m.isCancellationRequested||s.length===0)return;const a={edits:[]};for(const[,p]of s){const{edits:S}=D.WorkspaceEdit.from(p,{getTextDocumentVersion:u=>this._extHostDocumentsAndEditors.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(S)}return{edit:a,extensionNames:Array.from(t)}}}e.ExtHostFileSystemEventService=T}),define(De[206],Ie([1,0,2,37]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(D,A,y,T,O){this._extHostNotebooks=A,this._textDocumentsAndEditors=y,this._commands=T;const b=new I.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new I.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new I.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new I.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new I.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new I.ApiCommandResult("Notebook and input URI",g=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const E=this._extHostNotebooks.getEditorById(g.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:i.URI.revive(g.notebookUri),inputUri:i.URI.revive(g.inputUri),notebookEditor:E.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:i.URI.revive(g.notebookUri),inputUri:i.URI.revive(g.inputUri)}}));this._commands.registerApiCommand(b)}$willAddInteractiveDocument(D,A,y,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(i.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=w}),define(De[207],Ie([1,0,7,5]),function(ie,e,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(D){this._handlePool=0,this._proxy=D.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,D),(0,i.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=w}),define(De[208],Ie([1,0,2,23,8,6,70,5,10,52,18,9,250,20,7,83,78,63,209,12,15,27]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S,u,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class r{constructor(_,L){this._documents=_,this._provider=L}async provideDocumentSymbols(_,L){const W=this._documents.getDocument(_),q=await this._provider.provideDocumentSymbols(W,L);if(!(0,O.isFalsyOrEmpty)(q))return q[0]instanceof M.DocumentSymbol?q.map(w.DocumentSymbol.from):r._asDocumentSymbolTree(q)}static _asDocumentSymbolTree(_){_=_.slice(0).sort((q,ee)=>{let ce=q.location.range.start.compareTo(ee.location.range.start);return ce===0&&(ce=ee.location.range.end.compareTo(q.location.range.end)),ce});const L=[],W=[];for(const q of _){const ee={name:q.name||"!!MISSING: name!!",kind:w.SymbolKind.from(q.kind),tags:q.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:w.Range.from(q.location.range),selectionRange:w.Range.from(q.location.range),children:[]};for(;;){if(W.length===0){W.push(ee),L.push(ee);break}const ce=W[W.length-1];if(T.Range.containsRange(ce.range,ee.range)&&!T.Range.equalsRange(ce.range,ee.range)){ce.children?.push(ee),W.push(ee);break}W.pop()}}return L}}class c{constructor(_,L,W){this._documents=_,this._commands=L,this._provider=W,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(_,L){const W=this._documents.getDocument(_),q=await this._provider.provideCodeLenses(W,L);if(!q||L.isCancellationRequested)return;const ee=this._cache.add(q),ce=new m.DisposableStore;this._disposables.set(ee,ce);const be={cacheId:ee,lenses:[]};for(let oe=0;oe<q.length;oe++)be.lenses.push({cacheId:[ee,oe],range:w.Range.from(q[oe].range),command:this._commands.toInternal(q[oe].command,ce)});return be}async resolveCodeLens(_,L){const W=_.cacheId&&this._cache.get(..._.cacheId);if(!W)return;let q;if(typeof this._provider.resolveCodeLens!="function"||W.isResolved?q=W:q=await this._provider.resolveCodeLens(W,L),q||(q=W),L.isCancellationRequested)return;const ee=_.cacheId&&this._disposables.get(_.cacheId[0]);if(!!ee)return _.command=this._commands.toInternal(q.command??c._badCmd,ee),_}releaseCodeLenses(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}}c._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(J){return Array.isArray(J)?J.map(w.DefinitionLink.from):J?[w.DefinitionLink.from(J)]:[]}class d{constructor(_,L){this._documents=_,this._provider=L}async provideDefinition(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.provideDefinition(q,ee,W);return n(ce)}}class l{constructor(_,L){this._documents=_,this._provider=L}async provideDeclaration(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.provideDeclaration(q,ee,W);return n(ce)}}class f{constructor(_,L){this._documents=_,this._provider=L}async provideImplementation(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.provideImplementation(q,ee,W);return n(ce)}}class o{constructor(_,L){this._documents=_,this._provider=L}async provideTypeDefinition(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.provideTypeDefinition(q,ee,W);return n(ce)}}class h{constructor(_,L){this._documents=_,this._provider=L}async provideHover(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.provideHover(q,ee,W);if(!(!ce||(0,O.isFalsyOrEmpty)(ce.contents)))return ce.range||(ce.range=q.getWordRangeAtPosition(ee)),ce.range||(ce.range=new M.Range(ee,ee)),w.Hover.from(ce)}}class v{constructor(_,L){this._documents=_,this._provider=L}async provideEvaluatableExpression(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.provideEvaluatableExpression(q,ee,W);if(ce)return w.EvaluatableExpression.from(ce)}}class k{constructor(_,L){this._documents=_,this._provider=L}async provideInlineValues(_,L,W,q){const ee=this._documents.getDocument(_),ce=await this._provider.provideInlineValues(ee,w.Range.to(L),w.InlineValueContext.to(W),q);if(Array.isArray(ce))return ce.map(be=>w.InlineValue.from(be))}}class F{constructor(_,L){this._documents=_,this._provider=L}async provideDocumentHighlights(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.provideDocumentHighlights(q,ee,W);if(Array.isArray(ce))return ce.map(w.DocumentHighlight.from)}}class j{constructor(_,L){this._documents=_,this._provider=L}async provideLinkedEditingRanges(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.provideLinkedEditingRanges(q,ee,W);if(ce&&Array.isArray(ce.ranges))return{ranges:(0,O.coalesce)(ce.ranges.map(w.Range.from)),wordPattern:ce.wordPattern}}}class H{constructor(_,L){this._documents=_,this._provider=L}async provideReferences(_,L,W,q){const ee=this._documents.getDocument(_),ce=w.Position.to(L),be=await this._provider.provideReferences(ee,ce,W,q);if(Array.isArray(be))return be.map(w.location.from)}}class V{constructor(_,L,W,q,ee,ce,be){this._documents=_,this._commands=L,this._diagnostics=W,this._provider=q,this._logService=ee,this._extension=ce,this._apiDeprecation=be,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(_,L,W,q){const ee=this._documents.getDocument(_),ce=g.Selection.isISelection(L)?w.Selection.to(L):w.Range.to(L),be=[];for(const et of this._diagnostics.getDiagnostics(_))if(ce.intersection(et.range)&&be.push(et)>V._maxCodeActionsPerFile)break;const oe={diagnostics:be,only:W.only?new M.CodeActionKind(W.only):void 0,triggerKind:w.CodeActionTriggerKind.to(W.trigger)},we=await this._provider.provideCodeActions(ee,ce,oe,q);if(!(0,O.isNonEmptyArray)(we)||q.isCancellationRequested)return;const ve=this._cache.add(we),Ue=new m.DisposableStore;this._disposables.set(ve,Ue);const ze=[];for(let et=0;et<we.length;et++){const Ke=we[et];!Ke||(V._isCommand(Ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Ke.title,command:this._commands.toInternal(Ke,Ue)})):(oe.only&&(Ke.kind?oe.only.contains(Ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action is of kind '${Ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[ve,et],title:Ke.title,command:Ke.command&&this._commands.toInternal(Ke.command,Ue),diagnostics:Ke.diagnostics&&Ke.diagnostics.map(w.Diagnostic.from),edit:Ke.edit&&w.WorkspaceEdit.from(Ke.edit,void 0),kind:Ke.kind&&Ke.kind.value,isPreferred:Ke.isPreferred,disabled:Ke.disabled?.reason})))}return{cacheId:ve,actions:ze}}async resolveCodeAction(_,L){const[W,q]=_,ee=this._cache.get(W,q);if(!ee||V._isCommand(ee)||!this._provider.resolveCodeAction)return;const ce=await this._provider.resolveCodeAction(ee,L)??ee;return ce?.edit?w.WorkspaceEdit.from(ce.edit,void 0):void 0}releaseCodeActions(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}static _isCommand(_){return typeof _.command=="string"&&typeof _.title=="string"}}V._maxCodeActionsPerFile=1e3;class P{constructor(_,L,W,q){this._proxy=_,this._documents=L,this._provider=W,this._handle=q}async prepareDocumentPaste(_,L,W,q){if(!this._provider.prepareDocumentPaste)return;const ee=this._documents.getDocument(_),ce=L.map(oe=>w.Range.to(oe)),be=w.DataTransfer.toDataTransfer(W,()=>{throw new S.NotImplementedError});return await this._provider.prepareDocumentPaste(ee,ce,be,q),w.DataTransfer.toDataTransferDTO(be)}async providePasteEdits(_,L,W,q,ee){const ce=this._documents.getDocument(L),be=W.map(ve=>w.Range.to(ve)),oe=w.DataTransfer.toDataTransfer(q,async ve=>(await this._proxy.$resolvePasteFileData(this._handle,_,ve)).buffer),we=await this._provider.provideDocumentPasteEdits(ce,be,oe,ee);if(!!we)return{insertText:typeof we.insertText=="string"?we.insertText:{snippet:we.insertText.value},additionalEdit:we.additionalEdit?w.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}}class U{constructor(_,L){this._documents=_,this._provider=L}async provideDocumentFormattingEdits(_,L,W){const q=this._documents.getDocument(_),ee=await this._provider.provideDocumentFormattingEdits(q,L,W);if(Array.isArray(ee))return ee.map(w.TextEdit.from)}}class R{constructor(_,L){this._documents=_,this._provider=L}async provideDocumentRangeFormattingEdits(_,L,W,q){const ee=this._documents.getDocument(_),ce=w.Range.to(L),be=await this._provider.provideDocumentRangeFormattingEdits(ee,ce,W,q);if(Array.isArray(be))return be.map(w.TextEdit.from)}}class x{constructor(_,L){this._documents=_,this._provider=L,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(_,L,W,q,ee){const ce=this._documents.getDocument(_),be=w.Position.to(L),oe=await this._provider.provideOnTypeFormattingEdits(ce,be,W,q,ee);if(Array.isArray(oe))return oe.map(w.TextEdit.from)}}class z{constructor(_,L){this._provider=_,this._logService=L,this._cache=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(_,L){const W=await this._provider.provideWorkspaceSymbols(_,L);if(!(0,O.isNonEmptyArray)(W))return{symbols:[]};const q=this._cache.add(W),ee={cacheId:q,symbols:[]};for(let ce=0;ce<W.length;ce++){const be=W[ce];if(!be||!be.name){this._logService.warn("INVALID SymbolInformation",be);continue}ee.symbols.push({...w.WorkspaceSymbol.from(be),cacheId:[q,ce]})}return ee}async resolveWorkspaceSymbol(_,L){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!_.cacheId)return _;const W=this._cache.get(..._.cacheId);if(W){const q=await this._provider.resolveWorkspaceSymbol(W,L);return q&&(0,I.mixin)(_,w.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(_){this._cache.delete(_)}}class B{static supportsResolving(_){return typeof _.prepareRename=="function"}constructor(_,L,W){this._documents=_,this._provider=L,this._logService=W}async provideRenameEdits(_,L,W,q){const ee=this._documents.getDocument(_),ce=w.Position.to(L);try{const be=await this._provider.provideRenameEdits(ee,ce,W,q);return be?w.WorkspaceEdit.from(be):void 0}catch(be){const oe=B._asMessage(be);return oe?{rejectReason:oe,edits:void 0}:Promise.reject(be)}}async resolveRenameLocation(_,L,W){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const q=this._documents.getDocument(_),ee=w.Position.to(L);try{const ce=await this._provider.prepareRename(q,ee,W);let be,oe;if(M.Range.isRange(ce)?(be=ce,oe=q.getText(ce)):(0,b.isObject)(ce)&&(be=ce.range,oe=ce.placeholder),!be||!oe)return;if(be.start.line>ee.line||be.end.line<ee.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(be),text:oe}}catch(ce){const be=B._asMessage(ce);return be?{rejectReason:be,range:void 0,text:void 0}:Promise.reject(ce)}}static _asMessage(_){return typeof _=="string"?_:_ instanceof Error&&typeof _.message=="string"?_.message:void 0}}class K{constructor(_,L){this.resultId=_,this.tokens=L}}class Z{constructor(_,L){this._documents=_,this._provider=L,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(_,L,W){const q=this._documents.getDocument(_),ee=L!==0?this._previousResults.get(L):null;let ce=typeof ee?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(q,ee.resultId,W):await this._provider.provideDocumentSemanticTokens(q,W);return ee&&this._previousResults.delete(L),ce?(ce=Z._fixProvidedSemanticTokens(ce),this._send(Z._convertToEdits(ee,ce),ce)):null}async releaseDocumentSemanticColoring(_){this._previousResults.delete(_)}static _fixProvidedSemanticTokens(_){return Z._isSemanticTokens(_)?Z._isCorrectSemanticTokens(_)?_:new M.SemanticTokens(new Uint32Array(_.data),_.resultId):Z._isSemanticTokensEdits(_)?Z._isCorrectSemanticTokensEdits(_)?_:new M.SemanticTokensEdits(_.edits.map(L=>new M.SemanticTokensEdit(L.start,L.deleteCount,L.data?new Uint32Array(L.data):L.data)),_.resultId):_}static _isSemanticTokens(_){return _&&!!_.data}static _isCorrectSemanticTokens(_){return _.data instanceof Uint32Array}static _isSemanticTokensEdits(_){return _&&Array.isArray(_.edits)}static _isCorrectSemanticTokensEdits(_){for(const L of _.edits)if(!(L.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(_,L){if(!Z._isSemanticTokens(L)||!_||!_.tokens)return L;const W=_.tokens,q=W.length,ee=L.data,ce=ee.length;let be=0;const oe=Math.min(q,ce);for(;be<oe&&W[be]===ee[be];)be++;if(be===q&&be===ce)return new M.SemanticTokensEdits([],L.resultId);let we=0;const ve=oe-be;for(;we<ve&&W[q-we-1]===ee[ce-we-1];)we++;return new M.SemanticTokensEdits([{start:be,deleteCount:q-be-we,data:ee.subarray(be,ce-we)}],L.resultId)}_send(_,L){if(Z._isSemanticTokens(_)){const W=this._nextResultId++;return this._previousResults.set(W,new K(_.resultId,_.data)),(0,t.encodeSemanticTokensDto)({id:W,type:"full",data:_.data})}if(Z._isSemanticTokensEdits(_)){const W=this._nextResultId++;return Z._isSemanticTokens(L)?this._previousResults.set(W,new K(L.resultId,L.data)):this._previousResults.set(W,new K(_.resultId)),(0,t.encodeSemanticTokensDto)({id:W,type:"delta",deltas:(_.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class ue{constructor(_,L){this._documents=_,this._provider=L}async provideDocumentRangeSemanticTokens(_,L,W){const q=this._documents.getDocument(_),ee=await this._provider.provideDocumentRangeSemanticTokens(q,w.Range.to(L),W);return ee?this._send(ee):null}_send(_){return(0,t.encodeSemanticTokensDto)({id:0,type:"full",data:_.data})}}class ne{static supportsResolving(_){return typeof _.resolveCompletionItem=="function"}constructor(_,L,W,q,ee){this._documents=_,this._commands=L,this._provider=W,this._apiDeprecation=q,this._extension=ee,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}async provideCompletionItems(_,L,W,q){const ee=this._documents.getDocument(_),ce=w.Position.to(L),be=ee.getWordRangeAtPosition(ce)||new M.Range(ce,ce),oe=be.with({end:ce}),we=new p.StopWatch(!0),ve=await this._provider.provideCompletionItems(ee,ce,q,w.CompletionContext.to(W));if(!ve||q.isCancellationRequested)return;const Ue=Array.isArray(ve)?new M.CompletionList(ve):ve,ze=ne.supportsResolving(this._provider)?this._cache.add(Ue.items):this._cache.add([]),et=new m.DisposableStore;this._disposables.set(ze,et);const Ke=[],tt={x:ze,b:Ke,a:{replace:w.Range.from(be),insert:w.Range.from(oe)},c:Ue.isIncomplete||void 0,d:we.elapsed()};for(let Fe=0;Fe<Ue.items.length;Fe++){const ht=Ue.items[Fe],X=this._convertCompletionItem(ht,[ze,Fe],oe,be);Ke.push(X)}return tt}async resolveCompletionItem(_,L){if(typeof this._provider.resolveCompletionItem!="function")return;const W=this._cache.get(..._);if(!W)return;const q=await this._provider.resolveCompletionItem(W,L);if(!!q)return this._convertCompletionItem(q,_)}releaseCompletionItems(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}_convertCompletionItem(_,L,W,q){const ee=this._disposables.get(L[0]);if(!ee)throw Error("DisposableStore is missing...");const ce=this._commands.toInternal(_.command,ee),be={x:L,a:_.label,b:_.kind!==void 0?w.CompletionItemKind.from(_.kind):void 0,m:_.tags&&_.tags.map(w.CompletionItemTag.from),c:_.detail,d:typeof _.documentation>"u"?void 0:w.MarkdownString.fromStrict(_.documentation),e:_.sortText!==_.label?_.sortText:void 0,f:_.filterText!==_.label?_.filterText:void 0,g:_.preselect||void 0,i:_.keepWhitespace?1:0,k:_.commitCharacters?.join(""),l:_.additionalTextEdits&&_.additionalTextEdits.map(w.TextEdit.from),n:ce?.$ident,o:ce?.id,p:ce?.$ident?void 0:ce?.arguments};_.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),be.h=_.textEdit.newText):typeof _.insertText=="string"?be.h=_.insertText:_.insertText instanceof M.SnippetString&&(be.h=_.insertText.value,be.i|=4);let oe;return _.textEdit?oe=_.textEdit.range:_.range&&(oe=_.range),M.Range.isRange(oe)?be.j=w.Range.from(oe):oe&&(!W?.isEqual(oe.inserting)||!q?.isEqual(oe.replacing))&&(be.j={insert:w.Range.from(oe.inserting),replace:w.Range.from(oe.replacing)}),be}}class pe{async provideInlineCompletions(_,L,W,q){}disposeCompletions(_){}handleDidShowCompletionItem(_,L){}}class ae extends pe{constructor(_,L,W,q){super(),this._extension=_,this._documents=L,this._provider=W,this._commands=q,this._references=new de,this._isAdditionsProposedApiEnabled=(0,C.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,C.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(_,L,W,q){const ee=this._documents.getDocument(_),ce=w.Position.to(L),be=await this._provider.provideInlineCompletionItems(ee,ce,{selectedCompletionInfo:W.selectedSuggestionInfo?{range:w.Range.to(W.selectedSuggestionInfo.range),text:W.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[W.triggerKind]},q);if(!be||q.isCancellationRequested)return;const oe=Array.isArray(be)?be:be.items,we=this._isAdditionsProposedApiEnabled?Array.isArray(be)?[]:be.commands||[]:[];let ve;return{pid:this._references.createReferenceId({dispose(){ve?.dispose()},items:oe}),items:oe.map((ze,et)=>{let Ke;ze.command&&(ve||(ve=new m.DisposableStore),Ke=this._commands.toInternal(ze.command,ve));const tt=ze.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:ze.filterText,range:ze.range?w.Range.from(ze.range):void 0,command:Ke,idx:et,completeBracketPairs:this._isAdditionsProposedApiEnabled?ze.completeBracketPairs:!1}}),commands:we.map(ze=>(ve||(ve=new m.DisposableStore),this._commands.toInternal(ze,ve)))}}disposeCompletions(_){this._references.disposeReferenceId(_)?.dispose()}handleDidShowCompletionItem(_,L){const W=this._references.get(_)?.items[L];W&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(W)}}class de{constructor(){this._references=new Map,this._idPool=1}createReferenceId(_){const L=this._idPool++;return this._references.set(L,_),L}disposeReferenceId(_){const L=this._references.get(_);return this._references.delete(_),L}get(_){return this._references.get(_)}}class Y{constructor(_,L){this._documents=_,this._provider=L,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(_,L,W,q){const ee=this._documents.getDocument(_),ce=w.Position.to(L),be=this.reviveContext(W),oe=await this._provider.provideSignatureHelp(ee,ce,q,be);if(oe){const we=this._cache.add([oe]);return{...w.SignatureHelp.from(oe),id:we}}}reviveContext(_){let L;if(_.activeSignatureHelp){const W=w.SignatureHelp.to(_.activeSignatureHelp),q=this._cache.get(_.activeSignatureHelp.id,0);q?(L=q,L.activeSignature=W.activeSignature,L.activeParameter=W.activeParameter):L=W}return{..._,activeSignatureHelp:L}}releaseSignatureHelp(_){this._cache.delete(_)}}class me{constructor(_,L,W,q,ee){this._documents=_,this._commands=L,this._provider=W,this._logService=q,this._extension=ee,this._cache=new a.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(_,L,W){const q=this._documents.getDocument(_),ee=w.Range.to(L),ce=await this._provider.provideInlayHints(q,ee,W);if(!Array.isArray(ce)||ce.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${L}`);return}if(W.isCancellationRequested)return;const be=this._cache.add(ce);this._disposables.set(be,new m.DisposableStore);const oe={hints:[],cacheId:be};for(let we=0;we<ce.length;we++)this._isValidInlayHint(ce[we],ee)&&oe.hints.push(this._convertInlayHint(ce[we],[be,we]));return this._logService.trace(`[InlayHints] ${oe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${L}`),oe}async resolveInlayHint(_,L){if(typeof this._provider.resolveInlayHint!="function")return;const W=this._cache.get(..._);if(!W)return;const q=await this._provider.resolveInlayHint(W,L);if(!!q&&!!this._isValidInlayHint(q))return this._convertInlayHint(q,_)}releaseHints(_){this._disposables.get(_)?.dispose(),this._disposables.delete(_),this._cache.delete(_)}_isValidInlayHint(_,L){return _.label.length===0||Array.isArray(_.label)&&_.label.every(W=>W.value.length===0)?(console.log("INVALID inlay hint, empty label",_),!1):!(L&&!L.contains(_.position))}_convertInlayHint(_,L){const W=this._disposables.get(L[0]);if(!W)throw Error("DisposableStore is missing...");const q={label:"",cacheId:L,tooltip:w.MarkdownString.fromStrict(_.tooltip),position:w.Position.from(_.position),textEdits:_.textEdits&&_.textEdits.map(w.TextEdit.from),kind:_.kind&&w.InlayHintKind.from(_.kind),paddingLeft:_.paddingLeft,paddingRight:_.paddingRight};return typeof _.label=="string"?q.label=_.label:q.label=_.label.map(ee=>{const ce={label:ee.value};return ce.tooltip=w.MarkdownString.fromStrict(ee.tooltip),M.Location.isLocation(ee.location)&&(ce.location=w.location.from(ee.location)),ee.command&&(ce.command=this._commands.toInternal(ee.command,W)),ce}),q}}class Se{constructor(_,L){this._documents=_,this._provider=L,this._cache=new a.Cache("DocumentLink")}async provideLinks(_,L){const W=this._documents.getDocument(_),q=await this._provider.provideDocumentLinks(W,L);if(!(!Array.isArray(q)||q.length===0)&&!L.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:q.filter(Se._validateLink).map(w.DocumentLink.from)};{const ee=this._cache.add(q),ce={links:[],cacheId:ee};for(let be=0;be<q.length;be++){if(!Se._validateLink(q[be]))continue;const oe=w.DocumentLink.from(q[be]);oe.cacheId=[ee,be],ce.links.push(oe)}return ce}}}static _validateLink(_){return _.target&&_.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(_,L){if(typeof this._provider.resolveDocumentLink!="function")return;const W=this._cache.get(..._);if(!W)return;const q=await this._provider.resolveDocumentLink(W,L);if(!(!q||!Se._validateLink(q)))return w.DocumentLink.from(q)}releaseLinks(_){this._cache.delete(_)}}class Oe{constructor(_,L){this._documents=_,this._provider=L}async provideColors(_,L){const W=this._documents.getDocument(_),q=await this._provider.provideDocumentColors(W,L);return Array.isArray(q)?q.map(ce=>({color:w.Color.from(ce.color),range:w.Range.from(ce.range)})):[]}async provideColorPresentations(_,L,W){const q=this._documents.getDocument(_),ee=w.Range.to(L.range),ce=w.Color.to(L.color),be=await this._provider.provideColorPresentations(ce,{document:q,range:ee},W);if(!!Array.isArray(be))return be.map(w.ColorPresentation.from)}}class Be{constructor(_,L){this._documents=_,this._provider=L}async provideFoldingRanges(_,L,W){const q=this._documents.getDocument(_),ee=await this._provider.provideFoldingRanges(q,L,W);if(!!Array.isArray(ee))return ee.map(w.FoldingRange.from)}}class Xe{constructor(_,L,W){this._documents=_,this._provider=L,this._logService=W}async provideSelectionRanges(_,L,W){const q=this._documents.getDocument(_),ee=L.map(w.Position.to),ce=await this._provider.provideSelectionRanges(q,ee,W);if(!(0,O.isNonEmptyArray)(ce))return[];if(ce.length!==ee.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const be=[];for(let oe=0;oe<ee.length;oe++){const we=[];be.push(we);let ve=ee[oe],Ue=ce[oe];for(;;){if(!Ue.range.contains(ve))throw new Error("INVALID selection range, must contain the previous range");if(we.push(w.SelectionRange.from(Ue)),!Ue.parent)break;ve=Ue.range,Ue=Ue.parent}}return be}}class ke{constructor(_,L){this._documents=_,this._provider=L,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.prepareCallHierarchy(q,ee,W);if(!ce)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(ce)?ce.map(oe=>this._cacheAndConvertItem(be,oe)):[this._cacheAndConvertItem(be,ce)]}async provideCallsTo(_,L,W){const q=this._itemFromCache(_,L);if(!q)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyIncomingCalls(q,W);if(!!ee)return ee.map(ce=>({from:this._cacheAndConvertItem(_,ce.from),fromRanges:ce.fromRanges.map(be=>w.Range.from(be))}))}async provideCallsFrom(_,L,W){const q=this._itemFromCache(_,L);if(!q)throw new Error("missing call hierarchy item");const ee=await this._provider.provideCallHierarchyOutgoingCalls(q,W);if(!!ee)return ee.map(ce=>({to:this._cacheAndConvertItem(_,ce.to),fromRanges:ce.fromRanges.map(be=>w.Range.from(be))}))}releaseSession(_){this._cache.delete(_)}_cacheAndConvertItem(_,L){const W=this._cache.get(_),q=w.CallHierarchyItem.from(L,_,W.size.toString(36));return W.set(q._itemId,L),q}_itemFromCache(_,L){return this._cache.get(_)?.get(L)}}class ye{constructor(_,L){this._documents=_,this._provider=L,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(_,L,W){const q=this._documents.getDocument(_),ee=w.Position.to(L),ce=await this._provider.prepareTypeHierarchy(q,ee,W);if(!ce)return;const be=this._idPool.nextId();return this._cache.set(be,new Map),Array.isArray(ce)?ce.map(oe=>this._cacheAndConvertItem(be,oe)):[this._cacheAndConvertItem(be,ce)]}async provideSupertypes(_,L,W){const q=this._itemFromCache(_,L);if(!q)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySupertypes(q,W);if(!!ee)return ee.map(ce=>this._cacheAndConvertItem(_,ce))}async provideSubtypes(_,L,W){const q=this._itemFromCache(_,L);if(!q)throw new Error("missing type hierarchy item");const ee=await this._provider.provideTypeHierarchySubtypes(q,W);if(!!ee)return ee.map(ce=>this._cacheAndConvertItem(_,ce))}releaseSession(_){this._cache.delete(_)}_cacheAndConvertItem(_,L){const W=this._cache.get(_),q=w.TypeHierarchyItem.from(L,_,W.size.toString(36));return W.set(q._itemId,L),q}_itemFromCache(_,L){return this._cache.get(_)?.get(L)}}class Ce{constructor(_,L,W,q){this._proxy=_,this._documents=L,this._provider=W,this._handle=q}async provideDocumentOnDropEdits(_,L,W,q,ee){const ce=this._documents.getDocument(L),be=w.Position.to(W),oe=w.DataTransfer.toDataTransfer(q,async ve=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,_,ve)).buffer),we=await this._provider.provideDocumentDropEdits(ce,be,oe,ee);if(!!we)return{insertText:typeof we.insertText=="string"?we.insertText:{snippet:we.insertText.value},additionalEdit:we.additionalEdit?w.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}}class se{constructor(_,L){this.adapter=_,this.extension=L}}class le{constructor(_,L,W,q,ee,ce,be,oe){this._uriTransformer=L,this._documents=W,this._commands=q,this._diagnostics=ee,this._logService=ce,this._apiDeprecation=be,this._extensionTelemetry=oe,this._adapter=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadLanguageFeatures)}_transformDocumentSelector(_){return w.DocumentSelector.from(_,this._uriTransformer)}_createDisposable(_){return new M.Disposable(()=>{this._adapter.delete(_),this._proxy.$unregister(_)})}_nextHandle(){return le._handlePool++}async _withAdapter(_,L,W,q,ee,ce=!1){const be=this._adapter.get(_);if(!be||!(be.adapter instanceof L))return q;const oe=Date.now();ce||this._logService.trace(`[${be.extension.identifier.value}] INVOKE provider '${W.toString().replace(/[\r\n]/g,"")}'`);const we=W(be.adapter,be.extension);return Promise.resolve(we).catch(ve=>{(0,S.isCancellationError)(ve)||(this._logService.error(`[${be.extension.identifier.value}] provider FAILED`),this._logService.error(ve),this._extensionTelemetry.onExtensionError(be.extension.identifier,ve))}).finally(()=>{ce||this._logService.trace(`[${be.extension.identifier.value}] provider DONE after ${Date.now()-oe}ms`)}),E.CancellationToken.isCancellationToken(ee)?(0,u.raceCancellationError)(we,ee):we}_addNewAdapter(_,L){const W=this._nextHandle();return this._adapter.set(W,new se(_,L)),W}static _extLabel(_){return _.displayName||_.name}registerDocumentSymbolProvider(_,L,W,q){const ee=this._addNewAdapter(new r(this._documents,W),_),ce=q&&q.label||le._extLabel(_);return this._proxy.$registerDocumentSymbolProvider(ee,this._transformDocumentSelector(L),ce),this._createDisposable(ee)}$provideDocumentSymbols(_,L,W){return this._withAdapter(_,r,q=>q.provideDocumentSymbols(i.URI.revive(L),W),void 0,W)}registerCodeLensProvider(_,L,W){const q=this._nextHandle(),ee=typeof W.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(q,new se(new c(this._documents,this._commands.converter,W),_)),this._proxy.$registerCodeLensSupport(q,this._transformDocumentSelector(L),ee);let ce=this._createDisposable(q);if(ee!==void 0){const be=W.onDidChangeCodeLenses(oe=>this._proxy.$emitCodeLensEvent(ee));ce=M.Disposable.from(ce,be)}return ce}$provideCodeLenses(_,L,W){return this._withAdapter(_,c,q=>q.provideCodeLenses(i.URI.revive(L),W),void 0,W)}$resolveCodeLens(_,L,W){return this._withAdapter(_,c,q=>q.resolveCodeLens(L,W),void 0,void 0)}$releaseCodeLenses(_,L){this._withAdapter(_,c,W=>Promise.resolve(W.releaseCodeLenses(L)),void 0,void 0)}registerDefinitionProvider(_,L,W){const q=this._addNewAdapter(new d(this._documents,W),_);return this._proxy.$registerDefinitionSupport(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideDefinition(_,L,W,q){return this._withAdapter(_,d,ee=>ee.provideDefinition(i.URI.revive(L),W,q),[],q)}registerDeclarationProvider(_,L,W){const q=this._addNewAdapter(new l(this._documents,W),_);return this._proxy.$registerDeclarationSupport(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideDeclaration(_,L,W,q){return this._withAdapter(_,l,ee=>ee.provideDeclaration(i.URI.revive(L),W,q),[],q)}registerImplementationProvider(_,L,W){const q=this._addNewAdapter(new f(this._documents,W),_);return this._proxy.$registerImplementationSupport(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideImplementation(_,L,W,q){return this._withAdapter(_,f,ee=>ee.provideImplementation(i.URI.revive(L),W,q),[],q)}registerTypeDefinitionProvider(_,L,W){const q=this._addNewAdapter(new o(this._documents,W),_);return this._proxy.$registerTypeDefinitionSupport(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideTypeDefinition(_,L,W,q){return this._withAdapter(_,o,ee=>ee.provideTypeDefinition(i.URI.revive(L),W,q),[],q)}registerHoverProvider(_,L,W,q){const ee=this._addNewAdapter(new h(this._documents,W),_);return this._proxy.$registerHoverProvider(ee,this._transformDocumentSelector(L)),this._createDisposable(ee)}$provideHover(_,L,W,q){return this._withAdapter(_,h,ee=>ee.provideHover(i.URI.revive(L),W,q),void 0,q)}registerEvaluatableExpressionProvider(_,L,W,q){const ee=this._addNewAdapter(new v(this._documents,W),_);return this._proxy.$registerEvaluatableExpressionProvider(ee,this._transformDocumentSelector(L)),this._createDisposable(ee)}$provideEvaluatableExpression(_,L,W,q){return this._withAdapter(_,v,ee=>ee.provideEvaluatableExpression(i.URI.revive(L),W,q),void 0,q)}registerInlineValuesProvider(_,L,W,q){const ee=typeof W.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new k(this._documents,W),_);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(L),ee);let be=this._createDisposable(ce);if(ee!==void 0){const oe=W.onDidChangeInlineValues(we=>this._proxy.$emitInlineValuesEvent(ee));be=M.Disposable.from(be,oe)}return be}$provideInlineValues(_,L,W,q,ee){return this._withAdapter(_,k,ce=>ce.provideInlineValues(i.URI.revive(L),W,q,ee),void 0,ee)}registerDocumentHighlightProvider(_,L,W){const q=this._addNewAdapter(new F(this._documents,W),_);return this._proxy.$registerDocumentHighlightProvider(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideDocumentHighlights(_,L,W,q){return this._withAdapter(_,F,ee=>ee.provideDocumentHighlights(i.URI.revive(L),W,q),void 0,q)}registerLinkedEditingRangeProvider(_,L,W){const q=this._addNewAdapter(new j(this._documents,W),_);return this._proxy.$registerLinkedEditingRangeProvider(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideLinkedEditingRanges(_,L,W,q){return this._withAdapter(_,j,async ee=>{const ce=await ee.provideLinkedEditingRanges(i.URI.revive(L),W,q);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?le._serializeRegExp(ce.wordPattern):void 0}},void 0,q)}registerReferenceProvider(_,L,W){const q=this._addNewAdapter(new H(this._documents,W),_);return this._proxy.$registerReferenceSupport(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideReferences(_,L,W,q,ee){return this._withAdapter(_,H,ce=>ce.provideReferences(i.URI.revive(L),W,q,ee),void 0,ee)}registerCodeActionProvider(_,L,W,q){const ee=new m.DisposableStore,ce=this._addNewAdapter(new V(this._documents,this._commands.converter,this._diagnostics,W,this._logService,_,this._apiDeprecation),_);return this._proxy.$registerQuickFixSupport(ce,this._transformDocumentSelector(L),{providedKinds:q?.providedCodeActionKinds?.map(be=>be.value),documentation:q?.documentation?.map(be=>({kind:be.kind.value,command:this._commands.converter.toInternal(be.command,ee)}))},le._extLabel(_),Boolean(W.resolveCodeAction)),ee.add(this._createDisposable(ce)),ee}$provideCodeActions(_,L,W,q,ee){return this._withAdapter(_,V,ce=>ce.provideCodeActions(i.URI.revive(L),W,q,ee),void 0,ee)}$resolveCodeAction(_,L,W){return this._withAdapter(_,V,q=>q.resolveCodeAction(L,W),void 0,void 0)}$releaseCodeActions(_,L){this._withAdapter(_,V,W=>Promise.resolve(W.releaseCodeActions(L)),void 0,void 0)}registerDocumentFormattingEditProvider(_,L,W){const q=this._addNewAdapter(new U(this._documents,W),_);return this._proxy.$registerDocumentFormattingSupport(q,this._transformDocumentSelector(L),_.identifier,_.displayName||_.name),this._createDisposable(q)}$provideDocumentFormattingEdits(_,L,W,q){return this._withAdapter(_,U,ee=>ee.provideDocumentFormattingEdits(i.URI.revive(L),W,q),void 0,q)}registerDocumentRangeFormattingEditProvider(_,L,W){const q=this._addNewAdapter(new R(this._documents,W),_);return this._proxy.$registerRangeFormattingSupport(q,this._transformDocumentSelector(L),_.identifier,_.displayName||_.name),this._createDisposable(q)}$provideDocumentRangeFormattingEdits(_,L,W,q,ee){return this._withAdapter(_,R,ce=>ce.provideDocumentRangeFormattingEdits(i.URI.revive(L),W,q,ee),void 0,ee)}registerOnTypeFormattingEditProvider(_,L,W,q){const ee=this._addNewAdapter(new x(this._documents,W),_);return this._proxy.$registerOnTypeFormattingSupport(ee,this._transformDocumentSelector(L),q,_.identifier),this._createDisposable(ee)}$provideOnTypeFormattingEdits(_,L,W,q,ee,ce){return this._withAdapter(_,x,be=>be.provideOnTypeFormattingEdits(i.URI.revive(L),W,q,ee,ce),void 0,ce)}registerWorkspaceSymbolProvider(_,L){const W=this._addNewAdapter(new z(L,this._logService),_);return this._proxy.$registerNavigateTypeSupport(W,typeof L.resolveWorkspaceSymbol=="function"),this._createDisposable(W)}$provideWorkspaceSymbols(_,L,W){return this._withAdapter(_,z,q=>q.provideWorkspaceSymbols(L,W),{symbols:[]},W)}$resolveWorkspaceSymbol(_,L,W){return this._withAdapter(_,z,q=>q.resolveWorkspaceSymbol(L,W),void 0,void 0)}$releaseWorkspaceSymbols(_,L){this._withAdapter(_,z,W=>W.releaseWorkspaceSymbols(L),void 0,void 0)}registerRenameProvider(_,L,W){const q=this._addNewAdapter(new B(this._documents,W,this._logService),_);return this._proxy.$registerRenameSupport(q,this._transformDocumentSelector(L),B.supportsResolving(W)),this._createDisposable(q)}$provideRenameEdits(_,L,W,q,ee){return this._withAdapter(_,B,ce=>ce.provideRenameEdits(i.URI.revive(L),W,q,ee),void 0,ee)}$resolveRenameLocation(_,L,W,q){return this._withAdapter(_,B,ee=>ee.resolveRenameLocation(i.URI.revive(L),W,q),void 0,q)}registerDocumentSemanticTokensProvider(_,L,W,q){const ee=this._addNewAdapter(new Z(this._documents,W),_),ce=typeof W.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(ee,this._transformDocumentSelector(L),q,ce);let be=this._createDisposable(ee);if(ce){const oe=W.onDidChangeSemanticTokens(we=>this._proxy.$emitDocumentSemanticTokensEvent(ce));be=M.Disposable.from(be,oe)}return be}$provideDocumentSemanticTokens(_,L,W,q){return this._withAdapter(_,Z,ee=>ee.provideDocumentSemanticTokens(i.URI.revive(L),W,q),null,q)}$releaseDocumentSemanticTokens(_,L){this._withAdapter(_,Z,W=>W.releaseDocumentSemanticColoring(L),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(_,L,W,q){const ee=this._addNewAdapter(new ue(this._documents,W),_);return this._proxy.$registerDocumentRangeSemanticTokensProvider(ee,this._transformDocumentSelector(L),q),this._createDisposable(ee)}$provideDocumentRangeSemanticTokens(_,L,W,q){return this._withAdapter(_,ue,ee=>ee.provideDocumentRangeSemanticTokens(i.URI.revive(L),W,q),null,q)}registerCompletionItemProvider(_,L,W,q){const ee=this._addNewAdapter(new ne(this._documents,this._commands.converter,W,this._apiDeprecation,_),_);return this._proxy.$registerCompletionsProvider(ee,this._transformDocumentSelector(L),q,ne.supportsResolving(W),`${_.identifier.value}(${q.join("")})`),this._createDisposable(ee)}$provideCompletionItems(_,L,W,q,ee){return this._withAdapter(_,ne,ce=>ce.provideCompletionItems(i.URI.revive(L),W,q,ee),void 0,ee)}$resolveCompletionItem(_,L,W){return this._withAdapter(_,ne,q=>q.resolveCompletionItem(L,W),void 0,W)}$releaseCompletionItems(_,L){this._withAdapter(_,ne,W=>W.releaseCompletionItems(L),void 0,void 0)}registerInlineCompletionsProvider(_,L,W){const q=new ae(_,this._documents,W,this._commands.converter),ee=this._addNewAdapter(q,_);return this._proxy.$registerInlineCompletionsSupport(ee,this._transformDocumentSelector(L),q.supportsHandleDidShowCompletionItem),this._createDisposable(ee)}$provideInlineCompletions(_,L,W,q,ee){return this._withAdapter(_,pe,ce=>ce.provideInlineCompletions(i.URI.revive(L),W,q,ee),void 0,ee)}$handleInlineCompletionDidShow(_,L,W){this._withAdapter(_,pe,async q=>{q.handleDidShowCompletionItem(L,W)},void 0,void 0)}$freeInlineCompletionsList(_,L){this._withAdapter(_,pe,async W=>{W.disposeCompletions(L)},void 0,void 0)}registerSignatureHelpProvider(_,L,W,q){const ee=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,ce=this._addNewAdapter(new Y(this._documents,W),_);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(L),ee),this._createDisposable(ce)}$provideSignatureHelp(_,L,W,q,ee){return this._withAdapter(_,Y,ce=>ce.provideSignatureHelp(i.URI.revive(L),W,q,ee),void 0,ee)}$releaseSignatureHelp(_,L){this._withAdapter(_,Y,W=>W.releaseSignatureHelp(L),void 0,void 0)}registerInlayHintsProvider(_,L,W){const q=typeof W.onDidChangeInlayHints=="function"?this._nextHandle():void 0,ee=this._addNewAdapter(new me(this._documents,this._commands.converter,W,this._logService,_),_);this._proxy.$registerInlayHintsProvider(ee,this._transformDocumentSelector(L),typeof W.resolveInlayHint=="function",q,le._extLabel(_));let ce=this._createDisposable(ee);if(q!==void 0){const be=W.onDidChangeInlayHints(oe=>this._proxy.$emitInlayHintsEvent(q));ce=M.Disposable.from(ce,be)}return ce}$provideInlayHints(_,L,W,q){return this._withAdapter(_,me,ee=>ee.provideInlayHints(i.URI.revive(L),W,q),void 0,q)}$resolveInlayHint(_,L,W){return this._withAdapter(_,me,q=>q.resolveInlayHint(L,W),void 0,W)}$releaseInlayHints(_,L){this._withAdapter(_,me,W=>W.releaseHints(L),void 0,void 0)}registerDocumentLinkProvider(_,L,W){const q=this._addNewAdapter(new Se(this._documents,W),_);return this._proxy.$registerDocumentLinkProvider(q,this._transformDocumentSelector(L),typeof W.resolveDocumentLink=="function"),this._createDisposable(q)}$provideDocumentLinks(_,L,W){return this._withAdapter(_,Se,q=>q.provideLinks(i.URI.revive(L),W),void 0,W,L.scheme==="output")}$resolveDocumentLink(_,L,W){return this._withAdapter(_,Se,q=>q.resolveLink(L,W),void 0,void 0,!0)}$releaseDocumentLinks(_,L){this._withAdapter(_,Se,W=>W.releaseLinks(L),void 0,void 0,!0)}registerColorProvider(_,L,W){const q=this._addNewAdapter(new Oe(this._documents,W),_);return this._proxy.$registerDocumentColorProvider(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideDocumentColors(_,L,W){return this._withAdapter(_,Oe,q=>q.provideColors(i.URI.revive(L),W),[],W)}$provideColorPresentations(_,L,W,q){return this._withAdapter(_,Oe,ee=>ee.provideColorPresentations(i.URI.revive(L),W,q),void 0,q)}registerFoldingRangeProvider(_,L,W){const q=this._nextHandle(),ee=typeof W.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(q,new se(new Be(this._documents,W),_)),this._proxy.$registerFoldingRangeProvider(q,this._transformDocumentSelector(L),_.identifier,ee);let ce=this._createDisposable(q);if(ee!==void 0){const be=W.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(ee));ce=M.Disposable.from(ce,be)}return ce}$provideFoldingRanges(_,L,W,q){return this._withAdapter(_,Be,ee=>ee.provideFoldingRanges(i.URI.revive(L),W,q),void 0,q)}registerSelectionRangeProvider(_,L,W){const q=this._addNewAdapter(new Xe(this._documents,W,this._logService),_);return this._proxy.$registerSelectionRangeProvider(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideSelectionRanges(_,L,W,q){return this._withAdapter(_,Xe,ee=>ee.provideSelectionRanges(i.URI.revive(L),W,q),[],q)}registerCallHierarchyProvider(_,L,W){const q=this._addNewAdapter(new ke(this._documents,W),_);return this._proxy.$registerCallHierarchyProvider(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$prepareCallHierarchy(_,L,W,q){return this._withAdapter(_,ke,ee=>Promise.resolve(ee.prepareSession(i.URI.revive(L),W,q)),void 0,q)}$provideCallHierarchyIncomingCalls(_,L,W,q){return this._withAdapter(_,ke,ee=>ee.provideCallsTo(L,W,q),void 0,q)}$provideCallHierarchyOutgoingCalls(_,L,W,q){return this._withAdapter(_,ke,ee=>ee.provideCallsFrom(L,W,q),void 0,q)}$releaseCallHierarchy(_,L){this._withAdapter(_,ke,W=>Promise.resolve(W.releaseSession(L)),void 0,void 0)}registerTypeHierarchyProvider(_,L,W){const q=this._addNewAdapter(new ye(this._documents,W),_);return this._proxy.$registerTypeHierarchyProvider(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$prepareTypeHierarchy(_,L,W,q){return this._withAdapter(_,ye,ee=>Promise.resolve(ee.prepareSession(i.URI.revive(L),W,q)),void 0,q)}$provideTypeHierarchySupertypes(_,L,W,q){return this._withAdapter(_,ye,ee=>ee.provideSupertypes(L,W,q),void 0,q)}$provideTypeHierarchySubtypes(_,L,W,q){return this._withAdapter(_,ye,ee=>ee.provideSubtypes(L,W,q),void 0,q)}$releaseTypeHierarchy(_,L){this._withAdapter(_,ye,W=>Promise.resolve(W.releaseSession(L)),void 0,void 0)}registerDocumentOnDropEditProvider(_,L,W){const q=this._nextHandle();return this._adapter.set(q,new se(new Ce(this._proxy,this._documents,W,q),_)),this._proxy.$registerDocumentOnDropEditProvider(q,this._transformDocumentSelector(L)),this._createDisposable(q)}$provideDocumentOnDropEdits(_,L,W,q,ee,ce){return this._withAdapter(_,Ce,be=>Promise.resolve(be.provideDocumentOnDropEdits(L,i.URI.revive(W),q,ee,ce)),void 0,void 0)}registerDocumentPasteEditProvider(_,L,W,q){const ee=this._nextHandle();return this._adapter.set(ee,new se(new P(this._proxy,this._documents,W,ee),_)),this._proxy.$registerPasteEditProvider(ee,this._transformDocumentSelector(L),!!W.prepareDocumentPaste,q.pasteMimeTypes),this._createDisposable(ee)}$prepareDocumentPaste(_,L,W,q,ee){return this._withAdapter(_,P,ce=>ce.prepareDocumentPaste(i.URI.revive(L),W,q,ee),void 0,ee)}$providePasteEdits(_,L,W,q,ee,ce){return this._withAdapter(_,P,be=>be.providePasteEdits(L,i.URI.revive(W),q,ee,ce),void 0,ce)}static _serializeRegExp(_){return{pattern:_.source,flags:(0,y.regExpFlags)(_)}}static _serializeIndentationRule(_){return{decreaseIndentPattern:le._serializeRegExp(_.decreaseIndentPattern),increaseIndentPattern:le._serializeRegExp(_.increaseIndentPattern),indentNextLinePattern:_.indentNextLinePattern?le._serializeRegExp(_.indentNextLinePattern):void 0,unIndentedLinePattern:_.unIndentedLinePattern?le._serializeRegExp(_.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(_){return{beforeText:le._serializeRegExp(_.beforeText),afterText:_.afterText?le._serializeRegExp(_.afterText):void 0,previousLineText:_.previousLineText?le._serializeRegExp(_.previousLineText):void 0,action:_.action}}static _serializeOnEnterRules(_){return _.map(le._serializeOnEnterRule)}setLanguageConfiguration(_,L,W){const{wordPattern:q}=W;if(q&&(0,y.regExpLeadsToEndlessLoop)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this._documents.setWordDefinitionFor(L,q):this._documents.setWordDefinitionFor(L,void 0),W.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",_,"Do not use."),W.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",_,"Do not use.");const ee=this._nextHandle(),ce={comments:W.comments,brackets:W.brackets,wordPattern:W.wordPattern?le._serializeRegExp(W.wordPattern):void 0,indentationRules:W.indentationRules?le._serializeIndentationRule(W.indentationRules):void 0,onEnterRules:W.onEnterRules?le._serializeOnEnterRules(W.onEnterRules):void 0,__electricCharacterSupport:W.__electricCharacterSupport,__characterPairSupport:W.__characterPairSupport};return this._proxy.$setLanguageConfiguration(ee,L,ce),this._createDisposable(ee)}$setWordDefinitions(_){for(const L of _)this._documents.setWordDefinitionFor(L.languageId,new RegExp(L.regexSource,L.regexFlags))}}e.ExtHostLanguageFeatures=le,le._handlePool=0}),define(De[210],Ie([1,0,5,8,6,29,15,7]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,b,g,E){this._documents=b,this._commands=g,this._uriTransformer=E,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=O.getProxy(i.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this._languageIds=O}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(O,b){await this._proxy.$changeLanguage(O,b);const g=this._documents.getDocumentData(O);if(!g)throw new Error(`document '${O.toString()}' NOT found`);return g.document}async tokenAtPosition(O,b){const g=O.version,E=I.Position.from(b),m=await this._proxy.$tokensAtPosition(O.uri,E),t={type:w.StandardTokenType.Other,range:O.getWordRangeAtPosition(b)??new w.Range(b.line,b.character,b.line,b.character)};if(!m)return t;const s={range:I.Range.to(m.range),type:I.TokenType.to(m.type)};return!s.range.contains(b)||g!==O.version?t:s}createLanguageStatusItem(O,b,g){const E=this._handlePool++,m=this._proxy,t=this._ids,s=`${O.identifier.value}/${b}`;if(t.has(s))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);t.add(s);const a={selector:g,id:b,name:O.displayName??O.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const S=new A.DisposableStore,u=()=>{p?.dispose(),p=(0,D.disposableTimeout)(()=>{S.clear(),this._proxy.$setLanguageStatus(E,{id:s,name:a.name??O.displayName??O.name,source:O.displayName??O.name,selector:I.DocumentSelector.from(a.selector,this._uriTransformer),label:a.text,detail:a.detail??"",severity:a.severity===w.LanguageStatusSeverity.Error?M.default.Error:a.severity===w.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:a.command&&this._commands.toInternal(a.command,S),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},C={dispose(){S.dispose(),p?.dispose(),m.$removeLanguageStatus(E),t.delete(s)},get id(){return a.id},get name(){return a.name},set name(r){a.name=r,u()},get selector(){return a.selector},set selector(r){a.selector=r,u()},get text(){return a.text},set text(r){a.text=r,u()},get detail(){return a.detail},set detail(r){a.detail=r,u()},get severity(){return a.severity},set severity(r){a.severity=r,u()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(r){a.accessibilityInformation=r,u()},get command(){return a.command},set command(r){a.command=r,u()},get busy(){return a.busy},set busy(r){a.busy=r,u()}};return u(),C}}e.ExtHostLanguages=y}),define(De[72],Ie([1,0,21,10,2,3,11,5,26,14]),function(ie,e,i,I,w,M,D,A,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(g,E,m){this.logService=m,this.bundleCache=new Map,this._proxy=E.getProxy(A.MainContext.MainThreadLocalization),this.currentLanguage=g.environment.appLanguage,this.isDefaultLanguage=this.currentLanguage===i.LANGUAGE_DEFAULT}getMessage(g,E){const{message:m,args:t,comment:s}=E;if(this.isDefaultLanguage)return(0,I.format2)(m,t??{});let a=m;s&&s.length>0&&(a+=`/${Array.isArray(s)?s.join():s}`);const p=this.bundleCache.get(g)?.contents[a];return p||this.logService.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,I.format2)(p??a,t??{})}getBundle(g){return this.bundleCache.get(g)?.contents}getBundleUri(g){return this.bundleCache.get(g)?.uri}async initializeLocalizedMessages(g){if(this.isDefaultLanguage||!g.l10n&&!g.isBuiltin||this.bundleCache.has(g.identifier.value))return;let E;const m=await this.getBundleLocation(g);if(!m){this.logService.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const t=await this._proxy.$fetchBundleContents(m),s=JSON.parse(t);E=g.isBuiltin?s.contents?.bundle:s}catch(t){this.logService.error(`Failed to load translations for ${g.identifier.value} from ${m}: ${t.message}`);return}E&&this.bundleCache.set(g.identifier.value,{contents:E,uri:m})}async getBundleLocation(g){if(g.isBuiltin){const E=await this._proxy.$fetchBuiltInBundleUri(g.identifier.value);return w.URI.revive(E)}return g.l10n?w.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.currentLanguage}.json`):void 0}};O=He([$e(0,y.IExtHostInitDataService),$e(1,T.IExtHostRpcService),$e(2,D.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,M.createDecorator)("IExtHostLocalizationService")}),define(De[211],Ie([1,0,11,5,26,14,2,4,9]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends i.AbstractLoggerService{constructor(g,E){super(E.logLevel,A.Event.None),this._proxy=g.getProxy(I.MainContext.MainThreadLogger)}$setLevel(g,E){E?this.setLevel(D.URI.revive(E),g):(0,y.isUndefined)(g)||this.setLevel(g)}doCreateLogger(g,E,m){return new O(this._proxy,g,E,m)}};T=He([$e(0,M.IExtHostRpcService),$e(1,w.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class O extends i.AbstractMessageLogger{constructor(g,E,m,t){super(t?.always),this.proxy=g,this.file=E,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(E,t).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,E){const m=[[g,E]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(g){this.proxy.$log(this.file,g)}}}),define(De[212],Ie([1,0,5,11,27]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function M(A){return A&&A.title}let D=class{constructor(y,T){this._logService=T,this._proxy=y.getProxy(i.MainContext.MainThreadMessageService)}showMessage(y,T,O,b,g){const E={source:{identifier:y.identifier,label:y.displayName||y.name}};let m;typeof b=="string"||M(b)?m=[b,...g]:(E.modal=b?.modal,E.useCustom=b?.useCustom,E.detail=b?.detail,m=g),E.useCustom&&(0,w.checkProposedApiEnabled)(y,"resolvers");const t=[];for(let s=0;s<m.length;s++){const a=m[s];if(typeof a=="string")t.push({title:a,handle:s,isCloseAffordance:!1});else if(typeof a=="object"){const{title:p,isCloseAffordance:S}=a;t.push({title:p,isCloseAffordance:!!S,handle:s})}else this._logService.warn("Invalid message item:",a)}return this._proxy.$showMessage(T,O,E,t).then(s=>{if(typeof s=="number")return m[s]})}};D=He([$e(1,I.ILogService)],D),e.ExtHostMessageService=D}),define(De[213],Ie([1,0,24,4,7,28,10,9,2,63,5,37,8,6,43,185,95]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class a{get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(S=>S.apiEditor)}constructor(S,u,C,r){this._textDocumentsAndEditors=C,this._textDocuments=r,this._notebookStatusBarItemProviders=new Map,this._documents=new M.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new T.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._notebookProxy=S.getProxy(O.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=S.getProxy(O.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=S.getProxy(O.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===12){const n=c.notebookEditor?.notebookUri,d=c.cell.handle,f=this._documents.get(n)?.getCell(d);if(f)return f.apiCell}if(c&&c.$mid===13){const n=c.uri,d=this._documents.get(n);if(d)return d.apiNotebook}return c}}),a._registerApiCommands(u)}getEditorById(S){const u=this._editors.get(S);if(!u)throw new Error(`unknown text editor: ${S}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(S){for(const[u,C]of this._editors)if(C.apiEditor===S)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(S,u){const C=this._documents.get(S);if(!C&&!u)throw new Error(`NO notebook document for '${S}'`);return C}static _convertNotebookRegistrationData(S,u){if(!u)return;const C=u.filenamePattern.map(r=>g.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(u.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:u.displayName,filenamePattern:C,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,u,C){const r=a._notebookStatusBarItemProviderHandlePool++,c=typeof C.onDidChangeCellStatusBarItems=="function"?a._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,c,u);let n;return c!==void 0&&(n=C.onDidChangeCellStatusBarItems(d=>this._notebookProxy.$emitCellStatusBarEvent(c))),new E.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,c),n?.dispose()})}async createNotebookDocument(S){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:S.viewType,content:S.content&&g.NotebookData.from(S.content)});return y.URI.revive(u)}async openNotebookDocument(S){const u=this._documents.get(S);if(u)return u.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(S),r=this._documents.get(y.URI.revive(C));return(0,A.assertIsDefined)(r?.apiNotebook)}async showNotebookDocument(S,u){y.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let C;typeof u=="object"?C={position:g.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(g.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:C={preserveFocus:!1};const r=await this._notebookEditorsProxy.$tryShowNotebookDocument(S.uri,S.notebookType,C),c=r&&this._editors.get(r)?.apiEditor;if(c)return c;throw r?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,u,C,r){const c=this._notebookStatusBarItemProviders.get(S),n=y.URI.revive(u),d=this._documents.get(n);if(!d||!c)return;const l=d.getCellFromIndex(C);if(!l)return;const f=await c.provideCellStatusBarItems(l.apiCell,r);if(!f)return;const o=new w.DisposableStore,h=this._statusBarCache.add([o]),k=(Array.isArray(f)?f:[f]).map(F=>g.NotebookStatusBarItem.from(F,this._commandsConverter,o));return{cacheId:h,items:k}}$releaseNotebookCellStatusBarItems(S){this._statusBarCache.delete(S)}registerNotebookSerializer(S,u,C,r,c){if((0,D.isFalsyOrWhitespace)(u))throw new Error("viewType cannot be empty or just whitespace");const n=this._handlePool++;return this._notebookSerializer.set(n,C),this._notebookProxy.$registerNotebookSerializer(n,{id:S.identifier,location:S.extensionLocation},u,g.NotebookDocumentContentOptions.from(r),a._convertNotebookRegistrationData(S,c)),(0,w.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(n)})}async $dataToNotebook(S,u,C){const r=this._notebookSerializer.get(S);if(!r)throw new Error("NO serializer found");const c=await r.deserializeNotebook(u.buffer,C);return new m.SerializableObjectWithBuffers(g.NotebookData.from(c))}async $notebookToData(S,u,C){const r=this._notebookSerializer.get(S);if(!r)throw new Error("NO serializer found");const c=await r.serializeNotebook(g.NotebookData.to(u.value),C);return i.VSBuffer.wrap(c)}_createExtHostEditor(S,u,C){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const r=new s.ExtHostNotebookEditor(u,this._notebookEditorsProxy,S,C.visibleRanges.map(g.NotebookRange.to),C.selections.map(g.NotebookRange.to),typeof C.viewColumn=="number"?g.ViewColumn.to(C.viewColumn):void 0);this._editors.set(u,r)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const C of S.value.removedDocuments){const r=y.URI.revive(C),c=this._documents.get(r);c&&(c.dispose(),this._documents.delete(r),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:c.apiNotebook.getCells().map(n=>n.document.uri)}),this._onDidCloseNotebookDocument.fire(c.apiNotebook));for(const n of this._editors.values())n.notebookData.uri.toString()===r.toString()&&this._editors.delete(n.id)}if(S.value.addedDocuments){const C=[];for(const r of S.value.addedDocuments){const c=y.URI.revive(r.uri);if(this._documents.has(c))throw new Error(`adding EXISTING notebook ${c} `);const n=new t.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,c,r);C.push(...r.cells.map(d=>t.ExtHostCell.asModelAddData(n.apiNotebook,d))),this._documents.get(c)?.dispose(),this._documents.set(c,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(S.value.addedEditors)for(const C of S.value.addedEditors){if(this._editors.has(C.id))return;const r=y.URI.revive(C.documentUri),c=this._documents.get(r);c&&this._createExtHostEditor(c,C.id,C)}const u=[];if(S.value.removedEditors)for(const C of S.value.removedEditors){const r=this._editors.get(C);r&&(this._editors.delete(C),this._activeNotebookEditor?.id===r.id&&(this._activeNotebookEditor=void 0),u.push(r))}if(S.value.visibleEditors){this._visibleNotebookEditors=S.value.visibleEditors.map(r=>this._editors.get(r)).filter(r=>!!r);const C=new Set;this._visibleNotebookEditors.forEach(r=>C.add(r.id));for(const r of this._editors.values()){const c=C.has(r.id);r._acceptVisibility(c)}this._visibleNotebookEditors=[...this._editors.values()].map(r=>r).filter(r=>r.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this._activeNotebookEditor=void 0:S.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(S){const u=b.ApiCommandArgument.String.with("notebookType","A notebook type"),C=new b.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[u,new b.ApiCommandArgument("data","Bytes to convert to data",c=>c instanceof Uint8Array,c=>i.VSBuffer.wrap(c))],new b.ApiCommandResult("Notebook Data",c=>g.NotebookData.to(c.value))),r=new b.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[u,new b.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",c=>!0,c=>new m.SerializableObjectWithBuffers(g.NotebookData.from(c)))],new b.ApiCommandResult("Bytes",c=>c.buffer));S.registerApiCommand(C),S.registerApiCommand(r)}}e.ExtHostNotebookController=a,a._notebookStatusBarItemProviderHandlePool=0}),define(De[214],Ie([1,0,18,15,20,4,7,28,2,25,11,5,37,8,6,65,173,27,43]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let S=class{constructor(d,l,f,o,h){this._initData=l,this._extHostNotebook=f,this._commands=o,this._logService=h,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new M.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=d.getProxy(b.MainContext.MainThreadNotebookKernels);const v=new g.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new g.ApiCommandArgument("options","Select kernel options",k=>!0,k=>{if(k&&"notebookEditor"in k&&"id"in k){const F=this._extHostNotebook.getIdByEditor(k.notebookEditor);return{id:k.id,extension:k.extension,notebookEditorId:F}}else if(k&&"notebookEditor"in k){const F=this._extHostNotebook.getIdByEditor(k.notebookEditor);if(F===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${k.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:F}}return k})],g.ApiCommandResult.Void);this._commands.registerApiCommand(v)}createNotebookController(d,l,f,o,h,v){for(const ne of this._kernelData.values())if(ne.controller.id===l&&T.ExtensionIdentifier.equals(d.identifier,ne.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const k=this._handlePool++,F=this;this._logService.trace(`NotebookController[${k}], CREATED by ${d.identifier.value}, ${l}`);const j=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${d.identifier}'`);let H=!1;const V=new D.DisposableStore,P=new M.Emitter,U=new M.Emitter,R={id:c(d.identifier,l),notebookType:f,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:o||d.identifier.value,preloads:v?v.map(E.NotebookRendererScript.from):[]};let x=h??j,z;this._proxy.$addKernel(k,R).catch(ne=>{console.log(ne),H=!0});let B=0;const K=()=>{if(H)return;const ne=++B;Promise.resolve().then(()=>{ne===B&&this._proxy.$updateKernel(k,R)})},Z=new A.ResourceMap,ue={get id(){return l},get notebookType(){return R.notebookType},onDidChangeSelectedNotebooks:P.event,get label(){return R.label},set label(ne){R.label=ne??d.displayName??d.name,K()},get detail(){return R.detail??""},set detail(ne){R.detail=ne,K()},get description(){return R.description??""},set description(ne){R.description=ne,K()},get kind(){return(0,a.checkProposedApiEnabled)(d,"notebookControllerKind"),R.kind??""},set kind(ne){(0,a.checkProposedApiEnabled)(d,"notebookControllerKind"),R.kind=ne,K()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(ne){R.supportedLanguages=ne,K()},get supportsExecutionOrder(){return R.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){R.supportsExecutionOrder=ne,K()},get rendererScripts(){return R.preloads?R.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return x},set executeHandler(ne){x=ne??j},get interruptHandler(){return z},set interruptHandler(ne){z=ne,R.supportsInterrupt=Boolean(ne),K()},createNotebookCellExecution(ne){if(H)throw new Error("notebook controller is DISPOSED");if(!Z.has(ne.notebook.uri))throw F._logService.trace(`NotebookController[${k}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(pe=>pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return F._createNotebookCellExecution(ne,c(d.identifier,this.id))},dispose:()=>{H||(this._logService.trace(`NotebookController[${k}], DISPOSED`),H=!0,this._kernelData.delete(k),V.dispose(),P.dispose(),U.dispose(),this._proxy.$removeKernel(k))},updateNotebookAffinity(ne,pe){pe===m.NotebookControllerAffinity2.Hidden&&(0,a.checkProposedApiEnabled)(d,"notebookControllerAffinityHidden"),F._proxy.$updateNotebookPriority(k,ne.uri,pe)},onDidReceiveMessage:U.event,postMessage(ne,pe){return(0,a.checkProposedApiEnabled)(d,"notebookMessaging"),F._proxy.$postMessage(k,pe&&F._extHostNotebook.getIdByEditor(pe),ne)},asWebviewUri(ne){return(0,a.checkProposedApiEnabled)(d,"notebookMessaging"),(0,t.asWebviewUri)(ne,F._initData.remote)}};return this._kernelData.set(k,{extensionId:d.identifier,controller:ue,onDidReceiveMessage:U,onDidChangeSelection:P,associatedNotebooks:Z}),ue}getIdByController(d){for(const[l,f]of this._kernelData)if(f.controller===d)return c(f.extensionId,d.id);return null}$acceptNotebookAssociation(d,l,f){const o=this._kernelData.get(d);if(o){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l));f?o.associatedNotebooks.set(h.uri,!0):o.associatedNotebooks.delete(h.uri),this._logService.trace(`NotebookController[${d}] ASSOCIATE notebook`,h.uri.toString(),f),o.onDidChangeSelection.fire({selected:f,notebook:h.apiNotebook})}}async $executeCells(d,l,f){const o=this._kernelData.get(d);if(!o)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l)),v=[];for(const k of f){const F=h.getCell(k);F&&v.push(F.apiCell)}try{this._logService.trace(`NotebookController[${d}] EXECUTE cells`,h.uri.toString(),v.length),await o.controller.executeHandler.call(o.controller,v,h.apiNotebook,o.controller)}catch(k){this._logService.error(`NotebookController[${d}] execute cells FAILED`,k),console.error(k)}}async $cancelCells(d,l,f){const o=this._kernelData.get(d);if(!o)return;const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(l));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,h.apiNotebook);else for(const v of f){const k=h.getCell(v);k&&this._activeExecutions.get(k.uri)?.cancel()}}$acceptKernelMessageFromRenderer(d,l,f){const o=this._kernelData.get(d);if(!o)return;const h=this._extHostNotebook.getEditorById(l);o.onDidReceiveMessage.fire(Object.freeze({editor:h.apiEditor,message:f}))}$cellExecutionChanged(d,l,f){const h=this._extHostNotebook.getNotebookDocument(y.URI.revive(d)).getCell(l);if(h){const v=f?E.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;v!==void 0&&this._onDidChangeCellExecutionState.fire({cell:h.apiCell,state:v})}}_createNotebookCellExecution(d,l){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const h=new C(l,o,this._proxy);this._activeExecutions.set(o.uri,h);const v=h.onDidChangeState(()=>{h.state===u.Resolved&&(h.dispose(),v.dispose(),this._activeExecutions.delete(o.uri))});return h.asApiObject()}};S=He([$e(4,O.ILogService)],S),e.ExtHostNotebookKernels=S;var u;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(u||(u={}));class C extends D.Disposable{get state(){return this._state}constructor(d,l,f){super(),this._cell=l,this._proxy=f,this._handle=C.HANDLE++,this._onDidChangeState=new M.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=u.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new r(10,o=>this.update(o)),this._executionOrder=l.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,d,this._cell.notebook.uri,this._cell.handle)}cancel(){this._tokenSource.cancel()}async updateSoon(d){await this._collector.addItem(d)}async update(d){const l=Array.isArray(d)?d:[d];return this._proxy.$updateExecution(this._handle,new p.SerializableObjectWithBuffers(l))}verifyStateForOutput(){if(this._state===u.Init)throw new Error("Must call start before modifying cell output");if(this._state===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(d){let l=this._cell;if(d&&(l=this._cell.notebook.getCellFromApiCell(d)),!l)throw new Error("INVALID cell");return l.handle}validateAndConvertOutputs(d){return d.map(l=>{const f=m.NotebookCellOutput.ensureUniqueMimeTypes(l.items,!0);return f===l.items?E.NotebookCellOutput.from(l):E.NotebookCellOutput.from({items:f,id:l.id,metadata:l.metadata})})}async updateOutputs(d,l,f){const o=this.cellIndexToHandle(l),h=this.validateAndConvertOutputs((0,i.asArray)(d));return this.updateSoon({editType:s.CellExecutionUpdateType.Output,cellHandle:o,append:f,outputs:h})}async updateOutputItems(d,l,f){return d=m.NotebookCellOutput.ensureUniqueMimeTypes((0,i.asArray)(d),!0),this.updateSoon({editType:s.CellExecutionUpdateType.OutputItems,items:d.map(E.NotebookCellOutputItem.from),outputId:l.id,append:f})}asApiObject(){const d=this;return Object.freeze({get token(){return d._tokenSource.token},get cell(){return d._cell.apiCell},get executionOrder(){return d._executionOrder},set executionOrder(f){d._executionOrder=f,d.update([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:d._executionOrder}])},start(f){if(d._state===u.Resolved||d._state===u.Started)throw new Error("Cannot call start again");d._state=u.Started,d._onDidChangeState.fire(),d.update({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,o){if(d._state===u.Resolved)throw new Error("Cannot call resolve twice");d._state=u.Resolved,d._onDidChangeState.fire(),d._collector.flush(),d._proxy.$completeExecution(d._handle,new p.SerializableObjectWithBuffers({runEndTime:o,lastRunSuccess:f}))},clearOutput(f){return d.verifyStateForOutput(),d.updateOutputs([],f,!1)},appendOutput(f,o){return d.verifyStateForOutput(),d.updateOutputs(f,o,!0)},replaceOutput(f,o){return d.verifyStateForOutput(),d.updateOutputs(f,o,!1)},appendOutputItems(f,o){return d.verifyStateForOutput(),d.updateOutputItems(f,o,!0)},replaceOutputItems(f,o){return d.verifyStateForOutput(),d.updateOutputItems(f,o,!1)}})}}C.HANDLE=0;class r{constructor(d,l){this.delay=d,this.callback=l,this.batch=[],this.startedTimer=Date.now()}addItem(d){return this.batch.push(d),this.currentDeferred||(this.currentDeferred=new I.DeferredPromise,this.startedTimer=Date.now(),(0,I.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const d=this.currentDeferred;this.currentDeferred=void 0;const l=this.batch;return this.batch=[],this.callback(l).finally(()=>d.complete())}}function c(n,d){return`${n.value}/${d}`}e.createKernelId=c}),define(De[215],Ie([1,0,4,5,95]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class M{constructor(A,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=A.getProxy(I.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,T){const O=this._extHostNotebook.getEditorById(A);this._rendererMessageEmitters.get(y)?.fire({editor:O.apiEditor,message:T})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,b,g)=>this.getOrCreateEmitterFor(y).event(O,b,g),postMessage:(O,b)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,b]=[b,O]);const g=b&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(b);return this.proxy.$postMessage(g?.id,y,O)}}}getOrCreateEmitterFor(A){let y=this._rendererMessageEmitters.get(A);return y||(y=new i.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this._rendererMessageEmitters.delete(A)}}),this._rendererMessageEmitters.set(A,y),y)}}e.ExtHostNotebookRenderers=M}),define(De[216],Ie([1,0,20,4,7,5,2,6,12,18,29,62]),function(ie,e,i,I,w,M,D,A,y,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(E,m,t){const s=E.getProxy(M.MainContext.MainThreadQuickOpen);class a{constructor(l,f){this._sessions=new Map,this._instances=0,this._workspace=l,this._commands=f}showQuickPick(l,f,o=i.CancellationToken.None){this._onDidSelectItem=void 0;const h=Promise.resolve(l),v=++this._instances,k=s.$show(v,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},o),F={},j=k.then(()=>F);return Promise.race([j,h]).then(H=>{if(H!==F)return h.then(V=>{const P=[];for(let U=0;U<V.length;U++){const R=V[U];typeof R=="string"?P.push({label:R,handle:U}):R.kind===A.QuickPickItemKind.Separator?P.push({type:"separator",label:R.label}):P.push({label:R.label,description:R.description,detail:R.detail,picked:R.picked,alwaysShow:R.alwaysShow,handle:U})}return f&&typeof f.onDidSelectItem=="function"&&(this._onDidSelectItem=U=>{f.onDidSelectItem(V[U])}),s.$setItems(v,P),k.then(U=>{if(typeof U=="number")return V[U];if(Array.isArray(U))return U.map(R=>V[R])})})}).then(void 0,H=>{if(!(0,y.isCancellationError)(H))return s.$setError(v,H),Promise.reject(H)})}$onItemSelected(l){this._onDidSelectItem?.(l)}showInput(l,f=i.CancellationToken.None){return this._validateInput=l?.validateInput,s.$input(l,typeof this._validateInput=="function",f).then(void 0,o=>{if(!(0,y.isCancellationError)(o))return Promise.reject(o)})}async $validateInput(l){if(!this._validateInput)return;const f=await this._validateInput(l);if(!f||typeof f=="string")return f;let o;switch(f.severity){case A.InputBoxValidationSeverity.Info:o=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:o=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:o=O.default.Error;break;default:o=f.message?O.default.Error:O.default.Ignore;break}return{content:f.message,severity:o}}async showWorkspaceFolderPick(l,f=i.CancellationToken.None){const o=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!o)return;const h=await this._workspace.getWorkspaceFolders2();if(!!h)return h.find(v=>v.uri.toString()===o.uri.toString())}createQuickPick(l){const f=new c(l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}createInputBox(l){const f=new n(l,()=>this._sessions.delete(f._id));return this._sessions.set(f._id,f),f}$onDidChangeValue(l,f){this._sessions.get(l)?._fireDidChangeValue(f)}$onDidAccept(l){this._sessions.get(l)?._fireDidAccept()}$onDidChangeActive(l,f){const o=this._sessions.get(l);o instanceof c&&o._fireDidChangeActive(f)}$onDidChangeSelection(l,f){const o=this._sessions.get(l);o instanceof c&&o._fireDidChangeSelection(f)}$onDidTriggerButton(l,f){this._sessions.get(l)?._fireDidTriggerButton(f)}$onDidTriggerItemButton(l,f,o){const h=this._sessions.get(l);h instanceof c&&h._fireDidTriggerItemButton(f,o)}$onDidHide(l){this._sessions.get(l)?._fireDidHide()}}class p{constructor(l,f){this._extensionId=l,this._onDidDispose=f,this._id=c._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new I.Emitter,this._onDidChangeValueEmitter=new I.Emitter,this._onDidTriggerButtonEmitter=new I.Emitter,this._onDidHideEmitter=new I.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(l){this._title=l,this.update({title:l})}get step(){return this._steps}set step(l){this._steps=l,this.update({step:l})}get totalSteps(){return this._totalSteps}set totalSteps(l){this._totalSteps=l,this.update({totalSteps:l})}get enabled(){return this._enabled}set enabled(l){this._enabled=l,this.update({enabled:l})}get busy(){return this._busy}set busy(l){this._busy=l,this.update({busy:l})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(l){this._ignoreFocusOut=l,this.update({ignoreFocusOut:l})}get value(){return this._value}set value(l){this._value=l,this.update({value:l})}get placeholder(){return this._placeholder}set placeholder(l){this._placeholder=l,this.update({placeholder:l})}get buttons(){return this._buttons}set buttons(l){this._buttons=l.slice(),this._handlesToButtons.clear(),l.forEach((f,o)=>{const h=f===A.QuickInputButtons.Back?-1:o;this._handlesToButtons.set(h,f)}),this.update({buttons:l.map((f,o)=>({...r(f),tooltip:f.tooltip,handle:f===A.QuickInputButtons.Back?-1:o}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(l){this._value=l,this._onDidChangeValueEmitter.fire(l)}_fireDidTriggerButton(l){const f=this._handlesToButtons.get(l);f&&this._onDidTriggerButtonEmitter.fire(f)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,w.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),s.$dispose(this._id))}update(l){if(!this._disposed){for(const f of Object.keys(l)){const o=l[f];this._pendingUpdate[f]=o===void 0?null:o}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){s.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function S(d){if(d instanceof A.ThemeIcon)return{id:d.id};const l=C(d),f=u(d);return{dark:typeof l=="string"?D.URI.file(l):l,light:typeof f=="string"?D.URI.file(f):f}}function u(d){return typeof d=="object"&&"light"in d?d.light:d}function C(d){return typeof d=="object"&&"dark"in d?d.dark:d}function r(d){const l=S(d.iconPath);let f,o;return"id"in l?o=b.ThemeIcon.asClassName(l):f=l,{iconPath:f,iconClass:o}}class c extends p{constructor(l,f){super(l.identifier,f),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new I.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new I.Emitter,this._onDidTriggerItemButtonEmitter=new I.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(l){this._items=l.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),l.forEach((o,h)=>{this._handlesToItems.set(h,o),this._itemsToHandles.set(o,h)});const f=[];for(let o=0;o<l.length;o++){const h=l[o];h.kind===A.QuickPickItemKind.Separator?f.push({type:"separator",label:h.label}):f.push({handle:o,label:h.label,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,buttons:h.buttons?.map((v,k)=>({...r(v),tooltip:v.tooltip,handle:k}))})}this.update({items:f})}get canSelectMany(){return this._canSelectMany}set canSelectMany(l){this._canSelectMany=l,this.update({canSelectMany:l})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(l){this._matchOnDescription=l,this.update({matchOnDescription:l})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(l){this._matchOnDetail=l,this.update({matchOnDetail:l})}get sortByLabel(){return this._sortByLabel}set sortByLabel(l){this._sortByLabel=l,this.update({sortByLabel:l})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(l){this._keepScrollPosition=l,this.update({keepScrollPosition:l})}get activeItems(){return this._activeItems}set activeItems(l){this._activeItems=l.filter(f=>this._itemsToHandles.has(f)),this.update({activeItems:this._activeItems.map(f=>this._itemsToHandles.get(f))})}get selectedItems(){return this._selectedItems}set selectedItems(l){this._selectedItems=l.filter(f=>this._itemsToHandles.has(f)),this.update({selectedItems:this._selectedItems.map(f=>this._itemsToHandles.get(f))})}_fireDidChangeActive(l){const f=(0,T.coalesce)(l.map(o=>this._handlesToItems.get(o)));this._activeItems=f,this._onDidChangeActiveEmitter.fire(f)}_fireDidChangeSelection(l){const f=(0,T.coalesce)(l.map(o=>this._handlesToItems.get(o)));this._selectedItems=f,this._onDidChangeSelectionEmitter.fire(f)}_fireDidTriggerItemButton(l,f){const o=this._handlesToItems.get(l);if(!o||!o.buttons||!o.buttons.length)return;const h=o.buttons[f];h&&this._onDidTriggerItemButtonEmitter.fire({button:h,item:o})}}class n extends p{constructor(l,f){super(l.identifier,f),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(l){this._password=l,this.update({password:l})}get prompt(){return this._prompt}set prompt(l){this._prompt=l,this.update({prompt:l})}get valueSelection(){return this._valueSelection}set valueSelection(l){this._valueSelection=l,this.update({valueSelection:l})}get validationMessage(){return this._validationMessage}set validationMessage(l){this._validationMessage=l,l?typeof l=="string"?this.update({validationMessage:l,severity:O.default.Error}):this.update({validationMessage:l.message,severity:l.severity??O.default.Error}):this.update({validationMessage:void 0,severity:O.default.Ignore})}}return new a(m,t)}e.createExtHostQuickOpen=g});var Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)},Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i};define(De[217],Ie([1,0,2,4,58,7,15,5,18,119,11,25,62,8,27]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m){"use strict";var t,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(h){if(h)return typeof h.iconPath=="string"?i.URI.file(h.iconPath):i.URI.isUri(h.iconPath)||g.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function p(h,v){if(!h.iconPath&&!v.iconPath)return 0;if(h.iconPath){if(!v.iconPath)return 1}else return-1;const k=typeof h.iconPath=="string"?h.iconPath:i.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,F=typeof v.iconPath=="string"?v.iconPath:i.URI.isUri(v.iconPath)?v.iconPath.fsPath:v.iconPath.id;return(0,T.comparePaths)(k,F)}function S(h,v){let k=0;if(h.strikeThrough!==v.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==v.faded)return h.faded?1:-1;if(h.tooltip!==v.tooltip)return(h.tooltip||"").localeCompare(v.tooltip||"");if(k=p(h,v),k!==0)return k;if(h.light&&v.light)k=p(h.light,v.light);else{if(h.light)return 1;if(v.light)return-1}if(k!==0)return k;if(h.dark&&v.dark)k=p(h.dark,v.dark);else{if(h.dark)return 1;if(v.dark)return-1}return k}function u(h,v){if(h.command!==v.command)return h.command<v.command?-1:1;if(h.title!==v.title)return h.title<v.title?-1:1;if(h.tooltip!==v.tooltip){if(h.tooltip!==void 0&&v.tooltip!==void 0)return h.tooltip<v.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(v.tooltip!==void 0)return-1}if(h.arguments===v.arguments)return 0;if(h.arguments)if(v.arguments){if(h.arguments.length!==v.arguments.length)return h.arguments.length-v.arguments.length}else return 1;else return-1;for(let k=0;k<h.arguments.length;k++){const F=h.arguments[k],j=v.arguments[k];if(F!==j)return F<j?-1:1}return 0}function C(h,v){let k=(0,T.comparePaths)(h.resourceUri.fsPath,v.resourceUri.fsPath,!0);if(k!==0)return k;if(h.command&&v.command)k=u(h.command,v.command);else{if(h.command)return 1;if(v.command)return-1}if(k!==0)return k;if(h.decorations&&v.decorations)k=S(h.decorations,v.decorations);else{if(h.decorations)return 1;if(v.decorations)return-1}return k}function r(h,v){for(let k=0;k<h.length;k++)if(h[k]!==v[k])return!1;return!0}function c(h,v){return h.command===v.command&&h.title===v.title&&h.tooltip===v.tooltip&&(h.arguments&&v.arguments?r(h.arguments,v.arguments):h.arguments===v.arguments)}function n(h,v){return(0,y.equals)(h,v,c)}class d{get value(){return this._value}set value(v){v=v??"",Ae(this,t,"f").$setInputBoxValue(this._sourceControlHandle,v),this.updateValue(v)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(v){Ae(this,t,"f").$setInputBoxPlaceholder(this._sourceControlHandle,v),this._placeholder=v}get validateInput(){return(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(v){if((0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),v&&typeof v!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=v,Ae(this,t,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!v)}get enabled(){return this._enabled}set enabled(v){v=!!v,this._enabled!==v&&(this._enabled=v,Ae(this,t,"f").$setInputBoxEnablement(this._sourceControlHandle,v))}get visible(){return this._visible}set visible(v){v=!!v,this._visible!==v&&(this._visible=v,Ae(this,t,"f").$setInputBoxVisibility(this._sourceControlHandle,v))}constructor(v,k,F){this._extension=v,this._sourceControlHandle=F,t.set(this,void 0),this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Ye(this,t,k,"f")}showValidationMessage(v,k){(0,m.checkProposedApiEnabled)(this._extension,"scmValidation"),Ae(this,t,"f").$showValidationMessage(this._sourceControlHandle,v,k)}$onInputBoxValueChange(v){this.updateValue(v)}updateValue(v){this._value=v,this._onDidChange.fire(v)}}e.ExtHostSCMInputBox=d,t=new WeakMap;class l{get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(v){this._label=v,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,v)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(v){this._hideWhenEmpty=v,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(v){this._resourceStates=[...v],this._onDidUpdateResourceStates.fire()}constructor(v,k,F,j,H){this._proxy=v,this._commands=k,this._sourceControlHandle=F,this._id=j,this._label=H,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=l._handlePool++}getResourceState(v){return this._resourceStatesMap.get(v)}$executeResourceCommand(v,k){const F=this._resourceStatesCommandsMap.get(v);return F?(0,D.asPromise)(()=>this._commands.executeCommand(F.command,...F.arguments||[],k)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const v=[...this._resourceStates].sort(C),F=(0,y.sortedDiff)(this._resourceSnapshot,v,C).map(V=>{const P=V.toInsert.map(U=>{const R=this._resourceHandlePool++;this._resourceStatesMap.set(R,U);const x=U.resourceUri;let z;if(U.command)if(U.command.command==="vscode.open"||U.command.command==="vscode.diff"){const me=new M.DisposableStore;z=this._commands.converter.toInternal(U.command,me),this._resourceStatesDisposablesMap.set(R,me)}else this._resourceStatesCommandsMap.set(R,U.command);const B=a(U.decorations),K=U.decorations&&a(U.decorations.light)||B,Z=U.decorations&&a(U.decorations.dark)||B,ue=[K,Z],ne=U.decorations&&U.decorations.tooltip||"",pe=U.decorations&&!!U.decorations.strikeThrough,ae=U.decorations&&!!U.decorations.faded,de=U.contextValue||"";return{rawResource:[R,x,ue,ne,pe,ae,de,z],handle:R}});return{start:V.start,deleteCount:V.deleteCount,toInsert:P}}),j=F.map(({start:V,deleteCount:P,toInsert:U})=>[V,P,U.map(R=>R.rawResource)]),H=F.reverse();for(const{start:V,deleteCount:P,toInsert:U}of H){const R=U.map(z=>z.handle),x=this._handlesSnapshot.splice(V,P,...R);for(const z of x)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),this._resourceStatesDisposablesMap.get(z)?.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=v,j}dispose(){this._disposed=!0,this._onDidDispose.fire()}}l._handlePool=0;class f{get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(v){this._count!==v&&(this._count=v,Ae(this,s,"f").$updateSourceControl(this.handle,{count:v}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(v){this._quickDiffProvider=v,Ae(this,s,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!v})}get commitTemplate(){return this._commitTemplate}set commitTemplate(v){v!==this._commitTemplate&&(this._commitTemplate=v,Ae(this,s,"f").$updateSourceControl(this.handle,{commitTemplate:v}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(v){this._acceptInputDisposables.value=new M.DisposableStore,this._acceptInputCommand=v;const k=this._commands.converter.toInternal(v,this._acceptInputDisposables.value);Ae(this,s,"f").$updateSourceControl(this.handle,{acceptInputCommand:k})}get actionButton(){return(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(v){(0,m.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new M.DisposableStore,this._actionButton=v;const k=v!==void 0?{command:this._commands.converter.toInternal(v.command,this._actionButtonDisposables.value),secondaryCommands:v.secondaryCommands?.map(F=>F.map(j=>this._commands.converter.toInternal(j,this._actionButtonDisposables.value))),description:v.description,enabled:v.enabled}:void 0;Ae(this,s,"f").$updateSourceControl(this.handle,{actionButton:k??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(v){if(this._statusBarCommands&&v&&n(this._statusBarCommands,v))return;this._statusBarDisposables.value=new M.DisposableStore,this._statusBarCommands=v;const k=(v||[]).map(F=>this._commands.converter.toInternal(F,this._statusBarDisposables.value));Ae(this,s,"f").$updateSourceControl(this.handle,{statusBarCommands:k})}get selected(){return this._selected}constructor(v,k,F,j,H,V){this._extension=v,this._commands=F,this._id=j,this._label=H,this._rootUri=V,s.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new M.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new M.MutableDisposable,this._statusBarDisposables=new M.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ye(this,s,k,"f"),this._inputBox=new d(v,Ae(this,s,"f"),this.handle),Ae(this,s,"f").$registerSourceControl(this.handle,j,H,V)}createResourceGroup(v,k){const F=new l(Ae(this,s,"f"),this._commands,this.handle,v,k),j=I.Event.once(F.onDidDispose)(()=>this.createdResourceGroups.delete(F));return this.createdResourceGroups.set(F,j),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const v=[],k=[];for(const[F,j]of this.createdResourceGroups){j.dispose();const H=F.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(F),this.eventuallyUpdateResourceStates()});I.Event.once(F.onDidDispose)(()=>{this.updatedResourceGroups.delete(F),H.dispose(),this._groups.delete(F.handle),Ae(this,s,"f").$unregisterGroup(this.handle,F.handle)}),v.push([F.handle,F.id,F.label,F.features]);const V=F._takeResourceStateSnapshot();V.length>0&&k.push([F.handle,V]),this._groups.set(F.handle,F)}Ae(this,s,"f").$registerGroups(this.handle,v,k),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const v=[];this.updatedResourceGroups.forEach(k=>{const F=k._takeResourceStateSnapshot();F.length!==0&&v.push([k.handle,F])}),v.length>0&&Ae(this,s,"f").$spliceResourceStates(this.handle,v),this.updatedResourceGroups.clear()}getResourceGroup(v){return this._groups.get(v)}setSelectionState(v){this._selected=v,this._onDidChangeSelection.fire(v)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(v=>v.dispose()),Ae(this,s,"f").$unregisterSourceControl(this.handle)}}s=new WeakMap,f._handlePool=0,He([(0,w.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),He([(0,w.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let o=class Ji{get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}constructor(v,k,F){this._commands=k,this.logService=F,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=v.getProxy(A.MainContext.MainThreadSCM),this._telemetry=v.getProxy(A.MainContext.MainThreadTelemetry),k.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const H=this._sourceControls.get(j.sourceControlHandle);if(!H)return j;const V=H.getResourceGroup(j.groupHandle);return V?V.getResourceState(j.handle):j}else if(j&&j.$mid===4){const H=this._sourceControls.get(j.sourceControlHandle);return H?H.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const H=this._sourceControls.get(j.handle);return H||j}return j}})}createSourceControl(v,k,F,j){this.logService.trace("ExtHostSCM#createSourceControl",v.identifier.value,k,F,j),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:v.identifier.value});const H=Ji._handlePool++,V=new f(v,this._proxy,this._commands,k,F,j);this._sourceControls.set(H,V);const P=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier))||[];return P.push(V),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(v.identifier),P),V}getLastInputBox(v){this.logService.trace("ExtHostSCM#getLastInputBox",v.identifier.value);const k=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(v.identifier)),F=k&&k[k.length-1];return F&&F.inputBox}$provideOriginalResource(v,k,F){const j=i.URI.revive(k);this.logService.trace("ExtHostSCM#$provideOriginalResource",v,j.toString());const H=this._sourceControls.get(v);return!H||!H.quickDiffProvider||!H.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>H.quickDiffProvider.provideOriginalResource(j,F)).then(V=>V||null)}$onInputBoxValueChange(v,k){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",v);const F=this._sourceControls.get(v);return F&&F.inputBox.$onInputBoxValueChange(k),Promise.resolve(void 0)}$executeResourceCommand(v,k,F,j){this.logService.trace("ExtHostSCM#$executeResourceCommand",v,k,F);const H=this._sourceControls.get(v);if(!H)return Promise.resolve(void 0);const V=H.getResourceGroup(k);return V?V.$executeResourceCommand(F,j):Promise.resolve(void 0)}$validateInput(v,k,F){this.logService.trace("ExtHostSCM#$validateInput",v);const j=this._sourceControls.get(v);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>j.inputBox.validateInput(k,F)).then(H=>{if(!H)return Promise.resolve(void 0);const V=E.MarkdownString.fromStrict(H.message);return V?Promise.resolve([V,H.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(v){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",v),v!==void 0&&this._sourceControls.get(v)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=v,Promise.resolve(void 0)}};o._handlePool=0,o=He([$e(2,O.ILogService)],o),e.ExtHostSCM=o}),define(De[73],Ie([1,0,5,4,3]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class M{constructor(A){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(i.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,y){return this._proxy.$getPassword(A,y)}store(A,y,T){return this._proxy.$setPassword(A,y,T)}delete(A,y){return this._proxy.$deletePassword(A,y)}}e.ExtHostSecretState=M,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[218],Ie([1,0,6,5,134,7,8,9]),function(ie,e,i,I,w,M,D,A){"use strict";var y,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(m,t,s,a,p=i.StatusBarAlignment.Left,S){y.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new M.DisposableStore,Ye(this,y,m,"f"),Ye(this,T,t,"f"),this._entryId=O.ID_GEN++,this._extension=s,this._id=a,this._alignment=p,this._priority=this.validatePriority(S)}validatePriority(m){if(!!(0,A.isNumber)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(m){this._text=m,this.update()}set name(m){this._name=m,this.update()}set tooltip(m){this._tooltip=m,this.update()}set color(m){this._color=m,this.update()}set backgroundColor(m){m&&!O.ALLOWED_BACKGROUND_COLORS.has(m.id)&&(m=void 0),this._backgroundColor=m,this.update()}set command(m){this._command?.fromApi!==m&&(this._internalCommandRegistration.clear(),typeof m=="string"?this._command={fromApi:m,internal:Ae(this,T,"f").toInternal({title:"",command:m},this._internalCommandRegistration)}:m?this._command={fromApi:m,internal:Ae(this,T,"f").toInternal(m,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(m){this._accessibilityInformation=m,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ae(this,y,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let m;this._extension?this._id?m=`${this._extension.identifier.value}.${this._id}`:m=this._extension.identifier.value:m=this._id;let t;this._name?t=this._name:t=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let s=this._color;this._backgroundColor&&(s=O.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const a=D.MarkdownString.fromStrict(this._tooltip);Ae(this,y,"f").$setEntry(this._entryId,m,t,this._text,a,this._command?.internal,s,this._backgroundColor,this._alignment===i.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=O,y=new WeakMap,T=new WeakMap,O.ID_GEN=0,O.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new i.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new i.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(m){this._messages=[],this._item=m.createStatusBarEntry(void 0,"status.extensionMessage",i.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(m){const t={message:m};return this._messages.unshift(t),this._update(),new i.Disposable(()=>{const s=this._messages.indexOf(t);s>=0&&(this._messages.splice(s,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class g{constructor(m,t){this._proxy=m.getProxy(I.MainContext.MainThreadStatusBar),this._commands=t,this._statusMessage=new b(this)}createStatusBarEntry(m,t,s,a){return new O(this._proxy,this._commands,m,t,s,a)}setStatusBarMessage(m,t){const s=this._statusMessage.setMessage(m);let a;return typeof t=="number"?a=setTimeout(()=>s.dispose(),t):typeof t<"u"&&t.then(()=>s.dispose(),()=>s.dispose()),new i.Disposable(()=>{s.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=g}),define(De[74],Ie([1,0,5,4,3]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class M{constructor(A){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(i.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this._proxy.$registerExtensionStorageKeysToSync(A,y)}initializeExtensionStorage(A,y,T){return this._proxy.$initializeExtensionStorage(A,y).then(O=>O||T)}setValue(A,y,T){return this._proxy.$setValue(A,y,T)}$acceptValue(A,y,T){this._onDidChangeStorage.fire({shared:A,key:y,value:T})}}e.ExtHostStorage=M,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(De[75],Ie([1,0,3,26,11,55,2]),function(ie,e,i,I,w,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,i.createDecorator)("IExtensionStoragePaths");let A=class{constructor(T,O,b){this._logService=O,this._extHostFileSystem=b,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getWorkspaceStorageURI(T){return D.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,O=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(O),this._logService.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",O),await this._extHostFileSystem.value.createDirectory(O),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),O}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(T){if(this._value)return D.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return D.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=He([$e(0,I.IExtHostInitDataService),$e(1,w.ILogService),$e(2,M.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(De[56],Ie([1,0,4,5,3,2,14,7,6,135,12,174,20,38,159,62,9,15,8]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class S{constructor(o,h,v,k){this._proxy=o,this._id=h,this._creationOptions=v,this._name=k,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(j=>this._pidPromiseComplete=j);const F=this;this.value={get name(){return F._name||""},get processId(){return F._pidPromise},get creationOptions(){return F._creationOptions},get exitStatus(){return F._exitStatus},get state(){return F._state},sendText(j,H=!0){F._checkDisposed(),F._proxy.$sendText(F._id,j,H)},show(j){F._checkDisposed(),F._proxy.$show(F._id,j)},hide(){F._checkDisposed(),F._proxy.$hide(F._id)},dispose(){F._disposed||(F._disposed=!0,F._proxy.$dispose(F._id))},get dimensions(){if(!(F._cols===void 0||F._rows===void 0))return{columns:F._cols,rows:F._rows}}}}async create(o,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:o.name,shellPath:(0,s.withNullAsUndefined)(o.shellPath),shellArgs:(0,s.withNullAsUndefined)(o.shellArgs),cwd:(0,s.withNullAsUndefined)(o.cwd),env:(0,s.withNullAsUndefined)(o.env),icon:(0,s.withNullAsUndefined)(d(o.iconPath)),color:t.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:(0,s.withNullAsUndefined)(o.message),strictEnv:(0,s.withNullAsUndefined)(o.strictEnv),hideFromUser:(0,s.withNullAsUndefined)(o.hideFromUser),isFeatureTerminal:(0,s.withNullAsUndefined)(h?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,s.withNullAsUndefined)(h?.useShellEnvironment),location:h?.location||this._serializeParentTerminal(o.location,h?.resolvedExtHostIdentifier),isTransient:(0,s.withNullAsUndefined)(o.isTransient)})}async createExtensionTerminal(o,h,v,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:v,color:t.ThemeColor.isThemeColor(k)?k.id:void 0,location:this._serializeParentTerminal(o,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(o,h){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in o?{viewColumn:p.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(o){this._name=o}setExitStatus(o,h){this._exitStatus=Object.freeze({code:o,reason:h})}setDimensions(o,h){return o===this._cols&&h===this._rows||o===0||h===0?!1:(this._cols=o,this._rows=h,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(o){this._pidPromiseComplete?(this._pidPromiseComplete(o),this._pidPromiseComplete=void 0):this._pidPromise.then(h=>{h!==o&&(this._pidPromise=Promise.resolve(o))})}}e.ExtHostTerminal=S;class u{get onProcessReady(){return this._onProcessReady.event}constructor(o){this._pty=o,this.id=0,this.shouldPersist=!1,this._onProcessData=new i.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new i.Emitter,this._onDidChangeProperty=new i.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new i.Emitter,this.onProcessExit=this._onProcessExit.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${h}`)}async start(){}shutdown(){this._pty.close()}input(o){this._pty.handleInput?.(o)}resize(o,h){this._pty.setDimensions?.({columns:o,rows:h})}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(o){this._pty.onDidWrite(h=>this._onProcessData.fire(h)),this._pty.onDidClose?.((h=void 0)=>{this._onProcessExit.fire(h===void 0?void 0:h)}),this._pty.onDidOverrideDimensions?.(h=>{h&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this._pty.onDidChangeName?.(h=>{this._onDidChangeProperty.fire({type:"title",value:h})}),this._pty.open(o||void 0),o&&this._pty.setDimensions?.(o),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=u;let C=1,r=class extends A.Disposable{get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(o=>o.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}constructor(o,h){super(),this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new i.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new i.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new i.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new i.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new i.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._onDidChangeShell=new i.Emitter,this.onDidChangeShell=this._onDidChangeShell.event,this._proxy=h.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new m.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new i.Emitter({onWillAddFirstListener:()=>this._proxy.$startSendingDataEvents(),onDidRemoveLastListener:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(o),this._register({dispose:()=>{for(const[v,k]of this._terminalProcesses)k.shutdown(!0)}})}getDefaultShell(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(o){return(o?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(o,h){const v=new S(this._proxy,(0,E.generateUuid)(),o,o.name),k=new u(o.pty);return v.createExtensionTerminal(o.location,this._serializeParentTerminal(o,h).resolvedExtHostIdentifier,d(o.iconPath),l(o.color)).then(F=>{const j=this._setupExtHostProcessListeners(F,k);this._terminalProcessDisposables[F]=j}),this._terminals.push(v),v.value}_serializeParentTerminal(o,h){if(h=h||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const v=o.location.parentTerminal;if(v){const k=this._terminals.find(F=>F.value===v);k&&(h.resolvedExtHostIdentifier=k._id)}}else o.location&&typeof o.location!="object"?h.location=o.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(o,h){if(!this._getTerminalById(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const k=new u(h),F=this._setupExtHostProcessListeners(o,k);this._terminalProcessDisposables[o]=F}async $acceptActiveTerminalChanged(o){const h=this._activeTerminal;if(o===null){this._activeTerminal=void 0,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const v=this._getTerminalById(o);v&&(this._activeTerminal=v,h!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(o,h){const v=this._getTerminalById(o);v&&this._onDidWriteTerminalData.fire({terminal:v.value,data:h})}async $acceptTerminalDimensions(o,h,v){const k=this._getTerminalById(o);k&&k.setDimensions(h,v)&&this._onDidChangeTerminalDimensions.fire({terminal:k.value,dimensions:k.value.dimensions})}async $acceptTerminalMaximumDimensions(o,h,v){this._terminalProcesses.get(o)?.resize(h,v)}async $acceptTerminalTitleChange(o,h){const v=this._getTerminalById(o);v&&(v.name=h)}async $acceptTerminalClosed(o,h,v){const k=this._getTerminalObjectIndexById(this._terminals,o);if(k!==null){const F=this._terminals.splice(k,1)[0];F.setExitStatus(h,v),this._onDidCloseTerminal.fire(F.value)}}$acceptTerminalOpened(o,h,v,k){if(h){const H=this._getTerminalObjectIndexById(this._terminals,h);if(H!==null){this._terminals[H]._id=o,this._onDidOpenTerminal.fire(this.terminals[H]),this._terminals[H].isOpen=!0;return}}const F={name:k.name,shellPath:k.executable,shellArgs:k.args,cwd:typeof k.cwd=="string"?k.cwd:M.URI.revive(k.cwd),env:k.env,hideFromUser:k.hideFromUser},j=new S(this._proxy,o,F,v);this._terminals.push(j),this._onDidOpenTerminal.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(o,h){this._getTerminalById(o)?._setProcessId(h)}async $startExtensionTerminal(o,h){const v=this._getTerminalById(o);if(!v)return{message:(0,T.localize)(0,null,o)};v.isOpen||await new Promise(F=>{const j=this.onDidOpenTerminal(async H=>{H===v.value&&(j.dispose(),F())})});const k=this._terminalProcesses.get(o);k?k.startSendingEvents(h):this._extensionTerminalAwaitingStart[o]={initialDimensions:h}}_setupExtHostProcessListeners(o,h){const v=new A.DisposableStore;v.add(h.onProcessReady(F=>this._proxy.$sendProcessReady(o,F.pid,F.cwd))),v.add(h.onDidChangeProperty(F=>this._proxy.$sendProcessProperty(o,F))),this._bufferer.startBuffering(o,h.onProcessData),v.add(h.onProcessExit(F=>this._onProcessExit(o,F))),this._terminalProcesses.set(o,h);const k=this._extensionTerminalAwaitingStart[o];return k&&h instanceof u&&(h.startSendingEvents(k.initialDimensions),delete this._extensionTerminalAwaitingStart[o]),v}$acceptProcessAckDataEvent(o,h){this._terminalProcesses.get(o)?.acknowledgeDataEvent(h)}$acceptProcessInput(o,h){this._terminalProcesses.get(o)?.input(h)}$acceptTerminalInteraction(o){const h=this._getTerminalById(o);h?.setInteractedWith()&&this._onDidChangeTerminalState.fire(h.value)}$acceptProcessResize(o,h,v){try{this._terminalProcesses.get(o)?.resize(h,v)}catch(k){if(k.code!=="EPIPE"&&k.code!=="ERR_IPC_CHANNEL_CLOSED")throw k}}$acceptProcessShutdown(o,h){this._terminalProcesses.get(o)?.shutdown(h)}$acceptProcessRequestInitialCwd(o){this._terminalProcesses.get(o)?.getInitialCwd().then(h=>this._proxy.$sendProcessProperty(o,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(o){this._terminalProcesses.get(o)?.getCwd().then(h=>this._proxy.$sendProcessProperty(o,{type:"cwd",value:h}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this._linkProviders.add(o),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(o),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(o,h,v){if(this._profileProviders.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this._profileProviders.set(h,v),this._proxy.$registerProfileProvider(h,o.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(h),this._proxy.$unregisterProfileProvider(h)})}async $createContributedProfileTerminal(o,h){const v=new g.CancellationTokenSource().token;let k=await this._profileProviders.get(o)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(k&&!("options"in k)&&(k={options:k}),!k||!("options"in k))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in k.options){this.createExtensionTerminal(k.options,h);return}this.createTerminalFromOptions(k.options,h)}}async $provideLinks(o,h){const v=this._getTerminalById(o);if(!v)return[];this._terminalLinkCache.delete(o),this._terminalLinkCancellationSource.get(o)?.dispose(!0);const F=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(o,F);const j=[],H={terminal:v.value,line:h},V=[];for(const R of this._linkProviders)V.push(a.Promises.withAsyncBody(async x=>{F.token.onCancellationRequested(()=>x({provider:R,links:[]}));const z=await R.provideTerminalLinks(H,F.token)||[];F.token.isCancellationRequested||x({provider:R,links:z})}));const P=await Promise.all(V);if(F.token.isCancellationRequested)return[];const U=new Map;for(const R of P)R&&R.links.length>0&&j.push(...R.links.map(x=>{const z={id:C++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return U.set(z.id,{provider:R.provider,link:x}),z}));return this._terminalLinkCache.set(o,U),j}$activateLink(o,h){const v=this._terminalLinkCache.get(o)?.get(h);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(o,h){this._bufferer.stopBuffering(o),this._terminalProcesses.delete(o),delete this._extensionTerminalAwaitingStart[o];const v=this._terminalProcessDisposables[o];v&&(v.dispose(),delete this._terminalProcessDisposables[o]),this._proxy.$sendProcessExit(o,h)}_getTerminalById(o){return this._getTerminalObjectById(this._terminals,o)}_getTerminalObjectById(o,h){const v=this._getTerminalObjectIndexById(o,h);return v!==null?o[v]:null}_getTerminalObjectIndexById(o,h){let v=null;return o.some((k,F)=>k._id===h?(v=F,!0):!1),v}getEnvironmentVariableCollection(o){let h=this._environmentVariableCollections.get(o.identifier.value);return h||(h=new c,this._setEnvironmentVariableCollection(o.identifier.value,h)),h}_syncEnvironmentVariableCollection(o,h){const v=(0,b.serializeEnvironmentVariableCollection)(h.map);this._proxy.$setEnvironmentVariableCollection(o,h.persistent,v.length===0?void 0:v)}$initEnvironmentVariableCollections(o){o.forEach(h=>{const v=h[0],k=new c(h[1]);this._setEnvironmentVariableCollection(v,k)})}$acceptDefaultProfile(o,h){const v=this._defaultProfile;this._defaultProfile=o,this._defaultAutomationProfile=h,v?.path!==o.path&&this._onDidChangeShell.fire(o.path)}_setEnvironmentVariableCollection(o,h){this._environmentVariableCollections.set(o,h),h.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(o,h)})}};r=He([$e(1,D.IExtHostRpcService)],r),e.BaseExtHostTerminalService=r;class c{get persistent(){return this._persistent}set persistent(o){this._persistent=o,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}constructor(o){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new i.Emitter,this.map=new Map(o)}get size(){return this.map.size}replace(o,h){this._setIfDiffers(o,{value:h,type:y.EnvironmentVariableMutatorType.Replace})}append(o,h){this._setIfDiffers(o,{value:h,type:y.EnvironmentVariableMutatorType.Append})}prepend(o,h){this._setIfDiffers(o,{value:h,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(o,h){const v=this.map.get(o);(!v||v.value!==h.value||v.type!==h.type)&&(this.map.set(o,h),this._onDidChangeCollection.fire())}get(o){return this.map.get(o)}forEach(o,h){this.map.forEach((v,k)=>o.call(h,k,v,this))}[Symbol.iterator](){return this.map.entries()}delete(o){this.map.delete(o),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let n=class extends r{constructor(o){super(!1,o)}createTerminal(o,h,v){throw new O.NotSupportedError}createTerminalFromOptions(o,h){throw new O.NotSupportedError}};n=He([$e(0,D.IExtHostRpcService)],n),e.WorkerExtHostTerminalService=n;function d(f){if(!(!f||typeof f=="string"))return"id"in f?{id:f.id,color:f.color}:f}function l(f){return t.ThemeColor.isThemeColor(f)?f:void 0}});var Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)},Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i};define(De[219],Ie([1,0,18,24,20,4,183,220,7,23,9,38,5,14,96,8,6,42,67,51]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S){"use strict";var u,C;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(H,V,P){this.editors=P,this.resultsChangedEmitter=new M.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=H.getProxy(g.MainContext.MainThreadTesting),this.observer=new v(this.proxy),this.runTracker=new n(this.proxy),V.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==14)return U;const R=U,x=R.tests[R.tests.length-1].item.extId;return this.controllers.get(a.TestId.root(x))?.collection.tree.get(x)?.actual??(0,m.toItemFromContext)(U)}})}createTestController(H,V,P){if(this.controllers.has(H))throw new Error(`Attempt to insert a duplicate controller with ID "${H}"`);const U=new y.DisposableStore,R=U.add(new m.ExtHostTestItemCollection(H,V,this.editors));R.root.label=V;const x=new Map,z=this.proxy,B={items:R.root.children,get label(){return V},set label(Z){V=Z,R.root.label=Z,z.$updateController(H,{label:V})},get refreshHandler(){return P},set refreshHandler(Z){P=Z,z.$updateController(H,{canRefresh:!!Z})},get id(){return H},createRunProfile:(Z,ue,ne,pe,ae)=>{let de=(0,A.hash)(Z);for(;x.has(de);)de++;return new k(this.proxy,x,H,de,Z,ue,ne,pe,ae)},createTestItem(Z,ue,ne){return new m.TestItemImpl(H,Z,ue,ne)},createTestRun:(Z,ue,ne=!0)=>this.runTracker.createTestRun(H,R,Z,ue,ne),set resolveHandler(Z){R.resolveHandler=Z},get resolveHandler(){return R.resolveHandler},dispose:()=>{U.dispose()}};z.$registerTestController(H,V,!!P),U.add((0,y.toDisposable)(()=>z.$unregisterTestController(H)));const K={controller:B,collection:R,profiles:x};return this.controllers.set(H,K),U.add((0,y.toDisposable)(()=>this.controllers.delete(H))),U.add(R.onDidGenerateDiff(Z=>z.$publishDiff(H,Z.map(S.TestsDiffOp.serialize)))),B}createTestObserver(){return this.observer.checkout()}async runTests(H,V=w.CancellationToken.None){const P=d(H);if(!P)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.controllers.get(P.controllerId);if(!U)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:H.include?.map(R=>a.TestId.fromExtHostTestItem(R,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:F[P.kind],profileId:P.profileId,controllerId:P.controllerId}],exclude:H.exclude?.map(R=>R.id)},V)}$syncTests(){for(const{collection:H}of this.controllers.values())H.flushDiff();return Promise.resolve()}$provideFileCoverage(H,V,P){return(0,i.mapFind)(this.runTracker.trackers,R=>R.id===H?R.getCoverage(V):void 0)?.provideFileCoverage(P)??Promise.resolve([])}$resolveFileCoverage(H,V,P,U){return(0,i.mapFind)(this.runTracker.trackers,x=>x.id===H?x.getCoverage(V):void 0)?.resolveFileCoverage(P,U)??Promise.resolve([])}$configureRunProfile(H,V){this.controllers.get(H)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(H,V){await this.controllers.get(H)?.controller.refreshHandler?.(V)}$publishTestResults(H){this.results=Object.freeze(H.map(V=>(0,T.deepFreeze)(t.TestResults.to(V))).concat(this.results).sort((V,P)=>P.completedAt-V.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(H,V){const P=this.controllers.get(a.TestId.fromString(H).controllerId)?.collection;P&&(await P.expand(H,V<0?1/0:V),P.flushDiff())}$acceptDiff(H){this.observer.applyDiff(H.map(S.TestsDiffOp.deserialize))}async $runControllerTests(H,V){return Promise.all(H.map(P=>this.runControllerTestRequest(P,V)))}async runControllerTestRequest(H,V){const P=this.controllers.get(H.controllerId);if(!P)return{};const{collection:U,profiles:R}=P,x=R.get(H.profileId);if(!x)return{};const z=H.testIds.map(ue=>U.tree.get(ue)).filter(O.isDefined),B=H.excludeExtIds.map(ue=>P.collection.tree.get(ue)).filter(O.isDefined).filter(ue=>z.some(ne=>ne.fullId.compare(ue.fullId)===2));if(!z.length)return{};const K=new s.TestRunRequest(z.some(ue=>ue.actual instanceof m.TestItemRootImpl)?void 0:z.map(ue=>ue.actual),B.map(ue=>ue.actual),x),Z=this.runTracker.prepareForMainThreadTestRun(K,l.fromInternal(H,P.collection),V);try{return await x.runHandler(K,V),{}}catch(ue){return{error:String(ue)}}finally{Z.isRunning&&!V.isCancellationRequested&&await M.Event.toPromise(Z.onEnd),Z.dispose()}}$cancelExtensionTestRun(H){H===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(H)}};r=He([$e(0,E.IExtHostRpcService)],r),e.ExtHostTesting=r;class c extends y.Disposable{get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}constructor(H,V,P){super(),this.dto=H,this.proxy=V,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new M.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(P)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:U}of this.tasks.values())U.end()}))}getCoverage(H){return this.tasks.get(H)?.coverage}createRun(H){const V=this.dto.id,P=this.dto.controllerId,U=(0,b.generateUuid)(),R=new f(this.proxy,V,U),x=Z=>(ue,...ne)=>{if(B){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(ue)||(this.ensureTestIsKnown(ue),Z(ue,...ne))},z=(Z,ue)=>{const ne=ue instanceof Array?ue.map(t.TestMessage.from):[t.TestMessage.from(ue)];if(Z.uri&&Z.range){const pe={range:t.Range.from(Z.range),uri:Z.uri};for(const ae of ne)ae.location=ae.location||pe}this.proxy.$appendTestMessagesInRun(V,U,a.TestId.fromExtHostTestItem(Z,P).toString(),ne)};let B=!1;const K={isPersisted:this.dto.isPersisted,token:this.cts.token,name:H,get coverageProvider(){return R.coverageProvider},set coverageProvider(Z){R.coverageProvider=Z},enqueued:x(Z=>{this.proxy.$updateTestStateInRun(V,U,a.TestId.fromExtHostTestItem(Z,P).toString(),1)}),skipped:x(Z=>{this.proxy.$updateTestStateInRun(V,U,a.TestId.fromExtHostTestItem(Z,P).toString(),5)}),started:x(Z=>{this.proxy.$updateTestStateInRun(V,U,a.TestId.fromExtHostTestItem(Z,P).toString(),2)}),errored:x((Z,ue,ne)=>{z(Z,ue),this.proxy.$updateTestStateInRun(V,U,a.TestId.fromExtHostTestItem(Z,P).toString(),6,ne)}),failed:x((Z,ue,ne)=>{z(Z,ue),this.proxy.$updateTestStateInRun(V,U,a.TestId.fromExtHostTestItem(Z,P).toString(),4,ne)}),passed:x((Z,ue)=>{this.proxy.$updateTestStateInRun(V,U,a.TestId.fromExtHostTestItem(Z,this.dto.controllerId).toString(),3,ue)}),appendOutput:(Z,ue,ne)=>{B||(ne&&(this.dto.isIncluded(ne)?this.ensureTestIsKnown(ne):ne=void 0),this.proxy.$appendOutputToRun(V,U,I.VSBuffer.fromString(Z),ue&&t.location.from(ue),ne&&a.TestId.fromExtHostTestItem(ne,P).toString()))},end:()=>{B||(B=!0,this.proxy.$finishedTestRunTask(V,U),this.tasks.delete(U),this.isRunning||this.dispose())}};return this.tasks.set(U,{run:K,coverage:R}),this.proxy.$startedTestRunTask(V,{id:U,name:H,running:!0}),K}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(H){if(!(H instanceof m.TestItemImpl))throw new p.InvalidTestItemError(H.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(H,this.dto.controllerId).toString()))return;const V=[],P=this.dto.colllection.root;for(;;){const U=t.TestItem.from(H);if(V.unshift(U),this.sharedTestIds.has(U.extId)||(this.sharedTestIds.add(U.extId),H===P))break;H=H.parent||P}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,V)}}class n{get trackers(){return this.tracked.values()}constructor(H){this.proxy=H,this.tracked=new Map}prepareForMainThreadTestRun(H,V,P){return this.getTracker(H,V,P)}cancelRunById(H){for(const V of this.tracked.values())if(V.id===H){V.dispose();return}}cancelAllRuns(){for(const H of this.tracked.values())H.dispose()}createTestRun(H,V,P,U,R){const x=this.tracked.get(P);if(x)return x.createRun(U);const z=l.fromPublic(H,V,P,R),B=d(P);this.proxy.$startedExtensionTestRun({controllerId:H,profile:B&&{group:F[B.kind],id:B.profileId},exclude:P.exclude?.map(Z=>a.TestId.fromExtHostTestItem(Z,V.root.id).toString())??[],id:z.id,include:P.include?.map(Z=>a.TestId.fromExtHostTestItem(Z,V.root.id).toString())??[V.root.id],persist:R});const K=this.getTracker(P,z);return K.onEnd(()=>this.proxy.$finishedExtensionTestRun(z.id)),K.createRun(U)}getTracker(H,V,P){const U=new c(V,this.proxy,P);return this.tracked.set(H,U),U.onEnd(()=>this.tracked.delete(H)),U}}e.TestRunCoordinator=n;const d=j=>{if(!!j.profile){if(!(j.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class l{static fromPublic(H,V,P,U){return new l(H,(0,b.generateUuid)(),P.include?.map(R=>a.TestId.fromExtHostTestItem(R,H).toString())??[H],P.exclude?.map(R=>a.TestId.fromExtHostTestItem(R,H).toString())??[],U,V)}static fromInternal(H,V){return new l(H.controllerId,H.runId,H.testIds,H.excludeExtIds,!0,V)}constructor(H,V,P,U,R,x){this.controllerId=H,this.id=V,this.isPersisted=R,this.colllection=x,this.includePrefix=P.map(z=>z+"\0"),this.excludePrefix=U.map(z=>z+"\0")}isIncluded(H){const V=a.TestId.fromExtHostTestItem(H,this.controllerId).toString()+"\0";for(const P of this.excludePrefix)if(V===P||V.startsWith(P))return!1;for(const P of this.includePrefix)if(V===P||V.startsWith(P))return!0;return!1}}e.TestRunDto=l;class f{set coverageProvider(H){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!H||(this._coverageProvider=H,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}constructor(H,V,P){this.proxy=H,this.runId=V,this.taskId=P}async provideFileCoverage(H){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(H))());try{return(await this.fileCoverage)?.map(t.TestCoverage.fromFile)??[]}catch(V){throw this.fileCoverage=void 0,V}}async resolveFileCoverage(H,V){const P=await this.fileCoverage;let U=P?.[H];return!this._coverageProvider||!P||!U?[]:(U.detailedCoverage||(U=P[H]=await this._coverageProvider.resolveFileCoverage?.(U,V)??U),U.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class o extends S.IncrementalChangeCollector{get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}constructor(H){super(),this.emitter=H,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}add(H){this.added.add(H)}update(H){Object.assign(H.revived,t.TestItem.toPlain(H.item)),this.added.has(H)||this.updated.add(H)}remove(H){if(this.added.has(H)){this.added.delete(H);return}this.updated.delete(H);const V=a.TestId.parentId(H.item.extId);if(V&&this.alreadyRemoved.has(V.toString())){this.alreadyRemoved.add(H.item.extId);return}this.removed.add(H)}getChangeEvent(){const{added:H,updated:V,removed:P}=this;return{get added(){return[...H].map(U=>U.revived)},get updated(){return[...V].map(U=>U.revived)},get removed(){return[...P].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class h extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.changeEmitter=new M.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(H){return this.items.get(H)}getMirroredTestDataByReference(H){return this.items.get(H.id)}createItem(H,V){return{...H,revived:t.TestItem.toPlain(H.item),depth:V?V.depth+1:0,children:new Set}}createChangeCollector(){return new o(this.changeEmitter)}}e.MirroredTestCollection=h;class v{constructor(H){this.proxy=H}checkout(){this.current||(this.current=this.createObserverData());const H=this.current;return H.observers++,{onDidChangeTest:H.tests.onDidChangeTests,get tests(){return[...H.tests.rootTests].map(V=>V.revived)},dispose:(0,D.once)(()=>{--H.observers===0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(H){return this.current?.tests.getMirroredTestDataByReference(H)}applyDiff(H){this.current?.tests.apply(H)}createObserverData(){const H=new h;return this.proxy.$subscribeToDiffs(),{observers:0,tests:H}}}class k{get label(){return this._label}set label(H){H!==this._label&&(this._label=H,Ae(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:H}))}get isDefault(){return this._isDefault}set isDefault(H){H!==this._isDefault&&(this._isDefault=H,Ae(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:H}))}get tag(){return this._tag}set tag(H){H?.id!==this._tag?.id&&(this._tag=H,Ae(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:H?t.TestTag.namespace(this.controllerId,H.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(H){H!==this._configureHandler&&(this._configureHandler=H,Ae(this,u,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!H}))}constructor(H,V,P,U,R,x,z,B=!1,K=void 0){this.controllerId=P,this.profileId=U,this._label=R,this.kind=x,this.runHandler=z,this._isDefault=B,this._tag=K,u.set(this,void 0),C.set(this,void 0),Ye(this,u,H,"f"),Ye(this,C,V,"f"),V.set(U,this);const Z=F[x];if(typeof Z!="number")throw new Error(`Unknown TestRunProfile.group ${x}`);Ae(this,u,"f").$publishTestRunProfile({profileId:U,controllerId:P,tag:K?t.TestTag.namespace(this.controllerId,K.id):null,label:R,group:Z,isDefault:B,hasConfigurationHandler:!1})}dispose(){Ae(this,C,"f")?.delete(this.profileId)&&(Ye(this,C,void 0,"f"),Ae(this,u,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=k,u=new WeakMap,C=new WeakMap;const F={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(De[221],Ie([1,0,18,4,5,97,8,6]),function(ie,e,i,I,w,M,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new I.Emitter,this._onDidChangeTextEditorOptions=new I.Emitter,this._onDidChangeTextEditorVisibleRanges=new I.Emitter,this._onDidChangeTextEditorViewColumn=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=O.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(O){const b=this._extHostDocumentsAndEditors.allEditors();return O?b:b.map(g=>g.value)}async showTextDocument(O,b,g){let E;typeof b=="number"?E={position:D.ViewColumn.from(b),preserveFocus:g}:typeof b=="object"?E={position:D.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?D.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:E={preserveFocus:!1};const m=await this._proxy.$tryShowTextDocument(O.uri,E),t=m&&this._extHostDocumentsAndEditors.getEditor(m);if(t)return t.value;throw m?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,b){return new M.TextEditorDecorationType(this._proxy,O,b).value}$acceptEditorPropertiesChanged(O,b){const g=this._extHostDocumentsAndEditors.getEditor(O);if(!g)throw new Error("unknown text editor");if(b.options&&g._acceptOptions(b.options),b.selections){const E=b.selections.selections.map(D.Selection.to);g._acceptSelections(E)}if(b.visibleRanges){const E=i.coalesce(b.visibleRanges.map(D.Range.to));g._acceptVisibleRanges(E)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:{...b.options,lineNumbers:D.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const E=A.TextEditorSelectionChangeKind.fromValue(b.selections.source),m=b.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:m,kind:E})}if(b.visibleRanges){const E=i.coalesce(b.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:E})}}$acceptEditorPositionData(O){for(const b in O){const g=this._extHostDocumentsAndEditors.getEditor(b);if(!g)throw new Error("Unknown text editor");const E=D.ViewColumn.to(O[b]);g.value.viewColumn!==E&&(g._acceptViewColumn(E),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:E}))}}getDiffInformation(O){return Promise.resolve(this._proxy.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(De[222],Ie([1,0,2,3,5,7,6,8,9]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class T{constructor(g,E){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=g.getProxy(w.MainContext.MainThreadTimeline),E.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===11){const t=m.uri===void 0?void 0:i.URI.revive(m.uri);return this._itemsBySourceAndUriMap.get(m.source)?.get(O(t))?.get(m.handle)}return m}})}async $getTimeline(g,E,m,t){return this._providers.get(g)?.provideTimeline(i.URI.revive(E),m,t)}registerTimelineProvider(g,E,m,t){const s=new M.DisposableStore,a=this.convertTimelineItem(E.id,t,s).bind(this);let p;E.onDidChange&&(p=E.onDidChange(u=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:E.id}),this));const S=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...E,scheme:g,onDidChange:void 0,async provideTimeline(u,C,r){C?.resetCache&&(s.clear(),S.get(E.id)?.clear());const c=await E.provideTimeline(u,C,r);if(c==null)return;const n=a(u,C);return{...c,source:E.id,items:c.items.map(n)}},dispose(){for(const u of S.values())u.get(E.id)?.clear();p?.dispose(),s.dispose()}})}convertTimelineItem(g,E,m){return(t,s)=>{let a;if(s?.cacheResults){let p=this._itemsBySourceAndUriMap.get(g);p===void 0&&(p=new Map,this._itemsBySourceAndUriMap.set(g,p));const S=O(t);a=p.get(S),a===void 0&&(a=new Map,p.set(S,a))}return p=>{const{iconPath:S,...u}=p,C=`${g}|${p.id??p.timestamp}`;a?.set(C,p);let r,c,n;p.iconPath&&(S instanceof D.ThemeIcon?n={id:S.id,color:S.color}:i.URI.isUri(S)?(r=S,c=S):{light:r,dark:c}=S);let d;return D.MarkdownString.isMarkdownString(u.tooltip)?d=A.MarkdownString.from(u.tooltip):(0,y.isString)(u.tooltip)?d=u.tooltip:D.MarkdownString.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=A.MarkdownString.from(u.detail)):(0,y.isString)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=u.detail),{...u,id:u.id??void 0,handle:C,source:g,command:p.command?E.toInternal(p.command,m):void 0,icon:r,iconDark:c,themeIcon:n,tooltip:d,accessibilityInformation:p.accessibilityInformation}}}}registerTimelineProviderCore(g){if(this._providers.get(g.id))throw new Error(`Timeline Provider ${g.id} already exists.`);return this._proxy.$registerTimelineProvider({id:g.id,label:g.label,scheme:g.scheme}),this._providers.set(g.id,g),(0,M.toDisposable)(()=>{for(const m of this._itemsBySourceAndUriMap.values())m.get(g.id)?.clear();this._providers.delete(g.id),this._proxy.$unregisterTimelineProvider(g.id),g.dispose()})}}e.ExtHostTimeline=T;function O(b){return b?.toString()}}),define(De[223],Ie([1,0,7,13,2,5]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(y){this._openers=new Map,this._proxy=y.getProxy(M.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,T,O,b){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const g=b.schemes.find(E=>!D.supportedSchemes.has(E));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,O),this._proxy.$registerUriOpener(T,b.schemes,y,b.label),(0,i.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(y,T,O){const b=this._openers.get(y);if(!b)throw new Error(`Unknown opener with id: ${y}`);const g=w.URI.revive(T);return b.canOpenExternalUri(g,O)}async $openUri(y,T,O){const b=this._openers.get(y);if(!b)throw new Error(`Unknown opener id: '${y}'`);return b.openExternalUri(w.URI.revive(T.resolvedUri),{sourceUri:w.URI.revive(T.sourceUri)},O)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(De[224],Ie([1,0,5,2,7,12,25]),function(ie,e,i,I,w,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(T,O){if(this.handles.has(D.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const b=A.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(T)),this.handlers.set(b,O),this._proxy.$registerUriHandler(b,T),(0,w.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(T)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(T,O){const b=this.handlers.get(T);if(!b)return Promise.resolve(void 0);try{b.handleUri(I.URI.revive(O))}catch(g){(0,M.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(T){return I.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=A,A.HandlePool=0});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[57],Ie([1,0,4,13,23,2,146,167,65,5]),function(ie,e,i,I,w,M,D,A,y,T){"use strict";var O,b,g,E,m,t,s,a,p,S,u,C,r;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class c{constructor(F,j,H,V,P,U,R){O.set(this,void 0),b.set(this,void 0),g.set(this,void 0),E.set(this,void 0),m.set(this,void 0),t.set(this,void 0),s.set(this,""),a.set(this,void 0),p.set(this,!1),S.set(this,!1),u.set(this,void 0),C.set(this,void 0),this._onMessageEmitter=new i.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new i.Emitter),this._onDidDispose=Ae(this,r,"f").event,Ye(this,O,F,"f"),Ye(this,b,j,"f"),Ye(this,a,H,"f"),Ye(this,E,V,"f"),Ye(this,m,P,"f"),Ye(this,t,U,"f"),Ye(this,u,n(U),"f"),Ye(this,C,d(U),"f"),Ye(this,g,R,"f")}dispose(){Ye(this,p,!0,"f"),Ae(this,r,"f").fire(),Ae(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(F){return Ye(this,S,!0,"f"),(0,y.asWebviewUri)(F,Ae(this,E,"f"))}get cspSource(){const F=Ae(this,t,"f").extensionLocation;if(F.scheme===I.Schemas.https||F.scheme===I.Schemas.http){let j=F.toString();return j.endsWith("/")||(j+="/"),j+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ae(this,s,"f")}set html(F){this.assertNotDisposed(),Ae(this,s,"f")!==F&&(Ye(this,s,F,"f"),Ae(this,C,"f")&&!Ae(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(F)&&(Ye(this,S,!0,"f"),Ae(this,g,"f").report("Webview vscode-resource: uris",Ae(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ae(this,b,"f").$setHtml(Ae(this,O,"f"),this.rewriteOldResourceUrlsIfNeeded(F)))}get options(){return this.assertNotDisposed(),Ae(this,a,"f")}set options(F){this.assertNotDisposed(),w.equals(Ae(this,a,"f"),F)||Ae(this,b,"f").$setOptions(Ae(this,O,"f"),o(Ae(this,t,"f"),Ae(this,m,"f"),F)),Ye(this,a,F,"f")}async postMessage(F){if(Ae(this,p,"f"))return!1;const j=(0,A.serializeWebviewMessage)(F,{serializeBuffersForPostMessage:Ae(this,u,"f")});return Ae(this,b,"f").$postMessage(Ae(this,O,"f"),j.message,...j.buffers)}assertNotDisposed(){if(Ae(this,p,"f"))throw new Error("Webview is disposed")}rewriteOldResourceUrlsIfNeeded(F){if(!Ae(this,C,"f"))return F;const j=Ae(this,t,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,H=Ae(this,t,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?Ae(this,t,"f").extensionLocation.authority:void 0;return F.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,P,U,R,x,z)=>{const B=M.URI.from({scheme:R||"file",path:decodeURIComponent(x)}),K=(0,y.asWebviewUri)(B,{isRemote:j,authority:H}).toString();return`${P}${K}${z}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,P,U,R,x,z)=>{const B=M.URI.from({scheme:R||"file",path:decodeURIComponent(x)}),K=(0,y.asWebviewUri)(B,{isRemote:j,authority:H}).toString();return`${P}${K}${z}`})}}e.ExtHostWebview=c,O=new WeakMap,b=new WeakMap,g=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,s=new WeakMap,a=new WeakMap,p=new WeakMap,S=new WeakMap,u=new WeakMap,C=new WeakMap,r=new WeakMap;function n(k){try{const F=(0,D.normalizeVersion)((0,D.parseVersion)(k.engines.vscode));return!!F&&F.majorBase>=1&&F.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=n;function d(k){try{const F=(0,D.normalizeVersion)((0,D.parseVersion)(k.engines.vscode));return F?F.majorBase<1||F.majorBase===1&&F.minorBase<60:!1}catch{return!1}}class l{constructor(F,j,H,V,P){this.remoteInfo=j,this.workspace=H,this._logService=V,this._deprecationService=P,this._webviews=new Map,this._webviewProxy=F.getProxy(T.MainContext.MainThreadWebviews)}$onMessage(F,j,H){const V=this.getWebview(F);if(V){const{message:P}=(0,A.deserializeWebviewMessage)(j,H.value);V._onMessageEmitter.fire(P)}}$onMissingCsp(F,j){this._logService.warn(`${j} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(F,j,H){const V=new c(F,this._webviewProxy,h(j),this.remoteInfo,this.workspace,H,this._deprecationService);return this._webviews.set(F,V),V._onDidDispose(()=>{this._webviews.delete(F)}),V}deleteWebview(F){this._webviews.delete(F)}getWebview(F){return this._webviews.get(F)}}e.ExtHostWebviews=l;function f(k){return{id:k.identifier,location:k.extensionLocation}}e.toExtensionData=f;function o(k,F,j){return{enableCommandUris:j.enableCommandUris,enableScripts:j.enableScripts,enableForms:j.enableForms,portMapping:j.portMapping,localResourceRoots:j.localResourceRoots||v(k,F)}}e.serializeWebviewOptions=o;function h(k){return{enableCommandUris:k.enableCommandUris,enableScripts:k.enableScripts,enableForms:k.enableForms,portMapping:k.portMapping,localResourceRoots:k.localResourceRoots?.map(F=>M.URI.from(F))}}function v(k,F){return[...(F?.getWorkspaceFolders()||[]).map(j=>j.uri),k.extensionLocation]}}),define(De[225],Ie([1,0,20,220,7,13,22,2,8,57,63,5,6]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class E{constructor(c,n){this.document=c,this._storagePath=n,this._backupCounter=1,this._edits=new O.Cache("custom documents")}addEdit(c){return this._edits.add([c])}async undo(c,n){await this.getEdit(c).undo(),n||this.disposeBackup()}async redo(c,n){await this.getEdit(c).redo(),n||this.disposeBackup()}disposeEdits(c){for(const n of c)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const c=C(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,c)}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(c){const n=this._edits.get(c,0);if(!n)throw new Error("No edit found");return n}}class m{constructor(){this._documents=new Map}get(c,n){return this._documents.get(this.key(c,n))}add(c,n,d){const l=this.key(c,n.uri);if(this._documents.has(l))throw new Error(`Document already exists for viewType:${c} resource:${n.uri}`);const f=new E(n,d);return this._documents.set(l,f),f}delete(c,n){const d=this.key(c,n.uri);this._documents.delete(d)}key(c,n){return`${c}@@@${n}`}}var t;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(t||(t={}));class s{constructor(){this._providers=new Map}addTextProvider(c,n,d){return this.add(0,c,n,d)}addCustomProvider(c,n,d){return this.add(1,c,n,d)}get(c){return this._providers.get(c)}add(c,n,d,l){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:c,extension:d,provider:l}),new g.Disposable(()=>this._providers.delete(n))}}class a{constructor(c,n,d,l,f){this._extHostDocuments=n,this._extensionStoragePaths=d,this._extHostWebview=l,this._extHostWebviewPanels=f,this._editorProviders=new s,this._documents=new m,this._proxy=c.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(c,n,d,l){const f=new w.DisposableStore;return S(d)?(f.add(this._editorProviders.addTextProvider(n,c,d)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(c),n,l.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(c))):(f.add(this._editorProviders.addCustomProvider(n,c,d)),p(d)&&f.add(d.onDidChangeCustomDocument(o=>{const h=this.getCustomDocumentEntry(n,o.document.uri);if(u(o)){const v=h.addEdit(o);this._proxy.$onDidEdit(o.document.uri,n,v,o.label)}else this._proxy.$onContentChange(o.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(c),n,l.webviewOptions||{},!!l.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(c))),g.Disposable.from(f,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(c,n,d,l,f){const o=this._editorProviders.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provide type for '${n}'`);const h=A.URI.revive(c),v=await o.provider.openCustomDocument(h,{backupId:d,untitledDocumentData:l?.buffer},f);let k;return p(o.provider)&&this._extensionStoragePaths&&(k=this._extensionStoragePaths.workspaceValue(o.extension)??this._extensionStoragePaths.globalValue(o.extension)),this._documents.add(n,v,k),{editable:p(o.provider)}}async $disposeCustomDocument(c,n){const d=this._editorProviders.get(n);if(!d)throw new Error(`No provider found for '${n}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${n}'`);const l=A.URI.revive(c),{document:f}=this.getCustomDocumentEntry(n,l);this._documents.delete(n,f),f.dispose()}async $resolveWebviewEditor(c,n,d,l,f,o){const h=this._editorProviders.get(d);if(!h)throw new Error(`No provider found for '${d}'`);const v=y.ViewColumn.to(f),k=this._extHostWebview.createNewWebview(n,l.contentOptions,h.extension),F=this._extHostWebviewPanels.createNewWebviewPanel(n,d,l.title,v,l.options,k,!0),j=A.URI.revive(c);switch(h.type){case 1:{const{document:H}=this.getCustomDocumentEntry(d,j);return h.provider.resolveCustomEditor(H,F,o)}case 0:{const H=this._extHostDocuments.getDocument(j);return h.provider.resolveCustomTextEditor(H,F,o)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,n,d){this.getCustomDocumentEntry(n,c).disposeEdits(d)}async $onMoveCustomEditor(c,n,d){const l=this._editorProviders.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(!l.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this._extHostWebviewPanels.getWebviewPanel(c);if(!f)throw new Error("No webview found");const o=A.URI.revive(n),h=this._extHostDocuments.getDocument(o);await l.provider.moveCustomTextEditor(h,f,i.CancellationToken.None)}async $undo(c,n,d,l){return this.getCustomDocumentEntry(n,c).undo(d,l)}async $redo(c,n,d,l){return this.getCustomDocumentEntry(n,c).redo(d,l)}async $revert(c,n,d){const l=this.getCustomDocumentEntry(n,c);await this.getCustomEditorProvider(n).revertCustomDocument(l.document,d),l.disposeBackup()}async $onSave(c,n,d){const l=this.getCustomDocumentEntry(n,c);await this.getCustomEditorProvider(n).saveCustomDocument(l.document,d),l.disposeBackup()}async $onSaveAs(c,n,d,l){const f=this.getCustomDocumentEntry(n,c);return this.getCustomEditorProvider(n).saveCustomDocumentAs(f.document,A.URI.revive(d),l)}async $backup(c,n,d){const l=this.getCustomDocumentEntry(n,c),o=await this.getCustomEditorProvider(n).backupCustomDocument(l.document,{destination:l.getNewBackupUri()},d);return l.updateBackup(o),o.id}getCustomDocumentEntry(c,n){const d=this._documents.get(c,A.URI.revive(n));if(!d)throw new Error("No custom document found");return d}getCustomEditorProvider(c){const d=this._editorProviders.get(c)?.provider;if(!d||!p(d))throw new Error("Custom document is not editable");return d}}e.ExtHostCustomEditors=a;function p(r){return!!r.onDidChangeCustomDocument}function S(r){return typeof r.resolveCustomTextEditor=="function"}function u(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function C(r){const c=r.scheme===M.Schemas.file||r.scheme===M.Schemas.untitled?r.fsPath:r.toString();return(0,I.hash)(c)+""}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[226],Ie([1,0,4,7,2,38,8,57,5,6]),function(ie,e,i,I,w,M,D,A,y,T){"use strict";var O,b,g,E,m,t,s,a,p,S,u,C,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class c extends I.Disposable{constructor(f,o,h,v){super(),O.set(this,void 0),b.set(this,void 0),g.set(this,void 0),E.set(this,void 0),m.set(this,void 0),t.set(this,void 0),s.set(this,void 0),a.set(this,void 0),p.set(this,!0),S.set(this,void 0),u.set(this,!1),C.set(this,this._register(new i.Emitter)),this.onDidDispose=Ae(this,C,"f").event,r.set(this,this._register(new i.Emitter)),this.onDidChangeViewState=Ae(this,r,"f").event,Ye(this,O,f,"f"),Ye(this,b,o,"f"),Ye(this,E,h,"f"),Ye(this,g,v.viewType,"f"),Ye(this,m,v.panelOptions,"f"),Ye(this,a,v.viewColumn,"f"),Ye(this,t,v.title,"f"),Ye(this,S,v.active,"f")}dispose(){Ae(this,u,"f")||(Ye(this,u,!0,"f"),Ae(this,C,"f").fire(),Ae(this,b,"f").$disposeWebview(Ae(this,O,"f")),Ae(this,E,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ae(this,E,"f")}get viewType(){return this.assertNotDisposed(),Ae(this,g,"f")}get title(){return this.assertNotDisposed(),Ae(this,t,"f")}set title(f){this.assertNotDisposed(),Ae(this,t,"f")!==f&&(Ye(this,t,f,"f"),Ae(this,b,"f").$setTitle(Ae(this,O,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ae(this,s,"f")}set iconPath(f){this.assertNotDisposed(),Ae(this,s,"f")!==f&&(Ye(this,s,f,"f"),Ae(this,b,"f").$setIconPath(Ae(this,O,"f"),w.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ae(this,m,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ae(this,a,"f")=="number"&&Ae(this,a,"f")<0))return Ae(this,a,"f")}get active(){return this.assertNotDisposed(),Ae(this,S,"f")}get visible(){return this.assertNotDisposed(),Ae(this,p,"f")}_updateViewState(f){Ae(this,u,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Ye(this,S,f.active,"f"),Ye(this,p,f.visible,"f"),Ye(this,a,f.viewColumn,"f"),Ae(this,r,"f").fire({webviewPanel:this}))}reveal(f,o){this.assertNotDisposed(),Ae(this,b,"f").$reveal(Ae(this,O,"f"),{viewColumn:typeof f>"u"?void 0:D.ViewColumn.from(f),preserveFocus:!!o})}assertNotDisposed(){if(Ae(this,u,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,b=new WeakMap,g=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,s=new WeakMap,a=new WeakMap,p=new WeakMap,S=new WeakMap,u=new WeakMap,C=new WeakMap,r=new WeakMap;class n{static newHandle(){return(0,M.generateUuid)()}constructor(f,o,h){this.webviews=o,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(f,o,h,v,k={}){const F=typeof v=="object"?v.viewColumn:v,j={viewColumn:D.ViewColumn.from(F),preserveFocus:typeof v=="object"&&!!v.preserveFocus},H=(0,A.shouldSerializeBuffersForPostMessage)(f),V=n.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(f),V,o,{title:h,panelOptions:d(k),webviewOptions:(0,A.serializeWebviewOptions)(f,this.workspace,k),serializeBuffersForPostMessage:H},j);const P=this.webviews.createNewWebview(V,k,f);return this.createNewWebviewPanel(V,o,h,F,k,P,!0)}$onDidChangeWebviewPanelViewStates(f){const o=Object.keys(f);o.sort((h,v)=>{const k=f[h],F=f[v];return k.active?1:F.active?-1:+k.visible-+F.visible});for(const h of o){const v=this.getWebviewPanel(h);if(!v)continue;const k=f[h];v._updateViewState({active:k.active,visible:k.visible,viewColumn:D.ViewColumn.to(k.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,o,h){if(this._serializers.has(o))throw new Error(`Serializer for '${o}' already registered`);return this._serializers.set(o,{serializer:h,extension:f}),this._proxy.$registerSerializer(o,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(f)}),new T.Disposable(()=>{this._serializers.delete(o),this._proxy.$unregisterSerializer(o)})}async $deserializeWebviewPanel(f,o,h,v){const k=this._serializers.get(o);if(!k)throw new Error(`No serializer found for '${o}'`);const{serializer:F,extension:j}=k,H=this.webviews.createNewWebview(f,h.webviewOptions,j),V=this.createNewWebviewPanel(f,o,h.title,v,h.panelOptions,H,h.active);await F.deserializeWebviewPanel(V,h.state)}createNewWebviewPanel(f,o,h,v,k,F,j){const H=new c(f,this._proxy,F,{viewType:o,title:h,viewColumn:v,panelOptions:k,active:j});return this._webviewPanels.set(f,H),H}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=n;function d(l){return{enableFindWidget:l.enableFindWidget,retainContextWhenHidden:l.retainContextWhenHidden}}});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[227],Ie([1,0,4,7,57,8,5,6]),function(ie,e,i,I,w,M,D,A){"use strict";var y,T,O,b,g,E,m,t,s,a,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class S extends I.Disposable{constructor(r,c,n,d,l,f){super(),y.set(this,void 0),T.set(this,void 0),O.set(this,void 0),b.set(this,void 0),g.set(this,!1),E.set(this,void 0),m.set(this,void 0),t.set(this,void 0),s.set(this,void 0),a.set(this,this._register(new i.Emitter)),this.onDidChangeVisibility=Ae(this,a,"f").event,p.set(this,this._register(new i.Emitter)),this.onDidDispose=Ae(this,p,"f").event,Ye(this,O,n,"f"),Ye(this,m,d,"f"),Ye(this,y,r,"f"),Ye(this,T,c,"f"),Ye(this,b,l,"f"),Ye(this,E,f,"f")}dispose(){Ae(this,g,"f")||(Ye(this,g,!0,"f"),Ae(this,p,"f").fire(),Ae(this,b,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ae(this,m,"f")}set title(r){this.assertNotDisposed(),Ae(this,m,"f")!==r&&(Ye(this,m,r,"f"),Ae(this,T,"f").$setWebviewViewTitle(Ae(this,y,"f"),r))}get description(){return this.assertNotDisposed(),Ae(this,t,"f")}set description(r){this.assertNotDisposed(),Ae(this,t,"f")!==r&&(Ye(this,t,r,"f"),Ae(this,T,"f").$setWebviewViewDescription(Ae(this,y,"f"),r))}get visible(){return Ae(this,E,"f")}get webview(){return Ae(this,b,"f")}get viewType(){return Ae(this,O,"f")}_setVisible(r){r===Ae(this,E,"f")||Ae(this,g,"f")||(Ye(this,E,r,"f"),Ae(this,a,"f").fire())}get badge(){return this.assertNotDisposed(),Ae(this,s,"f")}set badge(r){this.assertNotDisposed(),!(r?.value===Ae(this,s,"f")?.value&&r?.tooltip===Ae(this,s,"f")?.tooltip)&&(Ye(this,s,M.ViewBadge.from(r),"f"),Ae(this,T,"f").$setWebviewViewBadge(Ae(this,y,"f"),r))}show(r){this.assertNotDisposed(),Ae(this,T,"f").$show(Ae(this,y,"f"),!!r)}assertNotDisposed(){if(Ae(this,g,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,T=new WeakMap,O=new WeakMap,b=new WeakMap,g=new WeakMap,E=new WeakMap,m=new WeakMap,t=new WeakMap,s=new WeakMap,a=new WeakMap,p=new WeakMap;class u{constructor(r,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=r.getProxy(D.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(r,c,n,d){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:n,extension:r}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(r),c,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,w.shouldSerializeBuffersForPostMessage)(r)}),new A.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(r,c,n,d,l){const f=this._viewProviders.get(c);if(!f)throw new Error(`No view provider found for '${c}'`);const{provider:o,extension:h}=f,v=this._extHostWebview.createNewWebview(r,{},h),k=new S(r,this._proxy,c,n,v,!0);this._webviewViews.set(r,k),await o.resolveWebviewView(k,{state:d},l)}async $onDidChangeWebviewViewVisibility(r,c){this.getWebviewView(r)._setVisible(c)}async $disposeWebviewView(r){const c=this.getWebviewView(r);this._webviewViews.delete(r),c.dispose(),this._extHostWebview.deleteWebview(r)}getWebviewView(r){const c=this._webviewViews.get(r);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=u}),define(De[99],Ie([1,0,4,5,2,13,10,3,14]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class Zi{get state(){return this._state}constructor(b){this._onDidChangeWindowState=new i.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Zi.InitialState,this._proxy=b.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,g){let E;if(typeof b=="string"){E=b;try{b=w.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,D.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,E,g)}async asExternalUri(b,g){if((0,D.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this._proxy.$asExternalUri(b,g);return w.URI.from(E)}};T.InitialState={focused:!0},T=He([$e(0,y.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(De[228],Ie([1,0,198,26,14]),function(ie,e,i,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let M=class extends i.AbstractExtHostConsoleForwarder{constructor(A,y){super(A,y)}_nativeConsoleLogMessage(A,y,T){y.apply(console,T)}};M=He([$e(0,w.IExtHostRpcService),$e(1,I.IExtHostInitDataService)],M),e.ExtHostConsoleForwarder=M}),define(De[229],Ie([1,0,15,24,20,12,4,7,120,192,43]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(k,F){try{return JSON.stringify(k,F)}catch{return"null"}}const E="$$ref$$",m={[E]:-1};class t{constructor(F,j){this.jsonString=F,this.referencedBuffers=j}}function s(k,F=null,j=!1){const H=[];return{jsonString:(j?g:JSON.stringify)(k,(P,U)=>{if(typeof U>"u")return m;if(typeof U=="object"){if(U instanceof I.VSBuffer){const R=H.push(U)-1;return{[E]:R}}if(F)return F(P,U)}return U}),referencedBuffers:H}}e.stringifyJsonWithBufferRefs=s;function a(k,F,j){return JSON.parse(k,(H,V)=>{if(V){const P=V[E];if(typeof P=="number")return F[P];if(j&&V.$mid===1)return j.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=a;function p(k,F){return JSON.stringify(k,F)}function S(k){return k?(F,j)=>j&&j.$mid===1?k.transformOutgoing(j):j:null}var u;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));var C;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(C=e.ResponsiveState||(e.ResponsiveState={}));const r=()=>{},c=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class d extends A.Disposable{constructor(F,j=null,H=null){super(),this[b]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=F,this._logger=j,this._uriTransformer=H,this._uriReplacer=S(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let V=0,P=O.ProxyIdentifier.count;V<P;V++)this._locals[V]=null,this._proxies[V]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new i.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(V=>this._receiveOneMessage(V))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(F=>{this._pendingRPCReplies[F].resolveErr(M.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(F){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(F){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(F){this._responsiveState!==F&&(this._responsiveState=F,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(F){return this._uriTransformer?(0,y.transformIncomingURIs)(F,this._uriTransformer):F}getProxy(F){const{nid:j,sid:H}=F;return this._proxies[j]||(this._proxies[j]=this._createProxy(j,H)),this._proxies[j]}_createProxy(F,j){const H={get:(V,P)=>(typeof P=="string"&&!V[P]&&P.charCodeAt(0)===36&&(V[P]=(...U)=>this._remoteCall(F,P,U)),P===n?j:V[P])};return new Proxy(Object.create(null),H)}set(F,j){return this._locals[F.nid]=j,j}assertRegistered(F){for(let j=0,H=F.length;j<H;j++){const V=F[j];if(!this._locals[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}_receiveOneMessage(F){if(this._isDisposed)return;const j=F.byteLength,H=l.read(F,0),V=H.readUInt8(),P=H.readUInt32();switch(V){case 1:case 2:{let{rpcId:U,method:R,args:x}=o.deserializeRequestJSONArgs(H);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(j,P,U,R,x,V===2);break}case 3:case 4:{let{rpcId:U,method:R,args:x}=o.deserializeRequestMixedArgs(H);this._uriTransformer&&(x=(0,y.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(j,P,U,R,x,V===4);break}case 5:{this._logger?.logIncoming(j,P,0,"ack"),this._onDidReceiveAcknowledge(P);break}case 6:{this._receiveCancel(j,P);break}case 7:{this._receiveReply(j,P,void 0);break}case 9:{let U=o.deserializeReplyOKJSON(H);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReply(j,P,U);break}case 10:{const U=o.deserializeReplyOKJSONWithBuffers(H,this._uriTransformer);this._receiveReply(j,P,U);break}case 8:{const U=o.deserializeReplyOKVSBuffer(H);this._receiveReply(j,P,U);break}case 11:{let U=o.deserializeReplyErrError(H);this._uriTransformer&&(U=(0,y.transformIncomingURIs)(U,this._uriTransformer)),this._receiveReplyErr(j,P,U);break}case 12:{this._receiveReplyErr(j,P,void 0);break}default:console.error("received unexpected message"),console.error(F)}}_receiveRequest(F,j,H,V,P,U){this._logger?.logIncoming(F,j,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(H)}.${V}(`,P);const R=String(j);let x,z;if(U){const K=new w.CancellationTokenSource;P.push(K.token),x=this._invokeHandler(H,V,P),z=()=>K.cancel()}else x=this._invokeHandler(H,V,P),z=r;this._cancelInvokedHandlers[R]=z;const B=o.serializeAcknowledged(j);this._logger?.logOutgoing(B.byteLength,j,1,"ack"),this._protocol.send(B),x.then(K=>{delete this._cancelInvokedHandlers[R];const Z=o.serializeReplyOK(j,K,this._uriReplacer);this._logger?.logOutgoing(Z.byteLength,j,1,"reply:",K),this._protocol.send(Z)},K=>{delete this._cancelInvokedHandlers[R];const Z=o.serializeReplyErr(j,K);this._logger?.logOutgoing(Z.byteLength,j,1,"replyErr:",K),this._protocol.send(Z)})}_receiveCancel(F,j){this._logger?.logIncoming(F,j,1,"receiveCancel");const H=String(j);this._cancelInvokedHandlers[H]?.()}_receiveReply(F,j,H){this._logger?.logIncoming(F,j,0,"receiveReply:",H);const V=String(j);if(!this._pendingRPCReplies.hasOwnProperty(V))return;const P=this._pendingRPCReplies[V];delete this._pendingRPCReplies[V],P.resolveOk(H)}_receiveReplyErr(F,j,H){this._logger?.logIncoming(F,j,0,"receiveReplyErr:",H);const V=String(j);if(!this._pendingRPCReplies.hasOwnProperty(V))return;const P=this._pendingRPCReplies[V];delete this._pendingRPCReplies[V];let U;H&&(H.$isError?(U=new Error,U.name=H.name,U.message=H.message,U.stack=H.stack):U=H),P.resolveErr(U)}_invokeHandler(F,j,H){try{return Promise.resolve(this._doInvokeHandler(F,j,H))}catch(V){return Promise.reject(V)}}_doInvokeHandler(F,j,H){const V=this._locals[F];if(!V)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(F));const P=V[j];if(typeof P!="function")throw new Error("Unknown method "+j+" on actor "+(0,O.getStringIdentifierForProxy)(F));return P.apply(V,H)}_remoteCall(F,j,H){if(this._isDisposed)return new T.CanceledLazyPromise;let V=null;if(H.length>0&&w.CancellationToken.isCancellationToken(H[H.length-1])&&(V=H.pop()),V&&V.isCancellationRequested)return Promise.reject(M.canceled());const P=o.serializeRequestArguments(H,this._uriReplacer),U=++this._lastMessageId,R=String(U),x=new T.LazyPromise;V&&V.onCancellationRequested(()=>{const B=o.serializeCancel(U);this._logger?.logOutgoing(B.byteLength,U,0,"cancel"),this._protocol.send(o.serializeCancel(U))}),this._pendingRPCReplies[R]=x,this._onWillSendRequest(U);const z=o.serializeRequest(U,F,j,P,!!V);return this._logger?.logOutgoing(z.byteLength,U,0,`request: ${(0,O.getStringIdentifierForProxy)(F)}.${j}(`,H),this._protocol.send(z),x}}e.RPCProtocol=d,b=c,d.UNRESPONSIVE_TIME=3*1e3;class l{static alloc(F,j,H){const V=new l(I.VSBuffer.alloc(H+1+4),0);return V.writeUInt8(F),V.writeUInt32(j),V}static read(F,j){return new l(F,j)}get buffer(){return this._buff}constructor(F,j){this._buff=F,this._offset=j}static sizeUInt8(){return 1}writeUInt8(F){this._buff.writeUInt8(F,this._offset),this._offset+=1}readUInt8(){const F=this._buff.readUInt8(this._offset);return this._offset+=1,F}writeUInt32(F){this._buff.writeUInt32BE(F,this._offset),this._offset+=4}readUInt32(){const F=this._buff.readUInt32BE(this._offset);return this._offset+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this._buff.writeUInt8(F.byteLength,this._offset),this._offset+=1,this._buff.set(F,this._offset),this._offset+=F.byteLength}readShortString(){const F=this._buff.readUInt8(this._offset);this._offset+=1;const H=this._buff.slice(this._offset,this._offset+F).toString();return this._offset+=F,H}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}readLongString(){const F=this._buff.readUInt32BE(this._offset);this._offset+=4;const H=this._buff.slice(this._offset,this._offset+F).toString();return this._offset+=F,H}writeBuffer(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this._buff.writeUInt32BE(F.byteLength,this._offset),this._offset+=4,this._buff.set(F,this._offset),this._offset+=F.byteLength}readVSBuffer(){const F=this._buff.readUInt32BE(this._offset);this._offset+=4;const j=this._buff.slice(this._offset,this._offset+F);return this._offset+=F,j}static sizeMixedArray(F){let j=0;j+=1;for(let H=0,V=F.length;H<V;H++){const P=F[H];switch(j+=1,P.type){case 1:j+=this.sizeLongString(P.value);break;case 2:j+=this.sizeVSBuffer(P.value);break;case 3:j+=this.sizeUInt32,j+=this.sizeLongString(P.value);for(let U=0;U<P.buffers.length;++U)j+=this.sizeVSBuffer(P.buffers[U]);break;case 4:break}}return j}writeMixedArray(F){this._buff.writeUInt8(F.length,this._offset),this._offset+=1;for(let j=0,H=F.length;j<H;j++){const V=F[j];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let P=0;P<V.buffers.length;++P)this.writeBuffer(V.buffers[P]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this._buff.readUInt8(this._offset);this._offset+=1;const j=new Array(F);for(let H=0;H<F;H++)switch(this.readUInt8()){case 1:j[H]=this.readLongString();break;case 2:j[H]=this.readVSBuffer();break;case 3:{const P=this.readUInt32(),U=this.readLongString(),R=[];for(let x=0;x<P;++x)R.push(this.readVSBuffer());j[H]=new O.SerializableObjectWithBuffers(a(U,R,null));break}case 4:j[H]=void 0;break}return j}}l.sizeUInt32=4;var f;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(f||(f={}));class o{static _useMixedArgSerialization(F){for(let j=0,H=F.length;j<H;j++)if(F[j]instanceof I.VSBuffer||F[j]instanceof O.SerializableObjectWithBuffers||typeof F[j]>"u")return!0;return!1}static serializeRequestArguments(F,j){if(this._useMixedArgSerialization(F)){const H=[];for(let V=0,P=F.length;V<P;V++){const U=F[V];if(U instanceof I.VSBuffer)H[V]={type:2,value:U};else if(typeof U>"u")H[V]={type:4};else if(U instanceof O.SerializableObjectWithBuffers){const{jsonString:R,referencedBuffers:x}=s(U.value,j);H[V]={type:3,value:I.VSBuffer.fromString(R),buffers:x}}else H[V]={type:1,value:I.VSBuffer.fromString(p(U,j))}}return{type:1,args:H}}return{type:0,args:p(F,j)}}static serializeRequest(F,j,H,V,P){switch(V.type){case 0:return this._requestJSONArgs(F,j,H,V.args,P);case 1:return this._requestMixedArgs(F,j,H,V.args,P)}}static _requestJSONArgs(F,j,H,V,P){const U=I.VSBuffer.fromString(H),R=I.VSBuffer.fromString(V);let x=0;x+=l.sizeUInt8(),x+=l.sizeShortString(U),x+=l.sizeLongString(R);const z=l.alloc(P?2:1,F,x);return z.writeUInt8(j),z.writeShortString(U),z.writeLongString(R),z.buffer}static deserializeRequestJSONArgs(F){const j=F.readUInt8(),H=F.readShortString(),V=F.readLongString();return{rpcId:j,method:H,args:JSON.parse(V)}}static _requestMixedArgs(F,j,H,V,P){const U=I.VSBuffer.fromString(H);let R=0;R+=l.sizeUInt8(),R+=l.sizeShortString(U),R+=l.sizeMixedArray(V);const x=l.alloc(P?4:3,F,R);return x.writeUInt8(j),x.writeShortString(U),x.writeMixedArray(V),x.buffer}static deserializeRequestMixedArgs(F){const j=F.readUInt8(),H=F.readShortString(),V=F.readMixedArray(),P=new Array(V.length);for(let U=0,R=V.length;U<R;U++){const x=V[U];typeof x=="string"?P[U]=JSON.parse(x):P[U]=x}return{rpcId:j,method:H,args:P}}static serializeAcknowledged(F){return l.alloc(5,F,0).buffer}static serializeCancel(F){return l.alloc(6,F,0).buffer}static serializeReplyOK(F,j,H){if(typeof j>"u")return this._serializeReplyOKEmpty(F);if(j instanceof I.VSBuffer)return this._serializeReplyOKVSBuffer(F,j);if(j instanceof O.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:P}=s(j.value,H,!0);return this._serializeReplyOKJSONWithBuffers(F,V,P)}else return this._serializeReplyOKJSON(F,g(j,H))}static _serializeReplyOKEmpty(F){return l.alloc(7,F,0).buffer}static _serializeReplyOKVSBuffer(F,j){let H=0;H+=l.sizeVSBuffer(j);const V=l.alloc(8,F,H);return V.writeVSBuffer(j),V.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static _serializeReplyOKJSON(F,j){const H=I.VSBuffer.fromString(j);let V=0;V+=l.sizeLongString(H);const P=l.alloc(9,F,V);return P.writeLongString(H),P.buffer}static _serializeReplyOKJSONWithBuffers(F,j,H){const V=I.VSBuffer.fromString(j);let P=0;P+=l.sizeUInt32,P+=l.sizeLongString(V);for(const R of H)P+=l.sizeVSBuffer(R);const U=l.alloc(10,F,P);U.writeUInt32(H.length),U.writeLongString(V);for(const R of H)U.writeBuffer(R);return U.buffer}static deserializeReplyOKJSON(F){const j=F.readLongString();return JSON.parse(j)}static deserializeReplyOKJSONWithBuffers(F,j){const H=F.readUInt32(),V=F.readLongString(),P=[];for(let U=0;U<H;++U)P.push(F.readVSBuffer());return new O.SerializableObjectWithBuffers(a(V,P,j))}static serializeReplyErr(F,j){const H=j?g(M.transformErrorForSerialization(j),null):void 0;if(typeof H!="string")return this._serializeReplyErrEmpty(F);const V=I.VSBuffer.fromString(H);let P=0;P+=l.sizeLongString(V);const U=l.alloc(11,F,P);return U.writeLongString(V),U.buffer}static deserializeReplyErrError(F){const j=F.readLongString();return JSON.parse(j)}static _serializeReplyErrEmpty(F){return l.alloc(12,F,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var v;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(v||(v={}))}),define(De[230],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const i=function(M){const D=A=>{self.removeEventListener("message",D);const y=A.data;Object.defineProperties(self,{postMessage:{value(T,O){y.postMessage(T,O)}},onmessage:{get(){return y.onmessage},set(T){y.onmessage=T}}}),y.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};self.addEventListener("message",D)}.toString();class I extends EventTarget{constructor(M,D,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${i})('${D}'))`,T=new Blob([y],{type:"application/javascript"}),O=URL.createObjectURL(T),b=new MessageChannel,g=O,E={type:"_newWorker",id:g,port:b.port2,url:O,options:A};M(E,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{M({type:"_terminateWorker",id:g}),URL.revokeObjectURL(O),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(m){b.port1.onmessage=m}},onmessageerror:{get(){return b.port1.onmessageerror},set(m){b.port1.onmessageerror=m}}}),b.port1.addEventListener("messageerror",m=>{const t=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(t)}),b.port1.addEventListener("message",m=>{const t=new MessageEvent("message",{data:m.data});this.dispatchEvent(t)}),b.port1.start()}}e.NestedWorker=I}),define(De[231],Ie([1,0,4,30,41,3,35,12,15]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new w.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new w.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new w.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,M.createDecorator)(e.OUTPUT_SERVICE_ID);var T;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(T=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.channels=new Map,this._onDidRegisterChannel=new i.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new i.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(m){this.channels.has(m.id)||(this.channels.set(m.id,m),this._onDidRegisterChannel.fire(m.id))}getChannels(){const m=[];return this.channels.forEach(t=>m.push(t)),m}getChannel(m){return this.channels.get(m)}removeChannel(m){this.channels.delete(m),this._onDidRemoveChannel.fire(m)}}I.Registry.add(e.Extensions.OutputChannels,new O);function b(E,m,t,s,a){return(0,y.createCancelablePromise)(async p=>{await(0,D.whenProviderRegistered)(t,s);const S=I.Registry.as(e.Extensions.OutputChannels);try{await g(t,1,s,a,p),S.registerChannel({id:E,label:m,file:t,log:!0})}catch(u){(0,A.isCancellationError)(u)||a.error("Error while registering log channel",t.toString(),(0,A.getErrorMessage)(u))}})}e.registerLogChannel=b;async function g(E,m,t,s,a){if(!await t.exists(E)){if(a.isCancellationRequested)throw new A.CancellationError;if(m>10)throw new Error("Timed out while waiting for file to be created");s.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",E.toString()),await(0,y.timeout)(1e3,a),await g(E,m+1,t,s,a)}}e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new w.RawContextKey("activeOutputChannel","")}),define(De[100],Ie([1,0,5,3,14,25,11,231,55,26,36,113,24,9,35,4,7,27]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class p extends D.AbstractMessageLogger{get disposed(){return this._disposed}constructor(r,c,n,d,l){super(),this.id=r,this.name=c,this.logger=n,this.proxy=d,this.extension=l,this.offset=0,this._disposed=!1,this.visible=!1,this._register(n.onDidChangeLogLevel(f=>this.setLevel(f)))}get logLevel(){return this.logger.getLevel()}appendLine(r){this.append(r+`
`)}append(r){this.info(r),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const r=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,r)}replace(r){const c=this.offset;this.info(r),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,c),this.visible&&this.logger.flush()}show(r,c){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof r=="boolean"?r:c))}hide(){this.proxy.$close(this.id)}log(r,c){this.offset+=g.VSBuffer.fromString(c).byteLength,(0,D.log)(this.logger,r,c)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}class S extends p{appendLine(r){this.append(r)}}let u=class{constructor(r,c,n,d,l,f){this.initData=c,this.extHostFileSystem=n,this.extHostFileSystemInfo=d,this.loggerService=l,this.logService=f,this.extensionLogDirectoryPromise=new Map,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=r.getProxy(i.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(c.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(r){this.visibleChannelId=r;for(const[c,n]of this.channels)n.visible=c===this.visibleChannelId}createOutputChannel(r,c,n){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");const d=typeof c=="object"&&c.log;d&&(0,a.checkProposedApiEnabled)(n,"extensionLog");const l=(0,E.isString)(c)?c:void 0;if((0,E.isString)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let f;const o=this.initData.environment.extensionLogLevel?.find(([v])=>M.ExtensionIdentifier.equals(n.identifier,v))?.[1];o&&(f=(0,D.parseLogLevel)(o));const h=d?this.doCreateLogOutputChannel(r,f,n):this.doCreateOutputChannel(r,l,n);return h.then(v=>{this.channels.set(v.id,v),v.visible=v.id===this.visibleChannelId}),d?this.createExtHostLogOutputChannel(r,f??this.logService.getLevel(),h):this.createExtHostOutputChannel(r,h)}async doCreateOutputChannel(r,c,n){this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation));const d=await this.outputDirectoryPromise,l=this.extHostFileSystemInfo.extUri.joinPath(d,`${this.namePool++}-${r.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(l,{always:!0,donotRotate:!0,donotUseFormatters:!0}),o=await this.proxy.$register(r,l,!1,c,n.identifier.value);return new p(o,r,f,this.proxy,n)}async doCreateLogOutputChannel(r,c,n){const d=await this.createExtensionLogDirectory(n),l=this.extHostFileSystemInfo.extUri.joinPath(d,`${r.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),f=this.loggerService.createLogger(l,{name:r},c),o=await this.proxy.$register(r,l,!0,void 0,n.identifier.value);return new S(o,r,f,this.proxy,n)}createExtensionLogDirectory(r){let c=this.extensionLogDirectoryPromise.get(r.identifier.value);if(!c){const n=this.extHostFileSystemInfo.extUri.joinPath(this.initData.logsLocation,r.identifier.value);this.extensionLogDirectoryPromise.set(r.identifier.value,c=(async()=>{try{await this.extHostFileSystem.value.createDirectory(n)}catch(d){if((0,m.toFileSystemProviderErrorCode)(d)!==m.FileSystemProviderErrorCode.FileExists)throw d}return n})())}return c}createExtHostOutputChannel(r,c){let n=!1;const d=()=>{if(n)throw new Error("Channel has been closed")};return{get name(){return r},append(l){d(),c.then(f=>f.append(l))},appendLine(l){d(),c.then(f=>f.appendLine(l))},clear(){d(),c.then(l=>l.clear())},replace(l){d(),c.then(f=>f.replace(l))},show(l,f){d(),c.then(o=>o.show(l,f))},hide(){d(),c.then(l=>l.hide())},dispose(){n=!0,c.then(l=>l.dispose())}}}createExtHostLogOutputChannel(r,c,n){const d=new s.DisposableStore,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},f=d.add(new t.Emitter);return n.then(o=>{d.add(o),d.add(o.onDidChangeLogLevel(h=>{c=h,f.fire(h)}))}),{...this.createExtHostOutputChannel(r,n),get logLevel(){return c},onDidChangeLogLevel:f.event,trace(o,...h){l(),n.then(v=>v.trace(o,...h))},debug(o,...h){l(),n.then(v=>v.debug(o,...h))},info(o,...h){l(),n.then(v=>v.info(o,...h))},warn(o,...h){l(),n.then(v=>v.warn(o,...h))},error(o,...h){l(),n.then(v=>v.error(o,...h))},dispose(){d.dispose()}}}};u=He([$e(0,w.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,y.IExtHostConsumerFileSystem),$e(3,O.IExtHostFileSystemInfo),$e(4,D.ILoggerService),$e(5,D.ILogService)],u),e.ExtHostOutputService=u,e.IExtHostOutputService=(0,I.createDecorator)("IExtHostOutputService")}),define(De[232],Ie([1,0,3]),function(ie,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,i.createDecorator)("remoteAgentService")}),define(De[233],Ie([1,0,39,13,19,21,22,2,3,163,49,178,232]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let E=class en{constructor(t,s,a,p){this.localUserHome=t,this.remoteAgentService=s,this.environmentService=a,this.contextService=p,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||M.OS)(),this.resolveUserHome=(async()=>{const S=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=S?.userHome??t})()}hasValidBasename(t,s,a){return typeof s=="string"||typeof s>"u"?this.resolveOS.then(p=>this.doHasValidBasename(t,p,s)):this.doHasValidBasename(t,s,a)}doHasValidBasename(t,s,a){return t.scheme===I.Schemas.file||t.scheme===I.Schemas.vscodeRemote?(0,i.isValidBasename)(a??(0,D.basename)(t),s===1):!0}get defaultUriScheme(){return en.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(t,s){if(t.remoteAuthority)return I.Schemas.vscodeRemote;const a=(0,T.getVirtualWorkspaceScheme)(s.getWorkspace());if(a)return a;const p=s.getWorkspace().folders[0];if(p)return p.uri.scheme;const S=s.getWorkspace().configuration;return S?S.scheme:I.Schemas.file}userHome(t){return t?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(t=>t===1?w.win32:w.posix)}async fileURI(t){let s="";if(await this.resolveOS===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const p=t.indexOf("/",2);p===-1?(s=t.substring(2),t="/"):(s=t.substring(2,p),t=t.substring(p)||"/")}return A.URI.from({scheme:I.Schemas.file,authority:s,path:t,query:"",fragment:""})}};E=He([$e(1,g.IRemoteAgentService),$e(2,b.IWorkbenchEnvironmentService),$e(3,O.IWorkspaceContextService)],E),e.AbstractPathService=E}),define(De[101],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class i{constructor(D,A){this.line=D,this.character=A}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,A){return new i(0,0)}with(D){return new i(0,0)}}e.Position=i;class I{constructor(D,A,y,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(D,A),this.end=new i(y,T)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new I(0,0,0,0)}with(D){return new I(0,0,0,0)}}e.Range=I;var w;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[44],Ie([1,0,18,34,23,39,10,3,19,12,101,15]),function(ie,e,i,I,w,M,D,A,y,T,O,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",E=" characters skipped \u27EB",m=(g.length+E.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var t;(function(ne){ne[ne.file=0]="file",ne[ne.text=1]="text"})(t=e.SearchProviderType||(e.SearchProviderType={}));var s;(function(ne){ne[ne.File=1]="File",ne[ne.Text=2]="Text"})(s=e.QueryType||(e.QueryType={}));function a(ne){return!!ne.preview}e.resultIsMatch=a;function p(ne){return!!ne.resource}e.isFileMatch=p;function S(ne){return!!ne.message}e.isProgressMessage=S;var u;(function(ne){ne[ne.Normal=0]="Normal",ne[ne.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class C{constructor(pe){this.resource=pe,this.results=[]}}e.FileMatch=C;class r{constructor(pe,ae,de){this.ranges=ae;const Y=Array.isArray(ae)?ae:[ae];if(de&&de.matchLines===1&&c(Y)){pe=(0,D.getNLines)(pe,de.matchLines);let me="",Se=0,Oe=0;const Be=Math.floor(de.charsPerLine/5),Xe=[];for(const ke of Y){const ye=Math.max(ke.startColumn-Be,0),Ce=ke.startColumn+de.charsPerLine;if(ye>Oe+Be+m){const se=g+(ye-Oe)+E;me+=se+pe.slice(ye,Ce),Se+=ye-(Oe+se.length)}else me+=pe.slice(Oe,Ce);Xe.push(new d(0,ke.startColumn-Se,ke.endColumn-Se)),Oe=Ce}this.preview={text:me,matches:Array.isArray(this.ranges)?Xe:Xe[0]}}else{const me=Array.isArray(ae)?ae[0].startLineNumber:ae.startLineNumber;this.preview={text:pe,matches:(0,i.mapArrayOrNot)(ae,Se=>new n(Se.startLineNumber-me,Se.startColumn,Se.endLineNumber-me,Se.endColumn))}}}}e.TextSearchMatch=r;function c(ne){const pe=ne[0].startLineNumber;for(const ae of ne)if(ae.startLineNumber!==pe||ae.endLineNumber!==pe)return!1;return!0}class n{constructor(pe,ae,de,Y){this.startLineNumber=pe,this.startColumn=ae,this.endLineNumber=de,this.endColumn=Y}}e.SearchRange=n;class d extends n{constructor(pe,ae,de){super(pe,ae,pe,de)}}e.OneLineRange=d;var l;(function(ne){ne.List="list",ne.Tree="tree"})(l=e.ViewMode||(e.ViewMode={}));var f;(function(ne){ne.Default="default",ne.FileNames="fileNames",ne.Type="type",ne.Modified="modified",ne.CountDescending="countDescending",ne.CountAscending="countAscending"})(f=e.SearchSortOrder||(e.SearchSortOrder={}));function o(ne,pe=!0){const ae=ne&&ne.files&&ne.files.exclude,de=pe&&ne&&ne.search&&ne.search.exclude;if(!ae&&!de)return;if(!ae||!de)return ae||de;let Y=Object.create(null);return Y=w.mixin(Y,w.deepClone(ae)),Y=w.mixin(Y,w.deepClone(de),!0),Y}e.getExcludes=o;function h(ne,pe){return ne.excludePattern&&I.match(ne.excludePattern,pe)?!1:ne.includePattern||ne.usingSearchPaths?ne.includePattern&&I.match(ne.includePattern,pe)?!0:ne.usingSearchPaths?!!ne.folderQueries&&ne.folderQueries.some(ae=>{const de=ae.folder.fsPath;if(M.isEqualOrParent(pe,de)){const Y=y.relative(de,pe);return!ae.includePattern||!!I.match(ae.includePattern,Y)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var v;(function(ne){ne[ne.unknownEncoding=1]="unknownEncoding",ne[ne.regexParseError=2]="regexParseError",ne[ne.globParseError=3]="globParseError",ne[ne.invalidLiteral=4]="invalidLiteral",ne[ne.rgProcessError=5]="rgProcessError",ne[ne.other=6]="other",ne[ne.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class k extends Error{constructor(pe,ae){super(pe),this.code=ae}}e.SearchError=k;function F(ne){const pe=ne.message;if((0,T.isCancellationError)(ne))return new k(pe,v.canceled);try{const ae=JSON.parse(pe);return new k(ae.message,ae.code)}catch{return new k(pe,v.other)}}e.deserializeSearchError=F;function j(ne){const pe={message:ne.message,code:ne.code};return new Error(JSON.stringify(pe))}e.serializeSearchError=j;function H(ne){return ne.type==="error"?!0:ne.type==="success"}e.isSerializedSearchComplete=H;function V(ne){return ne.type==="success"}e.isSerializedSearchSuccess=V;function P(ne){return!!ne.path}e.isSerializedFileMatch=P;function U(ne,pe){const ae=ne.searchPath?ne.searchPath:ne.relativePath;return(0,D.fuzzyContains)(ae,pe)}e.isFilePatternMatch=U;class R{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=R;function x(ne,pe){const ae={...ne||{},...pe||{}};return Object.keys(ae).filter(de=>{const Y=ae[de];return typeof Y=="boolean"&&Y})}e.resolvePatternsForProvider=x;class z{constructor(pe,ae){this._parsedIncludeExpression=null,this._excludeExpression={...pe.excludePattern||{},...ae.excludePattern||{}},this._parsedExcludeExpression=I.parse(this._excludeExpression);let de=pe.includePattern;ae.includePattern&&(de?de={...de,...ae.includePattern}:de=ae.includePattern),de&&(this._parsedIncludeExpression=I.parse(de))}matchesExcludesSync(pe,ae,de){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,ae,de))}includedInQuerySync(pe,ae,de){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(pe,ae,de)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(pe,ae,de))}includedInQuery(pe,ae,de){const Y=this._parsedExcludeExpression(pe,ae,de),me=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(pe,ae,de):!0;return(0,b.isThenable)(Y)?Y.then(Se=>Se?!1:me()):me()}hasSiblingExcludeClauses(){return B(this._excludeExpression)}}e.QueryGlobTester=z;function B(ne){for(const pe in ne)if(typeof ne[pe]!="boolean")return!0;return!1}function K(ne){if(!ne)return;let pe;return ae=>(pe||(pe=(ne()||Promise.resolve([])).then(de=>de?ue(de):{})),pe.then(de=>!!de[ae]))}e.hasSiblingPromiseFn=K;function Z(ne){if(!ne)return;let pe;return ae=>{if(!pe){const de=ne();pe=de?ue(de):{}}return!!pe[ae]}}e.hasSiblingFn=Z;function ue(ne){const pe={};for(const ae of ne)pe[ae]=!0;return pe}}),define(De[31],Ie([1,0,18,15,20,4,7,46,13,108,22,10,9,2,137,3,11,151,49,36,26,14,8,6,50,44,5]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S,u,C,r,c,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function f(V,P,U){return new O.ExtUri(R=>k(R,U)).isEqual(V,P)}function o(V,P,U){return f(V.uri,P.uri,U)?0:(0,b.compare)(V.uri.toString(),P.uri.toString())}function h(V,P,U){return V.index!==P.index?V.index<P.index?-1:1:f(V.uri,P.uri,U)?(0,b.compare)(V.name,P.name):(0,b.compare)(V.uri.toString(),P.uri.toString())}function v(V,P,U,R){const x=V.slice(0).sort((B,K)=>U(B,K,R)),z=P.slice(0).sort((B,K)=>U(B,K,R));return(0,i.delta)(x,z,(B,K)=>U(B,K,R))}function k(V,P){const U=P.getCapabilities(V.scheme);return!(U&&U&1024)}class F extends p.Workspace{static toExtHostWorkspace(P,U,R,x){if(!P)return{workspace:null,added:[],removed:[]};const{id:z,name:B,folders:K,configuration:Z,transient:ue,isUntitled:ne}=P,pe=[],ae=U;U?K.forEach((Se,Oe)=>{const Be=E.URI.revive(Se.uri),Xe=F._findFolder(R||U,Be,x);Xe?(Xe.name=Se.name,Xe.index=Se.index,pe.push(Xe)):pe.push({uri:Be,name:Se.name,index:Oe})}):pe.push(...K.map(({uri:Se,name:Oe,index:Be})=>({uri:E.URI.revive(Se),name:Oe,index:Be}))),pe.sort((Se,Oe)=>Se.index<Oe.index?-1:1);const de=new F(z,B,pe,!!ue,Z?E.URI.revive(Z):null,!!ne,Se=>k(Se,x)),{added:Y,removed:me}=v(ae?ae.workspaceFolders:[],de.workspaceFolders,o,x);return{workspace:de,added:Y,removed:me}}static _findFolder(P,U,R){for(let x=0;x<P.folders.length;x++){const z=P.workspaceFolders[x];if(f(z.uri,U,R))return z}}constructor(P,U,R,x,z,B,K){super(P,R.map(Z=>new p.WorkspaceFolder(Z)),x,z,K),this._name=U,this._isUntitled=B,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(K),R.forEach(Z=>{this._workspaceFolders.push(Z),this._structure.set(Z.uri,Z)})}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(P,U){return U&&this._structure.get(P)&&(P=(0,O.dirname)(P)),this._structure.findSubstr(P)}resolveWorkspaceFolder(P){return this._structure.get(P)}}let j=class{constructor(P,U,R,x,z){this._onDidChangeWorkspace=new M.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new M.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._editSessionIdentityProviders=new Map,this._providerHandlePool=0,this._logService=x,this._extHostFileSystemInfo=R,this._uriTransformerService=z,this._requestIdProvider=new T.Counter,this._barrier=new I.Barrier,this._proxy=P.getProxy(l.MainContext.MainThreadWorkspace),this._messageService=P.getProxy(l.MainContext.MainThreadMessageService);const B=U.workspace;this._confirmedWorkspace=B?new F(B.id,B.name,[],!!B.transient,B.configuration?E.URI.revive(B.configuration):null,!!B.isUntitled,K=>k(K,R)):void 0}$initializeWorkspace(P,U){this._trusted=U,this.$acceptWorkspaceData(P),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?E.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(P,U,R,...x){const z=[];if(Array.isArray(x)&&x.forEach(ne=>{E.URI.isUri(ne.uri)&&!z.some(pe=>f(pe.uri,ne.uri,this._extHostFileSystemInfo))&&z.push({uri:ne.uri,name:ne.name||(0,O.basenameOrAuthority)(ne.uri)})}),this._unconfirmedWorkspace||[U,R].some(ne=>typeof ne!="number"||ne<0)||R===0&&z.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(U+R>B.length)return!1;const K=B.slice(0);K.splice(U,R,...z.map(ne=>({uri:ne.uri,name:ne.name||(0,O.basenameOrAuthority)(ne.uri),index:void 0})));for(let ne=0;ne<K.length;ne++){const pe=K[ne];if(K.some((ae,de)=>de!==ne&&f(pe.uri,ae.uri,this._extHostFileSystemInfo)))return!1}K.forEach((ne,pe)=>ne.index=pe);const{added:Z,removed:ue}=v(B,K,h,this._extHostFileSystemInfo);if(Z.length===0&&ue.length===0)return!1;if(this._proxy){const ne=P.displayName||P.name;this._proxy.$updateWorkspaceFolders(ne,U,R,z).then(void 0,pe=>{this._unconfirmedWorkspace=void 0;const ae={source:{identifier:P.identifier,label:P.displayName||P.name}};this._messageService.$showMessage(a.Severity.Error,(0,m.localize)(0,null,ne,pe.toString()),ae,[])})}return this.trySetWorkspaceFolders(K),!0}getWorkspaceFolder(P,U){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,U)}async getWorkspaceFolder2(P,U){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(P,U)}async resolveWorkspaceFolder(P){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(P)}getPath(){if(!this._actualWorkspace)return;const{folders:P}=this._actualWorkspace;if(P.length!==0)return P[0].uri.fsPath}getRelativePath(P,U){let R,x="";if(typeof P=="string"?(R=E.URI.file(P),x=P):typeof P<"u"&&(R=P,x=P.fsPath),!R)return x;const z=this.getWorkspaceFolder(R,!0);if(!z)return x;typeof U>"u"&&this._actualWorkspace&&(U=this._actualWorkspace.folders.length>1);let B=(0,O.relativePath)(z.uri,R);return U&&z.name&&(B=`${z.name}/${B}`),B}trySetWorkspaceFolders(P){this._actualWorkspace&&(this._unconfirmedWorkspace=F.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:P,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(P){const{workspace:U,added:R,removed:x}=F.toExtHostWorkspace(P,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=U||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:R,removed:x}))}findFiles(P,U,R,x,z=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${x.value}, entryPoint: findFiles`);let B;if(U===null?B=!1:U&&(typeof U=="string"?B=U:B=U.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:K,folder:Z}=H(r.GlobPattern.from(P));return this._proxy.$startFileSearch((0,g.withUndefinedAsNull)(K),(0,g.withUndefinedAsNull)(Z),(0,g.withUndefinedAsNull)(B),(0,g.withUndefinedAsNull)(R),z).then(ue=>Array.isArray(ue)?ue.map(ne=>E.URI.revive(ne)):[])}async findTextInFiles(P,U,R,x,z=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${x.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),K=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Z,folder:ue}=H(r.GlobPattern.from(U.include)),ne=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,pe={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:K,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Z,excludePattern:ne},ae=!1;if(this._activeSearchCallbacks[B]=de=>{if(ae)return;const Y=E.URI.revive(de.resource);de.results.forEach(me=>{(0,d.resultIsMatch)(me)?R({uri:Y,preview:{text:me.preview.text,matches:(0,i.mapArrayOrNot)(me.preview.matches,Se=>new c.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))},ranges:(0,i.mapArrayOrNot)(me.ranges,Se=>new c.Range(Se.startLineNumber,Se.startColumn,Se.endLineNumber,Se.endColumn))}):R({uri:Y,text:me.text,lineNumber:me.lineNumber})})},z.isCancellationRequested)return{};try{const de=await this._proxy.$startTextSearch(P,(0,g.withUndefinedAsNull)(ue),pe,B,z);return delete this._activeSearchCallbacks[B],de||{}}catch(de){throw delete this._activeSearchCallbacks[B],de}}$handleTextSearchResult(P,U){this._activeSearchCallbacks[U]?.(P)}saveAll(P){return this._proxy.$saveAll(P)}resolveProxy(P){return this._proxy.$resolveProxy(P)}get trusted(){return this._trusted}requestWorkspaceTrust(P){return this._proxy.$requestWorkspaceTrust(P)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}registerEditSessionIdentityProvider(P,U){if(this._editSessionIdentityProviders.has(P))throw new Error(`A provider has already been registered for scheme ${P}`);this._editSessionIdentityProviders.set(P,U);const R=this._uriTransformerService.transformOutgoingScheme(P),x=this._providerHandlePool++;return this._proxy.$registerEditSessionIdentityProvider(x,R),(0,D.toDisposable)(()=>{this._editSessionIdentityProviders.delete(P),this._proxy.$unregisterEditSessionIdentityProvider(x)})}async $getEditSessionIdentifier(P,U){this._logService.info("Getting edit session identifier for workspaceFolder",P);const R=await this.resolveWorkspaceFolder(E.URI.revive(P));if(!R){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const x=this._editSessionIdentityProviders.get(R.uri.scheme);if(this._logService.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!x),!x)return;const z=await x.provideEditSessionIdentity(R,U);if(this._logService.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(P,U,R,x){this._logService.info("Getting edit session identifier for workspaceFolder",P);const z=await this.resolveWorkspaceFolder(E.URI.revive(P));if(!z){this._logService.warn("Unable to resolve workspace folder");return}this._logService.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const B=this._editSessionIdentityProviders.get(z.uri.scheme);if(this._logService.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!B),!B)return;const K=await B.provideEditSessionIdentityMatch?.(U,R,x);if(this._logService.info("Provider returned edit session identifier match result: ",K),!!K)return K}};j=He([$e(0,C.IExtHostRpcService),$e(1,u.IExtHostInitDataService),$e(2,S.IExtHostFileSystemInfo),$e(3,s.ILogService),$e(4,n.IURITransformerService)],j),e.ExtHostWorkspace=j,e.IExtHostWorkspace=(0,t.createDecorator)("IExtHostWorkspace");function H(V){let P,U;return V&&(typeof V=="string"?P=V:(P=V.pattern,U=E.URI.revive(V.baseUri))),{includePattern:P,folder:U}}}),define(De[32],Ie([1,0,23,4,31,5,6,154,89,9,15,3,14,11,2]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function t(c,n){if(n){const d=n.split(".");let l=c;for(let f=0;l&&f<d.length;f++)l=l[d[f]];return l}}function s(c){return c instanceof m.URI}function a(c){return c&&c.uri instanceof m.URI&&c.languageId&&typeof c.languageId=="string"}function p(c){return c&&!c.uri&&c.languageId&&typeof c.languageId=="string"}function S(c){return c&&c.uri instanceof m.URI&&(!c.name||typeof c.name=="string")&&(!c.index||typeof c.index=="number")}function u(c){if(s(c))return{resource:c};if(a(c))return{resource:c.uri,overrideIdentifier:c.languageId};if(p(c))return{overrideIdentifier:c.languageId};if(S(c))return{resource:c.uri};if(c===null)return{resource:null}}let C=class{constructor(n,d,l){this._proxy=n.getProxy(M.MainContext.MainThreadConfiguration),this._extHostWorkspace=d,this._logService=l,this._barrier=new O.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new r(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,d){this.getConfigProvider().then(l=>l.$acceptConfigurationChanged(n,d))}};C=He([$e(0,g.IExtHostRpcService),$e(1,w.IExtHostWorkspace),$e(2,E.ILogService)],C),e.ExtHostConfiguration=C;class r{constructor(n,d,l,f){this._onDidChangeConfiguration=new I.Emitter,this._proxy=n,this._logService=f,this._extHostWorkspace=d,this._configuration=A.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,d){const l={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(d,l))}getConfiguration(n,d,l){const f=u(d)||{},o=this._toReadonlyValue(n?t(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,f,l?.identifier);function h(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(k){return typeof t(o,k)<"u"},get:(k,F)=>{this._validateConfigurationAccess(n?`${n}.${k}`:k,f,l?.identifier);let j=t(o,k);if(typeof j>"u")j=F;else{let H;const V=(P,U)=>{let R;const x=()=>{H=H||(0,i.deepClone)(o),R=R||t(H,U)};return(0,T.isObject)(P)?new Proxy(P,{get:(z,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return x(),()=>R;if(H)return R=R||t(H,U),R[B];const K=z[B];return typeof B=="string"?V(K,`${U}.${B}`):K},set:(z,B,K)=>(x(),R&&(R[B]=K),!0),deleteProperty:(z,B)=>(x(),R&&delete R[B],!0),defineProperty:(z,B,K)=>(x(),R&&Object.defineProperty(R,B,K),!0)}):P};j=V(j,k)}return j},update:(k,F,j,H)=>{k=n?`${n}.${k}`:k;const V=h(j);return F!==void 0?this._proxy.$updateConfigurationOption(V,k,F,f,H):this._proxy.$removeConfigurationOption(V,k,f,H)},inspect:k=>{k=n?`${n}.${k}`:k;const F=this._configuration.inspect(k,f,this._extHostWorkspace.workspace);if(F)return{key:k,defaultValue:(0,i.deepClone)(F.policy?.value??F.default?.value),globalValue:(0,i.deepClone)(F.user?.value??F.application?.value),workspaceValue:(0,i.deepClone)(F.workspace?.value),workspaceFolderValue:(0,i.deepClone)(F.workspaceFolder?.value),defaultLanguageValue:(0,i.deepClone)(F.default?.override),globalLanguageValue:(0,i.deepClone)(F.user?.override??F.application?.override),workspaceLanguageValue:(0,i.deepClone)(F.workspace?.override),workspaceFolderLanguageValue:(0,i.deepClone)(F.workspaceFolder?.override),languageIds:(0,i.deepClone)(F.overrideIdentifiers)}}};return typeof o=="object"&&(0,i.mixin)(v,o,!1),Object.freeze(v)}_toReadonlyValue(n){const d=l=>(0,T.isObject)(l)?new Proxy(l,{get:(f,o)=>d(f[o]),set:(f,o,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(o)}' of object`)},deleteProperty:(f,o)=>{throw new Error(`TypeError: Cannot delete read only property '${String(o)}' of object`)},defineProperty:(f,o)=>{throw new Error(`TypeError: Cannot define property '${String(o)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):l;return d(n)}_validateConfigurationAccess(n,d,l){const f=y.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),o=l?`[${l.value}] `:"";if(f===4){typeof d?.resource>"u"&&this._logService.warn(`${o}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this._logService.warn(`${o}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,d){const l=new A.ConfigurationChangeEvent(n,d,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,o)=>l.affectsConfiguration(f,u(o))})}_toMap(n){return n.reduce((d,l)=>(d.set(l[0],l[1]),d),new Map)}}e.ExtHostConfigProvider=r,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[102],Ie([1,0,2,15,4,5,6,31,53,32,20,56,14,26,3,13,21,11,71,191,12]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S,u){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var r;(function(U){function R(z){if(z!=null)return z}U.from=R;function x(z){if(z!=null)return z}U.to=x})(r=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var c;(function(U){function R(z){if(z!=null)return z}U.from=R;function x(z){if(z!=null)return z}U.to=x})(c=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function(U){function R(z){if(z!=null)return z}U.from=R;function x(z){if(z!=null)return z}U.to=x})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var d;(function(U){function R(B){if(B){const K=B;return K&&!!K.process}else return!1}U.is=R;function x(B){if(B==null)return;const K={process:B.process,args:B.args};return B.options&&(K.options=n.from(B.options)),K}U.from=x;function z(B){if(B!=null)return new D.ProcessExecution(B.process,B.args,B.options)}U.to=z})(d=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var l;(function(U){function R(z){if(z!=null)return z}U.from=R;function x(z){if(z!=null)return z}U.to=x})(l=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(U){function R(B){if(B){const K=B;return K&&(!!K.commandLine||!!K.command)}else return!1}U.is=R;function x(B){if(B==null)return;const K={};return B.commandLine!==void 0?K.commandLine=B.commandLine:(K.command=B.command,K.args=B.args),B.options&&(K.options=l.from(B.options)),K}U.from=x;function z(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new D.ShellExecution(B.commandLine,B.options):new D.ShellExecution(B.command,B.args?B.args:[],B.options)}U.to=z})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var o;(function(U){function R(B){if(B){const K=B;return K&&K.customExecution==="customExecution"}else return!1}U.is=R;function x(B){return{customExecution:"customExecution"}}U.from=x;function z(B,K){return K.get(B)}U.to=z})(o=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(U){function R(x,z){let B;return x.scope!==void 0&&typeof x.scope!="number"?B=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===D.TaskScope.Workspace&&z&&z.workspaceFile?B=z.workspaceFile:B=S.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:B}}U.from=R})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(U){function R(x){if(x!=null)return{_id:x.id,isDefault:x.isDefault}}U.from=R})(v=e.TaskGroupDTO||(e.TaskGroupDTO={}));var k;(function(U){function R(B,K){if(B==null)return[];const Z=[];for(const ue of B){const ne=x(ue,K);ne&&Z.push(ne)}return Z}U.fromMany=R;function x(B,K){if(B==null)return;let Z;B.execution instanceof D.ProcessExecution?Z=d.from(B.execution):B.execution instanceof D.ShellExecution?Z=f.from(B.execution):B.execution&&B.execution instanceof D.CustomExecution&&(Z=o.from(B.execution));const ue=r.from(B.definition);let ne;return B.scope?typeof B.scope=="number"?ne=B.scope:ne=B.scope.uri:ne=D.TaskScope.Workspace,!ue||!ne?void 0:{_id:B._id,definition:ue,name:B.name,source:{extensionId:K.identifier.value,label:B.source,scope:ne},execution:Z,isBackground:B.isBackground,group:v.from(B.group),presentationOptions:c.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}U.from=x;async function z(B,K,Z){if(B==null)return;let ue;d.is(B.execution)?ue=d.to(B.execution):f.is(B.execution)?ue=f.to(B.execution):o.is(B.execution)&&(ue=o.to(B._id,Z));const ne=r.to(B.definition);let pe;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?pe=B.source.scope:pe=await K.resolveWorkspaceFolder(i.URI.revive(B.source.scope)):pe=D.TaskScope.Workspace),!ne||!pe)return;const ae=new D.Task(ne,pe,B.name,B.source.label,ue,B.problemMatchers);return B.isBackground!==void 0&&(ae.isBackground=B.isBackground),B.group!==void 0&&(ae.group=D.TaskGroup.from(B.group._id),ae.group&&B.group.isDefault&&(ae.group=new D.TaskGroup(ae.group.id,ae.group.label),B.group.isDefault===!0&&(ae.group.isDefault=B.group.isDefault))),B.presentationOptions&&(ae.presentationOptions=c.to(B.presentationOptions)),B._id&&(ae._id=B._id),B.detail&&(ae.detail=B.detail),ae}U.to=z})(k=e.TaskDTO||(e.TaskDTO={}));var F;(function(U){function R(z){return z}U.from=R;function x(z){if(!!z)return Object.assign(Object.create(null),z)}U.to=x})(F=e.TaskFilterDTO||(e.TaskFilterDTO={}));class j{constructor(R,x,z){this._id=x,this._task=z,C.set(this,void 0),Ye(this,C,R,"f")}get task(){return this._task}terminate(){Ae(this,C,"f").terminateTask(this)}fireDidStartProcess(R){}fireDidEndProcess(R){}}C=new WeakMap;var H;(function(U){function R(x){return{id:x._id,task:void 0}}U.from=R})(H=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let V=class{constructor(R,x,z,B,K,Z,ue,ne){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=R.getProxy(M.MainContext.MainThreadTask),this._workspaceProvider=z,this._editorService=B,this._configurationService=K,this._terminalService=Z,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=ue,this._deprecationService=ne,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(R,x,z){if(!z)return new D.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:x,provider:z,extension:R}),this._proxy.$registerTaskProvider(B,x),new D.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(R,x){this._proxy.$registerTaskSystem(R,x)}fetchTasks(R){return this._proxy.$fetchTasks(F.from(R)).then(async x=>{const z=[];for(const B of x){const K=await k.to(B,this._workspaceProvider,this._providedCustomExecutions2);K&&z.push(K)}return z})}get taskExecutions(){const R=[];return this._taskExecutions.forEach(x=>R.push(x)),R}terminateTask(R){if(!(R instanceof j))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(R._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(R,x,z){const B=this._providedCustomExecutions2.get(R.id);B&&(this._activeCustomExecutions2.set(R.id,B),this._terminalService.attachPtyToTerminal(x,await B.callback(z))),this._lastStartedTask=R.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(R)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(R){const x=await this.getTaskExecution(R);this._taskExecutionPromises.delete(R.id),this._taskExecutions.delete(R.id),this.customExecutionComplete(R),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(R){const x=await this.getTaskExecution(R.id);this._onDidTaskProcessStarted.fire({execution:x,processId:R.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(R){const x=await this.getTaskExecution(R.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:R.exitCode})}$provideTasks(R,x){const z=this._handlers.get(R);if(!z)return Promise.reject(new Error("no handler found"));const B=[],K=(0,I.asPromise)(()=>z.provider.provideTasks(O.CancellationToken.None)).then(Z=>this.provideTasksInternal(x,B,z,Z));return new Promise(Z=>{K.then(ue=>{Promise.all(B).then(()=>{Z(ue)})})})}async $resolveTask(R,x){const z=this._handlers.get(R);if(!z)return Promise.reject(new Error("no handler found"));if(x.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${z.type}].`);const B=await k.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const K=await z.provider.resolveTask(B,O.CancellationToken.None);if(!K)return;this.checkDeprecation(K,z);const Z=k.from(K,z.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return o.is(Z.execution)&&await this.addCustomExecution(Z,K,!0),await this.resolveTaskInternal(Z)}nextHandle(){return this._handleCounter++}async addCustomExecution(R,x,z){const B=await this._proxy.$createTaskId(R);!z&&!this._providedCustomExecutions2.has(B)&&(this._notProvidedCustomExecutions.add(B),this._activeCustomExecutions2.set(B,x.execution)),this._providedCustomExecutions2.set(B,x.execution)}async getTaskExecution(R,x){if(typeof R=="string"){const K=this._taskExecutionPromises.get(R);if(!K)throw new u.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return K}const z=this._taskExecutionPromises.get(R.id);if(z)return z;const B=new Promise((K,Z)=>{function ue(ne,pe,ae){ae?K(new j(ne,pe.id,ae)):Z("Unexpected: Task does not exist.")}x?ue(this,R,x):k.to(R.task,this._workspaceProvider,this._providedCustomExecutions2).then(ne=>ue(this,R,ne))});return this._taskExecutionPromises.set(R.id,B),B.then(K=>(this._taskExecutions.set(R.id,K),K),K=>Promise.reject(K))}checkDeprecation(R,x){R._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(R){this._activeCustomExecutions2.get(R.id)&&this._activeCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.has(R.id)&&this._lastStartedTask!==R.id&&(this._providedCustomExecutions2.delete(R.id),this._notProvidedCustomExecutions.delete(R.id));const z=this._notProvidedCustomExecutions.values();let B=z.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=z.next()}};V=He([$e(0,g.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,a.ILogService),$e(7,p.IExtHostApiDeprecationService)],V),e.ExtHostTaskBase=V;let P=class extends V{constructor(R,x,z,B,K,Z,ue,ne){super(R,x,z,B,K,Z,ue,ne),this.registerTaskSystem(t.Schemas.vscodeRemote,{scheme:t.Schemas.vscodeRemote,authority:"",platform:s.PlatformToString(0)})}async executeTask(R,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const z=k.from(x,R);if(z===void 0)throw new Error("Task is not valid");if(o.is(z.execution))await this.addCustomExecution(z,x,!1);else throw new u.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(z),x);return this._proxy.$executeTask(z).catch(K=>{throw new Error(K)}),B}provideTasksInternal(R,x,z,B){const K=[];if(B)for(const Z of B){this.checkDeprecation(Z,z),(!Z.definition||!R[Z.definition.type])&&this._logService.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const ue=k.from(Z,z.extension);ue&&o.is(ue.execution)?(K.push(ue),x.push(this.addCustomExecution(ue,Z,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:K,extension:z.extension}}async resolveTaskInternal(R){if(o.is(R.execution))return R;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(R,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(R,x,z){}};P=He([$e(0,g.IExtHostRpcService),$e(1,E.IExtHostInitDataService),$e(2,A.IExtHostWorkspace),$e(3,y.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,b.IExtHostTerminalService),$e(6,a.ILogService),$e(7,p.IExtHostApiDeprecationService)],P),e.WorkerExtHostTask=P,e.IExtHostTask=(0,m.createDecorator)("IExtHostTask")}),define(De[234],Ie([1,0,19,20,45,34,22,209,44]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(g,E,m){this.config=g,this.provider=E,this.sessionToken=m,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&M.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&M.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const E=this.config.folderQueries||[];return new Promise((m,t)=>{const s=a=>{this.resultCount++,g(a)};if(this.isCanceled)return m({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(a=>{const p=a.toString(),S=i.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,S)||this.matchFile(s,{base:a,basename:S})}),Promise.all(E.map(a=>this.searchInFolder(a,s))).then(a=>{m({limitHit:this.isLimitHit,stats:a[0]||void 0})},a=>{t(new Error((0,w.toErrorMessage)(a)))})})}async searchInFolder(g,E){const m=new I.CancellationTokenSource,t=this.getSearchOptionsForFolder(g),s=this.initDirectoryTree(),a=new y.QueryGlobTester(this.config,g),p=!a.hasSiblingExcludeClauses();let S;try{this.activeCancellationTokens.add(m),S=A.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},t,m.token),C=S.elapsed(),r=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(c=>{const n=i.posix.relative(g.folder.path,c.path);if(p){const d=i.basename(c.path);this.matchFile(E,{base:g.folder,relativePath:n,basename:d});return}this.addDirectoryEntries(s,g.folder,n,E)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(s,a,E),{providerTime:C,postProcessTime:r.elapsed()})}finally{m.dispose(),this.activeCancellationTokens.delete(m)}}getSearchOptionsForFolder(g){const E=(0,y.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),m=(0,y.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:m,includes:E,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},E,m,t){if(m===this.filePattern){const a=i.basename(this.filePattern);this.matchFile(t,{base:E,relativePath:this.filePattern,basename:a})}function s(a){const p=i.basename(a),S=i.dirname(a);let u=g[S];u||(u=g[S]=[],s(S)),u.push({base:E,relativePath:a,basename:p})}s(m)}matchDirectoryTree({rootEntries:g,pathToEntries:E},m,t){const s=this,a=this.filePattern;function p(S){const u=(0,y.hasSiblingFn)(()=>S.map(C=>C.basename));for(let C=0,r=S.length;C<r;C++){const c=S[C],{relativePath:n,basename:d}=c;if(m.matchesExcludesSync(n,d,a!==d?u:void 0))continue;const l=E[n];if(l)p(l);else{if(n===a)continue;s.matchFile(t,c)}if(s.isLimitHit)break}}p(g)}matchFile(g,E){(!this.includePattern||E.relativePath&&this.includePattern(E.relativePath,E.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(E))}}class O{constructor(){this.sessions=new Map}fileSearch(g,E,m,t){const s=this.getSessionTokenSource(g.cacheKey),a=new T(g,E,s&&s.token);let p=0;const S=u=>{p+=u.length,m(u.map(C=>this.rawMatchToSearchItem(C)))};return this.doSearch(a,O.BATCH_SIZE,S,t).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:u.stats}}))}clearCache(g){this.getSessionTokenSource(g)?.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new I.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:D.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,E,m,t){t.onCancellationRequested(()=>{g.cancel()});const s=p=>{p&&(a.push(p),E>0&&a.length>=E&&(m(a),a=[]))};let a=[];return g.search(s).then(p=>(a.length&&m(a),p),p=>(a.length&&m(a),Promise.reject(p)))}}e.FileSearchManager=O,O.BATCH_SIZE=512}),define(De[235],Ie([1,0,18,77,34,82,28,13,19,22,10,9,2,251,145,40,11,49,93,233,44]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let C=class{constructor(v,k,F,j,H){this.configurationService=v,this.workspaceContextService=k,this.editorGroupsService=F,this.logService=j,this.pathService=H}text(v,k,F={}){v=this.getContentPattern(v,F);const j=this.configurationService.getValue(),H=k&&k.some(P=>!this.configurationService.getValue({resource:P}).search.useRipgrep);return{...this.commonQuery(k?.map(a.toWorkspaceFolder),F),type:2,contentPattern:v,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:j.search.usePCRE2||H||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}getContentPattern(v,k){const F=this.configurationService.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const j={...v,wordSeparators:F.editor.wordSeparators};return this.isCaseSensitive(v,k)&&(j.isCaseSensitive=!0),this.isMultiline(v)&&(j.isMultiline=!0),j}file(v,k={}){return{...this.commonQuery(v,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}handleIncludeExclude(v,k){return v?(v=Array.isArray(v)?v.map(l):l(v),k?this.parseSearchPaths(v):{pattern:c(...Array.isArray(v)?v:[v])}):{}}commonQuery(v=[],k={}){const F=this.handleIncludeExclude(k.includePattern,k.expandPatterns),j=this.handleIncludeExclude(k.excludePattern,k.expandPatterns),H=v.length>1,V=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(R=>this.getFolderQueryForSearchPath(R,k,j)):v.map(R=>this.getFolderQueryForRoot(R,k,j,H))).filter(R=>!!R),P={_reason:k._reason,folderQueries:V,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:j.pattern,includePattern:F.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const R=i.coalesce(i.flatten(this.editorGroupsService.groups.map(B=>B.editors.map(K=>K.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(R));const x=R.filter(B=>(0,u.pathIncludedInQuery)(P,B.fsPath)),z=this.commonQueryFromFileList(x);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(z)),{...P,...z}}const U=k.extraFileResources&&k.extraFileResources.filter(R=>(0,u.pathIncludedInQuery)(P,R.fsPath));return P.extraFileResources=U&&U.length?U:void 0,P}commonQueryFromFileList(v){const k=[],F=new D.ResourceMap,j={};let H=!1;return v.forEach(V=>{if(V.scheme===A.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(V)){const U=this.workspaceContextService.getWorkspaceFolder(V)?.uri??V.with({path:y.dirname(V.fsPath)});let R=F.get(U);R||(H=!0,R={folder:U,includePattern:{}},k.push(R),F.set(U,R));const x=y.relative(U.fsPath,V.fsPath);(0,b.assertIsDefined)(R.includePattern)[x.replace(/\\/g,"/")]=!0}else V.fsPath&&(H=!0,j[V.fsPath]=!0)}),{folderQueries:k,includePattern:j,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}isCaseSensitive(v,k){if(k.isSmartCase){if(v.isRegExp){if(O.containsUppercaseCharacter(v.pattern,!0))return!0}else if(O.containsUppercaseCharacter(v.pattern))return!0}return!!v.isCaseSensitive}isMultiline(v){return v.isMultiline||v.isRegExp&&(0,E.isMultilineRegexSource)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const k=z=>y.isAbsolute(z)||/^\.\.?([\/\\]|$)/.test(z),j=(Array.isArray(v)?v:n(v)).map(z=>{const B=this.pathService.resolvedUserHome;return B?(0,M.untildify)(z,B.scheme===A.Schemas.file?B.fsPath:B.path):z}),H=I.groupBy(j,z=>k(z)?"searchPaths":"exprSegments"),V=(H.exprSegments||[]).map(z=>O.rtrim(z,"/")).map(z=>O.rtrim(z,"\\")).map(z=>(z[0]==="."&&(z="*"+z),d(z))),P={},U=this.expandSearchPathPatterns(H.searchPaths||[]);U&&U.length&&(P.searchPaths=U);const R=i.flatten(V),x=c(...R);return x&&(P.pattern=x),P}getExcludesForFolder(v,k){return k.disregardExcludeSettings?void 0:(0,u.getExcludes)(v,!k.disregardSearchExcludeSettings)}expandSearchPathPatterns(v){if(!v||!v.length)return[];const k=i.flatten(v.map(j=>{let{pathPortion:H,globPortion:V}=r(j);V&&(V=f(V));const P=this.expandOneSearchPath(H);return i.flatten(P.map(U=>this.resolveOneSearchPathPattern(U,V)))})),F=new Map;return k.forEach(j=>{const H=j.searchPath.toString(),V=F.get(H);V?j.pattern&&(V.pattern=V.pattern||{},V.pattern[j.pattern]=!0):F.set(H,{searchPath:j.searchPath,pattern:j.pattern?c(j.pattern):void 0})}),Array.from(F.values())}expandOneSearchPath(v){if(y.isAbsolute(v)){const k=this.workspaceContextService.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==A.Schemas.file?[{searchPath:k[0].uri.with({path:v})}]:[{searchPath:g.URI.file(y.normalize(v))}]}if(this.workspaceContextService.getWorkbenchState()===2){const k=this.workspaceContextService.getWorkspace().folders[0].uri;if(v=l(v),v.startsWith("../")||v===".."){const j=y.posix.resolve(k.path,v);return[{searchPath:k.with({path:j})}]}const F=f(v);return[{searchPath:k,pattern:F}]}else{if(v==="./"||v===".\\")return[];{const k=v.replace(/^\.[\/\\]/,""),j=this.workspaceContextService.getWorkspace().folders.map(H=>{const V=k.match(new RegExp(`^${O.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return V?{match:V,folder:H}:null}).filter(b.isDefined);if(j.length)return j.map(H=>{const V=H.match[1];return{searchPath:H.folder.uri,pattern:V&&f(V)}});{const H=v.match(/\.[\/\\](.+)[\/\\]?/),V=H?H[1]:v,P=m.localize(0,null,V);throw new Error(P)}}}}resolveOneSearchPathPattern(v,k){const F=v.pattern&&k?`${v.pattern}/${k}`:v.pattern||k,j=[{searchPath:v.searchPath,pattern:F}];return F&&!F.endsWith("**")&&j.push({searchPath:v.searchPath,pattern:F+"/**"}),j}getFolderQueryForSearchPath(v,k,F){const j=this.getFolderQueryForRoot((0,a.toWorkspaceFolder)(v.searchPath),k,F,!1);return j?{...j,includePattern:v.pattern}:null}getFolderQueryForRoot(v,k,F,j){let H;const V=g.URI.isUri(v)?v:v.uri;if(F.searchPaths){const z=F.searchPaths.filter(B=>(0,T.isEqual)(B.searchPath,V))[0];if(z&&!z.pattern)return null;z&&(H=z.pattern)}const P=this.configurationService.getValue({resource:V}),R={...this.getExcludesForFolder(P,k)||{},...H||{}},x=g.URI.isUri(v)?(0,T.basename)(v):v.name;return{folder:V,folderName:j?x:void 0,excludePattern:Object.keys(R).length>0?R:void 0,fileEncoding:P.files&&P.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!P.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!P.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!P.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!P.search.followSymlinks}}};C=He([$e(0,t.IConfigurationService),$e(1,a.IWorkspaceContextService),$e(2,p.IEditorGroupsService),$e(3,s.ILogService),$e(4,S.IPathService)],C),e.QueryBuilder=C;function r(h){const v=h.match(/[\*\{\}\(\)\[\]\?]/);if(v){const k=v.index,F=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(F){let j=h.substr(0,F.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:h.substr((F.index||0)+1)}}}return{pathPortion:h}}function c(...h){return h.length?h.reduce((v,k)=>(v[k]=!0,v),Object.create(null)):void 0}function n(h){return w.splitGlobAware(h,",").map(v=>v.trim()).filter(v=>!!v.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function l(h){return h.replace(/\\/g,"/")}function f(h){return l(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function o(h,v){h=i.distinct(h,j=>j.toString());const k=[],F=v.getWorkspace();return h&&h.forEach(j=>{let H;if(v.getWorkbenchState()===2)H=(0,T.relativePath)(F.folders[0].uri,j),H&&H!=="."&&(H="./"+H);else{const V=v.getWorkspaceFolder(j);if(V){const P=V.name;if(F.folders.filter(R=>R.name===P).length===1){const R=(0,T.relativePath)(V.uri,j);R===""?H=`./${V.name}`:H=`./${V.name}/${R}`}else H=j.fsPath}}H&&k.push(H)}),k}e.resolveResourcesForSearchIncludes=o}),define(De[236],Ie([1,0,22,2,20,12,3,235,44,49]),function(ie,e,i,I,w,M,D,A,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function b(t,s){const a=s.activationEvents;if(!a)return Promise.resolve(void 0);const p=[],S=[];for(const d of a)if(/^workspaceContains:/.test(d)){const l=d.substr(18);l.indexOf("*")>=0||l.indexOf("?")>=0||t.forceUsingSearch?S.push(l):p.push(l)}if(p.length===0&&S.length===0)return Promise.resolve(void 0);let u;const C=new Promise((d,l)=>{u=d}),r=d=>u({activationEvent:d}),c=Promise.all(p.map(d=>g(t,d,r))).then(()=>{}),n=E(t,s.identifier,S,r);return Promise.all([c,n]).then(()=>{u(void 0)}),C}e.checkActivateWorkspaceContainsExtension=b;async function g(t,s,a){for(const p of t.folders)if(await t.exists(i.joinPath(I.URI.revive(p),s))){a(`workspaceContains:${s}`);return}}async function E(t,s,a,p){if(a.length===0)return Promise.resolve(void 0);const S=new w.CancellationTokenSource,u=t.checkExists(t.folders,a,S.token),C=setTimeout(async()=>{S.cancel(),t.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},O);let r=!1;try{r=await u}catch(c){M.isCancellationError(c)||M.onUnexpectedError(c)}S.dispose(),clearTimeout(C),r&&p(`workspaceContains:${a.join(",")}`)}function m(t,s,a,p){const S=t.get(D.IInstantiationService),u=t.get(y.ISearchService),r=S.createInstance(A.QueryBuilder).file(s.map(c=>(0,T.toWorkspaceFolder)(I.URI.revive(c))),{_reason:"checkExists",includePattern:a,exists:!0});return u.fileSearch(r,p).then(c=>!!c.limitHit,c=>M.isCancellationError(c)?!1:Promise.reject(c))}e.checkGlobFileExists=m});var Ye=this&&this.__classPrivateFieldSet||function(ie,e,i,I,w){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ie!==e||!w:!e.has(ie))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?w.call(ie,i):w?w.value=i:e.set(ie,i),i},Ae=this&&this.__classPrivateFieldGet||function(ie,e,i,I){if(i==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ie!==e||!I:!e.has(ie))throw new TypeError("Cannot read private member from an object whose class did not declare it");return i==="m"?I:i==="a"?I.call(ie):I?I.value:e.get(ie)};define(De[33],Ie([1,0,132,19,76,22,15,7,46,2,11,5,32,180,74,31,27,179,12,25,24,164,6,90,3,26,75,14,60,64,56,4,236,73,166,13,72]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S,u,C,r,c,n,d,l,f,o,h,v,k,F,j,H,V,P){"use strict";var U,R,x;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let z=class Pi extends A.Disposable{constructor(ae,de,Y,me,Se,Oe,Be,Xe,ke,ye,Ce){super(),this._onDidChangeRemoteConnectionData=this._register(new k.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=de,this._extHostContext=Y,this._initData=Be,this._extHostWorkspace=me,this._extHostConfiguration=Se,this._logService=Oe,this._extHostTunnelService=ke,this._extHostTerminalService=ye,this._extHostLocalizationService=Ce,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._globalRegistry=new a.ExtensionDescriptionRegistry(this._initData.allExtensions);const se=(0,s.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new a.ExtensionDescriptionRegistry(Z(this._globalRegistry,se)),this._storage=new m.ExtHostStorage(this._extHostContext),this._secretState=new j.ExtHostSecretState(this._extHostContext),this._storagePath=Xe,this._instaService=ae.createChild(new o.ServiceCollection([m.IExtHostStorage,this._storage],[j.IExtHostSecretState,this._secretState]));let le=[],J=[];this._initData.remote.isRemote&&(le=this._initData.allExtensions.filter(L=>!L.main&&!L.browser).map(L=>L.identifier),J=this._initData.allExtensions.filter(L=>!se.has(S.ExtensionIdentifier.toKey(L.identifier.value))).filter(L=>(L.main||L.browser)&&L.api==="none").map(L=>L.identifier));const _=(0,s.extensionIdentifiersArrayToSet)(J);this._activator=this._register(new E.ExtensionsActivator(this._myRegistry,le,J,{onExtensionActivationError:(L,W,q)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(L,p.transformErrorForSerialization(W),q)},actualActivateExtension:async(L,W)=>{if(_.has(S.ExtensionIdentifier.toKey(L)))return await this._mainThreadExtensionsProxy.$activateExtension(L,W),new E.HostExtension;const q=this._myRegistry.getExtensionDescription(L);return this._activateExtension(q,W)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ae){p.onUnexpectedError(ae)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ae=[];try{ae=this._myRegistry.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this._deactivate(Se))}catch{}await Promise.all(ae)}terminate(ae,de=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ae}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),p.setUnexpectedErrorHandler(me=>{this._logService.error(me)}),this._extHostContext.dispose();const Y=this._deactivateAll();Promise.race([(0,D.timeout)(5e3),Y]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${de}`):this._logService.info(`Extension host exiting with code ${de}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(de)})}isActivated(ae){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ae):!1}async getExtension(ae){const de=await this._mainThreadExtensionsProxy.$getExtension(ae);let Y;if(de?.browserNlsBundleUris){Y={};for(const me of Object.keys(de.browserNlsBundleUris))Y[me]=T.URI.revive(de.browserNlsBundleUris[me])}return de&&{...de,identifier:new S.ExtensionIdentifier(de.identifier.value),extensionLocation:T.URI.revive(de.extensionLocation),browserNlsBundleUris:Y}}_activateByEvent(ae,de){return this._activator.activateByEvent(ae,de)}_activateById(ae,de){return this._activator.activateById(ae,de)}activateByIdWithErrors(ae,de){return this._activateById(ae,de).then(()=>{const Y=this._activator.getActivatedExtension(ae);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ae=>this._myRegistry)}getExtensionExports(ae){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ae).exports:null}async _realPathExtensionUri(ae){if(ae.scheme!==V.Schemas.file)return ae;const de=await this._hostUtils.realpath(ae.fsPath);return T.URI.file(de)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ae=>new ne(ae))),this._extensionPathIndex}async _createExtensionPathIndex(ae){const de=y.TernarySearchTree.forUris(Y=>M.extUriBiasedIgnorePathCase.ignorePathCasing(Y));return await Promise.all(ae.map(async Y=>{if(this._getEntryPoint(Y)){const me=await this._realPathExtensionUri(Y.extensionLocation);de.set(me,Y)}})),de}_deactivate(ae){let de=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ae))return de;const Y=this._activator.getActivatedExtension(ae);if(!Y)return de;try{typeof Y.module.deactivate=="function"&&(de=Promise.resolve(Y.module.deactivate()).then(void 0,me=>(this._logService.error(me),Promise.resolve(void 0))))}catch(me){this._logService.error(`An error occurred when deactivating the extension '${ae.value}':`),this._logService.error(me)}try{(0,A.dispose)(Y.subscriptions)}catch(me){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ae.value}':`),this._logService.error(me)}return de}async _activateExtension(ae,de){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ae.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ae.identifier),this._doActivateExtension(ae,de).then(Y=>{const me=Y.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ae.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,de),this._logExtensionActivationTimes(ae,de,"success",me),Y},Y=>{throw this._logExtensionActivationTimes(ae,de,"failure"),Y})}_logExtensionActivationTimes(ae,de,Y,me){const Se=B(ae,de);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...Se,...me||{},outcome:Y})}_doActivateExtension(ae,de){const Y=B(ae,de);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",Y);const me=this._getEntryPoint(ae);if(!me)return Promise.resolve(new E.EmptyExtension(E.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ae.identifier.value}, startup: ${de.startup}, activationEvent: '${de.activationEvent}'${ae.identifier.value!==de.extensionId.value?`, root cause: ${de.extensionId.value}`:""}`),this._logService.flush();const Se=new E.ExtensionActivationTimesBuilder(de.startup);return Promise.all([this._loadCommonJSModule(ae,(0,M.joinPath)(ae.extensionLocation,me),Se),this._loadExtensionContext(ae)]).then(Oe=>(w.mark(`code/extHost/willActivateExtension/${ae.identifier.value}`),Pi._callActivate(this._logService,ae.identifier,Oe[0],Oe[1],Se))).then(Oe=>(w.mark(`code/extHost/didActivateExtension/${ae.identifier.value}`),Oe))}_loadExtensionContext(ae){const de=new C.ExtensionGlobalMemento(ae,this._storage),Y=new C.ExtensionMemento(ae.identifier.value,!1,this._storage),me=new H.ExtensionSecrets(ae,this._secretState),Se=ae.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,Oe=this._initData.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ae.identifier.value}`),Promise.all([de.whenReady,Y.whenReady,this._storagePath.whenReady]).then(()=>{const Be=this;let Xe,ke;const ye=(0,s.isProposedApiEnabled)(ae,"ipc")?this._initData.messagePorts?.get(S.ExtensionIdentifier.toKey(ae.identifier)):void 0;return Object.freeze({globalState:de,workspaceState:Y,secrets:me,subscriptions:[],get extensionUri(){return ae.extensionLocation},get extensionPath(){return ae.extensionLocation.fsPath},asAbsolutePath(Ce){return I.join(ae.extensionLocation.fsPath,Ce)},get storagePath(){return Be._storagePath.workspaceValue(ae)?.fsPath},get globalStoragePath(){return Be._storagePath.globalValue(ae).fsPath},get logPath(){return I.join(Be._initData.logsLocation.fsPath,ae.identifier.value)},get logUri(){return T.URI.joinPath(Be._initData.logsLocation,ae.identifier.value)},get storageUri(){return Be._storagePath.workspaceValue(ae)},get globalStorageUri(){return Be._storagePath.globalValue(ae)},get extensionMode(){return Se},get extension(){return Xe===void 0&&(Xe=new K(Be,ae.identifier,ae,Oe,!1)),Xe},get extensionRuntime(){return(0,s.checkProposedApiEnabled)(ae,"extensionRuntime"),Be.extensionRuntime},get environmentVariableCollection(){return Be._extHostTerminalService.getEnvironmentVariableCollection(ae)},get messagePassingProtocol(){if(!ke){if(!ye)return;const Ce=k.Event.buffer(k.Event.fromDOMEventEmitter(ye,"message",se=>se.data));ye.start(),ke={onDidReceiveMessage:Ce,postMessage:ye.postMessage.bind(ye)}}return ke}})})}static _callActivate(ae,de,Y,me,Se){return Y=Y||{activate:void 0,deactivate:void 0},this._callActivateOptional(ae,de,Y,me,Se).then(Oe=>new E.ActivatedExtension(!1,null,Se.build(),Y,Oe,me.subscriptions))}static _callActivateOptional(ae,de,Y,me,Se){if(typeof Y.activate=="function")try{Se.activateCallStart(),ae.trace(`ExtensionService#_callActivateOptional ${de.value}`);const Oe=typeof global=="object"?global:self,Be=Y.activate.apply(Oe,[me]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(Be).then(Xe=>(Se.activateResolveStop(),Xe))}catch(Oe){return Promise.reject(Oe)}else return Promise.resolve(Y)}_activateOneStartupFinished(ae,de){this._activateById(ae.identifier,{startup:!1,extensionId:ae.identifier,activationEvent:de}).then(void 0,Y=>{this._logService.error(Y)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const ae of this._myRegistry.getAllExtensionDescriptions())if(ae.activationEvents)for(const de of ae.activationEvents)de==="onStartupFinished"&&this._activateOneStartupFinished(ae,de)}_handleEagerExtensions(){const ae=this._activateByEvent("*",!0).then(void 0,Se=>{this._logService.error(Se)});this._register(this._extHostWorkspace.onDidChangeWorkspace(Se=>this._handleWorkspaceContainsEagerExtensions(Se.added)));const de=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],Y=this._handleWorkspaceContainsEagerExtensions(de),me=Promise.all([ae,Y]).then(()=>{});return Promise.race([me,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),me}_handleWorkspaceContainsEagerExtensions(ae){return ae.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(de=>this._handleWorkspaceContainsEagerExtension(ae,de))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ae,de){if(this.isActivated(de.identifier))return;const Y=!this._initData.remote.isRemote&&!!this._initData.remote.authority,me={logService:this._logService,folders:ae.map(Oe=>Oe.uri),forceUsingSearch:Y,exists:Oe=>this._hostUtils.exists(Oe.fsPath),checkExists:(Oe,Be,Xe)=>this._mainThreadWorkspaceProxy.$checkExists(Oe,Be,Xe)},Se=await(0,F.checkActivateWorkspaceContainsExtension)(me,de);if(!!Se)return this._activateById(de.identifier,{startup:!0,extensionId:de.identifier,activationEvent:Se.activationEvent}).then(void 0,Oe=>this._logService.error(Oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ae){throw console.error(ae),ae}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ae,extensionTestsLocationURI:de}=this._initData.environment;if(!ae||!de)throw new Error(i.localize(0,null));const Y=await this._loadCommonJSModule(null,de,new E.ExtensionActivationTimesBuilder(!1));if(!Y||typeof Y.run!="function")throw new Error(i.localize(1,null,de.toString()));return new Promise((me,Se)=>{const Oe=(ke,ye)=>{ke?Se(ke):me(typeof ye=="number"&&ye>0?1:0)},Be=(0,M.originalFSPath)(de),Xe=Y.run(Be,Oe);Xe&&Xe.then&&Xe.then(()=>{me(0)}).catch(ke=>{Se(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ae,de){return this._resolvers[ae]=de,(0,A.toDisposable)(()=>{delete this._resolvers[ae]})}async _activateAndGetResolver(ae){const de=ae.indexOf("+");if(de===-1)throw new Error("Not an authority that can be resolved!");const Y=ae.substr(0,de);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this._resolvers[Y]}}async $resolveAuthority(ae,de){this._logService.info(`$resolveAuthority invoked for authority (${ue(ae)})`);const{authorityPrefix:Y,resolver:me}=await this._activateAndGetResolver(ae);if(!me)return{type:"error",error:{code:c.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Y}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(me)),w.mark(`code/extHost/willResolveAuthority/${Y}`);const Se=await me.resolve(ae,{resolveAttempt:de});w.mark(`code/extHost/didResolveAuthorityOK/${Y}`);const Oe={authority:ae,host:Se.host,port:Se.port,connectionToken:Se.connectionToken},Be={extensionHostEnv:Se.extensionHostEnv,isTrusted:Se.isTrusted,authenticationSession:Se.authenticationSessionForInitializingExtensions?{id:Se.authenticationSessionForInitializingExtensions.id,providerId:Se.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Oe,options:Be,tunnelInformation:{environmentTunnels:Se.environmentTunnels,features:Se.tunnelFeatures}}}}catch(Se){if(w.mark(`code/extHost/didResolveAuthorityError/${Y}`),Se instanceof r.RemoteAuthorityResolverError)return{type:"error",error:{code:Se._code,message:Se._message,detail:Se._detail}};throw Se}}async $getCanonicalURI(ae,de){this._logService.info(`$getCanonicalURI invoked for authority (${ue(ae)})`);const{resolver:Y}=await this._activateAndGetResolver(ae);if(!Y)return null;const me=T.URI.revive(de);if(typeof Y.getCanonicalURI>"u")return me;const Se=await(0,D.asPromise)(()=>Y.getCanonicalURI(me));return Se||me}static _applyExtensionsDelta(ae,de,Y){const me=new a.ExtensionDescriptionRegistry(ae.getAllExtensionDescriptions());me.deltaExtensions(Y.toAdd,Y.toRemove);const Se=(0,s.extensionIdentifiersArrayToSet)(de.getAllExtensionDescriptions().map(Be=>Be.identifier));for(const Be of Y.myToRemove)Se.delete(S.ExtensionIdentifier.toKey(Be));for(const Be of Y.myToAdd)Se.add(S.ExtensionIdentifier.toKey(Be));const Oe=Z(me,Se);return{globalRegistry:me,myExtensions:Oe}}$startExtensionHost(ae){ae.toAdd.forEach(me=>me.extensionLocation=T.URI.revive(me.extensionLocation));const{globalRegistry:de,myExtensions:Y}=Pi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ae);return this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(Y),this._startExtensionHost()}$activateByEvent(ae,de){return de===1?this._activateByEvent(ae,!1):this._readyToRunExtensions.wait().then(Y=>this._activateByEvent(ae,!1))}async $activate(ae,de){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ae)?(await this._activateById(ae,de),!0):!1}async $deltaExtensions(ae){ae.toAdd.forEach(Oe=>Oe.extensionLocation=T.URI.revive(Oe.extensionLocation));const{globalRegistry:de,myExtensions:Y}=Pi._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ae),me=await this._createExtensionPathIndex(Y);return(await this.getExtensionPathIndex()).setSearchTree(me),this._globalRegistry.set(de.getAllExtensionDescriptions()),this._myRegistry.set(Y),Promise.resolve(void 0)}async $test_latency(ae){return ae}async $test_up(ae){return ae.byteLength}async $test_down(ae){const de=u.VSBuffer.alloc(ae),Y=Math.random()%256;for(let me=0;me<ae;me++)de.writeUInt8(Y,me);return de}async $updateRemoteConnectionData(ae){this._remoteConnectionData=ae,this._onDidChangeRemoteConnectionData.fire()}};z=He([$e(0,n.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,t.IExtHostWorkspace),$e(4,g.IExtHostConfiguration),$e(5,O.ILogService),$e(6,d.IExtHostInitDataService),$e(7,l.IExtensionStoragePaths),$e(8,h.IExtHostTunnelService),$e(9,v.IExtHostTerminalService),$e(10,P.IExtHostLocalizationService)],z),e.AbstractExtHostExtensionService=z;function B(pe,ae){return{id:pe.identifier.value,name:pe.name,extensionVersion:pe.version,publisherDisplayName:pe.publisher,activationEvents:pe.activationEvents?pe.activationEvents.join(","):null,isBuiltin:pe.isBuiltin,reason:ae.activationEvent,reasonId:ae.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class K{constructor(ae,de,Y,me,Se){U.set(this,void 0),R.set(this,void 0),x.set(this,void 0),Ye(this,U,ae,"f"),Ye(this,R,de,"f"),Ye(this,x,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=I.normalize((0,M.originalFSPath)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=me,this.isFromDifferentExtensionHost=Se}get isActive(){return Ae(this,U,"f").isActivated(Ae(this,x,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ae(this,U,"f").getExtensionExports(Ae(this,x,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ae(this,U,"f").activateByIdWithErrors(Ae(this,x,"f"),{startup:!1,extensionId:Ae(this,R,"f"),activationEvent:"api"}),this.exports}}e.Extension=K,U=new WeakMap,R=new WeakMap,x=new WeakMap;function Z(pe,ae){return pe.getAllExtensionDescriptions().filter(de=>ae.has(S.ExtensionIdentifier.toKey(de.identifier)))}function ue(pe){const ae=pe.indexOf("+");return ae===-1?pe:pe.substring(0,ae)}class ne{constructor(ae){this._searchTree=ae}setSearchTree(ae){this._searchTree=ae}findSubstr(ae){return this._searchTree.findSubstr(ae)}forEach(ae){return this._searchTree.forEach(ae)}}e.ExtensionPaths=ne}),define(De[237],Ie([1,0,76,2,5,32,27,25,14,26,3,33,48,11,10]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let t=class{constructor(C,r,c,n,d,l,f){this._apiFactory=C,this._extensionRegistry=r,this._instaService=c,this._extHostConfiguration=n,this._extHostExtensionService=d,this._initData=l,this._logService=f,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),i.mark("code/extHost/willWaitForConfig");const C=await this._extHostConfiguration.getConfigProvider();i.mark("code/extHost/didWaitForConfig");const r=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,r,this._extensionRegistry,C,this._logService)),this.register(this._instaService.createInstance(p,r)),this.register(this._instaService.createInstance(s)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(S,r,this._initData.environment.appUriScheme))}register(C){if("nodeModuleName"in C)if(Array.isArray(C.nodeModuleName))for(const r of C.nodeModuleName)this._factories.set(r,C);else this._factories.set(C.nodeModuleName,C);typeof C.alternativeModuleName=="function"&&this._alternatives.push(r=>C.alternativeModuleName(r))}};t=He([$e(2,O.IInstantiationService),$e(3,M.IExtHostConfiguration),$e(4,b.IExtHostExtensionService),$e(5,T.IExtHostInitDataService),$e(6,E.ILogService)],t),e.RequireInterceptor=t;let s=class Qi{constructor(C){if(C.environment.appRoot&&Qi.aliased.size){const r=(0,m.escapeRegExpCharacters)(this.forceForwardSlashes(C.environment.appRoot.fsPath)),c="[a-z0-9_.-]",n=`@${c}+\\/${c}+|${c}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${r}/${d}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(C){if(!this.re)return;const r=this.re.exec(this.forceForwardSlashes(C));if(!r)return;const[,c,n,d]=r,l=Qi.aliased.get(n);if(l!==void 0)return console.warn(`${n} as been renamed to ${l}, please update your imports`),c+l+d}forceForwardSlashes(C){return C.replace(/\\/g,"/")}};s.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),s=He([$e(0,T.IExtHostInitDataService)],s);class a{constructor(C,r,c,n,d){this._apiFactory=C,this._extensionPaths=r,this._extensionRegistry=c,this._configProvider=n,this._logService=d,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(C,r){const c=this._extensionPaths.findSubstr(r);if(c){let n=this._extApiImpl.get(A.ExtensionIdentifier.toKey(c.identifier));return n||(n=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(c.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((d,l)=>n+=`	${l} -> ${d.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let p=class{constructor(C,r,c){this._extensionPaths=C,this.nodeModuleName="keytar",this._mainThreadTelemetry=r.getProxy(w.MainContext.MainThreadTelemetry);const{environment:n}=c,d=r.getProxy(w.MainContext.MainThreadKeytar);if(n.appRoot){let l=n.appRoot.fsPath;g.platform==="win32"&&(l=l.replace(/\\/g,"/")),l[l.length-1]==="/"&&(l=l.substr(0,l.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${l}/node_modules.asar/keytar`),this.alternativeNames.add(`${l}/node_modules/keytar`)}this._impl={getPassword:(l,f)=>d.$getPassword(l,f),setPassword:(l,f,o)=>d.$setPassword(l,f,o),deletePassword:(l,f)=>d.$deletePassword(l,f),findPassword:l=>d.$findPassword(l),findCredentials(l){return d.$findCredentials(l)}}}load(C,r){const c=this._extensionPaths.findSubstr(r);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:c?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(C){const r=C.length;if(r<=7||!this.alternativeNames)return;const c=r-7;if((C.charAt(c)==="/"||C.charAt(c)==="\\")&&C.endsWith("keytar")&&(C=C.replace(/\\/g,"/"),this.alternativeNames.has(C)))return"keytar"}};p=He([$e(1,y.IExtHostRpcService),$e(2,T.IExtHostInitDataService)],p);let S=class{constructor(C,r,c){this._extensionPaths=C,this._appUriScheme=r,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(w.MainContext.MainThreadTelemetry);const n=c.getProxy(w.MainContext.MainThreadWindow);this._impl=(d,l)=>{const f=I.URI.parse(d);return l?this.callOriginal(d,l):f.scheme==="http"||f.scheme==="https"?n.$openUri(f,d,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this._appUriScheme?n.$openUri(f,d,{}):this.callOriginal(d,l)}}load(C,r,c){const n=this._extensionPaths.findSubstr(r);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=c(C),this._impl}callOriginal(C,r){return this.sendNoForwardTelemetry(),this._original(C,r)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};S=He([$e(2,y.IExtHostRpcService)],S)}),define(De[103],Ie([1,0,203,7,19,48,3,53,54,33,6,31,176,32]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class m extends g.AbstractVariableResolverService{constructor(a,p,S,u,C,r,c){function n(){if(S){const d=S.activeEditor();if(d)return d.document.uri;const l=u.tabGroups.all.find(f=>f.isActive)?.activeTab;if(l!==void 0){if(l.input instanceof O.TextDiffTabInput||l.input instanceof O.NotebookDiffEditorTabInput)return l.input.modified;if(l.input instanceof O.TextTabInput||l.input instanceof O.NotebookEditorTabInput||l.input instanceof O.CustomEditorTabInput)return l.input.uri}}}super({getFolderUri:d=>{const l=r.folders.filter(f=>f.name===d);if(l&&l.length>0)return l[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(d,l)=>C.getConfiguration(void 0,d).get(l),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=n();if(d)return w.normalize(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const d=n();if(d){const l=p.getWorkspaceFolder(d);if(l)return w.normalize(l.uri.fsPath)}}},getSelectedText:()=>{if(S){const d=S.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(S){const d=S.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>a.getExtension(d)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(M.env))}}let t=class extends I.Disposable{constructor(a,p,S,u,C){super(),this.extensionService=a,this.workspaceService=p,this.editorService=S,this.configurationService=u,this.editorTabs=C,this._resolver=new i.Lazy(async()=>{const r=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async d=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new m(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,r,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};t=He([$e(0,T.IExtHostExtensionService),$e(1,b.IExtHostWorkspace),$e(2,A.IExtHostDocumentsAndEditors),$e(3,E.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs)],t),e.ExtHostVariableResolverProviderService=t}),define(De[104],Ie([1,0,15,4,9,2,3,5,54,33,14,6,31,169,171,32,103]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}constructor(n,d,l,f,o,h){this._workspaceService=d,this._extensionService=l,this._configurationService=f,this._editorTabs=o,this._variableResolver=h,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new I.Emitter,this._onDidTerminateDebugSession=new I.Emitter,this._onDidChangeActiveDebugSession=new I.Emitter,this._onDidReceiveDebugSessionCustomEvent=new I.Emitter,this._debugServiceProxy=n.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new I.Emitter({onWillAddFirstListener:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new S(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(v=>{v.onDidChange(k=>{this.registerAllDebugTypes(v)}),this.registerAllDebugTypes(v)})}asDebugSourceUri(n,d){const l=n;if(typeof l.sourceReference=="number"&&l.sourceReference>0){let f=`debug:${encodeURIComponent(l.path||"")}`,o="?";return d&&(f+=`${o}session=${encodeURIComponent(d.id)}`,o="&"),f+=`${o}ref=${l.sourceReference}`,M.URI.parse(f)}else{if(l.path)return M.URI.file(l.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const d=[];for(const l of n.getAllExtensionDescriptions())if(l.contributes){const f=l.contributes.debuggers;if(f&&f.length>0)for(const o of f)(0,m.isDebuggerMainContribution)(o)&&d.push(o.type)}this._debugServiceProxy.$registerDebugTypes(d)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(d=>n.push(d)),n}addBreakpoints(n){this.startBreakpoints();const d=n.filter(o=>{const h=o.id;return this._breakpoints.has(h)?!1:(this._breakpoints.set(h,o),!0)});this.fireBreakpointChanges(d,[],[]);const l=[],f=new Map;for(const o of d)if(o instanceof b.SourceBreakpoint){let h=f.get(o.location.uri.toString());h||(h={type:"sourceMulti",uri:o.location.uri,lines:[]},f.set(o.location.uri.toString(),h),l.push(h)),h.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof b.FunctionBreakpoint&&l.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this._debugServiceProxy.$registerBreakpoints(l)}removeBreakpoints(n){this.startBreakpoints();const d=n.filter(h=>this._breakpoints.delete(h.id));this.fireBreakpointChanges([],d,[]);const l=d.filter(h=>h instanceof b.SourceBreakpoint).map(h=>h.id),f=d.filter(h=>h instanceof b.FunctionBreakpoint).map(h=>h.id),o=d.filter(h=>h instanceof b.DataBreakpoint).map(h=>h.id);return this._debugServiceProxy.$unregisterBreakpoints(l,f,o)}startDebugging(n,d,l){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,d,{parentSessionID:l.parentSession?l.parentSession.id:void 0,lifecycleManagedByParent:l.lifecycleManagedByParent,repl:l.consoleMode===b.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:l.noDebug,compact:l.compact,suppressSaveBeforeStart:l.suppressSaveBeforeStart,suppressDebugStatusbar:l.suppressDebugStatusbar??l.debugUI?.simple,suppressDebugToolbar:l.suppressDebugToolbar??l.debugUI?.simple,suppressDebugView:l.suppressDebugView??l.debugUI?.simple})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,d,l){if(!d)return new b.Disposable(()=>{});const f=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:f,provider:d}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,l,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,f),new b.Disposable(()=>{this._configProviders=this._configProviders.filter(o=>o.provider!==d),this._debugServiceProxy.$unregisterDebugConfigurationProvider(f)})}registerDebugAdapterDescriptorFactory(n,d,l){if(!l)return new b.Disposable(()=>{});if(!this.definesDebugType(n,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.getAdapterDescriptorFactoryByType(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const f=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:d,handle:f,factory:l}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(d,f),new b.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(o=>o.factory!==l),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(f)})}registerDebugAdapterTrackerFactory(n,d){if(!d)return new b.Disposable(()=>{});const l=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:l,factory:d}),new b.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(f=>f.factory!==d)})}async $runInTerminal(n,d){return Promise.resolve(void 0)}async $substituteVariables(n,d){let l;const f=await this.getFolder(n);return f&&(l={uri:f.uri,name:f.name,index:f.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(l,d)}createDebugAdapter(n,d){if(n.type==="implementation")return new C(n.implementation)}createSignService(){}async $startDASession(n,d){const l=this,f=await this.getSession(d);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(f.type),f).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}' (extension might have failed to activate)`);const h=this.convertToDto(o),v=this.createDebugAdapter(h,f);if(!v)throw new Error(`Couldn't create a debug adapter for type '${f.type}'.`);const k=v;return this._debugAdapters.set(n,k),this.getDebugAdapterTrackers(f).then(F=>(F&&this._debugAdaptersTrackers.set(n,F),k.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const H=j,V={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const P=await this._signService.sign(H.arguments.value);V.body={signature:P},k.sendResponse(V)}else throw new Error("no signer")}catch(P){V.success=!1,V.message=P.message,k.sendResponse(V)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(j),j=(0,m.convertToVSCPaths)(j,!0),l._debugServiceProxy.$acceptDAMessage(n,j)}),k.onError(j=>{F&&F.onError&&F.onError(j),this._debugServiceProxy.$acceptDAError(n,j.name,j.message,j.stack)}),k.onExit(j=>{F&&F.onExit&&F.onExit((0,w.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,w.withNullAsUndefined)(j),void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),k.startSession()))})}$sendDAMessage(n,d){d=(0,m.convertToDAPaths)(d,!1);const l=this._debugAdaptersTrackers.get(n);l&&l.onWillReceiveMessage&&l.onWillReceiveMessage(d),this._debugAdapters.get(n)?.sendMessage(d)}$stopDASession(n){const d=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),d&&d.onWillStopSession&&d.onWillStopSession();const l=this._debugAdapters.get(n);return this._debugAdapters.delete(n),l?l.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const d=[],l=[],f=[];if(n.added)for(const o of n.added){const h=o.id;if(h&&!this._breakpoints.has(h)){let v;if(o.type==="function")v=new b.FunctionBreakpoint(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")v=new b.DataBreakpoint(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const k=M.URI.revive(o.uri);v=new b.SourceBreakpoint(new b.Location(k,new b.Position(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}v._id=h,this._breakpoints.set(h,v),d.push(v)}}if(n.removed)for(const o of n.removed){const h=this._breakpoints.get(o);h&&(this._breakpoints.delete(o),l.push(h))}if(n.changed){for(const o of n.changed)if(o.id){const h=this._breakpoints.get(o.id);if(h){if(h instanceof b.FunctionBreakpoint&&o.type==="function"){const v=h;v.enabled=o.enabled,v.condition=o.condition,v.hitCondition=o.hitCondition,v.logMessage=o.logMessage,v.functionName=o.functionName}else if(h instanceof b.SourceBreakpoint&&o.type==="source"){const v=h;v.enabled=o.enabled,v.condition=o.condition,v.hitCondition=o.hitCondition,v.logMessage=o.logMessage,v.location=new b.Location(M.URI.revive(o.uri),new b.Position(o.line,o.character))}f.push(h)}}}this.fireBreakpointChanges(d,l,f)}$provideDebugConfigurations(n,d,l){return(0,i.asPromise)(async()=>{const f=this.getConfigProviderByHandle(n);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.getFolder(d);return f.provideDebugConfigurations(o,l)}).then(f=>{if(!f)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return f})}$resolveDebugConfiguration(n,d,l,f){return(0,i.asPromise)(async()=>{const o=this.getConfigProviderByHandle(n);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const h=await this.getFolder(d);return o.resolveDebugConfiguration(h,l,f)})}$resolveDebugConfigurationWithSubstitutedVariables(n,d,l,f){return(0,i.asPromise)(async()=>{const o=this.getConfigProviderByHandle(n);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const h=await this.getFolder(d);return o.resolveDebugConfigurationWithSubstitutedVariables(h,l,f)})}async $provideDebugAdapter(n,d){const l=this.getAdapterDescriptorFactoryByHandle(n);if(!l)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const f=await this.getSession(d);return this.getAdapterDescriptor(l,f).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${f.type}'`);return this.convertToDto(o)})}async $acceptDebugSessionStarted(n){const d=await this.getSession(n);this._onDidStartDebugSession.fire(d)}async $acceptDebugSessionTerminated(n){const d=await this.getSession(n);d&&(this._onDidTerminateDebugSession.fire(d),this._debugSessions.delete(d.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,d){(await this.getSession(n))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(n,d){const f={session:await this.getSession(n),event:d.event,body:d.body};this._onDidReceiveDebugSessionCustomEvent.fire(f)}convertToDto(n){if(n instanceof b.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof b.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof b.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof b.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const d=this._adapterFactories.filter(l=>l.type===n);if(d.length>0)return d[0].factory}getAdapterDescriptorFactoryByHandle(n){const d=this._adapterFactories.filter(l=>l.handle===n);if(d.length>0)return d[0].factory}getConfigProviderByHandle(n){const d=this._configProviders.filter(l=>l.handle===n);if(d.length>0)return d[0].provider}definesDebugType(n,d){if(n.contributes){const l=n.contributes.debuggers;if(l&&l.length>0){for(const f of l)if(f.label&&f.type&&f.type===d)return!0}}return!1}getDebugAdapterTrackers(n){const l=n.configuration.type,f=this._trackerFactories.filter(o=>o.type===l||o.type==="*").map(o=>(0,i.asPromise)(()=>o.factory.createDebugAdapterTracker(n)).then(h=>h,h=>null));return Promise.race([Promise.all(f).then(o=>{const h=o.filter(v=>!!v);if(h.length>0)return new u(h)}),new Promise((o,h)=>{const v=setTimeout(()=>{clearTimeout(v),h(new Error("timeout"))},1e3)})]).catch(o=>{})}async getAdapterDescriptor(n,d){const l=d.configuration.debugServer;if(typeof l=="number")return Promise.resolve(new b.DebugAdapterServer(l));if(n){const o=await this._extensionService.getExtensionRegistry();return(0,i.asPromise)(()=>n.createDebugAdapterDescriptor(d,this.daExecutableFromPackage(d,o))).then(h=>{if(h)return h})}const f=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(d,f))}daExecutableFromPackage(n,d){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,d,l){(n.length>0||d.length>0||l.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:d,changed:l}))}async getSession(n){if(n)if(typeof n=="string"){const d=this._debugSessions.get(n);if(d)return d}else{let d=this._debugSessions.get(n.id);if(!d){const l=await this.getFolder(n.folderUri),f=n.parent?this._debugSessions.get(n.parent):void 0;d=new p(this._debugServiceProxy,n.id,n.type,n.name,l,n.configuration,f),this._debugSessions.set(d.id,d),this._debugServiceProxy.$sessionCached(d.id)}return d}throw new Error("cannot find session")}getFolder(n){if(n){const d=M.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};a=He([$e(0,O.IExtHostRpcService),$e(1,g.IExtHostWorkspace),$e(2,T.IExtHostExtensionService),$e(3,t.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,s.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class p{constructor(n,d,l,f,o,h,v){this._debugServiceProxy=n,this._id=d,this._type=l,this._name=f,this._workspaceFolder=o,this._configuration=h,this._parentSession=v}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,d){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,d)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=p;class S{constructor(n){this.value=Object.freeze({append(d){n.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.ExtHostDebugConsole=S;class u{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(d=>d.onError?d.onError(n):void 0)}onExit(n,d){this.trackers.forEach(l=>l.onExit?l.onExit(n,d):void 0)}}class C extends E.AbstractDebugAdapter{constructor(n){super(),this.implementation=n,n.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let r=class extends a{constructor(n,d,l,f,o,h){super(n,d,l,f,o,h)}};r=He([$e(0,O.IExtHostRpcService),$e(1,g.IExtHostWorkspace),$e(2,T.IExtHostExtensionService),$e(3,t.IExtHostConfiguration),$e(4,y.IExtHostEditorTabs),$e(5,s.IExtHostVariableResolverProvider)],r),e.WorkerExtHostDebugService=r}),define(De[238],Ie([1,0,12,76,2,5,229,11,59,60,26,149,14,50,33,69]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class s{static async installEarlyHandler(S){const u=S.get(A.ILogService),r=S.get(g.IExtHostRpcService).getProxy(M.MainContext.MainThreadErrors);i.setUnexpectedErrorHandler(c=>{u.error(c);const n=i.transformErrorForSerialization(c);r.$onUnexpectedError(n)})}static async installFullHandler(S){const u=S.get(A.ILogService),C=S.get(g.IExtHostRpcService),r=S.get(m.IExtHostExtensionService),c=S.get(t.IExtHostTelemetry),n=C.getProxy(M.MainContext.MainThreadExtensionService),d=C.getProxy(M.MainContext.MainThreadErrors),l=await r.getExtensionPathIndex(),f=new WeakMap;Error.prepareStackTrace=(o,h)=>{let v="",k,F;for(const j of h)v+=`
	at ${j.toString()}`,F=j.getFileName(),!k&&F&&(k=l.findSubstr(w.URI.file(F)));return f.set(o,k?.identifier),`${o.name||"Error"}: ${o.message||""}${v}`},i.setUnexpectedErrorHandler(o=>{u.error(o);const h=i.transformErrorForSerialization(o),v=f.get(o);if(!v){d.$onUnexpectedError(h);return}n.$onExtensionRuntimeError(v,h);const k=c.onExtensionError(v,o);u.trace("forwarded error to extension?",k,v)})}}Error.stackTraceLimit=100;class a{constructor(S,u,C,r,c){this._hostUtils=C,this._rpcProtocol=new D.RPCProtocol(S,null,r),u=a._transform(u,this._rpcProtocol);const n=new T.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());n.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...u,messagePorts:c}),n.set(g.IExtHostRpcService,new g.ExtHostRpcService(this._rpcProtocol)),n.set(E.IURITransformerService,new E.URITransformerService(r)),n.set(m.IHostUtils,C);const d=new b.InstantiationService(n,!0);d.invokeFunction(s.installEarlyHandler),this._logService=d.invokeFunction(l=>l.get(A.ILogService)),I.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",u),this._extensionService=d.invokeFunction(l=>l.get(m.IExtHostExtensionService)),this._extensionService.initialize(),d.invokeFunction(s.installFullHandler)}async asBrowserUri(S){const u=this._rpcProtocol.getProxy(M.MainContext.MainThreadExtensionService);return w.URI.revive(await u.$asBrowserUri(S))}terminate(S){this._extensionService.terminate(S)}static _transform(S,u){S.allExtensions.forEach(r=>{r.extensionLocation=w.URI.revive(u.transformIncomingURIs(r.extensionLocation));const c={};r.browserNlsBundleUris&&(Object.keys(r.browserNlsBundleUris).forEach(n=>c[n]=w.URI.revive(u.transformIncomingURIs(r.browserNlsBundleUris[n]))),r.browserNlsBundleUris=c)}),S.environment.appRoot=w.URI.revive(u.transformIncomingURIs(S.environment.appRoot));const C=S.environment.extensionDevelopmentLocationURI;return C&&(S.environment.extensionDevelopmentLocationURI=C.map(r=>w.URI.revive(u.transformIncomingURIs(r)))),S.environment.extensionTestsLocationURI=w.URI.revive(u.transformIncomingURIs(S.environment.extensionTestsLocationURI)),S.environment.globalStorageHome=w.URI.revive(u.transformIncomingURIs(S.environment.globalStorageHome)),S.environment.workspaceStorageHome=w.URI.revive(u.transformIncomingURIs(S.environment.workspaceStorageHome)),S.environment.extensionTelemetryLogResource=w.URI.revive(u.transformIncomingURIs(S.environment.extensionTelemetryLogResource)),S.nlsBaseUrl=w.URI.revive(u.transformIncomingURIs(S.nlsBaseUrl)),S.logsLocation=w.URI.revive(u.transformIncomingURIs(S.logsLocation)),S.logFile=w.URI.revive(u.transformIncomingURIs(S.logFile)),S.workspace=u.transformIncomingURIs(S.workspace),S}}e.ExtensionHostMain=a}),define(De[239],Ie([1,0,18,15,20,45,13,19,22,2,44]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class b{constructor(p,S,u,C){this.query=p,this.provider=S,this.fileUtils=u,this.processType=C,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(p,S){const u=this.query.folderQueries||[],C=new w.CancellationTokenSource;return S.onCancellationRequested(()=>C.cancel()),new Promise((r,c)=>{this.collector=new E(p);let n=!1;const d=(l,f)=>{if(!n&&!this.isLimitHit){const o=this.resultSize(l);t(l)&&typeof this.query.maxResults=="number"&&this.resultCount+o>this.query.maxResults&&(this.isLimitHit=!0,n=!0,C.cancel(),l=this.trimResultToSize(l,this.query.maxResults-this.resultCount));const h=this.resultSize(l);this.resultCount+=h,(h>0||!t(l))&&this.collector.add(l,f)}};Promise.all(u.map((l,f)=>this.searchInFolder(l,o=>d(o,f),C.token))).then(l=>{C.dispose(),this.collector.flush();const f=l.some(o=>!!o&&!!o.limitHit);r({limitHit:this.isLimitHit||f,messages:(0,i.flatten)(l.map(o=>o?.message?Array.isArray(o.message)?o.message:[o.message]:[])),stats:{type:this.processType}})},l=>{C.dispose();const f=(0,M.toErrorMessage)(l);c(new Error(f))})})}resultSize(p){return t(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}trimResultToSize(p,S){const u=Array.isArray(p.ranges)?p.ranges:[p.ranges],C=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:u.slice(0,S),preview:{matches:C.slice(0,S),text:p.preview.text},uri:p.uri}}async searchInFolder(p,S,u){const C=new O.QueryGlobTester(this.query,p),r=[],c={report:l=>{if(!this.validateProviderResult(l))return;const f=p.folder.scheme===D.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(y.dirname(l.uri))):void 0,o=y.relativePath(p.folder,l.uri);if(o){const h=C.includedInQuery(o,A.basename(o),f);(0,I.isThenable)(h)?r.push(h.then(v=>{v&&S(l)})):h&&S(l)}}},n=this.getSearchOptionsForFolder(p),d=await this.provider.provideTextSearchResults(g(this.query.contentPattern),n,c,u);return r.length&&await Promise.all(r),d}validateProviderResult(p){if(t(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(p){const S=(0,O.resolvePatternsForProvider)(this.query.includePattern,p.includePattern),u=(0,O.resolvePatternsForProvider)(this.query.excludePattern,p.excludePattern),C={folder:T.URI.from(p.folder),excludes:u,includes:S,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.fileUtils.toCanonicalName(p.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return C.usePCRE2=this.query.usePCRE2,C}}e.TextSearchManager=b;function g(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(p){this._onResult=p,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new s(512,S=>this.sendItems(S))}add(p,S){this._currentFileMatch&&(this._currentFolderIdx!==S||!y.isEqual(this._currentUri,p.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=S,this._currentFileMatch={resource:p.uri,results:[]}),this._currentFileMatch.results.push(m(p))}pushToCollector(){const p=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,p)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(p){this._onResult(p)}}e.TextSearchResultsCollector=E;function m(a){return t(a)?{preview:{matches:(0,i.mapArrayOrNot)(a.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:a.preview.text},ranges:(0,i.mapArrayOrNot)(a.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function t(a){return!!a.preview}e.extensionResultIsMatch=t;class s{constructor(p,S){this.maxBatchSize=p,this.cb=S,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(p,S){!p||this.addItemToBatch(p,S)}addItems(p,S){!p||this.addItemsToBatch(p,S)}addItemToBatch(p,S){this.batch.push(p),this.batchSize+=S,this.onUpdate()}addItemsToBatch(p,S){this.batch=this.batch.concat(p),this.batchSize+=S,this.onUpdate()}onUpdate(){this.totalNumberCompleted<s.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},s.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=s,s.TIMEOUT=4e3,s.START_BATCH_AFTER_COUNT=50}),define(De[105],Ie([1,0,7,5,3,234,14,50,11,2,239]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let b=class{constructor(t,s,a){this.extHostRpc=t,this._uriTransformer=s,this._logService=a,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new M.FileSearchManager}_transformScheme(t){return this._uriTransformer.transformOutgoingScheme(t)}registerTextSearchProvider(t,s){if(this._textSearchUsedSchemes.has(t))throw new Error(`a text search provider for the scheme '${t}' is already registered`);this._textSearchUsedSchemes.add(t);const a=this._handlePool++;return this._textSearchProvider.set(a,s),this._proxy.$registerTextSearchProvider(a,this._transformScheme(t)),(0,i.toDisposable)(()=>{this._textSearchUsedSchemes.delete(t),this._textSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerFileSearchProvider(t,s){if(this._fileSearchUsedSchemes.has(t))throw new Error(`a file search provider for the scheme '${t}' is already registered`);this._fileSearchUsedSchemes.add(t);const a=this._handlePool++;return this._fileSearchProvider.set(a,s),this._proxy.$registerFileSearchProvider(a,this._transformScheme(t)),(0,i.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(t),this._fileSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(t,s,a,p){const S=g(a),u=this._fileSearchProvider.get(t);if(u)return this._fileSearchManager.fileSearch(S,u,C=>{this._proxy.$handleFileMatch(t,s,C.map(r=>r.resource))},p);throw new Error("unknown provider: "+t)}$clearCache(t){return this._fileSearchManager.clearCache(t),Promise.resolve(void 0)}$provideTextSearchResults(t,s,a,p){const S=this._textSearchProvider.get(t);if(!S||!S.provideTextSearchResults)throw new Error(`Unknown provider ${t}`);const u=g(a);return this.createTextSearchManager(u,S).search(r=>this._proxy.$handleTextMatch(t,s,r),p)}$enableExtensionHostSearch(){}createTextSearchManager(t,s){return new O.TextSearchManager(t,s,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};b=He([$e(0,D.IExtHostRpcService),$e(1,A.IURITransformerService),$e(2,y.ILogService)],b),e.ExtHostSearch=b;function g(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(E),extraFileResources:m.extraFileResources&&m.extraFileResources.map(t=>T.URI.revive(t))}}e.reviveQuery=g;function E(m){return{...m,folder:T.URI.revive(m.folder)}}}),define(De[240],Ie([1,0,59,100,31,98,32,37,53,56,102,104,105,74,64,71,99,55,36,73,69,54,211,11,181,103,72]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S,u,C,r,c,n,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(l.IExtHostLocalizationService,l.ExtHostLocalizationService,1),(0,i.registerSingleton)(c.ILoggerService,r.ExtHostLoggerService,1),(0,i.registerSingleton)(c.ILogService,n.ExtHostLogService,1),(0,i.registerSingleton)(t.IExtHostApiDeprecationService,t.ExtHostApiDeprecationService,1),(0,i.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,i.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration,0),(0,i.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem,0),(0,i.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService,0),(0,i.registerSingleton)(M.IExtHostDecorations,M.ExtHostDecorations,0),(0,i.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,i.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,i.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService,1),(0,i.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch,0),(0,i.registerSingleton)(E.IExtHostStorage,E.ExtHostStorage,0),(0,i.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,i.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService,0),(0,i.registerSingleton)(m.IExtHostTunnelService,m.ExtHostTunnelService,0),(0,i.registerSingleton)(s.IExtHostWindow,s.ExtHostWindow,0),(0,i.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace,0),(0,i.registerSingleton)(S.IExtHostSecretState,S.ExtHostSecretState,0),(0,i.registerSingleton)(u.IExtHostTelemetry,u.ExtHostTelemetry,0),(0,i.registerSingleton)(C.IExtHostEditorTabs,C.ExtHostEditorTabs,0),(0,i.registerSingleton)(d.IExtHostVariableResolverProvider,d.ExtHostVariableResolverProviderService,0)}),define(De[241],Ie([1,0]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class i{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(w){if(w&&this._dragOperations.has(w)){const M=this._dragOperations.get(w);return this._dragOperations.delete(w),M}}addDragOperationTransfer(w,M){this._dragOperations.set(w,M)}getRenderedTreeElement(w){if(this._renderedElements.has(w))return this._renderedElements.get(w)}addRenderedTreeItemElement(w,M){this._renderedElements.set(w,M)}removeRenderedTreeItemElement(w){this._renderedElements.has(w)&&this._renderedElements.delete(w)}}e.TreeviewsService=i}),define(De[242],Ie([1,0,136,6,22,2,4,7,15,6,9,18,8,20,241,27]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(S,u){if((0,O.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let C;return Array.isArray(S.highlights)&&(C=S.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),C=C.length?C:void 0),{label:S.label,highlights:C}}}class a{constructor(u,C,r){this._proxy=u,this.commands=C,this.logService=r,this.treeViews=new Map,this.treeDragAndDropService=new m.TreeviewsService;function c(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}C.registerArgumentProcessor({processArgument:n=>c(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(d=>c(d)?this.convertArgument(d):d):n})}registerTreeDataProvider(u,C,r){const c=this.createTreeView(u,{treeDataProvider:C},r);return{dispose:()=>c.dispose()}}createTreeView(u,C,r){if(!C||!C.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const c=C.dragAndDropController?.dropMimeTypes??[],n=C.dragAndDropController?.dragMimeTypes??[],d=!!C.dragAndDropController?.handleDrag,l=!!C.dragAndDropController?.handleDrop,f=this.createExtHostTreeView(u,C,r),o=this._proxy.$registerTreeViewDataProvider(u,{showCollapseAll:!!C.showCollapseAll,canSelectMany:!!C.canSelectMany,dropMimeTypes:c,dragMimeTypes:n,hasHandleDrag:d,hasHandleDrop:l});return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,t.checkProposedApiEnabled)(r,"treeItemCheckbox"),f.onDidChangeCheckboxState},get message(){return f.message},set message(h){f.message=h},get title(){return f.title},set title(h){f.title=h},get description(){return f.description},set description(h){f.description=h},get badge(){return f.badge},set badge(h){h!==void 0&&T.ViewBadge.isViewBadge(h)?f.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(f.badge=void 0)},reveal:(h,v)=>f.reveal(h,v),dispose:async()=>{await o,this.treeViews.delete(u),f.dispose()}}}$getChildren(u,C){const r=this.treeViews.get(u);return r?r.getChildren(C):Promise.reject(new Error((0,i.localize)(0,null,u)))}async $handleDrop(u,C,r,c,n,d,l,f){const o=this.treeViews.get(u);if(!o)return Promise.reject(new Error((0,i.localize)(1,null,u)));const h=g.DataTransfer.toDataTransfer(r,async v=>(await this._proxy.$resolveDropFileData(u,C,v)).buffer);return l===u&&f&&await this.addAdditionalTransferItems(h,o,f,n,d),o.onDrop(h,c,n)}async addAdditionalTransferItems(u,C,r,c,n){const d=this.treeDragAndDropService.removeDragOperationTransfer(n);if(d)(await d)?.forEach((l,f)=>{l&&u.set(f,l)});else if(n&&C.handleDrag){const l=C.handleDrag(r,u,c);this.treeDragAndDropService.addDragOperationTransfer(n,l),await l}return u}async $handleDrag(u,C,r,c){const n=this.treeViews.get(u);if(!n)return Promise.reject(new Error((0,i.localize)(2,null,u)));const d=await this.addAdditionalTransferItems(new I.DataTransfer,n,C,c,r);if(!!d)return g.DataTransfer.toDataTransferDTO(d)}async $hasResolve(u){const C=this.treeViews.get(u);if(!C)throw new Error((0,i.localize)(3,null,u));return C.hasResolve}$resolve(u,C,r){const c=this.treeViews.get(u);if(!c)throw new Error((0,i.localize)(4,null,u));return c.resolveTreeItem(C,r)}$setExpanded(u,C,r){const c=this.treeViews.get(u);if(!c)throw new Error((0,i.localize)(5,null,u));c.setExpanded(C,r)}$setSelection(u,C){const r=this.treeViews.get(u);if(!r)throw new Error((0,i.localize)(6,null,u));r.setSelection(C)}$setFocus(u,C){const r=this.treeViews.get(u);if(!r)throw new Error((0,i.localize)(7,null,u));r.setFocus(C)}$setVisible(u,C){const r=this.treeViews.get(u);if(!r)throw new Error((0,i.localize)(8,null,u));r.setVisible(C)}$changeCheckboxState(u,C){const r=this.treeViews.get(u);if(!r)throw new Error((0,i.localize)(9,null,u));r.setCheckboxState(C)}createExtHostTreeView(u,C,r){const c=new p(u,C,this._proxy,this.commands.converter,this.logService,r);return this.treeViews.set(u,c),c}convertArgument(u){const C=this.treeViews.get(u.$treeViewId);return C&&"$treeItemHandle"in u?C.getExtensionElement(u.$treeItemHandle):C&&"$focusedTreeItem"in u&&u.$focusedTreeItem?C.focusedElement:null}}e.ExtHostTreeViews=a;class p extends A.Disposable{get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(u=>this.getExtensionElement(u)).filter(u=>!(0,O.isUndefinedOrNull)(u))}get focusedElement(){return this._focusedHandle?this.getExtensionElement(this._focusedHandle):void 0}constructor(u,C,r,c,n,d){if(super(),this.viewId=u,this.proxy=r,this.commands=c,this.logService=n,this.extension=d,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._focusedHandle=void 0,this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeCheckboxState=this._register(new D.Emitter),this.onDidChangeCheckboxState=this._onDidChangeCheckboxState.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new E.CancellationTokenSource,d.contributes&&d.contributes.views)for(const o in d.contributes.views)for(const h of d.contributes.views[o])h.id===u&&(this._title=h.name);this.dataProvider=C.treeDataProvider,this.dndController=C.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(o=>this._onDidChangeData.fire({message:!1,element:o})));let l,f;this._register(D.Event.debounce(this._onDidChangeData.event,(o,h)=>(o||(o={message:!1,elements:[]}),h.element!==!1&&(l||(l=new Promise(v=>f=v),this.refreshPromise=this.refreshPromise.then(()=>l)),Array.isArray(h.element)?o.elements.push(...h.element):o.elements.push(h.element)),h.message&&(o.message=!0),o),200,!0)(({message:o,elements:h})=>{h.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=f;return l=null,this.refresh(h).then(()=>v())})),o&&this.proxy.$setMessage(this.viewId,this._message)}))}async getChildren(u){const C=u?this.getExtensionElement(u):void 0;if(u&&!C)return this.logService.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let r=this.getChildrenNodes(u);return r||(r=await this.fetchChildrenNodes(C)),r?r.map(c=>c.item):void 0}getExtensionElement(u){return this.elements.get(u)}reveal(u,C){C=C||{select:!0,focus:!1};const r=(0,O.isUndefinedOrNull)(C.select)?!0:C.select,c=(0,O.isUndefinedOrNull)(C.focus)?!1:C.focus,n=(0,O.isUndefinedOrNull)(C.expand)?!1:C.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.refreshPromise.then(()=>this.resolveUnknownParentChain(u)).then(d=>this.resolveTreeNode(u,d[d.length-1]).then(l=>this.proxy.$reveal(this.viewId,{item:l.item,parentChain:d.map(f=>f.item)},{select:r,focus:c,expand:n})),d=>this.logService.error(d)):this.proxy.$reveal(this.viewId,void 0,{select:r,focus:c,expand:n})}get message(){return this._message}set message(u){this._message=u,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(u){this._title=u,this.proxy.$setTitle(this.viewId,u,this._description)}get description(){return this._description}set description(u){this._description=u,this.proxy.$setTitle(this.viewId,this._title,u)}get badge(){return this._badge}set badge(u){this._badge?.value===u?.value&&this._badge?.tooltip===u?.tooltip||(this._badge=g.ViewBadge.from(u),this.proxy.$setBadge(this.viewId,u))}setExpanded(u,C){const r=this.getExtensionElement(u);r&&(C?this._onDidExpandElement.fire(Object.freeze({element:r})):this._onDidCollapseElement.fire(Object.freeze({element:r})))}setSelection(u){(0,b.equals)(this._selectedHandles,u)||(this._selectedHandles=u,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setFocus(u){this._focusedHandle=u}setVisible(u){u!==this._visible&&(this._visible=u,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async setCheckboxState(u){const C=(await Promise.all(u.map(async r=>{const c=this.getExtensionElement(r.treeItemHandle);return c?{extensionItem:c,treeItem:await this.dataProvider.getTreeItem(c),newState:r.newState?T.TreeItemCheckboxState.Checked:T.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);C.forEach(r=>{r.treeItem.checkboxState=r.newState?T.TreeItemCheckboxState.Checked:T.TreeItemCheckboxState.Unchecked}),this._onDidChangeCheckboxState.fire({items:C.map(r=>[r.extensionItem,r.newState])})}async handleDrag(u,C,r){const c=[];for(const n of u){const d=this.getExtensionElement(n);d&&c.push(d)}if(!(!this.dndController?.handleDrag||c.length===0))return await this.dndController.handleDrag(c,C,r),C}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(u,C,r){const c=C?this.getExtensionElement(C):void 0;if(!(!c&&C||!this.dndController?.handleDrop))return(0,y.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(c,u,r):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(u,C){if(!this.dataProvider.resolveTreeItem)return;const r=this.elements.get(u);if(r){const c=this.nodes.get(r);if(c){const n=await this.dataProvider.resolveTreeItem(c.extensionItem,r,C)??c.extensionItem;return this.validateTreeItem(n),c.item.tooltip=this.getTooltip(n.tooltip),c.item.command=this.getCommand(c.disposableStore,n.command),c.item}}}resolveUnknownParentChain(u){return this.resolveParent(u).then(C=>C?this.resolveUnknownParentChain(C).then(r=>this.resolveTreeNode(C,r[r.length-1]).then(c=>(r.push(c),r))):Promise.resolve([]))}resolveParent(u){const C=this.nodes.get(u);return C?Promise.resolve(C.parent?this.elements.get(C.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(u))}resolveTreeNode(u,C){const r=this.nodes.get(u);return r?Promise.resolve(r):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(u)).then(c=>this.createHandle(u,c,C,!0)).then(c=>this.getChildren(C?C.item.handle:void 0).then(()=>{const n=this.getExtensionElement(c);if(n){const d=this.nodes.get(n);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${c}`)}))}getChildrenNodes(u){if(u){let C;if(typeof u=="string"){const r=this.getExtensionElement(u);C=r?this.nodes.get(r):void 0}else C=u;return C&&C.children||void 0}return this.roots}async fetchChildrenNodes(u){this.clearChildren(u);const C=new E.CancellationTokenSource(this._refreshCancellationSource.token);try{const r=u?this.nodes.get(u):void 0,c=await this.dataProvider.getChildren(u);if(C.token.isCancellationRequested)return;const n=await Promise.all((0,b.coalesce)(c||[]).map(async d=>{const l=await this.dataProvider.getTreeItem(d);return l&&!C.token.isCancellationRequested?this.createAndRegisterTreeNode(d,l,r):null}));return C.token.isCancellationRequested?void 0:(0,b.coalesce)(n)}finally{C.dispose()}}refresh(u){if(u.some(r=>!r))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new E.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const r=this.getHandlesToRefresh(u);if(r.length)return this.refreshHandles(r)}return Promise.resolve(void 0)}getHandlesToRefresh(u){const C=new Set,r=u.map(n=>this.nodes.get(n));for(const n of r)if(n&&!C.has(n.item.handle)){let d=n;for(;d&&d.parent&&r.findIndex(l=>d&&d.parent&&l&&l.item.handle===d.parent.item.handle)===-1;){const l=this.elements.get(d.parent.item.handle);d=l?this.nodes.get(l):void 0}d&&!d.parent&&C.add(n.item.handle)}const c=[];return C.forEach(n=>{const d=this.elements.get(n);if(d){const l=this.nodes.get(d);l&&(!l.parent||!C.has(l.parent.item.handle))&&c.push(n)}}),c}refreshHandles(u){const C={};return Promise.all(u.map(r=>this.refreshNode(r).then(c=>{c&&(C[r]=c.item)}))).then(()=>Object.keys(C).length?this.proxy.$refresh(this.viewId,C):void 0)}refreshNode(u){const C=this.getExtensionElement(u);if(C){const r=this.nodes.get(C);if(r)return this.clearChildren(C),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(C)).then(c=>{if(c){const n=this.createTreeNode(C,c,r.parent);return this.updateNodeCache(C,n,r,r.parent),r.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(u,C,r){const c=this.createTreeNode(u,C,r);if(C.id&&this.elements.has(c.item.handle))throw new Error((0,i.localize)(10,null,C.id));return this.addNodeToCache(u,c),this.addNodeToParentCache(c,r),c}getTooltip(u){return T.MarkdownString.isMarkdownString(u)?g.MarkdownString.from(u):u}getCommand(u,C){return C?{...this.commands.toInternal(C,u),originalId:C.command}:void 0}getCheckbox(u){if(!u.checkboxState)return;let C,r;return typeof u.checkboxState=="number"?C=u.checkboxState:(C=u.checkboxState.state,r=u.checkboxState.tooltip),{isChecked:C===T.TreeItemCheckboxState.Checked,tooltip:r}}validateTreeItem(u){if(!T.TreeItem.isTreeItem(u,this.extension))throw new Error(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(u,C,r){this.validateTreeItem(C);const c=new A.DisposableStore,n=this.createHandle(u,C,r),d=this.getLightIconPath(C);return{item:{handle:n,parentHandle:r?r.item.handle:void 0,label:s(C.label,this.extension),description:C.description,resourceUri:C.resourceUri,tooltip:this.getTooltip(C.tooltip),command:this.getCommand(c,C.command),contextValue:C.contextValue,icon:d,iconDark:this.getDarkIconPath(C)||d,themeIcon:this.getThemeIcon(C),collapsibleState:(0,O.isUndefinedOrNull)(C.collapsibleState)?T.TreeItemCollapsibleState.None:C.collapsibleState,accessibilityInformation:C.accessibilityInformation,checkbox:this.getCheckbox(C)},extensionItem:C,parent:r,children:void 0,disposableStore:c,dispose(){c.dispose()}}}getThemeIcon(u){return u.iconPath instanceof T.ThemeIcon?u.iconPath:void 0}createHandle(u,{id:C,label:r,resourceUri:c},n,d){if(C)return`${p.ID_HANDLE_PREFIX}/${C}`;const l=s(r,this.extension),f=n?n.item.handle:p.LABEL_HANDLE_PREFIX;let o=l?l.label:c?(0,w.basename)(c):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const h=this.nodes.has(u)?this.nodes.get(u).item.handle:void 0,v=this.getChildrenNodes(n)||[];let k,F=0;do{if(k=`${f}/${F}:${o}`,d||!this.elements.has(k)||h===k)break;F++}while(F<=v.length);return k}getLightIconPath(u){if(u.iconPath&&!(u.iconPath instanceof T.ThemeIcon))return typeof u.iconPath=="string"||M.URI.isUri(u.iconPath)?this.getIconPath(u.iconPath):this.getIconPath(u.iconPath.light)}getDarkIconPath(u){if(u.iconPath&&!(u.iconPath instanceof T.ThemeIcon)&&u.iconPath.dark)return this.getIconPath(u.iconPath.dark)}getIconPath(u){return M.URI.isUri(u)?u:M.URI.file(u)}addNodeToCache(u,C){this.elements.set(C.item.handle,u),this.nodes.set(u,C)}updateNodeCache(u,C,r,c){this.elements.delete(C.item.handle),this.nodes.delete(u),C.item.handle!==r.item.handle&&this.elements.delete(r.item.handle),this.addNodeToCache(u,C);const n=this.getChildrenNodes(c)||[],d=n.filter(l=>l.item.handle===r.item.handle)[0];d&&n.splice(n.indexOf(d),1,C)}addNodeToParentCache(u,C){C?(C.children||(C.children=[]),C.children.push(u)):(this.roots||(this.roots=[]),this.roots.push(u))}clearChildren(u){if(u){const C=this.nodes.get(u);if(C){if(C.children)for(const r of C.children){const c=this.elements.get(r.item.handle);c&&this.clear(c)}C.children=void 0}}else this.clearAll()}clear(u){const C=this.nodes.get(u);if(C){if(C.children)for(const r of C.children){const c=this.elements.get(r.item.handle);c&&this.clear(c)}this.nodes.delete(u),this.elements.delete(C.item.handle),C.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(u=>u.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll(),this.proxy.$disposeTree(this.viewId)}}p.LABEL_HANDLE_PREFIX="0",p.ID_HANDLE_PREFIX="1"}),define(De[243],Ie([1,0,20,12,4,29,2,123,252,111,121,35,5,68,196,195,37,197,32,199,200,201,184,202,53,33,204,205,208,210,212,100,187,216,217,218,74,56,221,242,8,6,224,57,99,31,168,207,61,98,102,104,105,11,50,14,26,213,182,64,71,193,222,75,55,227,225,226,194,36,219,223,73,54,69,214,101,215,13,87,186,165,206,7,27,170,72,162]),function(ie,e,i,I,w,M,D,A,y,T,O,b,g,E,m,t,s,a,p,S,u,C,r,c,n,d,l,f,o,h,v,k,F,j,H,V,P,U,R,x,z,B,K,Z,ue,ne,pe,ae,de,Y,me,Se,Oe,Be,Xe,ke,ye,Ce,se,le,J,_,L,W,q,ee,ce,be,oe,we,ve,Ue,ze,et,Ke,tt,Fe,ht,X,Q,ge,Ne,je,qe,We,Ze,nt,ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function It(at){const rt=at.get(ye.IExtHostInitDataService),Lt=at.get(we.IExtHostFileSystemInfo),At=at.get(q.IExtHostConsumerFileSystem),kt=at.get(d.IExtHostExtensionService),ft=at.get(ne.IExtHostWorkspace),yt=at.get(Ke.IExtHostTelemetry),Ut=at.get(p.IExtHostConfiguration),Rt=at.get(Xe.IURITransformerService),Ge=at.get(ke.IExtHostRpcService),Ct=at.get(P.IExtHostStorage),Ot=at.get(W.IExtensionStoragePaths),Bt=at.get(Be.ILoggerService),pt=at.get(Be.ILogService),_e=at.get(le.IExtHostTunnelService),Te=at.get(J.IExtHostApiDeprecationService),fe=at.get(ue.IExtHostWindow),G=at.get(ze.IExtHostSecretState),Pe=at.get(et.IExtHostEditorTabs);Ge.set(g.ExtHostContext.ExtHostFileSystemInfo,Lt),Ge.set(g.ExtHostContext.ExtHostLogLevelServiceShape,Bt),Ge.set(g.ExtHostContext.ExtHostWorkspace,ft),Ge.set(g.ExtHostContext.ExtHostConfiguration,Ut),Ge.set(g.ExtHostContext.ExtHostExtensionService,kt),Ge.set(g.ExtHostContext.ExtHostStorage,Ct),Ge.set(g.ExtHostContext.ExtHostTunnelService,_e),Ge.set(g.ExtHostContext.ExtHostWindow,fe),Ge.set(g.ExtHostContext.ExtHostSecretState,G),Ge.set(g.ExtHostContext.ExtHostTelemetry,yt),Ge.set(g.ExtHostContext.ExtHostEditorTabs,Pe);const Me=Ge.set(g.ExtHostContext.ExtHostDecorations,at.get(Y.IExtHostDecorations)),Je=Ge.set(g.ExtHostContext.ExtHostDocumentsAndEditors,at.get(n.IExtHostDocumentsAndEditors)),xe=Ge.set(g.ExtHostContext.ExtHostCommands,at.get(s.IExtHostCommands)),it=Ge.set(g.ExtHostContext.ExtHostTerminalService,at.get(U.IExtHostTerminalService)),ot=Ge.set(g.ExtHostContext.ExtHostDebugService,at.get(Se.IExtHostDebugService)),Tt=Ge.set(g.ExtHostContext.ExtHostSearch,at.get(Oe.IExtHostSearch)),Et=Ge.set(g.ExtHostContext.ExtHostTask,at.get(me.IExtHostTask)),_t=Ge.set(g.ExtHostContext.ExtHostOutputService,at.get(k.IExtHostOutputService)),vt=Ge.set(g.ExtHostContext.ExtHostLocalization,at.get(nt.IExtHostLocalizationService)),Ft=Ge.set(g.ExtHostContext.ExtHostUrls,new K.ExtHostUrls(Ge)),mt=Ge.set(g.ExtHostContext.ExtHostDocuments,new c.ExtHostDocuments(Ge,Je)),Mt=Ge.set(g.ExtHostContext.ExtHostDocumentContentProviders,new C.ExtHostDocumentContentProvider(Ge,Je,pt)),Kt=Ge.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new r.ExtHostDocumentSaveParticipant(pt,mt,Ge.getProxy(g.MainContext.MainThreadBulkEdits))),bt=Ge.set(g.ExtHostContext.ExtHostNotebook,new Ce.ExtHostNotebookController(Ge,xe,Je,mt)),Ht=Ge.set(g.ExtHostContext.ExtHostNotebookDocuments,new Ne.ExtHostNotebookDocuments(bt)),ni=Ge.set(g.ExtHostContext.ExtHostNotebookEditors,new ge.ExtHostNotebookEditors(pt,bt)),ri=Ge.set(g.ExtHostContext.ExtHostNotebookKernels,new tt.ExtHostNotebookKernels(Ge,rt,bt,xe,pt)),mi=Ge.set(g.ExtHostContext.ExtHostNotebookRenderers,new ht.ExtHostNotebookRenderers(Ge,bt)),St=Ge.set(g.ExtHostContext.ExtHostEditors,new R.ExtHostEditors(Ge,Je)),si=Ge.set(g.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(Ge.getProxy(g.MainContext.MainThreadTreeViews),xe,pt)),Ai=Ge.set(g.ExtHostContext.ExtHostEditorInsets,new pe.ExtHostEditorInsets(Ge.getProxy(g.MainContext.MainThreadEditorInsets),St,rt.remote)),Jt=Ge.set(g.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(Ge,pt,Lt,Je)),zt=Ge.set(g.ExtHostContext.ExtHostLanguages,new h.ExtHostLanguages(Ge,mt,xe.converter,Rt)),ut=Ge.set(g.ExtHostContext.ExtHostLanguageFeatures,new o.ExtHostLanguageFeatures(Ge,Rt,mt,xe,Jt,pt,Te,yt)),gi=Ge.set(g.ExtHostContext.ExtHostFileSystem,new l.ExtHostFileSystem(Ge,ut)),$t=Ge.set(g.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(Ge,pt,Je)),Gt=Ge.set(g.ExtHostContext.ExtHostQuickOpen,(0,j.createExtHostQuickOpen)(Ge,ft,xe)),oi=Ge.set(g.ExtHostContext.ExtHostSCM,new H.ExtHostSCM(Ge,xe,pt)),pi=Ge.set(g.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(Ge,xe,mt)),ai=Ge.set(g.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(Ge.getProxy(g.MainContext.MainThreadProgress))),vi=Ge.set(g.ExtHostContext.ExtHosLabelService,new ae.ExtHostLabelService(Ge)),Di=Ge.set(g.ExtHostContext.ExtHostTheming,new se.ExtHostTheming(Ge)),Zt=Ge.set(g.ExtHostContext.ExtHostAuthentication,new _.ExtHostAuthentication(Ge)),Ei=Ge.set(g.ExtHostContext.ExtHostTimeline,new L.ExtHostTimeline(Ge,xe)),ei=Ge.set(g.ExtHostContext.ExtHostWebviews,new Z.ExtHostWebviews(Ge,rt.remote,ft,pt,Te)),ti=Ge.set(g.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Ge,ei,ft)),Ri=Ge.set(g.ExtHostContext.ExtHostCustomEditors,new ce.ExtHostCustomEditors(Ge,mt,Ot,ei,ti)),bi=Ge.set(g.ExtHostContext.ExtHostWebviewViews,new ee.ExtHostWebviewViews(Ge,ei)),Xt=Ge.set(g.ExtHostContext.ExtHostTesting,new ve.ExtHostTesting(Ge,xe,Je)),Oi=Ge.set(g.ExtHostContext.ExtHostUriOpeners,new Ue.ExtHostUriOpeners(Ge));Ge.set(g.ExtHostContext.ExtHostInteractive,new je.ExtHostInteractive(Ge,bt,Je,xe,pt));const Fi=Object.values(g.ExtHostContext);Ge.assertRegistered(Fi);const Li=new oe.ExtHostBulkEdits(Ge,Je),Mi=new t.ExtHostClipboard(Ge),wi=new v.ExtHostMessageService(Ge,pt),Ii=new u.ExtHostDialogs(Ge),li=new V.ExtHostStatusBar(Ge,xe.converter);return m.ExtHostApiCommands.register(xe),function(Le,Vt,Ci){const gt=function(){let re=!Le.isUnderDevelopment;function he(){re||(pt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Re(st){if(Array.isArray(st))st.forEach(Re);else if(typeof st=="string")he();else{const wt=st;typeof wt.scheme>"u"&&he(),typeof wt.exclusive=="boolean"&&(0,We.checkProposedApiEnabled)(Le,"documentFiltersExclusive")}return st}}(),ci={getSession(re,he,Re){return Zt.getSession(Le,re,he,Re)},async hasSession(re,he){return(0,We.checkProposedApiEnabled)(Le,"authSession"),!!await Zt.getSession(Le,re,he,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(re,he,Re,st){return Zt.registerAuthenticationProvider(re,he,Re,st)}},Ni={registerCommand(re,he,Re){return xe.registerCommand(!0,re,he,Re,void 0,Le)},registerTextEditorCommand(re,he,Re){return xe.registerCommand(!0,re,(...st)=>{const wt=St.getActiveTextEditor();if(!wt){pt.warn("Cannot execute "+re+" because there is no active text editor.");return}return wt.edit(Dt=>{he.apply(Re,[wt,Dt,...st])}).then(Dt=>{Dt||pt.warn("Edits from command "+re+" were not applied.")},Dt=>{pt.warn("An error occurred while running command "+re,Dt)})},void 0,void 0,Le)},registerDiffInformationCommand:(re,he,Re)=>((0,We.checkProposedApiEnabled)(Le,"diffCommand"),xe.registerCommand(!0,re,async(...st)=>{const wt=Je.activeEditor(!0);if(!wt){pt.warn("Cannot execute "+re+" because there is no active text editor.");return}const Dt=await St.getDiffInformation(wt.id);he.apply(Re,[Dt,...st])},void 0,void 0,Le)),executeCommand(re,...he){return xe.executeCommand(re,...he)},getCommands(re=!1){return xe.getCommands(re)}},Ti={get machineId(){return rt.telemetryInfo.machineId},get sessionId(){return rt.telemetryInfo.sessionId},get language(){return rt.environment.appLanguage},get appName(){return rt.environment.appName},get appRoot(){return rt.environment.appRoot?.fsPath??""},get appHost(){return rt.environment.appHost},get uriScheme(){return rt.environment.appUriScheme},get clipboard(){return Mi.value},get shell(){return it.getDefaultShell(!1)},get onDidChangeShell(){return(0,We.checkProposedApiEnabled)(Le,"envShellEvent"),it.onDidChangeShell},get isTelemetryEnabled(){return yt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return yt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Le,"telemetry"),yt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,We.checkProposedApiEnabled)(Le,"telemetry"),yt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ke.isNewAppInstall)(rt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re){return(0,We.checkProposedApiEnabled)(Le,"telemetryLogger"),yt.instantiateLogger(Le,re)},openExternal(re,he){return fe.openUri(re,{allowTunneling:!!rt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===rt.environment.appUriScheme)return Ft.createAppUri(re);try{return await fe.asExternalUri(re,{allowTunneling:!!rt.remote.authority})}catch(he){if((0,Q.matchesScheme)(re,X.Schemas.http)||(0,Q.matchesScheme)(re,X.Schemas.https))return re;throw he}},get remoteName(){return(0,de.getRemoteName)(rt.remote.authority)},get remoteAuthority(){return(0,We.checkProposedApiEnabled)(Le,"resolvers"),rt.remote.authority},get uiKind(){return rt.uiKind},get logLevel(){return(0,We.checkProposedApiEnabled)(Le,"extensionLog"),pt.getLevel()},get onDidChangeLogLevel(){return(0,We.checkProposedApiEnabled)(Le,"extensionLog"),pt.onDidChangeLogLevel}};rt.environment.extensionTestsLocationURI||Object.freeze(Ti);const Ui={createTestController(re,he,Re){return Xt.createTestController(re,he,Re)},createTestObserver(){return(0,We.checkProposedApiEnabled)(Le,"testObserver"),Xt.createTestObserver()},runTests(re){return(0,We.checkProposedApiEnabled)(Le,"testObserver"),Xt.runTests(re)},get onDidChangeTestResults(){return(0,We.checkProposedApiEnabled)(Le,"testObserver"),Xt.onResultsChanged},get testResults(){return(0,We.checkProposedApiEnabled)(Le,"testObserver"),Xt.results}},ui=rt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,Si={getExtension(re,he){(0,We.isProposedApiEnabled)(Le,"extensionsAny")||(he=!1);const Re=Vt.mine.getExtensionDescription(re);if(Re)return new d.Extension(kt,Le.identifier,Re,ui,!1);if(he){const st=Vt.all.getExtensionDescription(re);if(st)return new d.Extension(kt,Le.identifier,st,ui,!0)}},get all(){const re=[];for(const he of Vt.mine.getAllExtensionDescriptions())re.push(new d.Extension(kt,Le.identifier,he,ui,!1));return re},get allAcrossExtensionHosts(){(0,We.checkProposedApiEnabled)(Le,"extensionsAny");const re=new We.ExtensionIdentifierSet(Vt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),he=[];for(const Re of Vt.all.getAllExtensionDescriptions()){const st=!re.has(Re.identifier);he.push(new d.Extension(kt,Le.identifier,Re,ui,st))}return he},get onDidChange(){return(0,We.isProposedApiEnabled)(Le,"extensionsAny")?w.Event.any(Vt.mine.onDidChange,Vt.all.onDidChange):Vt.mine.onDidChange}},Bi={createDiagnosticCollection(re){return Jt.createDiagnosticCollection(Le.identifier,re)},get onDidChangeDiagnostics(){return Jt.onDidChangeDiagnostics},getDiagnostics:re=>Jt.getDiagnostics(re),getLanguages(){return zt.getLanguages()},setTextDocumentLanguage(re,he){return zt.changeLanguage(re.uri,he)},match(re,he){const Re=mt.getDocumentData(he.uri)?.notebook;return(0,O.score)(z.LanguageSelector.from(re),he.uri,he.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(re,he,Re){return ut.registerCodeActionProvider(Le,gt(re),he,Re)},registerDocumentPasteEditProvider(re,he,Re){return(0,We.checkProposedApiEnabled)(Le,"documentPaste"),ut.registerDocumentPasteEditProvider(Le,gt(re),he,Re)},registerCodeLensProvider(re,he){return ut.registerCodeLensProvider(Le,gt(re),he)},registerDefinitionProvider(re,he){return ut.registerDefinitionProvider(Le,gt(re),he)},registerDeclarationProvider(re,he){return ut.registerDeclarationProvider(Le,gt(re),he)},registerImplementationProvider(re,he){return ut.registerImplementationProvider(Le,gt(re),he)},registerTypeDefinitionProvider(re,he){return ut.registerTypeDefinitionProvider(Le,gt(re),he)},registerHoverProvider(re,he){return ut.registerHoverProvider(Le,gt(re),he,Le.identifier)},registerEvaluatableExpressionProvider(re,he){return ut.registerEvaluatableExpressionProvider(Le,gt(re),he,Le.identifier)},registerInlineValuesProvider(re,he){return ut.registerInlineValuesProvider(Le,gt(re),he,Le.identifier)},registerDocumentHighlightProvider(re,he){return ut.registerDocumentHighlightProvider(Le,gt(re),he)},registerLinkedEditingRangeProvider(re,he){return ut.registerLinkedEditingRangeProvider(Le,gt(re),he)},registerReferenceProvider(re,he){return ut.registerReferenceProvider(Le,gt(re),he)},registerRenameProvider(re,he){return ut.registerRenameProvider(Le,gt(re),he)},registerDocumentSymbolProvider(re,he,Re){return ut.registerDocumentSymbolProvider(Le,gt(re),he,Re)},registerWorkspaceSymbolProvider(re){return ut.registerWorkspaceSymbolProvider(Le,re)},registerDocumentFormattingEditProvider(re,he){return ut.registerDocumentFormattingEditProvider(Le,gt(re),he)},registerDocumentRangeFormattingEditProvider(re,he){return ut.registerDocumentRangeFormattingEditProvider(Le,gt(re),he)},registerOnTypeFormattingEditProvider(re,he,Re,...st){return ut.registerOnTypeFormattingEditProvider(Le,gt(re),he,[Re].concat(st))},registerDocumentSemanticTokensProvider(re,he,Re){return ut.registerDocumentSemanticTokensProvider(Le,gt(re),he,Re)},registerDocumentRangeSemanticTokensProvider(re,he,Re){return ut.registerDocumentRangeSemanticTokensProvider(Le,gt(re),he,Re)},registerSignatureHelpProvider(re,he,Re,...st){return typeof Re=="object"?ut.registerSignatureHelpProvider(Le,gt(re),he,Re):ut.registerSignatureHelpProvider(Le,gt(re),he,typeof Re>"u"?[]:[Re,...st])},registerCompletionItemProvider(re,he,...Re){return ut.registerCompletionItemProvider(Le,gt(re),he,Re)},registerInlineCompletionItemProvider(re,he){return he.handleDidShowCompletionItem&&(0,We.checkProposedApiEnabled)(Le,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Le,gt(re),he)},registerDocumentLinkProvider(re,he){return ut.registerDocumentLinkProvider(Le,gt(re),he)},registerColorProvider(re,he){return ut.registerColorProvider(Le,gt(re),he)},registerFoldingRangeProvider(re,he){return ut.registerFoldingRangeProvider(Le,gt(re),he)},registerSelectionRangeProvider(re,he){return ut.registerSelectionRangeProvider(Le,re,he)},registerCallHierarchyProvider(re,he){return ut.registerCallHierarchyProvider(Le,re,he)},registerTypeHierarchyProvider(re,he){return ut.registerTypeHierarchyProvider(Le,re,he)},setLanguageConfiguration:(re,he)=>ut.setLanguageConfiguration(Le,re,he),getTokenInformationAtPosition(re,he){return(0,We.checkProposedApiEnabled)(Le,"tokenInformation"),zt.tokenAtPosition(re,he)},registerInlayHintsProvider(re,he){return ut.registerInlayHintsProvider(Le,re,he)},createLanguageStatusItem(re,he){return zt.createLanguageStatusItem(Le,re,he)},registerDocumentDropEditProvider(re,he){return ut.registerDocumentOnDropEditProvider(Le,re,he)}},jt={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return it.activeTerminal},get terminals(){return it.terminals},async showTextDocument(re,he,Re){const st=await(D.URI.isUri(re)?Promise.resolve(ii.openTextDocument(re)):Promise.resolve(re));return St.showTextDocument(st,he,Re)},createTextEditorDecorationType(re){return St.createTextEditorDecorationType(Le,re)},onDidChangeActiveTextEditor(re,he,Re){return St.onDidChangeActiveTextEditor(re,he,Re)},onDidChangeVisibleTextEditors(re,he,Re){return St.onDidChangeVisibleTextEditors(re,he,Re)},onDidChangeTextEditorSelection(re,he,Re){return St.onDidChangeTextEditorSelection(re,he,Re)},onDidChangeTextEditorOptions(re,he,Re){return St.onDidChangeTextEditorOptions(re,he,Re)},onDidChangeTextEditorVisibleRanges(re,he,Re){return St.onDidChangeTextEditorVisibleRanges(re,he,Re)},onDidChangeTextEditorViewColumn(re,he,Re){return St.onDidChangeTextEditorViewColumn(re,he,Re)},onDidCloseTerminal(re,he,Re){return it.onDidCloseTerminal(re,he,Re)},onDidOpenTerminal(re,he,Re){return it.onDidOpenTerminal(re,he,Re)},onDidChangeActiveTerminal(re,he,Re){return it.onDidChangeActiveTerminal(re,he,Re)},onDidChangeTerminalDimensions(re,he,Re){return(0,We.checkProposedApiEnabled)(Le,"terminalDimensions"),it.onDidChangeTerminalDimensions(re,he,Re)},onDidChangeTerminalState(re,he,Re){return it.onDidChangeTerminalState(re,he,Re)},onDidWriteTerminalData(re,he,Re){return(0,We.checkProposedApiEnabled)(Le,"terminalDataWriteEvent"),it.onDidWriteTerminalData(re,he,Re)},get state(){return fe.state},onDidChangeWindowState(re,he,Re){return fe.onDidChangeWindowState(re,he,Re)},showInformationMessage(re,...he){return wi.showMessage(Le,M.default.Info,re,he[0],he.slice(1))},showWarningMessage(re,...he){return wi.showMessage(Le,M.default.Warning,re,he[0],he.slice(1))},showErrorMessage(re,...he){return wi.showMessage(Le,M.default.Error,re,he[0],he.slice(1))},showQuickPick(re,he,Re){return Gt.showQuickPick(re,he,Re)},showWorkspaceFolderPick(re){return Gt.showWorkspaceFolderPick(re)},showInputBox(re,he){return Gt.showInput(re,he)},showOpenDialog(re){return Ii.showOpenDialog(re)},showSaveDialog(re){return Ii.showSaveDialog(re)},createStatusBarItem(re,he,Re){let st,wt,Dt;return typeof re=="string"?(st=re,wt=he,Dt=Re):(wt=re,Dt=he),li.createStatusBarEntry(Le,st,wt,Dt)},setStatusBarMessage(re,he){return li.setStatusBarMessage(re,he)},withScmProgress(re){return Te.report("window.withScmProgress",Le,"Use 'withProgress' instead."),ai.withProgress(Le,{location:B.ProgressLocation.SourceControl},(he,Re)=>re({report(st){}}))},withProgress(re,he){return ai.withProgress(Le,re,he)},createOutputChannel(re,he){return _t.createOutputChannel(re,he,Le)},createWebviewPanel(re,he,Re,st){return ti.createWebviewPanel(Le,re,he,Re,st)},createWebviewTextEditorInset(re,he,Re,st){return(0,We.checkProposedApiEnabled)(Le,"editorInsets"),Ai.createWebviewEditorInset(re,he,Re,st,Le)},createTerminal(re,he,Re){return typeof re=="object"?"pty"in re?it.createExtensionTerminal(re):it.createTerminalFromOptions(re):it.createTerminal(re,he,Re)},registerTerminalLinkProvider(re){return it.registerLinkProvider(re)},registerTerminalProfileProvider(re,he){return it.registerProfileProvider(Le,re,he)},registerTreeDataProvider(re,he){return si.registerTreeDataProvider(re,he,Le)},createTreeView(re,he){return si.createTreeView(re,he,Le)},registerWebviewPanelSerializer:(re,he)=>ti.registerWebviewPanelSerializer(Le,re,he),registerCustomEditorProvider:(re,he,Re={})=>Ri.registerCustomEditorProvider(Le,re,he,Re),registerFileDecorationProvider(re){return Me.registerFileDecorationProvider(re,Le.identifier)},registerUriHandler(re){return Ft.registerUriHandler(Le.identifier,re)},createQuickPick(){return Gt.createQuickPick(Le)},createInputBox(){return Gt.createInputBox(Le)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(re,he,Re){return Di.onDidChangeActiveColorTheme(re,he,Re)},registerWebviewViewProvider(re,he,Re){return bi.registerWebviewViewProvider(Le,re,he,Re?.webviewOptions)},get activeNotebookEditor(){return bt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,he,Re){return bt.onDidChangeActiveNotebookEditor(re,he,Re)},get visibleNotebookEditors(){return bt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return bt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,he,Re){return ni.onDidChangeNotebookEditorSelection(re,he,Re)},onDidChangeNotebookEditorVisibleRanges(re,he,Re){return ni.onDidChangeNotebookEditorVisibleRanges(re,he,Re)},showNotebookDocument(re,he){return bt.showNotebookDocument(re,he)},registerExternalUriOpener(re,he,Re){return(0,We.checkProposedApiEnabled)(Le,"externalUriOpener"),Oi.registerExternalUriOpener(Le.identifier,re,he,Re)},get tabGroups(){return Pe.tabGroups}},ii={get rootPath(){return Te.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(re){throw I.readonly()},getWorkspaceFolder(re){return ft.getWorkspaceFolder(re)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(re){throw I.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(re){throw I.readonly()},updateWorkspaceFolders:(re,he,...Re)=>ft.updateWorkspaceFolders(Le,re,he||0,...Re),onDidChangeWorkspaceFolders:function(re,he,Re){return ft.onDidChangeWorkspace(re,he,Re)},asRelativePath:(re,he)=>ft.getRelativePath(re,he),findFiles:(re,he,Re,st)=>ft.findFiles(re,he,Re,Le.identifier,st),findTextInFiles:(re,he,Re,st)=>{(0,We.checkProposedApiEnabled)(Le,"findTextInFiles");let wt,Dt;return typeof he=="object"?(wt=he,Dt=Re):(wt={},Dt=he,st=Re),ft.findTextInFiles(re,wt||{},Dt,Le.identifier,st)},saveAll:re=>ft.saveAll(re),applyEdit(re,he){return Li.applyWorkspaceEdit(re,Le,he)},createFileSystemWatcher:(re,he,Re,st)=>$t.createFileSystemWatcher(ft,Le,re,he,Re,st),get textDocuments(){return mt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw I.readonly()},openTextDocument(re){let he;const Re=re;if(typeof re=="string")he=Promise.resolve(D.URI.file(re));else if(D.URI.isUri(re))he=Promise.resolve(re);else if(!Re||typeof Re=="object")he=mt.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>mt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(re,he,Re)=>mt.onDidAddDocument(re,he,Re),onDidCloseTextDocument:(re,he,Re)=>mt.onDidRemoveDocument(re,he,Re),onDidChangeTextDocument:(re,he,Re)=>mt.onDidChangeDocument(re,he,Re),onDidSaveTextDocument:(re,he,Re)=>mt.onDidSaveDocument(re,he,Re),onWillSaveTextDocument:(re,he,Re)=>Kt.getOnWillSaveTextDocumentEvent(Le)(re,he,Re),get notebookDocuments(){return bt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,he){let Re;if(D.URI.isUri(re))Re=re,await bt.openNotebookDocument(re);else if(typeof re=="string")Re=D.URI.revive(await bt.createNotebookDocument({viewType:re,content:he}));else throw new Error("Invalid arguments");return bt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(re,he,Re){return Ht.onDidSaveNotebookDocument(re,he,Re)},onDidChangeNotebookDocument(re,he,Re){return Ht.onDidChangeNotebookDocument(re,he,Re)},get onDidOpenNotebookDocument(){return bt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return bt.onDidCloseNotebookDocument},registerNotebookSerializer(re,he,Re,st){return bt.registerNotebookSerializer(Le,re,he,Re,(0,We.isProposedApiEnabled)(Le,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,he,Re)=>Ci.onDidChangeConfiguration(re,he,Re),getConfiguration(re,he){return he=arguments.length===1?void 0:he,Ci.getConfiguration(re,he,Le)},registerTextDocumentContentProvider(re,he){return Mt.registerTextDocumentContentProvider(re,he)},registerTaskProvider:(re,he)=>(Te.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Et.registerTaskProvider(Le,re,he)),registerFileSystemProvider(re,he,Re){return(0,qe.combinedDisposable)(gi.registerFileSystemProvider(Le,re,he,Re),At.addFileSystemProvider(re,he))},get fs(){return At.value},registerFileSearchProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Le,"fileSearchProvider"),Tt.registerFileSearchProvider(re,he)),registerTextSearchProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Le,"textSearchProvider"),Tt.registerTextSearchProvider(re,he)),registerRemoteAuthorityResolver:(re,he)=>((0,We.checkProposedApiEnabled)(Le,"resolvers"),kt.registerRemoteAuthorityResolver(re,he)),registerResourceLabelFormatter:re=>((0,We.checkProposedApiEnabled)(Le,"resolvers"),vi.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,he,Re)=>$t.onDidCreateFile(re,he,Re),onDidDeleteFiles:(re,he,Re)=>$t.onDidDeleteFile(re,he,Re),onDidRenameFiles:(re,he,Re)=>$t.onDidRenameFile(re,he,Re),onWillCreateFiles:(re,he,Re)=>$t.getOnWillCreateFileEvent(Le)(re,he,Re),onWillDeleteFiles:(re,he,Re)=>$t.getOnWillDeleteFileEvent(Le)(re,he,Re),onWillRenameFiles:(re,he,Re)=>$t.getOnWillRenameFileEvent(Le)(re,he,Re),openTunnel:re=>((0,We.checkProposedApiEnabled)(Le,"tunnels"),_e.openTunnel(Le,re).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,We.checkProposedApiEnabled)(Le,"tunnels"),_e.getTunnels()},onDidChangeTunnels:(re,he,Re)=>((0,We.checkProposedApiEnabled)(Le,"tunnels"),_e.onDidChangeTunnels(re,he,Re)),registerPortAttributesProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Le,"portsAttributes"),_e.registerPortsAttributesProvider(re,he)),registerTimelineProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Le,"timeline"),Ei.registerTimelineProvider(re,he,Le.identifier,xe.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:re=>((0,We.checkProposedApiEnabled)(Le,"workspaceTrust"),ft.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,he,Re)=>ft.onDidGrantWorkspaceTrust(re,he,Re),registerEditSessionIdentityProvider:(re,he)=>((0,We.checkProposedApiEnabled)(Le,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(re,he))},xi={get inputBox(){return Te.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),oi.getLastInputBox(Le)},createSourceControl(re,he,Re){return oi.createSourceControl(Le,re,he,Re)}},Nt={createCommentController(re,he){return pi.createCommentController(Le,re,he)}},di={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(re,he,Re){return ot.onDidStartDebugSession(re,he,Re)},onDidTerminateDebugSession(re,he,Re){return ot.onDidTerminateDebugSession(re,he,Re)},onDidChangeActiveDebugSession(re,he,Re){return ot.onDidChangeActiveDebugSession(re,he,Re)},onDidReceiveDebugSessionCustomEvent(re,he,Re){return ot.onDidReceiveDebugSessionCustomEvent(re,he,Re)},onDidChangeBreakpoints(re,he,Re){return ot.onDidChangeBreakpoints(re,he,Re)},registerDebugConfigurationProvider(re,he,Re){return ot.registerDebugConfigurationProvider(re,he,Re||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,he){return ot.registerDebugAdapterDescriptorFactory(Le,re,he)},registerDebugAdapterTrackerFactory(re,he){return ot.registerDebugAdapterTrackerFactory(re,he)},startDebugging(re,he,Re){return!Re||typeof Re=="object"&&"configuration"in Re?ot.startDebugging(re,he,{parentSession:Re}):ot.startDebugging(re,he,Re||{})},stopDebugging(re){return ot.stopDebugging(re)},addBreakpoints(re){return ot.addBreakpoints(re)},removeBreakpoints(re){return ot.removeBreakpoints(re)},asDebugSourceUri(re,he){return ot.asDebugSourceUri(re,he)}},zi={registerTaskProvider:(re,he)=>Et.registerTaskProvider(Le,re,he),fetchTasks:re=>Et.fetchTasks(re),executeTask:re=>Et.executeTask(Le,re),get taskExecutions(){return Et.taskExecutions},onDidStartTask:(re,he,Re)=>Et.onDidStartTask(re,he,Re),onDidEndTask:(re,he,Re)=>Et.onDidEndTask(re,he,Re),onDidStartTaskProcess:(re,he,Re)=>Et.onDidStartTaskProcess(re,he,Re),onDidEndTaskProcess:(re,he,Re)=>Et.onDidEndTaskProcess(re,he,Re)},$i={createNotebookController(re,he,Re,st,wt){return ri.createNotebookController(Le,re,he,Re,st,(0,We.isProposedApiEnabled)(Le,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(re,he)=>bt.registerNotebookCellStatusBarItemProvider(Le,re,he),createRendererMessaging(re){return mi.createRendererMessaging(Le,re)},onDidChangeNotebookCellExecutionState(re,he,Re){return(0,We.checkProposedApiEnabled)(Le,"notebookCellExecutionState"),ri.onDidChangeNotebookCellExecutionState(re,he,Re)}},Wi={t(...re){if(typeof re[0]=="string"){const he=re.shift(),Re=!re||typeof re[0]!="object"?re:re[0];return vt.getMessage(Le.identifier.value,{message:he,args:Re})}return vt.getMessage(Le.identifier.value,re[0])},get bundle(){return vt.getBundle(Le.identifier.value)},get uri(){return vt.getBundleUri(Le.identifier.value)}};return{version:rt.version,authentication:ci,commands:Ni,comments:Nt,debug:di,env:Ti,extensions:Si,l10n:Wi,languages:Bi,notebooks:$i,scm:xi,tasks:zi,tests:Ui,window:jt,workspace:ii,Breakpoint:B.Breakpoint,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:I.CancellationError,CancellationTokenSource:i.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestionList,Hover:B.Hover,IndentAction:T.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,SnippetTextEdit:B.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItem2:B.TreeItem,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:E.UIKind,Uri:D.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,DocumentDropEdit:B.DocumentDropEdit,DocumentPasteEdit:B.DocumentPasteEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.NotebookEdit,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:B.DataTransfer,DataTransferItem:B.DataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.TextTabInput,TabInputTextDiff:B.TextDiffTabInput,TabInputTextMerge:B.TextMergeTabInput,TabInputCustom:B.CustomEditorTabInput,TabInputNotebook:B.NotebookEditorTabInput,TabInputNotebookDiff:B.NotebookDiffEditorTabInput,TabInputWebview:B.WebviewEditorTabInput,TabInputTerminal:B.TerminalEditorTabInput,TabInputInteractiveWindow:B.InteractiveWindowInput,TerminalExitReason:B.TerminalExitReason,LogLevel:Be.LogLevel,EditSessionIdentityMatch:ct.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=It}),define(De[244],Ie([1,0,243,33,2,237,6,15,228]),function(ie,e,i,I,w,M,D,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends M.RequireInterceptor{_installInterceptor(){}getModule(E,m){for(const t of this._alternatives){const s=t(E);if(s){E=s;break}}if(this._factories.has(E))return this._factories.get(E).load(E,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=D.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(y.ExtHostConsoleForwarder);const E=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,E,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(E){return E.browser}async _loadCommonJSModule(E,m,t){m=m.with({path:b(m.path,".js")});const s=E?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const a=w.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(m)),p=await fetch(a.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),p.status!==200)throw new Error(p.statusText);const S=await p.text(),u=`${m.toString(!0)}#vscode-extension`,C=`${S}
//# sourceURL=${u}`;let r;try{r=new Function("module","exports","require",C)}catch(l){throw console.error(s?`Loading code for extension ${s} failed: ${l.message}`:`Loading code failed: ${l.message}`),console.error(`${m.toString(!0)}${typeof l.line=="number"?` line ${l.line}`:""}${typeof l.column=="number"?` column ${l.column}`:""}`),console.error(l),l}E&&await this._extHostLocalizationService.initializeLocalizedMessages(E);const c={},n={exports:c},d=l=>{const f=this._fakeModules.getModule(l,m);if(f===void 0)throw new Error(`Cannot load module '${l}'`);return f};try{return t.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),r(n,c,d),n.exports!==c?n.exports:c}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),t.codeLoadingStop()}}async $setRemoteEnvironment(E){}async _waitForDebuggerAttachment(E=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+E;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function b(g,E){return g.endsWith(E)?g:g+E}}),define(De[245],Ie([1,0,59,33,75,244]),function(ie,e,i,I,w,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,i.registerSingleton)(I.IExtHostExtensionService,M.ExtHostExtensionService,0),(0,i.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths,0)}),define(De[253],Ie([1,0,24,4,68,238,230,19,76,13,2,240,245]),function(ie,e,i,I,w,M,D,A,y,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const g=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(r){return/^(file|vscode-remote):/i.test(r)}const m=fetch.bind(self);function t(r){self.fetch=async function(c,n){return c instanceof Request||E(String(c))&&(c=(await r(O.URI.parse(String(c)))).toString(!0)),m(c,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(c,n,d,l,f){(async()=>(E(n.toString())&&(n=(await r(O.URI.parse(n.toString()))).toString(!0)),super.open(c,n,d??!0,l,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(c,n){if(/^file:/i.test(c.toString()))c=T.FileAccess.asBrowserUri(O.URI.parse(c.toString())).toString(!0);else if(/^vscode-remote:/i.test(c.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const l=`(${function(v){function k(H){return typeof H=="string"||H instanceof URL?String(H).replace(/^file:\/\//i,"vscode-file://vscode-app"):H}const F=fetch.bind(self);self.fetch=function(H,V){return H instanceof Request?F(H,V):F(k(H),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(H,V,P,U,R){return super.open(H,k(V),P??!0,U,R)}};const j=importScripts.bind(self);self.importScripts=(...H)=>{j(...H.map(k))},j(v)}.toString()}('${c}'))`;n=n||{},n.name=n.name||A.basename(c.toString());const f=new Blob([l],{type:"application/javascript"}),o=URL.createObjectURL(f);return new r(o,n)}}else self.Worker=class extends D.NestedWorker{constructor(r,c){super(g,r,{name:A.basename(r.toString()),...c})}};const s=new class{constructor(){this.pid=void 0}exit(r){b()}async exists(r){return!0}async realpath(r){return r}};class a{constructor(){const c=new MessageChannel,n=new I.Emitter;let d=!1;g(c.port2,[c.port2]),c.port1.onmessage=l=>{const{data:f}=l;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const o=i.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,w.isMessageOfType)(o,2)){d=!0,S("received terminate message from renderer");return}n.fire(o)},this.protocol={onMessage:n.event,send:l=>{if(!d){const f=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);c.port1.postMessage(f,[f])}}}}}function p(r){return new Promise(c=>{const n=r.onMessage(d=>{n.dispose();const l=JSON.parse(d.toString());r.send((0,w.createMessageOfType)(0)),c({protocol:r,initData:l})});r.send((0,w.createMessageOfType)(1))})}let S=r=>b();function u(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function C(){y.mark("code/extHost/willConnectToRenderer");const r=new a;return{onmessage(c){!u(c)||p(r.protocol).then(n=>{y.mark("code/extHost/didWaitForInitData");const d=new M.ExtensionHostMain(n.protocol,n.initData,s,null,c.data);t(l=>d.asBrowserUri(l)),S=l=>d.terminate(l)})}}}e.create=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/86f0f9bfa268fe21af7efae37d8f0da1dba8137f/core/vs/workbench/api/worker/extensionHostWorker.js.map
